Package: pracma
Type: Package
Version: 2.4.6
Date: 2025-10-20
Title: Practical Numerical Math Functions
Authors@R: person("Hans W.", "Borchers", 
                  email="hwborchers@googlemail.com", 
                  role=c("aut", "cre"))
Depends: R (>= 3.1.0)
Imports: graphics, grDevices, stats, utils
Suggests: NlcOptim, quadprog
Description: 
    Provides a large number of functions from numerical analysis and
    linear algebra, numerical optimization, differential equations,
    time series, plus some well-known special mathematical functions.
    Uses 'MATLAB' function names where appropriate to simplify porting.
License: GPL (>= 3)
ByteCompile: true
LazyData: yes
NeedsCompilation: no
Packaged: 2025-10-21 15:28:06 UTC; hwb
Author: Hans W. Borchers [aut, cre]
Maintainer: Hans W. Borchers <hwborchers@googlemail.com>
Repository: CRAN
Date/Publication: 2025-10-22 15:00:02 UTC
Built: R 4.4.0; ; 2026-07-18 06:31:27 UTC; unix

Package: pracma
Type: Package
Version: 2.3.3
Date: 2021-01-22
Title: Practical Numerical Math Functions
Authors@R: person("Hans W.", "Borchers", 
                  email="hwborchers@googlemail.com", 
                  role=c("aut", "cre"))
Depends: R (>= 3.1.0)
Imports: graphics, grDevices, stats, utils
Suggests: NlcOptim, quadprog
Description: 
    Provides a large number of functions from numerical analysis and
    linear algebra, numerical optimization, differential equations,
    time series, plus some well-known special mathematical functions.
    Uses 'MATLAB' function names where appropriate to simplify porting.
License: GPL (>= 3)
ByteCompile: true
LazyData: yes
Author: Hans W. Borchers [aut, cre]
Maintainer: Hans W. Borchers <hwborchers@googlemail.com>
Repository: CRAN
Repository/R-Forge/Project: optimist
Repository/R-Forge/Revision: 495
Repository/R-Forge/DateTimeStamp: 2021-01-22 18:52:59
Date/Publication: 2021-01-23 10:10:02 UTC
NeedsCompilation: no
Packaged: 2021-01-22 19:09:06 UTC; rforge

###
### NAMESPACE
###

## Public routines
exportPattern("^[[:alpha:]]+")

## Imports
#  importFrom("quadprog", "solve.QP")
#  importFrom("NlcOptim", "solnl")

# import("datasets")
import("graphics")
import("grDevices")
import("stats")
import("utils")

## S3 and S4 Methods

# Package PRACMA

## Introduction

This package provides R implementations of more advanced functions in
numerical analysis, with a special view on on optimization and time
series routines. Uses Matlab/Octave function names where appropriate
to simplify porting.

Some of these implementations are the result of courses on Scientific
Computing (``Wissenschaftliches Rechnen'') and are mostly intended to
demonstrate how to implement certain algorithms in R/S. Others are
implementations of algorithms found in textbooks.

## Details

The package encompasses functions from all areas of numerical analysis,
for example:

* Root finding and minimization of univariate functions,  
  e.g. Newton-Raphson, Brent-Dekker, Fibonacci or `golden ratio' search.
* Handling polynomials, including roots and polynomial fitting,  
  e.g. Laguerre's and Muller's methods.
* Interpolation and function approximation,  
  barycentric Lagrange interpolation, Pade and rational interpolation,
  Chebyshev or trigonometric approximation.
* Some special functions,  
  e.g. Fresnel integrals, Riemann's Zeta or the complex Gamma function,
  and Lambert's W computed iteratively through Newton's method.
* Special matrices, e.g. Hankel, Rosser, Wilkinson
* Numerical differentiation and integration,  
  Richardson approach and ``complex step'' derivatives, adaptive
  Simpson and Lobatto integration and adaptive Gauss-Kronrod quadrature.
* Solvers for ordinary differential equations and systems,  
  Euler-Heun, classical Runge-Kutta, ode23, or predictor-corrector method 
  such as the Adams-Bashford-Moulton.
* Some functions from number theory,  
  such as primes and prime factorization, extended Euclidean algorithm.
* Sorting routines, e.g. recursive quickstep.
* Several functions for string manipulation and regular search,
  all wrapped and named similar to their Matlab analogues.

## Goals

It serves three main goals:

* Collecting R scripts that can be demonstrated in courses on
  Numerical Analysis or Scientific Computing using R/S as the chosen
  programming language.
* Wrapping functions with appropriate Matlab names to simplify
  porting programs from Matlab or Octave to R.
* Providing an environment in which R can be used as a full-blown
  numerical computing system.

Besides that, many of these functions could be called in R applications
as they do not have comparable counterparts in other R packages (at least
at this moment, as far as I know). 

All referenced books have been utilized in one way or another.
Web links have been provided where reasonable.

## Emulated MATLAB Functions

The following 220 functions are emulations of correspondingly named Matlab 
functions and bear the same signature as their Matlab cousins if possible:

    accumarray, acosd, acot, acotd, acoth, acsc, acscd, acsch, and, angle, ans,
    arrayfun, asec, asecd, asech, asind, atand, atan2d,  
    beep, bernoulli, blank, blkdiag, bsxfun,  
    cart2pol, cart2sph, cd, ceil, circshift, clear, compan, cond, conv,  
    cosd, cot, cotd, coth, cross, csc, cscd, csch, cumtrapz,  
    dblquad, deblank, deconv, deg2rad, detrend, deval, disp, dot,  
    eig, eigint, ellipj, ellipke, eps, erf, erfc, erfcinv, erfcx, erfi, erfinv,  
    errorbar, expint, expm, eye, ezcontour, ezmesh, ezplot, ezpolar, ezsurf,  
    fact, fftshift, figure, findpeaks, findstr, flipdim, fliplr, flipud,  
    fminbnd, fmincon, fminsearch, fminunc, fplot, fprintf, fsolve, fzero,  
    gammainc, gcd, geomean, gmres, gradient,  
    hadamard, hankel, harmmean, hilb, histc, humps, hypot,  
    idivide, ifft, ifftshift, inpolygon, integral, integral2, integral3,  
    interp1, interp2, inv, isempty, isprime,  
    kron,  
    legendre, linprog, linspace, loglog, logm, logseq, logspace, lsqcurvefit,  
    lsqlin, lsqnonlin, lsqnonneg, lu,  
    magic, meshgrid, mkpp, mldivide, mod, mrdivide,  
    nchoosek, ndims, nextpow2, nnz, normest, nthroot, null, num2str, numel,  
    ode23, ode23s, ones, or, orth,  
    pascal, pchip, pdist, pdist2, peaks, perms, piecewise, pinv, plotyy,  
    pol2cart, polar, polyfit, polyint, polylog, polyval, pow2, ppval,  
    primes, psi, pwd,  
    quad, quad2d, quadgk, quadl, quadprog, quadv, quiver,  
    rad2deg, randi, randn, randsample, rat, rats, regexp, regexpi,  
    regexpreg, rem, repmat, roots, rosser, rot90, rref, runge,  
    sec, secd, sech, semilogx, semilogy, sinc, sind, size, sortrows, sph2cart,  
    sqrtm, squareform, std, str2num, strcat, strcmp, strcmpi,  
    strfind, strfindi, strjust, subspace,  
    tand, tic, toc, trapz, tril, trimmean, triplequad, triu,  
    vander, vectorfield, ver,  
    what, who, whos, wilkinson,  
    zeros, zeta

The following Matlab function names have been capitalized in `pracma' to
avoid shadowing functions from R base or one of its recommended packages
(on request of Bill Venables and because of Brian Ripley's CRAN policies):

    Diag, factors, finds, Fix, Imag, Lcm, Mode, Norm, nullspace (<- null),
    Poly, Rank, Real, Reshape, strRep, strTrim, Toeplitz, Trace, uniq (<- unique).

To use `ans` instead of `ans()` -- as is common practice in Matlab -- 
type (and similar for other Matlab commands):

    makeActiveBinding("ans", function() .Last.value, .GlobalEnv)
    makeActiveBinding("who", who(), .GlobalEnv)

### Note

The R package `matlab' contains some of the basic routines from Matlab,
but unfortunately not any of the higher math routines.

## References

  Abramowitz, M., and I. A. Stegun (1972). Handbook of Mathematical Functions
  (with Formulas, Graphs, and Mathematical Tables). Dover, New York.
  URL: www.math.ubc.ca/~cbm/aands/notes.htm

  Arndt, J. (2010). Matters Computational: Ideas, Algorithms, Source Code.
  Springer-Verlag, Berlin Heidelberg Dordrecht.
  FXT: a library of algorithms: <https://www.jjj.de/fxt/>.

  Cormen, Th. H., Ch. E. Leiserson, and R. L. Rivest (2009). Introduction
  to Algorithms. Third Edition, The MIT Press, Cambridge, MA.

  Encyclopedia of Mathematics (2012). Editor-in-Chief: Ulf Rehmann.
  <https://encyclopediaofmath.org/wiki/Main_Page>.

  Gautschi, W. (1997). Numerical Analysis: An Introduction.
  Birkhaeuser, Boston.

  Gentle, J. E. (2009). Computational Statistics.
  Springer Science+Business Media LCC, New York.

  Hazewinkel, M., Editor (2002). Encyclopaedia of Mathematics.
  Springer-Verlag, Berlin Heidelberg New York.

  MathWorld.com (2011).
  Wolfram MathWorld: <https://mathworld.wolfram.com/>.
  Matlab Central: www.mathworks.com/matlabcentral/.

  NIST: National Institute of Standards and Technology.
  Olver, F. W. J., et al. (2010). NIST Handbook of Mathematical Functions.
  Cambridge University Press. 
  Internet: NIST Digital Library of Mathematical Functions, 
  <https://dlmf.nist.gov/>;
  Dictionary of Algorithms and Data Structures,
  <https://www.nist.gov/>;
  Guide to Available Mathematical Software, <https://gams.nist.gov/>

  Press, W. H., S. A. Teukolsky, W. T Vetterling, and B. P. Flannery (2007).
  Numerical Recipes: The Art of Numerical Computing. Third Edition, incl.
  Numerical Recipes Software, Cambridge University Press, New York.
  URL: numerical.recipes/book/book.html

  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.

  Skiena, St. S. (2008). The Algorithm Design Manual. Second Edition,
  Springer-Verlag, London. The Stony Brook Algorithm Repository:
  <https://algorist.com/algorist.html>.

  Stoer, J., and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Springer-Verlag, New York.

  Strang, G. (2007). Computational Science and Engineering.
  Wellesley-Cambridge Press.

  Weisstein, E. W. (2003). CRC Concise Encyclopedia of Mathematics.
  Second Edition, Chapman & Hall/CRC Press.

  Zhang, S., and J. Jin (1996). Computation of Special Functions.
  John Wiley & Sons.

# Package PRACMA

## Introduction

This package provides R implementations of more advanced functions in
numerical analysis, with a special view on on optimization and time
series routines. Uses Matlab/Octave function names where appropriate
to simplify porting.

Some of these implementations are the result of courses on Scientific
Computing (``Wissenschaftliches Rechnen'') and are mostly intended to
demonstrate how to implement certain algorithms in R/S. Others are
implementations of algorithms found in textbooks.

## Details

The package encompasses functions from all areas of numerical analysis,
for example:

* Root finding and minimization of univariate functions,  
  e.g. Newton-Raphson, Brent-Dekker, Fibonacci or `golden ratio' search.
* Handling polynomials, including roots and polynomial fitting,  
  e.g. Laguerre's and Muller's methods.
* Interpolation and function approximation,  
  barycentric Lagrange interpolation, Pade and rational interpolation,
  Chebyshev or trigonometric approximation.
* Some special functions,  
  e.g. Fresnel integrals, Riemann's Zeta or the complex Gamma function,
  and Lambert's W computed iteratively through Newton's method.
* Special matrices, e.g. Hankel, Rosser, Wilkinson
* Numerical differentiation and integration,  
  Richardson approach and ``complex step'' derivatives, adaptive
  Simpson and Lobatto integration and adaptive Gauss-Kronrod quadrature.
* Solvers for ordinary differential equations and systems,  
  Euler-Heun, classical Runge-Kutta, ode23, or predictor-corrector method 
  such as the Adams-Bashford-Moulton.
* Some functions from number theory,  
  such as primes and prime factorization, extended Euclidean algorithm.
* Sorting routines, e.g. recursive quickstep.
* Several functions for string manipulation and regular search,
  all wrapped and named similar to their Matlab analogues.

## Goals

It serves three main goals:

* Collecting R scripts that can be demonstrated in courses on
  Numerical Analysis or Scientific Computing using R/S as the chosen
  programming language.
* Wrapping functions with appropriate Matlab names to simplify
  porting programs from Matlab or Octave to R.
* Providing an environment in which R can be used as a full-blown
  numerical computing system.

Besides that, many of these functions could be called in R applications
as they do not have comparable counterparts in other R packages (at least
at this moment, as far as I know). 

All referenced books have been utilized in one way or another.
Web links have been provided where reasonable.

## Emulated MATLAB Functions

The following 220 functions are emulations of correspondingly named Matlab 
functions and bear the same signature as their Matlab cousins if possible:

    accumarray, acosd, acot, acotd, acoth, acsc, acscd, acsch, and, angle, ans,
    arrayfun, asec, asecd, asech, asind, atand, atan2d,  
    beep, bernoulli, blank, blkdiag, bsxfun,  
    cart2pol, cart2sph, cd, ceil, circshift, clear, compan, cond, conv,  
    cosd, cot, cotd, coth, cross, csc, cscd, csch, cumtrapz,  
    dblquad, deblank, deconv, deg2rad, detrend, deval, disp, dot,  
    eig, eigint, ellipj, ellipke, eps, erf, erfc, erfcinv, erfcx, erfi, erfinv,  
    errorbar, expint, expm, eye, ezcontour, ezmesh, ezplot, ezpolar, ezsurf,  
    fact, fftshift, figure, findpeaks, findstr, flipdim, fliplr, flipud,  
    fminbnd, fmincon, fminsearch, fminunc, fplot, fprintf, fsolve, fzero,  
    gammainc, gcd, geomean, gmres, gradient,  
    hadamard, hankel, harmmean, hilb, histc, humps, hypot,  
    idivide, ifft, ifftshift, inpolygon, integral, integral2, integral3,  
    interp1, interp2, inv, isempty, isprime,  
    kron,  
    legendre, linprog, linspace, loglog, logm, logseq, logspace, lsqcurvefit,  
    lsqlin, lsqnonlin, lsqnonneg, lu,  
    magic, meshgrid, mkpp, mldivide, mod, mrdivide,  
    nchoosek, ndims, nextpow2, nnz, normest, nthroot, null, num2str, numel,  
    ode23, ode23s, ones, or, orth,  
    pascal, pchip, pdist, pdist2, peaks, perms, piecewise, pinv, plotyy,  
    pol2cart, polar, polyfit, polyint, polylog, polyval, pow2, ppval,  
    primes, psi, pwd,  
    quad, quad2d, quadgk, quadl, quadprog, quadv, quiver,  
    rad2deg, randi, randn, randsample, rat, rats, regexp, regexpi,  
    regexpreg, rem, repmat, roots, rosser, rot90, rref, runge,  
    sec, secd, sech, semilogx, semilogy, sinc, sind, size, sortrows, sph2cart,  
    sqrtm, squareform, std, str2num, strcat, strcmp, strcmpi,  
    strfind, strfindi, strjust, subspace,  
    tand, tic, toc, trapz, tril, trimmean, triplequad, triu,  
    vander, vectorfield, ver,  
    what, who, whos, wilkinson,  
    zeros, zeta

The following Matlab function names have been capitalized in `pracma' to
avoid shadowing functions from R base or one of its recommended packages
(on request of Bill Venables and because of Brian Ripley's CRAN policies):

    Diag, factos, finds, Fix, Imag, Lcm, Mode, Norm, nullspace (<- null),
    Poly, Rank, Real, Reshape, strRep, strTrim, Toeplitz, Trace, uniq (<- unique).

To use `ans` instead of `ans()` -- as is common practice in Matlab -- 
type (and similar for other Matlab commands):

    makeActiveBinding("ans", function() .Last.value, .GlobalEnv)
    makeActiveBinding("who", who(), .GlobalEnv)

### Note

The R package `matlab' contains some of the basic routines from Matlab,
but unfortunately not any of the higher math routines.

## References

  Abramowitz, M., and I. A. Stegun (1972). Handbook of Mathematical Functions
  (with Formulas, Graphs, and Mathematical Tables). Dover, New York.
  URL: www.math.ubc.ca/~cbm/aands/notes.htm

  Arndt, J. (2010). Matters Computational: Ideas, Algorithms, Source Code.
  Springer-Verlag, Berlin Heidelberg Dordrecht.
  FXT: a library of algorithms: <https://www.jjj.de/fxt/>.

  Cormen, Th. H., Ch. E. Leiserson, and R. L. Rivest (2009). Introduction
  to Algorithms. Third Edition, The MIT Press, Cambridge, MA.

  Encyclopedia of Mathematics (2012). Editor-in-Chief: Ulf Rehmann.
  <https://encyclopediaofmath.org/wiki/Main_Page>.

  Gautschi, W. (1997). Numerical Analysis: An Introduction.
  Birkhaeuser, Boston.

  Gentle, J. E. (2009). Computational Statistics.
  Springer Science+Business Media LCC, New York.

  Hazewinkel, M., Editor (2002). Encyclopaedia of Mathematics.
  Springer-Verlag, Berlin Heidelberg New York.

  MathWorld.com (2011).
  Wolfram MathWorld: <https://mathworld.wolfram.com/>.
  Matlab Central: <https://www.mathworks.com/matlabcentral/>.

  NIST: National Institute of Standards and Technology.
  Olver, F. W. J., et al. (2010). NIST Handbook of Mathematical Functions.
  Cambridge University Press. 
  Internet: NIST Digital Library of Mathematical Functions, 
  <https://dlmf.nist.gov/>;
  Dictionary of Algorithms and Data Structures,
  <https://www.nist.gov/>;
  Guide to Available Mathematical Software, <https://gams.nist.gov/>

  Press, W. H., S. A. Teukolsky, W. T Vetterling, and B. P. Flannery (2007).
  Numerical Recipes: The Art of Numerical Computing. Third Edition, incl.
  Numerical Recipes Software, Cambridge University Press, New York.
  URL: numerical.recipes/book/book.html

  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.

  Skiena, St. S. (2008). The Algorithm Design Manual. Second Edition,
  Springer-Verlag, London. The Stony Brook Algorithm Repository:
  <https://algorist.com/algorist.html>.

  Stoer, J., and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Springer-Verlag, New York.

  Strang, G. (2007). Computational Science and Engineering.
  Wellesley-Cambridge Press.

  Weisstein, E. W. (2003). CRC Concise Encyclopedia of Mathematics.
  Second Edition, Chapman & Hall/CRC Press.

  Zhang, S., and J. Jin (1996). Computation of Special Functions.
  John Wiley & Sons.

##
##  p r a c m a . R  'pracma' Demos
##

require("pracma")

# Remember graphics settings
opar <- par(ask = dev.interactive(orNone = TRUE))

if (interactive())
    readline("Press ENTER to continue: ")
cat("Some demos will follow shortly. BYE.\n")

# Reset graphics parameters
par(opar)

##
##  s i z e . R  tests
##

size <- pracma::size
numel <- pracma::numel
ndims <- pracma::ndims
isempty <- pracma::isempty

identical(size(1:8), c(1, 8))
identical(size(1:8, 1), 1)
identical(size(1:8, 2), 8)
identical(size(1:8, 3), 1)
identical(size(matrix(1:12, 3, 4)), c(3L, 4L))

identical(numel(array(0, c(4,4,2))), 32)
identical(numel(1:100), 100)

identical(ndims(array(NA, c(4,4,2))), 3L)
identical(ndims(list(a=1:5)), 2L)

identical(isempty(numeric(0)), TRUE)
identical(isempty(matrix(0, 1, 0)), TRUE)
identical(isempty(matrix(0, 1, 1)), FALSE)
identical(isempty(array(NA, c(2,2,2))), FALSE)
identical(isempty(array(NA, c(2,0,2))), TRUE)

###
### PRIMES.R  +++ Test suite +++
###


test.primes <- function(input, expected) {
    output <- do.call(getFromNamespace("primes", "pracma"), input)
    identical(output, expected)
}

primes.expected.n1  <- NULL
primes.expected.n2  <- 2
primes.expected.n3  <- c(2, 3)
primes.expected.n5  <- c(2, 3, 5)
primes.expected.n8  <- c(2, 3, 5, 7)
primes.expected.101 <- c( 2,  3,  5,  7, 11, 13, 17, 19, 23, 29, 31, 37, 41,
                         43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97,101)

test.primes(list(n=1), primes.expected.n1)
test.primes(list(n=2), primes.expected.n2)
test.primes(list(n=3), primes.expected.n3)
test.primes(list(n=5), primes.expected.n5)
test.primes(list(n=8), primes.expected.n8)
test.primes(list(n=101), primes.expected.101)

###
### polyint.R  +++ Test suite +++
###


test.polyint <- function(input, expected) {
   output <- do.call(getFromNamespace("polyint", "pracma"), input)
   identical(output, expected)
}

polyint.expected.1 <- c(1, 0)
polyint.expected.2 <- c(1/6, 1/5, 1/4, 1/3, 1/2, 1, 1)

test.polyint(list(p=c(1)), polyint.expected.1)
test.polyint(list(p=c(1,1,1,1,1,1), k=1), polyint.expected.2)

##
##  f l i p d i m . R  tests
##

flipdim <- pracma::flipdim
flipud <- pracma::flipud
fliplr <- pracma::fliplr
rot90 <- pracma::rot90

a <- matrix(c(1,2,3, 4,5,6, 7,8,9, 10,11,12), nrow=3, ncol=4)
b <- matrix(c(1,2, 3,4), nrow=2, ncol=2, byrow=TRUE)

identical(flipdim(a, 1), flipud(a))
identical(fliplr(a), matrix(c(10,11,12, 7,8,9, 4,5,6, 1,2,3 ), 3, 4))
identical(rot90(b, k=1), matrix(c(2,1, 4,3), 2, 2))
identical(rot90(b, k=6), matrix(c(4,2, 3,1), 2, 2))
identical(rot90(b, k=-1), matrix(c(3,4, 1,2), 2, 2))

##
##  m o d . R  tests
##

mod <- pracma::mod
rem <- pracma::rem

identical(mod(0, 0), 0)
identical(mod(1, 0), 1)
identical(mod(0, 2), 0)
identical(mod(5, 3), 2)
identical(mod(5, -3), -1)
identical(mod(-5, 3), 1)
identical(mod(-5, -3), -2)

identical(rem(0, 0), NaN)
identical(rem(1, 0), NaN)
identical(rem(0, 2), 0)
identical(rem(5, 3), 2)
identical(rem(5, -3), 2)
identical(rem(-5, 3), -2)
identical(rem(-5, -3), -2)

###
### hilb.R  +++ Test suite +++
###


test.hilb <- function(input, expected) {
   output <- do.call(getFromNamespace("hilb", "pracma"), input)
   identical(output, expected)
}

hilb.expected.m1 <- matrix(NA, nrow=0, ncol=0)
hilb.expected.0  <- matrix(0, nrow=0, ncol=0)
hilb.expected.1  <- matrix(1, nrow=1, ncol=1)
hilb.expected.5  <- 1 / matrix(c(1:5,2:6,3:7,4:8,5:9), nrow=5,ncol=5)

test.hilb(list(n=-1), hilb.expected.m1)
test.hilb(list(n=0), hilb.expected.0)
test.hilb(list(n=1), hilb.expected.1)
test.hilb(list(n=5), hilb.expected.5)

###
### compan.R  +++ Test suite +++
###


test.compan <- function(input, expected) {
   output <- do.call(getFromNamespace("compan", "pracma"), input)
   identical(output, expected)
}

compan.expected.empty  <- c()
compan.expected.sngl1  <- c()
compan.expected.sngl2  <- c()
compan.expected.bspl1  <- matrix(c(0, 7, -6, 1, 0, 0, 0, 1, 0),
                                 nrow=3, ncol=3, byrow=TRUE)

test.compan(list(p=c()), compan.expected.empty)
test.compan(list(p=c(0)), compan.expected.sngl1)
test.compan(list(p=c(1)), compan.expected.sngl2)
test.compan(list(p=c(1,0,-7,6)), compan.expected.bspl1)

##
##  f i n d . R  tests
##

finds <- pracma::finds

v <- c(3, 2, 1, 1, 2, 3)
identical(finds(v == 1), c(3L, 4L))
v <- c(1, 0, 4, -3, 0, 0, 0, 8, 6)
identical(finds(v), as.integer(c(1, 3, 4, 8, 9)))
identical(finds(v > 2), c(3L, 8L, 9L))
identical(finds(c()), integer(0))
identical(finds(c(TRUE, FALSE, TRUE, FALSE, TRUE)), c(1L, 3L, 5L))

##
##  r e g e x p . R  Test suite
##


regexp <- pracma::regexp
regexpi <- pracma::regexpi
regexprep <- pracma::regexprep
refindall <- pracma::refindall

s <- "bat cat can car COAT court cut ct CAT-scan"
pat <-  'c[aeiou]+t'
identical(regexp(s, pat)$match,
          c("cat", "cut"))
identical(regexpi(s, pat)$match,
          c("cat", "COAT", "cut", "CAT"))
identical(regexp(s, pat, once = TRUE)$match,
          c("cat"))
identical(regexp(s, pat, ignorecase = TRUE, split = TRUE)$split,
          c("bat ", " can car ", " court ", " ct ", "-scan"))

identical(regexprep(s, pat, '---'),
          c("bat --- can car COAT court --- ct CAT-scan"))
identical(regexprep(s, pat, '---', once = TRUE),
          c("bat --- can car COAT court cut ct CAT-scan"))
identical(regexprep(s, pat, '---', ignorecase = TRUE),
          c("bat --- can car --- court --- ct ----scan"))

identical(refindall("AbababaBa", 'aba'), c(3, 5))
identical(refindall("AbababaBa", 'aba', ignorecase = TRUE), c(1, 3, 5, 7))

##
##  c e i l . R  tests
##

ceil <- pracma::ceil
Fix <- pracma::Fix

identical(ceil(0), 0)
identical(ceil(-1), -1)
identical(ceil(-1.5), -1)
identical(ceil(1), 1)
identical(ceil(1.5), 2)

identical(Fix(0), 0)
identical(Fix(-1), -1)
identical(Fix(-1.5), -1)
identical(Fix(1), 1)
identical(Fix(1.5), 1)

##
##  c o  n d . r  Test suite
##


cond <- pracma::cond
normest <- pracma::normest

hilb <- pracma::hilb
all.equal(c(cond(hilb(1)), cond(hilb(2)), cond(hilb(3)), cond(hilb(4))),
          c(1, 19.281470, 524.056778,  15513.738739),
          tolerance = 1e-6)
magic <- pracma::magic
all.equal(normest(magic(5)), max(svd(magic(5))$d))
all.equal(normest(pracma::magic(100)), 500050)

##
##  l i n s p a c e . R
##

linspace <- pracma::linspace
logspace <- pracma::logspace
logseq   <- pracma::logseq

identical(linspace(1, 100), as.numeric(1:100))
identical(linspace(0, 25, 5), c(0, 6.25, 12.50, 18.75, 25))
identical(linspace(1, 25, 1.5), 25)
identical(all.equal(logspace(1, pi, n=5),
                    c(10.0000, 7.4866, 5.6050, 4.1963, 3.1416),
                    tolerance=0.0001),
          TRUE)
all.equal(logseq(1, 100, 3), c(1, 10, 100))

##
##  m t r a c e . R  Test suite
##

Diag <- pracma::Diag

all.equal(Diag(matrix(1:12,3,4),  1), c(4,8,12))
all.equal(Diag(matrix(1:12,3,4), -1), c(2,6))
identical(Diag(Diag(c(1,5,9)), 0), c(1,5,9))

###
### polyarea.R  +++ Test suite +++
###


test.polyarea <- function(input, expected) {
   output <- do.call(getFromNamespace("polyarea", "pracma"), input)
   identical(output, expected)
}

polyarea.expected.empty <- 0
polyarea.expected.gen1 <- 3.5
polyarea.expected.gen2 <- 4
polyarea.expected.mtrx <- c(4, 4)
polyarea.expected.cmpl <- 0.5

test.polyarea(list(x=c(), y=c()), polyarea.expected.empty)
test.polyarea(list(x=c(0,2,2,1,0), y=c(0,-1,2,1,1)), polyarea.expected.gen1)
test.polyarea(list(x=matrix(c(1,1,3,3,1), 5, 1),
                   y=matrix(c(1,3,3,1,1), 5, 1)),
              polyarea.expected.gen2)
test.polyarea(list(x=matrix(c(1,3,3,1,1,1,3,3), 4, 2),
                   y=matrix(c(1,1,3,3,1,3,3,1), 4, 2)),
              polyarea.expected.mtrx)
test.polyarea(list(x=c(0,1,1,0), y=c(0,0,1i,0)), polyarea.expected.cmpl)

##
##  r a n k . r  Test suite
##


Rank <- pracma::Rank
nullspace <- pracma::nullspace

magic <- pracma::magic
all.equal(Rank(c()), 0)
r <- numeric(8)
for (i in 3:10){
    r[i-2] <- Rank(magic(i))
}
identical(r, c(3, 3, 5, 5, 7, 3, 9, 7))

hilb <- pracma::hilb
identical(Rank(hilb(6)), 6L)

# Vorzeichenwechsel moeglich
# N <- nullspace(magic(4))
# all.equal(as.numeric(N), c(0.2236, 0.6708, -0.6708, -0.2236),
#           tolerance = 1e-5)

###
### Poly.R  +++ Test suite +++
###


test.Poly <- function(input, expected) {
   output <- do.call(getFromNamespace("Poly", "pracma"), input)
   identical(output, expected)
}

Poly.expected.empty  <- 1
Poly.expected.1 <- c(1, -6, 11, -6)
#Poly.expected.2 <- error
Poly.expected.3 <- c(1, 0, 0, 0, -1)
Poly.expected.4 <- c(1, -10, 35, -50, 24)
Poly.expected.5 <- c(1, -4, 6, -4, 1)
Poly.expected.6 <- c(1, -5)

test.Poly(list(x=c()), Poly.expected.empty)
test.Poly(list(x=c(1,2,3)), Poly.expected.1)
#test.Poly(list(x=matrix(1:6, 2, 3)), Poly.expected.2)
test.Poly(list(x=c(1,-1,1i,-1i)), Poly.expected.3)
test.Poly(list(x=c(1,2,3,4)), Poly.expected.4)
test.Poly(list(x=diag(4)), Poly.expected.5)
test.Poly(list(x=5), Poly.expected.6)

###
### roots.R  +++ Test suite +++
###


test.roots <- function(input, expected) {
   output <- do.call(getFromNamespace("roots", "pracma"), input)
   identical(output, expected)
}

roots.expected.empty <- matrix(0, nrow=0, ncol=0)
roots.expected.singl <- matrix(0, nrow=0, ncol=0)
roots.expected.bspl1 <-  c(0, 2, -2, 1, -1)  # Matlab: c(0, -2, -1, 1, 2)
                         c(0, 2, -2, 1, -1)
roots.expected.bspl2 <-  c(0.5, -0.2)
roots.expected.bspl3 <- -c(0, 0, -1, 1)

test.roots(list(p=c()), roots.expected.empty)
test.roots(list(p=c(0)), roots.expected.singl)
#test.roots(list(p=c(1,0,-5,0,4,0)), roots.expected.bspl1)  # zapsmall
test.roots(list(p=c(1,-0.3,-0.1)), roots.expected.bspl2)
test.roots(list(p=c(1,0,-1,0,0)), roots.expected.bspl3)

##
##  f n o r m  Test suite
##


fnorm <- pracma::fnorm

identical(fnorm(log, sqrt, 1, 2, p = Inf), 1.0)
identical(fnorm(log, sqrt, 1, 2, p = -Inf), sqrt(2) - log(2))
identical(fnorm(log, sqrt, 1, 2, p = 0), Inf)

##
##  q u a d r a t u r e . R  Test suite
##


quad <- pracma::quad
quadl <- pracma::quadl
quadgk <- pracma::quadgk
quadgr <- pracma::quadgr
quadinf <- pracma::quadinf
quad2d <- pracma::quad2d
dblquad <- pracma::dblquad

simpson2d <- pracma::simpson2d
simpadpt <- pracma::simpadpt
gauss_kronrod <- pracma::gauss_kronrod
clenshaw_curtis <- pracma::clenshaw_curtis
romberg <- pracma::romberg

gaussLegendre <- pracma::gaussLegendre
gaussHermite <- pracma::gaussHermite
gaussLaguerre <- pracma::gaussLaguerre

##  F i n i t e  I n t e r v a l s

f1 <- function(x) exp(x)*sin(x)      # [0, pi]  12.0703463163896 = 1/2*(1+e^pi)
f2 <- pracma::runge                  # [-1, 1]   0.549360306778006
f3 <- function(x) 1/(x^3 - 2*x - 5)  # [0, 2]   -0.460501533846733
f4 <- function(x) abs(sin(10*x))     # [0, pi]   2.0

# quad (Adaptive Simpson)
all.equal(quad(f1, 0, pi, tol=1e-12),   12.0703463163896,
          tolerance = 1e-12)
all.equal(quad(f2, -1, 1, tol=1e-12),    0.549360306778006,
          tolerance = 1e-12)
all.equal(quad(f3, 0, 2, tol=1e-12),    -0.460501533846733,
          tolerance = 1e-12)
all.equal(quad(f4, 0, pi, tol=1e-12),    2.0,
          tolerance = 1e-12)

# quadl (Adaptive Lobatto)
all.equal(quadl(f1, 0, pi, tol=1e-9),   12.0703463163896,
          tolerance = 1e-12)
all.equal(quadl(f2, -1, 1, tol=1e-9),    0.549360306778006,
          tolerance = 1e-12)
all.equal(quadl(f3, 0, 2, tol=1e-9),    -0.460501533846733,
          tolerance = 1e-12)
all.equal(quadl(f4, 0, pi, tol=1e-12),   2.0,
          tolerance = 1e-12)

# quadgr (Gauss-Richardson)
all.equal(quadgr(f1, 0, pi, tol=1e-12)$value, 12.0703463163896,
          tolerance = 1e-13)
all.equal(quadgr(f2, -1, 1, tol=1e-12)$value,  0.549360306778006,
          tolerance = 1e-15)
all.equal(quadgr(f3, 0, 2, tol=1e-12)$value,  -0.460501533846733,
          tolerance = 1e-15)
all.equal(quadgr(f4, 0, pi, tol=1e-12)$value,  2.0,
          tolerance = 1e-15)

# quadgk (Adaptive Gauss-Kronrod)
all.equal(quadgk(f1, 0, pi), 12.0703463163896,
          tolerance = 1e-13)
all.equal(quadgk(f2, -1, 1),  0.549360306778006,
          tolerance = 1e-15)
all.equal(quadgk(f3, 0, 2),  -0.460501533846733,
          tolerance = 1e-13)
all.equal(quadgk(f4, 0, pi, tol = 1e-12),  2.0,
          tolerance = 1e-12)

# Adaptive Simpson (simpadpt)
all.equal(simpadpt(f1, 0, pi, tol=1e-12),     12.0703463163896,
          tolerance = 1e-13)
all.equal(simpadpt(f2, -1, 1, tol=1e-12),      0.549360306778006,
          tolerance = 1e-12)
all.equal(simpadpt(f3, 0, 2, tol=1e-12),      -0.460501533846733,
          tolerance = 1e-13)
all.equal(simpadpt(f4, 0, pi, tol=1e-12),      2.0,
          tolerance = 1e-14)

# Gauss-Kronrod
all.equal(gauss_kronrod(f1, 0, pi)$value, 12.0703463163896,
          tolerance = 1e-13)
all.equal(gauss_kronrod(f2, -1, 1)$value,  0.549360306778006,       # BAD
          tolerance = 1e-2)
all.equal(gauss_kronrod(f3, 0, 2)$value,  -0.460501533846733,       # Bad
          tolerance = 1e-5)
all.equal(gauss_kronrod(f4, 0, pi)$value,  2.0,                     # BAD
          tolerance = 1e-0)

# Clenshaw-Curtis
all.equal(clenshaw_curtis(f1, 0, pi, n = 128), 12.0703463163896,
          tolerance = 1e-12)
all.equal(clenshaw_curtis(f2, -1, 1, n = 128),  0.549360306778006,
          tolerance = 1e-12)
all.equal(clenshaw_curtis(f3, 0, 2, n = 128),  -0.460501533846733,
          tolerance = 1e-12)
all.equal(clenshaw_curtis(f4, 0, pi, n = 1024),  2.0,               # Bad
          tolerance = 2e-5)

# romberg
all.equal(romberg(f1, 0, pi, tol=1e-12)$value, 12.0703463163896,
          tolerance = 1e-12)
all.equal(romberg(f2, -1, 1, tol=1e-12)$value,  0.549360306778006,
          tolerance = 1e-12)
all.equal(romberg(f3, 0, 2, tol=1e-12)$value,  -0.460501533846733,  # BAD
          tolerance = 1e-3)
all.equal(romberg(f4, 0, pi, tol=1e-12)$value,  2.0,
          tolerance = 1e-12)

f5 <- function(x) log(x)*sin(x)/x       # pi/2 * gamma , cannot be computed !
f6 <- function(x) sin(x)^2 * exp(-x)    # [0, Inf] , 0.4
f7 <- function(x) sin(x)^2 * exp(-x^2)  # [-Inf, Inf] , (e-1)*sqrt(pi)/(4*e)
x7 <- (exp(1)-1) * sqrt(pi) / (2*exp(1))

# quadinf
all.equal(quadinf(f6, 0, Inf), 0.4, tolerance = 1e-15)
all.equal(quadinf(f7, -Inf, Inf), x7, tolerance = 1e-15)

all.equal(quadgr(f6, 0, Inf)$value, 0.4, tolerance = 1e-11)
all.equal(quadgr(f7, -Inf, Inf)$value, x7, tolerance = 1e-9)

gL <- gaussLaguerre(64)
all.equal(sum(gL$w * sin(gL$x)^2), 0.4, tolerance = 1e-15)
gH <- gaussHermite(64)
all.equal(sum(gH$w * sin(gH$x)^2), x7, tolerance = 1e-14)

f8 <- function(x, y) y * sin(x)  # [0, pi/2]x[0, 1] , 1/2
f9 <- function(x, y) ifelse(x^2 + y^2 <= 1, 1-x^2-y^2, 0)

# quad2d
all.equal(quad2d(f8, 0, pi/2, 0, 1), 0.5,         tolerance = 1e-15)
all.equal(quad2d(f9, -1, 1, 0, 1, n = 128), pi/4, tolerance = 1e-6)

# dblquad
all.equal(dblquad(f8, 0, pi/2, 0, 1), 0.5, tolerance = 1e-15)
#all.equal(dblquad(f9, -1, 1, 0, 1), pi/4,  tolerance = 1e-6)
    # disabled because of problems with Fedora and Solaris

# simpson2d
all.equal(simpson2d(f8, 0, pi/2, 0, 1), 0.5, tolerance = 1e-9)
all.equal(simpson2d(f9, -1, 1, 0, 1), pi/4,  tolerance = 1e-5)

# Integrals with singularities at boundaries:
f11 <- function(t) log(1-t) / t  # [1, 0]  pi^2/6 , dilogarithm
f12 <- function(t) log(-log(t))  # [0, 1]  gamma = 0.57721 56649 01532 ...
f13 <- function(t) 1 / sqrt(t)   # [0, 1]  2.0

all.equal(quad(f11, 1, 0, tol = 1e-12),  1.64493406684823,
          tolerance = 1e-10)
all.equal(quad(f12, 0, 1, tol = 1e-12), -0.577215664901533,
          tolerance = 5e-10)
all.equal(quad(f13, 0, 1, tol = 1e-12),  2.0,
          tolerance = 1e-4)                                         # Bad
                                       
all.equal(quadl(f11, 1, 0, tol = 1e-12),  1.64493406684823,
          tolerance = 1e-12)           
all.equal(quadl(f12, 0, 1, tol = 1e-12), -0.577215664901533,
          tolerance = 5e-12)           
all.equal(quadl(f13, 0, 1, tol = 1e-12),  2.0,
          tolerance = 1e-7)                                         # Bad

all.equal(quadgr(f11, 1, 0, tol = 1e-12)$value,  1.64493406684823,
          tolerance = 1e-12)
all.equal(quadgr(f12, 0, 1, tol = 1e-12)$value, -0.577215664901533,
          tolerance = 5e-12)
all.equal(quadgr(f13, 0, 1, tol = 1e-12)$value,  2.0,
          tolerance = 1e-12)

all.equal(simpadpt(f11, 1, 0, tol = 1e-12),  1.64493406684823,
          tolerance = 1e-11)           
all.equal(simpadpt(f12, 0, 1, tol = 1e-12), -0.577215664901533,
          tolerance = 5e-11)           
all.equal(simpadpt(f13, 0, 1, tol = 1e-10),  2.0,
          tolerance = 1e-7)                                         # Bad

##  E o F

##
##  m l d i v i d e . R  test suite
##


mldivide <- pracma::mldivide
mrdivide <- pracma::mrdivide

A <- matrix(c(8,1,6, 3,5,7, 4,9,2), nrow = 3, ncol = 3, byrow = TRUE)
identical(all.equal(mldivide(A, A), diag(1, 3, 3), tolerance=1e-7), TRUE)
identical(all.equal(mrdivide(A, A), diag(1, 3, 3), tolerance=1e-7), TRUE)

###
### polyder.R  +++ Test suite +++
###


test.polyder <- function(input, expected) {
   output <- do.call(getFromNamespace("polyder", "pracma"), input)
   identical(output, expected)
}

polyder.expected.0 <- 0
polyder.expected.1 <- 0
polyder.expected.5 <- c(4, 3, 2, 1)
polyder.expected.3 <- c(2, 0)
polyder.expected.2 <- c(12, 36, 42, 18)


test.polyder(list(p=c()), polyder.expected.0)
test.polyder(list(p=c(1)), polyder.expected.1)
test.polyder(list(p=c(1,1,1,1,1)), polyder.expected.5)
test.polyder(list(p=c(1,0,0), q=c(0,0,1)), polyder.expected.3)
test.polyder(list(p=c(3,6,9), q=c(1,2,0)), polyder.expected.2)

###
### f a c t o r s . R  +++ Test suite +++
###


test.factors <- function(input, expected) {
    output <- do.call(getFromNamespace("factors", "pracma"), input)
    identical(output, expected)
}

factors.expected.n2  <- 2
factors.expected.n3  <- 3
# factors.expected.prm <- 999983
# factors.expected.pr2 <- c(9999889, 9999901)
# factors.expected.prp <- c(65003, 65003)
# factors.expected.nn  <- c(2, 2, 2, 2, 2, 3, 3, 3, 3, 5, 5, 5, 7, 7, 11)
# factors.expected.nm  <- c(99989, 99991, 100003)
# factors.expected.n32 <- c(3, 5, 17, 257, 65537)

test.factors(list(n=2), factors.expected.n2)
test.factors(list(n=3), factors.expected.n3)
# test.factors(list(n=999983), factors.expected.prm)
# test.factors(list(n=9999889*9999901), factors.expected.pr2)
# test.factors(list(n=4225390009), factors.expected.prp)
# test.factors(list(n=2^5 * 3^4 * 5^3 * 7^2 * 11), factors.expected.nn)
# test.factors(list(n=99989*99991*100003), factors.expected.nm)
# test.factors(list(n=2^32-1), factors.expected.n32)

##
##  r e p m a t . R  Test Suite
##

repmat <- pracma::repmat
Reshape <- pracma::Reshape

v <- c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)
a <- matrix(v, 3, 4)
identical(Reshape(a, 4, 3), matrix(v, 4, 3))

identical(repmat(matrix(1:4, 2, 2), 3),
          matrix(rep(c(rep(c(1,2), 3), rep(c(3, 4), 3)), 3), nrow=6, ncol=6))

##
##  f i n d p e a k s . R  Test suite
##


findpeaks <- pracma::findpeaks

x <- c(2, 12, 4, 6, 9, 4, 3, 1, 19, 7)
identical(findpeaks(x),
          matrix(c(12,9,19, 2,5,9, 1,3,8, 3,8,10), nrow=3, ncol=4))
identical(findpeaks(x, npeaks = 1, sortstr = TRUE),
          matrix(c(19, 9, 8, 10), nrow = 1))
identical(findpeaks(x, minpeakheight = 15),
          matrix(c(19, 9, 8, 10), nrow = 1))
identical(findpeaks(x, threshold = 10),
          matrix(c(19, 9, 8, 10), nrow = 1))
# Not yet implemented
# identical(findpeaks(x, threshold = 10),
#           c(19, 9, 8, 9))

##
##  n o r m  Test suite
##


Norm <- pracma::Norm

identical(Norm(c(3, 4)), 5)
identical(Norm(c(1, 1, 1), p=2), sqrt(3))
identical(Norm(1:10, p = 1), sum(1:10)+0.0)
identical(Norm(1:10, p = 0), Inf)
identical(Norm(1:10, p = Inf), max(1:10))
identical(Norm(1:10, p = -Inf), min(1:10))

###
### cross.R  +++ Test suite +++
###


test.cross <- function(input, expected) {
   output <- do.call(getFromNamespace("cross", "pracma"), input)
   identical(output, expected)
}

cross.expected.1 <- c(-3, 6, -3)
#cross.expected. <- 
#cross.expected. <- 
#cross.expected. <- 

test.cross(list(x=c(1, 2, 3), y=c(4, 5, 6)), cross.expected.1)
#test.cross(list(), cross.expected.)
#test.cross(list(), cross.expected.)
#test.cross(list(), cross.expected.)

##
##  m e s h g r i d . R Test suite
##


meshgrid <- pracma::meshgrid

identical(meshgrid(1:3, 10:14)$X,
          matrix(rep(c(1:3), each = 5), nr = 5, nc = 3))
identical(meshgrid(1:3, 10:14)$Y, 
          matrix(rep(10:14, times = 3), nr = 5, nc = 3))

###
### wilkinson.R  +++ Test suite +++
###

wilkinson <- pracma::wilkinson

identical(wilkinson(0), NULL)
identical(wilkinson(1), matrix(0, nrow=1, ncol=1))
identical(wilkinson(3), matrix(c(1,1,0, 1,0,1, 0,1,1), 3, 3))

###
### polyfit.R  +++ Test suite +++
###


test.polyfit <- function(input, expected) {
   output <- do.call(getFromNamespace("polyfit", "pracma"), input)
   identical(all.equal(output,
                       expected,
                       tolerance=1e-7),
             TRUE
    )
}

polyfit.expected.n1  <- c(1, 0)
polyfit.expected.n23 <- c(0, 1, 1, 1)
polyfit.expected.n4  <- c(-1, 0, 7, 0, 0) / 6
polyfit.expected.mat <- c(0, 1, -14, 65, -112, 60) / 12

test.polyfit(list(x=c(1,2,3), y=c(1,2,3)), polyfit.expected.n1)
test.polyfit(list(x=c(-2,-1,0,1,2), y=c(3,1,1,3,7), n=3), polyfit.expected.n23)
test.polyfit(list(x=c(-2,-1,0,1,2), y=c(2,1,0,1,2), n=4), polyfit.expected.n4)
test.polyfit(list(x=matrix(1:6, nrow=2, ncol=3, byrow=TRUE),
                  y=matrix(c(0,0,1,1,0,0), nrow=2, ncol=3, byrow=TRUE),
                  n=5), polyfit.expected.mat)

###
### trapz.R  +++ Test suite +++
###


test.trapz <- function(input, expected) {
   output <- do.call(getFromNamespace("trapz", "pracma"), input)
   identical(output, expected)
}

trapz.expected.empty1 <- 0
trapz.expected.empty2 <- 0
trapz.expected.gen1 <- 12
trapz.expected.gen2 <- 6
trapz.expected.cmpl1 <- 0+0.5i
trapz.expected.cmpl2 <- 0+0.5i

test.trapz(list(x=c()), trapz.expected.empty1)
test.trapz(list(x=c(), y=c()), trapz.expected.empty2)
test.trapz(list(x=1:5), trapz.expected.gen1)
test.trapz(list(x=seq(0,2,by=0.5), y=1:5), trapz.expected.gen2)
test.trapz(list(x=c(0,1), y=c(0,1i)), trapz.expected.cmpl1)
test.trapz(list(x=c(0,1i), y=c(0,1)), trapz.expected.cmpl2)

###
### VANDER.R  +++ Test suite +++
###

test.vander <- function(input, expected) {
    output <- do.call(getFromNamespace("vander", "pracma"), input)
    identical(output, expected)
}

vander.expected.empty <- matrix(as.numeric(NA), nrow=0, ncol=0)
vander.expected.scalar <- matrix(1.0, nrow=1, ncol=1)
vander.expected.seq3 <- matrix(c( 1,       1,     1,    1,   1,
                                  5.0625,  3.375, 2.25, 1.5, 1,
                                 16,       8,     4,    2,   1,
                                 39.0625, 15.625, 6.25, 2.5, 1,
                                 81,      27,     9,    3,   1),
                               nrow=5, ncol=5, byrow=TRUE)
vander.expected.complex <- matrix(c(-1, 0.0 + 1i, 1.0,
                                    -4, 0.0 + 2i, 1.0,
                                    -9, 0.0 + 3i, 1.0),
                                  nrow=3, ncol=3, byrow=TRUE)

test.vander(list(x=numeric()), vander.expected.empty)
test.vander(list(x=1), vander.expected.scalar)
test.vander(list(x=seq(from=1, to=3, by=0.5)), vander.expected.seq3)
test.vander(list(x=c(1,2,3)*1i), vander.expected.complex)

##
##  s t r f i n d . R  Test suite
##


strfind <- pracma::strfind
strfindi <- pracma::strfindi
#findstr <- pracma::findstr

identical(strfind("", "aba"), NULL)
identical(strfind("ab", "aba"), NULL)
identical(strfind("aba", "aba"), 1)
identical(strfind("ababa", "aba"), c(1, 3))
identical(strfind("ababa", "aba", overlap=FALSE), 1)

identical(strfindi("ABA", "aba"), 1)
identical(strfindi("aba", "ABA"), 1)
identical(strfindi("ABABA", "aba"), c(1, 3))
identical(strfindi("aBaBa", "AbA", overlap=FALSE), 1)

###
### pow2.R  +++ Test suite +++
###


test.pow2 <- function(input, expected) {
    output <- do.call(getFromNamespace("pow2", "pracma"), input)
    identical(output, expected)
}

pow2.expected.00 <- 0
pow2.expected.m1 <- -0.5
pow2.expected.f  <- c(1, 2, 4, 8)
pow2.expected.fe <- c(0, 0.5, -8, 24)
pow2.expected.c  <- c(2^(1i), 2^(-1i))

test.pow2(list(f=0, e=0), pow2.expected.00)
test.pow2(list(f=-1, e=-1), pow2.expected.m1)
test.pow2(list(f=c(0,1,2,3)), pow2.expected.f)
test.pow2(list(f=c(0,1,-2,3), e=c(0,-1,2,3)), pow2.expected.fe)
test.pow2(list(f=c(1i, -1i)), pow2.expected.c)

##
##  s t r i n g s . R  tests
##

strcat <- pracma::strcat
strcmp <- pracma::strcmp
strcmpi <- pracma::strcmpi

strcmp(" empty", " empty")               # T
!strcmp("empty ", "empty")               # F
!strcmp("foobar", "barfoo")              # F
!strcmp("string", "String")              # F
!strcmp(c("yes", "no"), c("yes", "on"))  # F
!strcmp(c("abc", "abc"), c("abc"))       # F
strcmp(c("yes", "no"), c("yes", "no"))   # T

strcmpi("string", "String")              # T
strcmpi(c("yes", "no"), c("Yes", "No"))  # T

blanks <- pracma::blanks
deblank <- pracma::deblank
strTrim <- pracma::strTrim
strjust <- pracma::strjust
strRep <- pracma::strRep

identical(c(blanks(0), blanks(1), blanks(2)), c("", " ", "  "))
s <- c("  abc", "abc   ", " abc ", " a b c ", "abc", "a b c")
identical(deblank(s), c("  abc", "abc", " abc", " a b c", "abc", "a b c"))
identical(strTrim(s), c("abc", "abc", "abc", "a b c", "abc", "a b c"))
identical(strjust(s, justify = "center"),
          c(" abc ", " abc ", " abc ", "a b c", " abc ", "a b c"))
s <- c('This is a good example.', "He has a good character.",
       'This is good, good food.', "How goodgood this is!")
identical(strRep(s, 'good', 'great'),
          c('This is a great example.', "He has a great character.",
            'This is great, great food.', "How greatgreat this is!"))

##
##  p e r m s . R  Test Suite
##

perms <- pracma::perms
randperm <- pracma::randperm

identical(perms(2), matrix(2, 1, 1))
identical(perms(c(1, 2)), matrix(c(2, 1, 1, 2), 2, 2))
identical(nrow(perms(1:6)), 720L)

all(c(1,2,3) %in% randperm(c(1,2,3)))

###
### eig.R  +++ Test suite +++
###


test.inv <- function(input, expected) {
   output <- do.call(getFromNamespace("inv", "pracma"), input)
   identical(output, expected)
}

inv.expected.empty <- matrix(0, nrow=0, ncol=0)
inv.expected.singl <- matrix(Inf, 2, 2)
inv.expected.mat1  <- matrix(c(3,-3,1, -3,5,-2, 1,-2,1), 3, 3)

test.inv(list(a=c()), inv.expected.empty)
test.inv(list(a=matrix(1, 2, 2)), inv.expected.singl)
test.inv(list(a=matrix(c(1,1,1, 1,2,3, 1,3,6), 3, 3)), inv.expected.mat1)

##
##  i n t e r p 1 . R Test suite
##


interp1 <- pracma::interp1

x <- c(0.0, 0.5, 1.0, 1.5)
y <- x^2
xi <- c(0.25, 0.75, 1.25)

identical(interp1(x, y, xi, method="constant"), c(0.0, 0.25, 1.0))
identical(interp1(x, y, xi, method="linear"),   c(0.125, 0.625, 1.625))
identical(interp1(x, y, xi, method="nearest"),  c(0.25, 1.00, 2.25))
identical(interp1(x, y, xi, method="spline"),   c(0.0625, 0.5625, 1.5625))

# Not yet implemented
# identical(interp1(x, y, xi, method="cubic"),    c(0.0781, 0.5547, 1.5547))

##
##  p i e c e w i s e . R  Test suite
##


piecewise <- pracma::piecewise

x <- c(0, 1,  2, 3, 4, 5)
y <- c(1, 1, -1, 0, 1, 0)
identical(piecewise(x, y)$area,  1.5)
identical(piecewise(x, y)$zeros, c(1.5, 3, 5))
identical(piecewise(x, y, abs = TRUE)$area,  3.0)
identical(piecewise(x, y, abs = TRUE)$zeros, c(1.5, 3, 5))

###
### dot.R  +++ Test suite +++
###


test.dot <- function(input, expected) {
   output <- do.call(getFromNamespace("dot", "pracma"), input)
   identical(output, expected)
}

dot.expected.empty <- 0
dot.expected.55 <- 55
dot.expected.t55 <- 55
dot.expected.mm <- c(26, 44)
dot.expected.00 <- 0
dot.expected.neg <- -2

test.dot(list(x=c(), y=c()), dot.expected.empty)
test.dot(list(x=1:5, y=1:5), dot.expected.55)
test.dot(list(x=1:5, y=t(t(1:5))), dot.expected.t55)
test.dot(list(x=matrix(c(1,3,2,4), 2, 2), y=matrix(c(5,7,6,8), 2, 2)),
         dot.expected.mm)
test.dot(list(x=c(0, 0), y=c(1, 2)), dot.expected.00)
test.dot(list(x=c(1, 1), y=c(-1, -1)), dot.expected.neg)

##
##  c r o s s n . R  tests
##

crossn <- pracma::crossn

x <- c(1.0, 0.0, 0.0)
y <- c(1.0, 0.5, 0.0)
z <- c(0.0, 0.0, 1.0)
identical(pracma::dot(x, crossn(rbind(y, z))),
          det(rbind(x, y, z)))

##
##  s t d . r  tests
##

std <- pracma::std
std_err <- pracma::std_err

all.equal(std(1:10), 3.0277, tolerance=0.0001)
all.equal(std(1:10, flag=0), 3.0277, tolerance=0.0001)
all.equal(std(1:10, flag=1), 2.8723, tolerance=0.0001)

all.equal(std_err(1:10), 0.9574271, tolerance=0.0001)

##
##  p a s c a l . R  Test Suite
##

pascal <- pracma::pascal
nchoosek <- pracma::nchoosek

identical(pascal(3),
          matrix(c(1, 1, 1, 1, 2, 3, 1, 3, 6), 3, 3))

identical(nchoosek(6, 1), choose(6, 1))
identical(nchoosek(6, 2), choose(6, 2))
identical(nchoosek(6, 3), choose(6, 3))
identical(nchoosek(6, 4), choose(6, 4))
identical(nchoosek(6, 5), choose(6, 5))
identical(nchoosek(6, 6), choose(6, 6))

###
### nextpow2.R  +++ Test suite +++
###


test.nextpow2 <- function(input, expected) {
    output <- do.call(getFromNamespace("nextpow2", "pracma"), input)
    identical(output, expected)
}

nextpow2.expected.empty <- NULL
nextpow2.expected.0 <- 0
nextpow2.expected.vector <- c(0, 1, 2, 2, 3, 3, 3, 3, 4, 4)
nextpow2.expected.matrix <- matrix(c(0, 1, 1, 0), 2, 2)
nextpow2.expected.16 <- 4
nextpow2.expected.m16 <- 4
nextpow2.expected.m6 <- -19
nextpow2.expected.mq <- -2

test.nextpow2(list(x=c()), nextpow2.expected.empty)
test.nextpow2(list(x=0), nextpow2.expected.0)
test.nextpow2(list(x=1:10), nextpow2.expected.vector)
test.nextpow2(list(x=matrix(c(1i, 2i, 2+0i, 0+0i), 2, 2)),
                       nextpow2.expected.matrix)
test.nextpow2(list(x=16), nextpow2.expected.16)
test.nextpow2(list(x=-16), nextpow2.expected.m16)
test.nextpow2(list(x=1e-6), nextpow2.expected.m6)
test.nextpow2(list(x=-0.25), nextpow2.expected.mq)

##
##  h or n e r . R  Test Suite
##


horner <- pracma::horner
hornerdefl <- pracma::hornerdefl

p <- c(1, 0, 1)
x <- c(-2, -1, 0, 1, 2)
identical(horner(p, x)$y, x^2 + 1)
identical(horner(p, x)$dy, 2*x)

p <- c(1, -6, 11, -6)
identical(hornerdefl(p, 3)$y, 0)
identical(hornerdefl(p, 3)$q, (c(1, -3, 2)))

###
### eig.R  +++ Test suite +++
###


test.eig <- function(input, expected) {
   output <- do.call(getFromNamespace("eig", "pracma"), input)
   identical(output, expected)
}

eig.expected.empty <- matrix(0, nrow=0, ncol=0)
eig.expected.singl <- 1
eig.expected.mat1  <- c(2, 0)
eig.expected.mat2  <- c(1+1i, 1-1i)
eig.expected.mat3  <- c(1, -1)

test.eig(list(a=c()), eig.expected.empty)
test.eig(list(a=c(1)), eig.expected.singl)
test.eig(list(a=matrix(c(1,-1,-1,1), 2, 2)), eig.expected.mat1)
test.eig(list(a=matrix(c(1,1,-1,1), 2, 2)), eig.expected.mat2)
test.eig(list(a=matrix(c(0,1i,-1i,0), 2, 2)), eig.expected.mat3)

###
### NTHROOT.R  +++ Test suite +++
###


test.nthroot <- function(input, expected) {
    output <- do.call(getFromNamespace("nthroot", "pracma"), input)
    identical(output, expected)
}

nthroot.expected.n0 <- c(-1.2)
nthroot.expected.n1 <- c(1, -2, 3)
nthroot.expected.n2 <- c(1,  0, 3)
nthroot.expected.n3 <- c(1, -2, 3)

test.nthroot(list(x=-1.2^5, n=5), nthroot.expected.n0)
test.nthroot(list(x=c(1,-2, 3), n=1), nthroot.expected.n1)
test.nthroot(list(x=c(1, 0, 9), n=2), nthroot.expected.n2)
test.nthroot(list(x=c(1,-8,27), n=3), nthroot.expected.n3)

###
### polyval.R  +++ Test suite +++
###


test.polyval <- function(input, expected) {
   output <- do.call(getFromNamespace("polyval", "pracma"), input)
   identical(output, expected)
}

polyval.expected.empty1 <- c()
polyval.expected.empty2 <- c(0, 0)
polyval.expected.vec <- c(3, 1, 1, 3, 7)
polyval.expected.mat <- matrix(c(1, 4, 9, 16), nrow=2, ncol=2)

test.polyval(list(p=c(1,1), x=c()), polyval.expected.empty1)
test.polyval(list(p=c(), x=c(1,1)), polyval.expected.empty2)
test.polyval(list(p=c(1,1,1), x=-2:2), polyval.expected.vec)
test.polyval(list(p=c(1,0,0), x=matrix(1:4, 2, 2)), polyval.expected.mat)

##
##  c o m b s . R  Test Suite
##

combs <- pracma::combs
randcomb <- pracma::randcomb

identical(combs(2, 1), 2)
identical(combs(c(1, 2, 3), 2), matrix(rep(c(1, 2, 3), each = 2), 3, 2))
identical(nrow(combs(1:6, 4)), 15L)

all(c(1,2,3) %in% randcomb(c(1,2,3), 3))

##
##  f i n d i n t e r v a l s . R  Test suite
##

findintervals <- pracma::findintervals

identical(findintervals(0, zapsmall(sin(seq(0, 10*pi, len=100)))),
          as.integer(c(1, 10, 20, 30, 40, 50, 60, 70, 80, 90, 100)))

##
##  s u b s p a c e . r  Test suite
##


orth <- pracma::orth
subspace <- pracma::subspace

is.null(orth(c()))
M <- matrix(1:12, 3, 4)
all.equal(orth(M),
          matrix(c(-0.504533, -0.760776,
                   -0.574516, -0.057141,
                   -0.644497,  0.646495), 3, 2, byrow = TRUE),
          tolerance = 1e-5)

H <- pracma::hadamard(8)
A <- H[, 2:4]
B <- H[, 5:8]
all.equal(subspace(A, B), pi/2, tolerance = 1e-10)  

##
##  n o r m . R  Vector Norm
##


Norm <- function(x, p=2) {
    stopifnot(is.numeric(x) || is.complex(x),
              is.numeric(p), length(p) == 1)

    if (p > -Inf && p < Inf) sum(abs(x)^p)^(1/p)
    else if (p ==  Inf) max(abs(x))
    else if (p == -Inf) min(abs(x))
    else return(NULL)
}

##
##  n e l d e r m e a d . R  Nelder-Mead function minimization
##


nelder_mead <- function(fn, x0, ..., adapt = TRUE,
                        tol = 1e-08, maxfeval = 5000, 
			            step = rep(1.0, length(x0))) {
    stopifnot(is.numeric(x0), is.numeric(step))
    n <- length(x0)
    if (length(step) != n)
        stop("Argument 'step' must be of the same length as 'x0'.")

    fun <- match.fun(fn)
    fn  <- function(x) fun(x, ...)

                        # Inputs:
    start  <- x0        # starting point
    reqmin <- tol       # terminating limit for the variance of function values
    # step <- step      # size and shape of the initial simplex
    kcount <- maxfeval  # maximum number of function evaluations.
    konvge <- kcount/100# convergence check is carried out every
	                    #   KONVGE iterations, >= 1

                        # Outputs:
    xmin   <- NA        # estimated minimum of the function
    ynewlo <- NA        # minimum value of the function
    icount <- 0         # number of function evaluations
    numres <- 0         # number of restarts, must be > 1
    ifault <- 0         # error indicator, 0, 1, 2

    # Constants for Nelder-Mead
	if (adapt) {
	    rcoeff <- 1.0               # reflection   1.0
	    ecoeff <- 1.0 + 2.0/n       # expansion    2.0
	    ccoeff <- 0.75 - 1.0/(2*n)  # contraction  0.5
	    scoeff <- 1.0 - 1.0/n       # shrinking    0.5
	    eps    <- 0.001
	} else {
        rcoeff <- 1.0
        ecoeff <- 2.0
        ccoeff <- 0.5
    	scoeff <- 0.5
        eps    <- 0.001
    }
    
    jcount <- konvge
    dn <- n
    nn <- n + 1
    dnn <- nn
    del <- 1.0
    rq <- reqmin * dn

    pbar   <- numeric(n)  # centroid
    pstar  <- numeric(n)
    p2star <- numeric(n)

    y <- numeric(n+1)
    p <- matrix(0, n, n+1)

    while ( TRUE ) {                    # outer while loop
        
        # Initial or restarted loop
        p[, nn] <- start
        y[nn] <- fn ( start )
        icount <- icount + 1

        for (j in 1:n) {
          x <- start[j]
          start[j] <- start[j] + step[j] * del
          p[, j] <- start
          y[j] <- fn ( start )
          icount <- icount + 1
          start[j] <- x
        } # simplex construction is complete

        # Find highest and lowest y values.
        ilo <- which.min(y)
        ylo <- y[ilo]

        while ( icount < kcount ) {                # inner while loop

            # indicate the vertex of the simplex to be replaced
            ihi <- which.max(y)
            ynewlo <- y[ihi]

            # Calculate the centroid of the simplex vertices
            #   excepting the vertex with Y value YNEWLO
            pbar <- rowSums(p[, -ihi]) / dn

            # Reflection through the centroid
            pstar <- pbar + rcoeff * ( pbar - p[,ihi] )
            ystar <- fn ( pstar )
            icount <- icount + 1

            # Successful reflection, so extension
            if ( ystar < ylo ) {
                p2star = pbar + ecoeff * ( pstar - pbar )
                y2star <- fn ( p2star )
                icount <- icount + 1

                # Check extension.
                if ( ystar < y2star ) {
                    p[, ihi] <- pstar
                    y[ihi] <- ystar

                # Retain extension or contraction.
                } else {
                    p[, ihi] <- p2star
                    y[ihi] <- y2star
                }

            #  No extension.
            } else {
                l <- sum(ystar < y)
                if ( l > 1 ) {
                    p[, ihi] <- pstar
                    y[ihi] <- ystar

                # Contraction on the Y(IHI) side of the centroid.
                } else if ( l == 0 ) {
                    p2star <- pbar + ccoeff * ( p[, ihi] - pbar )
                    y2star <- fn ( p2star )
                    icount <- icount + 1

                    #  Contract the whole simplex.
                    if ( y[ihi] < y2star ) {
                        for (j in 1:nn) {
                            p[, j] <- scoeff * (p[, j] + p[, ilo])
                            xmin <- p[, j]
                            y[j] <- fn ( xmin )
                            icount <- icount + 1
                        }

                        ilo <- which.min(y)
                        ylo <- y[ilo]
                        next

                    # Retain contraction
                    } else {
                        p[, ihi] <- p2star
                        y[ihi] <- y2star
                    }

                #  Contraction on the reflection side of the centroid
                } else if ( l == 1 ) {
                    p2star <- pbar + ccoeff * ( pstar - pbar )
                    y2star <- fn ( p2star )
                    icount <- icount + 1

                    #  Retain reflection?
                    if ( y2star <= ystar ) {
                        p[, ihi] <- p2star
                        y[ihi] <- y2star

                    } else {
                        p[, ihi] <- pstar
                        y[ihi] <- ystar
                    }
                }
            }

            #  Check if YLO improved.
            if ( y[ihi] < ylo ) {
                ylo <- y[ihi]
                ilo <- ihi
            }
            jcount <- jcount - 1
            
            if ( 0 < jcount )
                next

            #  Check to see if minimum reached.
            if ( icount <= kcount ) {
              jcount <- konvge

              x <- sum(y) / dnn
              z <- sum((y - x)^2)
              if ( z <= rq )
                break
            }
        }                               # end inner while loop

        # Factorial tests to check that YNEWLO is a local minimum
        xmin <- p[, ilo]
        ynewlo <- y[ilo]

        if ( kcount < icount ) {
            ifault <- 2
            break
        }

        ifault <- 0

        # Check in all directions with step length
        for (i in 1:n) {
            del <- step[i] * eps
            xmin[i] <- xmin[i] + del
            z <- fn ( xmin )
            icount <- icount + 1
            if ( z < ynewlo ) {
                ifault <- 2
                break
            }
            xmin[i] <- xmin[i] - del - del
            z <- fn ( xmin )
            icount <- icount + 1
            if ( z < ynewlo ) {
                ifault <- 2
                break
            }
            xmin[i] <- xmin[i] + del
        }

        if ( ifault == 0 )
            break

        #  Restart the procedure.
        start <- xmin

        del <- eps
        numres <- numres + 1
    }                                   # end outer while loop

    return(list(xmin = xmin, fmin = ynewlo, count = icount, convergence = 0,
                info = list(solver = "Nelder-Mead", restarts = numres)))
} # end of function

##
##  q u a d g r . R  Gauss-Richardson Quadrature
##


quadgr <- function(f, a, b, tol = .Machine$double.eps^(1/2), ...) {
    stopifnot(is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1)
    
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    
    # Check for multivalues/vectorization
    if (length(f(a)) != 1 || length(f(b)) != 1)
        stop("Function 'f' may be multi-valued; please check.")
    if (length(f(c(a, b))) != 2)
        stop("Function 'f' needs to be vectorized (see 'Vectorize').")
    
    # check order of limits
    if (a == b) return(list(value = 0, rel.err = 0))
    else if (a > b) {
        tmp <- a; a <- b; b <- tmp
        rev_p <- TRUE
    } else
        rev_p <- FALSE
    
    # Check infinite limits
    if (is.infinite(a) || is.infinite(b)) {
        if (is.finite(a) && is.infinite(b)) {
            f1 <- function(t) f(a + t/(1-t)) / (1-t)^2
            Q <- quadgr(f1, 0, 1, tol = tol)
            
        } else if (is.infinite(a) && is.finite(b)) {
            f2 <- function(t) f(b + t/(1+t)) / (1+t)^2
            Q <- quadgr(f2, -1, 0, tol = tol)
            
        } else if (is.infinite(a) && is.infinite(b)) {
            f1 <- function(t) f(t/(1-t)) / (1-t)^2
            f2 <- function(t) f(t/(1+t)) / (1+t)^2
            Q1 <- quadgr(f1,  0, 1, tol = tol/2)
            Q2 <- quadgr(f2, -1, 0, tol = tol/2)
            Q  <- list(value = Q1$value + Q2$value,
                       rel.err = Q1$rel.err + Q2$rel.err)
        }
        if (rev_p) Q$value <- -Q$value
        return(Q)
    } # else ...
    
    # 12-point Gauss-Legendre quadrature
    xq <- c(0.12523340851146894, 0.36783149899818018, 0.58731795428661748,
            0.76990267419430469, 0.9041172563704748,  0.98156063424671924)
    wq <- c(0.24914704581340288, 0.23349253653835478, 0.20316742672306584,
            0.16007832854334636, 0.10693932599531818, 0.047175336386511842)
    xq <- matrix(c(xq, -xq), ncol = 1)
    wq <- c(wq,  wq)
    nq <- length(xq)
    
    # Initiate vectors
    maxit <- 17                         # max number of iterations
    Q0 <- zeros(maxit,1)       	        # quadrature
    Q1 <- zeros(maxit,1)       	        # first Richardson extrapolation
    Q2 <- zeros(maxit,1)       	        # second Richardson extrapolation
    
    # One interval
    hh <- (b - a)/2                     # half interval length
    x <- (a + b)/2 + hh*xq              # nodes
    Q0[1] = hh * wq %*% fun(x)          # quadrature
    
    for (k in 3:maxit) {
        hh <- hh/2
        x <- cbind(x + a, x + b) / 2
        # Q0[k] <- hh * wq %*% apply(f(x), 1, sum)
        A <- numeric(12)
        for (i in 1:12) A[i] <- sum(f(x[i, ]))
        Q0[k] <- hh * wq %*% A
        
        # Richardson extrapolation
        if (k >= 5) {
            Q1[k] <- .rich(Q0,k)
            Q2[k] <- .rich(Q1,k)
        } else if (k >= 3) {
            Q1[k] <- .rich(Q0,k)
        }
        
        # Estimate absolute error
        if (k >= 6) {
            Qv <- c(Q0[k], Q1[k], Q2[k])
            Qw <- c(Q0[k-1], Q1[k-1], Q2[k-1])
        } else if (k >= 4) {
            Qv <- c(Q0[k], Q1[k])
            Qw <- c(Q0[k-1], Q1[k-1])
        } else {
            Qv <- Q0[k]
            Qw <- Q0[k-1]
        }
        
        err <- min(abs(Qv - Qw))
        j <- which.min(abs(Qv - Qw))
        Q <- Qv[j]
        
        # Convergence
        if (err < tol || !is.finite(Q)) break
    }
    
    if (rev_p) Q <- -Q
    return(list(value = Q, rel.err = err))
}


.rich <- function(Q, k) {
    if (Q[k] != Q[k-1]) {
        cc <- (Q[k-1] - Q[k-2]) / (Q[k] - Q[k-1]) - 1
    } else {
        cc <- 1
    }
    cc <- max(cc, 0.07)
    return(Q[k] + (Q[k] - Q[k-1])/cc)
}

###
### VANDER.R  Vandermonde matrix
###


vander <- function(x) {
    n <- length(x)
    if (n == 0) return(matrix(0, nrow=0, ncol=0))
    if ((!is.numeric(x) && !is.complex(x)) || is.array(x))
        stop("Argument 'x' must be a numeric or complex  vector.")

    A <- outer(x, seq(n-1, 0), "^")
    return(A)
}

##
##  o d e 2 3 . R  ODE Solver
##


ode23 <- function(f, t0, tfinal, y0, ..., rtol = 1e-3, atol = 1e-6) {
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1,
              is.numeric(tfinal), length(tfinal) == 1)
              
    if (is.vector(y0)) {
        y0 <- as.matrix(y0)
    } else if (is.matrix(y0)) {
        if (ncol(y0) != 1)
            stop("Argument 'y0' must be a vector or single column matrix.")
    }

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)
    if (length(f(t0, y0)) != length(y0))
        stop("Argument 'f' does not describe a system of equations.")

    # Set initial parameters
    eps <- .Machine$double.eps  # Matlab parameters
    realmin <- 1e-100

    tdir <- sign(tfinal - t0)
    threshold <- atol / rtol
    hmax <- abs(0.1 * (tfinal-t0))

    t <- t0; tout <- t
    y <- y0; yout <- t(y)

    # Compute initial step size
    s1 <- f(t, y)
    r <- max(abs(s1 / max(abs(y), threshold))) + realmin
    h <- tdir * 0.8 * rtol^(1/3) / r

    # Main loop
    while (t != tfinal) {
        hmin <- 16 * eps * abs(t)
        if (abs(h) > hmax) {
            h <- tdir * hmax
        } else if (abs(h) < hmin) {
            h <- tdir * hmin
        }

        # Stretch the step if t is close to tfinal
        if (1.1 * abs(h) >= abs(tfinal - t))
            h <- tfinal - t

        # Attempt a step
        s2   <- f(t + h/2, y + h/2 * s1)
        s3   <- f(t + 3*h/4, y + 3*h/4 * s2)
        tnew <- t + h
        ynew <- y + h * (2*s1 + 3*s2 + 4*s3) / 9
        s4   <- f(tnew, ynew)

        # Estimate the error
        e   <-  h * (-5*s1 + 6*s2 + 8*s3 - 9*s4) / 72
        err <- max(abs(e / max(max(abs(y), abs(ynew)), threshold))) + realmin

        # Accept the solution if the estimated error is less than the tolerance
        if (err <= rtol) {
            t <- tnew
            y <- ynew
            tout <- c(tout, t)
            yout <- rbind(yout, t(y))
            s1 <- s4     # Reuse final function value to start new step.
        }

        # Compute a new step size
        h <- h * min(5, 0.8 * (rtol/err)^(1/3))

        # Exit early if step size is too small
        if (abs(h) <= hmin) {
            warning("Step size too small.")
            t <- tfinal
        }
    } # end while

    # Return results
    return(list(t = c(tout), y = yout))
}

##
##  e x p i n t . R  Exponential Integral
##


expint <- function(x) {
    stopifnot(is.numeric(x) || is.complex(x))
    eps <- .Machine$double.eps

    x <- c(x)
    n <- length(x)
    y <- numeric(n)

    p <- c(-3.602693626336023e-09, -4.819538452140960e-07, -2.569498322115933e-05,
           -6.973790859534190e-04, -1.019573529845792e-02, -7.811863559248197e-02,
           -3.012432892762715e-01, -7.773807325735529e-01,  8.267661952366478e+00)
    polyv <- polyval(p, Re(x))

    # series expansion
    k <- which(abs(Im(x)) <= polyv)
    if (length(k) != 0) {
       # initialization
       egamma <- 0.57721566490153286061
       xk <- x[k]
       yk <- -egamma - log(xk +0i)
       j <- 1
       pterm <- xk
       term  <- xk

       while (any(abs(term) > eps)) {
          yk <- yk + term
          j  <- j + 1
          pterm <- -xk * pterm / j
          term  <- pterm / j
       }
       y[k] <- yk
    }

    # continued fraction
    k <- which( abs(Im(x)) > polyv )
    if (length(k) != 0) {
        m <- 1  # we're calculating E1(x)

        # initialization
        xk <- x[k]
        nk <- length(xk)
        am2 <- numeric(nk)
        bm2 <- rep(1, nk)
        am1 <- rep(1, nk)
        bm1 <- xk;
        f <- am1 / bm1
        oldf <- rep(Inf, nk)
        j <- 2

        while (any(abs(f - oldf) > (100 * eps) * abs(f))) {
            alpha <- m - 1 + (j/2)

            # calculate the recursion coefficients
            a <- am1 + alpha * am2
            b <- bm1 + alpha * bm2

            # save new normalized variables for next pass
            am2 <- am1 / b
            bm2 <- bm1 / b
            am1 <- a / b
            bm1 <- 1
            f <- am1
            j <- j + 1

            # calculate the coefficients for j odd
            alpha <- (j-1)/2
            beta <- xk
            a <- beta * am1 + alpha * am2
            b <- beta * bm1 + alpha * bm2
            am2 <- am1 / b
            bm2 <- bm1 / b
            am1 <- a / b
            bm1 <- 1
            oldf <- f
            f <- am1
            j <- j+1
        }
        y[k] <- exp(-xk) * f - 1i * pi * ((Re(xk) < 0) & (Im(xk) == 0))
    }

    if (all(Im(y) == 0)) y <- Re(y)
    return(y)  
}

expint_E1 <- expint           # E1()


expint_Ei <- function(x) {    # Ei()
    stopifnot(is.numeric(x) || is.complex(x))
    # y <- -expint(-x) + sign(Im(x)) * pi * 1i
    y <- ifelse(sign(Im(x)) <= 0, -expint(-x) - pi*1i, -expint(-x) + pi*1i)
    if (all(Im(y) == 0)) y <- Re(y)
    return(y)
}

li <- function(x) {
    stopifnot(is.numeric(x) || is.complex(x))
    y <- expint_Ei(log(x + 0i))
    if (all(Im(y) == 0)) y <- Re(y)
    return(y)
}

##
##  e z p l o t . R
##


fplot <- function(f, interval, ...) {
    stopifnot(is.numeric(interval), length(interval) == 2)
    a <- interval[1]; b <- interval[2]
    ezplot(f, a, b, main = "", ...)
}

ezplot <- function(f, a, b, n = 101, col = "blue", add = FALSE,
                   lty = 1, lwd = 1, marker = 0, pch = 1,
                   grid = TRUE, gridcol = "gray", 
                   fill = FALSE, fillcol = "lightgray",
                   xlab = "x", ylab = "f (x)", main = "Function Plot", ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x)
    stopifnot(is.numeric(a), is.numeric(b),
              length(a) == 1, length(b) == 1, a < b)

    x <- seq(a, b, length.out = n)
    y <- f(x)

    if (!add)
        plot(x, y, type = "n",
        xlab = xlab, ylab = ylab, main = main, ...)

    if (grid)
        grid(col = gridcol)

    if (fill) {
        xx <- c(x, rev(x))
        yy <- c(rep(0, length(x)), rev(y))
        polygon(xx, yy, col = fillcol, border = "darkgray")
    }

    lines(x, y, col = col, lty = lty, lwd = lwd)

    if (marker > 0) {
        m <- min(max(marker, 3), n %/% 3)
        d  <- c(0, sqrt(diff(x)^2 + diff(y)^2))
        cs <- cumsum(d)
        s  <- cs[n]  # sum(d)
        l  <- s / (m-1)

        inds <- numeric(m)
        inds[c(1, m)] <- c(1, n)
        for (k in 2:(m-1))
            inds[k] <- which.min(abs(cs - (k-1)*l))
        points(x[inds], y[inds], col = col, pch = pch)
    } 

    invisible(NULL)
}


ezcontour <- function(f, xlim = c(-pi,pi), ylim = c(-pi,pi), 
                         n = 60, filled = FALSE, col = NULL) {
    fun <- match.fun(f)
    f <- function(x) fun(x)
    stopifnot(is.numeric(xlim), is.numeric(ylim),
              length(xlim) == 2, length(ylim) == 2,
              xlim[1] < xlim[2], ylim[1] < ylim[2])

    xx <- linspace(xlim[1], xlim[2], n)
    yy <- linspace(ylim[1], ylim[2], n)
    F <- matrix(NA, n, n)
    for (i in 1:n) {
        for (j in 1:n) {
            F[i, j] <- f(c(xx[i], yy[j]))
        }
    }
    if (filled) {
        if (is.null(col)) col <- heat.colors(12)
        image(xx, yy, F, col = col)
        contour(xx, yy, F, add = TRUE)
    } else {
        if (is.null(col)) col <- "black"
        contour(xx, yy, F)
        grid()
    }
    invisible(NULL) 
}


ezsurf <- function (f, xlim = c(-pi, pi), ylim = c(-pi, pi),
                    n = 60, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x)
    stopifnot(is.numeric(xlim), is.numeric(ylim), length(xlim) == 2,
              length(ylim) == 2, xlim[1] < xlim[2], ylim[1] < ylim[2])
    
    x <- linspace(xlim[1], xlim[2], n)
    y <- linspace(ylim[1], ylim[2], n)
    # z <- outer(xx, yy, f)
    z <- matrix(NA, n, n)
    for (i in 1:n) {
        for (j in 1:n) {
            z[i, j] <- f(c(x[i], y[j]))
        }
    }
    
    # interpolating colors in the range of specified colors
    nbcol <- 100
    # jet.colors <- colorRampPalette( c("blue", "yellow") )
    # colors <- jet.colors(nbcol)
    colors <- topo.colors(nbcol)
    
    # Compute the z-value at the facet centres
    zfacet <- z[-1, -1] + z[-1, -n] + z[-n, -1] + z[-n, -n]
    facetcol <- cut(zfacet, nbcol)
    
    persp(x, y, z, col = colors[facetcol], border = "grey50", ...)
    invisible(NULL)
}


ezmesh <- function(f, xlim = c(-pi,pi), ylim = c(-pi,pi), 
                   n = 60, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x)
    stopifnot(is.numeric(xlim), is.numeric(ylim),
              length(xlim) == 2, length(ylim) == 2,
              xlim[1] < xlim[2], ylim[1] < ylim[2])
    
    x <- linspace(xlim[1], xlim[2], n)
    y <- linspace(ylim[1], ylim[2], n)
    z <- matrix(NA, n, n)
    for (i in 1:n) {
        for (j in 1:n) {
            z[i, j] <- f(c(x[i], y[j]))
        }
    }
    persp(x, y, z, col = "yellow", border = "grey50", ...)
    invisible(NULL)
}


ezpolar <- function(fun, interv = c(0, 2*pi)) {
    stopifnot(is.numeric(interv))
    if (length(interv) != 2 || interv[1] >= interv[2])
        stop("Argument 'interv' must have two elements [a, b] with a < b.")

    n <- 91
    x <- seq(interv[1], interv[2], length.out = n)
    y <- fun(x)
    if (length(y) != n) {
        warning("Function 'fun' not vectorized: will do that for you.")
        y <- numeric(n)
        for (i in 1:n) y[i] <- fun(x[i])
    }

    polar(x, y)
    invisible(NULL)
}

##
##  p a d e . R  Pade Approximation
##


pade <- function(p1, p2 = c(1), d1 = 5, d2 = 5) {
	stopifnot(is.numeric(p1), is.numeric(p2),
	    is.numeric(d1), length(d1) == 1, floor(d1) == ceiling(d1), d1 >= 0,
	    is.numeric(d2), length(d2) == 1, floor(d2) == ceiling(d2), d2 >= 0)

	if (d1 == 0 && d2 == 0)
	    return(list(r1 = p1[length(p1)], r2 = p2[length(p2)]))

	z   <- rep(0, d1 + d2 + 3)
	p2 <- rev(c(z, p2))[1:(d1+d2+3)]
	p1 <- rev(c(z, p1))[1:(d1+d2+3)]

	L <- Toeplitz(p2[1:(d1+d2)]); L[upper.tri(L)] <- 0
	R <- Toeplitz(p1[1:(d1+d2)]); R[upper.tri(R)] <- 0

    # generate the linear system of coefficient equations
    D1 <- if (d1 > 0) 1:d1 else c()
    D2 <- if (d2 > 0) 1:d2 else c()
	A <- cbind(L[, D1], -R[, D2])
	b <- p2[1]*p1[2:(d1+d2+1)] - p1[1]*p2[2:(d1+d2+1)]

	# imitate pinv() if some eigenvalues are zero
	P <- svd(A); U <- P$u; V <- P$v; s <- P$d
	r <- sum(s > max(dim(A)) * max(s) * .Machine$double.eps)
	if (r == 0) {
	    pinvA <- matrix(0, nrow = nrow(A), ncol = ncol(A))
	} else {
	    S <- diag(1/s[1:r])
	    pinvA <- V[, 1:r] %*% S %*% t(U[, 1:r])
    }

	# solve the linear system of coefficient equations
	B <- zapsmall(pinvA %*% b)

	# reconstruct the rational function
	r1 <- rev(c(p1[1], B[1:d1]))
	r2 <- rev(c(p2[1], B[(d1+1):length(B)]))

	# scale such that max(r2) = 1
	rmax <- max(abs(r2))
	if (rmax == 0) rmax <- 1
	r1 <- r1 / rmax
	r2 <- r2 / rmax

	# return numerator and denominator
	return(list(r1 = r1, r2 = r2))
}

##
##  s i n e d . R  Trigonometric Functions with degrees
##


sind <- function(x)  sinpi( x / 180 )
cosd <- function(x)  cospi( x / 180 )
tand <- function(x)  sinpi(x/180) / cospi(x/180)
cotd <- function(x)  1 / tand(x)

asind <- function(x)  asin(x) * 180 / pi
acosd <- function(x)  acos(x) * 180 / pi
atand <- function(x)  atan(x) * 180 / pi
acotd <- function(x)  atand(1 / x)

atan2d <- function(x1, x2)  atan2(x1, x2) * 180 / pi

secd  <- function(x)  1 / cosd(x)
cscd  <- function(x)  1 / sind(x)
asecd <- function(x)  asec(x) * 180 / pi
acscd <- function(x)  acsc(x) * 180 / pi

##
##  k r o n . R  Kronecker product
##


kron <- function(a, b) {	
	if (length(a) == 0 || length(b) == 0) return(c())
	if (!(is.numeric(a) || is.complex(a)) ||
		!(is.numeric(b) || is.complex(b)))
		stop("Arguments 'a' and 'b' must be real/complex vectors/matrices.")
	
	kronecker(a, b)
}

##
##  p p . R  Piecewise Polynomial Structures
##


mkpp <- function(x, P) {
    stopifnot(is.numeric(x), is.numeric(P))
    if (!is.vector(x) || is.unsorted(x))
        stop("Argument 'x' must be a sorted, finite numeric vector.")

    lx <- length(x)
    n <- nrow(P); m <- ncol(P)
    if (lx != n+1) stop("Length of 'x' must be equal to 'nrow(P)+1'.")
    
    pp <- list(breaks = x, coefs = P, pieces = n, order = m, dim = 1)
    class(pp) <- "pp"
    return(pp)
}


ppval <- function(pp, xx) {
    stopifnot(is.numeric(xx), any(!is.na(xx)))
    if (!inherits(pp, "pp"))
        stop("Argument 'pp' must be piecewise polynomial structure.")
    
    lx <- length(xx); yy <- rep(NA, lx)
    xb <- pp$breaks;  lb <- length(xb)

    inds <- findInterval(xx, xb)
    inds[inds == 0] <- 1
    inds[inds == lb] <- lb - 1
    for (i in 1:(lb-1)) {
        js <- which(inds == i)
        yy[js] <- polyval(pp$coefs[i, ], xx[js] - xb[i])
    }
    return(yy)
}

##
##  m a t l a b . R  Matlab Idioms
##


matlab <- function() {
    cat(paste("",
  "The following functions are emulations of corresponding Matlab functions",
  "and bear the same signature as their Matlab cousins as far as possible:",
  "
  accumarray, acosd, acot, acotd, acoth, acsc, acscd, acsch, and, angle, ans,
      arrayfun, asec, asecd, asech, asind, atand, atan2d,
  beep, bernoulli, blank, blkdiag, bsxfun,
  cart2pol, cart2sph, cd, ceil, circshift, clear, compan, cond, conv,
      cosd, cot, cotd, coth, cross, csc, cscd, csch, cumtrapz,
  dblquad, deblank, deconv, deg2rad, detrend, deval, disp, dot,
  eig, eigint, ellipj, ellipke, eps, erf, erfc, erfcinv, erfcx, erfi, erfinv,
      errorbar, expint, expm, eye, ezcontour, ezmesh, ezplot, ezpolar, ezsurf,
  fact, fftshift, figure, findpeaks, findstr, flipdim, fliplr, flipud,
      fminbnd, fminsearch, fplot, fprintf, fsolve, fzero,
  gammainc, gcd, geomean, gmres, gradient,
  hadamard, hankel, harmmean, hilb, histc, humps, hypot,
  idivide, ifft, ifftshift, inpolygon, integral, integral2, integral3,
      interp1, interp2, inv, isempty, isprime,
  kron,
  legendre, linprog, linspace, loglog, logm, logseq, logspace, lsqcurvefit,
      lsqlin, lsqnonlin, lsqnonneg, lu,
  magic, meshgrid, mkpp, mldivide, mod, mrdivide,
  nchoosek, ndims, nextpow2, nnz, normest, nthroot, null, num2str, numel,
  ode23, ode23s, ones, or, orth,
  pascal, pchip, pdist, pdist2, peaks, perms, piecewise, pinv, plotyy,
      pol2cart,polar, polyfit, polyint, polylog, polyval, pow2, ppval,
      primes, psi, pwd,
  quad, quad2d, quadgk, quadl, quadprog, quadv, quiver,
  rad2deg, randi, randn, randsample, rat, rats, regexp, regexpi, regexpreg,
      rem, repmat, roots, rosser, rot90, rref, runge,
  sec, secd, sech, semilogx, semilogy, sinc, sind, size, sortrows, sph2cart,
      sqrtm, squareform, std, str2num, strcat, strcmp, strcmpi,
	  strfind, strfindi, strjust, subspace,
  tand, tic, toc, trapz, tril, trimmean, triplequad, triu,
  vander, vectorfield, ver,
  what, who, whos, wilkinson,
  zeros, zeta.",
  "", 
  "The following Matlab function names have been capitalized in 'pracma' to",
  "avoid shadowing functions from R base or one of its recommended packages:",
  "
  Diag, factors, finds, Fix, Imag, Lcm, Mode, Norm, nullspace (null),
  Poly, Rank, Real, Reshape, strRep, strTrim, Toeplitz, Trace, uniq (unique).", 
  "",
  "To use 'ans' instead of 'ans()' (i.e., as is common practice in Matlab)",
  "type (and similar for other Matlab commands):",
  "
  makeActiveBinding('ans', function() .Last.value, .GlobalEnv)
  makeActiveBinding('who', who, .GlobalEnv)",
  "",
  "etc. after loading the 'pracma' package.",
  "\n",
    sep = "\n", collapse = ""))
  
    invisible(NULL)
}

##
##  v e c t o r f i e l d . R
##


vectorfield <- function(fun, xlim, ylim, n = 16,
                        scale = 0.05, col = "green", ...) {
    stopifnot(is.numeric(xlim), length(xlim) == 2,
              is.numeric(ylim), length(ylim) == 2)

	xpts <- linspace(xlim[1], xlim[2], n)
	ypts <- linspace(ylim[1], ylim[2], n)

	M <- meshgrid(xpts, ypts)
	x <- M$X
	y <- M$Y

	px = matrix(1, nrow=n , ncol=n)
	py = fun(x, y);

	plot(xlim, ylim, type="n"); grid()
	quiver(x, y, px, py, scale = scale, col = col, ...)
}


quiver <- function(x, y, u, v,
                    scale = 0.05, angle = 10, length = 0.1, ...) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(u), is.numeric(v))
    

	arrows(x, y, x+scale*u, y+scale*v, angle=10, length=length, ...)
}

##
##  h a m p e l . R  MAD Outlier in Time Series
##


hampel <- function (x, k, t0 = 3)
{
    #   x:  vector or time series
    #   k:  window [x_(i-k),...,x_i,...,x_(i+k)]
    n   <- length(x)
    y   <- x         # corrected x vector
    ind <- c()       # indices of outliers

    L  <- 1.4826     # constants for normal distributions
    # t0 <- 3        # Pearson's 3 sigma edit rule

    # we don't look at outliers at the end parts of x !
    for ( i in (k+1):(n-k) ) {
        x0 <- median( x[(i-k):(i+k)] )
        S0 <- L * median( abs(x[(i-k):(i+k)] - x0) )
        if ( abs(x[i]-x0) > t0 * S0 ) {
            y[i] <- x0
            ind  <- c(ind, i)
        }
    }
    # return a list with 2 components
    list(y=y, ind=ind)
}

##
##  e n t r o p y . R  (Fast) Approximate Entropy
##


approx_entropy <- function(ts, edim = 2, r = 0.2*sd(ts), elag = 1) {

    N <- length(ts)
    result <- numeric(2)

    for (j in 1:2) {
        m <- edim + j - 1
        phi <- zeros(1, N-m+1)
        dataMat <- zeros(m, N-m+1)
        for (i in 1:m)
            dataMat[i, ] <- ts[i:(N-m+i)]

        for (i in 1:(N-m+1)) {
            tempMat <- abs(dataMat - repmat(dataMat[, i, drop = FALSE], 1, N-m+1))
            boolMat <- apply(tempMat > r, 2, max)
            phi[i]  <- sum(!boolMat)/(N-m+1)
        }
        result[j] <- sum(log(phi))/(N-m+1)
    }

    apen <- result[1] - result[2]
    return(apen)
}


sample_entropy <- function(ts, edim = 2, r = 0.2*sd(ts), tau = 1) {
    stopifnot(is.numeric(ts), is.numeric(edim))

    if (tau > 1) {
        s <- seq(1, length(ts), by = tau)
        ts <- ts[s]
    }

    N <- length(ts)
    correl  <- numeric(2)
    datamat <- zeros(edim + 1, N - edim)
    for (i in 1:(edim+1))
        datamat[i, ] <- ts[i:(N - edim + i - 1)]

    for (m in edim:(edim+1)) {
        count <- zeros(1, N-edim)
        tempmat <- datamat[1:m, ]

        for (i in 1:(N-m-1)) {
            # calculate Chebyshev distance
            X <- abs(tempmat[, (i+1):(N-edim)] - 
                            repmat(tempmat[, i, drop=FALSE], 1, N-edim-i))
            dst <- apply(X, 2, max)

            # calculate Heaviside function
            d <- (dst < r)

            count[i] <- sum(d) / (N - edim)
        }

        correl[m - edim + 1] <- sum(count) / (N - edim)
    }

   return(log(correl[1]/correl[2]))
}

##
##  a i t k e n . R  Aitken's acceleration method
##


aitken <- function(f, x0, nmax = 12, tol = 1e-8, ...) {
    if (!is.numeric(x0) || length(x0) != 1)
        stop("Argument 'x0' must be a numeric scalar.")
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    x <- x0
    diff <- 1 + tol
    niter <- 0
    while (diff > tol && niter <= nmax) {
        gx <- f(x)
        ggx <- f(gx)
        xnew <- (x*ggx - gx^2) / (ggx - 2*gx + x)
        diff <- abs(x - xnew)
        x <- xnew
        niter <- niter + 1
    }
    if (niter > nmax)
        warning("Maximum number of iterations exceeded.")
    return(x)
}

##
##  f d e r i v . R  Numerical Differentiation
##

fderiv <- function(f, x, n = 1, h = 0,
                   method = c("central", "forward", "backward"), ...) {
    if (length(x) == 0) return(c())
    if (!is.numeric(x))
        stop("Argument 'x' must be a number or a numeric vector.")
    n <- floor(n)
    if (n < 0)
        stop("The order of the derivative, 'n', can only be between 0 and 8.")
    if (n > 8)
        warning("Numerical derivatives of order 'n > 8' will be very inexact.")

    method <- match.arg(method)

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    fx <- f(x)
    if (length(fx) != length(x))
        stop("Function 'f' must first be vectorized: Vectorize(f).")

    if (n == 0) return(f(x))

    if (h == 0) {
        h <- .Machine$double.eps^(1/(n+2))
    }

    if (method == "central") {
        if (n == 1) {
            .df <- (f(x+h) - f(x-h)) / (2*h)
        } else if (n == 2) {
            .df <- (f(x+h) - 2*f(x) + f(x-h)) / h^2
        } else if (n == 3) {
            .df <- (f(x+2*h) - 2*f(x+h) + 2*f(x-h) - f(x-2*h)) / (2*h^3)
        } else if (n == 4) {
            .df <- (f(x+2*h) - 4*f(x+h) + 6*f(x) - 4*f(x-h) + f(x-2*h)) / h^4
        } else {
            .df <- sum((-1)^(0:n) * choose(n, 0:n) * f(((n/2):(-n/2))*h))/h^n
        }

    } else if (method == "forward") {
        if (n == 1) {
            .df <- (-f(x+2*h) + 4*f(x+h) - 3*f(x)) / (2*h)
        } else if (n == 2) {
            .df <- (-f(x+3*h) + 4*f(x+2*h) - 5*f(x+h) + 2*f(x)) / h^2
        } else if (n == 3) {
            .df <- (-3*f(x+4*h) + 14*f(x+3*h) - 24*f(x+2*h) + 18*f(x+h) - 5*f(x)) / (2*h^3)
        } else if (n == 4) {
            .df <- (-2*f(x+5*h) + 11*f(x+4*h) - 24*f(x+3*h) + 26*f(x+2*h) - 14*f(x+h) + 3*f(x)) / h^4
        } else {
            .df <- sum((-1)^(0:n) * choose(n, 0:n) * f((n:0)*h))/h^n
        }

    } else if (method == "backward") {
        if (n == 1) {
            .df <- (3*f(x) - 4*f(x-h) + f(x-2*h)) / (2*h)
        } else if (n == 2) {
            .df <- (2*f(x) - 5*f(x-h) + 4*f(x-2*h) - f(x-3*h)) / h^2
        } else if (n == 3) {
            .df <- (5*f(x) - 18*f(x-h) + 24*f(x-2*h) - 14*f(x-3*h) + 3*f(x-4*h)) / (2*h^3)
        } else if (n == 4) {
            .df <- (3*f(x) - 14*f(x-h) + 26*f(x-2*h) - 24*f(x-3*h) + 11*f(x-4*h) - 2*f(x-5*h)) / h^4
        } else {
            .df <- sum((-1)^(0:n) * choose(n, 0:n) * f((0:-n)*h))/h^n
        }
        
    } else
        stop("Unknown 'method'; use 'central', 'forward' or 'backward' instead.")

    return(.df)
}

##
##  h a n k e l . R
##


hankel <- function(a, b) {
    if (!is.vector(a))
        stop("Argument 'a' must be a numeric or complex vector.")
    n <- length(a)
	if (missing(b)) b <- c(a[n], rep(0, n-1))
    if (!is.vector(b))
        stop("Argument 'b' must be a numeric or complex vector.")
    m <- length(b)
	
	if (a[n] != b[1])
	    warning("a[n] not equal to b[1], b[1] set to a[n].")

	H <- matrix(0, n, m)
	for (i in 2:(n+m))
		H[row(H)+col(H) == i] <- if (i <= n+1) a[i-1] else b[i-n]
	return(H)
}

##
##  m o d u l a r . R  Modular functions
##

ceil <- function(n) ceiling(n)


Fix <- function(n) trunc(n)


mod <- function(n, m) {
    stopifnot(is.numeric(n), is.numeric(m))
    if (length(m) != 1 || floor(m) != ceiling(m))
        stop("Argument 'm' must be an integer scalar.")
    if (m == 0) return(n)
    else        return(n %% m)
}


rem <- function(n, m) {
    stopifnot(is.numeric(n), is.numeric(m))
    if (length(m) != 1 || floor(m) != ceiling(m))
        stop("Argument 'm' must be an integer scalar.")
    if (m == 0) return(NaN)
    k <- mod(n, m)
    l <- which(k != 0 & sign(n)*sign(m) < 0)
    k[l] <- k[l] - m
    return(k)
}


idivide <- function(n, m, rounding = c("fix", "floor", "ceil", "round")) {
    stopifnot(is.numeric(n), is.numeric(m))
    rounding <- match.arg(rounding)
    if (length(n) == 1) {
        n <- rep(n, length(m))
    } else if (length(m) == 1) {
        m <- rep(m, length(n))
    }
    ln <- length(n); lm <- length(m)
    if (ln != lm)
        stop("Arguments 'n', 'm' must be scalars or have the same length.")
    if (any(floor(n) != ceiling(n)) || any(floor(m) != ceiling(m)))
        stop("Arguments 'n', 'm' must be integers or vectors of integers.")

    k <- n / m
    if      (rounding == "fix")   k <- Fix(k)
    else if (rounding == "floor") k <- floor(k)
    else if (rounding == "ceil")  k <- ceil(k)
    else if (rounding == "round") k <- round(k)
    else
        stop("Rounding must be one of 'fix', 'floor', 'ceil', 'round'.")
    return(k)
}


gcd <- function(a, b, extended = FALSE) {
    stopifnot(is.numeric(a), is.numeric(b))
    if (length(a) == 1) {
        a <- rep(a, times=length(b))
    } else if (length(b) == 1) {
        b <- rep(b, times=length(a))
    }
    n <- length(a)

    e <- d <- g <- numeric(n)
    for (k in 1:n) {
        u <- c(1, 0, abs(a[k]))
        v <- c(0, 1, abs(b[k]))
        while (v[3] != 0) {
            q <- floor(u[3]/v[3])
            t <- u - v*q
            u <- v
            v <- t
        }
        e[k] <- u[1] * sign(a[k])
        d[k] <- u[2] * sign(a[k])
        g[k] <- u[3]
    }

    if (extended) {
        return(list(g = g, c = e, d = d))
    } else {
        return(g)
    }
}


Lcm <- function(a, b) {
    stopifnot(is.numeric(a), is.numeric(b))
    if (length(a) == 1) {
        a <- rep(a, times=length(b))
    } else if (length(b) == 1) {
        b <- rep(b, times=length(a))
    }

    g <- gcd(a, b, extended = FALSE)
    return( a / g * b )
}

##
##  q p s p e c i a l . R
##


qpspecial <- function(G, x, maxit = 100) {
    stopifnot(is.numeric(G), is.matrix(G))

    m <- nrow(G); n <- ncol(G)
    if (m*n <= 0) {
        warning("qpspecial: Matrix 'G' is empty; nothing can be done.")
        return(list(x = c(), d = c(), q = Inf, niter = 0, info = 2))
    }
    maxit <- max(floor(maxit), 5)

    e <- matrix(1, n, 1)
    if (missing(x)) {
        x <- e
    } else {
        x <- as.matrix(c(x))
        nx <- length(x)
        if (any(x < 0) || nx != n)
            x <- e
    }

    idx <- seq(1, (n*n), by = n+1)
    Q <- t(G) %*% G
    z <- x
    y <- 0
    eta <- 0.9995
    delta <- 3
    mu0 <- sum(x*z)/n
  
    tolmu <- 1e-5
    tolrs <- 1e-5
    kmu <- tolmu * mu0
  
    nQ <- norm(Q, "I") + 2
    krs <- tolrs * nQ

    ap <- 0; ad <- 0

    for (k in 1:maxit) {

        r1 <- -Q %*% x + e*y + z
        r2 <- -1 + sum(x)
        r3 <- -x * z
        rs <- norm(rbind(r1, r2), "I")
        mu <- -sum(r3)/n
    
        if (mu < kmu) {
            if (rs < krs) {
                niter <- k-1; info <- 0
                break
            }
        }

        zdx <- z / x
        QD <- Q
        QD[idx] <- QD[idx] + zdx
        C <- chol(QD)
        KT <- solve(t(C), e)
        M <- sum(KT * KT)

        r4 <- r1 + r3/x
        r5 <- sum(KT * solve(t(C), r4))
        r6 <- r2 + r5
        dy <- -r6/M
        r7 <- r4 + e*dy
        dx <- solve(C, solve(t(C), r7))
        dz <- (r3 - z*dx)/x

        p <- -x / dx
        p0 <- p[p > 0]
        if (length(p0) > 0) { ap <- min(p0, 1)
        } else              { ap <- 1 }
        p <- -z / dz
        p0 <- p[p > 0]
        if (length(p0) > 0) { ad <- min(p0, 1)
        } else              { ad <- 1 }

        mauff <- sum((x + ap*dx) * (z + ad*dz)) / n
        sig <- (mauff/mu)^delta
    
        r3 <- r3 + sig*mu
        r3 <- r3 - dx*dz
        r4 <- r1 + r3/x
        r5 <- sum(KT * solve(t(C), r4))
        r6 <- r2 + r5
        dy <- -r6/M
        r7 <- r4 + e*dy
        dx <- solve(C, solve(t(C), r7))
        dz <- (r3 - z*dx)/x

        p <- -x / dx
        p0 <- p[p > 0]
        if (length(p0) > 0) { ap <- min(p0, 1)
        } else              { ap <- 1 }
        p <- -z/dz
        p0 <- p[p > 0]
        if (length(p0) > 0) { ad <- min(p0, 1)
        } else              { ad <- 1 }

        x <- x + eta * ap * dx
        y <- y + eta * ad * dy
        z <- z + eta * ad * dz
    }

    if (k == maxit) info <- 1
    x <- pmax(x,0)
    x <- x/sum(x)
    d <- G %*% x
    q <- sum(d * d)
    list(x = x, d = d, q = q, niter = k, info = info)
}


qpsolve <- function(d, A, b, meq = 0, tol = 1e-07){
    sol <- dvec <- d
    bvec <- b
    imeq <- seq_len(meq)
    
    Nmat <- NULL
    wvec <- NULL
    active <- NULL
    niter <- 0
    repeat{
        niter <- niter + 1
        viol <-  crossprod(A, sol) - bvec
        viol1 <- viol / pmax(1,abs(bvec))
        iim <- viol1[imeq] >= tol
        if( any(iim) ){
            iim <- which(iim)
            viol[iim] <- -viol[iim]
            bvec[iim] <- -bvec[iim]
            A[,iim] <- -A[,iim]
        }
        ii <- which.min(viol1)[1]
        if( viol1[ii] > -tol) break
        if(ii %in% active) stop("Error in projection")
        wvec <- c(wvec, 0)
        active <- c(active, ii)
        npvec <- A[,ii]
        if( !is.null(Nmat) ){
            rvec <- solve(qr(Nmat, LAPACK=TRUE), npvec)
            dvec <- npvec - c(Nmat %*% rvec)
        }else{
            dvec <- npvec
            rvec <- NULL
        }
        jj <- rvec > 0
        jj[1] <- FALSE
        tmp <- wvec[jj]/rvec[jj]
        t1 <- suppressWarnings(min(tmp))
        t2 <- -viol[ii]/crossprod(npvec, dvec)
        t <- min(c(t1, t2))
        if( !is.finite(t) || t < 0 || t1 <= t2 ) stop("Error in projection")
        sol <- sol + t * dvec
        wvec <- wvec - t * c(rvec, -1)
        Nmat <- cbind(Nmat, npvec)
    }
    sol <- c(sol)
    val <- 0.5 * sum(sol * sol) - sum(d * sol)
    return(list(sol = sol, val = val, niter = niter))
}

##
##  c h e b y s h e v . R
##


chebPoly <- function(n, x = NULL) {
    stopifnot(is.numeric(n), length(n) == 1,
              floor(n) == ceiling(n), n >= 0)

	N <- max(2, n+1)
    T <- matrix(0, N, N)

	# Preset degree 0 and 1
	T[1, 1] <- 1
	T[2, 2] <- 1

	# Use recursion formula
	if (n >= 2)
	    for (i in 3:N)
		    T[i, ] <- 2 * c(0, T[i-1, 1:(N-1)]) - T[i-2, ]

    # Reverse with highest coefficient first
    T <- T[ ,ncol(T):1]

    if  (is.null(x)) {
        return(T)
    } else if (is.numeric(x)) {
        return(polyval(T[n+1, ], x))
    } else
        stop("Argument 'x' must be a numeric vector.")
}


chebCoeff <- function(fun, a, b, n) {
    N <- n+1
    # Map interval [a, b] to [-1, 1]
    c1 <- 0.5*(b-a)
    c2 <- 0.5*(b+a)

    # Evaluate function at Chebyshev points (in [a, b])
    k  <- c(0:(N-1))
    y  <- cos(pi*(k+0.5)/N)
    fy <- fun(c1*y + c2)

    # Now compute the Chebyshev coefficients
    c0 <- 2.0 / N
    K  <- matrix(k+0.5, N, 1)
    cheb <- c0 * fy %*% cos(pi/N * K %*% k)

    # Remove too small coefficients and return
    eps <- 2 * .Machine$double.eps    # machine precision
    cheb <- ifelse(abs(cheb) < eps, 0, cheb)
    return(drop(cheb))
}


chebApprox <- function(x, fun, a, b, n) {
	# Compute the Chebyshev polynomials of fun in [a, b]
	cP <- chebPoly(n)
	cC <- chebCoeff(fun, a, b, n)
	p  <- drop(cC %*% cP)
	c0 <- cC[1]

	# Map x into [-1, 1] and evaluate the Chebyshev polynomial
	xx <- (2*x - (b+a))/(b-a)
	yy <- polyval(p, xx) - c0/2
	return(yy)
}

##
##  l a g u e r r e . R  Laguerre Method
##


laguerre <- function(p, x0, nmax = 25, tol = .Machine$double.eps^(1/2)) {
    if (!is.numeric(p) && !is.complex(p))
        stop("Argument 'p' must be a numeric or complex vector.")
    if ( (!is.numeric(x0) && !is.complex(x0)) || length(x0) != 1)
        stop("Argument 'x0' must be a real or complex number.")

    n <- length(p) - 1
    p1 <- polyder(p)
    p2 <- polyder(p1)

    y0 <- polyval(p, x0)
    if (abs(y0) < tol) return(x0)

    for (m in 1:nmax) {
        a <- polyval(p1, x0) / y0
        a2 <- a^2
        b <- a2 - polyval(p2, x0) / y0

        x <- x0 - n/(a + a/abs(a) * sqrt((n-1)*(n*b - a2)))
        if (is.na(x))
            stop("Start value 'x0' results in an indefinite direction.")
        y <- polyval(p, x)
        if (abs(y) < tol) break
        x0 <- x
        y0 <- y
    }
    if (m > nmax)
        warning("Root finding process might not have converged.")

    return(x)
}

##
##  d b l q u a d . R  Double Integration
##


dblquad <- function(f, xa, xb, ya, yb, dim = 2, ..., 
                    subdivs = 300, tol = .Machine$double.eps^0.5) {
    stopifnot(is.numeric(xa), length(xa) == 1, is.numeric(xb), length(xb) == 1,
              is.numeric(ya), length(ya) == 1, is.numeric(yb), length(yb) == 1)

    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)
    if (length(f(c(xa, xb), c(ya, yb))) != 2)
        stop("Function 'f' does not appear to be vectorized.")

    if (dim == 2) {
        fy <- function(x)
                integrate(function(y) f(x, y), ya, yb,
                          subdivisions = subdivs, rel.tol = tol)$value
        Fy <- Vectorize(fy)
        Q  <- integrate(Fy, xa, xb,
                        subdivisions = subdivs, rel.tol = tol)$value

    } else if (dim == 1) {
        fx <- function(y)
                integrate(function(x) f(x, y), xa, xb,
                          subdivisions = subdivs, rel.tol = tol)$value
        Fx <- Vectorize(fx)
        Q  <- integrate(Fx, ya, yb,
                        subdivisions = subdivs, rel.tol = 10*tol)$value

    } else
        stop("Argument 'dim' can only be 1 (x-) or 2 (y-variable first).")

    return(Q)
}


triplequad <- function(f, xa, xb, ya, yb, za, zb, 
                        subdivs = 300, tol = .Machine$double.eps^0.5, ...) {
    stopifnot(is.numeric(xa), length(xa) == 1, is.numeric(xb), length(xb) == 1,
              is.numeric(ya), length(ya) == 1, is.numeric(yb), length(yb) == 1,
              is.numeric(za), length(za) == 1, is.numeric(zb), length(zb) == 1)

    fun <- match.fun(f)
    f <- function(x, y, z) fun(x, y, z, ...)

    fyz <- function(y, z) {
        Qin <- numeric(length(y))
        for (i in 1:length(y)) {
            fx  <- function(x) f(x, y[i], z[i])
            Qin <- integrate(fx, xa, xb,
                             subdivisions = subdivs, rel.tol = 1e-10)$value
        }
        Qin
    }
    fyz <- Vectorize(fyz)
    dblquad(fyz, ya, yb, za, zb, tol = tol)
}


simpson2d <- function(f, xa, xb, ya, yb, nx = 128, ny = 128, ...) {
    stopifnot(is.numeric(xa), length(xa) == 1, is.numeric(xb), length(xb) == 1,
              is.numeric(ya), length(ya) == 1, is.numeric(yb), length(yb) == 1)

    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)

    if (nx %% 2 != 0) nx <- nx + 1
    if (ny %% 2 != 0) ny <- ny + 1

    # Grid and grid vectors
    hx <- (xb - xa) / nx
    hy <- (yb - ya) / ny
    xg <- seq(xa, xb, by = hx)
    yg <- seq(ya, yb, by = hy)

    # Interchange meshgrid
    mgrid <- meshgrid(yg, xg)
    X <- mgrid$Y
    Y <- mgrid$X

    F <- f(X, Y)

    # Contributions from the corner points
    s1 <- F[1, 1] + F[1, ny+1] + F[nx+1, 1] + F[nx+1, ny+1]

    # Contributions from other edge points
    ixo <- seq(2, nx, by = 2); ixe <- seq(3, nx-1, by = 2)
    iyo <- seq(2, ny, by = 2); iye <- seq(3, ny-1, by = 2)
    s2 <- 2 * ( sum(F[1, iye]) + sum(F[nx+1, iye]) + sum(F[ixe, 1]) + sum(F[ixe, ny+1]) );
    s3 <- 4 * ( sum(F[1, iyo]) + sum(F[nx+1, iyo]) + sum(F[ixo, 1]) + sum(F[ixo, ny+1]) );

    # Contributions from interior points
    s4 <- 16 * sum( sum( F[ixo,iyo] ) ) + 4 * sum( sum( F[ixe,iye] ) );
    s5 <-  8 * sum( sum( F[ixe,iyo] ) ) + 8 * sum( sum( F[ixo,iye] ) );

    S <- hx * hy * (s1 + s2 + s3 + s4 + s5) / 9.0
    return(S)
}

##
##  s i m p s o n . R  Simpson Integration
##


simpson <- function(f, a, b, n = 100, ...) {
    # Implementation of Simpson's 1/3 rule for numerical integration
    #
    # Args:
    #   f: The function to integrate (must be vectorized)
    #   a: Lower limit of integration
    #   b: Upper limit of integration
    #   n: Number of subintervals (must be even)
    #
    # Returns:
    #   The approximate integral of f from a to b
    
    if (n %% 2 != 0) {
        stop("n must be even for Simpson's rule")
    }
    
    h <- (b - a) / n
    x <- seq(a, b, length.out = n + 1)
    y <- f(x)
    
    # Simpson's rule weights: 1, 4, 2, 4, 2, ..., 4, 1
    weights <- rep(c(4, 2), times = n/2)
    weights <- c(1, weights)
    weights[length(weights)] <- 1
    
    integral <- (h / 3) * sum(weights * y)
    
    return(integral)
}


simpson2d <- function(f, xa, xb, ya, yb, nx = 128, ny = 128, ...) {
    stopifnot(is.numeric(xa), length(xa) == 1, is.numeric(xb), length(xb) == 1,
              is.numeric(ya), length(ya) == 1, is.numeric(yb), length(yb) == 1)
    
    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)
    
    if (nx %% 2 != 0) nx <- nx + 1
    if (ny %% 2 != 0) ny <- ny + 1
    
    # Grid and grid vectors
    hx <- (xb - xa) / nx
    hy <- (yb - ya) / ny
    xg <- seq(xa, xb, by = hx)
    yg <- seq(ya, yb, by = hy)
    
    # Interchange meshgrid
    mgrid <- meshgrid(yg, xg)
    X <- mgrid$Y
    Y <- mgrid$X
    
    F <- f(X, Y)
    
    # Contributions from the corner points
    s1 <- F[1, 1] + F[1, ny+1] + F[nx+1, 1] + F[nx+1, ny+1]
    
    # Contributions from other edge points
    ixo <- seq(2, nx, by = 2); ixe <- seq(3, nx-1, by = 2)
    iyo <- seq(2, ny, by = 2); iye <- seq(3, ny-1, by = 2)
    s2 <- 2 * ( sum(F[1, iye]) + sum(F[nx+1, iye]) + sum(F[ixe, 1]) + sum(F[ixe, ny+1]) );
    s3 <- 4 * ( sum(F[1, iyo]) + sum(F[nx+1, iyo]) + sum(F[ixo, 1]) + sum(F[ixo, ny+1]) );
    
    # Contributions from interior points
    s4 <- 16 * sum( sum( F[ixo,iyo] ) ) + 4 * sum( sum( F[ixe,iye] ) );
    s5 <-  8 * sum( sum( F[ixe,iyo] ) ) + 8 * sum( sum( F[ixo,iye] ) );
    
    S <- hx * hy * (s1 + s2 + s3 + s4 + s5) / 9.0
    return(S)
}

##
##  s o f t l i n e . R  Soft (Inexact) Line Search
##


softline <- function(x0, d0, f, g = NULL) {
    if (!is.numeric(x0) || !is.numeric(d0))
        stop("Arguments 'x0' and 'd0' must be numeric vectors.")
    if (length(x0) != length(d0))
        stop("Vectors 'x0' and 'd0' must have the same length.")

    f <- match.fun(f)
    if (!is.null(g)) {
        g <- match.fun(g)
    } else {
        g <- function(x) grad(f, x)
    }

    # STEP 1: Initialize search parameters
    tau <- 0.1;  chi <- 0.75
    rho <- 0.1;  sigma <- 0.1
    mhat <- 400; epsilon <- 1e-10

    xk <- c(x0)
    dk <- c(d0)

    m <- 0                              # no. of function calls
    f0 <- f(xk)
    gk <- g(xk); m <- m + 2
    deltaf0 <- f0

    # STEP 2: Initialize line search
    aL <- 0; aU <- 1e9                  # interval [a, b]
    fL <- f0

    dfL <- sum(gk * dk)                 # derivative at x0
    if (abs(dfL) > epsilon)   a0 <- -2*deltaf0 / dfL
    else                      a0 <- 1
    if (a0 <= 1e-9 || a0 > 1) a0 <- 1
    
    # STEP 3 and 4: Estimate a0 and compute f0
    repeat {
        deltak <- a0*dk
        f0 <- f(xk + deltak); m <- m + 1

        # STEP 5: Interpolation
        if (f0 > (fL + rho*(a0 - aL)*dfL) &&
            abs(fL - f0) > epsilon && m < mhat) {
            if (a0 < aU) aU <- a0

            # Compute a0hat by extrapolation
            a0hat <- aL + ((a0 - aL)^2 * dfL) / (2*(fL - f0 + (a0 - aL)*dfL))
            a0Lhat <- aL + tau * (aU - aL)
            if (a0hat < a0Lhat)
                a0hat <- a0Lhat
            a0Uhat <- aU - tau * (aU - aL)
            if (a0hat > a0Uhat)
                a0hat <- a0Uhat
            a0 <- a0hat

        # STEP 6: Compute df0
        } else {
            df0 <- sum(g(xk + a0*dk) * dk)
            m <- m + 1

            # STEP 7: Extrapolation
            if (df0 < sigma*dfL &&
                abs(fL - f0) > epsilon && m < mhat && dfL != df0) {
                deltaa0 <- (a0 - aL) * df0 / (dfL - df0)
                if (deltaa0 <= 0) a0hat <- 2*a0
                else              a0hat <- a0 + deltaa0

                a0Uhat <- a0 + chi * (aU - a0)
                if (a0hat > a0Uhat) a0hat <- a0Uhat

                # Pepare next iteration
                aL <- a0
                a0 <- a0hat
                fL <- f0
                dfL <- df0
            } else {
                break
            }
        }
    }
    z <- max(a0, 1e-5)
    return(z)
}

##
##  l e g e n d r e . R  Legendre Functions
##


legendre <- function(n, x) {
	stopifnot(is.numeric(x), is.numeric(n),
	          length(n) == 1, floor(n) == ceiling(n), n >= 0)
	x <- c(x)
	N <- length(x)

	if (n == 0) return(rep(1, N))

    # generate the Legendre polynomials up to degree n
    Lp <- matrix(0, n+1, n+1)
    Lp[1, n+1] <- Lp[2, n] <- 1
    if (n > 1) {
        for (i in 3:(n+1)) {
	        j <- i-1
	        Lp[i, (n-i+2):(n+1)] <- (2*j-1)/j * c(Lp[i-1, (n-i+3):(n+1)], 0) -
	                      (j-1)/j * Lp[i-2, (n-i+2):(n+1)]
        }
    }
    lp <- Lp[n+1, ]

    # associated Legendre functions up to order n
    L <- matrix(NA, n+1, N)
    L[1, ] <- polyval(lp, x)

    for (j in 1:n) {
	    lp <- polyder(lp)
	    L[j+1, ] <- (-1)^j * sqrt((1-x^2)^j) * polyval(lp, x)
    }

    return(L)
}

##
##  q u a d . R  Adaptive Simpson Quadrature
##


quad <- function(f, xa, xb, tol = .Machine$double.eps^0.5, trace = FALSE, ...)
{
    stopifnot(is.numeric(xa), length(xa) == 1, is.finite(xa),
              is.numeric(xb), length(xb) == 1, is.finite(xb))

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (xa == xb) return(xb-xa)
    else if (xa > xb) {
        tmp <- xa; xa <- xb; xb <- tmp
        rev_p <- TRUE
    } else
        rev_p <- FALSE

    eps <- .Machine$double.eps
    if (!is.finite(f(xa))) xa <- xa + 2*eps
    if (!is.finite(f(xb))) xb <- xb - 2*eps

    Q <- .adaptsim(f, xa, xb, tol, trace)
    if (rev_p) Q <- -1 * Q
    return(Q)
}


.adaptsim <- function(f, xa, xb, tol = tol, trace = trace)
{
    x <- c(xa, (xa+xb)/2, xb)
    y <- c(f(xa), f((xa+xb)/2), f(xb))

    fa <- y[1]; fm <- y[2]; fb <- y[3]
    yy <- f(xa + c(0.9501, 0.2311, 0.6068, 0.4860, 0.8913) * (xb-xa))

    ab <- (xb - xa)/8 * (sum(y)+sum(yy))
    if (ab == 0) ab <- xb-xa
    ab <- ab * tol/.Machine$double.eps

    Q <- .adaptsimstp(f, xa, xb, fa, fm, fb, ab, trace)
	return(Q)
}

.adaptsimstp <- function(f, xa, xb, fa, fm, fb, ab, trace)
{
    m <- (xa + xb)/2
    h <- (xb - xa)/4

    x <- c(xa + h, xb - h)
    y <- c(f(xa + h), f(xb - h))

    fml <- y[1]; fmr <- y[2]
    i1 <- h/1.5 * (fa + 4*fm + fb)
    i2 <- h/3 * (fa + 4*(fml + fmr) + 2*fm + fb)
    i1 <- (16*i2 - i1)/15

    if ( (ab + (i1-i2) == ab) || (m <= xa) || (xb<=m) ) {
        if ( ((m <= xa) || (xb<=m)))
            warning("Required tolerance may not be met.")

        Q <- i1
        if (trace) cat(xa, xb-xa, Q, "\n")

    } else {
        Q <- .adaptsimstp (f, xa, m, fa, fml, fm, ab, trace) +
             .adaptsimstp (f, m, xb, fm, fmr, fb, ab, trace)
    }
    return(Q)
}

##
##  r e c t i n t . R  Rectangular Intersections
##


rectint <- function(x, y) {
    stopifnot(is.numeric(x), is.numeric(y))
    if (is.vector(x) && length(x) == 4 &&
        is.vector(y) && length(y) == 4) {

        if (any(c(x[3], x[4], y[3], y[4]) < 0))
            stop("All widths and heights must be greater than 0.")

        if (x[1]+x[3] <= y[1] || y[1]+y[3] <= x[1] ||
            x[2]+x[4] <= y[2] || y[2]+y[4] <= x[2]) {
            return(0)

        } else {
            if (x[1] > y[1]) {
                tmp <- x; x <- y; y <- tmp
            }
            z1 <- y[1]
            z2 <- max(x[2], y[2])
            z3 <- min(x[1]+x[3], y[1]+y[3])
            z4 <- min(x[2]+x[4], y[2]+y[4])
            area <- (z3-z1) * (z4-z2)
            return(area)
        }

    } else if (is.matrix(x) && ncol(x) == 4 &&
               is.matrix(y) && ncol(y) == 4) {

        nx <- nrow(x); ny <- nrow(y)
        R <- matrix(NA, nrow = nx, ncol = ny)

        for (i in 1:nx) {
            for (j in 1:ny) {
                R[i, j] <- rectint(x[i, ], y[j, ])
            }
        }

        return(R)  
      
    } else {
        stop("All lengths and no. of matrix columns must be equal to 4.")
    }
}

##
##  b i s e c t . R
##


bisect <- function(fun, a, b, maxiter = 500, tol = NA, ...)
# Bisection search, trimmed for exactness, not number of iterations
{
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

    if (!is.na(tol)) warning("Deprecated: Argument 'tol' not used anymore.")
	if (f(a)*f(b) > 0) stop("f(a) and f(b) must have different signs.")
	x1 <- min(a, b); x2 <- max(a,b)
	xm <- (x1+x2)/2.0
	n <- 1
	while (x1 < xm && xm < x2 && n < maxiter) {
		n <- n+1
		if (sign(x1) != sign(x2) && x1 != 0 && x2 != 0) {
		    xm <- 0.0
		    if (f(xm) == 0.0) {x1 <- x2 <- xm; break}
		}
		if (sign(f(x1)) != sign(f(xm))) {
			x2 <- xm
		} else {
			x1 <- xm
		}
		xm <- (x1 + x2) / 2.0
	}
	return(list(root=xm, f.root=f(xm), iter=n, estim.prec=abs(x1-x2)))
}


secant <- function(fun, a, b, maxiter = 500, tol = 1e-08, ...)
# Secant search for zero of a univariate function
{
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)
    
    x1 <- a; x2 <- b
    f1 <- f(x1); if (abs(f1) <= tol) return(x1)
    f2 <- f(x2); if (abs(f2) <= tol) return(x1)
    n <- 0
    while (n <= maxiter && abs(x2 - x1) > tol) {
        n <- n+1
        slope <- (f2 - f1)/(x2 - x1)
        if (slope == 0) return(root=NA, f.root=NA, iter=n, estim.prec=NA)
        x3 <- x2 - f2/slope
        f3 <- f(x3); if (abs(f3) <= tol) break
        x1 <- x2; f1 <- f2
        x2 <- x3; f2 <- f3
    }
    if (n > maxiter) {
        warning("Maximum number of iterations 'maxiter' was reached.")
    }
    return(list(root=x3, f.root=f3, iter=n, estim.prec=2*abs(x3-x2)))
}


regulaFalsi <- function(fun, a, b, maxiter = 500, tol = 1e-08, ...)
#Regula Falsi search for zero of a univariate function in a bounded interval
{
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

	x1 <- a;      x2 <- b
	f1 <- f(x1);  f2 <- f(x2)
	if (f1*f2 > 0) stop("f(a) and f(b) must have different signs.")

	m <- 0.5                                         # Illinois rule
	niter <- 0
	while (abs(x2-x1) >= tol && niter <= maxiter) {
		niter <- niter + 1
		x3 <- (x1*f2-x2*f1)/(f2-f1); f3 <- f(x3)

		if(f3*f2 < 0) {
			x1 <- x2;  f1 <- f2
			x2 <- x3;  f2 <- f3
		} else {
			# m <- f2/(f2+f3)                         # Pegasus rule
			# m <- if (1-f3/f2 > 0) 1-f3/f2 else 0.5  # Andersen/Bjoerk
			f1 <- m * f1
			x2 <- x3;  f2 <- f3
		}
	}
	if (niter > maxiter && abs(x2-x1) >= tol)
		cat("regulaFalsi stopped without converging.\n")
	return(list(root = x3, f.root = f3, niter = niter, estim.prec = x1-x2))
}


# bisect <- function(f, a, b, maxiter=100, tol=.Machine$double.eps^0.5)
# # Bisection search for zero of a univariate function in a bounded interval
# {
#     if (f(a)*f(b) > 0) stop("f(a) and f(b) must have different signs.")
#     x1 <- min(a, b); x2 <- max(a,b)
#     xm <- (x1+x2)/2.0
#     n <- 0
#     while (abs(x1-x2)/2.0 > tol) {
#         n <- n+1
#         if (abs(f(xm)) <= tol) break
#         if (f(x1)*f(xm) < 0) {
#             x2 <- xm
#         } else {
#             x1 <- xm
#         }
#         xm <- (x1+x2)/2.0  # xm <- x1 - f(x1) * (x2-x1) / (f(x2)-f(x1))
#         if (n >= maxiter) break
#     }
#     return(list(root=xm, f.root=f(xm), iter=n, estim.prec=abs(x1-x2)/2.0))
# }

##
##  c o n d . R  Matrix Condition
##


cond <- function(M, p = 2) {
    if (length(M) == 0)
        return(0)
    if (!is.numeric(M))
        stop("Argument 'M' must be a numeric matrix.")
    if (is.vector(M))
        M <- matrix(c(M), nrow = length(M), ncol = 1)

    if (length(M) == 0) return(c())
    if (ncol(M) != nrow(M) && p != 2)
        stop("Matrix 'M' must be square if p = 2.")

    if (p == 2) {
        s <- svd(M)$d
        cnd <- if (any(s == 0)) Inf else max(s) / min(s)
    } else {
        stop("At the moment, p-norms other than p = 2 are not implemented.")
        #cnd <- norm(M, p) * norm(inv(M), p)
    }
    return(cnd)
}

##
##  n c h o o s e k . R  Binomial Coefficients
##


nchoosek <- function(n, k) {
    stopifnot(is.numeric(n), length(n) == 1, n >= 0, floor(n) == ceiling(n),
              is.numeric(k), length(k) == 1, k >= 0, floor(k) == ceiling(k))
    if (k > n)
        stop("Argument 'k' must be an integer between 0 and 'n'.")

    choose(n, k)
}

##
##  t r i q u a d . R  Gaussian Triangle Quadrature
##


triquad <- function(f, x, y, n = 10, tol = 1e-10, ...) {
    if (!is.numeric(x) || length(x) != 3 ||
        !is.numeric(y) || length(y) != 3)
        stop("Arguments 'x' and 'y' must be numeric vectors of length 3.")
    n <- floor(abs(n))
    if (n <= 2)
        stop("Argument 'n' must be an integer greater or equal 2.")

    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)

    v <- cbind(x, y)
    rel.tol <- Inf
    kmax <- 5
    k <- 1
    while (rel.tol > tol && k <= kmax) {
        G1 <- .tricoef(v, N = n)
        I1 <- t(G1$Wx) %*% f(G1$X, G1$Y) %*% G1$Wy
        G2 <- .tricoef(v, N = 2*n+1)
        I2 <- t(G2$Wx) %*% f(G2$X, G2$Y) %*% G2$Wy
        rel.tol <- abs(I1 - I2)
        k <- k + 1
    }
    return(c(I2))
}


.tricoef <- function(v, N = 32, ...) {
    eps <- .Machine$double.eps

    n <- 1:N
    nnk <- 2*n + 1
    A <- c(1/3, repmat(1,1,N) / (nnk * (nnk+2)))
    
    n <- 2:N
    nnk <- nnk[n]
    B1 <- 2/9
    nk <- n+1
    nnk2 <- nnk * nnk
    B <- 4*(n * nk)^2 / (nnk2 * nnk2 - nnk2)
    ab <- cbind(A, c(2, B1, B))
    s <- sqrt(ab[2:N, 2])

    VX <- eigen(Diag(ab[1:N,1], 0) + Diag(s, -1) + Diag(s, 1))
    X <- VX$values
    V <- VX$vectors
    I <- order(X)
    X <- X[I]
    x <- (X + 1) / 2
    wx <- ab[1,2] * as.matrix(V[1,I])^2 / 4

    N <- N-1; N1 <- N+1; N2 <- N+2
    y <- cos((2*as.matrix(N:0)+1)*pi/(2*N+2))

    L <- zeros(N1, N2)
    y0=2
    iter=0;
    while (max(abs(y-y0)) > eps) {
        L[, 1] <- 1
        L[, 2] <- y  
        for (k in 2:N1) {
            L[, k+1] <- ( (2*k-1) * y * L[, k] - (k-1) * L[,k-1] ) / k
        }
        Lp <- N2 * ( L[, N1] - y * L[,N2] ) / (1-y^2) 
        y0 <- y
        y <- y0 - L[, N2]/Lp
        iter <- iter+1
    }
    cc <- matrix(c(1,0,0, -1,0,1, 0,1,-1), 3, 3, byrow = TRUE) %*% v
    t1 <- (1+y)/2
    Wx <- abs(det(cc[2:3,])) * wx
    Wy <- 1/((1-y^2) * Lp^2) * (N2/N1)^2
    mg <- meshgrid(t1, x)
    t2 <- mg$X; xx <- mg$Y 
    yy <- t2 * xx
    X  <- cc[1,1] + cc[2,1]*xx + cc[3,1]*yy
    Y  <- cc[1,2] + cc[2,2]*xx + cc[3,2]*yy

    return(list(X = X, Y = Y, Wx = Wx, Wy = Wy))
}

##
##  z z z . R
##


# Define 'ans' as in Matlab
# But: "Package namespaces are locked when loaded!"
# makeActiveBinding("ans", function() .Last.value, .GlobalEnv)

.pracmaEnv <- new.env()
assign("elapsedTime", 0, envir = .pracmaEnv)

.onLoad <- function(libname, pkgname) {
    # require(some_packages)

    # Load dynamic libraries
    # library.dynam(pkg, pkg, lib)

    environment(.pracmaEnv) <- asNamespace("pracma")

    # packageStartupMessage(
    #     paste("pracma Package Version 1.4.6\n",
    #           "Practical Numerical Math Functions\n",
    #           "Copyright (c) 2011-2013 Hans W Borchers\n",
    #     sep='', collapse=''))
}

bits <- function(x, k = 54, pos_sign = FALSE, break0 = FALSE) {
    stopifnot(is.numeric(x), length(x) == 1)
    if (ceiling(k) != floor(k) || k <= 0)
        stop("Argument 'k' must be a (positive) integer.")
  
    if (x >= 0) {
        b <- if (pos_sign) "+" else ""
    } else {
        b <- "-"
        x <- -x
    }
      
    xn <- trunc(x)
    xf <- x - xn
      
    if (xn >= 1) {
        m2 <- nextpow2(xn)
        if (2^m2 > xn) m2 <- m2 - 1
        for (i in seq(m2, 0, by=-1)) {
            s <- 2^i
            if (xn >= s) {
                b <- paste(b, "1", sep="")
                xn <- xn - s
            } else
                b <- paste(b, "0", sep="")
        }
    } else {
          b <- paste(b, "0", sep="")
    }
      
    if (xf > 0) {
        b <- paste(b, ".", sep="")
        for (i in 1:k) {
            s <- 1/2^i
            if (xf >= s) {
                b <- paste(b, "1", sep="")
                xf <- xf - s
                if (break0 && xf == 0) break
            } else
                b <- paste(b, "0", sep="")
        }
    }
      
    return(b)
}

###
### NEXTPOW2.R  Next higher power of 2
###

nextpow2 <- function(x) {
    if (is.null(x) || length(x) == 0) return(c())
    if (!is.numeric(x) && !is.complex(x))
        stop("Argument 'x' must be a numeric/complex vector/matrix.")

    x[x == 0] <- 1
    return(ceiling(log2(abs(x))))
}

bernstein <- function(f, n, x) {
    stopifnot(is.function(f), is.numeric(n), is.numeric(x))
    if (floor(n) != ceiling(n) || n < 0)
        stop("Argument 'n' must be a nonnegative integer.")
    if (any(x < -1.0 || x > 1.0))
        stop("Elements of argument 'x' must all lie in [0, 1].")

    if (length(x) == 1) {
        b2 <- f((0:n)/n)
        for (j in 1:n) {
            b1 <- b2
            b2[1:(n-j+1)] <- b1[1:(n-j+1)] * (1-x) + b1[2:(n-j+2)] * x
        }
        b <- b2[1]
    } else {
        b <- 0
        for (k in 0:n) {
            b <- b + choose(n,k) * x^k * (1-x)^(n-k) * f(k/n)
        }
    }
    return(b)
}


bernsteinb<- function(k, n, x) {
    stopifnot(is.numeric(k), is.numeric(n), is.numeric(x))
    if (floor(n) != ceiling(n) || n < 0)
        stop("Argument 'n' must be a nonnegative integer.")
    if (floor(k) != ceiling(k) || k < 0 || k > n)
        stop("Argument 'k' must be an integer between 0 and 'n'.")
    if (any(x < -1.0 || x > 1.0))
        stop("Elements of argument 'x' must all lie in [0, 1].")

    choose(n,k) * x^k * (1-x)^(n-k)
}

###
### f a c t o r s . R  Factorize natural number
###


factors <- function(n) {
    if (!is.numeric(n) || length(n) != 1 || n != round(n) || n < 1)
        stop("Argument 'n' must be a nonnegative integer.")
    if (n >= 2^53)
        stop("Argument 'n' must not be larger than 2^53-1.")
    if (n < 4) return(n)

    f <- c()
    p <- primes(sqrt(n))
    d <- which(n %% p == 0)
    if (length(d) == 0) return(n)  # n is prime

    for (q in p[d]) {
        while (n %% q == 0) {
            f <- c(f, q)
            n <- n/q
        }
    }
    if (n > 1) f <- c(f, n)
    return(f)
}

##
##  d e c o n v . R  Deconvolution
##


deconv <- function(b, a) {
    if (length(b) == 0)
        return(list(q = 0, r = c()))
    if ( (!is.numeric(b) && ! is.complex(b)) ||
         (!is.numeric(a) && ! is.complex(a)) )
        stop("Arguments 'b' and 'a' must be numeric or complex.")

    if ( a[1] == 0)
        stop("First element of argument 'a' must be nonzero.")

    nb <- length(b)
    na <- length(a)
    if (nb < na)
        return(list(q = 0, r = b))

    q <- c()
    while (nb >= na) {
        d <- b[1] / a[1]
        b <- b - conv(a, c(d, rep(0, nb-na)))
        q <- c(q, d)
        b <- b[2:nb]
        nb <- nb -1
    }
    return(list(q = q, r = b))
}

##
##  h e s s i a n . R  Hessian Matrix
##


hessian <- function(f, x0, h = .Machine$double.eps^(1/4), ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    n <- length(x0)
    if (length(f(x0)) != 1)
        stop("Function 'f' must be a univariate function of n variables.")

    if (n == 1)
        return(matrix(fderiv(f, x0, n = 2, h = h), nrow = 1, ncol = 1))

    H <- matrix(NA, nrow = n, ncol = n)
    hh <- diag(h, n)
    for (i in 1:(n-1)) {
        hi <- hh[, i]
        H[i, i] <- (f(x0-hi) - 2*f(x0) + f(x0+hi)) / h^2
        for (j in (i+1):n) {
            hj <- hh[, j]
            H[i, j] <- (f(x0+hi+hj) - f(x0+hi-hj) - f(x0-hi+hj) + f(x0-hi-hj)) / (4*h^2)
            H[j, i] <- H[i, j]
        }
    }
    hi <- hh[, n]
    H[n, n] <- (f(x0-hi) - 2*f(x0) + f(x0+hi)) / h^2

    return(H)
}


hessvec <- function (f, x, v, csd = FALSE, ...) {
    if (!is.numeric(x) || !is.numeric(v)) 
        stop("Arguments 'x' and 'v' must be a numeric.")
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    if (length(x) < 2 || length(f(x)) != 1) 
        stop("Function 'f' must be univariate of 2 or more variables.")
    if (length(v) != length(x))
        stop("Vectors 'x' and 'v' must be of equal length.")
    
    h <- .Machine$double.eps^(1/4)
    r <- h / sqrt(sum(v*v))
    if (csd) {
        hv <- (grad_csd(f, x+r*v) - grad_csd(f, x-r*v))/(2*r)
    } else {
        hv <- (grad(f, x+r*v) - grad(f, x-r*v))/(2*r)
    }
    return(hv)
}


hessdiag <- function(f, x, ...) {
    if (!is.numeric(x)) 
        stop("Arguments 'x' and 'v' must be a numeric.")
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    if (length(x) < 2 || length(f(x)) != 1) 
        stop("Function 'f' must be univariate of 2 or more variables.")
    
    n <- length(x)
    h <- .Machine$double.eps^(1/4)
    hh <- rep(0, n)
    HD <- numeric(n)
    for (i in 1:n) {
        hh[i] <- h
        HD[i] <- (f(x + hh) - 2*f(x) + f(x - hh)) / h^2
        hh[i] <- 0
    }
    return(HD)
}


laplacian <- function(f, x0, h = .Machine$double.eps^(1/4), ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

	n  <- length(x0)
	hh <- rep(0, n)
	L  <- 0
	for (i in 1:n) {
		hh[i] <- h
		L <- L + (f(x0+hh) + f(x0-hh) - 2*f(x0)) / h^2
		hh[i] <- 0
	}

    return(L)
}

##
##  t r i s o l v e . R  Tridiagonal Linear System Solver
##


trisolve <- function(a, b, d, rhs) {
    stopifnot(is.numeric(a), is.numeric(b), is.numeric(d), is.numeric(rhs))

    n <- length(a)
    if (n < 3)
        stop("Argument 'n' must be greater or equal 3.")
    if (length(b) != n-1 || length(d) != n-1)
        stop("Vectors 'b' and 'd' must be of a length of length(a)-1.")
    if (length(rhs) != n)
        stop("Vector 'rhs' must be of the same length as 'a'.")
    else
        x <- rhs

    b <- c(b, 0)
    for (i in 1:(n-1)) {
        if (d[i] != 0) {
            t <- a[i]/d[i]
            si <- 1/sqrt(1+t*t)
            co <- t*si
            a[i] <- a[i]*co + d[i]*si

            h <- b[i]
            b[i] <- h*co + a[i+1]*si
            a[i+1] <- -h*si + a[i+1]*co
            d[i] <- b[i+1]*si
            b[i+1] <- b[i+1]*co

            h <- x[i]
            x[i] <- h*co + x[i+1]*si
            x[i+1] <- -h*si + x[i+1]*co
        }
    }

    if (any(a == 0.0))
        stop("Triangular matrix is singular -- system not solvable.")

    x[n]   <- x[n]/a[n]
    x[n-1] <- ( x[n-1] - b[n-1]*x[n] ) / a[n-1]
    for (i in (n-2):1) {
        x[i] <- ( x[i] - b[i]*x[i+1] - d[i]*x[i+2] ) / a[i]
    }
    return(x)
}

##
##  f i b s e a r c h . R  Fibonacci Search
##


fibsearch <- function(f, a, b, ...,
					  endp = FALSE, tol = .Machine$double.eps^(1/2))
# Fibonacci search for a univariate function minimum in a bounded interval
{
	if (a >= b) stop("Left endpoint a must be smaller than b.")
	tol <- max(tol, .Machine$double.eps)

	# Compute Fibonacci numbers [F0,] F1, F2, ..., Fm
	F <- c(1, 2); n <- 2
	while (F[n] <= 2*(b-a)/tol) { F[n+1] <- F[n] + F[n-1]; n <- n + 1 }

	# Initialize values (k == 0)
	x1 <- a; x2 <- b
	xa <- a + (b-a) * F[n-2]/F[n]; fxa <- f(xa, ...)
	xb <- a + (b-a) * F[n-1]/F[n]; fxb <- f(xb, ...)

	# Compute iteration
	k <- 1
	while (k <= n-3 && xa < xb && (x2 - x1) >= tol) {
		if (fxa > fxb) {
			x1 <- xa; xa <- xb
			xb <- x1 + (x2-x1) * F[n-k-1]/F[n-k]
			fxa <- fxb; fxb <- f(xb, ...)
		} else {
			x2 <- xb; xb <- xa
			xa <- x1 + (x2-x1) * F[n-k-2]/F[n-k]
			fxb <- fxa; fxa <- f(xa, ...)
		}
		k <- k + 1
	}

	# Finally use the mean and consider endpoints
	xmin <- (xa+xb)/2; fmin <- f(xmin, ...)
	if (endp) {
		fa <- f(a, ...); fb <- f(b, ...)
		if (xmin-a < tol && fa < fmin) {
			xmin <- a; fmin <- fa
		} else {
			if (b - xmin < tol && fb < fmin) {
				xmin <- b; fmin <- fb
			}
		}
	}
	estim.prec <- max(xmin-x1, x2-xmin)
	return(list(xmin=xmin, fmin=fmin, niter=k, estim.prec=estim.prec))
}

##
##  r a n d . R  Generate Random Matrices
##


rand <- function(n = 1, m = n) {
    stopifnot(is.numeric(n), length(n) <= 2, is.numeric(m))
    if (length(n) == 2)
        return(rand(n[1], n[2]))

    if (length(m) != 1) m <- m[1]
    n <- floor(n)
    m <- floor(m)

    if (n <= 0 || m <= 0) matrix(NA, 0, 0)
    else                  matrix(runif(n*m), nrow=n, ncol=m)
}

randn <- function(n = 1, m = n) {
    stopifnot(is.numeric(n), length(n) <= 2, is.numeric(m))
    if (length(n) == 2)
        return(randn(n[1], n[2]))

    if (length(m) != 1) m <- m[1]
    n <- floor(n)
    m <- floor(m)

    if (n <= 0 || m <= 0) matrix(NA, 0, 0)
    else                  matrix(rnorm(n*m), nrow=n, ncol=m)
}


randi <- function(imax, n = 1, m = n) {
    stopifnot(is.numeric(n), length(n) == 1,
              is.numeric(m), length(m) == 1)
    if (length(imax) == 1) {
        imin <- 1
    } else if (length(imax) == 2) {
        imin <- imax[1]
        imax <- imax[2]
    } else {
        stop("Argument 'imax' must be a scalar or have two elements.")
    }
    if (imin > imax)
        stop("Argument 'imax' must be greater than or equal to 'imin'.")
    n <- floor(n)
    m <- floor(m)

    if (n <= 0 || m <= 0) matrix(NA, 0, 0)
    else matrix(sample(imin:imax, n*m, replace=TRUE), nrow=n, ncol=m)
}


rands <- function (n = 1, N = 1, r = 1) 
{
    if (n < 1 || N < 1 || r < 0) return(c())
    X <- randn(n, N+1)
    Y <- sqrt(rowSums(X^2))
    return(r * X/Y)
}


randp <- function(n = 1, r = 1) {
    if (n < 1 || r < 0) return(c())
    x <- rnorm(n); y <- rnorm(n)
    r <- r * sqrt(runif(n)/(x^2 + y^2))
    return(cbind(r*x, r*y))
}


randsample <- function(n, k, w = NULL, replacement = FALSE) {
	stopifnot(is.numeric(n), is.numeric(k))
	if (length(n) == 1) n <- 1:floor(n)
	else                n <- c(n)
	if (k > length(n) && !replacement) {
		warning("k > n or length(n): replacement will be set to TRUE.")
		replacement = TRUE
	}
	if (is.numeric(w)) {
		if (!replacement) replacement = TRUE
		if (length(n) != length(w))
			stop("Weights vector 'w' must have the same length as 'n'.")
	}

	sample(n, k, replace = replacement, prob = w)
}

##
##  f i n d i n t e r v a l s . R  Find Interval Indices
##


findintervals <- function(x, xs) {
    if (length(x) == 0 || length(xs) == 0) return(c())
    if (!is.vector(x, mode="numeric") || !is.vector(x, mode="numeric"))
        stop("Arguments 'x' and 'xs' must be numeric vectors.")
    if (length(x) != 1)
        stop("Length of vector 'x' must be 1.")

    n <- length(xs)
    xsx <- xs - x

	i0 <- which(xsx == 0)
	i1 <- which(xsx[1:(n-1)] * xsx[2:n] < 0)
	
	return(sort(c(i0, i1)))
}

##
##  s i g m o i d . R  Sigmoid Function
##


sigmoid <- function(x, a = 1, b = 0) {
    if (length(x) == 0) return(c())
    stopifnot(is.numeric(x), is.numeric(a), is.numeric(b))
    a <- a[1]; b <- b[1]

    1 / (1 + exp(-a*(x-b)))
}


logit <- function (x, a = 1, b = 0) {
    if (length(x) == 0) 
        return(c())
    stopifnot(is.numeric(x), is.numeric(a), is.numeric(b))
    a <- a[1]; b <- b[1]
    if (any(x < 0) | any(x > 1))
        warning("NaNs produced with x < 0 or x > 1.", call. = TRUE)
    inds <- which(x < 0.0 | x > 1.0)
    x[inds] <- 0.5
    y <- b + log(x/(1 - x))/a
    y[inds] <- NaN

    return(y)
}

##
##  m o l e r . R
##


moler <- function(n) {
	if (length(n) != 1 || n != round(n))
		stop("Argument 'n' must be an integer.")
	if (n <= 0) return(c())

	A <- matrix(0, nrow = n, ncol = n)
	for (i in 1:n) {
		A[i, 1:i] <- (1:i) - 2
	}
	A <- A + t(A)
	diag(A) <- 1:n
	A
}

###
### TICTOC.R - Stopwatch timer
###


##-----------------------------------------------------------------------------
tic <- function(gcFirst = FALSE) {
    if (gcFirst == TRUE) {
        gc(verbose = FALSE)
    }
    assign("elapsedTime", proc.time()[3], envir = .pracmaEnv)
    invisible()
}


##-----------------------------------------------------------------------------
toc <- function(echo = TRUE) {
    prevTime <- get("elapsedTime", envir = .pracmaEnv)
    diffTimeSecs <- proc.time()[3] - prevTime
    if (echo) {
        cat(sprintf("elapsed time is %f seconds", diffTimeSecs), "\n")
        return(invisible(diffTimeSecs))
    } else {
        return(diffTimeSecs)
    }
}

##
##  a g m e a n . R  Arithmetic-geometric Mean
##


agmean <- function(a, b) {
    eps <- .Machine$double.eps
    stopifnot(is.numeric(a) || is.complex(a),
              is.numeric(b) || is.complex(b))
    if (is.numeric(a) && any(a < 0) || is.numeric(b) && any(b < 0)) {
        a <- as.complex(a)
        b <- as.complex(b)
    }

    if (length(a) == 1) {
        n <- length(b)
        a <- rep(a, n)
    } else if (length(b) == 1) {
        n <- length(a)
        b <- rep(b, n)
    } else 
        if (length(a) != length(b)) 
            stop("Arguments must have the same length or one has length 1.")

    niter = 0
    while ( any(abs(a-b) >= eps) ) {
        niter = niter + 1
        a1 <- (a + b) / 2
        b1 <- sqrt(a * b)
        if (max(abs(a-a1)) < eps && max(abs(b-b1)) < eps) break
        a <- a1
        b <- b1
    }

    return( list(agm = (a+b)/2, niter = niter, prec = max(abs(b-a))) )
}

##
##  a n d r e w s . R  Andrews Curves
##


andrewsplot <- function(A, f, style = "pol", scaled = FALSE, npts = 101) {
    stopifnot(is.numeric(A), is.matrix(A))
    if (is.factor(f)) f <- as.integer(f)
    if (!is.integer(f))
        stop("Argument 'f' must be a factor or an integer vector.")

    n <- nrow(A); m <- ncol(A)
    if (m < 2 || n < 2)
        stop("Matrix 'A' must have at least two rows and columns.")

    if (scaled) A <- scaled(A)

    xpts <- seq(0, 2*pi, length = npts)
    Y <- matrix(NA, nrow = n, ncol = npts)

    # Compute the Andrews function
    for (i in 1:n) {
        xs <- A[i, ]
        ypts <- c()
        for (p in xpts) {
            y <- xs[1]
            for (j in 2:m) {
                if (j %% 2 == 1) { y <- y + xs[j]*sin((j %/% 2)*p) }
                else             { y <- y + xs[j]*cos((j %/% 2)*p) }
            }
            ypts <- c(ypts, y)
        }
        Y[i, ] <- ypts
    }

    if (style == "cart") {
        # plot in cartesian coordinates
        ymin <- min(Y)
        ymax <- max(Y)
        plot(0, 0, type="n", xlim=c(0, 2*pi), ylim=c(ymin, ymax),
             main="Andrews' Curves", xlab="", ylab="")
        for (i in sample(1:n, n)) {
            lines(xpts, Y[i, ], col = f[i])
        }

    } else if (style == "pol") {
        ymax <- max(abs(Y))
        polar(0, ymax, type="n", main = "Andrews' Curves", bxcol = "white")
        for (i in sample(1:n, n)) {
            polar(xpts, Y[i, ], col=f[i], add=TRUE)
        }

    } else
        stop("Argument 'style' can only be 'cart' or 'pol'.")

    invisible()
}

##
##  f m i n s e a r c h . R
##


fminsearch <- function(fn, x0, ..., lower = NULL, upper = NULL, 
                       method = c("Nelder-Mead", "Hooke-Jeeves"),
                       minimize = TRUE, maxiter = 1000, tol = 1e-08) {

    n <- length(x0)
    if (!is.numeric(x0) || n == 0) {
        stop("Argument 'x0' must be a numeric vector.")
	} else if (n == 1) {
		stop("Don't use 'fminsearch' for one-dimensional minimization.")
	}

    method <- match.arg(method)

    scl <- if(minimize) 1 else -1
    fun <- match.fun(fn)
    fn <- function(x) scl * fun(x, ...)

    if ((!is.null(lower) || !is.null(upper)) && method == "Nelder-Mead") {
        stop("'Nelder-Mead' cannot handle bounds constraints;\n",
                "Instead, use 'Hooke-Jeeves' with bounds/box constraints.")
    }

    if (method == "Nelder-Mead") {
        # Call Nelder-Mead w/o bounds constraints
        opt <- nelder_mead(fn, x0, tol = tol, maxfeval = 5*maxiter)

    } else if (method == "Hooke-Jeeves") {
        if (is.null(lower) && !is.null(upper)) lower <- rep(-Inf, n)
        if (!is.null(lower) && is.null(upper)) upper <- rep( Inf, n)

        # Call Hooke-Jeeves w/o or w/ bounds constraints
        opt <- hooke_jeeves(x0, fn, lb = lower, ub = upper,
                            tol = tol, maxfeval = 10*maxiter)
    } else {
        warning("Unknown Method: use 'Nelder-Mead' or 'Hooke-Jeeves'!")
    }

    xopt <- opt$xmin; fopt <- opt$fmin
    if (! minimize) fopt <- -fopt
    return(list(xmin = xopt, fmin = fopt, count = opt$count,
                convergence = 0, info = opt$info))
}

##
##  p o i s s o n 2 d i s k . R
##


poisson2disk <- function(n, a = 1, b = 1, m = 10, info = TRUE) {
    if (a <= 0 || b <= 0)
        stop("Width a and height b must be positive reals.")
    if (floor(n) != ceiling(n) || n < 1 ||
        floor(m) != ceiling(m) || m < 1)
        stop("n and m must be integer numbers.")

    ab <- rep(c(a, b), times = c(m, m))
    A <- matrix(0, n, 2)
    A[1, ] <- c(a, b) * runif(2)

    i <- 2
    while (i <= n) {
        B <- matrix( ab * runif(2*m), nrow = m, ncol = 2)
        C <- distmat(B, A[1:(i-1), ])
        k <- which.max(apply(C, 1, min))
        A[i, ] <- B[k, ]
        i <- i + 1
    }
    if (info) {
        AA <- distmat(A, A)
        diag(AA) <- max(AA)
        d <- sqrt(2*a*b / n)
        cat("Minimal Distance between points: ", min(AA), '\n')
    }
    return(A)
}

circshift <- function(a, sz) {
    if (is.null(a)) return(a)
    
    if (is.vector(a) && length(sz) == 1) {
        n <- length(a)
        s <- sz %% n
        a <- a[(1:n-s-1) %% n + 1]

    } else if (is.matrix(a) && length(sz) == 2) {
        n <- nrow(a); m <- ncol(a)
        s1 <- sz[1] %% n
        s2 <- sz[2] %% m
        a <- a[(1:n-s1-1) %% n + 1, (1:m-s2-1) %% m + 1]
    } else
        stop("Length of 'sz' must be equal to the no. of dimensions of 'a'.")

    return(a)
}

hessenberg <- function(A) {
    stopifnot(is.numeric(A), is.matrix(A))
    m <- nrow(A); n <- ncol(A)
    if (m != n)
        stop("Input 'A' must be a square matrix.")
    if (n <= 2) {
        return(list(H = A, P = eye(n)))
    }

    # initialize variables
    H <- A
    V <- vector(mode = "list", length = n-2)

    # Householder transformation
    for (k in 1:(n-2)) {
        v <- H[(k+1):n, k]
        sgn <- sign(v[1])
        if (sgn == 0) sgn <- 1
        v[1] <- v[1] + sgn * Norm(v)
        if (Norm(v) != 0) v <- v / Norm(v)

        H[(k+1):n,k:n] <- H[(k+1):n, k:n] -
                          2 * v %*% (t(v) %*% H[(k+1):n,k:n])
        H[ ,(k+1):n] <- H[ , (k+1):n] -
                        (2 * (H[ , (k+1):n] %*% v)) %*% t(v)
        V[[k]] <- v
    }

    Q <- eye(n)
    for (j in (n-2):1) {
        Q[(j+1):n, ] <- Q[(j+1):n, ] -
                       (2 * V[[j]]) %*% (t(V[[j]]) %*% Q[(j+1):n, ])
    }

    return(list(H = H, P = Q))
}

##
##  r m s e r r o r . R  RMS Error
##


rmserr <- function(x, y, summary = FALSE) {
    if (!is.numeric(x) || !is.numeric(y))
        stop("Arguments 'x' and 'y' must be numeric vectors.")
    if (length(x) != length(y))
        stop("Vectors 'x' and ' y' must have the same length.")

    n <- length(x);

    mae    <- sum(abs(y - x))/n
    mae_f  <- formatC(mae, digits=4, format="f")
    mse    <- sum((y - x)^2)/n
    mse_f  <- formatC(mse, digits=4, format="f")
    rmse   <- sqrt(sum((y - x)^2)/n)
    rmse_f <- formatC(rmse, digits=4, format="f")
    mape   <- sum( abs((y - x)/x) )/n
    mape_f <- formatC(mape, digits=4, format="f")
    nmse   <- sum((y - x)^2)/sum((x - mean(x))^2)
    nmse_f <- formatC(nmse, digits=4, format="f")
    rstd   <- sqrt(sum((y - x)^2)/n) / mean(x)
    rstd_f <- formatC(rstd, digits=4, format="f")

    if (summary) {
cat("-- Error Terms --------------------------------------------------\n");
cat(" MAE:  ", mae_f,  "  \t- mean absolute error (in range [", range(x), "])\n")
cat(" MSE:  ", mse_f,  "  \t- mean squared error (the variance?!)\n");
cat(" RMSE: ", rmse_f, "  \t- root mean squared error (std. dev.)\n");
cat(" MAPE: ", mape_f, "  \t- mean absolute percentage error\n");
cat(" LMSE: ", nmse_f, "  \t- normalized mean squared error\n");
cat(" rSTD: ", rstd_f, "  \t- relative standard deviation (", mean(x), ")\n");
cat("-----------------------------------------------------------------\n");
    }

    R <- list(mae  = mae,  mse  = mse,  rmse = rmse,
              mape = mape, nmse = nmse, rstd = rstd)

    if (summary) {
        invisible(R)
    } else {
        return(R)
    }
}

##
##  q u a d l . R  Adaptive Simpson Quadrature
##


quadl <- function(f, xa, xb, tol = .Machine$double.eps^0.5, trace = FALSE, ...)
{
    stopifnot(is.numeric(xa), length(xa) == 1, is.finite(xa),
              is.numeric(xb), length(xb) == 1, is.finite(xb))

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (xa == xb) return(xb-xa)
    else if (xa > xb) {
        tmp <- xa; xa <- xb; xb <- tmp
        rev_p <- TRUE
    } else
        rev_p <- FALSE

    eps <- .Machine$double.eps
    if (!is.finite(f(xa))) xa <- xa + 2*eps
    if (!is.finite(f(xb))) xb <- xb - 2*eps

    Q <- .adaptlob(f, xa, xb, tol, trace)
    if (rev_p) Q <- -1 * Q
    return(Q)
}


.adaptlob <- function(f, a, b, tol = tol, trace = trace)
{
    m <- (a+b)/2
    h <- (b-a)/2
    alpha <- sqrt(2/3)
    beta <- 1/sqrt(5)

    x1 <- 0.942882415695480
    x2 <- 0.641853342345781
    x3 <- 0.236383199662150
    x <- c(a, m-x1*h, m-alpha*h, m-x2*h, m-beta*h, m-x3*h,  m,
              m+x3*h, m+beta*h,  m+x2*h, m+alpha*h, m+x1*h, b)

    y <- f(x)
    fa <- y[1]
    fb <- y[13]
    i2 <- (h/6) * (y[1] + y[13] + 5*(y[5]+y[9]))
    i1 <- (h/1470) * (77*(y[1]+y[13]) + 432*(y[3]+y[11]) + 
                      625*(y[5]+y[9]) + 672*y[7])
    ab  <- h * (0.0158271919734802 * (y[1]+y[13]) +
                0.0942738402188500 * (y[2]+y[12]) +
                0.155071987336585  * (y[3]+y[11]) +
                0.188821573960182  * (y[4]+y[10]) +
                0.199773405226859  * (y[5]+y[9])  +
                0.224926465333340  * (y[6]+y[8])  +
                0.242611071901408  *  y[7])

    s <- sign(ab)
    if (s == 0) s <- 1
    erri1 <- abs(i1-ab)
    erri2 <- abs(i2-ab)
    R <- 1
    if (erri2 != 0) R <- erri1/erri2
    if (R > 0 && R < 1) tol <- tol/R
    ab <- s * abs(ab) * tol/.Machine$double.eps
    if (ab == 0) ab <- b-a

    Q <- .adaptlobstp(f, a, b, fa, fb, ab, trace)
}


.adaptlobstp <- function(f, a, b, fa, fb, ab, trace)
{
    h <- (b-a)/2
    m <- (a+b)/2
    alpha <- sqrt(2/3)
    beta <- 1/sqrt(5)
    mll <- m - alpha*h
    ml  <- m - beta*h
    mr  <- m + beta*h
    mrr <- m + alpha*h

    x <- c(mll, ml, m, mr, mrr)
    y <- f(x)

    fmll <- y[1]
    fml  <- y[2]
    fm   <- y[3]
    fmr  <- y[4]
    fmrr <- y[5]
    i2 <- (h/6) * (fa + fb + 5*(fml+fmr))
    i1 <- (h/1470) * (77*(fa+fb) + 432*(fmll+fmrr) + 625*(fml+fmr) + 672*fm)

    if ( ab+(i1-i2) == ab | mll <= a | b <= mrr ) {
        if ( (m <= a || b <= m) )
            warning("Required tolerance may not be met.")

        Q <- i1
        if (trace) cat(a, b-a, Q, "\n")

    } else {
        Q <- .adaptlobstp(f, a, mll, fa, fmll, ab, trace)   +
             .adaptlobstp(f, mll, ml, fmll, fml, ab, trace) +
             .adaptlobstp(f, ml, m, fml, fm, ab, trace)     +
             .adaptlobstp(f, m, mr, fm, fmr, ab, trace)     +
             .adaptlobstp(f, mr, mrr, fmr, fmrr, ab, trace) +
             .adaptlobstp(f, mrr, b, fmrr, fb, ab, trace)
    }
    return(Q)
}

##
##  s u b s p a ce . R  Matrix Image


orth <- function(M) {
    if (length(M) == 0)
        return(c())
    if (!is.numeric(M))
        stop("Argument 'M' must be a numeric matrix.")
    if (is.vector(M))
        M <- matrix(c(M), nrow = length(M), ncol = 1)

    svdM <- svd(M)
    U <- svdM$u
    s <- svdM$d
    tol <-  max(dim(M)) * max(s) * .Machine$double.eps

    r <- sum(s > tol)
    U[,1:r, drop = FALSE]
}

subspace <- function(A, B) {
    if (!is.numeric(A) || !is.numeric(B))
        stop("Arguments 'A' and 'B' must be numeric matrices.")
    if (is.vector(A))
        A <- matrix(c(A), nrow = length(A), ncol = 1)
    if (is.vector(B))
        B <- matrix(c(B), nrow = length(B), ncol = 1)
    if (nrow(A) != nrow(B))
        stop("Matrices 'A' and 'B' must have the same number of rows.")

    A <- orth(A)
    B <- orth(B)
    if (ncol(A) < ncol(B)) {
        tmp <- A; A <- B; B <- tmp
    }

    for (k in 1:ncol(A)) {
        B <- B - A[, k] %*% t(A[, k]) %*% B
    }

    asin(min(1, max(svd(B)$d)))
}

##
##  m u l l e r . R  Muller's Method
##


muller <- function(f, p0, p1, p2 = NULL, maxiter = 100, tol = 1e-10) {
    if (is.null(p2)) p2 <- (p0 + p1)/2
    stopifnot(is.numeric(p0) || is.complex(p0), length(p0) == 1,
              is.numeric(p1) || is.complex(p1), length(p1) == 1,
              is.numeric(p2) || is.complex(p2), length(p2) == 1)
    f <- match.fun(f)

    fp0 <- f(p0); fp1 <- f(p1); fp2 <- f(p2)
    if (!is.finite(fp0) || !is.finite(fp1) || !is.finite(fp2))
        stop("Function 'f' not finite at one of the initial points.")

    # Initialization
    h1 <- p1 - p0
    h2 <- p2 - p1
    d1 <- (fp1 - fp0) / h1
    d2 <- (fp2 - fp1) / h2
    d  <- (d2 - d1) / (h2 + h1)

    # main loop
    i  <- 3
    while (i <= maxiter) {
        b <- d2 + h2*d
        D <- sqrt(b^2 - 4*f(p2)*d + 0i)

        if (abs(b - D) < abs(b + D)) {
        	E <- b + D
        } else {
            E <- b - D
        }

        h <- -2*f(p2) / E
        p <- p2 + h
        fp <- f(p)

        if (abs(h) < tol) break

        # prepare for next iteration
        p0 <- p1
        p1 <- p2
        p2 <- p
        h1 <- p1 - p0
        h2 <- p2 - p1
        d1 <- (f(p1) - f(p0)) / h1
        d2 <- (f(p2) - f(p1)) / h2
        d  <- (d2 - d1) / (h2 + h1)
        i  <- i + 1
    }

    if (i > maxiter)
        warning("Root not found to the desired tolerance.")

    if (abs(Im(p)) <= 0.1*tol ) {
        p <- Re(p); fp <- f(p)
    }

    return(list(root = p, fval = fp, niter = i, reltol = abs(h)))
}

##
##  a k i m a . R  Univariate Akima Interpolation
##


akimaInterp <- function(x, y, xi) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(xi),
               is.vector(x),  is.vector(y),  is.vector(xi))

    n <- length(x)
    if (length(y) != n)
        stop("Vectors 'x' and 'y' must be of the same length.")
    dx <- diff(x)
    if (any(dx <= 0))
        stop("Argument 'x' must be an in strictly ascending order.")
    if (any(xi < x[1]) || any(xi > x[n]))
        stop("All points in 'xi' must lie between x[1] and x[n].")

    m <- diff(y) / dx
    mm <- 2*m[1]-m[2];     mmm <- 2*mm-m[1]     # augment at left
    mp <- 2*m[n-1]-m[n-2]; mpp <- 2*mp-m[n-1]   # augment at right
    m1 <- c(mmm, mm, m, mp, mpp)                # slopes

    dm <- abs(diff(m1))
    f1 <- dm[3:(n+2)]; f2 <- dm[1:n]; f12 <- f1 + f2
    id <- which(f12 > 1e-8 * max(f12))
    b <- m1[2:n+1]
    b[id] <- (f1[id] * m1[id+1] + f2[id] * m1[id+2]) / f12[id]
    e <- (3*m - 2*b[1:n-1] - b[2:n]) / dx
    d <- (b[1:n-1] + b[2:n] - 2*m) / dx^2

    bin <- findInterval(xi,x)
    bin <- pmin(bin,n-1)
    bb <- bin[1:length(xi)]
    wj <- xi - x[bb]
    yi <- ((wj * d[bb] + e[bb]) * wj + b[bb]) * wj + y[bb]

    return(yi)
}

##
##  s t r f i n d . R  Find Substrings
##


strfind <- function(s1, s2, overlap = TRUE) {
	stopifnot(is.character(s1), is.character(s2))
	if (length(s2) != 1)
		stop("Pattern 's2' must be a character vector of length 1.")

	L <- list()
	for (i in 1:length(s1)) {
		si <- s1[i]
		if (nchar(si) < nchar(s2)) {
			L[[i]] <- c()
		} else {
			L[[i]] <- findstr(s2, si, overlap=overlap)
		}
	}
	if (length(s1) == 1) L <- unlist(L)
	return(L)
}

strfindi <- function(s1, s2, overlap = TRUE) {
    stopifnot(is.character(s1), is.character(s2))

    strfind(tolower(s1), tolower(s2), overlap=overlap)
}

findstr <- function(s1, s2, overlap = TRUE) {
	stopifnot(is.character(s1), is.character(s2))
	if (length(s1) != 1 || length(s2) != 1)
		stop("Arguments must be character vectors of length 1.")
	if (nchar(s1) > nchar(s2)) {
		s <- s1; s1 <- s2; s2 <- s
	}
	if (s1 == '') return(c())

	n1 <- nchar(s1)
	n2 <- nchar(s2)
	r  <- c()
	i  <- 1
	while (i <= n2 - n1 + 1) {
		if (s1 == substring(s2, i, i  + n1 - 1)) {
			r <- c(r, i)
			if (!overlap) i <- i + n1 - 1
		}
		i <- i + 1
	}
	return(r)
}

##
##  e i g j a c o b i . R  Jacobi Eigenvalue Method
##


eigjacobi <- function(A, tol = .Machine$double.eps^(2/3)) {
    stopifnot(is.numeric(A))
    n <- nrow(A)
    if (ncol(A) != n || any(t(A) != A))
        stop("Matrix 'A' must be a square and real symmetric matrix.")

    D <- A
    V <- eye(n)

    # calculate greatest off-diagonal element
    ind <- which.max(abs(D - diag(diag(D))))
    pq <- arrayInd(ind, dim(D))
    p <- pq[1]; q <- pq[2]
    
    while (TRUE) {
        # Zero out D[p, q] and D[q, p]
        t <- D[p,q] / (D[q,q] - D[p,p])
        d <- 1/sqrt(t^2 + 1)
        s <- d * t
        R <- matrix(c(d, -s, s, d), 2, 2)
        
        D[c(p, q), ] <- t(R) %*% D[c(p, q), ]
        D[, c(p, q)] <- D[, c(p, q)] %*% R
        V[, c(p, q)] <- V[, c(p, q)] %*% R

        ind <- which.max(abs(D - diag(diag(D))))
        pq <- arrayInd(ind, dim(D))
        p <- pq[1]; q <- pq[2]
        if (abs(D[p,q]) < tol * sqrt(sum(diag(D)^2)/n))
            break
    }

    return(list(V = V, D = diag(D)))
}

###
### HILB.R  Hilbert matrix
###


hilb <- function(n) {
    if (!is.numeric(n))
        stop("Input argument 'n' must be a numeric scalar.")
    if (n < 0) return(matrix(NA, nrow=0, ncol=0))
    if (length(n) > 1 || ceiling(n) != floor(n)) {
        n <- floor(n[1])
        warning("Size 'n' should be a single integer number.")
    }

    J <- matrix(rep(1:n, each=n), n, n)
    I <- t(J)
    E <- matrix(1, n, n)
    H <- E / (I + J - 1)
    return(H)
}

##
##  r k f 5 4 . R  Runge-Kutta-Fehlberg
##


rkf54 <- function(f, a, b, y0, tol = .Machine$double.eps^0.5,
                               control = list(), ...) {
    stopifnot(is.numeric(a), length(a) == 1, is.numeric(b), length(b) == 1)
    if (tol < .Machine$double.eps)  tol <- .Machine$double.eps

    # control list handling
    cntrl <- list(hmin = 0.001, hmax = 0.250, jmax = 200)
    nmsCo <- match.arg(names(control), choices = names(cntrl), several.ok = TRUE)
    if (!is.null(names(control))) cntrl[nmsCo] <- control

    fun <- match.fun(f)
    f   <- function(x, y) fun(x, y, ...)

    # coefficient matrices
    a2 <- 1/4; b2 <- 1/4
    a3 <- 3/8; b3 <- 3/32; c3 <- 9/32
    a4 <- 12/13; b4 <- 1932/2197; c4 <- -7200/2197; d4 <- 7296/2197
    a5 <- 1; b5 <- 439/216; c5 <- -8; d5 <- 3680/513; e5 <- -845/4104
    a6 <- 1/2; b6 <- -8/27; c6 <- 2; d6 <- -3544/2565; e6 <- 1859/4104; f6 <- -11/40

    r1 <- 1/360; r3 <- -128/4275; r4 <- -2197/75240; r5 <- 1/50; r6 <- 2/55
    n1 <- 25/216; n3 <- 1408/2565; n4 <- 2197/4104; n5 <- -1/5

    # Initialize solution vectors
    j <- 1
    T <- c(a)
    Y <- c(y0)

    # Initialize control parameters
    hmin <- cntrl$hmin
    hmax <- cntrl$hmax
    jmax <- cntrl$jmax
    h <- 0.8*hmin + 0.2*hmax
    br <- b - tol * abs(b)

    while (T[j] < b) {
        if (T[j] + h > br)  h <- b - T[j]
        tj <- T[j]; yj <- Y[j]

        k1 <- h * f(tj, yj)
        k2 <- h * f(tj + a2*h, yj + b2*k1)
        k3 <- h * f(tj + a3*h, yj + b3*k1 + c3*k2)
        k4 <- h * f(tj + a4*h, yj + b4*k1 + c4*k2 + d4*k3)
        k5 <- h * f(tj + a5*h, yj + b5*k1 + c5*k2 + d5*k3 + e5*k4)
        k6 <- h * f(tj + a6*h, yj + b6*k1 + c6*k2 + d6*k3 + e6*k4 + f6*k5)

        err  <-  abs(r1*k1 + r3*k3 + r4*k4 + r5*k5 + r6*k6)
        ynew <- yj + n1*k1 + n3*k3 + n4*k4 + n5*k5

        # Convergence condition
        if (err < tol || h < 2*hmin) {
            Y <- c(Y, ynew)
            if (tj + h > br) T <- c(T, b)
            else             T <- c(T, tj + h)
            j <- j+1;
        }

        # Compute next step length
        if (err == 0) s <- 0 else s <- s <- (tol*h/(2*err))^0.25
        if (s < 0.1) s <- 0.1
        if (s > 4.0) s <- 4.0

        h <- s * h
        if (h > hmax)  h <- hmax
        if (h < hmin)  h <- hmin

        if (j >= jmax) {
            warning(paste("Maximum number of steps reached:", j))
            break
        }
    }
    return(list(x = T, y = Y))
}

interp1 <- function (x, y, xi = x,
             method = c("linear", "constant", "nearest", "spline", "cubic"))
{
    if (!is.vector(x, mode="numeric") || !is.vector(y, mode="numeric"))
        stop("Arguments 'x' and 'y' must be numeric vectors.")
    nx <- length(x)
    if (length(y) != nx)
        stop("Arguments 'x' and 'y' must be vectors of the same length.")
    if (nx <= 1)
        stop("Arguments 'x', 'y' must have at least a length >= 2.")

    if (min(xi) < min(x) || max(xi) > max(x))
        stop("Points 'xi' outside of range of argument 'x'.")

    e <- try(method <- match.arg(method), silent = TRUE)
    if(inherits(e, "try-error")) {
        warning("Unknown method: will use 'linear' interpolation.")
        method <- "linear"
    }

    if (is.unsorted(x)) {  # necessary for method 'nearest'
        warning("Points in argument in 'x' unsorted; will be sorted.")
        o <- order(x)
        x <- x[o]; y <- y[o]
    }

    if (any(duplicated(x)))
        warning("There are duplicated values in 'x'; mean will be tried.")

    if (method == "constant" || method == "linear") {
        yi <- approx(x, y, xi, method = method)$y
    } else if (method == "nearest") {
        n <- length(x)
        xx <- c(x[1], (x[2:n] + x[1:(n-1)])/2, x[n])
        yy <- c(y, y[n])
        yi <- approx(xx, yy, xi, method = "constant")$y
    } else if (method == "spline") {
        #spfun <- splinefun(x, y, method = "fmm"); yi <- spfun(xi)
        yi <- .ml.spline(x, y, xi)
    } else if (method == "cubic") {
        yi<- pchip(x, y, xi)
    } else
        stop(paste("Method", method, "not yet implemented."))

    return(yi)
}

#-- Moler's spline function --------------------------------
.ml.spline <- function(x, y, xi) {
    x <- c(x); y <- c(y)
    n <- length (x)
    if (length(y) != n) stop("Arguments 'x', 'y' must have the same length.")
    if (n < 3)          stop("spline routine: requires at least 3 points")

    # First derivatives
    h <- diff(x)
    delta <- diff(y)/h
    d <- .ml.splineslopes(h, delta)

    # Piecewise polynomial coefficients
    cc <- (3*delta - 2*d[1:(n-1)] - d[2:n])/h
    b  <- (d[1:(n-1)] - 2*delta + d[2:n])/h^2

    # Find subinterval indices k so that x(k) <= xi < x(k+1)
    m <- length(xi)
    k <- rep(1, m)
    for (j in 2:(n-1))
        k[x[j] <= xi] <- j

    # Evaluate spline
    s <- xi - x[k]
    v <- y[k] + s*(d[k] + s*(cc[k] + s*b[k]))

    return(v)
}

.ml.splineslopes <- function(h, delta) {

    # Diagonals of tridiagonal system
    n <- length(h)+1
    a <- numeric(length(h))
    b <- a; cc <- a; r <- a
    a[1:(n-2)] <- h[2:(n-1)]
    a[n-1] <- h[n-2] + h[n-1]
    b[1] <- h[2]
    b[2:(n-1)] <- 2*(h[2:(n-1)] + h[1:(n-2)])
    b[n] <- h[n-2]
    cc[1] <- h[1] + h[2]
    cc[2:(n-1)] <- h[1:(n-2)]

    # Right-hand side
    r[1] <- ((h[1] + 2*cc[1]) * h[2]*delta[1] + 
              h[1]^2 * delta[2])/cc[1]
    r[2:(n-1)] <- 3 * (h[2:(n-1)] * delta[1:(n-2)] + 
                  h[1:(n-2)] * delta[2:(n-1)])
    r[n] <- (h[n-1]^2 * delta[n-2] + 
             (2*a[n-1] + h[n-1]) * h[n-2] * delta[n-1])/a[n-1]

    # Solve tridiagonal linear system
    d <- .ml.tridisolve(a, b, cc, r)
    return(d)
}

.ml.tridisolve <- function(a, b, cc, d) {
    x <- d
    n <- length(x)

    for (j in 1:(n-1)) {
       mu <- a[j]/b[j]
       b[j+1] <- b[j+1] - mu*cc[j]
       x[j+1] <- x[j+1] - mu*x[j]
    }

    x[n] <- x[n]/b[n]
    for (j in (n-1):1)
        x[j] <- (x[j]-cc[j]*x[j+1])/b[j]

    return(x)
}

##
##  r a n k . R  Matrix Rank
##


Rank <- function(M) {
    if (length(M) == 0)
        return(0)
    if (!is.numeric(M))
        stop("Argument 'M' must be a numeric matrix.")
    if (is.vector(M))
        M <- matrix(c(M), nrow = length(M), ncol = 1)

    # The MASS way
    r1 <- qr(M)$rank

    # The Matlab way
    sigma <- svd(M)$d
    tol <- max(dim(M)) * max(sigma) * .Machine$double.eps
    r2 <- sum(sigma > tol)

    if (r1 != r2)
        warning("Rank calculation may be problematic.")
    return(r2)
}


nullspace <- function(M) {
    if (!is.numeric(M))
        stop("Argument 'M' must be a numeric matrix.")
    if (is.vector(M))
        M <- matrix(c(M), nrow = length(M), ncol = 1)

    qrM <- qr(t(M))
    rnk <- qrM$rank
    if (rnk == ncol(M)) return(NULL)

    inds <- if (rnk == 0) 1:ncol(M) else -(1:rnk)
    qrQ <- qr.Q(qrM, complete = TRUE)[, inds, drop = FALSE]

    if (length(qrQ) == 0) return(NULL)
    else                  return(qrQ)
}


null <- nullspace

##
##  g e o _ m e d i a n . R  Geometrical Median
##


geo_median <- function(P, tol = 1e-07, maxiter = 200) {
	stopifnot(is.numeric(P))
	if (!is.matrix(P))
	    stop("Argument 'P' must be a matrix (of points in R^n).")

	m <- nrow(P); n <- ncol(P)
    if (n == 1)
        return(list(p = median(P), d = sum(abs(P - median(P))),
                    reltol = 0, niter = 0))

	p0 <- apply(P, 2, mean)
	p1 <- p0 + 1

    iter <- 1
	while(max(abs(p0 - p1)) > tol && iter < maxiter) {
		iter <- iter + 1
		p0 <- p1
	    s1 <- s2 <- 0
	    for (j in 1:m) {
		    d <- Norm(P[j, ] - p0)
		    s1 <- s1 + P[j, ]/d
		    s2 <- s2 + 1/d
	    }
	    p1 <- s1 / s2
	}
	if (iter >= maxiter)
        warning("Maximum number of iterations reached; may not converge.")

    d <- 0
    for (j in 1:m)
        d <- d + Norm(P[j, ] - p1)

	return( list(p = p1, d = d, reltol = max(abs(p0 - p1)), niter = iter) )
}

##
##  a r n o l d i . R  Arnoldi Iteration
##

arnoldi <- function(A, q, m) {
    stopifnot(is.numeric(A), is.numeric(q))
    if (!is.matrix(A) || nrow(A) != nrow(A))
        stop("Argument 'A' must be a square matrix")
    n <- nrow(A)
    q1 <- as.matrix(c(q))
    if (length(q1) != n)
        stop("Argument 'q' must be a vector of length 'nrow(A)'.")
    if (missing(m)) m <- n

    q1 <- q1 / Norm(q1)
    Q <- zeros(n,m)
    Q[, 1] <- q1
    H <- zeros(min(m+1,m), n)

    for (k in 1:m) {
        z <- A %*% Q[, k]
        for (i in 1:k) {
            H[i, k] <- t(Q[, i]) %*% z
            z <- z - H[i, k] * Q[, i]
        }
        if (k < n) {
            H[k+1, k] <- Norm(z)
            if (H[k+1, k] == 0)
                return(list(Q = Q, H = H))
            Q[, k+1] <- z / H[k+1, k]
        }
    }
    return(list(Q = Q, H = H))
}

##
##  c l e a r . R
##


clear <- function(lst) {
    if (missing(lst))
        lst <- ls(name = .GlobalEnv)
    if (!is.character(lst))
        stop("Argument must be empty or a character vector.")
    rm(list = lst, envir = globalenv())
    # capture.output(gc())
    null <- gc()
}


who <- function() ls(name = .GlobalEnv)


whos <- function() {
    envir <- parent.frame()
    lslist <- ls(envir)
    if (isempty(lslist))
        return(invisible(NULL))

    m <- max(nchar(lslist))
    for (item in lslist) {
        itemObj   <- eval(parse(text = item), parent.frame())
        itemClass <- class(itemObj)
        itemSize  <- object.size(itemObj)
        itemDim   <- paste(dim(itemObj), collapse="x")
        if (itemDim == '') itemDim <- length(itemObj)

        itemSize <- as.numeric(itemSize)
        if (itemSize < 1024) itemSize <- paste(itemSize, "Byte")
        else if (itemSize >= 1024 & itemSize < 1024*1024)
            itemSize <- paste(round(itemSize/1024, 1), "KB")
        else
            itemSize <- paste(round(itemSize/1024/1024, 1), "MB")

        format(cat( item, blanks(m - nchar(item) + 2),
                    itemClass, ", ",
                    itemDim, ", ",
                    itemSize, "\n", 
                    sep=""), justify="centre")
    }
    cat("\n")
    invisible(lslist)
}


what <- function(dname = getwd()) {  # , fexp = "*.R"
    if (is.na(file.info(dname)$isdir)) {
        cat("Argument '", dname, "' is not a known directory.\n", sep = '')
    } else if (file.info(dname)$isdir) {
        fnames <- list.files(dname)
        if (isempty(fnames)) {
            cat("No files in Directory ", dname, ".\n\n", sep = '')
        } else {
            cat("Files in Directory ", dname, ":\n\n", sep = '')
            for (fname in fnames) {
                gname <- paste(dname, fname, sep = "/")
                if (!file.info(gname)$isdir) {
                    cat(fname, "\n")
                }
            }
        }
    } else {
        cat("Argument '", dname, "' is not a directory.\n", sep = '')
    }
    invisible(NULL)
}


cd <- function(dname) {
    if (missing(dname)) {
        dname <- getwd()
    } else {
        setwd(dname)
        dname <- getwd()
    }
    return(dname)
}


pwd <- function()
    getwd()

##
##  h u m p s . R  Matlab Test Function
##


humps <- function(x) {
    if (missing(x))
        x <- seq(0.0, 1.0, by=0.05)

    stopifnot(is.numeric(x))

    1/((x-0.3)^2 + 0.01) + 1/((x-0.9)^2 + 0.04) - 6
}

sinc <- function(x) {
    stopifnot(is.numeric(x))

    sin(pi * x) / (pi * x)
}

psinc <- function(x, n) {
    stopifnot(is.numeric(x), is.numeric(n))
    if (floor(n) != ceiling(n) || n < 1)
        stop("Argument 'n' must be a positive integer.")
    
    sin(x * n/2) / n * sin(x/2)
}

###
### ISPRIME.R  Prime number property
###


isprime <- function(x) {
    if (is.null(x) || length(x) == 0)
        stop("Argument 'x' must be a nonempty vector or matrix.")
    if (!is.numeric(x) || any(x < 0) || any(x != round(x)))
        stop("All entries of 'x' must be nonnegative integers.")

    n <- length(x)
    X <- x[1:n]
    L <- logical(n)
    p <- primes(ceiling(sqrt(max(x))))
    for (i in 1:n) {
        L[i] <- all(X[i] %% p[p < X[i]] != 0)  # all(rem(X[k], p[p < X[k]]))
    }
    L[X == 1 | X == 0] <- FALSE
    N <- as.numeric(L)
    dim(N) <- dim(x)
    return(N)
}

##
##  g a m m a i n c . R  Incomplete Gamma Function
##


gammainc <- function(x, a) {
    if (!is.numeric(a) || !is.numeric(x))
        stop("All arguments must be real numbers.")
    if (length(a) > 1 || length(x) > 1)
        stop("Arguments must be of length 1; function is not vectorized.")
    if (a < 0)
        stop("Argument 'a' must be real and nonnegative.")
    if (x == 0 && a == 0)
        return(c(lowinc = 0.0, uppinc = Inf, reginc = 0.0))
    if (x == 0)
        return(c(lowinc = 0.0, uppinc = gamma(a), reginc = 0.0))

    if (x > 0)  xam <- -x + a*log(x)
    else        xam <- -x + a*log(x + 0i)
    if (abs(xam) > 700.0 || abs(a) > 170.0) {
        warning("Arguments 'x' and/or 'a' are too large.")
        return(NA)
    }

    # Computation of the incomplete gamma function
    gin <- gim <- gip <- 0

    if (x == 0.0) {
        ga <- gamma(a)
        gim <- ga
        gip <- 0.0
    } else if (x <= 1.0 + a) {
        s <- 1/a
        r <- s
        for  (k in 1:60) {
            r <- r * x/(a+k);
            s <- s+r;
            if (abs(r/s) < 1e-15) break
        }
        gin <- exp(xam) * s
        ga <- gamma(a)
        gip <- gin/ga
        gim <- ga - gin
    } else if (x > 1.0 + a) {
        t0 <- 0
        for  (k in 60:1) {
            t0 <- (k-a)/(1 + k/(x+t0))
        }
        gim <- exp(xam)/(x+t0)
        ga <- gamma(a)
        gin <- ga - gim
        gip <- 1 - gim/ga
    }
    return(c(lowinc = Re(gin), uppinc = Re(gim), reginc = Re(gip)))
}


incgam <- function(x, a) {
    if (!is.numeric(a) || !is.numeric(x)) 
        stop("All arguments must be real numbers.")
    if (length(a) > 1 || length(x) > 1) 
        stop("Arguments must be of length 1; function is not vectorized.")
    
    if (x > 0) {
        if (a > 0) {
            g_gamma <- gamma(a)
            g_upper <- g_gamma * pgamma(x, a, 1, lower.tail = FALSE)
            # g_regul <- pgamma(x, a, 1, lower = TRUE)
            # g_lower <- g_gamma * g_regul
        } else if (a == 0) {
            g_upper <- pracma::expint_E1(x)
        } else if (a < 0 && a >= -1) {
            g_upper <- -1 * x^a*exp(-x)/a + incgam(x, a+1)/a
        } else { # (a < 0)
            stop("Not yet implemented: use recursion -- see help")
        }
        
    } else if (x == 0) {
        g_upper <- gamma(a)
    } else { # (x < 0)
        stop("Not implemented: Result for 'x<0' will be complex.")
    }
    
    # g_lower <- gamma(a) - g_upper
    # g_regul <- 1 - g_upper / gamma(a)
    return(g_upper)
}

##
##  r e p m a t . R
##


repmat <- function(a, n, m = n) {
    if (length(a) == 0) return(c())
    if (!is.numeric(a) && !is.complex(a))
        stop("Argument 'a' must be a numeric or complex.")
    if (is.vector(a))
        a <- matrix(a, nrow = 1, ncol = length(a))
    if (!is.numeric(n) || !is.numeric(m) ||
        length(n) != 1 || length(m) != 1)
        stop("Arguments 'n' and 'm' must be single integers.")
    n <- max(floor(n), 0)
    m <- max(floor(m), 0)
    if (n <= 0 || m <= 0)
        return(matrix(0, nrow = n, ncol = m))

	matrix(1, n, m) %x% a  # Kronecker product
}

Reshape <- function(a, n, m) {
	if (missing(m)) m <- length(a) %/% n
	if (length(a) != n*m)
		stop("Matrix 'a' does not have n*m elements")
	dim(a) <- c(n, m)
	return(a)
}


sortrows <- function(A, k = 1) {  # l <- k+1
    stopifnot(is.numeric(A), is.numeric(k))
    if (!is.matrix(A))
        stop("Argument 'A' must be a numeric matrix.")
    if (length(k) != 1 || floor(k) != ceiling(k))
        stop("Argument 'k' must be a single integer number.")

    n <- nrow(A); m <- ncol(A)
    if (k < 1 || k > m)
        stop("Argument 'k' must satisfy 1 <= k <= ncol(A).")

    o <- order(A[, k])
    A[o, ]
}

###
###  p r i m e s . R  Prime numbers
###


primes <- function(n) {
    if (!is.numeric(n) || length(n) != 1)
        stop("Argument 'n' must be a numeric scalar.")
    n <- floor(n)
    if (n < 2) return(c())
    p <- seq(1, n, by=2)
    q <- length(p)
    p[1] <- 2
    if (n >= 9) {
        for (k in seq(3, sqrt(n), by=2)) {
            if (p[(k+1)/2] != 0)
                p[seq((k*k+1)/2, q, by=k)] <- 0
        }    
    }
    p[p > 0]
}

##
##  t a y l o r . R  Taylor Series Approximation
##


taylor <- function(f, x0, n = 4, ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric value or vector.")
    if (!is.numeric(n) || floor(n) != ceil(n) || length(n) != 1)
        stop("Order 'n' must be an scalar integer between 1 and 8.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (n > 8) {
        # n <- 8
        warning("Order 'n' is too high; should not be greater than 'n=8'.")
    } else if (n <= 0) {
        n <- 4
        warning("Order 'n' is too low; will be reset to the default 'n=4'.")
    }

    T <- f(x0)
    for (i in 1:n) {
        T <- polyadd(T, fderiv(f, x0, i)/fact(i) * polypow(c(1, -x0), i))
    }
    return(T)
}

###
### p o l y a r e a . R  Calculate area and center of a polygon
###


polyarea <- function(x, y) {
    if (length(x) == 0 && length(y) == 0) return(0)
    if (!(is.numeric(x) || is.complex(x)) ||
        !(is.numeric(y) || is.complex(y)))
        stop("Arguments 'x' and 'y' must be real or complex.")
    if (is.null(dim(x))) x <- matrix(x, length(x), 1)
    if (is.null(dim(y))) y <- matrix(y, length(y), 1)
    if (any(dim(x) != dim(y)))
        stop("Matrices 'x' and 'y' must be of same size.")

    n <- nrow(x); m <- ncol(x)
    z <- numeric(m)
    for (i in 1:m) {
        xi <- x[, i]
        yi <- y[, i]
        # Gauss' formula
        p1 <- sum(xi[1:(n-1)]*yi[2:n]) + xi[n]*yi[1]
        p2 <- sum(xi[2:n]*yi[1:(n-1)]) + xi[1]*yi[n]
        z[i] <- 0.5*(p1-p2)
    }
    return(z)
}


poly_center <- function(x, y) {
    stopifnot(is.numeric(x), is.numeric(y))
    n <- length(x)
    if (length(y) != n || n <= 2)
        stop("Arguments 'x' and 'y' must be of the same length >= 3.")

    parea <- polyarea(x, y)
    if (parea == 0)
        return(c(NA, NA))

    x1 <- x[1:(n-1)]; x2 <- x[2:n]
    y1 <- y[1:(n-1)]; y2 <- y[2:n]
    xy <- x1*y2 - x2*y1

    cx <- sum((x1+x2) * xy)
    cy <- sum((y1+y2) * xy)
    return(1/parea/6 * c(cx, cy))
}


poly_length <- function(x, y) {
    stopifnot(is.numeric(x), is.numeric(y))

    X  <- cbind(x, y)
    dX <- diff(X)
    return(sum(sqrt(rowSums(dX^2))))
}


poly_crossings <- function(L1, L2) {
    stopifnot(is.numeric(L1), is.numeric(L2))
    # L1, L2 marices with two rows: rbind(x, y)
    if (!is.matrix(L1) || !is.matrix(L2) || nrow(L1) != 2 || nrow(L2) != 2)
        stop("Arguments 'L1', 'L2' must be matrices with 2 rows.")

    # Utility function
    Dd <- function(x, y) {
        x1 <- x[, 1:(ncol(x)-1)]
        x2 <- x[, 2:ncol(x)]
        y1 <- repmat(as.matrix(y), 1, ncol(x1))
        y2 <- repmat(y, nrow(x2), 1)
        (x1 - y1) * (x2 - y1)
    }

    # Preliminary stuff
    x1  <- L1[1, ];    x2  <- L2[1, ]
    y1  <- L1[2, ];    y2  <- L2[2, ]
    dx1 <- diff(x1);   dy1 <- diff(y1)
    dx2 <- diff(x2);   dy2 <- diff(y2)
    n1  <- length(x1); n2  <- length(x2)

    # Determine 'signed differences'
    S1 <- dx1 * y1[1:(n1-1)] - dy1 * x1[1:(n1-1)]
    S2 <- dx2 * y2[1:(n2-1)] - dy2 * x2[1:(n2-1)]
    X1 <- outer(dx1, y2, "*") - outer(dy1, x2, "*")
    X2 <- outer(y1, dx2, "*") - outer(x1, dy2, "*")

    C1 <- Dd(X1, S1)
    C2 <- t(Dd(t(X2), S2))

    # Segments with expected intersection
    ij <- which((C1 <= 0) & (C2 <= 0), arr.ind = TRUE)
    if (length(ij) == 0)
        return(c())

    # Prepare for output
    i <- ij[, 1]; j <- ij[, 2]
    L <- dy2[j] * dx1[i] - dy1[i] * dx2[j]
    i <- i[L != 0]; j <- j[L != 0]
    L <- L[L != 0]              # avoid divisions by 0

    # Get the common points
    P <- cbind(dx2[j] * S1[i] - dx1[i] * S2[j],
               dy2[j] * S1[i] - dy1[i] * S2[j]) / cbind(L, L)
    # TO DO: throw out equal points

    colnames(P) <- c('x', 'y')
    return(P)
}

##
##  p l o t y y . R  Two-ordinates Plot
##


plotyy <- function( x1, y1, x2, y2, gridp = TRUE, box.col = "grey",
                                    type = "l", lwd = 1, lty = 1,
                                    xlab = "x", ylab = "y", main = "",
                                    col.y1 = "navy", col.y2 = "maroon", ...)
{
    stopifnot(is.numeric(x1), is.numeric(y1), is.numeric(x2), is.numeric(y2))

    y1pretty <- pretty(y1); y1l <- min(y1pretty); y1u <- max(y1pretty)
    y2pretty <- pretty(y2); y2l <- min(y2pretty); y2u <- max(y2pretty)

    ptrans <- function(y) y1l + (y - y2l)/(y2u - y2l) * (y1u - y1l)

    y1pretty <- pretty(c(y1, ptrans(y2)))

    opar <- par(mar = c(4.1, 4.1, 3.1, 3.1))
    plot(range(c(x1, x2)), range(y1pretty),
        xlab = xlab, ylab = ylab, main = main,
        type = "n", yaxt = "n", bty = "n", ...)
    box(col = box.col)

    mx <- axis(side = 2, at = y1pretty,  labels = FALSE, col = col.y1)
    my <- axis(side = 4, at = ptrans(y2pretty), labels = FALSE, col = col.y2)
    mtext(mx, side = 2, line = 1, at = mx, col = col.y1)
    mtext(y2pretty, side = 4, line = 1, at = my, col = col.y2)


    if (gridp) grid()
    points(x1, y1,  type = type, col = col.y1, lwd = lwd, lty = lty)
    points(x2, ptrans(y2), type = type, col = col.y2, lwd = lwd, lty = lty)
    par(opar)


    invisible()
}

##
##  w i l k i n s o n . R  Wilkinson matrix
##


wilkinson <- function(n){
	if (length(n) != 1 || n != round(n))
		stop("Argument 'n' must be an integer.")
	if (n <= 0) return(c())

	m <- (n-1)/2.0
	r <- rep(1, n-1)
	Diag(abs(-m:m)) + Diag(r, 1) + Diag(r, -1)
}

lsqnonneg <- function(C, d) {
    stopifnot(is.numeric(C), is.numeric(d))
    if (!is.matrix(C) || !is.vector(d))
        stop("Argument 'C' must be a matrix, 'd' a vector.")
    m <- nrow(C); n <- ncol(C)
    if (m != length(d))
        stop("Arguments 'C' and 'd' have nonconformable dimensions.")

    tol = 10 * eps() * norm(C, type = "2") * (max(n, m) + 1)

    x  <- rep(0, n)             # initial point
    P  <- logical(n); Z <- !P   # non-active / active columns
    
    resid <- d - C %*% x
    w <- t(C) %*% resid
    wz <- numeric(n)

    # iteration parameters
    outeriter <- 0; it <- 0
    itmax <- 3 * n; exitflag <- 1

    while (any(Z) && any(w[Z] > tol)) {
        outeriter <- outeriter + 1
        z <- numeric(n)
        wz <- rep(-Inf, n)
        wz[Z] <- w[Z]
        im <- which.max(wz)
        P[im] <- TRUE; Z[im] <- FALSE
        z[P] <- qr.solve(C[, P], d)
        
        while (any(z[P] <= 0)) {
            it <- it + 1
            if (it > itmax) stop("Iteration count exceeded.")

            Q <- (z <= 0) & P
            alpha <- min(x[Q] / (x[Q] - z[Q]))
            x <- x + alpha*(z - x)
            Z <- ((abs(x) < tol) & P) | Z
            P <- !Z
            z <- numeric(n)
            z[P] <- qr.solve(C[, P], d)
        }
    x <- z
    resid <- d - C %*% x
    w <- t(C) %*% resid
    }
    return(list(x = x, resid.norm = sum(resid*resid)))
}

anms <- function(fn, x0, ...,
                 tol = 1e-10, maxfeval = NULL) {
    stopifnot(is.numeric(x0) && length(x0) > 1)
    d <- length(x0); d1 <- d + 1
    fun <- match.fun(fn)
    fn <- function(x) fun(x, ...)

    if (is.null(maxfeval)) maxfeval <- 50 * d^2

    # set up adaptive parameters
    alpha <- 1; beta <- 1 + 2/d
    gamma <- 0.75 - 0.5/d; delta <- 1 - 1/d

    # large initial simplex is used
    scalefactor <- min(max(max(abs(x0)), 1), 10)

    # construct the initial simplex
    D0 <- rbind(eye(d),
                (1-sqrt(d1)) / d * ones(1,d))
    X <- matrix(0, nrow = d1, ncol = d)
    FX <- numeric(d1)
    for (i in 1:d1) {
        X[i, ] <- x0 + scalefactor * D0[i, ]
        FX[i] <- fn(X[i, ])
    }
    o <-order(FX, decreasing = FALSE)
    FX <- FX[o]; X <- X[o, ]

    # main iteration
    ct <- d1
    while (max(abs(X[2:d1, ] - X[1:d, ])) >= scalefactor*tol) {
        if (ct > maxfeval) break
        M <- apply(X[1:d, ], 2, mean)
        xref <- (1+alpha) * M - alpha * X[d1, ]
        Fref <- fn(xref)
        ct <- ct + 1
        if (Fref < FX[1]) {
            # expansion
            xexp <- (1+alpha*beta) * M - alpha*beta*X[d1, ]
            Fexp <- fn(xexp)
            ct <- ct+1
            if (Fexp < Fref) {
                X[d1, ] <- xexp
                FX[d1] <- Fexp
            } else {
                X[d1, ] <- xref
                FX[d1] <- Fref
            }
        } else {
            if (Fref < FX[d]) {
                # accept reflection point
                X[d1, ] <- xref
                FX[d1] <- Fref
            } else {
                if (Fref < FX[d1]) {
                    # Outside contraction
                    xoc <- (1+alpha*gamma) * M - alpha*gamma*X[d1, ]
                    Foc <- fn(xoc)
                    ct <- ct+1;
                    if (Foc <= Fref) {
                        X[d1, ] <- xoc
                        FX[d1] <- Foc
                    } else {
                        # shrink
                        for (i in 2:d1) {
                            X[i, ] <- X[1, ] + delta*(X[i, ] - X[1, ])
                            FX[i] <- fn(X[i, ])
                        }
                        ct=ct+d
                    }
                } else {
                    # inside contraction
                    xic <- (1-gamma) * M + gamma*X[d1, ]
                    Fic <- fn(xic)
                    ct <- ct+1
                    if (Fic < FX[d1]) {
                        X[d1, ] <- xic
                        FX[d1] <- Fic
                    } else {
                        # shrink
                        for (i in 2:d1) {
                            X[i, ] <- X[1, ] + delta*(X[i, ] - X[1, ])
                            FX[i] <- fn(X[i, ])
                        }
                        ct <- ct+d
                    }
                }
            }
        }
        o <-order(FX, decreasing = FALSE)
        FX <- FX[o]; X <- X[o, ]
    }
    xmin <- X[1, ]
    fmin <- FX[1]

    return(list(xmin = xmin, fmin = fmin, nfeval = ct))
}

###
### NTHROOT.R - Compute the real n-th root
###


nthroot <- function(x, n) {
    if (! is.numeric(x))
        stop("Argument 'x' must be numeric.")
    if (missing(n) || n <= 0 || ceiling(n) != floor(n))
        stop("Argument 'n' must be a positive integer.")
    if (any(x[!is.na(x)] < 0) && n %% 2 == 0)
        stop("If argument 'x' is negative, 'n' must be an odd integer.")

    sx <- sign(x)
    return(sx * (sx * x)^(1/n))
}

##
##  p p f i t . R  Piecewise Polynomial Fit
##


ppfit <- function(x, y, xi, method = c("linear", "cubic")) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(xi))
    if (length(x) != length(y) || length(x) <= 1)
        stop("Length of 'x' and 'y' must be equal and greater than 1.")
    method <- match.arg(method)

    y0 <- interp1(x, y, xi, method = method)
    nn <- finds(x >= xi[1] & x <= xi[length(xi)])
    fcn <- function(yi) sum((interp1 (xi, yi, x[nn], method) - y[nn])^2)
    yi <- optim(y0, fcn)$par

    n <- length(xi) - 1
    if (method == "linear") {
        P <- matrix(NA, nrow = n, ncol = 2)
        for (i in 1:n)
            P[i, ] <- c((yi[i+1]-yi[i])/(xi[i+1]-xi[i]), yi[i])
        pp <- mkpp(xi, P)
    } else if (method == "cubic") {
        pp <- cubicspline(xi, yi)
    } else
        stop("Unknown method: must be 'linear' or 'cubic'.")

    return(pp)
}

##
##  m l d i v i d e . R  Matlab backslash Operator
##


mldivide <- function(A, B, pinv = TRUE) {
    stopifnot(is.numeric(A) || is.complex(A),
              is.numeric(B) || is.complex(B))
    if (is.vector(A)) A <- as.matrix(A)
    if (is.vector(B)) B <- as.matrix(B)
    if (nrow(A) != nrow(B))
        stop("Matrices 'A' and 'B' must have the same number of rows.")
    if (pinv) {
        pinv(t(A) %*% A) %*% t(A) %*% B
    } else {
        qr.solve(A, B)
    }
}

mrdivide <- function(A, B, pinv = TRUE) {
    stopifnot(is.numeric(A) || is.complex(A),
              is.numeric(B) || is.complex(B))
    if (is.vector(A)) A <- t(A)
    if (is.vector(B)) B <- t(B)
    if (ncol(A) != ncol(B))
        stop("Matrices 'A' and 'B' must have the same number of columns.")

    t(mldivide(t(B), t(A), pinv = pinv))
}

##
##  d i s t m a t . R  Distance matrix and Hausdorff dimension
##

# If a is m x r and b is n x r then 
#
#   apply(outer(a,t(b),"-"),c(1,4),function(x)sqrt(sum(diag(x*x))))
#
# is the m x n matrix of distances between the m rows of a and 
# n rows of b.
#
# Modify, as necessary, if you want distances other than euclidean.
#
# The following code is 10-100 times faster.


distmat <- function(X, Y)
#   Computes Euclidean distance between two vectors as:
#       ||A-B|| = sqrt ( ||A||^2 + ||B||^2 - 2*A.B )
#   and vectorizes to rows in two matrices (or vectors).
{
    if (!is.numeric(X) || !is.numeric(Y))
        stop("X and Y must be numeric vectors or matrices.")
    if (is.vector(X)) dim(X) <- c(1,length(X))
    if (is.vector(Y)) dim(Y) <- c(1,length(Y))
    if (ncol(X) != ncol(Y))
        stop("X and Y must have the same number of columns.")

    m  <- nrow(X); n <- nrow(Y)
    XY <- X %*% t(Y)    # (m,n)-matrix
    XX <- matrix( rep(apply(X*X, 1, sum), n), m, n, byrow=F )
    YY <- matrix( rep(apply(Y*Y, 1, sum), m), m, n, byrow=T )

    sqrt(pmax(XX + YY - 2*XY, 0))
}


pdist <- function(X) {
    distmat(X, X)
}


pdist2 <- function(X, Y) {
    distmat(X, Y)
}


hausdorff_dist <- function(P, Q) {
    stopifnot(is.numeric(P), is.numeric(Q))
    if (is.vector(P)) P <- matrix(P, ncol = 1)
    if (is.vector(Q)) Q <- matrix(Q, ncol = 1)
    if (ncol(P) != ncol(Q))
        stop("'P' and 'Q' must have the same number of columns.")

    D <- distmat(P, Q)

    # directional Hausdorff dimension
    dhd_PQ <- max(apply(D, 1, min))
    dhd_QP <- max(apply(D, 2, min))

    return(max(dhd_PQ, dhd_QP))
}

##
##  l i n s p a c e . R
##


linspace <- function(x1, x2, n=100) {
	stopifnot(is.numeric(x1), is.numeric(x2), length(x1)==1, length(x2)==1)
	n <- floor(n)
	if (n <= 1) x2
	else seq(x1, x2, length.out=n)
}

logspace <- function(x1, x2, n=50) {
	if (x2 == pi) x2 <- log10(x2)
	10^linspace(x1, x2, n)
}

logseq <- function(x1, x2, n=100) {
    x <- linspace(log(abs(x1)), log(abs(x2)), n)
    exp(x)
}

##
##  f m i n c o n . R
##


fmincon <- function(x0, fn, gr = NULL, ..., method = "SQP",
                    A = NULL, b = NULL, Aeq = NULL, beq = NULL,
                    lb = NULL, ub = NULL, hin = NULL, heq = NULL,
                    tol = 1e-06, maxfeval = 10000, maxiter = 5000) {

    if (method != "SQP")
        stop("Methods other than 'SQP' are not yet implemented.")
    if (!is.numeric(x0) || length(x0) <= 1)
        stop("'x0' must be a numeric vector of length greater 1.")
    if (!is.null(gr))
        warning("Gradient function is not used for SQP approach.")

    if (!requireNamespace("NlcOptim", quietly =TRUE))
        stop("Package 'NlcOptim' missing -- install from CRAN.")
    if (!requireNamespace("quadprog", quietly =TRUE))
        stop("Package 'quadprog' missing -- install from CRAN.")

    fun <- match.fun(fn)
    fn  <- function(x) fun(x, ...)

    if (!is.null(A)) {
        if (!is.matrix(A) || ncol(A) != length(x0))
            stop("Argument 'A' must be a matrix with length(x0) columns.")
        if (is.null(b) || nrow(A) != length(b))
            stop("Argument 'b' must be a vector of length(b) = nrow(A).")
    }
    if (!is.null(Aeq)) {
        if (!is.matrix(Aeq) || ncol(Aeq) != length(x0))
            stop("Argument 'Aeq' must be a matrix with length(x0) columns.")
        if (is.null(beq) || nrow(Aeq) != length(beq))
            stop("Argument 'beq' must be a vector of length(beq) = nrow(Aeq).")
    }
    if (!is.null(lb) && length(lb) != length(x0)) {
        if (length(lb == 1)) lb <- rep(lb, length(x0))
        else stop("Length of argument 'lb' must be equal to length(x0).")
    }
    if (!is.null(ub) && length(ub) != length(x0)) {
        if (length(ub == 1)) ub <- rep(ub, length(x0))
        else stop("Length of argument 'ub' must be equal to length(x0).")
    }
    
    if (is.null(hin) && is.null(heq)) { confun = NULL
    } else if (is.null(heq)) {
        confun <- function(x) list(ceq = NULL, c = hin(x))
    } else if (is.null(hin)) {
        confun <- function(x) list(ceq = heq(x), c = NULL)
    } else
        confun <- function(x) list(ceq = heq(x), c = hin(x))

    sol <- NlcOptim::solnl(X = x0, objfun = fn, confun = confun,
                           A = A, B = b, Aeq = Aeq, Beq = beq,
                           lb = lb, ub = ub,
                           tolX = tol, tolFun = 0.1*tol, tolCon = 0.1*tol)
    ans <- list(par = c(sol$par), value = sol$fn, convergence = 0,
                info = list(lambda = sol$lambda, grad = sol$grad,
                            hessian = sol$hessian))
    return(ans)
}

##
##  h u r s t . R  Hurst Exponent
##


.hurstrs <- function(x) {
	# half intervals of indices
	half <- function(N) sort(c(N, N[-length(N)]+((diff(N)+1)%/%2)))
	# define the R/S scale
	rscalc <- function(x) {
		n <- length(x); y <- cumsum(x - mean(x))
		R <- diff(range(y)); S <- sd(x)
		return(R/S)
	}
	# set initial values
	X <- c(length(x))
	Y <- c(rscalc(x))
	N <- c(0, length(x) %/% 2, length(x))
	# compute averaged R/S for halved intervals
	while ( min(diff(N)) >= 8 ) {
		xl <- c(); yl <- c()
		for (i in 2:length(N)) {
			rs <- rscalc(x[(N[i-1]+1):N[i]])
			xl <- c(xl, N[i]-N[i-1])
			yl <- c(yl, rs)
		}
		X <- c(X, mean(xl))
		Y <- c(Y, mean(yl))
		# next step
		N <- half(N)
	}
	# apply linear regression
	rs_lm <- lm(log(Y) ~ log(X))
	return(unname(coefficients(rs_lm)[2]))
}


hurstexp <- function(x, d = 50, display = TRUE) {
    stopifnot(is.numeric(x), is.numeric(d))
    d <- max(2, floor(d[1]))
    N <- length(x)
    if (N %% 2 != 0) {
        x <- c(x, (x[N-1] + x[N])/2)
        N <- N + 1
    }

    # Calculate simple R/S
    rssimple <- function(x){
        n <- length(x)
        y <- x - mean(x)
        s <- cumsum(y)
        rs <- (max(s) - min(s)) / sd(x)
        log(rs) / log(n)
    }

    # Calculate empirical R/S
    rscalc <- function(z, n) {
        m <- length(z)/n
        y <- matrix(x, n, m)
        e <- apply(y, 2, mean)
        s <- apply(y, 2, std)
        for (i in 1:m) y[, i] <- y[, i] - e[i]
        y <- apply(y, 2, cumsum)
        mm <- apply(y, 2, max) - apply(y, 2, min)
        return( mean(mm/s) )
    }
    divisors <- function(n, n0 = 2) {
        n0n <- n0:floor(n/2)
        dvs <- n0n[n %% n0n == 0]
        return(dvs)
    }

    # Find the optimal vector d
    N <- length(x); dmin <- d
    N0 <- min(floor(0.99 * N), N-1)
    N1 <- N0; dv <- divisors(N1, dmin)
    for (i in (N0+1):N) {
        dw <- divisors(i, dmin)
        if (length(dw) > length(dv))
            {N1 <- i; dv <- dw}
    }
    OptN <- N1; d <- dv
    x <- x[1:OptN]

    N <- length(d)
    RSe <- ERS <- numeric(N)
    for (i in 1:N)
        RSe[i] <- rscalc(x, d[i])

    # Compute corrected theoretical E(R/S)
    for (i in 1:N) {
        n <- d[i]
        K <- c((n-1):1)/c(1:(n-1))
        ratio <- (n-0.5)/n * sum(sqrt(K))
        if (n > 340) ERS[i] <- ratio/sqrt(0.5*pi*n)
        else         ERS[i] <- (gamma(0.5*(n-1))*ratio) / (gamma(0.5*n)*sqrt(pi))
    }

    # Compute the Hurst exponent as the slope on a loglog scale
    ERSal <- sqrt(0.5*pi*d)
    Pal <- polyfit(log10(d), log10(RSe - ERS + ERSal), 1)
    Hal <- Pal[1]

    # Calculate the empirical and theoretical Hurst exponents
    Pe <- polyfit(log10(d), log10(RSe), 1)
    He <- Pe[1]
    P  <- polyfit(log10(d), log10(ERS), 1)
    Ht <- P[1]

    Hs   <- rssimple(x)
    Hrs <- .hurstrs(x)

    if (display) {
        cat("Simple R/S Hurst estimation:        ", Hs,  "\n")
        cat("Corrected R over S Hurst exponent:  ", Hrs, "\n")
        cat("Empirical Hurst exponent:           ", He,  "\n")
        cat("Corrected empirical Hurst exponent: ", Hal, "\n")
        cat("Theoretical Hurst exponent:         ", Ht,  "\n")
        invisible(list(Hs = Hs, Hrs = Hrs, He = He, Hal = Hal, Ht = Ht))
    } else {
        return(list(Hs = Hs, Hrs = Hrs, He = He, Hal = Hal, Ht = Ht))
    }
}

##
##  b a r y c e n t r i c . R  Barycentric Lagrange Interpolation
##


barylag <- function(xi, yi, x) {
    stopifnot(is.vector(xi, mode="numeric"), is.vector(xi, mode="numeric"))
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector or matrix.")

	n <- length(xi); m <- length(x)

	# Check the input arguments
	if (length(yi) != n)
		stop("Node vectors xi an yi must be of same length.")
	if ( min(x) < min(xi) || max(x) > max(xi) )
		stop("Some interpolation points outside the nodes.")

	# Compute weights
	X  <- matrix(rep(xi, times=n), n, n)
	wi <- 1 / apply(X - t(X) + diag(1, n, n), 1, prod)

	# Distances between nodes and interpolation points
	Y <- outer(x, xi, "-")

	# Identify interpolation points that are nodes
	inds <- which(Y == 0, arr.ind=TRUE)
	Y[inds] <- NA

	# Compute the values of interpolated points
	W <- matrix(rep(wi, each=m), m, n) / Y
	y <- (W %*% yi) / apply(W, 1, sum)

	# Replace with values at corresponding nodes
	y[inds[,1]] <- yi[inds[,2]]

	# Return interpolation values as vector
	return(y[,])
}


barylag2d <- function(F, xn, yn, xf, yf) {
    M  <- nrow(F);     N <- ncol(F)
    Mf <- length(xf); Nf <- length(yf)

    # Compute weights
    X  <- matrix(xn, M, 1) %x% matrix(1, 1, M)  # Kronecker product
    Y  <- matrix(yn, N, 1) %x% matrix(1, 1, N)
    Wx <- t(1 / apply(X - t(X) + diag(1, M, M), 1, prod)) %x% matrix(1, Mf, 1)
    Wy <- t(1 / apply(Y - t(Y) + diag(1, N, N), 1, prod)) %x% matrix(1, Nf, 1)

    # Distances between nodes and interpolation points
    xdist <- matrix(xf, Mf, 1) %x% matrix(1,  1, M) -
             matrix(xn,  1, M) %x% matrix(1, Mf, 1)
    ydist <- matrix(yf, Nf, 1) %x% matrix(1,  1, N) -
             matrix(yn,  1, N) %x% matrix(1, Nf, 1)
             
    # Identify interpolation points that are nodes
    eps <- .Machine$double.eps
    xdist[xdist == 0] <- eps
    ydist[ydist == 0] <- eps  # Thanks to Greg von Winckel for this trick !

    Hx <- Wx / xdist
    Hy <- Wy / ydist

    Hx %*% F %*% t(Hy) /
        ( (matrix(apply(Hx, 1, sum), Mf, 1) %x% matrix(1, 1, Nf)) *
          (matrix(apply(Hy, 1, sum), 1, Nf) %x% matrix(1, Mf, 1)) )
}

##
##  s e m i l o g . R
##


semilogx <- function(x, y, ...) {
    plot(x, y, log = "x", ...)
    grid()
}


semilogy <- function(x, y, ...) {
    plot(x, y, log = "y", ...)
    grid()
}


loglog <- function(x, y, ...) {
    plot(x, y, log = "xy", ...)
    grid()
}

##
##  r a n d o r t h o . R  Generate Random Orthogonal Matrix
##


randortho <- function(n, type = c("orthonormal", "unitary")) {
    stopifnot(is.numeric(n), length(n) == 1,
              floor(n) == ceiling(n), n >= 1)
    if (n == 1) 
        return(matrix(1, 1, 1))
    
    type <- match.arg(type)
    if (type == "orthonormal") {
        z <- randn(n, n) / sqrt(2.0)
    } else {
        z <- (randn(n, n) + 1i * randn(n, n)) / sqrt(2.0)
    }
    
    # QR decomposition for real or complex matrices
    Z <- qr(z)
    q <- qr.Q(Z); r <- qr.R(Z)
    
    d <- diag(r)
    ph <- d/abs(d)
    q %*% diag(ph)
}

##
##  r i d d e r s . R  Ridders' Method
##


ridders <- function(fun, a, b, 
                    maxiter = 500, tol = 1e-12, ...) {
    # (!is.numeric(a) && !is.complex(a) && !is(a,"mpfr") ||
    #  !is.numeric(b) && !is.complex(b) && !is(b,"mpfr"))
    #     stop("Arguments 'a' and 'b' must be numeric, complex, or mpfr.")
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

	x1 <- a;      x2 <- b
	f1 <- f(x1);  f2 <- f(x2)
	if (f1*f2 >= 0) stop("f(a) and f(b) must have different signs.")

    niter <- 2
    while(abs(x1 - x2) > tol && niter < maxiter) {
        xm <- (x1 + x2)/2;  fm <- f(xm)
        if (fm == 0)
            return(list(root = xm, f.root = 0, niter = niter, estim.prec = 0))

        x3 <- xm + (xm - x1) * sign(f1 - f2) * fm / sqrt(fm^2 - f1 * f2)
        f3 <- f(x3);  niter <- niter + 2
        if (f3 == 0)
            return(list(root = x3, f.root = 0, niter = niter, estim.prec = 0))

        if (fm * f3 < 0) {
            x1 <- xm;  f1 <- fm
            x2 <- x3;  f2 <- f3
        } else if (f1 * f3 < 0) {
            x2 <- x3;  f2 <- f3
        } else if (f2 * f3 < 0) {
            x1 <- x3;  f1 <- f3
        } else {
            stop("Inform the maintainer: you should never get here.")
        }
     }

    if (abs(f1) < abs(f2)) {
        x0 <- x1;  f0 <- f1
    } else {
        x0 <- x2;  f0 <- f2
    }
    ep <- abs(x1 - x2)
    return(list(root = x0, f.root = f0, niter = niter, estim.prec = ep))
}

###
### ROOTS.R  Matlab ROOTS Function
###

roots <- function(p) {
    if (is.null(p) || length(p) == 0) return(matrix(0, nrow=0, ncol=0))
    if ( !is.vector(p, mode="numeric") &&
         !is.vector(p, mode="complex") )
        stop("Argument p must be a vector of real or complex numbers.")
    if (length(p) == 1) return(matrix(0, nrow=0, ncol=0))

    # Find non-zero entries in p
    inz <- which(p != 0)
    nnz <- length(inz)
    if (nnz == 0) return(c())

    # Strip leading and trailing zeros, but remember the trailing zeros
    q <- p[inz[1]:inz[nnz]]
    r <- rep(0, length(p) - inz[nnz])

    A <- compan(q)
    return(c(r, eig(A)))
}


# Greatest common factor/divisor of polynomials
polygcf <- function(p, q, tol=1e-12) {
    if ( !is.vector(p, mode="numeric") && !is.vector(p, mode="complex") )
        stop("Arguments 'p' must be a real or complex vector.")
    if ( !is.vector(q, mode="numeric") && !is.vector(q, mode="complex") )
        stop("Arguments 'q' must be a real or complex vector.")
    
    np <- Norm(p)
    pd <- polydiv(p,q)
    a <- pd$d; r0 <- pd$r
    if (Norm(r0) > np*tol) {
        pd <- polydiv(q,r0)
        a <- pd$d; r1 <- pd$r
        if (Norm(r1) > np*tol) {
            rn <- 1
            while (Norm(rn) > np*tol) {
                pd <- polydiv(r0,r1)
                a <- pd$d; rn <- pd$r
                r0 <- r1
                r1 <- rn
            }
            g <- r0
        } else {
            g <- r0
        }
    } else {
        g <- q
    }
    # g <- g / g[1]
    return(g)
}


# Determine multiplicity of polynomial roots
rootsmult <- function(p, r, tol=1e-12) {
    np <- Norm(p)
    v <- abs(polyval(p, r))
    if (v > np*tol) {
        warning("Value 'r' is not root of polynomial 'p'.")
        return(0)
    } else {
        n <- 0
        while (v < np*tol) {
            p <- polyder(p)
            v <- abs(polyval(p,r))
            n <- n+1
        }
        return(n)
    }
}


# Find the multiplicity of all roots of a polynomial
polyroots <- function(p, ntol = 1e-04, ztol = 1e-08) {
    stopifnot(is.numeric(p))
    
    # Multiplicity of 0 as root
    wp <- which(p != 0)
    minp <- min(wp); maxp <- max(wp)
    mz <- length(p) - maxp
    p0 <- p[minp:maxp]
    zp <- zm <- c()
    if (mz > 0)  {zp <- c(zp, 0); zm <- c(zm, mz)}
    if (length(p0) < 2) return(data.frame(root = zp, mult = zm))
    
    s <- abs(p0[length(p0)] / p0[1])
    if (s < 1)  p0 <- p0[length(p0):1]
    
    q0 <- polyder(p0)
    g1 <- p0 / p0[1]
    g2 <- q0[1:max(which(q0 != 0))] / q0[1]
    
    for (k in 3:(2*length(p0))) {
        l12 <- length(g1) - length(g2); l21 <- -l12
        g3 <- c(g2, zeros(1, l12)) - c(g1, zeros(1, l21))
        wh <- which(abs(g3) > ztol)
        g3 <- if (isempty(wh)) c(0) else g3[min(wh):max(wh)]
        ren <- Norm(g3, Inf) / Norm(g2, Inf)
        if (ren < ntol) break
        if(l12 >= 0)  g1 <- g2
        g2 <- g3 / g3[1]
    }
    
    g0 <- g1
    u0 <- deconv(p0, g0)$q
    v0 <- deconv(q0, g0)$q
    w0 <- polyder(u0)
    z0 <- roots(u0)
    m0 <- polyval(v0, z0) / polyval(w0, z0)
    if (s < 1) z0 <- z0^-1
    
    zp <- c(zp, z0); zm <- c(zm, round(abs(m0)))
    return(data.frame(root = zp, mult = zm))
}

##
##  i n v . R  matrix inverse
##


inv <- function(a) {
	if (length(a) == 0) return(matrix(0, nrow=0, ncol=0))
	if ((!is.numeric(a) && !is.complex(a)) || !is.matrix(a))
		stop("Argument 'a' must be a numeric or complex matrix.")
	if (nrow(a) != ncol(a))
		stop("Matrix 'a' must be square.")

	e <- try(b <- solve(a), silent=TRUE)
	if(inherits(e, "try-error")) {
		warning("Matrix appears to be singular.")
		b <- rep(Inf, length(a))
		dim(b) <- dim(a)
	}
	return(b)
}

##
##  f r a c t a l c u r v e . R  Fractal curves
##


fractalcurve <- function(n, which = c("hilbert", "sierpinski", "snowflake",
                "dragon", "triangle", "arrowhead", "flowsnake", "molecule"))
{
     curve <- match.arg(which)
     if (curve == "hilbert") {  # Hilbert curve
         a <- 1 + 1i
         b <- 1 - 1i
         z <- 0
         for (k in 1:n) {
             w <- 1i * Conj(z)
             z <- c(w-a, z-b, z+a, b-w) / 2.0
         }

     } else if (curve == "sierpinski") {  # Sierpinski Cross curve
         a <- 1 + 1i
         b <- 1 - 1i
         c <- 2 - sqrt(2)
         z <- c
         for (k in 1:n) {
             w <- 1i * z
             z <- c(z+b, w+b, a-w, z+a) / 2.0
         }
         z <- c(z, 1i*z, -z, -1i*z, z[1])

     } else if (curve == "snowflake") {  # Koch snowflake
         a <- 1/2 + sqrt(-3+0i)/6; b <- 1 - a
         c <- 1/2 + sqrt(-3+0i)/2; d <- 1 - c
         z <- 1
         for (k in 1:n) {
             z <- Conj(z)
             z <- c(a*z, b*z+a)
         }
         z <- c(0, z, 1-c*z, 1-c-d*z)

     } else if (curve == "dragon") {  # Dragon curve
         a <- (1 + 1i)/2
         b <- (1 - 1i)/2
         c <- sqrt(1/2 + 0i)
         z <- c(1-c, c)
         for (k in 1:n) {
             w <- rev(z)  # z(end:-1:1);
             z <- c(a*z, 1-b*w)
         }

     } else if (curve == "triangle") {  # Sierpinski Triangle curve
         a <- (1 + sqrt(-3+0i))/2
         z <- c(0, 1)
         for (k in 1:n) {
             z <- c(z, z+a, z+1)/2
         }
         z <- c(z, a, 0)

     } else if (curve == "arrowhead") {  # Sierpinski Arrowhead curve
         a <- (1 + sqrt(-3+0i))/2
         b <- (1 - sqrt(-3+0i))/2
         z <- 0
         for (k in 1:n) {
             w <- Conj(z)
             z <- c(a*w, z+a, b*w+a+1)/2
         }
         z <- c(z, 1)

     } else if (curve == "flowsnake") {  # Gosper Flowsnake curve
         a <- (1 + sqrt(-3+0i))/2
         b <- (1 - sqrt(-3+0i))/2
         c <- c(1, a, -b, -1, -a, b)
         u = 0;
         for (k in 1:n) {
             v <- rev(u)
             u <- c(u, v+1, v+3, u+2, u, u, v-1)
         }
         u <- mod(u, 6)
         z <- cumsum(c[u+1])
         z <- c(0, z/7^(n/2))

     } else if (curve == "molecule") {  # Hexagon Molecule curve
         a <- (1 + sqrt(-3+0i))/2
         b <- (1 - sqrt(-3+0i))/2
         c <- c(1, a, -b, -1, -a, b)
         u <- 0
         for (k in 1:n) {
             u <- c(u+1, -u, u-1)
         }
         u <- c(u, 1-u, 2+u, 3-u, 4+u, 5-u)
         u <- mod(u, 6)
         z <- cumsum(c[u+1])
         z <- c(0, z/2^n)

     } else {
         stop("Unknown fractal curve name ...")
     }
     return(list(x = Re(z), y = Im(z)))
}

##
##  f m i n b n d . R  Brent's Minimization Algorithm
##


fminbnd <- function(f, a, b, maxiter = 1000, maximum = FALSE,
                    tol = 1e-07, rel.tol = tol, abs.tol = 1e-15, ...) {
    stopifnot(is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1)
    if (a >= b)
        stop("Interval end points must fulfill  a < b !")
    
    fun <- match.fun(f)
    if (maximum)
        f <- function(x) -fun(x, ...)
    else
        f <- function(x)  fun(x, ...)
    
    # phi is the square of the inverse of the golden ratio.
    phi <- 0.5 * ( 3.0 - sqrt ( 5.0 ) )

    xl <- a; xu <- b
    xmin <- xl + phi*(xu-xl)
    fmin <- f(xmin)
    nfeval   <- 1
    
    step <- step2 <- 0.0

    xmin1 <- xmin; fmin1 <- fmin
    xmin2 <- xmin; fmin2 <- fmin

    converged <- FALSE
    iter <- 0
    while (iter < maxiter) {
        pp <- qq <- 0.0

        tolx <- rel.tol * abs(xmin) + abs.tol

        xm = (xu+xl)/2

        if (abs(xmin - xm) <= 2*tolx - (xu-xl)/2) {
            converged <- TRUE
            break
        }

        iter <- iter + 1
        
        if (abs(step2) > tolx) {
            rr <- (xmin - xmin1) * (fmin - fmin2)
            qq <- (xmin - xmin2) * (fmin - fmin1)
            pp <- (xmin - xmin2) * qq - (xmin - xmin1) * rr
            qq <- 2*(qq - rr)

            if (qq > 0) {
                pp <- -pp
            } else {
                qq <- -qq
            }
        }

        if (abs(pp) < abs(qq*step2/2) && pp < qq*(xu-xmin) && pp < qq*(xmin-xl)) {
            step2 <- step
            step <- pp/qq

            xtemp <- xmin + step
            if ((xtemp - xl) < 2*tolx || (xu - xtemp) < 2*tolx) {
                step <- if (xmin < xm) tolx else -tolx
            }
        } else {
            step2 <- if (xmin < xm) xu - xmin else xl - xmin
            step <- phi * step2
        }

        if (abs(step) >= tolx) {
            xnew <- xmin + step
        } else {
            xnew <- xmin + (if (step > 0) tolx else -tolx)
        }

        fnew <- f(xnew)
        nfeval <- nfeval + 1

        if (fnew <= fmin) {
            if (xnew < xmin) {
                xu <- xmin
            } else {
                xl <- xmin
            }
            xmin2 <- xmin1; fmin2 <- fmin1
            xmin1 <- xmin;  fmin1 <- fmin
            xmin  <- xnew;  fmin <- fnew
        } else {
            if (xnew < xmin) {
                xl <- xnew
            } else {
                xu <- xnew
            }
            if (xnew <= xmin1 || xmin1 == xmin) {
                xmin2 = xmin1; fmin2 = fmin1
                xmin1 = xnew;  fmin1 = fnew
            } else if (xnew <= xmin2 || xmin2 == xmin || xmin2 == xmin1) {
                xmin2 <- xnew; fmin2 <- fnew
            }
        }
    }
    return(list(xmin = xmin, fmin = fmin,
                niter = iter, estim.prec = abs(step)))
}


# fminbnd <- function(f, a, b, ..., maxiter = 1000, maximum = FALSE,
#                     tol = .Machine$double.eps^(2/3)) {
#     stopifnot(is.numeric(a), length(a) == 1,
#               is.numeric(b), length(b) == 1)
#     if (a >= b)
#         stop("Interval end points must fulfill  a < b !")
# 
#     fun <- match.fun(f)
#     if (maximum)
#         f <- function(x) -fun(x, ...)
#     else
#         f <- function(x)  fun(x, ...)
# 
#     # phi is the square of the inverse of the golden ratio.
#     phi <- 0.5 * ( 3.0 - sqrt ( 5.0 ) )
# 
#     # Set tolerances
#     tol1 <- 1 + eps()
#     eps0 <- sqrt(eps())
#     tol3 <- tol / 3
# 
#     sa <- a; sb <- b
#     x  <- sa + phi * ( b - a )
#     fx <- f(x)
#     v  <- w  <- x
#     fv <- fw <- fx
#     e  <- 0.0;
# 
#     niter <- 1
#     while ( niter <= maxiter ) {
#         xm <-  0.5 * ( sa + sb )
#         t1 <- eps0 * abs ( x ) + tol/3
#         t2 <-  2.0 * t1
# 
#         #  Check the stopping criterion.
#         if ( abs ( x - xm ) <= t2 - (dx <- ( sb - sa ) / 2 ) ) break
# 
#         r <- 0.0
#         p <- q <- r
# 
#         # Fit a parabola.
#         if ( t1 < abs ( e ) ) {
#             r <- ( x - w ) * ( fx - fv )
#             q <- ( x - v ) * ( fx - fw )
#             p <- ( x - v ) * q - ( x - w ) * r
#             q <- 2.0 * ( q - r );
#             
#             if ( 0.0 < q ) p <- - p
#             
#             q <- abs ( q )
#             r <- e
#             e <- d
#         }
# 
#         # Is the parabola acceptable
#         if ( abs ( p ) < abs ( 0.5 * q * r ) &&
#                  q * ( sa - x ) < p          &&
#                  p < q * ( sb - x ) ) {
#              #  Take the parabolic interpolation step.
#              d <- p / q
#              u <- x + d
# 
#              #  F must not be evaluated too close to a or b.
#              if ( ( u - sa ) < t2 | ( sb - u ) < t2 ) {
#                  d <- if (x < xm) t1 else -t1
#              }
# 
#          } else {
#          #  A golden-section step.
#             e <- if (x < xm) sb - x else a - x
#             d <- phi * e
#         }
# 
#         #  F must not be evaluated too close to X.
#         if ( t1 <= abs ( d ) ) {
#             u = x + d
#         } else if ( 0.0 < d ) {
#             u = x + t1
#         } else {
#             u = x - t1
#         }
# 
#         fu = f ( u )
# 
#         #  Update a, b, v, x, and x.
#         if ( fu <= fx ) {
#             if ( u < x ) sb <- x
#             else         sa <- x
#         
#             v <- w; fv <- fw
#             w <- x; fw <- fx
#             x <- u; fx <- fu
# 
#         } else {
#             if ( u < x ) sa <- u
#             else         sb <- u
# 
#             if ( fu <= fw || w == x ) {
#                 v <- w; fv <- fw
#                 w <- u; fw <- fu
#             } else if ( fu <= fv || v == x || v== w ) {
#                 v <- u; fv <- fu
#             }
#         }
#         niter <- niter + 1
# 
#     } #endwhile
# 
#     if (niter > maxiter)
#         warning("No. of max. iterations exceeded; no convergence reached.")
# 
#     if (maximum) fx <- -fx
#     return( list(xmin = x, fmin = fx, niter = niter, estim.prec = dx) )
# }

###
### m a g i c . R -- Create a Magic Square
###


magic <- function(n) {
    if (!is.numeric(n)) {
        stop("Argument 'n' must be numeric.")
    } else if (!(length(n) == 1)) {
        stop("Argument 'n' must be of length 1.")
    }

    oddOrder <- function(n) {
        J <- matrix(rep(1:n, each = n),  n, n)
        I <- matrix(rep(1:n, times = n), n, n)
        A <- (I + J - (n + 3) / 2) %% n
        B <- (I + 2 * J - 2) %% n
        M <- n * A + B + 1;

        return(M)
    }

    doublyEvenOrder <- function(n) {
        J <- matrix(rep(1:n, each = n),  n, n)
        I <- matrix(rep(1:n, times = n), n, n)
        K <- trunc((I %% 4) / 2) == trunc((J %% 4) / 2)
        M <- t(matrix(1:(n*n), n, n))
        # M <- t(pracma::Reshape(as.matrix(1:(n * n)), n, n))
        M[K] = n * n + 1 - M[K]

        return(M)
    }

    singlyEvenOrder <- function(n) {
        p <- n / 2
        M <- magic(p)
        M <- rbind(cbind(M, M + 2 * p ^ 2),
                   cbind(M + 3 * p ^ 2, M + p ^ 2))
        if (!(n == 2)) {
            i <- t(1:p)
            k <- (n - 2) / 4
            j <- c(1:k, if ((n - k + 2) <= n) (n - k + 2):n)
            M[cbind(i, i + p), j] <- M[cbind(i + p, i), j]
            i <- k + 1
            j <- c(1, i)
            M[cbind(i, i + p), j] <- M[cbind(i + p, i), j]
        }

        return(M)
    }

    n <- floor(n)
    M <- if (n <= 0) {
             matrix(numeric(0), 0, 0)       # degenerate
         } else if (n == 1) {
             matrix(as.numeric(1), 1, 1)    # degenerate
         } else {
             if (pracma::mod(n, 2) == 1) {
                 oddOrder(n)
             } else if (pracma::mod(n, 4) == 0) {
                 doublyEvenOrder(n)
             } else {
                 singlyEvenOrder(n)
             }
         }

    if (n == 2)                             # impossible
        warning("There is no magic square of order 2.")
    return(M)
}

##
##  r o m b e r g . R  Romberg Integration
##


romberg <- function(f, a, b, maxit = 25, tol = 1e-12, ...)
{
    stopifnot(is.numeric(a), is.numeric(b), length(a) == 1, length(b) == 1)
    tol <- abs(tol)
    if (a == b) return(list(value = 0, iter = 0, rel.error = 0))
    if (a > b)  return(-1 * romberg(f, b, a, tol = tol, ...))

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    eps <- .Machine$double.eps
    if (!is.finite(f(a))) a <- a + eps * sign(b-a)
    if (!is.finite(f(b))) b <- b - eps * sign(b-a)

    I <- matrix(0, nrow = maxit+1, ncol = maxit+1)
    n <- 1; iter <- 0; err <- 1.0
    while (err > tol && iter < maxit) {
        iter <- iter+1

        # inner trapezoid rule with correction term
        n <- 2 * n
        h <- (b-a) / n
        S <- f(a)
        for (i in 1:(n-1)) {
            xi <- a + h * i
            S <- S + 2*f(xi)
        }
        S <- (S + f(b)) * h/2
        # S <- S - ((f(b)-f(xi)) - (f(a+h)-f(a))) * h/12.0  # truncation errors
        I[iter+1, 1] <- S

        # Richardson approximation
        for (k in 2:(iter+1)) {
            j <- 2+iter-k
            I[j,k] <- (4^(k-1)*I[j+1,k-1] - I[j,k-1]) / (4^(k-1)-1)
        }
        err <- abs(I[1,iter+1] - I[2,iter])
    }

    if (iter == maxit)
        warning("Maximum number of iterations has been reached.")

    return(list(value = I[1, iter+1], iter = iter, rel.error = err))
}

##
##  n u m d e r i v . R  Richardson Numerical Derivative
##


numderiv <- function(f, x0, maxiter = 16, h = 1/2, ...,
                        tol = .Machine$double.eps)
{
    if (length(x0) != 1 || !is.numeric(x0))
        stop("Argument 'x0' must be a numeric scalar.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    if (length(f(x0)) != 1)
        stop("Function 'f' must be a univariate function of one variable.")

    eps <- .Machine$double.eps
    err <- 1; err_new <- 1

    j <- 1
    D <- matrix(0, nrow = maxiter, ncol = maxiter)

    D[1, 1] <- (f(x0+h) - f(x0-h))/(2*h)
    while (err > tol && j < maxiter) {
        h <- h / 2.0
        D[j+1, 1] <- (f(x0+h) - f(x0-h)) / (2*h)
        for (k in 1:j) {
            D[j+1, k+1] <- D[j+1, k] + (D[j+1,k] - D[j,k]) / (4^k - 1)
        }

        err_new <- 2 * abs(D[j+1,j+1] - D[j,j]) / 
                  (abs(D[j+1,j+1]) + abs(D[j,j]) + eps)
        if (err_new >= err) break

        err <- err_new
        j <- j + 1
    }
    if (j >= maxiter)
        warning("Maximum number of iterations reached.")

    return(list(df = D[j, j], rel.err = err, niter = j))
}


numdiff <- function(f, x, maxiter = 16, h = 1/2, ...,
                    tol = .Machine$double.eps) {
    if (!is.vector(x, mode = "numeric"))
        stop("Argument 'x' must be a numeric vector.")

    ndf <- function(xx) numderiv(f, xx, maxiter = maxiter, h = h, ...,
                                 tol = .Machine$double.eps)$df

    sapply(x, ndf)
}

ode23s <- function(f, t0, tfinal, y0, jac = NULL, ...,
            rtol = 1e-03, atol = 1e-06, hmax = 0.0) {
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1,
              is.numeric(tfinal), length(tfinal) == 1)
    if (t0 >= tfinal)
        warning("'t0 >= tfinal' may lead to incorrect behavior or results.")

    if (is.vector(y0)) {
        y0 <- as.matrix(y0)
    } else if (is.matrix(y0)) {
        if (ncol(y0) != 1)
            stop("Argument 'y0' must be a vector or single column matrix.")
    }

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)
    if (length(f(t0, y0)) != length(y0))
        stop("Argument 'f' does not describe a system of equations.")

    n <- length(y0); m <- length(f(t, y0))
    # use finite difference Jacobian
    if (is.null(jac)) {
        jac <- function(t, x) {
            jacob <- matrix(NA, m, n)
            hh <- numeric(n); heps <- 5e-06
            for (i in 1:n) {
                hh[i] <- heps
                jacob[, i] <- (f(t, x+hh) - f(t, x-hh)) / (2*heps)
                hh[i] <- 0
            }
            jacob
        }
    }

    # Set initial parameters
    d <- 1/(2 + sqrt(2))
    cc <- 1/2
    e32 <-  6 + sqrt(2)

    t <- t0
    tdir <- sign(tfinal - t)

    h <- tdir * 0.01 * (tfinal - t)
    if (hmax == 0.0)
        hmax <- 0.1 * abs(tfinal - t)
    hmin <- min(16 * eps(tfinal - t), h)

    y <- as.matrix(y0)
    tout <- c(t)
    yout <- c(y)

    # Main loop
    while (abs(t) < abs(tfinal) && hmin < abs(h)) {
        if (abs(t - tfinal) < abs(h))
            h <- tfinal - t

        J <- jac(t, y)

        # approximate time-derivative of f
        T <- (f(t + 0.01*h, y) - f(t, y)) / (0.01*h)

        # Wolfbrandt coefficient
        W <- eye(length(y0)) - h * d * J

        # modified Rosenbrock formula
        F1 <- f(t, y)
        k1 <- qr.solve(W, F1 + h * d * T)
        F2 <- f(t + cc * h, y + cc * h * k1)
        k2 <- qr.solve(W, F2 - k1) + k1

        # 2nd and 3rd order estimates
        ynew <- y + h * k2
        F3 = f(t + h, ynew)
        k3 = qr.solve(W, (F3 - e32*(k2 - F2) - 2*(k1 - F1) + h*d*T))

        # estimate error and acceptable error
        err <- h/6 * Norm(k1 - 2*k2 + k3)
        tau <- max(rtol * max(Norm(y),Norm(ynew)), atol)

        # check if new solution is acceptable
        if (err <= tau) {
            t <- t + h
            tout <- c(tout, t)
            y <- ynew
            yout <- cbind(yout, y)
            if (err == 0) err <- eps()/2
            # h <- min(hmax, 1.25*h)
        } else {
            if (h <= hmin)
                warning("ode23s: Requested step size too small!")
            # h <- max(hmin, 0.5*h)
        }
        # update the step size
        h <- tdir * min(hmax, abs(h)*0.8*(tau/err)^(1/3))
        if (abs(h) > hmax)
            h <- sign(h)*hmax
    }
    return(list(t = c(tout), y = t(yout)))
}

##
##  f i n d z e r o s . R  Find all roots or minima
##


findzeros <- function(f, a, b, n = 100, tol = .Machine$double.eps^(2/3), ...) {
    stopifnot(is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1,
              is.numeric(n), floor(n) == ceiling(n), n >= 2)
    if (! a < b)
        stop("Left interval border must be smaller than right one.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

	h <- (b - a) / n
	x <- seq(a, b, by = h)  # length(x) == n+1
	y <- f(x)

    R <- c()
    s <- sign(f(x[1]))
    if (abs(f(x[1])) < tol) {
        R <- c(x[1])
        s <- 0
    }

	for (i in 2:n) {
	    si <- sign(f(x[i]))
	    if (abs(f(x[i])) < tol) {
	        R <- c(R, x[i])
	        si <- 0
	    } else if (s * si < 0) {  # function values have different sign, != 0
		    u <- uniroot(f, c(x[i-1], x[i]))
		    R <- c(R, u$root)
		} else if (s * si > 0) {  # function values both positive or negative
		    xm <- (x[i-1] + x[i])/2
		    ym <- f(xm)
		    d <- (y[i] - y[i-1])/h
		    if (d == 0) next
		    xv <- xm - ym/d
		    if (xv > x[i-1] && xv < x[i]) {
		        if (s > 0) {
		            s <- optimize(f, c(x[i-1], x[i]), tol = tol)
		            sm <- s$minimum
	            } else {
	                s <- optimize(f, c(x[i-1], x[i]), maximum = TRUE, tol = tol)
	                sm <- s$maximum
	            }
		        if (abs(s$objective) < tol)
		            R <- c(R, sm)
		    }
		}
		s <- si
	}
    if (abs(f(x[n+1])) < tol)
        R <- c(R, x[n+1])

	return(R)
}


findmins <- function(f, a, b, n = 100, tol = .Machine$double.eps^(2/3), ...) {
    stopifnot(is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1,
              is.numeric(n), floor(n) == ceiling(n), n >= 2)
    if (! a < b)
        stop("Left interval border must be smaller than right one.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

	h <- (b - a) / n
	x <- seq(a, b, by = h)  # length(x) == n+1

    R <- c()

    for (i in 2:(n-1)) {
        if ( (f(x[i]) - f(x[i-1]) < 0) && (f(x[i+1]) - f(x[i])) > 0 ) {
            o <- optimize(f, c(x[i-1], x[i+1]))
            R <- c(R, o$minimum)
        }
    }

    return(R)
}

##
##  p r o c r u s t e s . R  Procrustes Problem
##


procrustes <- function(A, B) {
    stopifnot(is.numeric(A), is.numeric(B))
    if (!is.matrix(A) || !is.matrix(B))
        stop("Arguments 'A' and 'B' must be numeric matrices.")
    if (any(dim(A) != dim(B)))
        stop("Matrices 'A' and 'B' must be of the same size.")

    C <- t(B) %*% A

    Svd <- svd(C)                       # singular value decomposition
    U <- Svd$u
    S <- diag(Svd$d)
    V <- Svd$v

    Q <- U %*% t(V)
    P <- B %*% Q

    R <- A - P;
    r <- sqrt(Trace(t(R) %*% R))        # Frobenius norm: Norm(A - P)
    return(list(P = P, Q = Q, d = r))
}


kabsch <- function(A, B, w = NULL) {
    stopifnot(is.numeric(A), is.numeric(B))
    if ( !is.matrix(A) || !is.matrix(B) )
        stop("Arguments 'A' and 'B' must be numeric matrices.")
    if ( any(dim(A) != dim(B)) )
        stop("Matrices 'A' and 'B' must be of the same size.")

    D <- nrow(A)    # space dimension
    N <- ncol(A)    # number of points
    if (is.null(w)) {
        w <- matrix(1/N, nrow = N, ncol = 1)    # weights as column vector
    } else {
        if (!is.numeric(w) || length(w) != N)
            stop("Argument 'w' must be a (column) vector of length ncol(A).")
    }

    p0 <- A %*% w           # the centroid of A
    q0 <- B %*% w           # the centroid of B
    v1 <- ones(1,N)         # row vector of N ones
    A  <- A - p0 %*% v1     # translating A to center the origin
    B  <- B - q0 %*% v1     # translating B to center the origin

    Pdm <- zeros(D,N)
    for (i in 1:N) Pdm[, i] <- w[i] * A[, i]
    C <- Pdm %*% t(B) 	
    
    Svd <- svd(C)           # singular value decomposition
    V <- Svd$u
    S <- diag(Svd$d)
    W <- Svd$v

    I <- eye(D)
    # more numerically stable than using (det(C) < 0)
    if (det(V %*% t(W)) < 0) I[D, D] <- -1

    U <- W %*% I %*% t(V)
    R <- q0 - U %*% p0

    Diff <- U %*% A - B     # A, B already centered
    lrms <- 0
    for (i in 1:N) lrms <- lrms + w[i] * t(Diff[, i]) %*% Diff[, i]
    lrms <- sqrt(lrms)

    return(list(U = U, R = R, d = lrms))
}

##
##  t r a p z . R  Numerical integration by trapezoidal rule
##


trapz <- function(x, y) {
    if (missing(y)) {
        if (length(x) == 0) return(0)
        y <- x
        x <- seq(along=x)
    }
    if (length(x) == 0 && length(y) == 0) return(0)
    if (!(is.numeric(x) || is.complex(x)) ||
            !(is.numeric(y) || is.complex(y)) )
        stop("Arguments 'x' and 'y' must be real or complex vectors.")
    m <- length(x)
    if (length(y) != m)
        stop("Arguments 'x', 'y' must be vectors of the same length.")
    if (m <= 1) return(0.0)

    # z <- sum((x[2:m] - x[1:(m-1)]) * (y[1:(m-1)] + y[2:m]))
    # return(0.5 * z)

    xp <- c(x, x[m:1])
    yp <- c(numeric(m), y[m:1])
    n <- 2*m
    p1 <- sum(xp[1:(n-1)]*yp[2:n]) + xp[n]*yp[1]
    p2 <- sum(xp[2:n]*yp[1:(n-1)]) + xp[1]*yp[n]

    return(0.5*(p1-p2))
}


cumtrapz <- function(x, y) {
    if (missing(y)) {
        if (length(x) == 0) return(0)
        y <- x
        x <- 1:length(x)
    }
    if (length(x) == 0) return(0)
    if (!(is.numeric(x) || is.complex(x)) ||
        !(is.numeric(y) || is.complex(y)))
        stop("Arguments 'x' and 'y' must be real or complex.")

    x <- as.matrix(c(x))
    m <- length(x)
    if (is.vector(y)) y <- as.matrix(y)
    if (nrow(y) != m)
        stop("Arguments 'x' and 'y' are not compatible: nrow(y) != length(x).")

    n  <- ncol(y)
    dt <- repmat(diff(x)/2, 1, n)
    ct <- apply(dt * (y[1:(m-1), ] + y[2:m, ]), 2, cumsum)

    return(rbind(zeros(1, n), ct))
}


trapzfun <- function(f, a, b, maxit = 25, tol = 1e-07, ...) {
    stopifnot(is.numeric(a), length(a) == 1, is.finite(a),
              is.numeric(b), length(b) == 1, is.finite(b))

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (a == b) return(list(area = 0.0, iter = 0, error = 0))
	
    n <- 1
    h <- b - a
    T <- h * (f(a) + f(b)) / 2.0

    for (i in 1:maxit) {
        M <- 0
        for (j in 0:(n-1)) {
            M <- M + f(a + (j + 0.5) * h)
        }
        M <- h * M
        T <- (T + M) / 2.0
        h <- h / 2.0
        n <- 2 * n
        err <- abs(T - M)
        if (err < tol) break
    }

    return(list(value = T, iter = i, rel.err = err))
}

##
##  i t e r s o l v e . R  Iterative Solutions of LSEs
##


itersolve <- function(A, b, x0 = NULL, 
                      nmax = 1000, tol = .Machine$double.eps^(0.5),
                      method = c("Gauss-Seidel", "Jacobi", "Richardson")) {
    stopifnot(is.numeric(A), is.numeric(b))

    n <- nrow(A)
    if (ncol(A) != n)
        stop("Argument 'A' must be a square, positive definite matrix.")
    b <- c(b)
    if (length(b) != n)
        stop("Argument 'b' must have the length 'n = ncol(A) = nrow(A).")
    if (is.null(x0)) {
        x0 <- rep(0, n)
    } else {
        stopifnot(is.numeric(x0))
        x0 <- c(x0)
        if (length(x0) != n)
            stop("Argument 'x0' must have the length 'n=ncol(A)=nrow(A).")
    }

    method <- match.arg(method)

    if (method == "Jacobi") {
        L <- diag(diag(A))
        U <- eye(n)
        beta <- 1; alpha <- 1
    } else if (method == "Gauss-Seidel") {
        L <- tril(A)
        U <- eye(n)
        beta <- 1; alpha <- 1
    } else {  # method = "Richardson"
        L <- eye(n)
        U <- L
        beta <- 0
    }

    b <- as.matrix(b)
    x <- x0 <- as.matrix(x0)
    r <- b - A %*% x0
    r0 <- err <- norm(r, "f")

    iter <- 0
    while (err > tol && iter < nmax) {
        iter <- iter + 1
        z <- qr.solve(L, r)
        z <- qr.solve(U, z)
        if (beta == 0) alpha <- drop(t(z) %*% r/(t(z) %*% A %*% z))
        x <- x + alpha * z
        r <- b - A %*% x
        err <- norm(r, "f") / r0
    }

    return(list(x = c(x), iter = iter, method = method))
}

ratinterp <- function(x, y, xs = x) {
    if (!is.vector(x, mode="numeric") || !is.vector(y, mode="numeric"))
        stop("Arguments 'x' and 'y' must be numeric vectors.")
    m <- length(x)
    if (length(y) != m)
        stop("Arguments 'x' and 'y' must be vectors of the same length.")
    if (m <= 2)
        stop("Arguments 'x', 'y' must have at least a length >= 3.")

    if (is.unsorted(x))
        stop("Argument 'x' must be a sorted vector")
    
    n <- length(xs)
    ys <- numeric(n)
    node_p <- FALSE

    for (h in 1:n) {
        for (i in 1:m) {
            d <- xs[h] - x[i]
            # First stage: xs[h] is data points
            if (d == 0) {
                ys[h] <- y[i]
                node_p <- TRUE
            }
        }

        if (!node_p) {
            # Second stage
            R <- matrix(0, nrow = m, ncol = m)
            R[, 1] <- y
            for (i in 1:(m-1)) {
                D <- R[i+1, 1] - R[i, 1]
                rr <- (xs[h] - x[i]) / (xs[h] - x[i+1])
                denom <- rr * (1 - D/R[i+1, 1]) - 1
                R[i, 2] <- R[i+1, 1] + D/denom
            }

            for (j in 3:m) {
                # Third and next stages
                for (i in 1:(m-j+1)) {
                    D <- R[i+1, j-1] - R[i, j-1]
                    rr <- (xs[h] - x[i]) / (xs[h]- x[i+j-1])
                    if (D == 0) {
                        R[i, j] <- R[i+1, j-1]
                    } else {
                        DD <- R[i+1, j-1] - R[i+1, j-2]
                        denom <- rr * (DD - D) - DD
                        R[i, j] <- R[i+1, j-1] + D * DD / denom
                    }
                }
            }
            ys[h] <- R[1, m]
        }
        node_p <- FALSE
    }
    return(ys)
}

fornberg <- function(x, y, xs, k = 1) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(xs))
    if (any(is.na(y))) {
        inna <- which(!is.na(y))
        x <- x[inna]; y <- y[inna]
    }
    n <- length(x); l <- length(xs)
    if (length(unique(x)) != n)
        stop("All elements in vector 'x' must be different.")
    if (k >= n)
        stop("Length of 'x' must be greater than k.")
    if (k <= 0)
        stop("Order 'k' must be between 1 and length of 'x'.")

    m <- k
    Y <- matrix(NA, nrow = l, ncol = k+1)

    for (ij in 1:l) {
        x0 <- xs[ij]
        c1 <- 1
        c4 <- x[1] - x0
        C <- zeros(n, m+1)
        C[1,1] <- 1
    
        for (i in 1:(n-1)) {
            i1 <- i+1
            mn <- min(i,m)
            c2 <- 1
            c5 <- c4
            c4 <- x[i1] - x0
            for (j in 0:(i-1)) {
                j1 <- j+1
                c3 <- x[i1] - x[j1]
                c2 <- c2*c3
                if (j == i-1) {
                    for (s in mn:1) {
                        s1 <- s+1
                        C[i1,s1] <- c1*(s*C[i1-1,s1-1] - c5*C[i1-1,s1])/c2
                    }
                    C[i1,1] <- -c1*c5*C[i1-1,1]/c2
                }
                for (s in mn:1) {
                    s1 <- s+1
                    C[j1,s1] <- (c4*C[j1,s1] - s*C[j1,s1-1])/c3
                }
                C[j1,1] <- c4*C[j1,1]/c3
            }
            c1 <- c2
        }
        Y[ij, ] <- y %*% C
    }

    if (k == 0) Y <- Y[, 1, drop = FALSE]
    return(Y)
}

##
##  e r r o r f . R  Error functions (Matlab Style)
##


# Error function
erf     <- function(x) {  # 2*pnorm(sqrt(2)*x)-1
    pchisq(2*x^2,1)*sign(x)
}

# Inverse error function
erfinv  <- function(y) {
        y[abs(y) > 1] <- NA
        sqrt(qchisq(abs(y),1)/2) * sign(y)
}

# Complementary error function
erfc    <- function(x) {  # 1 - erf(x)
    2 * pnorm(-sqrt(2) * x)
}

# Inverse complementary error function
erfcinv <- function(y) {
    y[y < 0 | y > 2] <- NA
    -qnorm(y/2)/sqrt(2)
}

# Scaled complementary error function
erfcx   <- function(x) {
    exp(x^2) * erfc(x)
}

# Complex error function
erfz    <- function(z)
{
    if (is.null(z)) return( NULL )
    else if (!is.numeric(z) && !is.complex(z))
        stop("Argument 'z' must be a numeric or complex scalar or vector.")

    a0 <- abs(z)
    c0 <- exp(-z * z)
    z1 <- ifelse (Re(z) < 0, -z, z) 

	i <- a0 <= 5.8
	work.i <- i
	cer <- rep(NA, length = length(z))
    if ( sum(work.i) > 0) {
        cs <- z1
        cr <- cs
        for (k in 1:120) {
            cr[work.i] <- cr[work.i] * z1[work.i] * z1[work.i]/(k + 0.5)
            cs[work.i] <- cs[work.i] + cr[work.i]
            work.i <- work.i & (abs(cr/cs) >= 1e-15)
	    if (sum(work.i) == 0) break
        }
        cer[i] <- 2 * c0[i] * cs[i]/sqrt(pi)
    }
	work.i <- !i
    if( sum(work.i) > 0) {
        cl <- 1/z1
        cr <- cl
        for (k in 1:13) {
            cr[work.i] <- -cr[work.i] * (k - 0.5)/(z1[work.i] * z1[work.i])
            cl[work.i] <-  cl[work.i] + cr[work.i]
            work.i <- work.i & (abs(cr/cl) >= 1e-15)
	    if (sum(work.i) == 0) break
        }
        cer[!i] <- 1 - c0[!i] * cl[!i]/sqrt(pi)
    }
	cer[ Re(z) < 0] <- -cer[ Re(z) < 0]
    return(cer)
}


# Imaginary error function
erfi <- function(z) {
    if (length(z) == 0) return(c())
    else if (length(z) == 1) {
        if (is.na(z))           return(NA)
        else if (z == 0)        return(0.0)
        else if (is.numeric(z)) return(Re(-1i * erfz(1i * z)))
        else if (is.complex(z)) return(-1i * erfz(1i * z))
        else stop("Argument 'z' must be a numeric or complex scalar or vector.")
    } else {
        return(sapply(z, erfi))
    }
}


#-- Error function for real values
# erf <- function(x) {
#     eps <- .Machine$double.eps
#     pi <- 3.141592653589793
#     x2 <- x * x
#     if (abs(x) < 3.5) {
#         er <- 1.0
#         r <- 1.0
#         for (k in 1:50) {
#             r <- r * x2 / (k+0.5)
#             er <- er+r
#             if (abs(r) < abs(er)*eps) break
#         }
#         c0 <- 2.0 / sqrt(pi) * x * exp(-x2)
#         err <- c0 * er
#     } else {
#         er <- 1.0
#         r <- 1.0
#         for (k in 1:12) {
#             r<- -r * (k-0.5) / x2
#             er <- er + r
#         }
#         k <- 12+1
#         c0 <- exp(-x2) / (abs(x) * sqrt(pi))
#         err <- 1.0 - c0 * er
#         if (x < 0.0) err <- -err
#     }
#     return(err) 
# }

#-- Error function for complex values
# erfz <- function(z) {
#     if (is.null(z) || length(z) != 1)
#         stop("Argument 'z' must be single complex value.")
# 
#     a0 <- abs(z);
#     c0 <- exp(-z*z)
# 
#     z1 <- if (Re(z) < 0.0) -z else z
# 
#     if(a0 <=  5.8) {
#         cs <- z1
#         cr <- cs
#         for (k in 1:120) {
#             cr <- cr * z1 * z1 / (k+0.5)
#             cs <- cs + cr
#             if (abs(cr/cs) < 1.0e-15) break
#         }
#         cer <- 2.0 * c0 * cs / sqrt(pi)
# 
#     } else {
#         cl <- 1.0 / z1
#         cr <- cl
#         for (k in 1:13) {
#             cr <- -cr * (k-0.5) / (z1 * z1)
#             cl <- cl + cr
#             if (abs(cr/cl) < 1.0e-15) break
#         }
#         cer <- 1.0 - c0 * cl / sqrt(pi)
#     }
# 
#     if(Re(z)< 0.0) cer <- -cer
# 
#     return(cer)
# }

##
##  h a v e r s i n e . R  Haversine Formula
##


haversine <- function(loc1, loc2, R = 6371.0) {
    if (is.character(loc1)) {
        locs <- strsplit(loc1, ',')[[1]]
        lat1 <- locs[1]; lon1 <- locs[2]
        lat1 <- .check_coords(lat1) * pi / 180
        lon1 <- .check_coords(lon1) * pi / 180
    } else if (is.numeric(loc1)) {
        if (length(loc1) != 2)
            stop("Coordinate input not in correct format.")
        lat1 <- loc1[1]; lon1 <- loc1[2]
        if (abs(lat1) > 90 || abs(lon1) > 180)
            stop("Coordinate input not in correct format.")
        lat1 <- lat1 * pi /180; lon1 <- lon1 * pi / 180
    } else {
        stop("Location must be given as string 'lat lon'.")
    }
    if (is.character(loc2)) {
        locs <- strsplit(loc2, ',')[[1]]
        lat2 <- locs[1]; lon2 <- locs[2]
        lat2 <- .check_coords(lat2) * pi / 180
        lon2 <- .check_coords(lon2) * pi / 180
    } else if (is.numeric(loc2)) {
        if (length(loc2) != 2)
            stop("Coordinate input not in correct format.")
        lat2 <- loc2[1]; lon2 <- loc2[2]
        if (abs(lat2) > 90 || abs(lon2) > 180)
            stop("Coordinate input not in correct format.")
        lat2 <- lat2 * pi /180; lon2 <- lon2 * pi / 180
    } else {
        stop("Location must be given as string 'lat, lon'.")
    }
    # R <- 6371.0  # average earth radius [km]
    dlat <- lat2 - lat1
    dlon <- lon2 - lon1

    # Haversine formula
    a <- sin(dlat/2)^2 + 
         cos(lat1) * cos(lat2) * sin(dlon/2)^2;
    c <- 2 * atan2(sqrt(a), sqrt(1-a))
    return(R * c)
}


.check_coords <- function(s) {
    m <- gregexpr("^\\s*(\\d+)\\s+(\\d+)\\s+(\\d*)\\s*(\\w?)\\s*$",
                  s, perl=TRUE)
    m <- m[[1]]
    if (m[1] != 1) stop("Coordinate input not in correct format.")

    strt <- attr(m, "capture.start")
    lngt <- attr(m, "capture.length")
    c1 <- as.numeric( substr(s, strt[1], strt[1]+lngt[1]-1) )
    c2 <- as.numeric( substr(s, strt[2], strt[2]+lngt[2]-1) )
    c3 <- as.numeric( substr(s, strt[3], strt[3]+lngt[3]-1) )

    c0 <- c1 + c2/60 + c3/3600
    if (c1 > 180 || c2 >= 60 || c3 >= 60)
        stop("Coordinate input not in correct format.")

    c4 <- substr(s, strt[4], strt[4]+lngt[4]-1)
    if (c4 == 'S' || c4 == 'W') {
        c0 <- -1 * c0
    } else if (c4 != 'N' && c4 != 'E') {
        stop("Coordinate input not in correct format.")
    }
    return(c0)
}

##
##  d e v a l . R
##


deval <- function(x, y, xp, idx = NULL) {
    stopifnot(is.vector(x, mode = "numeric"), is.numeric(y),
              is.vector(xp, mode= "numeric"))
    if (is.vector(y)) y <- as.matrix(y)
    if (length(x) != nrow(y))
        stop("Length of 'x' must be equal to the number of rows in 'y'.")
    if (is.unsorted(x))
        stop("Argument vector 'x' must be sorted.")
    if (is.null(idx)) idx <- 1:ncol(y)
    if (! all(idx %in% 1:ncol(y)))
        stop("Indices 'idx' must be between 1 and no. of columns of 'y'.")

    fint <- findInterval(xp, x)
    flen <- length(fint)

    yp <- matrix(NA, nrow = flen, ncol = length(idx))

    for (i in 1:flen) {
        fi <- fint[i]
        if (fi == 0) next
        if (fi < length(x)) {
            yp[i, ] <- y[fi, idx] + 
                       (xp[i] - x[fi])/(x[fi+1] - x[fi]) * (y[fi+1, idx] - y[fi, idx])
        } else {
            if (xp[i] > x[length(x)]) {
                next
            } else {
                yp[i, ] <- y[fi, idx]
            }
        }
    }

    if (flen == 1) yp <- drop(yp)
    return(yp)
}


deeve <- function(x, y, yv = 0, idx = NULL){
    stopifnot(is.vector(x, mode = "numeric"), is.numeric(y),
              is.numeric(yv), length(yv) == 1)
    if (is.vector(y)) y <- as.matrix(y)
    if (is.unsorted(x))
        stop("Argument vector 'x' must be sorted.")
    if (length(x) != nrow(y))
        stop("Length of 'x' must be equal to the number of rows in 'y'.")
    if (is.null(idx)) idx <- ncol(y)
    else if (length(idx) > 1) {
        idx <- idx[1]
        warning("Several indices found; only accepting the first one.")
    }

    y <- y[, idx]
    if (yv < min(y) || yv > max(y))
        return(NA)

    # findInterval() needs nondecreasingly sorted vector
    fint <- findintervals(yv, y)
    flen <- length(fint)
    if (flen == 0) return(c())

    x0 <- numeric(flen)
    for (i in 1:flen) {
        fi <- fint[i]
        if (fi < length(y)) {
            x0[i] <- (yv - y[fi]) / (y[fi+1] - y[fi]) * (x[fi+1] - x[fi]) + x[fi]
        } else {
            x0[i] <- x[fi]
        }
    }

    return(x0)
}

charpoly <- function(a, info = FALSE) {
    stopifnot(is.numeric(a), is.matrix(a))
    n <- nrow(a); m <- ncol(a)
    if (n != m || n < 2)
        stop("Argument 'a' must be a square matrix.")
    if (n > 100)
        cat("The algorithm will be *very* slow for n > 100.\n")

    p <- rep(1, n+1)

    a1 <- a
    for (k in 2:n) {
        p[k] <- -1 * sum(diag(a1))/(k-1)
        if (k == n) a2 <- a1
        a1 <- a %*% (a1 + p[k] * diag(1, n))
    }
    p[n+1] <- -1 * sum(diag(a1))/n

    if (info) {
        adet <- (-1)^n * p[n+1]
        if (adet != 0)
            ainv <- -1 * (a2 + p[n] * diag(1, n))/p[n+1]
        else
            ainv = NaN

        # determine accuracy of the computation
        e <- a2 %*% a + p[n] *a - adet * diag(1, n)
        e <- max(abs(e))
        cat("Error term:", e, "\n")
    }

    if (info) return(list(cp = p, det = adet, inv = ainv))
    else      return(p)
}

##
##  d i a g . R  Matrix diagonal
##


Diag <- function(x, k=0) {
    if (!is.numeric(x) && !is.complex(x))
        stop("Argument 'x' must be a real or complex vector or matrix.")
    if (!is.numeric(k) || k != round(k))
        stop("Argument 'k' must be an integer.")

    # if (length(x) == 1) return(x)
    if (is.matrix(x)) {
        n <- nrow(x); m <- ncol(x)
        if (k >= m || -k >= n) {
            y <- matrix(0, nrow=0, ncol=0)
        } else {
            y <- x[col(x) == row(x) + k]
        }
    } else {
        if (is.vector(x)) {
            n <- length(x)
            m <- n + abs(k)
            y <- matrix(0, nrow=m, ncol=m)
            y[col(y) == row(y) + k] <- x
        } else {
            stop("Argument 'x' must be a real or complex vector or matrix.")
        }
    }
    return(y)
}

##
##  s h u b e r t . R  Shubert-Piyawskii Method
##


shubert <- function(f, a, b, L, crit = 1e-04, nmax = 1000) {
    stopifnot(is.numeric(a), is.numeric(b),
              length(a) == 1, length(b) == 1)
    fun <- match.fun(f); f <- function(x) fun(x)

    nf <- 0
    x0 <- (a + b)/2.0
    y0 <- f(x0); nf <- nf + 1
    xmax <- x0; ymax <- y0
    fmax <- y0 + L*(b - a)/2.0

    X <- numeric(nmax); Z <- numeric(nmax)
    X[1] <- b; Z[1] <- y0 + fmax
    X[2] <- a; Z[2] <- y0 + fmax

    n <- 2
    while ((fmax - ymax) > crit && n < nmax) {
        xn <- X[n]; zn <- Z[n]
        yn <- f(xn); nf <- nf + 1
        if (yn > ymax) {
            xmax <- xn; ymax <- yn
        }
        zL <- (zn + yn)/2.0; zR <- zL
        xL <- xn - (zn - yn)/2.0/L
        xR <- xn + (zn - yn)/2.0/L

        i1 <- 0; i2 <- 0
        if (xL >= a && xL <= b) i1 <- 1
        if (xR >= a && xR <= b) i2 <- 1

        if (i1 == 1 && i2 == 0) {
            X[n] <- xL; Z[n] <- zL
        } else if (i1 == 0 && i2 == 1) {
            X[n] <- xR; Z[n] <- zR
        } else if (i1 == 1 && i2 == 1) {
            X[n] <- xL; Z[n] <- zL
            X[n+1] <- xR; Z[n+1] <- zR
            n <- n + 1
        }
        Zo <- order(Z[1:n])
        Z[1:n] <- Z[Zo]; X[1:n] <- X[Zo]
        fmax <- Z[n]
    }
    return(list(xopt = xmax, fopt = fmax, nopt = n))
}

findpeaks <- function(x,nups = 1, ndowns = nups, zero = "0", peakpat = NULL, 
                      # peakpat = "[+]{2,}[0]*[-]{2,}", 
                      minpeakheight = -Inf, minpeakdistance = 1,
                      threshold = 0, npeaks = 0, sortstr = FALSE)
{
    stopifnot(is.vector(x, mode="numeric") || length(is.na(x)) == 0)
    if (! zero %in% c('0', '+', '-'))
        stop("Argument 'zero' can only be '0', '+', or '-'.")

    # transform x into a "+-+...-+-" character string
    xc <- paste(as.character(sign(diff(x))), collapse="")
    xc <- gsub("1", "+", gsub("-1", "-", xc))
    # transform '0' to zero
    if (zero != '0') xc <- gsub("0", zero, xc)

    # generate the peak pattern with no of ups and downs
    if (is.null(peakpat)) {
        peakpat <- sprintf("[+]{%d,}[-]{%d,}", nups, ndowns)
    }

    # generate and apply the peak pattern
    rc <- gregexpr(peakpat, xc)[[1]]
    if (rc[1] < 0) return(NULL)

    # get indices from regular expression parser
    x1 <- rc
    x2 <- rc + attr(rc, "match.length")
    attributes(x1) <- NULL
    attributes(x2) <- NULL

    # find index positions and maximum values
    n <- length(x1)
    xv <- xp <- numeric(n)
    for (i in 1:n) {
        xp[i] <- which.max(x[x1[i]:x2[i]]) + x1[i] - 1
        xv[i] <- x[xp[i]]
    }

    # eliminate peaks that are too low
    inds <- which(xv >= minpeakheight & xv - pmax(x[x1], x[x2]) >= threshold)

    # combine into a matrix format
    X <- cbind(xv[inds], xp[inds], x1[inds], x2[inds])

    # eliminate peaks that are near by
    if (minpeakdistance < 1)
        warning("Handling 'minpeakdistance < 1' is logically not possible.")

    # sort according to peak height
    if (sortstr || minpeakdistance > 1) {
        sl <- sort.list(X[, 1], na.last = NA, decreasing = TRUE)
        X <- X[sl, , drop = FALSE]
    }

    # return NULL if no peaks
    if (length(X) == 0) return(c())

	# find peaks sufficiently distant
    if (minpeakdistance > 1) {
        no_peaks <- nrow(X)
        badpeaks <- rep(FALSE, no_peaks)

        # eliminate peaks that are close to bigger peaks
        for (i in 1:no_peaks) {
            ipos <- X[i, 2]
            if (!badpeaks[i]) {
                dpos <- abs(ipos - X[, 2])
                badpeaks <- badpeaks | (dpos > 0 & dpos < minpeakdistance)
            }
        }
        # select the good peaks
        X <- X[!badpeaks, , drop = FALSE]
    }

    # Return only the first 'npeaks' peaks
    if (npeaks > 0 && npeaks < nrow(X)) {
        X <- X[1:npeaks, , drop = FALSE]
    }

    return(X)
}

###
### EIG.R  Eigenvalues
###


eig <- function(a) {
    if (length(a) == 0) return(matrix(0, nrow=0, ncol=0))
    if (length(a) == 1) return(a)
    if ((!is.numeric(a) && !is.complex(a)) || !is.matrix(a))
        stop("Argument 'a' must be a numeric or complex matrix.")
    if (nrow(a) != ncol(a))
        stop("Matrix 'a' must be square matrix.")

    eigen(a, only.values=TRUE)$values
}

##
##  q r . R  QR Factorization
##


# Modified Gram-Schmidt process
gramSchmidt <- function(A, tol = .Machine$double.eps^0.5) {
    stopifnot(is.numeric(A), is.matrix(A))
    m <- nrow(A); n <- ncol(A)
    if (m < n)
        stop("No. of rows of 'A' must be greater or equal no. of colums.")

    Q <- matrix(0, m, n)
    R <- matrix(0, n, n)
    for (k in 1:n) {
        Q[, k] <- A[, k]
        if (k > 1) {
            for (i in 1:(k-1)) {
                R[i, k] <- t(Q[, i]) %*% Q[, k]
                Q[ , k] <- Q[, k] - R[i, k] * Q[, i]
            }
        }
        R[k, k] <- Norm(Q[, k])
        if (abs(R[k, k]) <= tol)
            stop("Matrix 'A' does not have full rank.")
        Q[, k] <- Q[, k] / R[k, k]
    }
    return(list(Q = Q, R = R))
}

qrSolve <- function(A, b) {
    stopifnot(is.numeric(A), is.matrix(A), is.numeric(b))
    m <- nrow(A); n <- ncol(A)
    b <- c(b)
    if (m < n || length(b) != m)
        stop("Matrix 'A' and vektor 'b' have non-fitting dimensions.")

    gs <- householder(A)
    Q <- gs$Q; R <- gs$R

    b <- t(Q[, 1:n]) %*% b
    x <- numeric(n)
    x[n] <- b[n] / R[n, n]
    for (k in (n-1):1)
        x[k] <- (b[k] - R[k, (k+1):n] %*% x[(k+1):n]) / R[k, k]
    return(x)
}


# Givens transformation
.givens <- function(xk, xl) {
    if (xl != 0) {
        r <- Norm(c(xk, xl))
        G <- matrix(c(xk, -xl, xl, xk), 2, 2) / r
        x <- as.matrix(c(r, 0))
    } else {
        G <- eye(2)
        x <- as.matrix(c(xk, 0))
    }
    return(list(G = G, x = x))
}

# Givens QR decomposition
givens <- function(A) {  # n >= m
    stopifnot(is.numeric(A), is.matrix(A))
    n <- nrow(A); m <- ncol(A)
    if (n != m)
        stop("Matrix 'A' must be a square matrix.")

    Q <- eye(n)
    for (k in 1:(n-1)) {
        l <- which.max(abs(A[(k+1):n, k])) + k
        if (A[k, k] == 0 && A[l, k] == 0)
            stop("Matrix 'A' does not have full rank.")
        j <- which(A[(k+1):n, k] != 0) + k
        j <- unique(c(l, j[j != 1]))
        for (h in j) {
            gv <- .givens(A[k, k], A[h, k])
            G <- gv$G; x <- gv$x
            Q[c(k, h), ] <- G %*% Q[c(k, h), ]
            A[k, k] <- x[1]
            A[h, k] <- 0
            A[c(k, h), (k+1):m] <- G %*% A[c(k, h), (k+1):m]
        }
    }
    return(list(Q = t(Q), R = triu(A)))
}


# Householder transformation
householder <- function(A) {
    m <- nrow(A); n <- ncol(A)
    Q <- eye(m)
    for (k in 1:min(m-1, n)) {
        ak <- A[k:m, k, drop = FALSE]
        s  <- if (ak[1] >= 0) 1 else -1
        vk <- ak + s * Norm(ak) * c(1, rep(0, m-k))
        vk2 <- c(t(vk) %*% vk)
        Hk <- eye(m-k+1) - 2/vk2 * (vk %*% t(vk))
        if (k == 1) Qk <- Hk
        else        Qk <- blkdiag(eye(k-1), Hk)
        A <- Qk %*% A
        Q <- Q %*% Qk
    }
    return(list(Q = Q, R = A))
}

##
##  h o o k e j e e v e s . R  Hooke-Jeeves Minimization
##


hooke_jeeves <- function(x0, fn, ..., lb = NULL, ub = NULL, tol = 1e-08,
                         maxfeval = 10000, target = Inf, info = FALSE) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")
    n <- length(x0)
    if (n == 1)
        stop("Do not use Hooke-Jeeves for univariate functions.")

    fun <- match.fun(fn)
    f <- function(x) fun(x, ...)

    if (is.null(lb) && is.null(ub)) {
        result <- .hj(x0, f, tol, target, maxfeval, info)
    } else {
        if (is.null(lb)) lb <- -Inf
        if (is.null(ub)) ub <-  Inf
        if(!is.numeric(lb) || !is.numeric(ub))
            stop("Lower and upper limits must be numeric.", call. = FALSE)
        if (length(lb) == 1) lb <- rep(lb, n)
        if (length(ub) == 1) ub <- rep(ub, n)
        if (!all(lb <= ub))
            stop("All lower limits must be smaller than upper limits.", call. = FALSE)
        if (!all(lb <= x0) || !all(x0 <= ub))
            stop("Infeasible starting values -- check limits.", call. = FALSE)
        
        result <- .hjb(x0, f, lb, ub, tol, target, maxfeval, info)
    }

    res <- list(xmin = result$xmin, fmin = result$fmin, 
                count = result$fcalls, convergence = 0,
                info = list(solver = "Hooke-Jeeves", iterations = result$niter))
    return(res)
}


.hj <- function(x0, f, tol, target, maxfeval, info) {
    n = length(x0)
    #-- Setting steps and stepsize -----
    nsteps <- floor(log2(1/tol))        # number of steps
    steps  <- 2^c(-(0:(nsteps-1)))      # decreasing step size
    dir <- diag(1, n, n)                # orthogonal directions

    x <- x0                             # start point
    fx <- fbest <- f(x)                 # smallest value so far
    fcount <- 1                         # counts number of function calls

    if (info) cat("step\tnofc\tfmin\txpar\n")   # info header

    #-- Start the main loop ------------
    ns <- 0
    while (ns < nsteps && fcount < maxfeval && abs(fx) < target) {
        ns <- ns + 1
        hjs    <- .hjsearch(x, f, steps[ns], dir, fcount, maxfeval, target)
        x      <- hjs$x
        fx     <- hjs$fx
        sf     <- hjs$sf
        fcount <- fcount + hjs$finc

        if (info)
            cat(ns, "\t",  fcount, "\t", fx, "\t", x[1], "...\n")
    }

    if (fcount > maxfeval) {
        warning("Function evaluation limit exceeded -- may not converge.")
        conv <- 1
    } else if (abs(fx) > target) {
        warning("Function exceeds min/max value -- may not converge.")
        conv <- 1
    } else {
        conv <- 0
    }

    return(list(xmin = x, fmin = fx,
                fcalls = fcount, niter = ns, convergence = conv))
}

##  Search with a single scale -----------------------------
.hjsearch <- function(xb, f, h, dir, fcount, maxfeval, target) {
    x  <- xb
    xc <- x
    sf <- 0
    finc <- 0
    hje  <- .hjexplore(xb, xc, f, h, dir)
    x    <- hje$x
    fx   <- hje$fx
    sf   <- hje$sf
    finc <- finc + hje$numf

    # Pattern move
    while (sf == 1) {
        d  <- x-xb
        xb <- x
        xc <- x+d
        fb <- fx
        hje  <- .hjexplore(xb, xc, f, h, dir, fb)
        x    <- hje$x
        fx   <- hje$fx
        sf   <- hje$sf
        finc <- finc + hje$numf

        if (sf == 0) {  # pattern move failed
           hje  <- .hjexplore(xb, xb, f, h, dir, fb)
           x    <- hje$x
           fx   <- hje$fx
           sf   <- hje$sf
           finc <- finc + hje$numf
        }
        if (fcount + finc > maxfeval || abs(fx) > target) break
    }

    return(list(x = x, fx = fx, sf = sf, finc = finc))
}

##  Exploratory move ---------------------------------------
.hjexplore <- function(xb, xc, f, h, dir, fbold) {
    n <- length(xb)
    x <- xb

    if (missing(fbold)) {
        fb <- f(x)
        numf <- 1
    } else {
        fb <- fbold
        numf <- 0
    }

    fx <- fb
    xt <- xc
    sf <- 0                             # do we find a better point ?
    dirh <- h * dir
    fbold <- fx
    for (k in sample.int(n, n)) {       # resample orthogonal directions
        p1 <- xt + dirh[, k]
        ft1 <- f(p1)
        numf <- numf + 1

        p2 <- xt - dirh[, k]
        ft2 <- f(p2)
        numf <- numf + 1

        if (min(ft1, ft2) < fb) {
            sf <- 1
            if (ft1 < ft2) {
                xt <- p1
                fb <- ft1
            } else {
                xt <- p2
                fb <- ft2
            }
        }
    }

    if (sf == 1) {
        x <- xt
        fx <- fb
    }
    return(list(x = x, fx = fx, sf = sf, numf = numf))
}


.hjb <- function(x0, f, lower, upper, tol, target, maxfeval, info) {
    n <- length(x0)
    # checking lower and upper bounds
    if(!is.numeric(lower) || !is.numeric(upper))
        stop("Lower and upper limits must be numeric.", call. = FALSE)
    if (length(lower) == 1) lower <- rep(lower, n)
    if (length(upper) == 1) upper <- rep(upper, n)
    if (!all(lower <= upper))
        stop("All lower limits must be smaller than upper limits.", call. = FALSE)
    if (!all(lower <= x0) || !all(x0 <= upper))
        stop("Infeasible starting values -- check limits.", call. = FALSE)
    
    #-- Setting steps and stepsize -----
    nsteps <- floor(log2(1/tol))        # number of steps
    steps  <- 2^c(-(0:(nsteps-1)))      # decreasing step size
    dir <- diag(1, n, n)                # orthogonal directions

    x <- x0                            # start point
    fx <- fbest <- f(x)                 # smallest value so far
    fcount <- 1                         # counts number of function calls

    if (info) cat("step\tnofc\tfmin\txpar\n")   # info header

    #-- Start the main loop ------------
    ns <- 0
    while (ns < nsteps && fcount < maxfeval && abs(fx) < target) {
        ns <- ns + 1
        hjs    <- .hjbsearch(x, f, lower, upper,
                            steps[ns], dir, fcount, maxfeval, target)
        x      <- hjs$x
        fx     <- hjs$fx
        sf     <- hjs$sf
        fcount <- fcount + hjs$finc

        if (info)
            cat(ns, "\t",  fcount, "\t", fx, "\t", x[1], "...\n")
    }

    if (fcount > maxfeval) {
        warning("Function evaluation limit exceeded -- may not converge.")
        conv <- 1
    } else if (abs(fx) > target) {
        warning("Function exceeds min/max value -- may not converge.")
        conv <- 1
    } else {
        conv <- 0
    }

    return(list(xmin = x, fmin = fx,
                fcalls = fcount, niter = ns, convergence = conv))
}

##  Search with a single scale -----------------------------
.hjbsearch <- function(xb, f, lo, up, h, dir, fcount, maxfeval, target) {
    x  <- xb
    xc <- x
    sf <- 0
    finc <- 0
    hje  <- .hjbexplore(xb, xc, f, lo, up, h, dir)
    x    <- hje$x
    fx   <- hje$fx
    sf   <- hje$sf
    finc <- finc + hje$numf

    # Pattern move
    while (sf == 1) {
        d  <- x-xb
        xb <- x
        xc <- x+d
        xc <- pmax(pmin(xc, up), lo)
        fb <- fx
        hje  <- .hjbexplore(xb, xc, f, lo, up, h, dir, fb)
        x    <- hje$x
        fx   <- hje$fx
        sf   <- hje$sf
        finc <- finc + hje$numf

        if (sf == 0) {  # pattern move failed
           hje  <- .hjbexplore(xb, xb, f, lo, up, h, dir, fb)
           x    <- hje$x
           fx   <- hje$fx
           sf   <- hje$sf
           finc <- finc + hje$numf
        }
        if (fcount + finc > maxfeval || abs(fx) > target) break
    }

    return(list(x = x, fx = fx, sf = sf, finc = finc))
}

##  Exploratory move ---------------------------------------
.hjbexplore <- function(xb, xc, f, lo, up, h, dir, fbold) {
    n <- length(xb)
    x <- xb

    if (missing(fbold)) {
        fb <- f(x)
        numf <- 1
    } else {
        fb <- fbold
        numf <- 0
    }

    fx <- fb
    xt <- xc
    sf <- 0                             # do we find a better point ?
    dirh <- h * dir
    fbold <- fx
    for (k in sample.int(n, n)) {       # resample orthogonal directions
        p1 <- xt + dirh[, k]
        if ( p1[k] <= up[k] ) {
            ft1 <- f(p1)
            numf <- numf + 1
        } else {
            ft1 <- fb
        }

        p2 <- xt - dirh[, k]
        if ( lo[k] <= p2[k] ) {
            ft2 <- f(p2)
            numf <- numf + 1
        } else {
            ft2 <- fb
        }

        if (min(ft1, ft2) < fb) {
            sf <- 1
            if (ft1 < ft2) {
                xt <- p1
                fb <- ft1
            } else {
                xt <- p2
                fb <- ft2
            }
        }
    }

    if (sf == 1) {
        x  <- xt
        fx <- fb
    }

    return(list(x = x, fx = fx, sf = sf, numf = numf))
}

##
##  n e w m a r k . R  Newmark Method
##


newmark <- function(f, t0, t1, y0, ..., N = 100, zeta = 0.25, theta = 0.5) {
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1, 
              is.numeric(N),  is.numeric(t1), length(t1) == 1)
    if (length(y0) != 2)
        stop("Argument 'y0' must be a numeric vector of length 2.")
    N <- floor(N)
    if (N < 2) stop("Argument 'N' must be an integer greater than 1.")

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)
    #if (length(f(t0, y0)) != 2)
    #    stop("Function 'f' must always return a vector of length 2.")

    yout <- matrix(NA, N, 2)
    yout[1, ] <- y <- c(y0)

    h <- (t1 - t0)/(N-1)
    t <- 0
    ts <- linspace(t0, t1, N)

    f1 <- f(ts[1], y)

    # internal function used for root finding
    nmfun <- function(w) {
        f2 <- f(t, w)
        z1 <- w[1] - y[1] - h * y[2] - h^2 * (zeta*f2 + (0.5 - zeta) * f1)
        z2 <- w[2] - y[2] - h * ((1-theta)*f1 + theta*f2)
        c(z1, z2)
    }

    for (i in 2:N) {
        t <- ts[i]
        w <- fsolve(nmfun, y)$x
        f1 <- f(t, w)
        yout[i, ] <- w
        y <- w
    }

    return(list(t = ts, y = yout))
}

##
##  l u. R  LU Decomposition
##


lu <- function(A, scheme = c("kji", "jki", "ijk")) {
    stopifnot(is.numeric(A), is.matrix(A))
    n <- nrow(A)
    if (ncol(A) != n || n <= 1)
        stop("Argument 'A' must be a square, positive definite matrix.")

    scheme <- match.arg(scheme)

    if (scheme == "kji") {
        for (k in 1:(n-1)) {
            if (A[k, k] == 0)
                stop("All diagonal elements of matrix 'A' must be non-zero.")
            for (i in (k+1):n) {
                A[i, k] <- A[i, k] / A[k, k]
                A[i, (k+1):n] <- A[i, (k+1):n] - A[i, k] * A[k, (k+1):n]
            }
        }

    } else if (scheme == "jki") {
        if (A[1, 1] == 0)
            stop("All diagonal elements of matrix 'A' must be non-zero.")
        i <- 2:n
        A[i, 1] <- A[i, 1] / A[1, 1]
        for (j in 2:n) {
            if (A[j, j] == 0)
                stop("All diagonal elements of matrix 'A' must be non-zero.")
            for (k in 1:(j-1)) {
                i <- (k+1):n
                A[i, j] <- A[i, j] - A[i, k] * A[k, j]
            }
            if (j < n) {
                i <- (j+1):n
                A[i, j] <- A[i, j] / A[j, j]
            }
        }

    } else if (scheme == "ijk") {       # 'compact' Doolittle scheme
        for (i in 2:n) {                # j in 1:n
            for (j in 2:i) {
                if (A[j, j] == 0)
                    stop("All diagonal elements of matrix 'A' must be non-zero.")
                A[i, j-1] <- A[i, j-1] / A[j-1, j-1]
                k <- 1:(j-1)
                A[i, j] <- A[i, j] - A[i, k] %*% A[k, j]
            }
            if (i < n) {
                k <- 1:(i-1)
                for (j in (i+1):n) {
                    A[i, j] <- A[i, j] - A[i, k] %*% A[k, j]
                }
            }
        }
    }

    L <- eye(n) + tril(A, -1)
    U <- triu(A)
    return(list(L = L, U = U))
}


lu_crout <- function(A) {
    stopifnot(is.numeric(A), is.matrix(A))
    n <- nrow(A)
    if (ncol(A) != n || n <= 1)
        stop("Argument 'A' must be a square, positive definite matrix.")

    L <- matrix(0, n, n); U <- matrix(0, n, n)
    for (i in 1:n) {
        L[i, 1] <- A[i, 1]
        U[i, i] <- 1
    }
    for (j in 2:n) {
        U[1, j] <- A[1, j] / L[1, 1]
    }
    for (i in 2:n) {
        for (j in 2:i) {
            L[i, j] <- A[i, j] - sum(L[i, 1:(j-1)] * U[1:(j-1), j])
        }
        if (i < n) {
            for (j in ((i+1):n)) {
                U[i, j] = (A[i, j]-sum(L[i, 1:(i-1)]*U[1:(i-1), j]))/L[i, i]
            }
        }
    }
    return(list(L = L, U = U))
}


lufact <- function(A) {
    stopifnot(is.numeric(A), is.matrix(A))
    m <- nrow(A); n <- ncol(A)
    if (m != n || m == 1)
        stop("Matrix 'A' must be a square matrix with 2 rows at least.")

    detA <- 1
    rows <- 1:n
    for (p in 1:(n-1)) {
        prow <- which.max(abs(A[p:n, p])) + (p-1)
        if (p < prow) {
            rows[c(p, prow)] <- rows[c(prow, p)]
            detA <- -detA
        }
        detA <- detA * A[rows[p], p]
        if (detA == 0) {
            warning("Matrix 'A' is singular, no results computed.")
            return(list(LU = A, perm = rows, det = NA, x = NULL))
        }

        for (k in (p+1):n) {
            f <- A[rows[k], p] / A[rows[p], p]
            A[rows[k], p] <- f
            A[rows[k], (p+1):n] <- A[rows[k],(p+1):n] - f*A[rows[p], (p+1):n]
        }
    }
    detA <- detA * A[rows[n], n]
    return(list(LU = A, perm = rows, det = detA))
 }


lusys <- function(A, b) {
    stopifnot(is.numeric(A), is.matrix(A), is.numeric(b))
    b <- as.matrix(b)

    m <- nrow(A); n <- ncol(A)
    if (m != n || m == 1)
        stop("Matrix 'A' must be a square matrix with 2 rows at least.")

    x <- zeros(n, 1); y <- zeros(n, 1)
    r <- c(1:n)

    for (p in 1:(n-1)) {
        # find the pivot row for column p
        q <- which.max(abs(A[p:n, p])) + (p-1)

        # interchange rows p and q
        A[c(p, q), ] <- A[c(q, p), ]
        r[c(p, q)] <- r[c(q, p)]

        if (A[p, p] == 0)
            stop("Matrix 'A' singular: no unique solution.")

        # calculate multiplier and place
        for (k in (p+1):n) {
            a = A[k, p] / A[p, p]
            A[k, p] <- a
            A[k, (p+1):n] <- A[k, (p+1):n] - a*A[p, (p+1):n]
        }
    }
    # solve for y
    y[1] = b[r[1]]
    for (k in 2:n)
        y[k] <- b[r[k]] - A[k,1:(k-1)] %*% y[1:(k-1)]

    # solve for x
    x[n] <- y[n] / A[n, n]
    for (k in (n-1):1)
        x[k] <- (y[k] - A[k, (k+1):n] %*% x[(k+1):n]) / A[k, k]

    return(x)
}

##
##  c r o s s n . R  Vector Cross Product
##


crossn <- function(A) {
	if (!is.numeric(A))
		stop("Argument 'A' must be numeric.")

	if (is.vector(A) && length(A) == 2) {
		crossA <- c(A[2], -A[1])
	} else {
		if (is.matrix(A) && nrow(A) >= 2 && ncol(A) == nrow(A) + 1) {
			m <- ncol(A)
			crossA <- numeric(m)
			for (i in 1:m)
				crossA[i] <- (-1)^(i+1) * det(A[, -i])
		} else {
			stop("Matrix 'A' must be of size n x (n+1) with n >= 1.")
		}
	}
	return(crossA)
}

##
##  t r a c e . R  Matrix trace
##


Trace <- function(a) {
	if (length(a) <= 1) return(a)
	if ((!is.numeric(a) && !is.complex(a)) || !is.matrix(a))
		stop("Argument 'a' must be a real or complex matrix.")
	if (nrow(a) != ncol(a))
		stop("Matrix 'a' must be square.")

	return(sum(diag(a)))
}

##
##  p e r m s . R  Permutations
##

perms <- function(a) {
    n <- length(a)
    if (length(a) == 0) return(c())
    else    if (n <= 1) return(matrix(a, 1, 1))

    q <- perms(1:(n-1))  # recursive call
    m <- nrow(q)
    P <- matrix(0, n*m, n)
    P[1:m, ] <- cbind(matrix(n, m, 1), q)

    for (i in (n-1):1) {
        t <- q
        t[t == i] <- n
        P[(m*(n-i)+1):(m*(n-i+1)), ] <- cbind(i*matrix(1, m, 1), t)
    }

    b <- a[c(P)]
    dim(b) <- dim(P)
    return(b)
}


randperm <- function(a, k) {
    n <- length(a)
    if (n == 0 || a[1] == 0) return(c())
    if (n == 1) {
        if (floor(a) != ceiling(a) || a < 1)
            stop("Argument 'a' must be a positive integer.")
        n <- a; a <- 1:a
    }
    if (missing(k)) k <- n
    if (k > n)
        stop("'k' must be smaller or equal to 'a' or length of 'a'.")

    m <- sample(a, size = k, replace = FALSE)
    return(m)
}

##
##  n e w t o n s y s . R
##


# Finds a zero of a nonlinear system by Newton's method
newtonsys <- function(Ffun, x0, Jfun = NULL, ...,
	                  maxiter = 100, tol = .Machine$double.eps^(1/2)) {
	.vnorm <- function(x) { sqrt(sum(x^2)) }
	if (is.null(Jfun)) Jfun <- function(x, ...) jacobian(Ffun, x, ...)

	niter <- 0; err <- tol + 1
	x <- x0
	while (err >= tol && niter < maxiter) {
		niter <- niter + 1
		F <- Ffun(x, ...)
		J <- Jfun(x, ...)
		delta <- -1 * solve(J, F)
		x <- x + delta
		err <- .vnorm(delta)
	}
	F <- .vnorm(Ffun(x, ...))
	if (niter > maxiter && err > tol) {
		cat("Fails to converge within maximum number of iterations.\n",
		    "The iterate returned has relative residual ", F, "\n", sep="")
	}
	return(list(zero=x, fnorm=F, niter=niter))
}

##
##  e y e . R  Generate basic Matrices
##


eye <- function(n, m = n) {
    stopifnot(is.numeric(n), length(n) == 1,
              is.numeric(m), length(m) == 1)
    n <- floor(n)
    m <- floor(m)
    if (n <= 0 || m <= 0) return(matrix(NA, 0, 0))
    else                  return(base::diag(1, n, m))
}

ones <- function(n, m = n) {
        stopifnot(is.numeric(n), length(n) == 1,
                  is.numeric(m), length(m) == 1)
        n <- floor(n)
        m <- floor(m)
        if (n <= 0 || m <= 0) return(matrix(1, 0, 0))
        else                  return(matrix(1, n, m))
}

zeros <- function(n, m = n) {
    stopifnot(is.numeric(n), length(n) == 1,
              is.numeric(m), length(m) == 1)
    n <- floor(n)
    m <- floor(m)
    if (n <= 0 || m <= 0) return(matrix(0, 0, 0))
    else                  return(matrix(0, n, m))
}

##
##  l e b e s g u e . R  Lebesgue Coefficient
##


lebesgue <- function(x, refine = 4, plotting = FALSE) {
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector.")
    if (! refine %in% c(2,3,4,5,6,7,8,9,10))
        stop("Argument 'refine' must be one of 2,3,4,5,6,7,8,9,10.")

    n <- length(x)
    N <- 2^refine * n + 1
    X <- matrix(rep(x, times = n), nrow = n, ncol = n)

    # weights
    w <- 1 / apply(X - t(X) + diag(n), 1, prod)

    # refine grid points
    xp <- seq(min(x), max(x), length.out = N)
    xdiff <- matrix(rep(xp, times = n), n, N, byrow = TRUE) -
             matrix(rep(x,  times = N), n, N)

    inds <- (xdiff == 0)
    lfun <- apply(xdiff, 2, prod)
    xdiff[inds] <- .Machine$double.eps

    # compute Lebesgue function
    Y <- abs((diag(w) %*% matrix(rep(lfun, times = n), n, N, byrow = TRUE)) / xdiff)
    lebfun <- apply(Y, 2, sum)
    if (plotting) {
        plot(xp, lebfun, type = "l", col = "blue", lty = 2, lwd = 2,
             xlab="Grid points", ylab="Coefficients", main = "Lebesgue Function")
        grid()
    }

    # return Lebesgue coefficient
    return(max(lebfun))
}

##
##  c r a n k n i c . R  Crank-Nicolson
##


cranknic <- function(f, t0, t1, y0, ..., N = 100) {
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1, 
              is.numeric(t1), length(t1) == 1)
    if (is.vector(y0)) {
        y0 <- as.matrix(y0)
    } else if (is.matrix(y0)) {
        if (ncol(y0) != 1) 
            stop("Argument 'y0' must be a row or column vector.")
    }

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)

    n <- length(y0)
    y <- y0
    yout <- matrix(NA, N, n)
    yout[1, ] <- c(y0)

    h <- (t1 - t0)/(N-1)
    t <- 0
    ts <- linspace(t0, t1, N)

    # internal function used for root finding
    cnfun <- function(w)  w - y - 0.5* h * (f(t, w) + f(t, y))
    m <- length(f(t0, y0))
    if (m != n)
        stop("Function f must return a vector the same length as 'y0'.")

    # solver used for root finding
    if (n == 1) solver <- fzero
    else        solver <- fsolve

    for (i in 2:N) {
        t <- ts[i]
        w <- solver(cnfun, y)$x
        yout[i, ] <- w
        y <- w
    }

    if (n == 1) yout <- drop(yout)
    return(list(t = ts, y = yout))
}

###
### CROSS.R  Vector product
###

cross <- function(x, y) {
	if (!is.numeric(x) || !is.numeric(y))
		stop("Arguments 'x' and 'y' must be numeric vectors or matrices.")

	if (is.vector(x) && is.vector(y)) {
		if (length(x) == length(y) && length(x) == 3) {
			xxy <- c(x[2]*y[3] - x[3]*y[2],
			         x[3]*y[1] - x[1]*y[3],
    		         x[1]*y[2] - x[2]*y[1])
		} else {
			stop("Vectors 'x' and 'y' must be both of length 3.")
		}
	} else {
		if (is.matrix(x) && is.matrix(y)) {
			if (all(dim(x) == dim(y))) {
				if (ncol(x) == 3) {
                    xxy <- cbind(x[, 2]*y[, 3] - x[, 3]*y[, 2],
        			             x[, 3]*y[, 1] - x[, 1]*y[, 3],
            		             x[,1 ]*y[, 2] - x[, 2]*y[, 1])
				} else {
					if (nrow(x) == 3) {
                        xxy <- rbind(x[2, ]*y[3, ] - x[3, ]*y[2, ],
            			             x[3, ]*y[1, ] - x[1, ]*y[3, ],
                		             x[1, ]*y[2, ] - x[2, ]*y[1, ])
					} else {
						stop("'x', 'y' must have one dimension of length 3.")
					}
				}
			} else {
				stop("Matrices 'x' and 'y' must be of same size.")
			}
		} else {
			if (is.vector(x) && is.matrix(y) ||
				is.matrix(x) && is.vector(y)) {
			stop("Arguments 'x', 'y' must be vectors/matrices of same size.")
				}
		}
	}
	return(xxy)
}

##
##  e i n s t e i n F . R  Einstein Functions
##


einsteinF <- function(d, x) {
    stopifnot(is.numeric(x) || is.complex(x))
    fi <- which(x == 0)

    if (d == 1) {
        y <- x^2 * exp(x) / (exp(x) - 1)^2
        y[fi] <- 1
    } else if (d == 2) {
        y <- x / (exp(x) - 1)
        y[fi] <- 1
    } else if (d == 3) {
        y <- log(1 - exp(-x))
        y[fi] <- -Inf
    } else if (d == 4) {
        y <- x / (exp(x) - 1) - log(1 - exp(-x))
        y[fi] <- Inf
    } else {
        stop("Argument 'd' must be one of the integers 1, 2, 3, 4.")
    }

    return(y)
}

##
##  s o r t i n g . R  Sorting Routines
##


.comp <- function(u, v) {
	# strictly increasing order
	if (u < v) TRUE
	else FALSE
}

bubbleSort <- function(a) {
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")

    n <- length(a)
    if (n <= 1) return(a)
    for (i in 1:n) {
        for (j in 2:n) {
            b <- a[j]
            if (.comp(a[j], a[j-1]) ) {
                a[j] <- a[j-1]
                a[j-1] <- b
            }
        }
    }
    return(a)
}

insertionSort <- function(a) {
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")

	n <- length(a)
	if (n <= 1) return(a)
	for (i in 2:n) {
		t <- a[i]
		j <- i
		while (j >=2 && a[j-1] > t) {
			a[j] <- a[j-1]
			j <- j-1
		}
		a[j] <- t
	}
	return(a)
}

selectionSort <- function(a) {
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")

    n <- length(a)
    if (n <= 1) return(a)
    for (i in 1:(n-1)) {
        min <- i
        for (j in (i+1):n) {
            if (a[j] < a[min]) min <- j
        }
        t <- a[min]; a[min] <- a[i]; a[i] <- t
    }
    return(a)
}

shellSort <- function(a, f = 2.3) {
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")
    if (!is.numeric(f) || length(f) != 1 || f <= 1)
        stop("The retracting factor 'f' must be a numeric scalar > 1.0")

	n <- length(a)
	if (n <= 1) return(a)
	h <- n %/% 2
	while ( h >= 1) {
		for (i in (h+1):n) {
			t <- a[i]
			j <- i
			while (a[j-h] > t) {
				a[j] <- a[j-h]
				j <- j - h
				if (j <= h) break
			}
			a[j] <- t
		}
		h <- round(h/f)
	}
	return(a)
}

heapSort <- function(a) {
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")
    warning("Function 'heapSort' not yet implemented.")

    n <- length(a)
    if (n <= 1) return(a)
	return(a)
}

mergeSort <- function(a, m = 10) {
    stopifnot(is.numeric(m), length(m) == 1, floor(m) == ceiling(m))
    if (!is.numeric(a))
        stop("Argument 'a' must be a non-empty numeric vector.")

	n <- length(a)
	#if (n <= 1) return(a)
	if (n <= m) return(insertionSort(a))
	m <- n %/% 2
	left <- mergeSort(a[1:m])
	right <- mergeSort(a[(m+1):n])
	return(mergeOrdered(left, right))
}

mergeOrdered <- function(a, b){
	na <- length(a); nb <- length(b)
	ab <- numeric(na + nb)
	i <- j <- 1
	repeat {
		if (a[i] <= b[j]) {
			ab[i+j-1] <- a[i]
			i <- i + 1
			if (i > na) {
				ab[(i+j-1):(na+nb)] <- b[j:nb]
				break
			}
		} else {
			ab[i+j-1] <- b[j]
			j <- j + 1
			if (j > nb) {
				ab[(i+j-1):(na+nb)] <- a[i:na]
				break
			}
		}
	}
	return(ab)
}

quickSort <- function(a, m = 3) {  # m = 3..30
	n <- length(a)
	if (n <= m) {
		return( insertionSort(a) )
	} else {
		v <- (a[1]+a[2])/2
		return ( c(quickSort(a[a <= v], m=m), quickSort(a[a > v], m=m)))
	}
}

quickSortx <- function(a, m = 25) {  # m=20..40, m=25 is favoured
	n <- length(a)
	if (n <= m) return(insertionSort(a))
	i <- 0; j <- n
	v <- a[n]
	repeat {
		while (i < n && a[i+1]  < v) i <- i+1
		while (j > 1 && a[j-1] >= v) j <- j-1
		if (i >= j-1) break
		t <- a[i+1]; a[i+1] <- a[j-1]; a[j-1] <- t
	}
	if (i == 0) return( c(a[n], quickSortx(a[1:(n-1)])) )
	if (j == n) return( c(quickSortx(a[1:(n-1)]), a[n]) )
	return( c(quickSortx(a[1:i]), a[n], quickSortx(a[(i+1):(n-1)])) )
}

is.sorted <- function(a) !is.unsorted(a)

testSort <- function(n = 1000) {
	if (n >= 1e5) warning("n quite large: This will take some time!")
	x <- runif(n)
	
	cat("Test Begin...\n")
	cat("Do not test bubble sort (too slow).\n\n")

	# elapsed <- system.time(y <- bubbleSort(x))[3]
	# cat("Bubble sort: Elapsed time = ", elapsed, "\n")
	# if (is.sorted(y)) cat("Bubble sort successful.\n\n")
	# else cat("Bubble sort test FAILED.\n\n")
	# flush(stdout())

	elapsed <- system.time(y <- insertionSort(x))[3]
	cat("Insertion sort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y)) cat("Insertion sort successful.\n\n")
	else cat("Insertion sort test FAILED.\n\n")
	flush(stdout())

	elapsed <- system.time(y <- selectionSort(x))[3]
	cat("Selection sort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y)) cat("Selection sort successful.\n\n")
	else cat("Selection sort test FAILED.\n\n")
	flush(stdout())

	elapsed <- system.time(y <- shellSort(x))[3]
	cat("Shellsort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y))  { cat("Shell sort successful.\n\n")
	} else { cat("Shell sort test FAILED.\n\n") }
	flush(stdout())

	elapsed <- system.time(y <- mergeSort(x))[3]
	cat("Mergesort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y))  { cat("Merge sort successful.\n\n")
	} else { cat("Merge sort test FAILED.\n\n") }
	flush(stdout())

	elapsed <- system.time(y <- heapSort(x))[3]
	cat("Heapsort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y))  { cat("heap sort successful.\n\n")
	} else { cat("Heap sort test FAILED.\n\n") }
	flush(stdout())

	elapsed <- system.time(y <- quickSort(x))[3]
	cat("Quicksort: Elapsed time = ", elapsed, "secs\n")
	if (is.sorted(y))  { cat("Quicksort successful.\n\n")
	} else { cat("Quicksort test FAILED.\n\n") }

	cat("Test End\n")
}

#-- HwB (C) 2010 -------------------------------------------------------

##
##  i n t e r p 2 . R  2-D Interpolation
##


interp2 <- function(x, y, Z, xp, yp,
                    method = c("linear", "nearest", "constant")) {
    stopifnot(is.numeric(x),  is.numeric(y),  is.numeric(Z),
              is.numeric(xp), is.numeric(yp), is.matrix(Z) )

    lx <- length(x); ly <- length(y)
    if (ncol(Z) != lx || nrow(Z) != ly)
        stop("Required: 'length(x) = ncol(Z)' and 'length(y) = nrow(Z)'.")
    n  <- length(xp)
    if (length(yp) != n)
        stop("Length of vectors 'xp' and 'yp' must be the same.")

    method <- match.arg(method)

    Z <- t(Z)         # TODO: Exchange Z[x, y] with Z[y, x] instead!
    v  <- numeric(n)

    xi <- findInterval(xp, x)
    yi <- findInterval(yp, y)

    i0 <- which(xp < min(x) | xp > max(x) | yp < min(y) | yp > max(y))

    if (method == "linear") {
        for (k in 1:length(xp)) {
            if ( k %in% i0) {
                v[k] <- NA
            } else {
                i <- xi[k]; j <- yi[k]
                if (i == lx) i <- i-1
                if (j == ly) j <- j-1
                A <- matrix(c(1, x[i],   y[j],   x[i]*y[j],
                              1, x[i],   y[j+1], x[i]*y[j+1],
                              1, x[i+1], y[j],   x[i+1]*y[j],
                              1, x[i+1], y[j+1], x[i+1]*y[j+1]),
                            nrow = 4, ncol = 4, byrow = TRUE)
                b <- Z[cbind(c(i,i,i+1,i+1), c(j,j+1,j,j+1))]
                v[k] <- sum(solve(A, b) * c(1, xp[k], yp[k], xp[k]*yp[k]))
            } 
        }

    } else if (method == "constant") {
        for (k in 1:length(xp)) {
            if ( k %in% i0) {
                v[k] <- NA
            } else {
                v[k] <- Z[xi[k], yi[k]]
            }
        }

    } else if (method == "nearest") {
        for (k in 1:length(xp)) {
            if (k %in% i0) {
                v[k] <- NA
            } else {
                i <- xi[k]
                if (i == lx) i <- i-1
                j <- yi[k]
                if (j == ly) j <- j-1
                if (xp[k] <= (x[i] + x[i+1])/2) {
                    if (yp[k] <= (y[j] + y[j+1])/2) {
                        v[k] <- Z[i, j]
                    } else {
                        v[k] <- Z[i, j+1]
                    }
                } else {
                    if (yp[k] <= (y[j] + y[j+1])/2) {
                        v[k] <- Z[i+1, j]
                    } else {
                        v[k] <- Z[i+1, j+1]
                    }
                }
            }
        }

    } else
        stop("Method 'cubic' and others are not yet implemented.")
    
    return(v)
}

##
##  f a c t . R  Factorial Function
##


fact <- function(n) {
    if (!is.numeric(n))
        stop("Argument 'n' must be a numeric vector or matrix.")

    d <- dim(n)
    n <- c(n)
    n <- floor(n)

    f <- rep(1, length(n))
    i0 <- which(n > 170)
    if (length(i0) > 0) f[i0] <- Inf
    i1 <- which(n < 0)
    if (length(i1) > 0) f[i1] <- NaN
    i2 <- which(is.na(n))
    if (length(i2) > 0) f[i2] <- NA

    ii <- which(n > 0 & n <= 170)
    if (length(ii) > 0) {
        nn <- n[ii]
        ff <- numeric(length(nn))

        s = 1
        for (k in 1:max(nn)) {
            s <- s * k
            p <- which(nn == k)
            ff[p] <- s
        }
        f[ii] <- ff
    }

    dim(f) <- d
    return(f)
}


factorial2 <- function(n) {
    stopifnot(is.numeric(n) || length(n) > 1)
    n = floor(n)
    if (n > 170) return(Inf)
    if (n < 0)   return(NaN)
    if (n == 0)  return(1)

    if (n %% 2 == 0) {
        return( prod(seq(from = 2, to = n, by = 2)) )
    } else {
        return( prod(seq(from = 1, to = n, by = 2)) )
    }
}

##
##  s a v g o l . R  Savitzky-Golay Smoothing
##


savgol <- function(T, fl, forder = 4, dorder = 0) {
    stopifnot(is.numeric(T), is.numeric(fl))
    if (fl <= 1 || fl %% 2 == 0)
        stop("Argument 'fl' must be an odd integer greater than 1.")
    n <- length(T)

    # -- calculate filter coefficients --
    fc <- (fl-1)/2                          # index: window left and right
    X <- outer(-fc:fc, 0:forder, FUN="^")   # polynomial terms and coeffs
    Y <- pinv(X);                           # pseudoinverse

    # -- filter via convolution and take care of the end points --
    T2 <- convolve(T, rev(Y[(dorder+1),]), type="o")   # convolve(...)
    T2 <- T2[(fc+1):(length(T2)-fc)]

    Tsg <- (-1)^dorder * T2
    return( Tsg )
}

##
##  w h i t t a k e r . R  Whittaker Smoothing
##


whittaker <- function(y, lambda = 1600, d = 2){
    #   Smoothing with a finite difference penalty
    #   y:      signal to be smoothed
    #   lambda: smoothing parameter (rough 50..1e4 smooth)
    #   d:      order of differences in penalty (generally 2)
    
    m <- length(y)
    E <- eye(m)
    D <- diff(E, lag = 1, differences = d)
    B <- E + (lambda * t(D) %*% D)
    z <- solve(B, y)

    return(z)
}

# whittaker <- function(y, lambda = 1600, d = 2) {
#   stopifnot(is.numeric(y))
#   success <- library("SparseM", pos = "package:base",
#                      logical.return = TRUE, warn.conflicts = FALSE)
#   if (!success)
#       stop("Function 'whittaker' requires package 'SparseM'.")
# 
#     m <- length(y)
#     E <- as(m, "matrix.diag.csr")
#     class(E) <- "matrix.csr"
# 
#     Dmat <- diff(E, differences = d)
#     B <- E + (lambda * t(Dmat) %*% Dmat)
#     z <- solve(B, y)
# 
#     return(z)
# }

##
##  g a u s s N e w t o n . R  Gauss-Newton Function Minimization
##


gaussNewton <- function(x0, Ffun, Jfun = NULL,
                         maxiter =100, tol = .Machine$double.eps^(1/2), ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")
    x0 <- c(x0)
    n <- length(x0)
    if (n == 1)
        stop("Function is univariate -- use a different approach.")

    Fun <- match.fun(Ffun)
    F <- function(x) Fun(x, ...)
    m <- length(F(x0))

    # Define J as Jacobian of F, and f as sum(F_i)
    f <- function(x) sum(F(x)^2)
    if (is.null(Jfun)) {
        J <- function(x) jacobian(F, x)
    } else {
        Jun <- match.fun(Jfun)
        J <- function(x) Jun(x, ...)
    }
    # The gradient g of f (!) computed through the Jacobian
    g <- function(x) 2 * t(J(x)) %*% F(x)

    # First iteration
    xk <- x0
    fk <- f(xk)
    Jk <- J(xk)
    gk <- g(xk)  # 2 * t(Jk) %*% F(xk)
    Hk <- 2 * t(Jk) %*% Jk + tol * diag(1, n)

    # Line search step
    dk <- -inv(Hk) %*% gk
    if (!all(is.finite(dk))) dk <- .mdhess(Hk, gk)
    ak <- softline(xk, dk, f, g)
    adk <- ak * dk
    err <- Norm(adk)
    
    k <- 1
    while (err > tol && k < maxiter) {
        xk <- xk + adk
        fl <- f(xk)
        Jk <- J(xk)
        gk <- g(xk)
        Hk <- 2 * t(Jk) %*% Jk + tol * diag(1, n)

        dk <- -inv(Hk) %*% gk
        if (!all(is.finite(dk))) dk <- .mdhess(Hk, gk)
        ak <- softline(xk, dk, f, g)
        adk <- ak * dk
        err <- abs(fl - fk)

        # Prepare next iteration
        fk <- fl
        k <- k + 1
    }

    if (k >= maxiter)
        warning("Maximum number of iterations reached -- no convergence.")
    xs <- c(xk + adk)
    fs <- f(xk + adk)
        
    return(list(xs = xs, fs = fs, niter = k, relerr = err))
}


.mdhess <- function(H, gk) {
    n <- length(gk)

    # Matthews-Davies algorithm
    L <- D <- matrix(0, n, n)
    h00 <- if (H[1, 1] > 0) H[1, 1] else 1
    for (k in 2:n) {
        m <- k-1
        L[m, m] <- 1
        if (H[m, m] <= 0) H[m, m] <- h00
        for (i in k:n) {
            L[i, m] <- -H[i, m] / H[m, m]
            H[i, m] <- 0
            for (j in k:n) {
                H[i, j] <- H[i, j] + L[i, m] * H[m, j]
            }
        }
        if (H[k, k] > 0 && H[k, k] < h00) h00 <- H[k, k]
    }
    L[n, n] <- 1
    if (H[n,n] <= 0) H[n, n] <- h00
    for (i in 1:n)
        D[i, i] <- H[i, i]

    # Determine direction vector
    yk <- -L %*% gk
    dk <- t(L) %*% diag(1/diag(D)) %*% yk

    return(dk)
}

##
##  e x p m . R  Matrix Exponential
##


expm <- function(A, np = 128) {
    if (!is.numeric(A) || !is.matrix(A) || nrow(A) != ncol(A))
        stop("Argument 'A' must be a square numeric matrix.")
    if (!is.numeric(np) || length(np) != 1 ||
        floor(np) != ceiling(np) || np < 2)
        stop("Argument 'np' must be an integer greater or equal to 2.")

    N <- nrow(A)
    circle <- exp(2i*pi*(1:np)/np)      # generate np unit roots
    z0 <- ceiling(mean(range(Re(eig(A)))) + 0.1)
    radius <- ceiling(max(abs(eig(A) - z0)) + 0.1)
    z <- z0 + radius*circle

    I <- eye(N); B <- zeros(N)
    for (i in 1:np) {
      R <- inv(z[i]*I - A)                # resolvent matrix at point z(i)
      B <- B + R * (z[i]-z0) * exp(z[i])  # add up contributions to integral
    }

    B <- Re(B)/np
    return(zapsmall(B))
}


logm <- function(A) {
    if (!is.numeric(A) || !is.matrix(A) || nrow(A) != ncol(A))
        stop("Argument 'A' must be a square numeric matrix.")

    E <- eigen(A)
    e <- E$values
    if (any(Im(e) == 0 & Re(e) <= 0))
        stop("A must not have any nonpositive real eigenvalues.")


    D <- diag(log(E$values))
    X <- E$vectors %*% D %*% solve(E$vectors)
    return(Re(X))
}

##
##  g m r e s . R  Generalized Linear equation solver
##


gmres <- function(A, b, x0 = rep(0, length(b)), 
                  errtol = 1e-6, kmax = length(b)+1, reorth = 1) {
    stopifnot(is.numeric(A), is.numeric(b), is.matrix(A))
    b <- as.matrix(b)
    n <- length(b)
    if (nrow(A) != n || ncol(A) != n)
        stop("Matrix 'A' must be square and compatible with 'b'.")

    # initialization
    h <- zeros(kmax)
    v <- zeros(n, kmax)
    c <- zeros(kmax+1, 1)
    s <- zeros(kmax+1, 1)

    normF <- function(x) norm(as.matrix(x), type = 'F')

    x <- as.matrix(x0)
    if (norm(x, 'F') != 0) {
        r <- b - A %*% x
    } else {
        r <- b
    }

    rho <- norm(r, 'F')
    g <- rho*eye(kmax+1, 1)
    errtol <- errtol * norm(b, 'F')
    error <- c()

    # test for termination on entry
    error <- c(error, rho)
    niter <- 0
    if(rho < errtol)
        return(list(x = x, error = error, niter = niter))

    v[, 1] <- r/rho
    beta <- rho

    # GMRES iteration
    k <- 0
    while (rho > errtol && k < kmax) {
        k <- k + 1
        v[, k+1] <- A %*% v[, k]
        normav <- normF(v[, k+1])

        # modified Gram-Schmidt
        for (j in 1:k) {
            h[j, k] <- t(v[, j]) %*% v[, k+1]
            v[, k+1] <- v[, k+1] - h[j,k] * v[, j]
        }
        h[k+1, k] <- normF(v[, k+1])
        normav2 <- h[k+1, k]

        # reorthogonalize
        if ((reorth == 1 && normav + 0.001*normav2 == normav) || reorth == 3) {
            for (j in 1:k) {
                hr <- t(v[, j]) %*% v[, k+1]
                h[j, k] <- h[j, k] + hr
                v[, k+1] = v[, k+1] - hr*v[, j]
            }
            h[k+1, k] <- normF(v[, k+1])
        }

        # watch out for happy breakdown
        if (h[k+1, k] != 0)
            v[, k+1] <- v[, k+1] / h[k+1, k]

        # form and store the information for the new Givens rotation
        if (k > 1)
            h[1:k, k] <- .givapp(c[1:(k-1)], s[1:(k-1)], h[1:k, k], k-1)

        nu <- normF(h[k:(k+1), k])
        if (nu != 0) {
            c[k] <- Conj(h[k, k] / nu)
            s[k] <- -h[k+1, k] / nu
            h[k, k] <- c[k] * h[k, k] - s[k] * h[k+1, k]
            h[k+1, k] <- 0
            g[k:(k+1)] <- .givapp(c[k], s[k], g[k:(k+1)], 1)
        }

        # update the residual norm
        rho <- abs(g[k+1])
        error <- c(error,rho)
    }

    # at this point either k > kmax or rho < errtol
    y <- qr.solve(h[1:k, 1:k], g[1:k])
    x <- x0 + v[1:n, 1:k] %*% y

    return(list(x = x, error = error, niter = k))
}


.givapp <- function(c, s, v_in, k) {
    v_rot <- v_in
    for (i in 1:k) {
        w1 <- c[i] * v_rot[i] - s[i] * v_rot[i+1]
        w2 <- s[i] * v_rot[i] + Conj(c[i]) * v_rot[i+1]
        v_rot[i:(i+1)] <- c(w1, w2)
    }
    v_rot
}

##
##  f s o l v e . R
##


fsolve <- function(f, x0, J = NULL,
                   maxiter = 100, tol = .Machine$double.eps^(0.5), ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")
    x0 <- c(x0)

    # Prepare objective function and its Jacobian
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    n <- length(x0)
    m <- length(f(x0))
    if (n == 1)
        stop("Function 'fsolve' not applicable for univariate root finding.")

    if (!is.null(J)) {
        Jun <- match.fun(J)
        J <- function(x) J(x, ...)
    } else {
        J <- function(x) jacobian(f, x)
    }

    if (m == n) {
        sol = broyden(f, x0, J0 = J(x0), maxiter = maxiter, tol = tol)
        xs <- sol$zero; fs <- f(xs)
    } else {
        sol <- gaussNewton(x0, f, Jfun = J, maxiter = maxiter, tol = tol)
        xs <- sol$xs; fs <- sol$fs
        if (fs > tol)
            warning("Minimum appears not to be a zero -- change starting point.")
    }

    return(list(x = xs, fval = fs))
}


fzsolve <- function(fz, z0) {
    if (length(z0) == 0) return(c())
    if (length(z0) > 1) {
        warning("Argument 'z0' has length > 1, first component taken.")
        z0 <- z0[1]
    }

    if (is.numeric(z0)) {
        x0 <- c(z0, 0)
    } else if (is.complex(z0)) {
        x0 <- c(Re(z0), Im(z0))
    } else
        stop("Argument 'z0' must be a real or complex number.")

    fz <- match.fun(fz)
    fn <- function(x) {
        z <- x[1] + x[2]*1i
        Z <- fz(z)
        if (is.complex(Z))      Z <- c(Re(Z), Im(Z))
        else if (is.numeric(Z)) Z <- c(Z, 0)
        else                    Z <- c(NA, NA)
        return(Z)
    }
    x <- broyden(fn, x0)$zero
    return(x[1] + x[2]*1i)
}

##
##  n o r m e s t . R  Matrix Norm estimation
##


normest <- function(M, maxiter = 100, tol = .Machine$double.eps^(1/2)) {
    if (length(M) == 0)
        return(0)
    if (!is.numeric(M))
        stop("Argument 'M' must be a numeric matrix.")
    if (is.vector(M))
        M <- matrix(c(M), nrow = length(M), ncol = 1)

    x <- matrix(apply(abs(M), 2, sum), ncol = 1)
    est <- norm(x, "F")      # Frobenius Norm
    if (est == 0) return(0)

    x <- x/est
    est0 <- 0
    niter <- 0
    while (abs(est - est0) > tol * est && niter <= maxiter) {
        est0 <- est
        Mx <- M %*% x
        if (all(Mx == 0))
            Mx <- matrix(runif(length(Mx)), ncol(Mx), nrow(Mx))
        x <- t(M) %*% Mx
        normx <- norm(x, "F")
        est <- normx / norm(Mx, "F")
        x <- x / normx
        niter <- niter + 1
    }
    if (niter > maxiter)
        warning("Number of iterations exceeded 'maxiter'.")

    return(est)
}

###
### p o l y v a l . R  Polynomial Evaluation
###


polyval <- function(p, x) {
    if (length(x) == 0) return(c())
    if (length(p) == 0) return(0 * x)
    if (!is.vector(p, mode="numeric") && !is.vector(p, mode="complex"))
        stop("Argument 'p' must be a real or complex vector.")
    if (!is.vector(x) && !is.matrix(x))
        stop("Argument 'x' must be a real or complex matrix.")

    n <- length(p)
    y <- outer(x[1:length(x)], (n-1):0, "^") %*% p
    dim(y) <- dim(x)
    return(y)
}

polyvalm <- function(p, A) {
    stopifnot(is.numeric(p) || isempty(p), is.numeric(A))
    if (!is.vector(p))
        stop("Argument 'p' must be a numeric vector.")
    if (!is.matrix(A) || nrow(A) != ncol(A))
        stop("Argument 'A' must be a square matrix.")
    
    n <- length(p)
    if (n == 0) {
        y <- zeros(nrow(A))
    } else if (n == 1) {
        y <- diag(p, n)
    } else {
        id <- eye(nrow(A))
        y <- p[1] * id
        for (i in 2:n)
            y <- y %*% A + p[i] * id
    }
    return(y)
}

##
##  b e r n o u l l i . R  Bernoulli numbers and polynomials
##


bernoulli <- function(n, x) {
    stopifnot(length(n) == 1, floor(n) == ceiling(n), n >= 0)
    if (missing(x)) {
        if (n == 0) return(1.0)
        bf <- function(n) -n * zeta(1-n)
        bx <- c(1.0, sapply(1:n, bf))
        bx[2] <- -0.5
    } else {
        stopifnot(is.numeric(x))
        bn <- bernoulli(n)
        cn <- choose(n, 0:n)
        bx <-polyval(cn*bn, x)
    }
    bx
}


# euler <- function(n) {
#     stopifnot(length(n) >= 1, floor(n) == ceiling(n))
#     if (n == 0) return(1)
#     en <- numeric(n)
#     en[1] <- 0.0
#     en[2] <- -1.0
#     if (n < 4) return(c(1.0, en[1:n]))
#     for (m in 2:floor(n/2)) {
#         s <- 1.0
#         for (k in 1:(m-1)) {
#             r = 1.0
#             for (j in 1:(2*k)) {
#                 r <- r * (2*m - 2*k + j) / j
#             }
#             s <- s + r*en[2*k]
#         }
#         en[2*m] <- (-s)
#     }
#     c(1.0, en)
# }

##
##  c o n v . R  Polynomial Convolution
##


conv <- function(x, y) {
    if ( (!is.vector(x, mode="numeric") && !is.vector(x, mode="complex")) ||
         (!is.vector(y, mode="numeric") && !is.vector(y, mode="complex")) )
        stop("Arguments 'x' and 'y' must be real or complex vectors.")

    lx <- length(x)
    ly <- length(y)
    n <-  lx +  ly - 1
    z <- fft(fft(c(x, rep(0, n - lx))) * fft(c(y, rep(0, n - ly))),
             inverse = TRUE) / n

    if (is.numeric(x) && is.numeric(y))
        z <- Re(z)
    return(z)
}

##
##  e l l i p . R  Elliptic Integrals
##


ellipke <- function(m, tol = .Machine$double.eps) {
    stopifnot(is.numeric(m))
    m <- c(m)
    if (any(m < 0) || any(m > 1))
        stop("Some elements of argument 'm' are out of range.")

    a0 <- 1
    b0 <- sqrt(1-m)
    s0 <- m
    i1 <- 0
    mm <- 1
    while (mm > tol) {
        a1 <- (a0+b0)/2
        b1 <- sqrt(a0*b0)
        c1 <- (a0-b0)/2
        i1 <- i1 + 1
        w1 <- 2^i1 * c1^2
        mm <- max(w1)
        s0 <- s0 + w1
        a0 <- a1
        b0 <- b1
    }
    k <- pi / (2*a1)
    e <- k * (1-s0/2)
    im <- finds(m == 1)
    if (!isempty(im)) {
        e[im] <- ones(length(im), 1)
        k[im] <- Inf
    }
    return(list(k = k, e = e))
}


##  Jacobi elliptic functions
ellipj <- function(u, m, tol = .Machine$double.eps) {
    stopifnot(is.numeric(u), is.numeric(m) || is.complex(m))
    u <- c(u); m <- c(m)
    if (length(u) == 1) {
        u <- rep(u, length(m))
    } else if (length(m) == 1) {
        m <- rep(m, length(u))
    } else {
        if (length(u) != length(m))
            stop("Arguments 'u' and 'm' must be of the same length.")
    }
    if (any(m < 0) || any(m > 1))
        stop("Some elements of argument 'm' are out of range.")

    mmax <- length(u); chunk <- 10
    cn <- sn <- dn <- numeric(mmax)
    a  <- b  <- cc <- matrix(0, nrow = chunk, ncol = mmax)
    a[1, ]  <- 1
    b[1, ]  <- sqrt(1-m)
    cc[1, ] <- sqrt(m)

    n <- numeric(mmax)
    i <- 1
    while (any(abs(cc[i, ]) > tol)) {
        i <- i + 1
        if (i > nrow(a)) {
          a  <- rbind(a,  matrix(0, chunk, mmax))
          b  <- rbind(b,  matrix(0, chunk, mmax))
          cc <- rbind(cc, matrix(0, chunk, mmax))
        }
        a[i, ]  <- 0.5 * (a[i-1, ] + b[i-1, ])
        b[i, ]  <-   sqrt(a[i-1, ] * b[i-1, ])
        cc[i, ] <- 0.5 * (a[i-1, ] - b[i-1, ])
        inds <- which(abs(cc[i, ]) <= tol & abs(cc[i-1, ]) > tol)
        if (!isempty(inds)) {
          mi <- 1; ni <- length(inds)  # [mi,ni] <- size(inds)
          n[inds]     <- rep(i-1, ni)  # repmat((i-1), mi, ni)
        }
    }

    phin <- matrix(0, nrow = i, ncol = mmax)
    phin[i, ] <- 2^n * a[i, ] * u
    while (i > 1) {
        i <- i - 1
        inds <- which(n >= i)
        phin[i, ] <- phin[i+1, ]
        if (!isempty(inds)) {
          phin[i, inds] <- 0.5 * (asin(cc[i+1, inds] * 
              sin(phin[i+1, inds] %% (2*pi)) / a[i+1, inds]) + phin[i+1,inds])
        }
    }
    # the general case
    sn <- sin(phin[1, ] %% (2*pi))
    cn <- cos(phin[1, ] %% (2*pi))
    dn <- sqrt(1 - m * sn^2)

    # some special cases
    m1 <- which(m == 1)         # special case m = 1
    sn[m1] <- tanh(u[m1])
    cn[m1] <- sech(u[m1])
    dn[m1] <- sech(u[m1])
    dn[m == 0] <- 1             # special case m = 0

    return(list(sn = sn, cn = cn, dn = dn))
}

##
##  o d e 5 4 . R  ODE Solver
##


ode45 = function(f, t0, tfinal, y0, ..., atol = 1e-6, hmax = 0.0)
{
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1, 
              is.numeric(tfinal), length(tfinal) == 1)
    if (is.vector(y0)) {
        y0 <- as.matrix(y0)
    }
    else if (is.matrix(y0) && ncol(y0) != 1) {
        stop("Argument 'y0' must be a vector or single column matrix.")
    }
    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)

    pow <- 1/6                      # see p.91 in Ascher & Petzold
    nsteps <- 1e3 * (tfinal - t0)   # estimated number of steps
    if (hmax == 0.0)
        hmax <- (tfinal - t0)/2.5   # max stepsize

    # Define the Dormand-Prince 4(5) coefficients
    dp = matrix(c(0, 0, 0, 0, 0, 0,
                  1/5, 0, 0, 0, 0, 0,
                  3/40, 9/40, 0, 0, 0, 0,
                  44/45, -56/15, 32/9, 0, 0, 0,
                  19372/6561, -25360/2187, 64448/6561, -212/729, 0, 0,
                  9017/3168,  -355/33, 46732/5247, 49/176, -5103/18656, 0,
                  35/384, 0, 500/1113, 125/192, -2187/6784, 11/84),
                nrow = 7, ncol = 6, byrow=TRUE)
    b4 = c(5179/57600, 0, 7571/16695, 393/640, -92097/339200, 187/2100, 1/40)
    b5 = c(35/384, 0, 500/1113, 125/192, -2187/6784, 11/84, 0)
    cc = rowSums(dp)

    # Initialization
    t <- t0
    hmin <- (tfinal - t)/1e20
    h <- (tfinal - t)/100           # initial step size guess
    x <- as.matrix(y0)              # ensure x is a column vector

    nstates <- size(x,1)
    tout <- zeros(nsteps, 1)        # preallocating memory
    xout <- zeros(nsteps, nstates)

    nsteps_rej <- 0
    nsteps_acc <- 1
    tout[nsteps_acc] <- t           # first output time
    xout[nsteps_acc,] <- x          # first output solution = IC's

    # Main loop using Dormand-Prince 4(5) pair
    kk <- x %*% zeros(1, 7)
    kk[, 1] <- f(t, x)
    while (t < tfinal && h >= hmin) {
        if (t + h > tfinal) h <- tfinal - t
        for (j in 1:6)
            kk[, j+1] <- f(t + cc[j+1]*h, x + h*kk[, 1:j] %*% as.matrix(dp[j+1, 1:j]))

        # compute the 4th and 5th order estimates
        x4 <- x + h * (kk %*% b4)
        x5 <- x + h * (kk %*% b5)

        # estimate the errors
        gamma1 <- x5 - x4                   # local truncation error
        delta = Norm(gamma1, Inf);          # actual error
        tau = atol * max(Norm(x, Inf), 1.0)  # allowable error

        # update solution only if the error is acceptable
        if (delta < tau) {
            t = t + h
            x = x5              # "local extrapolation"

            nsteps_acc <- nsteps_acc + 1
            tout[nsteps_acc] <- t
            xout[nsteps_acc, ] <- x
            kk[, 1] <- kk[, 7]

        } else {                # unacceptable integration step
            nsteps_rej <- nsteps_rej + 1
        }

        # update the step size
        if (delta == 0.0) delta <- 1e-16
        h <- min(hmax, 0.8 * h * (tau/delta)^pow)
    }

    # Trim output
    if (nsteps_acc < nsteps) {
        tout <- tout[1:nsteps_acc]
        xout <- xout[1:nsteps_acc, ]
    }
    if (t < tfinal)
        warning("Step size grew too small.")

    return(list(t = tout, y = xout))
}

##
##  c a r t 2 s p h . R  Coordinate Transformations
##


cart2sph <- function(xyz) {
    stopifnot(is.numeric(xyz))

    # Transform cartesian to spherical coordinates
    if (is.vector(xyz) && length(xyz) == 3) {
        x <- xyz[1];  y <- xyz[2];  z <- xyz[3]
        m <- 1
    } else if (is.matrix(xyz) && ncol(xyz) == 3) {
        x <- xyz[, 1];  y <- xyz[, 2];  z <- xyz[, 3]
        m <- nrow(xyz)
    } else
        stop("Input must be a vector of length 3 or a matrix with 3 columns.")
    
    hypotxy <- hypot(x, y)
    r       <- hypot(hypotxy, z)
    phi     <- atan2(z, hypotxy)
    theta   <- atan2(y, x)

    if (m == 1) tpr <- c(theta, phi, r)
    else        tpr <- cbind(theta, phi, r)
    return(tpr)
}


sph2cart <- function(tpr) {
    stopifnot(is.numeric(tpr))

    # Transform spherical to cartesian coordinates
    if (is.vector(tpr) && length(tpr) == 3) {
        theta <- tpr[1];  phi <- tpr[2];  r <- tpr[3]
        m <- 1
    } else if (is.matrix(tpr) && ncol(tpr) == 3) {
        theta <- tpr[, 1];  phi <- tpr[, 2];  r <- tpr[, 3]
        m <- nrow(tpr)
    } else
        stop("Input must be a vector of length 3 or a matrix with 3 columns.")

    z   <- r * sin(phi)
    tmp <- r * cos(phi)
    x   <- tmp * cos(theta)
    y   <- tmp * sin(theta)

    if (m == 1) xyz <- c(x, y, z)
    else        xyz <- cbind(x, y, z)
    return(xyz)
}


cart2pol <- function(xyz) {
    stopifnot(is.numeric(xyz))

    # Transform cartesian to cylindrical or polar coordinates
    if (is.vector(xyz) && (length(xyz) == 2 || length(xyz) == 3)) {
        x <- xyz[1];  y <- xyz[2]
        m <- 1; n <- length(xyz)
    } else if (is.matrix(xyz) && (ncol(xyz) == 2 || ncol(xyz) == 3)) {
        x <- xyz[, 1];  y <- xyz[, 2]
        m <- nrow(xyz); n <- ncol(xyz)
    } else
        stop("Input must be a vector of length 3 or a matrix with 3 columns.")

    phi <- atan2(y, x)
    r   <- hypot(x, y)

    if (n == 2) {
        if (m == 1) prz <- c(phi, r)
        else        prz <- cbind(phi, r)
    } else {
        if (m == 1) {
            z <- xyz[3]
            prz <- c(phi, r, z)
        } else {
            z <- xyz[, 3]
            prz <- cbind(phi, r, z)
        }
    }
    return(prz)
}


pol2cart <- function(prz) {
    stopifnot(is.numeric(prz))

    # Transform polar or cylindrical to cartesian coordinates
    if (is.vector(prz) && (length(prz) == 2 || length(prz) == 3)) {
        phi <- prz[1];  r <- prz[2]
        m <- 1; n <- length(prz)
    } else if (is.matrix(prz) && (ncol(prz) == 2 || ncol(prz) == 3)) {
        phi <- prz[, 1];  r <- prz[, 2]
        m <- nrow(prz); n <- ncol(prz)
    } else
        stop("Input must be a vector of length 3 or a matrix with 3 columns.")

    x <- r * cos(phi)
    y <- r * sin(phi)

    if (n == 2) {
        if (m == 1) xyz <- c(x, y)
        else        xyz <- cbind(x, y)
    } else {
        if (m == 1) {
            z <- prz[3]
            xyz <- c(x, y, z)
        } else {
            z <- prz[, 3]
            xyz <- cbind(x, y, z)
        }
    }
    return(xyz)
}

##
##  h i s t c . R  Histogram Count
##


histc <- function(x, edges) {
    stopifnot(is.numeric(x), is.numeric(edges))

    edges <- c(edges)
    n <- length(edges)
    if (is.unsorted(edges))
        stop("Argument 'edges' must be a monotonically non-decreasing vector.")

    if (length(edges) == 1) {
        bin <- numeric(length(x))
        if (is.matrix(x)) dim(bin) <- c(n, ncol(x))
    	return(list(cnt = 0, bin = bin))
    }

    bin <- numeric(length(x))
    if (is.vector(x)) {
        cnt <- numeric(n)
        for (i in 1:(n-1)) {
            li <- edges[i] <= x & x < edges[i+1]
            cnt[i] <- sum(li)
            bin[li] <- i
        }
        li <- x == edges[n]
        cnt[n] <- sum(li)
        bin[li] <- n

    } else if (is.matrix(x)) {
        cnt <- matrix(0, n, ncol(x))
        for (i in 1:(n-1)) {
            li <- edges[i] <= x & x < edges[i+1]
            cnt[i, ] <- apply(li, 2, sum)
            bin[li] <- i
        }
        li <- x == edges[n]
        cnt[n, ] <- apply(li, 2, sum)
        bin[li] <- n

    } else {
        stop("Argument 'x' must be a numeric vector or matrix.")
    }

    dim(bin) <- dim(x)
    return(list(cnt = cnt, bin = bin))
}


histss <- function(x, n = 100, plotting = FALSE) {
    stopifnot(is.numeric(x), is.numeric(n))
    x <- c(x)
    if (length(n) > 1 || n < 2 || floor(n) != ceiling(n))
        stop("Argument 'n' must be an integer greater than 1.")

    D <- C <- numeric(n-1)
    for (i in 1:(n-1)) {
        D[i] <- diff(range(x)) / (i+1)

        E    <- seq(min(x), max(x), length.out = i+1)
        hp   <- hist(x, breaks = E, plot = FALSE)
        ki   <- hp$counts
        k    <- mean(ki)
        v    <- sum((ki-k)^2) / (i+1)

        C[i] <- (2*k - v) / D[i]^2                  # cost function
    }

    idx  <- which.min(C)
    optD <- D[idx]
    E    <- seq(min(x), max(x), length = idx+1)
    h    <- hist(x, breaks = E, plot = plotting)    # rug(x)

    if (plotting) invisible(h)
    else          return(h)
}

##
##  e u l e r H e u n . R  Euler-Heun ODE Solver
##


euler_heun <- function(f, a, b, y0, n = 100, improved = TRUE, ...) {
    stopifnot(is.numeric(a), is.numeric(b), length(a) == 1, length(b) == 1,
              is.numeric(y0), length(y0) == 1)

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)
    if (length(f(a, y0)) != 1)
        stop("Argument function 'f' must be an univariate function.")

    h <- (b - a)/n
    t <- seq(a, b, length.out = n+1)
    y <- numeric(n+1)
    y[1] <- y0

    for (i in 1:n) {
        y[i+1] <- y[i] + h*f(t[i], y[i])
        if (improved) {
            y[i+1] <- y[i] + h * (f(t[i], y[i]) + f(t[i+1], y[i+1]))/2.0
        }
    }
    return(list(t = t, y = y))
}

##
##  s q r t m . R  Matrix Square and p-th Roots
##


sqrtm <- function(A, kmax = 20, tol = .Machine$double.eps^(1/2)) {
	stopifnot(is.numeric(A), is.matrix(A))
	if (nrow(A) != ncol(A))
	    stop("Matrix 'A' must be square.")

	# should be "try(solve(A))"
	P0 <- A; Q0 <- diag(nrow(A))

	k <- 0  # then k <- 1
	while (norm(A - P0 %*% P0, 'F') > tol && k < kmax) {
		P1 <- 0.5 * (P0 + solve(Q0))
		Q1 <- 0.5 * (Q0 + solve(P0))
		P0 <- P1
		Q0 <- Q1
		k <- k + 1
	}

	# k < 0 if iteration has not converged.
	if (k >= kmax) k <- -1

	# return sqrtm(A) and sqrtm(A)^-1
	return(list(B = P0, Binv = Q0, k = k, acc = norm(A - P0 %*% P0, 'F')))
}


signm <- function(A, kmax = 20, tol = .Machine$double.eps^(1/2)) {
    A %*% sqrtm(A %*% A)$Binv
}


rootm <- function(A, p, kmax = 20, tol = .Machine$double.eps^(1/2)) {
	stopifnot(is.numeric(A), is.matrix(A))
	if (nrow(A) != ncol(A))
	    stop("Matrix 'A' must be square.")

	n <- nrow(A)
	A0 <- A
	p0 <- p

    # err <- try(solve(A), silent = TRUE)
    # if (class(err == "try-error")) ... else ...

	if (p %% 2 == 1) {
		A <- A %*% A
		p <- 2*p
	} else {
		while (p %% 4 == 0) {
			A <- sqrtm(A)$B
			p <- p / 2
		}
	}

	N <- N0 <- 1
	acc <- Inf
	k <- 0
	while (acc > tol && k < kmax) {  # && acc <= accp
		N <- 2*N
		wN <- cos(2*pi/N) + 1i * sin(2*pi/N)  # N-th root of unity

		# summing with roots of unity
		S <- solve(A)/4
		for (j in 1:(N-1)) {
			B <- solve( A - ((1-wN^j)/(1+wN^j))^p * diag(n) )
			S <- S + B * wN^j/(1+wN^j)^2
		}
		S <- 2*p*sin(pi/p)/N * A %*% S
		S <- Re(S)

		Sp <- S
		for (j in 1:(p0-1)) Sp <- Sp %*% S

		acc <- norm(A0 - Sp, 'F')
		k <- k + 1
	}

	# k < 0 if iteration has not converged.
	if (k >= kmax) k <- -1

	return(list(B = S, k = k, acc = acc))
}

isposdef <- function(A, psd = FALSE, tol = 1e-10) {
    if (nrow(A) != ncol(A)) {
        warning("Matrix 'A' is not quadratic.\n", .call = FALSE)
        a <- FALSE
    } else if (any(abs(A - t(A)) > tol)) {
        warning("Matrix 'A' is not symmetric.\n", .call = FALSE)
        a <- FALSE
    } else {
        e <- try(chol(A, pivot = psd), silent = TRUE)
        if(inherits(e, "try-error")) {
            a <- FALSE
        } else {
            a <- TRUE
        }
    }
    return(a)
}

##
##  q u a d 2 d . R  and  q u a d v .R
##


quad2d <- function(f, xa, xb, ya, yb, n = 32, ...) {
    stopifnot(is.numeric(xa), length(xa) == 1, is.numeric(ya), length(ya) == 1,
              is.numeric(xb), length(xb) == 1, is.numeric(yb), length(yb) == 1)

    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)

    # Get Gauss-Legendre nodes and weights in x- and y-direction.
    cx <- gaussLegendre(n, xa, xb)
    x  <- cx$x
    wx <- cx$w
    cy <- gaussLegendre(n, ya, yb)
    y  <- cy$x
    wy <- cy$w

    # Compute function f at all nodes in x- and y-direction
    mgrid <- meshgrid(x, y)
    Z <- f(mgrid$X, mgrid$Y)

    Q <- wx %*% Z %*% as.matrix(wy)
    return(Q[,])
}

###
### POW2.R  Raise 2 to some power
###

pow2 <- function(f, e) {
    if (!is.numeric(f) && !is.complex(f))
        stop("Argument 'f' must be numeric or complex.")
    if (missing(e)) {
        e <- f
        f <- rep(1, length(e))
    } else {
        if (!is.numeric(e) && !is.complex(e))
            stop("Argument 'e' must be numeric or complex.")
        if (is.complex(f) || is.complex(e)) {
            f <- Re(f)
            e <- Re(e)
            warning("Imaginary part of arguments ignored.")
        }
    }
    if (length(f) != length(e))
        stop("Arguments 'e' and 'f' must be of same length.")

    return(f * 2^e)
}

##
##  e p s . R
##


eps <- function(x = 1.0) {
    stopifnot(is.numeric(x))

    x <- max(abs(x))

    if (x <  .Machine$double.xmin) {
        e <- .Machine$double.xmin
    } else {
        e <- 2^floor(log2(x)) * .Machine$double.eps
    }
    e
}

##
##  s t r i n g s . R
##


strcat <- function(s1, s2 = NULL, collapse = "") {
	stopifnot(is.character(collapse))
	if (!is.vector(s1, mode = "character"))
	    stop("Argument 's1' must be a character vector.")

	if (is.null(s2)) {
	    paste(s1, collapse=collapse)
	} else {
	    if (!is.vector(s2, mode = "character"))
	        stop("Argument 's2' must be a character vector.")
	    else
	        paste(rep(s1, each = length(s2)), s2, sep = collapse)
    }
}

strcmp <- function(s1, s2) {
	if (!is.vector(s1, mode="character") || !is.vector(s1, mode="character"))
	    stop("Arguments 's1' and 's2' must be character vectors.")

    if (length(s1) == length(s2))
        all(s1 == s2)
    else
	    FALSE
}

strcmpi <- function(s1, s2) {
	if (!is.vector(s1, mode="character") || !is.vector(s1, mode="character"))
	    stop("Arguments 's1' and 's2' must be character vectors.")

    strcmp(tolower(s1), tolower(s2))
}

strTrim <- function(s) {
    if (! is.character(s))
        stop("Argument 's' must be a character vector.")

    sub("\\s+$", "", sub("^\\s+", "", s))
}

deblank <- function(s) {
    if (! is.character(s))
        stop("Argument 's' must be a character vector.")

    sub("\\s+$", "", s)
}

blanks <- function(n = 1) {
    stopifnot(is.numeric(n), length(n) == 1, n >= 0)
    n <- floor(n)

    paste(rep(" ", n), collapse="")
}

strjust <- function(s, justify = c("left", "right", "center")) {
    if (! is.character(s))
        stop("Argument 's' must be a character vector.")

    justify <- match.arg(justify)

    s <- strTrim(s)
    n <- length(s)
    M <- nchar(s)
    m <- max(M)

    S <- character(n)
    for (i in 1:n) {
        k <- m - M[i]
        if (justify == "left") {
            S[i] <- paste(s[i], blanks(k), sep = "", collapse="")
        } else if (justify == "right") {
            S[i] <- paste(blanks(k), s[i], sep = "", collapse="")
        } else {  # justify == "center"
            kl <- k %/% 2
            kr <- k - kl
            S[i] <- paste(blanks(kl), s[i], blanks(kr), sep = "", collapse="")
        }
   }
   return(S)
}

strRep <- function(s, old, new) {
    # Find and replace substring
    if (! is.character(s))
        stop("Argument 's' must be a character vector.")
    if (!is.character(old) || !is.character(new) ||
        length(old) != 1   || length(new) != 1)
        stop("Arguments 'old' and 'new' must be simple character strings.")

    gsub(old, new, s, fixed = TRUE)
}

##
##  s t e e p _ d e s c e n t . R  Minimization by Steepest Descent
##


steep_descent <- function (x0, f, g = NULL, info = FALSE,
                           maxiter = 100, tol = .Machine$double.eps^(1/2)) {
    eps <- .Machine$double.eps
    if (! is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")
    n <- length(x0)

    # User provided or numerical gradient
    f <- match.fun(f)
    if (is.null(g)) g <- function(x) grad(f, x)
    else            g <- match.fun(g)

    if (info) cat(0, "\t", x0, "\n")

    x <- x0
    k <- 1
    while (k <= maxiter) {
        f1 <- f(x)
        g1 <- g(x)
        z1 <- sqrt(sum(g1^2))
        if (z1 == 0) {
            warning(
                paste("Zero gradient at:", x, f1, "-- not applicable.\n"))
            return(list(xmin = NA, fmin = NA, niter = k))
        }
        # else use gradient as unit vector
        g1 <- g1 / z1

        a1 <- 0
        a3 <- 1; f3 <- f(x - a3*g1)

        # Find a minimum on the gradient line (or line search)
        while (f3 >= f1) {
            a3 <- a3/2; f3 <- f(x - a3*g1)
            if (a3 < tol/2) {
                if (info)
                    cat("Method of steepest descent converged to:", x, "\n")
                x[x < eps] <- 0
                return(list(xmin = x, fmin = f(x), niter = k))
            }
        }

        # Check an intermediate point (for faster convergence)
        a2 <- a3/2; f2 <- f(x - a2*g1)
        h1 <- (f2 - f1)/a2
        h2 <- (f3 -f2)/(a3 - a2)
        h3 <- (h2 - h1)/a3
        a0 <- 0.5*(a2 - h1/h3); f0 <- f(x - a0*g1)

        if (f0 < f3) a <- a0
        else         a <- a3

        x <- x - a*g1
        if (info) cat(k, "\t", x, "\n")
        k <- k + 1
    }
    if(k > maxiter)
        warning("Maximum number of iterations reached -- not converged.\n")
    return(list(xmin = NA, fmin = NA, niter = k))
}

##
##  c o m p l e x s t e p . R  Complex Step Derivation
##


complexstep <- function(f, x0, h = 1e-20, ...) {
    stopifnot(is.numeric(x0), is.numeric(h), h < 1e-15)
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    try(fx0hi <- f(x0 + h*1i))
    if (inherits(fx0hi, "try-error"))
        stop("Function 'f' does not appear to accept complex arguments.")
    
    if (!is.complex(fx0hi) || !is.double(f(x0))) {
        # apply Richardson's method
        f_csd <- numderiv(f, x0, h = 0.1)$df
        warning("Some maginary part is zero: applied Richardson instead.")
    } else {
        # apply complex-step method
        f_csd <- Im(fx0hi) / h          # Im(f(x0 + h * 1i)) / h
    }
    return(f_csd)
}


grad_csd <- function(f, x0, h = 1e-20, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    z <- f(x0)
    n <- length(x0); m <- length(z)
    if (m > 1)
        stop("Funktion 'f' does not return a scalar; call 'Jacobian_csd'.")

    G <- rep(NA, n)
    for (k in 1:n) {
        x1 <- x0
        x1[k] <- x1[k] + h * 1i
        G[k] <- Im(f(x1)) / h
    }
    return(G)
}


jacobian_csd <- function(f, x0, h = 1e-20, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    z <- f(x0)
    n <- length(x0); m <- length(z)
    J <- matrix(NA, nrow = m, ncol = n)

    for (k in 1:n) {
        x1 <- x0
        x1[k] <- x1[k] + h * 1i
        J[ , k] <- Im(f(x1)) / h
    }
    # drop matrix dimensions if n = m = 1
    # if (m == 1 && n == 1) J <- J[,]
    return(J)
}


hessian_csd <- function(f, x0, h = 1e-20, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    z <- f(x0)
    n <- length(x0); m <- length(z)
    if (m > 1)
        stop("Funktion 'f' does not return a scalar, as needed for Hessian.")
    
    H <- matrix(NA, nrow = n, ncol = n)
    for (i in 1:n) {
        fi <- function(x) {
            x[i] <- x[i] + h*1i
            Im(f(x)) / h
        }
        for (j in 1:n) {
            ff <- function(x) {
                xx <- x0
                xx[j] <- x
                fi(xx)
            }
            H[i, j] <- numderiv(ff, x0[j])$df
        }
    }
    return(H)
}


laplacian_csd <- function(f, x0, h = 1e-20, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    z <- f(x0)
    n <- length(x0); m <- length(z)
    if (m > 1)
        stop("Funktion 'f' does not return a scalar, as needed for Lapacian.")
    
    L <- rep(NA, n)
    for (i in 1:n) {
        fi <- function(x) {
            x[i] <- x[i] + h*1i
            Im(f(x)) / h
        }
        ff <- function(x) {
            xx <- x0
            xx[i] <- x
            fi(xx)
        }
        L[i] <- numderiv(ff, x0[i])$df
    }
    return(sum(L))
}

cutpoints <- function(x, nmax = 8, quant = 0.95) {
    stopifnot(is.numeric(x), is.numeric(nmax), is.numeric(quant))
    if (length(nmax) != 1 || floor(nmax) != ceiling(nmax) || nmax <= 0)
        stop("Argument 'nmax' must be a positive integer.")
    if (length(quant) != 1 || quant < 0 || quant > 1)
        stop("Argument 'quant' must be a numeric value in [0,1].")

    if (length(x) == 1) return(list(cutp = c(), cutd = c()))
    if (!is.vector(x))  x <- c(x)
    if (is.unsorted(x)) x <- sort(x)

    d <- diff(x)
    if (quant == 0.0) n <- nmax
    else {
        q <- quantile(d, probs = quant)
        n <- min(nmax, sum(d >= q))
    }

    o <- order(d)
    inds <- o[length(d):(length(d)-(n-1))]
    dc <- d[inds]
    xc <- x[inds] + dc/2

    o <- order(xc)
    return(list(cutp = xc[o], cutd = dc[o]))
}

##  Example

##
##  q u a d p r o g . R  Quadratic Programming
##


quadprog <- function(
    C, d,                     # min! 1/2 x'Cx + d'x
    A = NULL,   b = NULL,     # A x <= b
    Aeq = NULL, beq = NULL,   # Aeq x == beq
    lb = NULL,  ub = NULL)    # lb <= x <= ub
{
    if (!requireNamespace("quadprog", quietly = TRUE)) {
        stop("quadprog needed for this function to work. Please install it.",
              call. = FALSE)
    }

    stopifnot(is.numeric(C), is.matrix(C), is.numeric(d), is.vector(d))
    if (is.null(A) && !is.null(b) || !is.null(A) && is.null(b))
        stop("If any, both 'A' and 'b' must be NULL.")
    if (is.null(Aeq) && !is.null(beq) || !is.null(Aeq) && is.null(beq))
        stop("If any, both 'Aeq' and 'beq' must be NULL.")

    if (any(C != t(C)))
        warning("Argument 'C' is not a symmetric matrix.")
    if (any(eigen(C)$values <= 0))
        warning("Matrix 'C' is not positive definite.")

    # check matrix sizes for C, A, and Aeq
    mc  <- nrow(C); nc  <- ncol(C); n <- nc
    if (mc != nc)
        stop("Argument 'C' must be a quadratic matrix")
    if (length(d) != nc)
        stop("Dimensions of 'C' and 'd' do not fit.")
    if (is.null(Aeq)) {
        meq <- 0
    } else if (is.vector(Aeq)) {
        Aeq <- matrix(Aeq, 1)
        meq <- 1
    } else {
        meq <- nrow(Aeq)
    }
    if (!is.null(Aeq) && ncol(Aeq) != n)
        stop("Dimensions of 'C' and 'Aeq' do not fit.")

    # check lower and upper bounds
    if (is.null(lb)) {
        diag_lb <- NULL
    } else {
        if (length(lb) == 1) {
            lb <- rep(lb, n)
        } else if (length(lb) != n) {
            stop("Length of 'lb' and dimensions of C do not fit.")
        }
        diag_lb <- diag(n)
    }
    if (is.null(ub)) {
        diag_ub <- NULL
    } else {
        if (length(ub) == 1) {
            ub <- rep(ub, n)
        } else if (length(ub) != n) {
            stop("Length of 'ub' and dimensions of C do not fit.")
        }
        diag_ub <- -diag(n) # quadprog requires -x >= -ub
        ub <- -ub
    }

    # collect all constraints into one matrix H and vector
    if (!is.null(A)) {
        A <- -A
        b <- -b
    }
    H <- rbind(Aeq, A, diag_lb, diag_ub)
    f <- c(beq, b, lb, ub)

    qps <- quadprog::solve.QP(C, -d, t(H), f, meq = meq)

    eflag <- 0
    if (all(C == t(C)) && all(eigen(C)$values > 0)) eflag <- 1

    list(xmin = qps$solution, fval = qps$value, eflag = eflag)
}

##
##  l i n e a r p r o j . R  Linear and affine projection
##


linearproj <- function(A, B) {
    # Return the projection of points in the columns of B
    # onto the linear subspace spaned by the columns of A.
    stopifnot(is.numeric(A), is.numeric(B))
    if (!is.matrix(A)) A <- as.matrix(A)
    if (!is.matrix(B)) B <- as.matrix(B)
    nA <- nrow(A); mA <- ncol(A)
    nB <- nrow(B); mB <- ncol(B)
    if (nA != nB)  # dimension of R^n
        stop("Arguments 'A', 'B' must have the same number of rows.")
    if (Rank(A) < mA)
        stop("Matrix 'A' does not have maximal rank -- not a basis.")

    P  <- qr.solve(t(A) %*% A, t(A) %*% B)
    Q <- A %*% P
    return(list(P = P, Q = Q))
}


affineproj <- function(x0, C, b, unbound = TRUE, maxniter = 100) {
    if (unbound) {
        # Return projection of x0 onto the affine subspace 
        # C x = b and the distance of x0 from this subspace.
        mC <- nrow(C); nC <- ncol(C)    # n dimension, m codimension
        CC <- C %*% t(C)
        xp <- (diag(1, nC) - t(C) %*% qr.solve(CC, C)) %*% x0 + 
               t(C) %*% qr.solve(CC, b)
        d <- Norm(xp)
        return(list(proj = xp, dist = d, niter = 0))
    } else {
        # C fast projection method for enforcing equality and
        # positivity constraints: C x = b and x >= 0
        svdC <- svd(C); x <- x0
        svdmat <- svdC$v %*% diag(1/svdC$d, length(svdC$d)) %*% t(svdC$u)
        iterate <- TRUE; niter <- 0
        while(iterate & niter <= maxniter) { 
            niter <- niter + 1
            bCx <- (b - c(C %*% x))
            x <- x + c(svdmat %*% bCx)
            if (any(x < 0)) x[x < 0] <- 0 else iterate <- FALSE
        }
        d <- Norm(x0 - x)
        return(list(proj = x, dist = d, niter = niter))
    }
}

##
##  k r i g i n g . R  Kriging Interpolation
##


kriging <- function(u, v, u0, type = c("ordinary", "simple")) {
	stopifnot(is.numeric(u), is.numeric(v), is.numeric(u0))
	if (!is.matrix(u))
		stop("Argument 'u' must be a numeric matrix.")
	n <- nrow(u); m <- ncol(u)
	if (is.vector(v)) {
	    if (length(v) != n)
	    	stop("Length of vector 'v' must be equal to ncol(u).")
	} else if (is.matrix(v)) {
		if (ncol(v) == 1 || nrow(v) == n) {
			v <- c(v)
		} else
		    stop("As matrix 'v' must be a column vector (with ncol(u) elements).")
	} else {
	    stop("Argument 'v' must be a vector or matrix (with ncol(u) elements).")
    }
    if (is.vector(u0)) {
    	if (length(u0) == m) {
    	    u0 <- t(u0)
    	} else {
    	    stop("Length of vector 'u0' must be equal to ncol(u).")
    	}
    } else if (is.matrix(u0)) {
    	if (ncol(u0) != m)
    		stop("Matrix 'u0' must have the same number of colums as 'u'.")
    } else
        stop("Argument 'u0' must be a vector or matrix (with ncol(u) elements).")

    type <- match.arg(type)

    # Define the Variogram
    V  <- distmat(u, u)
    U0 <- distmat(u, u0)

    # Compute kriging formula
    if (type == "simple") {
        w <- v %*% inv(V) %*% U0

    } else if (type == "ordinary") {
    	k <- nrow(u0)
    	C <- matrix(1, n+1, n+1)
    	C[1:n, 1:n] <- V
    	C[n+1, n+1] <- 0

    	D <- matrix(1, n+1, k)
    	D[1:n, 1:k] <- U0

    	v <- c(v, 0)
    	w <- v %*% inv(C) %*% D

    } else  # ntype = 0
        stop("Argument 'type' can only be 'simple' or 'ordinary'.")

    drop(w)     # return as vector
}

###
### DOT.R  Scalar product
###

dot <- function(x, y) {
    if (length(x) == 0 && length(y) == 0) return(0)
    if (!(is.numeric(x) || is.complex(x)) ||
        !(is.numeric(y) || is.complex(y)))
        stop("Arguments 'x' and 'y' must be real or complex.")
    x <- drop(x); y <- drop(y)
    if (any(dim(x) != dim(y)))
        stop("Matrices 'x' and 'y' must be of same size")

    if (is.vector(x) && is.vector(y)) {
        dim(x) <- c(length(x), 1)
        dim(y) <- c(length(y), 1)
    }
    x.y <- apply(Conj(x) * y, 2, sum)
    return(x.y)
}

##
##  p o l y A p p r o x . R  Polynomial Approximation
##


polyApprox <- function(f, a, b, n, ...) {
    if (!is.numeric(a) || !is.numeric(b) || !is.numeric(n) ||
        length(a) != 1 || length(b) != 1 || length(n) != 1 ||
        a >= b || n <= 0)
        stop("One of arguments 'a', 'b', or 'n' incorrectly chosen.")

    f1 <- match.fun(f)
    f  <- function(x) f1(x, ...)

    # Compute the Chebyshev coefficients
    cP <- chebPoly(n)
    cC <- chebCoeff(f, a, b, n)
    pC <- drop(cC %*% cP)
    c0 <- cC[1]

    # Compute the corresponding polynomial
    q  <- c(2, -(b+a))/(b-a)
    p  <- polytrans(pC, q)
    p  <- polyadd(p, c(-c0/2))

    rf <- function(x) polyval(p, x)
    ep <- fnorm(f, rf, a, b, p = Inf)
    return(list(p = p, f = rf, cheb.coeff = pC, estim.prec = ep))
}

###
### COMPAN.R  Polynom
###

compan <- function(p) {
	if (length(p) == 0) return(c())
	if ( !is.vector(p, mode="numeric") &&
	    (!is.vector(p, mode="complex")) )
		stop("Argument p must be a vector of real or complex numbers.")
	while(p[1] == 0 && length(p) >= 2) {
		p <- p[2:length(p)]
	}

	n <- length(p)
	if (n <= 1) {
		a <- c()
	} else {
		if (n == 2) {
			a <- -p[2]/p[1]
		} else {
			a <- diag(0, n-1, n-1)
			for (i in 2:(n-1)) {
				a[i, i-1] <- 1
			}
			a[1, ] <- -p[2:n]/p[1]
		}
	}
	return(a)
}

##
##  b s x f u n . R
##


bsxfun <- function(func, x, y) {
    stopifnot(is.numeric(x), is.numeric(y))
    # fun <- match.fun(f)
    # f <- function(x, y) fun(x, y, ...)

    dx <- dim(x); dy <- dim(y)
    if ( is.vector(x) && is.vector(y) ) {
        z <- mapply(func, x, y)

    } else if (is.matrix(x) && is.matrix(y) && all(dx == dy)) {
        z <- sweep(x, y, MARGIN = c(1, 2), FUN = func)
        # dim(z) <- dx
        
    } else if (is.array(x)  && is.array(y) && all(dx == dy)) {
        z <- mapply(func, x, y)
        dim(z) <- dx

    } else {
        stop("Argument 'x', 'y' must be vectors or arrays of the same size.")
    }
    return(z)
}


arrayfun <- function(func, ...) {
    # func <- match.fun(func)

    dots <- list(...)
    if (length(dots) < 1)
        stop("Empty list of arrays: Result cannot be computed.")
    
    d <- dim(dots[[1]])        # no test on array sizes to be fast
    r <- mapply(func, ...)     # no try ... catch, number of variables
    dim(r) <- d
    return(r)
}

##
##  p i n v . R  Pseudoinverse (Moore-Penrose Generalized Inverse)
##


pinv <- function (A, tol = .Machine$double.eps^(2/3)) {
    stopifnot(is.numeric(A), length(dim(A)) == 2, is.matrix(A))

    s <- svd(A)
    # D <- diag(s$d); Dinv <- diag(1/s$d)
    # U <- s$u; V <- s$v
    # A = U D V'
    # X = V Dinv U'

    p <- ( s$d > max(tol * s$d[1], 0) )
    if (all(p)) {
        mp <- s$v %*% (1/s$d * t(s$u))
    } else if (any(p)) {
        mp <- s$v[, p, drop=FALSE] %*% (1/s$d[p] * t(s$u[, p, drop=FALSE]))
    } else {
        mp <- matrix(0, nrow=ncol(A), ncol=nrow(A))
    }

    return(mp)
}

##
##  q u a d c c . R  Clenshaw-Curtis Quadrature
##


clenshaw_curtis <- function(f, a = -1, b = 1, n = 1024, ...) {
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (a == b) return(0)
    eps <- .Machine$double.eps  # assume a < b
    if (!is.finite(f(a))) a <- a + eps * sign(b-a)
    if (!is.finite(f(b))) b <- b - eps * sign(b-a)

    # Evaluate f at Chebyshev points
    x  <- cos(pi*(0:n)/n)
    fx <- f(0.5*((b-a)*x + (b+a)))/(2*n)

    # Fast Fourier transform
    g  <- Re(fft(fx[c(1:(n+1), n:2)]))

    # Chebyshev coefficients and weight vector
    d  <- c(g[1], g[2:n] + g[(2*n):(n+2)], g[n+1])
    w <- 0 * d
    w[seq(1, n+1, by=2)] <- 2/(1-(seq(0, n, by=2))^2)

    # Return the integral
    Q <- sum(w * d) * (b-a)/2
    return(Q)
}

##
##  s t d . R
##


std <- function(x, flag=0) {
    if (length(x) == 0) return(c())
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector or matrix.")

    n <- if (flag == 0) length(x) - 1 else length(x)
    sqrt(sum((x-mean(x))*(x-mean(x)))/n)
}


std_err <- function(x) {
    if (length(x) == 0) return(c())
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector or matrix.")

    sqrt(var(x)/length(x))
}

midpoint <- function(f, t0, tfinal, y0, tol = 1e-08, kmax = 101, ...){

    stopifnot (is.function(f),
               is.numeric(t0), length(t0) == 1,
               is.numeric(tfinal), length(tfinal) == 1,
               is.numeric(y0))
    if (is.vector(y0)) {
        y0 <- as.matrix(y0)
    } else if (is.matrix(y0)) {
        if (ncol(y0) != 1)
            stop ( "midpoint: Argument 'y0' must be row or column vector.")
    }

    fun <- match.fun(f)
    f <- function(t, y) fun (t, y, ...)

    n <- kmax
    y_length <- length(y0)
    y <- y0
    yout <- matrix (NA, n, y_length)
    yout[1, ] <- c(y0)
    
    dt <- (tfinal - t0) / (n-1)
    t <- 0.0
    tw <- 0.0
    ts <- linspace (t0, tfinal, n)

    myfun <- function(w) (w - y) - 0.5*dt*f(tw, w)

    f_length <- length(f(t0, y0))
    if (f_length != y_length)
        stop ("midpoint: Function f must have the same length as 'y0'.") 
    
    #  Choose solver used for root finding
    if (y_length == 1) {
        solver <- fzero
    } else {
        solver <- fsolve
    }
    for (i in 2:n) {
        t <- ts[i-1]
        tw <- t + 0.5 * dt
        w <- y + 0.5 * dt * f(t, y)
        w <- solver ( myfun, w)$x
        w <- 2.0 * w - yout[i-1, ]
        yout[i, ] <- w
        y <- w
    }

    if ( y_length == 1 ) {
        yout <- drop(yout)
    }

    return ( list(t = ts, y = yout))
}



.midp <- function(f, x0, xfinal, y0, nsteps) {
    # stopifnot(nsteps >= 2, x0 < xfinal, f(...) column vector)
    h <- (xfinal - x0) / nsteps
    x <- x0
    y1 <- y0
    y2 <- y1 + h * f(x, y1)

    for (i in 1:(nsteps-1)) {
        x <- x + h
        yy <- y1 + 2.0 * h * f(x, y2)
        y1 <- y2
        y2 <- yy
    }
    0.5*(y1 + y2 + h * f(x, yy))
}


.midpoint <- function(f, t0, tfinal, y0, tol = 1e-07, kmax = 25) {
    stopifnot(is.numeric(y0), is.numeric(t0), length(t0) == 1,
              is.numeric(tfinal), length(tfinal) == 1)
    n <- length(y0)

    # Richardson extrapolation
    nsteps <- 2
    r <- matrix(NA, kmax, n)
    r[1, ] <- .midp(f, t0, tfinal, y0, nsteps)
    rold <- r[1, ]
    for (k in 2:kmax) {
        nsteps <- 2*nsteps
        r[k, 1:n] <- .midp(f, t0, tfinal, y0, nsteps)
        for (j in (k-1):1) {
            cc <- 4^(k-j)
            r[j, ] <- (cc * r[j+1, ] - r[j, ]) / (cc - 1.0)
        }
        dr <- r[1, ] - rold
        err <- sqrt(dot(dr, dr)/n)
        if (err < tol) break
        rold <- r[1, ]
    }
    return(r[1, ])
}


bulirsch_stoer <- function(f, t, y0, tol = 1e-08, ...) {
    stopifnot(is.numeric(t), is.numeric(y0))

    fun <- match.fun(f)
    f <- function(t, y) fun(t, y, ...)   # as row vector

    x <- t
    D <- length(f(x[1], y0))    # image of f
    if (length(y0) != D)
        stop("Argument 'y0' and 'f(..)' must be of the same length.")
    N <- length(x)              # no. of grid points
    if (N < 2)
        stop("Argument 't' must be a vector of length at least 2.")
    mtol <- tol / (N-1)

    z <- matrix(0, N, D)
    z[1, ] <- y0
    for (i in 2:N) {
        z[i, ] <- .midpoint(f, x[i-1], x[i], z[i-1, ], tol = mtol)
    }
    return(z)
}

###
### p o l y f i t . R  Polynom
###

polyfit <- function(x, y, n = 1) {
    if (!is.numeric(x) || !is.numeric(y))
        stop("Arguments x and y must be numeric.")
    if (length(x) != length(y))
        stop("Vectors/matrices x and y must be of same length.")
    if (is.null(n) || n < 0 || ceiling(n) != floor(n))
        stop("Degree n must be a non-negative integer.")

    x <- x[1:length(x)]; y <- y[1:length(y)]
    A <- outer(x, seq(n, 0), "^")
    p <- qr.solve(A, y)
    return(p)
}


polyfix <- function(x, y, n, xfix, yfix)
{
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(xfix), is.numeric(yfix))
    nfit = length(x)
    if (length(y) != nfit)
        stop("Arguments 'x' and 'y' must have the same length.")
    nfix = length(xfix)
    if (length(yfix) != nfix)
        stop("Arguments 'xfix' and 'yfix' must have the same length.")

    if (!is.numeric(n) || n < 0 || floor(n) != ceiling(n))
        stop("Argument 'n' must be an integer.")
    if (n < nfix-1) {
        stop("Argument 'n' shall be greater or equal to 'nfix-1'.")
    } else if (n == nfix-1) {
        warning("Data points can not be taken into account.")
        return(polyfit(xfix, yfix, n))
    }

    A <- ones(nfix, n+1)
    for (i in 1:(n+1))
        A[, i] <- ones(nfix, 1) * xfix^(n+1-i)

    pc <- qr.solve(A[,(n+2-nfix):ncol(A)], yfix)  # Satifies A*pc = yfix

    pcfull <- matrix(0, n+1, 1)
    pcfull[(n+2-nfix):(n+1)] <- pc

    yfit <- y - polyval(pc, x)

    B <- nullspace(A)
    X <- matrix(0, nfit,n+1)
    for(i in 1:(n+1))
        X[, i] <- matrix(1, nfit,1) * x^(n+1-i)

    z = qr.solve(X %*% B, yfit)  # Least squares solution of X*B*z = yfit
    p0 <- B %*% z                # Satisfies A*p0 = 0
    p <- p0 + pcfull             # Satisfies A*p = b

    return(c(p))
}


# polyfit2 <- function(x, y, n = 1, p0 = NULL) {
#     if (!is.numeric(x) || !is.numeric(y))
#         stop("Arguments 'x' and 'y' must be numeric.")
#     if (length(x) != length(y))
#         stop("Vectors/matrices 'x' and 'y' must be of same length.")
#     if (is.null(n) || n <= 0 || ceiling(n) != floor(n))
#         stop("Argument 'n', order of fit, must be a positive integer.")
#     if (is.null(p0))
#         return(polyfit(x, y, n = n))
#     else if (!is.numeric(p0) || length(p0) != 2)
#         stop("Argument 'p0' must be a numeric vector of length 2.")
# 
#     x0 <- p0[1];  y0 <- p0[2]
#     xx <- x - x0; yy <- y - y0
# 
#     M <- matrix(0, length(x), n)
#     M[, n] <- xx
#     for (i in (n-1):1) {
#         M[, i] <- xx * M[, i+1]
#     }
#     pt <- qr.solve(M, yy)
#     pt <- c(pt, y0)
#     p <- numeric(n+1)
#     for (i in (n+1):1) {
#         p[i] <- polyval(pt, -x0)
#         pt   <- polyder(pt)/(n-i+2)
#     }
#     return(p)
# }

##
##  l 1 l i n r e g . R
##


L1linreg <- function(A, b, p = 1, tol = 1e-07, maxiter = 200) {
    stopifnot(is.numeric(A), is.numeric(b))

    if (is.vector(A)) A <- as.matrix(A)
    n <- nrow(A); m <- ncol(A)
    b <- c(b)
    if (length(b) != n)
        stop("Arguments 'A' and 'b' are not compatible.")
    if (p > 1)
            stop("Argument 'p' must be smaller or equal to 1.")

    B <- Bold <- qr.solve(A, b)
    Bold[1] <- Bold[1] + 10*tol

    iter <- 1
    while (max(abs(B - Bold)) > tol && iter <= maxiter) {
        Bold <- B
        e <- c( pmax(abs(A %*% Bold - b), tol) )
        if (p == 1) {
            w <- sqrt(1/e)
        } else {
            w <- sqrt(e^(p-2))
        }
        B <- c(qr.solve(diag(w) %*% A, w * b))
        iter <- iter + 1
    }
    if (iter > maxiter)
        warning("Reached max. no. of iterations; may not have converged.")

    return(list(x = B, reltol = max(abs(B - Bold)), niter = iter))
}

##
##  c o n s t r L s q l i n
##


lsqlincon <- function(C, d,                     # min ||C x - d||_2
                      A = NULL,   b = NULL,     # A x   <= b
                      Aeq = NULL, beq = NULL,   # Aeq x == beq
                      lb = NULL,  ub = NULL)    # lb <= x <= ub
{
    if (!requireNamespace("quadprog", quietly = TRUE)) {
        stop("quadprog needed for this function to work. Please install it.",
              call. = FALSE)
    }

    stopifnot(is.numeric(C), is.numeric(d))
    if (is.null(A) && !is.null(b) || !is.null(A) && is.null(b))
        stop("If any, both 'A' and 'b' must be NULL.")
    if (is.null(Aeq) && !is.null(beq) || !is.null(Aeq) && is.null(beq))
        stop("If any, both 'Aeq' and 'beq' must be NULL.")

    if (!is.matrix(C)) C <- matrix(C, 1)
    mc  <- nrow(C);   nc  <- ncol(C);  n <- nc
    if (length(d) != mc)
        stop("Dimensions of 'C' and 'd' do not fit.")
    if (is.null(A) && is.null(Aeq) && is.null(lb) && is.null(ub))
        return(qr.solve(C, d))
    
    if (!is.null(A)) {
        if (!is.matrix(A)) A <- matrix(A, 1)
        ma  <- nrow(A);   na  <- ncol(A)
        if (na != n)
            stop("Number of columns of 'A' does not fit with 'C'.")
        # ATTENTION: quadprog requires  A x >= b !
        A <- -A; b <- -b
    }
    if (is.null(Aeq)) {
        meq <- 0
    } else {
        if (!is.matrix(Aeq)) Aeq <- matrix(Aeq, 1)
        meq  <- nrow(Aeq);   neq  <- ncol(Aeq)
        if (neq != n)
            stop("Number of columns of 'Aeq' does not fit with 'C'.")
    }

    if (is.null(lb)) {
        diag_lb <- NULL
    } else {
        if (length(lb) == 1) {
            lb <- rep(lb, n)
        } else if (length(lb) != n) {
            stop("Length of 'lb' and dimensions of C do not fit.")
        }
        diag_lb <- diag(n)
    }
    if (is.null(ub)) {
        diag_ub <- NULL
    } else {
        if (length(ub) == 1) {
            ub <- rep(ub, n)
        } else if (length(ub) != n) {
            stop("Length of 'ub' and dimensions of C do not fit.")
        }
        # ATTENTION: quadprog requires -x >= -ub
        diag_ub <- -diag(n)
        ub <- -ub
    }
    
    Dmat <- t(C) %*% C
    dvec <- t(C) %*% d
    
    Amat <- rbind(Aeq, A, diag_lb, diag_ub)
    bvec <- c(beq, b, lb, ub)

    rslt <- quadprog::solve.QP(Dmat, dvec, t(Amat), bvec, meq=meq)
    rslt$solution
}

##
##  m e a n . R  Geometric and Harmonic Mean (Matlab Style)
##


harmmean <- function(x, dim = 1) {
    stopifnot(is.numeric(x))
    if (dim < 1 || dim > ndims(x))
        stop("Argument 'dim' must be between 1 and 'ndims(x)'.")

    if (is.vector(x)) {
        m <- 1 / mean( 1/x )
    } else if (is.matrix(x)) {
        m <- 1 / apply( 1/x, c(2,1)[dim], mean)
    } else if (is.array(x)) {
        mid <- setdiff(1:ndims(x), dim)
        m <- 1 / apply( 1/x, mid, mean)
    } else {
        stop("Argument 'x' must be a numeric vector, matrix, or array.")
    }

    return(m)
}


geomean <- function(x, dim = 1) {
    stopifnot(is.numeric(x))
    if (dim < 1 || dim > ndims(x))
        stop("Argument 'dim' must be between 1 and 'ndims(x)'.")

    if (is.vector(x)) {
        m <- exp( sum( log(x) ) / length(x) )
    } else if (is.matrix(x)) {
        n <- size(x)[dim]
        m <- exp( apply(log(x), c(1,2)[-dim], sum) / n )
    } else if (is.array(x)) {
        n <- size(x)[dim]
        mid <- c(1:ndims(x))[-dim]
        m <- exp( apply(log(x), c(1:n)[-dim], sum) / n )
    } else {
        stop("Argument 'x' must be a numeric vector, matrix, or array.")
    }

    return(m)
}


trimmean <- function(x, percent = 0) {
    stopifnot(is.numeric(x), is.numeric(percent))
    if (length(percent) != 1 || percent < 0 || 100 < percent)
        stop("Argument 'percent' must be a scalar between 0 and 100.")

    # k <- percent / 100 / 2
    # mean(x, trim = k, na.remove = TRUE)

    .tmean <- function(x, p) {
        n <- length(x)
        k <- round (n * percent/100 / 2 )
        if (2*k > n-1) return(NA)
        x <- sort(x)
        mean(x[(k+1):(n-k)])
    }

    if (is.vector(x)) {
        m <- .tmean(x, percent)
    } else if (is.matrix(x)) {
        m <- apply(x, 2, .tmean)
    } else if (is.array(x)) {
        stop("Function 'trimmean' not yet implemented for arrays.")
    } else
        stop("Argument 'x' must be a numeric vector or matrix.")

    return(m)
}

##
##  b e e p . R
##


beep <- function() cat("\a")


disp <- function(...) cat(..., "\n")


ver <- function() {
    z <- list()
    z$R.version <- R.Version()
    z$platform <- z$R.version$platform
    if (nzchar(.Platform$r_arch)) 
        z$platform <- paste(z$platform, .Platform$r_arch, sep = "/")
    z$platform <- paste(z$platform, " (", 8 * .Machine$sizeof.pointer, 
        "-bit)", sep = "")
    z$locale <- Sys.getlocale()

    cat("------------------------------------------------------------------------\n")
    cat("Version:    ", z$R.version$version.string, "\n", sep = "")
    cat("License:    Gnu General Public License, GPL-3\n", sep = "")
    cat("Platform:   ", z$R.version$platform, "\n", sep = "")
    cat("Op.System:  ",  z$platform, "\n", sep = "")
    cat("Locale:     ",  z$locale, "\n", sep = "")
    cat("------------------------------------------------------------------------\n")

    # Loaded base and contributed packages
    session_info <- sessionInfo()
    base_pkgs <- session_info$basePkgs
    cat("Loaded Base Packages:\n  ", base_pkgs, "\n", sep = "  ")
    cat("Contributed Packages:\n")
    other_pkgs <- session_info$otherPkgs
    for (pack in other_pkgs) {
        pkg_name <- pack$Package; l <- max(12 - nchar(pkg_name), 2)
        pkg_name <- paste(pkg_name, blanks(l), sep = "", collapse = "")

        pkg_version <- pack$Version; l <- max(8 - nchar(pkg_version), 2)
        pkg_version <- paste("Version ", pkg_version, blanks(l), sep = "", collapse = "")

        pkg_date <- substr(pack$Date, 1, 10)
        pkg_date <- paste("(", pkg_date, ")", sep = "", collapse = "")

        pkg_license <- pack$License
        pkg_license <- paste("  License ", pkg_license, sep = "", collapse = "")

        cat(pkg_name, pkg_version, pkg_date, pkg_license, "\n", sep = "  ")
    }
    cat("------------------------------------------------------------------------\n")
    invisible(NULL)
}

##
##  b r e n t d e k k e r . R  Brent-Dekker Algorithm
##


brentDekker <- function(fun, a, b, maxiter = 500, tol = 1e-12, ...)
# Brent and Dekker's root finding method,
# based on bisection, secant method and quadratic interpolation
{
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

    stopifnot(is.numeric(a), is.numeric(b),
              length(a) == 1, length(b) == 1)
    if (!is.function(f) || is.null(f))
        stop("Argument 'f' must be a valid R function.")

	x1 <- a; f1 <- f(x1)
	if (f1 == 0) return(list(root = a, f.root = 0, f.calls = 1, estim.prec = 0))
	x2 <- b; f2 <- f(x2)
	if (f2 == 0) return(list(root = b, f.root = 0, f.calls = 1, estim.prec = 0))
	if (f1*f2 > 0.0)
	    stop("Brent-Dekker: Root is not bracketed in [a, b].")

	x3 <- 0.5*(a+b)
	# Beginning of iterative loop
	niter <- 1
	while (niter <= maxiter) {
		f3 <- f(x3)
		if (abs(f3) < tol) {
		    x0 <- x3
		    break
		}

		# Tighten brackets [a, b] on the root
		if (f1*f3 < 0.0) b <- x3 else a <- x3
		if ( (b-a) < tol*max(abs(b), 1.0) ) {
		    x0 <- 0.5*(a + b)
		    break
	    }

		# Try quadratic interpolation
		denom <- (f2 - f1)*(f3 - f1)*(f2 - f3)
		numer <- x3*(f1 - f2)*(f2 - f3 + f1) + f2*x1*(f2 - f3) + f1*x2*(f3 - f1)
		# if denom==0, push x out of bracket to force bisection
		if (denom == 0) {
			dx <- b - a
		} else {
			dx <- f3*numer/denom
		}

		x <- x3 + dx
		# If interpolation goes out of bracket, use bisection.
		if ((b - x)*(x - a) < 0.0) {
			dx <- 0.5*(b - a)
			x  <- a + dx;
		}

		# Let x3 <-- x & choose new x1, x2 so that x1 < x3 < x2.
		if (x1 < x3) {
			x2 <- x3; f2 <- f3
		} else {
			x1 <- x3; f1 <- f3
		}

		niter <- niter + 1
		if (abs(x - x3) < tol) {
		    x0 <- x
		    break
	    }
		x3 <- x;
	}

    if (niter > maxiter)
        warning("Maximum numer of iterations, 'maxiter', has been reached.")

    prec <- min(abs(x1-x3), abs(x2-x3))
    return(list(root = x0, f.root = f(x0),
                f.calls = niter+2, estim.prec = prec))
}


# alias
brent <- brentDekker

##
##  s t e r e o g r a p h i c  Stereographic Projection
##


stereographic <- function(p) {
    stopifnot(is.numeric(p))
    if (is.vector(p)) p <- as.matrix(p)
    m <- nrow(p); n <- ncol(p)

    s <- 2.0 / ( 1.0 + p[m, 1:n] )
    ss <- repmat(s, m, 1)
    f <- zeros(m,1)
    f[m] <- -1.0
    ff <- repmat ( f, 1, n )

    q <- ss * p + (1.0 - ss) * ff
    return(q)
}

stereographic_inv <- function(q) {
    stopifnot(is.numeric(q))
    if (is.vector(q)) q = as.matrix(q)
    m <- nrow(q); n <- ncol(q)

    f <- zeros(m, 1)
    f[m] <- -1.0
    ff <- repmat(f, 1, n)

    s <- 4.0 / (4.0 + apply(q[1:(m-1),1:n, drop = FALSE]^2, 2, sum))
    ss <- repmat (s, m, 1)

    p <- ss * q + (1.0 - ss) * ff[1:m,1:n]
    return(p)
}

## 
##  s u m a l t . R  Summing alternating series
##


sumalt <- function(f_alt, n) {
    b <- 2^(2*n-1)
    c <- b  # ; s <- 0
    s <- 0.0
    for (k in (n-1):0) {
        t <- f_alt(k)
        s <- s + c*t
        b <- b * (2*k+1) * (k+1) / (2 * (n-k) * (n+k))
        c <- c + b
    }
    s <- s / c
    return(s)
}

##
##  f m i n u n c . R  Unconstrained Minimization
##

#   o Added 'fminunc()' for unconstrained function minimization, based
#     on a 'variable metric' approach by John Nash (see package Rvmmin).


#' Minimization of unconstrained multivariable functions
fminunc <- function(x0, fn, gr = NULL, ...,
                    tol = 1e-08, maxiter = 0, maxfeval = 0) {
    if (!is.numeric(x0) || length(x0) <= 1)
        stop("Argument 'x0' must be a vector of length greater than 1.")
    fun <- match.fun(fn)
    fn  <- function(x) fun(x, ...)
    if (is.null(gr)) gr <- function(x) pracma::grad(fn, x)

    sol <- .varmetric(x0, fn, gr, tol = tol,
                      maxiter = maxiter, maxfeval = maxfeval)
    return(sol)
}


.varmetric <- function(par, fn, gr, 
                       tol = 1e-08, maxiter = 0, maxfeval = 0) {
    
    # Prepare control parameters
    n <- length(par)
    if (maxiter == 0)  maxiter  <- 1000 +  5 * n
    if (maxfeval == 0) maxfeval <- 3000 + 10 * n
    maxit <- maxiter
    eps <- tol
    acctol <- 0.0001
    dowarn <- FALSE
    stepredn <- 0.2
    offset <- 100.0
    stopbadupdate <- TRUE
    ceps <- .Machine$double.eps * offset
    dblmax <- .Machine$double.xmax  # used to flag bad function
    
    # Set working parameters
    keepgoing <- TRUE
    ifn <- ig <- 1  # count function evaluations
    ilast <- ig
    bvec <- par; f <- fn(bvec)
    fmin <- f;   g <- gr(bvec)
    oldstep <- 1
    msg <- "Status not resolved"
    conv <- -1
    gnorm <- sqrt(sum(g*g))
    if (gnorm < (1 + abs(fmin))*eps*eps ) {
        keepgoing <- FALSE
        msg <- "Small gradient norm"
        conv <- 2
    }
    while (keepgoing) { ## main loop
        if (ilast == ig) B <- diag(1, n, n)
        fmin <- f
        par <- bvec
        c <- g
        t <- as.vector(-B %*% g)        # compute search direction
        gradproj <- sum(t * g)          # gradient projection
        accpoint <- FALSE 
        if (gradproj <= 0) {
            changed <- TRUE
            steplength <- oldstep
            while ((f >= fmin) && changed && (!accpoint)) {
                bvec <- par + steplength * t
                changed <- (!identical((bvec + offset), (par + offset)) )
                if (changed) {
                    f <- fn(bvec)
                    ifn <- ifn + 1
                    if (ifn > maxfeval) {
                        msg <- "Too many function evaluations"
                        if (dowarn) warning(msg)
                        conv <- 1
                        changed <- FALSE
                        keepgoing <- FALSE
                        break
                    }
                    if (f < fmin) {
                        accpoint <- (f <= fmin + gradproj * steplength * acctol)
                    }
                    else {
                        steplength <- steplength * stepredn
                    }
                }
            }
        }
        if (accpoint) {
            fmin <- f
            g <- gr(bvec)
            ig <- ig + 1
            if (ig > maxit) {
                keepgoing = FALSE
                msg = "Too many gradient evaluations"
                if (dowarn) warning(msg)
                conv <- 1
                break
            }
            par <- bvec
            gnorm <- sqrt(sum(g*g)) 
            if (gnorm < (1 + abs(fmin))*eps*eps ) {
                keepgoing <- FALSE
                msg <- "Small gradient norm"
                conv <- 2
                break
            }
            t <- as.vector(steplength * t)
            c <- as.vector(g - c)
            D1 <- sum(t * c)
            if (D1 > 0) {
                y <- as.vector(crossprod(B, c))
                D2 <- as.double(1+crossprod(c,y)/D1)  
                B <- B - (outer(t, y) + outer(y, t) - D2 * outer(t, t))/D1
            } else {
                if (ig == ilast+1) {
                    if (stopbadupdate && ! accpoint) keepgoing=FALSE
                    msg <- paste("UPDATE NOT POSSIBLE: ilast, ig",
                                 ilast, ig, sep = "")
                    conv <- 3
                }
                ilast <- ig
            }
        } else {
            if ( (ig == ilast) || (abs(gradproj) < (1 + abs(fmin))*eps*eps ) ) {
                # we reset to gradient and did new linesearch
                keepgoing <- FALSE  # no progress possible
                if (conv < 0) { # conv == -1 is used to indicate it is not set
                    conv <- 0
                }
                msg <- "Rvmminu converged"
            } else {
                ilast <- ig
            }
        }
    }  # end main loop
    
    counts <- c("function" = ifn, "gradient" = ig)
    ans <- list(par = par, value = fmin, counts = counts,
                convergence = conv, message = msg)
    return(ans) 
}

##
##  p o l y n o m i a l s . R  Polynomial Functions
##


# Generate a polynomial from its roots
Poly <- function(x) {
    if (is.null(x) || length(x) == 0) return(c(1))
    if (is.vector(x, mode="numeric") || is.vector(x, mode="complex")) {
        y <- x
    } else {
        if ((is.numeric(x) || is.complex(x))  && is.matrix(x)) {
            y <- eigen(x)$values
        } else {
            stop("Argument 'x' must be a vector or square matrix.")
        }
    }
    
    n <- length(y)
    p <- c(1, rep(0, n))
    for (i in 1:n) {
        p[2:(i+1)] <- p[2:(i+1)] - y[i] * p[1:i]
    }
    if (all(Im(p) == 0)) p <- Re(p)
    return(p)
}


# Add (and subtract) polynomials
polyadd <- function(p, q){
    if ( (!is.vector(p, mode="numeric") && !is.vector(p, mode="complex")) ||
         (!is.vector(q, mode="numeric") && !is.vector(q, mode="complex")) )
        stop("Arguments 'p' and 'q' must be real or complex vectors.")
    
    lp <- length(p)
    lq <- length(q)
    
    if (lp >= lq) {
        r <- p + c(numeric(lp-lq), q)
    } else {
        r <- q + c(numeric(lq-lp), p)
    }
    
    lr <- length(r)
    while (r[1] == 0 && lr > 1) {
        r <- r[2:lr]
        lr <- lr - 1
    }
    return(r)
}


# Multiply polynomials
polymul <- function(p, q){
    if ( (!is.vector(p, mode="numeric") && !is.vector(p, mode="complex")) ||
         (!is.vector(q, mode="numeric") && !is.vector(q, mode="complex")) )
        stop("Arguments 'p' and 'q' must be real or complex vectors.")
    
    n <- length(p); m <- length(q)
    if (n <= 1 || m <= 1) return(p*q)
    
    r <- rep(0, n+m-1)
    for (i in seq(along=q)) {
        r <- r + c(rep(0, i-1), p * q[i], rep(0, m-i))
    }
    
    while (r[1] == 0 && length(r) > 1)
        r <- r[2:length(r)]
    
    return(r)
}


# Take powers of polynomials
polypow <- function(p, n){
    if ( !is.vector(p, mode="numeric") && !is.vector(p, mode="complex") )
        stop("Arguments 'p' must be a real or complex vector.")
    if ( !is.numeric(n) || length(n) != 1 || floor(n) != ceiling(n) || n < 0 )
        stop("Argument 'n' must be a non-negative integer.")
    
    pp <- c(1)
    while (n > 0) {
        pp <- polymul(pp, p)
        n <- n - 1
    }
    return(pp)
}


# Divide polynomials using the 'deconv' function
polydiv <- function(p, q) {
    if (length(q) == 1)
        return(list(d = p/q, r = 0))
    qr <- deconv(p,q)
    d <- zapsmall(qr$q); r <- zapsmall(qr$r)
    return(list(d = d, r = r))
}


# 'Symbolic' derivative of a polynomial
polyder <- function(p, q) {
    if (!missing(q)) {
        if (length(q) == 0) return(0)
        if (!is.numeric(q) && !is.complex(q))
            stop("Arguments must be real or complex vectors or matrices.")
        m <- length(q)
        if (is.matrix(q)) q <- q[1:m]
    } else {
        q <- 1; m <- 1
    }
    
    if (length(p) == 0) return(0)
    if (!is.numeric(p) && !is.complex(p))
        stop("Argument 'p' must be a real or complex vector or matrix.")
    n <- length(p)
    if (is.matrix(p)) p <- p[1:n]
    
    # multiply polynomials p an q
    if (n*m <= 1) {
        return(0)
    } else {
        r <- rep(0, n+m-1)
        for (i in seq(along=q)) {
            r <- r + c(rep(0, i-1), p * q[i], rep(0, m-i))
        }
    }
    
    # case k > 1
    k <- length(r)
    r <- c((k-1):1) * r[1:(k-1)]
    
    while (r[1] == 0 && length(r) >= 2) {
        r <- r[2:length(r)]
    }
    return(r)
}


# 'Symbolic' antiderivative of a polynomial
polyint <- function(p, k=0) {
    if (length(p) == 0) return(c())
    if (!is.vector(p, mode="numeric") && !is.vector(p, mode="complex"))
        stop("Argument 'p' must be a real or complex vector.")
    if (!is.vector(k, mode="numeric") && !is.vector(k, mode="complex"))
        stop("Argument 'k' must be a real or complex vector")
    
    return( c(p / (length(p):1), k) )
}


# Transform a polynomial with another polynomial
polytrans <- function(p, q){
    if ( (!is.vector(p, mode="numeric") && !is.vector(p, mode="complex")) ||
         (!is.vector(q, mode="numeric") && !is.vector(q, mode="complex")) )
        stop("Arguments 'p' and 'q' must be real or complex vectors.")
    
    n <- length(p)
    if (length(p) == 1)
        return(p)
    
    pt <- 0
    for (i in 1:n) {
        pt <- polyadd(pt, p[i]*polypow(q, n-i))
    }
    
    return(pt)
}


# Print polynomial in normal form (highest powers first)
poly2str <- function(p, svar = "x", smul = "*",
                     d = options("digits")$digits) {
    if (length(p) == 0) return("")
    if (is.complex(p))
        stop("Printing of complex coefficients not yet implemented.")
    else if (!is.numeric(p))
        stop("Argument 'p' must be a numeric vector.")
    
    while (p[1] == 0 && length(p) > 1)
        p <- p[2:length(p)]
    if (length(p) == 1) return(as.character(p))
    
    s <- sign(p)
    p <- abs(p)
    
    p <- formatC(p, digits = d)
    p <- sub("^\\s+", "", p)
    
    n <- length(p) - 1
    S <- ""
    
    s1 <- if (s[1] == 1) "" else "-"
    S <- paste(s1, p[1], smul, svar, "^", n, sep = "")
    
    for (i in 2:(n+1)) {
        if (s[i] == 1) s1 <- " + "
        else if (s[i] == -1) s1 <- " - "
        else next
        
        if (n-i+1 > 1) {
            S <- paste(S, s1, p[i], smul, svar, "^", n-i+1, sep="")
        } else if (i == n) {
            S <- paste(S, s1, p[i], smul, svar, sep="")
        } else {
            S <- paste(S, s1, p[i], sep="")
        }
    }
    return(S)
}

##
##  i n t e g r a l 2 . R  Double and Triple Integrals
##


integral2 <- function(fun, xmin, xmax, ymin, ymax, sector = FALSE,
                        reltol = 1e-6, abstol = 0, maxlist = 5000,
                        singular = FALSE, vectorized = TRUE, ...) {
    stopifnot(is.numeric(xmin), length(xmin) == 1,
              is.numeric(xmax), length(xmax) == 1)
    if ( is.infinite(xmin) || is.infinite(xmax) ||
        (!is.function(ymin) && is.infinite(ymin)) ||
        (!is.function(ymax) && is.infinite(ymax)) )
        stop("Borders of the integration domain cannot be infinite.")

    # check input parameters
    nlist <- floor(maxlist/10)

    # check function and vectorization
    fun <- match.fun(fun)
    if (sector) {
        # FUN <- function(theta, r) fun(r*cos(theta), r*sin(theta), ...) * r
        FUN <- function(x, y) fun(y*cos(x), y*sin(x), ...) * y
    } else {
        FUN <- function(x, y) fun(x, y, ...)
    }

    # check upper and lower bounds of y
    if (is.function(ymin)) {
        phiBvar <- ymin
    } else if (is.numeric(ymin)) {
        phiBvar <- function(x) ymin * ones(size(x)[1], size(x)[2])
    } else
        stop("Argument 'ymin' must be a constant or a (vectorized) function.")

    if (is.function(ymax)) {
        phiTvar <- ymax
    } else if (is.numeric(ymax)) {
        phiTvar <- function(x) ymax * ones(size(x)[1], size(x)[2])
    } else
        stop("Argument 'ymax' must be a constant or a (vectorized) function.")

    # check borders and redefine
    if (singular) {
        thetaL <- 0; thetaR <- pi
        phiB <- 0; phiT <- pi
    } else {
        thetaL <- xmin; thetaR <- xmax
        phiB <- 0; phiT <- 1
    }
    area <- (thetaR - thetaL) * (phiT - phiB)

    # initial quadrature
    Qs   <- .tensor(xmin, xmax, thetaL, thetaR, phiB, phiT, FUN, phiBvar, phiTvar,
                      vectorized = vectorized, singular = singular)
    Qsub <- Qs$qsub; esub <- Qs$esub
    Q    <- sum(Qsub)

    # some more parameters and main list
    eps <- .Machine$double.eps
    tol <- 100 * eps * abs(Q)
    err_ok <- 0
    adjust <- 1
    mainList <- zeros(nlist, 7)
    nList <- 0

    # save info on rectangles in main list
    s2l <- .save2list(mainList, nList, Qsub, esub, thetaL, thetaR, phiB, phiT,
                        tol, area, adjust, err_ok)
    mainList <- s2l$mlist
    nList    <- s2l$nlist
    errbnd   <- s2l$errbnd

    if (nList == 0 || errbnd <= tol)
        return(list(Q = Q, error = errbnd))

    while (TRUE) {
        ne <- .nextEntry(mainList, nList)
        mainList <- ne$mlist
        nList <- ne$nlist

        temp <- ne$entry
        q <- temp[1]; e <- temp[2]
        thetaL <- temp[3]; thetaR <- temp[4]
        phiB <- temp[5]; phiT <- temp[6]

        # Approximate integral over four subrectangles
        Qs <- .tensor(xmin, xmax, thetaL, thetaR, phiB, phiT, FUN, phiBvar, phiTvar,
                        vectorized = vectorized, singular = singular)
        Qsub <- Qs$qsub; esub <- Qs$esub

        newq <- sum(Qsub)
        adjust <- min(1, abs(q - newq)/e)
        Q <- Q + (newq - q)
        tol <- max(abstol, reltol * abs(Q)) / 8  
        tol <- max(tol, 100 * eps * abs(Q))

        s2l <- .save2list(mainList, nlist, Qsub, esub, thetaL, thetaR, phiB, phiT,
                            tol, area, adjust, err_ok)
        mainList <- s2l$mlist
        nList    <- s2l$nlist
        errbnd   <- s2l$errbnd

        if (nList == 0 || errbnd <= tol) {
            break
        } else if (nList > maxlist) {
            if (errbnd > max(abstol, max(100*eps, reltol) * abs(Q))) {
                stop("Maximum number of subintervals: w/o convergence.")
            } else {
                warning("Maximum number of subintervals: maybe low accuracy.")
            }
            break
        }
    }
    # accuracy or max. number of subdivisions rached
    return(list(Q = Q, error = errbnd))
}


.tensor <- function(a, b, thetaL, thetaR, phiB, phiT, FUN, phiBvar, phiTvar,
                        vectorized = vectorized, singular = singular)
{
    # Gauss-Kronrod (3,7) pair with degrees of precision 5 and 11
    nodes <- c( -0.9604912687080202, -0.7745966692414834, -0.4342437493468026,
                0, 0.4342437493468026, 0.7745966692414834, 0.9604912687080202) 
    nnodes <- length(nodes)    
    onevec <- ones(2*nnodes,1)
    narray <- 0.25 * cbind(nodes, nodes)
    wt3    <- c(0, 5/9, 0, 8/9, 0, 5/9, 0)
    wt7    <- c(0.1046562260264672, 0.2684880898683334, 0.4013974147759622,
                0.4509165386584744, 0.4013974147759622, 0.2684880898683334,
                0.1046562260264672)

    Qsub <- zeros(4,1)
    esub <- zeros(4,1)
    
    dtheta <- thetaR - thetaL
    etheta <- thetaL + dtheta * c(0.25,0.75)
    theta  <- c(dtheta*narray + rep(etheta, each = nnodes))
    if (singular) {
        x <- 0.5*(b + a) + 0.5*(b - a)*cos(theta)
    } else {
        x <- theta
    }
    X <- onevec %*% x

    dphi <- phiT - phiB;
    ephi <- phiB + dphi * c(0.25,0.75)
    phi  <- c(dphi*narray + rep(ephi, each = nnodes))
    phi  <- as.matrix(c(phi))

    top    <- phiTvar(x)
    bottom <- phiBvar(x)
    dydt <- top - bottom
    if (singular) {
        t <- 0.5 + 0.5*cos(phi)
    } else {
        t <- phi
    }
    Y <- onevec %*% bottom + t %*% dydt

    if (vectorized) {
        Z <- FUN(X, Y)
    } else {
        Z <- arrayfun(FUN, X, Y)
    }

    if (singular) {
        temp <- 0.25*(b - a) * sin(phi) %*% (dydt * sin(theta))
    } else {
        temp <- onevec %*% dydt
    }
    Z <- Z * temp

    # Tensor product: Gauss 3 and 7 points formulae
    esub[1] <- wt3 %*% t(wt3 %*% Z[1:nnodes,1:nnodes])
    esub[2] <- wt3 %*% t(wt3 %*% Z[1:nnodes,(nnodes+1):(2*nnodes)])  
    esub[3] <- wt3 %*% t(wt3 %*% Z[(nnodes+1):(2*nnodes),1:nnodes])
    esub[4] <- wt3 %*% t(wt3 %*% Z[(nnodes+1):(2*nnodes),(nnodes+1):(2*nnodes)])
    esub <- (esub/4)*(dtheta/2)*(dphi/2) 

    Qsub[1] <- wt7 %*% t(wt7 %*% Z[1:nnodes,1:nnodes])
    Qsub[2] <- wt7 %*% t(wt7 %*% Z[1:nnodes,(nnodes+1):(2*nnodes)])
    Qsub[3] <- wt7 %*% t(wt7 %*% Z[(nnodes+1):(2*nnodes),1:nnodes])
    Qsub[4] <- wt7 %*% t(wt7 %*% Z[(nnodes+1):(2*nnodes),(nnodes+1):(2*nnodes)])   

    Qsub <- (Qsub/4)*(dtheta/2)*(dphi/2);  
    esub <- abs(esub - Qsub);

    return(list(qsub = Qsub, esub = esub))
}


.save2list <- function(mainList, nList,
                      Qsub, esub, thetaL, thetaR, phiB, phiT,
                      tol, area, adjust, err_ok) {

    eps <- .Machine$double.eps
    dtheta <- thetaR - thetaL
    dphi <- phiT - phiB
    localtol <- tol * (dtheta/2) * (dphi/2) / area
    localtol <- max(localtol, 100*eps*abs(sum(Qsub)))

    adjerr <- adjust * esub
    if (nList+4 > size(mainList,1))
        mainList <- rbind(mainList, zeros(100, 7))
    
    if (adjerr[1] > localtol) {
        nList <- nList + 1
        mainList[nList, ] <- c(Qsub[1], esub[1], thetaL, thetaL + dtheta/2,
                                             phiB ,phiB + dphi/2, adjerr[1])
    } else {
      err_ok <- err_ok + adjerr[1]
    }

    if (adjerr[2] > localtol) {
      nList <- nList + 1
      mainList[nList, ] <- c(Qsub[2], esub[2], thetaL + dtheta/2, thetaR,
                                           phiB, phiB + dphi/2, adjerr[2])
    } else {
      err_ok <- err_ok + adjerr[2]
    }

    if (adjerr[3] > localtol) {
      nList <- nList + 1
      mainList[nList, ] <- c(Qsub[3], esub[3], thetaL, thetaL + dtheta/2,
                                           phiB + dphi/2, phiT, adjerr[3])
    } else {
      err_ok <- err_ok + adjerr[3]
    }

    if (adjerr[4] > localtol) {
      nList <- nList + 1
      mainList[nList, ] <- c(Qsub[4], esub[4], thetaL + dtheta/2, thetaR,
                                           phiB + dphi/2, phiT, adjerr[4])
    } else {
      err_ok <- err_ok + adjerr[4]
    }   
    
    errbnd <- err_ok + sum(mainList[, 7])
    return(list(mlist = mainList, nlist = nList, errbnd = errbnd))
}


.nextEntry <- function(mainList, nList) {
    indx <- which.max(abs(mainList[1:nList, 7]))
    temp <- mainList[ indx, ]
    mainList <- mainList[-indx, ]
    nList <- nList - 1
    return(list(mlist = mainList, nlist = nList, entry = temp))
}

#-- --------------------------------------------------------------------------

integral3 <- function (fun, xmin, xmax, ymin, ymax, zmin, zmax, 
                          reltol = 1e-06, ...) 
{
    fct <- match.fun(fun)
    fun <- function(x, y, z) fct(x, y, z, ...)

    if (is.function(ymin)) { yBvar <- ymin
    } else if (is.numeric(ymin)) {
        yBvar <- function(x) rep(ymin, length(x))
    } else {
        stop("Argument 'ymin' must be a constant or a function of x.")
    }
    if (is.function(ymax)) { yTvar <- ymax
    } else if (is.numeric(ymax)) {
        yTvar <- function(x) rep(ymax, length(x))
    } else {
        stop("Argument 'ymax' must be a constant or a function of x.")
    }
    if (is.function(zmin)) {zBvar <- zmin
    } else if (is.numeric(zmin)) {
        zBvar <- function(x, y) rep(zmin, length(y))
    } else {
        stop("Argument 'zmin' must be a constant or a function of x and y.")
    }
    if (is.function(zmax)) { zTvar <- zmax
    } else if (is.numeric(zmax)) {
        zTvar <- function(x, y) rep(zmax, length(y))
    } else {
        stop("Argument 'zmax' must be a constant or a function of x and y.")
    }

    fx <- function(x) {
        z1 <- function(y) zBvar(x, y)
        z2 <- function(y) zTvar(x, y)
        fyz <- function(y, z) fun(x, y, z)
        integral2(fyz, yBvar(x), yTvar(x), z1, z2, reltol = reltol)$Q
    }

    f <- Vectorize(fx)
    integrate(f, xmin, xmax, subdivisions = 300L, rel.tol = reltol)$value
}

##
##  h y p e r b o l i c . R  Hyperbolic Functions
##


### More trigonometric functions ###

# cotangens
cot <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / tan(z)
}

# cosecans
csc <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / sin(z)
}

# secans
sec <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / cos(z)
}

# arcus cotangens
acot <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    atan(1/z)
}

#arcus cosecans
acsc <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    asin(1/z)
}

# arcus secans
asec <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    acos(1/z)
}


### More hyperbolic functions ###

# hyperbolic cotangens
coth <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / tanh(z)
}

# hyperbolic cosecans
csch <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / sinh(z)  # 2 / (exp(z) - exp(-z))
}

# hyperbolic secans
sech <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    1 / cosh(z)  # 2 / (exp(z) + exp(-z))
}

# area cotangens
acoth <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    atanh(1/z)
}

# area cosecans
acsch <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    asinh(1/z)
}

# area secans
asech <- function(z) {
    stopifnot(is.numeric(z) || is.complex(z))
    acosh(1/z)
}

##
##  Matlab flipping matrices functions
##


flipdim <- function(a, dim=1) {
	if (!is.matrix(a))
		stop("Argument 'a' must ba a matrix.")
	if (!(dim %in% c(1,2)))
		stop("Argument 'dim' must be 1 or 2 (for rows or columns).")

	if (dim == 1) {
		a <- a[nrow(a):1, ]
	} else {
		a <- a[ ,ncol(a):1]
	}
	return(a)
}

flipud <- function(a) {
	flipdim(a, 1)
}

fliplr <- function(a) {
	flipdim(a, 2)
}

rot90 <- function(a, k=1) {
	if (!is.matrix(a))
		stop("Argument 'a' must ba a matrix.")
	if (floor(k) != ceiling(k))
		k <- 0

	switch(EXPR = 1 + (k %% 4),
		a,
		t(a[, seq(ncol(a), 1, by=-1)]),
		a[seq(nrow(a), 1, by=-1), seq(ncol(a), 1, by=-1)],
		{a <- t(a); a[, seq(ncol(a), 1, by=-1)]}
	)
}

##
##  m o v a v g . R  Moving Average Filters
##


movavg <- function(x, n, type=c("s", "t", "w", "m", "e", "r")) {
    stopifnot(is.numeric(x), is.numeric(n), is.character(type))
    if (length(n) != 1 || ceiling(n != floor(n)) || n <= 1)
        stop("Window length 'n' must be a single integer greater 1.")
    nx <- length(x)
    if (n >= nx)
        stop("Window length 'n' must be greater then length of time series.")

    y <- numeric(nx)
    if (type == "s") {         # simple
        for (k in 1:(n-1))  y[k] <- mean(x[1:k])
        for (k in n:nx)     y[k] <- mean(x[(k-n+1):k])

    } else if (type == "t") {  # triangular
        n <- ceiling((n + 1)/2)
        s <- movavg(x, n, "s")
        y <- movavg(s, n, "s")

    } else if (type == "w") {  # weighted
        for (k in 1:(n-1))  y[k] <- 2 * sum((k:1)*x[k:1]) / (k*(k+1))
        for (k in n:nx)     y[k] <- 2 * sum((n:1)*x[k:(k-n+1)]) / (n*(n+1))

    } else if (type == "m") {  # modified
        y[1] <- x[1]
        for (k in 2:nx)     y[k] <- y[k-1] + (x[k] - y[k-1])/n

    } else if (type == "e") {  # exponential
        a <- 2/(n+1)
        y[1] <- x[1]
        for (k in 2:nx)     y[k] <- a*x[k] + (1-a)*y[k-1]

    } else if (type == "r") {  # running
        a <- 1/n
        y[1] <- x[1]
        for (k in 2:nx)     y[k] <- a*x[k] + (1-a)*y[k-1]

    } else
        stop("The type must be one of 's', 't', 'w', 'm', 'e', or 'r'.")

    return(y)
}

##
##  s t r 2 n u m . R
##


str2num <- function(S) {
    s1 <- strTrim(S)
    ls <- nchar(s1)
    if (substr(s1, ls, ls) == ';') {
        s1 <- sub(';$', '', s1)
        prit <- FALSE
    } else {
        prit <- TRUE
    }

    s1 <- sub('^\\[', '', s1)
    s1 <- sub('\\]$', '', s1)
    s1 <- gsub(',', ' ', s1)

    s2 <- strsplit(s1, ';')[[1]]

    m  <- length(s2)
    L1 <- scan(text=s2[1], quiet = TRUE)
    n  <- length(L1)

    if (m > 1) {
        for (i in 2:m) {
            Li <- scan(text=s2[i], quiet = TRUE)
            if (n != length(Li))
                stop("All rows in Argument 's' must have the same length.")
            L1 <- rbind(L1, Li)
        }
    }
    L2 <- unname(L1)
    if (any(is.na(L2)) || isempty(L2)) L2 <- c()

    if (prit) print(L2)
    invisible(L2)
}


num2str <- function(A, fmt = 3) {
    stopifnot(is.numeric(A), length(fmt) == 1)
    if (is.numeric(fmt))
        fmt = paste("%.", round(fmt), "f", sep = '')

    dm <- dim(A)
    a1 <- sprintf(fmt, A)       # a2 <- as.numeric(a1)
    if (!is.null(dm)) {
        dim(a1) <- dm           # dim(a2) <- dm
    }
    return(a1)
}

##
##  c u r v e f i t . R  Polynomial Curve Fit
##


curvefit <- function(u, x, y, n, U = NULL, V = NULL) {
    stopifnot(is.numeric(u), is.numeric(x), is.numeric(y))
    u <- c(u); m <- length(u)
    x <- as.matrix(c(x)); y <- as.matrix(c(y))
    if (length(x) != m || length(y) != m)
        stop("Vectors 'x' and 'y' must have the same length as 't'.")
    if (!is.numeric(n) || length(n) != 1 || floor(n) != ceiling(n) || n < 1)
        stop("Argument 'n' must be an integer greater or equal 1.")

    Ax <- outer(u, seq(n, 0), "^")
    Ay <- outer(u, seq(n, 0), "^")

    if (is.null(U) || is.null(V)) {
        px <- lsqlin(Ax, x)
        py <- lsqlin(Ay, y)
    } else {
        Cx <- outer(U, seq(n, 0), "^"); cx <- V[, 1]
        Cy <- outer(U, seq(n, 0), "^"); cy <- V[, 2]
        px <- lsqlin(Ax, x, Cx, cx)
        py <- lsqlin(Ay, y, Cy, cy)
    }
    xp <- polyval(c(px), u)
    yp <- polyval(c(py), u)

    return(list(xp = xp, yp = yp, px = px, py = py))
}

##
##  g r a d . R  Function Gradient
##


grad <- function(f, x0, heps = .Machine$double.eps^(1/3), ...) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric value.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

    if (length(f(x0)) != 1)
        stop("Function 'f' must be a univariate function of 2 variables.")
    n <- length(x0)

    hh <- rep(0, n)
    gr <- numeric(n)
    for (i in 1:n) {
        hh[i] <- heps
        gr[i] <- (f(x0 + hh) - f(x0 - hh)) / (2*heps)
        # gr[i] <- (-f(x0+2*hh)+8*f(x0+hh)-8*f(x0-hh)+f(x0-2*hh))/(12*h)
        hh[i] <- 0
    }
    return(gr)
}


# Compute the Jacobian as  J_{ij} = df_i/dx_j  for a vector-valued function
# w/o assuming that the f_i are vectorized.
jacobian <- function(f, x0, heps = .Machine$double.eps^(1/3), ...) {
    if (!is.numeric(x0) || length(x0) == 0)
        stop("Argument 'x' must be a non-empty numeric vector.")

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

	n <- length(x0)
	m <- length(f(x0))
	jacob <- matrix(NA, m, n)
	hh <- numeric(n)
	for (i in 1:n) {
		hh[i] <- heps
		jacob[, i] <- (f(x0 + hh) - f(x0 - hh)) / (2*heps)
		# jacob[, i] <- (-f(x+2*h)+8*f(x+h)-8*f(x-h)+f(x-2*h))/(12*h.eps)
		hh[i] <- 0
	}
	return(jacob)
}

##
##  h o r n e r . R  Horner Scheme
##


# Horner's rule to compute p(x) and p'(x) vectorized for the
# polynomial  p = p_1*x^n + p_2*x^{n-1} + ... + p_n*x + p_{n+1}
horner <- function(p, x) {
    if (length(p) == 0 || length(x) == 0) return(NULL)

	n <- length(p); m <- length(x)
	if (n == 0) { y <- dy <- rep(NA, m) }
	else if (n == 1) { y <- rep(p, m); dy <- rep(0, m) }
	else {
		y <- p[1]; dy <- 0
		for (i in 2:n) {
			dy <- dy * x + y
			y  <-  y * x + p[i]
		}
	}
	return(list(y = y, dy = dy))
}


# Deflated Horner scheme that returns p(x) and the polynomial q with
# p(x) = q(x) * (x - x0) + r, r constant, and r = 0 if x0 is a root of p.
hornerdefl <- function(p, x) {
    if (length(p) == 0 || length(x) == 0) return(NULL)

    n <- length(p) -1                   # degree of polynomial
    q <- numeric(n+1)
    q[1] <- p[1]
    for (j in 2:(n+1))
        q[j] <- p[j] + q[j-1]*x
    return(list(y = q[n+1], q = q[1:n]))
}

##
##  c i r c l e f i t . R  Fitting a Circle
##


circlefit <- function(xp, yp, fast = TRUE) {
    if (!is.vector(xp, mode="numeric") || !is.vector(yp, mode="numeric"))
        stop("Arguments 'xp' and 'yp' must be numeric vectors.")
    if (length(xp) != length(yp))
        stop("Vectors 'xp' and 'yp' must be of the same length.")
    if (!fast)
        warning("Option 'fast' is deprecated and will not be used!",
                call. = FALSE, immediate. = TRUE)

    n  <- length(xp)
    p <- qr.solve(cbind(xp, yp, 1), matrix(xp^2 + yp^2, ncol = 1))
    v <- c(p[1]/2, p[2]/2, sqrt((p[1]^2 + p[2]^2)/4 + p[3]))

    rms <- sqrt(sum((sqrt((xp-v[1])^2 + (yp-v[2])^2) - v[3])^2)/n)
    cat("RMS error:", rms, "\n")
    return(v)
}

##
##  a c c u m a r r a y . R  Accumulate Vector Elements
##


uniq <- function(a, first = FALSE) {
    if (length(a) == 0)
        return(list(b = c(), m = c(), n = c()))
    if (!is.numeric(a) || !is.vector(a))
        stop("Argument 'a' must be a numeric vector.")

    la <- length(a); n <- numeric(la)
    u  <- unique(a)
    lu <- length(u); m <- numeric(lu)

    mima <- if (first) min else max

    for (i in 1:lu) {
        w <- which(a == u[i])
        m[i] <- mima(w)
        n[w] <- i 
    }

    return(list(b = u, m = m, n = n))
}


accumarray <- function(subs, val, sz = NULL, func = sum, fillval = 0) {
    stopifnot(is.numeric(subs), is.numeric(val))
    subs <- floor(subs)
    val <- c(val)
    if (any(subs < 1))
        stop("Argument 'subs' must be a matrix of integer indices.")

    matrix_p <- TRUE
    if (is.vector(subs)) {
        subs <- as.matrix(subs)
        matrix_p <- FALSE
    }

    n <- nrow(subs); m <- ncol(subs)
    if (length(val) < n)
        stop("Length of 'vals' must not be smaller than no. of rows of 'subs'.")

    dm <- apply(subs, 2, max)
    if (!is.null(sz)) {
        if (length(sz) != ncol(subs) || any(sz < dm))
            stop("Argument 'sz' does not fit with 'subs'.")
        dm <- sz
    }

    if (m == 1) {
        A <- rep(fillval, dm)
        for (i in unique(subs)) {
            A[i] <- func(val[subs == i])
        }
        if (matrix_p) A <- as.matrix(A)

    } else {
        cm <- cumprod(dm[1:(m-1)])
        A <- array(fillval, dim = dm)

        K <- numeric(n)
        for (i in 1:n) {
            K[i] <- subs[i, 1] +  sum(cm * (subs[i, 2:m]-1))
        }
        for (i in unique(K)) {
            A[i] <- func(val[K == i])
        }
    }
    return(A)
}

##
##  l s q n o n l i n . R  Nonlinear Least-Squares Fitting
##


lsqnonlin <- function(fun, x0, options = list(), ...) {
    stopifnot(is.numeric(x0))

    #-- Option list handling -----------
    opts <- list(tau     = 1e-3,
                 tolx    = 1e-8,
                 tolg    = 1e-8,
                 maxeval = 700)
    namedOpts <- match.arg(names(options), choices = names(opts),
                           several.ok = TRUE)
    if (!is.null(names(options)))
        opts[namedOpts] <- options
                                    # x0 is   good...not so good start value
    tau     <- opts$tau             # tau = 1e-6...1e-3...1
    tolx    <- opts$tolx            #
    tolg    <- opts$tolg            #
    maxeval <- opts$maxeval         # max. number of iterations

    #-- Matching function
    fct <- match.fun(fun)
    fun <- function(x) fct(x, ...)

    n <- length(x0)                     # fun: R^n --> R^m; n <- nrow(A)
    m <- length(fun(x0))

    # Initialization: Compute f, r, and J
    x <- x0;              r <- fun(x)
    f <- 0.5 * sum(r^2);  J <- jacobian(fun, x)
    g <- t(J) %*% r;     ng <- Norm(g, Inf)
    A <- t(J) %*% J                     # g is a column vector

    mu <- tau * max(diag(A))            # damping parameter
    nu <- 2; nh <- 0

    #-- Main loop
    errno <- 0
    k <- 1
    while (k < maxeval) {
        k <- k + 1

        # h <- solve(A + mu*eye(n), -g) # compute step through linear system
        R <- chol(A + mu*eye(n))        # use the Cholesky decomposition
        h <- c(-t(g) %*% chol2inv(R))   # h <- solve(R, solve(t(R), -g))

        nh <- Norm(h); nx <- tolx + Norm(x)
        if (nh <= tolx * nx) {errno <- 1; break}

        xnew <- x + h; h <- xnew - x
        dL <- sum(h * (mu*h - g))/2
        rn <- fun(xnew)
        fn <- 0.5 * sum(rn^2); Jn <- jacobian(fun, xnew)
        if (length(rn) != length(r))  {df <- f - fn
        } else                        {df <- sum((r - rn) * (r + rn))/2}

        if (dL > 0 && df > 0) {
            x <- xnew;         f <- fn;  J <- Jn;       r <- rn; 
            A <- t(J) %*% J;   g <- t(J) %*% r;         ng <- Norm(g,Inf)
            mu <- mu * max(1/3, 1 - (2*df/dL - 1)^3);   nu <- 2
        } else {
            mu <- mu*nu;  nu <- 2*nu
        }
        if (ng <= tolg) { errno <- 2; break }
    }

    if (k >= maxeval) errno <- 3
    errmess <- switch(errno,
                     "Stopped by small x-step.",
                     "Stopped by small gradient.",
                     "No. of function evaluations exceeded.")

    return(list(x = c(xnew), ssq = sum(fun(xnew)^2), ng = ng, nh = nh,
                mu = mu, neval = k, errno = errno, errmess = errmess))
}


# lsqnonneg <- function(C, d) {
#     stopifnot(is.numeric(C), is.numeric(d))
#     if (!is.matrix(C) || !is.vector(d))
#         stop("Argument 'C' must be a matrix, 'd' a vector.")
#     n <- nrow(C); m <- ncol(C); ld <- length(d)
#     if (n != ld)
#         stop("Arguments 'C' and 'd' have nonconformable dimensions.")
# 
#     fn <- function(x) C %*% as.matrix(exp(x)) - d
#     x0 <- rep(0, m)
#     sol <- lsqnonlin(fn, x0)
# 
#     xs <- exp(sol$x)
#     resi <- d - C %*% as.matrix(xs)
#     resn <- Norm(resi)
#     return(list(x = xs, resnorm = resn, residual = resi, 
#                 exitflag = sol$errmess))
# }


lsqcurvefit <- function(fun, p0, xdata, ydata) {
    stopifnot(is.function(fun), is.numeric(p0))
    stopifnot(is.numeric(xdata), is.numeric(ydata))
    if (length(xdata) != length(ydata))
        stop("Aguments 'xdata', 'ydata' must have the same length.")

    fn <- function(p, x) fun(p, xdata) - ydata
    lsqnonlin(fn, p0)    
}

##
##  g a u s s L e g e n d r e . R  Gauss-Legendre et al. Quadrature Formula
##


gaussLegendre <- function(n, a, b) {
    stopifnot(is.numeric(a), length(a) == 1, is.numeric(b), length(b) == 1,
              is.numeric(n), length(n) == 1, n >= 2)

    i <- seq(1, n-1, by = 1)
    d <- i / sqrt(4*i^2 - 1)

    E <- eigen(Diag(d, 1) + Diag(d, -1), symmetric = TRUE)
    L <- E$values
    V <- E$vectors

    inds <- order(L)
    x <- L[inds]
    V <- t(V[, inds])
    w <- 2 * V[, 1]^2

    x <- 0.5 * ((b-a)*x + a+b)
    w <- -0.5 * (a-b)*w

    return(list(x = x, w = w))
}


gaussHermite <- function(n) {
    stopifnot(is.numeric(n), length(n) == 1, n >= 2)

    i <- seq(1, n-1, by = 1)
    d <- sqrt(i/2)

    E <- eigen(Diag(d, 1) + Diag(d, -1), symmetric = TRUE)
    L <- E$values
    V <- E$vectors

    inds <- order(L)
    x <- L[inds]
    V <- t(V[, inds])
    w <- sqrt(pi) * V[, 1]^2

    return(list(x = x, w = w))
}


gaussLaguerre <- function(n, a = 0) {
    stopifnot(is.numeric(n), length(n) == 1, n >= 2)
    stopifnot(is.numeric(a), length(a) == 1, a >= 0)

    i <- 1:n
    d <- (2*i - 1) + a
    b <- sqrt( i[1:(n-1)] * ((1:(n-1)) + a) )

    E <- eigen(Diag(d) + Diag(b, 1) + Diag(b, -1))
    L <- E$values
    V <- E$vectors

    inds <- order(L)
    x <- L[inds]
    V <- t(V[, inds])

    w <- gamma(a + 1) * V[, 1]^2

    return(list(x = x, w = w))
}

##
##  s p i n t e r p . R
##


spinterp <- function(x, y, xp) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(xp))
    stopifnot(is.vector(x), is.vector(y), is.vector(xp))
    n <- length(x)
    n1 <- n - 1
    if (n <= 3)
        stop("Length of arguments 'x', 'y' must be greater than 3.")
    if (length(y) != n)
        stop("Arguments 'x', 'y' must be vectors of the same length.")
    if(any(is.na(y)))
        stop("NAs are not allowed in argument 'y'.")

    # M o n o t o n i c i t y
    h <- diff(x)
    dy <- diff(y)
    if (any(h <= 0))
        stop("Argument 'x' must be a sorted list af real values.")
    if (any(dy < 0))
        stop("Argument 'y' must be monotonically increasing.")

    # C o n v e x i t y
    delta <- dy / h
    dd <- diff(delta)
    cnvx <- if (all(dd > 0)) TRUE else FALSE

    # Approximate the derivatives at all data points
    if (cnvx) d_mode <- "harmonic"
    else      d_mode <- "geometric"
    d <- rep(NA, n)
    d[1] <- delta[1]
    d[n] <- delta[n1]
    if (d_mode == "arithmetic") {
        for (j in 2:n1)
            d[j] <- (h[j]*delta[j-1] + h[j-1]*delta[j]) / (h[j] + h[j-1])
    } else if (d_mode == "geometric") {
        for (j in 2:n1) {
            d[j] <- (delta[j-1]^h[j] * delta[j]^h[j-1])^(1/(h[j-1]+h[j]))
        }
    } else if (d_mode == "harmonic") {
        for (j in 2:n1) {
            d[j] <- (h[j] + h[j-1]) / (h[j]/delta[j-1] + h[j-1]/delta[j])
        }
    }

    # "C u b i c i t y"
    r <- rep(3, n1)
    if (!cnvx) r_mode <- "monotonic"  #  a n d  monotone
    else       r_mode <- "otherwise"
    r_mode <- "monotonic"               # Fix to "monotonic" for the moment !
    # Now define the r-values for Delbourg & Gregory
    if (r_mode == "monotonic") {
        k <- which(delta != 0)
        #r <- 1 + (d[1:n1] + d[2:n]) / delta  # strictly monotonic
        r[k] <- (d[k] + d[k+1]) / delta[k]
    } else if (r_mode == "otherwise") {
        for (j in 1:n1) {
            r[j] <- 1 + (d[j+1]-delta[j]) / (delta[j]-d[j]) +
                        (delta[j]-d[j]) / (d[j+1]-delta[j])
        }
    }

    # Apply cubic Delbourgo & Gregory formula
    m <- length(xp)
    fi <- findInterval(xp, x)
    yp <- rep(NA, m)

    for (j in 1:m) {
        i <- fi[j]  # findInterval(xp[j], x)
        if (i < n) {
            theta <- (xp[j] - x[i]) / h[i]
            P <- y[i+1] * theta^3 + 
                 (r[i]*y[i+1] - h[i]*d[i+1]) * theta^2 * (1-theta) + 
                 (r[i]*y[i] + h[i]*d[i]) * theta * (1-theta)^2 + 
                 y[i] * (1-theta)^3
            Q <- 1 + (r[i]-3) * theta * (1-theta)
            yp[j] <- P / Q
        } else {
            yp[j] <- y[n]
        }
    }

    return(yp)
}

##
##  b v p . R  Boundary Value Problems
##


bvp <- function(f, g, h, x, y, n = 50) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(n))
    if (length(x) != 2 || length(y) != 2)
        stop("Arguments 'x' and 'y' must have length 2.")
    if (length(n) != 1 || floor(n) != ceiling(n) || n < 2)
        stop("Argument 'n' must be an integer greater or equal 2.")

    if (is.numeric(f)) ffun <- function(x) rep(f[1], length(x))
    else               ffun <- match.fun(f)
    if (is.numeric(g)) gfun <- function(x) rep(g[1], length(x))
    else               gfun <- match.fun(g)
    if (is.numeric(h)) hfun <- function(x) rep(h[1], length(x))
    else               hfun <- match.fun(h)

    xa <- x[1]; xb <- x[2]
    ya <- y[1]; yb <- y[2]
    xs <- linspace(xa, xb, n+2)[2:(n+1)]
    dt <- (xb - xa) / (n+1)

    a <- -2 - dt^2 * gfun(xs)           # main diagonal
    b <-  1 - dt/2 * ffun(xs[1:(n-1)])  # superdiagonal
    d <-  1 + dt/2 * ffun(xs[2:n])      # subdiagonal

    rhs <- dt^2 * hfun(xs)              # right hand side
    rhs[1] <- rhs[1] - ya * (1 + (dt/2) * ffun(xs[1]))
    rhs[n] <- rhs[n] - yb * (1 - (dt/2) * ffun(xs[n]))

    ys <- trisolve(a, b, d, rhs)
    return(list(xs = c(xa, xs, xb), ys = c(ya, ys, yb)))
}


# bvp <- function(p, q, r, a, b, ya, yb) {
#     z0 <- as.matrix(c(ya, 0, 0, 1))
#     fun0 <- function(x, z) {
#         as.matrix(c(z[2],
#                     p(x)*z[2] + q(x)*z[1] + r(x),
#                     z[4],
#                     p(x)*z[4] + q(x)*z[3]
#                    )
#         )
#     }
#     res <- ode45(fun0, a, b, z0, hmax = 0.05)
#     t <- res$t; z <- res$y
#     n <- length(t)
# 
#     y <- z[, 1] + (yb - z[n, 1]) * z[, 3] / z[n, 3]
#     return(list(xs = t, ys = y))
# }

quadv <- function(f, a, b, tol = .Machine$double.eps^(1/2), ...) {
    stopifnot(is.numeric(a), is.numeric(b))
    if (length(a) != 1 || length(b) != 1 || a > b)
        stop("Interval boundaries must satisfy 'a <= b'.")
    if (a == b) return(list(Q = 0, fcnt = 0, estim.prec = 0))
    eps <- .Machine$double.eps

    fun <- match.fun(f)
    f   <- function(x) fun(x, ...)

    # Initialize with unequal intervals
    h <- 0.13579 * (b-a)
    x <- c(a, a + h, a + 2*h, (a + b)/2, b - 2*h, b - h, b)
    y <- f(x[1])
    for (j in 2:7) {
        y <- rbind(y, f(x[j]))
    }
    fcnt <- 7

    # Fudge endpoints to avoid infinities
    if (any(!is.finite(y[1, ]))) {
        y[1, ] <- f(a + eps*(b-a))
        fcnt <- fcnt + 1
    }
    if (any(!is.finite(y[7, ]))) {
        y[7, ] <- f(b - eps*(b-a))
        fcnt <- fcnt + 1
    }

    # Call recursively the main integrator function
    hmin <- eps*(b-a)/1024
    I1 <- .quadvstep(f,x[1], x[3], y[1, ],y[2, ], y[3, ], tol, fcnt, hmin)
    Q1 <- I1$Q
    fcnt <- I1$fcnt
    I2 <- .quadvstep(f,x[3], x[5], y[3, ],y[4, ], y[5, ], tol, fcnt, hmin)
    Q2 <- I2$Q
    fcnt <- I2$fcnt
    I3 <- .quadvstep(f,x[5], x[7], y[5, ],y[6, ], y[7, ], tol, fcnt, hmin)
    Q3 <- I3$Q
    fcnt <- I3$fcnt

    Q <- unname(Q1 + Q2 + Q3)
    return(list(Q = Q, fcnt = fcnt, estim.prec = tol*(fcnt-7)/2))
}


.quadvstep <- function(f, a, b, fa, fc, fb, tol, fcnt, hmin) {
    maxfcnt <- 10000

    # Evaluate integrand twice in interior of subinterval [a,b].
    h <- b - a
    c <- (a + b)/2
    d <- (a + c)/2
    e <- (c + b)/2
    fd <- f(d)
    fe <- f(e)
    fcnt <- fcnt + 2

    Q1 <- (h/6) *(fa + 4*fc + fb)               # Three point Simpson's rule
    Q2 <- (h/12)*(fa + 4*fd + 2*fc + 4*fe + fb) # Five point double Simpson's rule
    Q  <- Q2 + (Q2 - Q1)/15                     # One step of Romberg extrapolation

    if (!all(is.finite(Q)))
        stop("Improper function values: infinite or NaN encountered.")
    if (fcnt > maxfcnt)
        stop("Maximum function count exceeded; singularity likely.")
    if (abs(h) < hmin || c == a || c == b)
        stop("Minimum step size reached; singularity possible.")
    if (max(Q2 - Q) < tol)
        return(list(Q = Q, fcnt = fcnt))

    Iac <- .quadvstep(f, a, c, fa, fd, fc, tol, fcnt, hmin)
    Qac <- Iac$Q
    fcnt <- Iac$fcnt
    Icb <- .quadvstep(f, c, b, fc, fe, fb, tol, fcnt, hmin)
    Qcb <- Icb$Q
    fcnt <- Icb$fcnt

    Q <- Qac + Qcb
    return(list(Q = Q, fcnt = fcnt))
}

shooting <- function(f, t0, tfinal, y0, h, a, b,
                     itermax = 20, tol = 1e-6, hmax = 0) {
    stopifnot(is.numeric(y0), length(y0) == 1,
              is.numeric(t0), length(t0) == 1,
              is.numeric(tfinal), length(tfinal) == 1,
              is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1)

    fun <- match.fun(f)
    ff  <- function(t, y)
              matrix( c(y[2], fun(t, y[1], y[2])) )
    hun <- match.fun(h)
    hh  <- function(u, v) hun(u, v)

    dy <- numeric(itermax); dy[1:2] <- c(a, b)
    m  <- numeric(itermax)
    test <- 1; i <- 1

    while (test > tol && i <= itermax) {
        if (i > 2)
            dy[i] <- dy[i-1] - (dy[i-1]-dy[i-2]) * m[i-1] / (m[i-1]-m[i-2])
        z0 <- matrix(c(y0, dy[i]))
        sol <- ode45(ff, t0, tfinal, z0, atol = tol, hmax = hmax)
        Tsol <- sol$t; Ysol <- sol$y
        n <- length(Tsol)
        yend <- Ysol[n, 1]; ypend <- Ysol[n, 2]
        m[i] <- h(yend, ypend)
        test <- abs(m[i])
        i <- i+1
    }
    return(list(t = Tsol, y = Ysol))
}

##
##  d e t r e n d . R  Remove Linear Trends
##


detrend <- function(x, tt = 'linear', bp = c()) {
    if (!is.numeric(x) && !is.complex(x))
        stop("'x' must be a numeric or complex vector or matrix.")
    trendType <- pmatch(tt, c('constant', 'linear'), nomatch = 0)

    if (is.vector(x))
        x <- as.matrix(x)
    n <- nrow(x)
    if (length(bp) > 0 && !all(bp %in% 1:n))
        stop("Breakpoints 'bp' must elements of 1:length(x).")

    if (trendType == 1) {  # 'constant'
        if (!is.null(bp))
            warning("Breakpoints not used for 'constant' trend type.")
        y <- x - matrix(1, n, 1) %*% apply(x, 2, mean)

    } else if (trendType == 2) {  # 'linear'
        bp <- sort(unique(c(0, c(bp), n-1)))
        lb <- length(bp) - 1

        a <- cbind(matrix(0, n, lb), matrix(1, n, 1))
        for (kb in 1:lb) {
            m <- n - bp[kb]
            a[(1:m) + bp[kb], kb] <- as.matrix(1:m)/m
        }
        y <- x - a %*% qr.solve(a, x)

    } else {
        stop("Trend type 'tt' must be 'constant' or 'linear'.")
    }
    
    return(y)
}

##
##  e r r o r b a r . R  Plot Error Bars
##


#-- Plot or add horizontal and vertical error bars
errorbar <- function(x, y, xerr = NULL, yerr = NULL,
                     bar.col = "red", bar.len = 0.01,
                     grid = TRUE, with = TRUE, add = FALSE, ...)
{
    stopifnot(is.numeric(x), is.numeric(y))
    if (!is.vector(x) || !is.vector(y) || length(x) != length(y))
        stop("Arguments 'x' and 'y' must be numeric vectors of equal length.")

    n <- length(x)
    if ( !is.null(xerr) &&
        (!is.vector(xerr) || (length(xerr) != n && length(xerr) != 1)) )
        stop("Argument 'xerr' must be a vector the same length as 'x'.")
    if ( !is.null(yerr) &&
        (!is.vector(yerr) || (length(yerr) != n && length(yerr) != 1)) )
        stop("Argument 'yerr' must be a vector the same length as 'y'.")

    if (is.null(xerr)){
        x1 <- min(x); x2 <- max(x)
    } else {
	    x1 <- min(x - abs(xerr))
	    x2 <- max(x + abs(xerr))
    }
    if (is.null(yerr)) {
        y1 <- min(y); y2 <- max(y)
    } else {
	    y1 <- min(y - abs(yerr))
	    y2 <- max(y + abs(yerr))
    }

	if (!add) {
		plot(x, y, xlim = c(x1, x2), ylim = c(y1, y2), ...)
		if (grid) grid()
	}

	# Plot the error bars
	if (!is.null(yerr))
	    segments(x, y-yerr, x, y+yerr, col = bar.col)
	if (!is.null(xerr))
	    segments(x-xerr, y, x+xerr, y, col = bar.col)


	if (with) {
		xd <- bar.len * (x2 - x1) / 2.0
		yd <- bar.len * (y2 - y1) / 2.0

        if (!is.null(yerr)) {
		    segments(x-xd, y-yerr, x+xd, y-yerr, col = bar.col)
		    segments(x-xd, y+yerr, x+xd, y+yerr, col = bar.col)
	    }
	    if (!is.null(xerr)) {
		    segments(x-xerr, y-yd, x-xerr, y+yd, col = bar.col)
		    segments(x+xerr, y-yd, x+xerr, y+yd, col = bar.col)
	    }
	}

	invisible()
}

##
##  t r i . R  Triangular matrices
##


tril <- function(M, k = 0) {
    if (k == 0) {
        M[upper.tri(M, diag = FALSE)] <- 0
    } else {
        M[col(M) >= row(M) + k + 1] <- 0
    }
    return(M)
}


triu <- function(M, k = 0) {
    if (k == 0) {
        M[lower.tri(M, diag = FALSE)] <- 0
    } else {
        M[col(M) <= row(M) + k - 1] <- 0
    }
    return(M)
}


##  Format distance matrix
squareform <- function(x) {
    stopifnot(is.numeric(x) || is.complex(x))

    if (is.vector(x)) {
        n <- length(x)
        m <- floor(sqrt(2*n))
        if (m*(m+1) != 2*n)
            stop("Argument 'x' does not correspond to a distance matrix.")
        inds <- c()
        k <- m+1
        for (i in 1:(k-1))
            inds <- c(inds, (1+i+(i-1)*k):(i*k))
        y <- numeric(k*k)
        y[inds] <- x
        y <- matrix(y, k, k) + t(matrix(y, k, k))
    
    } else if (is.matrix(x)) {
        m <- nrow(x); n <- ncol(x)
        if (m != n)
            stop("Argument 'x' must be a vector or a square matrix.")
        if (any(diag(x) != 0))
            stop("Argument 'x' can only have 0s on the diagonal.")
        if (n == 1) return(c())
        inds <- c()
        for (i in 1:(n-1))
            inds <- c(inds, (1+i+(i-1)*n):(i*n))
        y <- x[inds]
    
    } else
        stop("Argument 'x' must be a numeric or complex vector or matrix.")

    return(y)
}

##
##  p c h i p . R  Piecwise Cubic Hermitean Interpolation Polynomials
##


pchip <- function(xi, yi, x) {
    stopifnot(is.numeric(xi), is.numeric(yi), is.numeric(x))
    # xi <- c(xi); yi <- c(yi); x <- c(x)
    if (!is.sorted(xi))
        stop("Argument 'xi' must be a sorted vector of real numbers.")
    n <- length(xi);
    if (length(yi) != n)
        stop("Arguments 'xi', 'yi' must be vectors of equal length.")
    if (n <= 2)
        stop("At least three points needed for cubic interpolation.")

    # First derivatives
    h <- diff(xi)
    delta <- diff(yi) / h
    d <- .pchipslopes(h, delta)

    # Piecewise polynomial coefficients
    a <- (3*delta - 2*d[1:(n-1)] - d[2:n]) / h
    b <- (d[1:(n-1)] - 2*delta + d[2:n]) / h^2;

    # Find subinterval indices k so that xi[k] <= x < xi[k+1]
    k <- rep(1, length(x))
    for (j in 2:(n-1)) {
       k[xi[j] <= x] <- j
    }

    # Evaluate interpolant
    s <- x - xi[k]
    v <- yi[k] + s*(d[k] + s*(a[k] + s*b[k]))

    return(v)
}


.pchipslopes <- function(h, delta) {

    # Slopes at interior points
    n <- length(h) + 1
    d <- numeric(length(h))
    k <- which(sign(delta[1:(n-2)]) * sign(delta[2:(n-1)]) > 0) + 1
    w1 <- 2*h[k] + h[k-1]
    w2 <- h[k]+2*h[k-1]
    d[k] <- (w1+w2) / (w1/delta[k-1] + w2/delta[k])

    # Slopes at endpoints
    d[1] <- .pchipend(h[1], h[2], delta[1], delta[2])
    d[n] <- .pchipend(h[n-1], h[n-2], delta[n-1], delta[n-2])

    return(d)
}


.pchipend <- function(h1, h2, del1, del2) {
    # Noncentered, shape-preserving, three-point formula.
    d <- ((2*h1 + h2)*del1 - h1*del2) / (h1 + h2)
    if (sign(d) != sign(del1)) {
        d <- 0
    } else if ((sign(del1) != sign(del2)) && (abs(d) > abs(3*del1))) {
        d <- 3*del1
    }
    return(d)
}


pchipfun <- function(xi, yi) {
    stopifnot(is.numeric(xi), is.numeric(yi))
    # xi <- c(xi); yi <- c(yi)
    if (!is.sorted(xi))
        stop("Argument 'xi' must be a sorted vector of real numbers.")
    n <- length(xi);
    if (length(yi) != n)
        stop("Arguments 'xi', 'yi' must be vectors of equal length.")
    if (n <= 2)
        stop("At least three points needed for cubic interpolation.")

    function(x) pchip(xi, yi, x)
}

##
##  a r c l e n g t h . R  Arc Length
##


arclength <- function(f, a, b, nmax = 20, tol = 1e-05, ...) {
	stopifnot(is.numeric(a), length(a) == 1,
	          is.numeric(b), length(b) == 1)
 	fun <- match.fun(f)
 	f <- function(x) fun(x, ...)

 	if (abs(b-a) < tol)
 	    return(list(length = 0, niter = 0, rel.err = tol))

    fa <- f(a); fb <- f(b)
    m <- length(fa)
    if (length(fa) < 2)
        stop("Argument 'f' must be a parametrized function.")
    if (length(f(c(a, b))) != 2*m)
        stop("Argument 'f' must be a vectorized function.")

    h <- (b - a)
	A <- matrix(0, nmax, nmax)
    A[1, 1] <- sqrt(sum((fb - fa)^2))

    for (i in 1:(nmax-1)) {
    	h <- h/2
    	x <- seq(a, b, by = (b-a)/2^i)
    	y <- c(f(x))
    	X <- matrix(y, ncol = m)
    	dX <- diff(X)

    	A[i+1, 1] <- sum(sqrt(rowSums(dX^2)))
    	for (j in 1:i) {
            A[i+1, j+1] <- (4^j * A[i+1, j] - A[i, j]) / (4^j - 1)
        }
        if (abs(A[i+1, i+1] - A[i, i]) < tol && i > 3) break
    }

    e <- abs(A[i+1, i+1] - A[i, i])
    list(length = A[i+1, i+1], niter = i+1, rel.err = e)
}

##
##  i n p o l y g o n . R  Polygon Interior
##


inpolygon <- function(x, y, xp, yp, boundary = FALSE) {
    stopifnot(is.numeric(x), is.numeric(y), length(x) == length(y),
              is.numeric(xp), is.numeric(yp), length(xp) == length(yp))

    # xmin <- min(xp); xmax <- max(xp)  # exclude all points 'far' outside
    # ymin <- min(yp); ymax <- max(yp)

    n  <- length(x)
    np <- length(xp)

    # Polygon must be closed
    if (xp[1] != xp[np] || yp[1] != yp[np]) {
        xp <- c(xp, xp[1])
        yp <- c(yp, yp[1])
        np <- np + 1
    }

    inpoly <- rep(FALSE, n)
    onpoly <- rep(FALSE, n)

    j <- np
    for (i in 1:np) {
        dxp <- xp[j] - xp[i]
        dyp <- yp[j] - yp[i]
        dist <- dxp * (y - yp[i]) - (x - xp[i]) * dyp

        idx1 <- ( ((yp[i] <= y & y < yp[j])  |
                   (yp[j] <= y & y < yp[i])) &
                  (0 < dist * dyp) )
        inpoly[idx1] <- !inpoly[idx1]

        idx2 <- ( ((yp[i] <= y & y <= yp[j]) | (yp[j] <= y & y <= yp[i])) &
                  ((xp[i] <= x & x <= xp[j]) | (xp[j] <= x & x <= xp[i])) &
                  (0 == dist | !dxp) )
        onpoly[idx2] <- TRUE

        j <- i
    }

    if (boundary) inpoly[onpoly] <- TRUE
    else          inpoly[onpoly] <- FALSE

    return(inpoly)
}

##
##  t r i g r e g r e s s . R  Trigonometric Regression
##


trigPoly <- function(x, m) {
    stopifnot(is.numeric(x), is.numeric(m), length(m) == 1, m >= 0)
    if (m == 0)
        return(list(a0 = mean(x), a = c(), b = c()))

    n <- length(x)
    t <- seq(0, 2*(n-1)*pi/n, length.out = n)
    t <- as.matrix(t)

    a <- b <- numeric(m)
    for (j in 1:m) {
        a[j] <- x %*% cos(j*t)
        b[j] <- x %*% sin(j*t)
    }
    a <- 2*a/n
    b <- 2*b/n
    a0 <- sum(x)/n
    if (n == 2*m) a[m] <- a[m]/2

    return(list(a0 = a0, a = a, b = b))
}


trigApprox <- function(t, x, m) {
    stopifnot(is.numeric(t))

    tP <- trigPoly(x, m)
    a0 <- tP$a0
    a <- tP$a; b <- tP$b

    y <- a0
    for (j in 1:m) {
        y <- y + a[j]*cos(j*t) + b[j]*sin(j*t)
    }
    return(y)
}

##
##  c o m b s . R  Combinations
##


combs <- function(a, m){
    n <- length(a)
    if (length(a) == 0 || m <= 0) return(c())
    if (m >= n) return(a)
    if (m <= 1) return(matrix(a, n, 1))

    v <- c(a)
    P <- c()
    for (k in 1:(n-m)) {
        Q <- combs(v[(k+1):n], m-1)
        P <- rbind(P, cbind(v[k], Q))
    }
    k <- n-m+1
    Q <- combs(v[(k+1):n], m-1)
    P <- rbind(P, c(v[k], Q))

    b <- a[c(P)]
    dim(b) <- dim(P)
    return(P)
}

randcomb <- function(a, m) {
    n <- length(a)
    if (n == 0) return(c())


    m <- sample(1:n, size = m, replace = FALSE)
    return(a[m])
}

##
##  q u a d c c . R  Adaptive Clenshaw-Curtis Quadrature
##


quadcc <- function(f, a, b, tol = .Machine$double.eps^0.5, ...) {
    stopifnot(is.numeric(a), length(a) == 1,
              is.numeric(b), length(b) == 1)
    eps <- .Machine$double.eps

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    
    if (a == b)     return(0)
    else if (a > b) return(-1 * quadgk(f, b, a, tol = tol))
    if (!is.finite(f(a))) a <- a + eps * sign(b-a)
    if (!is.finite(f(b))) b <- b - eps * sign(b-a)

    .ccadpt <- function(f, a, b, tol = tol) {
        Q4 <- clenshaw_curtis(f, a, b, n = 4)
        Q8 <- clenshaw_curtis(f, a, b, n = 8)
        if (abs(Q4 - Q8) < tol) {
            return(Q8)
        } # else

        Q2 <- .ccadpt(f, (a+b)/2, b, tol = tol)
        Q1 <- .ccadpt(f, a, (a+b)/2, tol = tol)

        return(Q1 + Q2)
    }
    return(.ccadpt(f, a, b, tol))
}

##
##  s i m p a d p t . R  Adaptive Simpson's Rule
##


simpadpt <- function(f, a, b, tol = 1e-6, ...) {
    stopifnot(is.numeric(a), length(a) == 1, is.numeric(b), length(b) == 1)
    eps <- .Machine$double.eps

    fun <- match.fun(f)
    f <- function(x) fun(x, ...)
    
    if (a == b)     return(0)
    else if (a > b) return(-1 * simpadpt(f, b, a, tol = tol))
        
    # Start with unequal subintervals
    h <- 1/8 * (b-a)
    x <- c(a,      a+h,    a+2*h,    (a+b)/2,    b-2*h,    b-h,    b)
    y <- c(f(a), f(a+h), f(a+2*h), f((a+b)/2), f(b-2*h), f(b-h), f(b))

    # Avoid infinities at end points
    if ( !is.finite(y[1]) ) y[1] <- f(a + eps*(b-a))
    if ( !is.finite(y[7]) ) y[7] <- f(b - eps*(b-a))

    # Call the adaptive simpson function
    hmin <- eps * (b-a) / 1024
    Q1 <- .simpadpt(f, x[1], x[3], y[1], y[2], y[3], tol, hmin)
    Q2 <- .simpadpt(f, x[3], x[5], y[3], y[4], y[5], tol, hmin)
    Q3 <- .simpadpt(f, x[5], x[7], y[5], y[6], y[7], tol, hmin)

    return(Q1 + Q2 + Q3)
}


.simpadpt <- function(f, a, b, fa, fc, fb, tol, hmin) {
    h <- b - a
    g <- (a + b)/2  # fc
    d <- (a + g)/2; fd <- f(d)
    e <- (g + b)/2; fe <- f(e)

    # Three- and five-point Simpson's rule
    # plus a one-step Romberg extrapolation
    Q1 <- (h/6) * (fa + 4*fc + fb)
    Q2 <- (h/12) * (fa + 4*fd + 2*fc + 4*fe + fb)
    Q <- Q2 + (Q2 - Q1)/15

    if (!is.finite(Q)) {
        warning("Infinite or NA function value encountered.")
        return(Q)
    } else if (abs(Q2 - Q) <= tol) {
        return(Q)
    } else if (abs(h) < hmin || g == a || g == b) {
        warning("Minimum step size reached; singularity possible.")
        return(Q)
    }

    Q4 <- .simpadpt(f, a, g, fa, fd, fc, tol, hmin)
    Q5 <- .simpadpt(f, g, b, fc, fe, fb, tol, hmin)

    return(Q4 + Q5)
}

##
##  r e g e x p . R
##

regexp <- function(s, pat, ignorecase = FALSE, once = FALSE, split = FALSE)
{
    # Match regular expression
    stopifnot(is.character(pat), is.character(s))
    if (length(pat) > 1) {
        warning("Only the first string in argument 'pat' is taken.")
        pat <- pat[1]
    }
    if (length(s) > 1) {
        warning("Only the first string in argument 's' is taken.")
        s <- s[1]
    }
    if (is.na(pat) || is.na(s))
        stop("In arguments 'pat' and 's' NA values not allowed.")

    if (once) {
        res <- regexpr(pat, s, ignore.case = ignorecase, perl = TRUE)
    } else {
        res <- gregexpr(pat, s, ignore.case = ignorecase, perl = TRUE)[[1]]
    }

    if (length(res) == 1 && res < 0)
        if (split)
            return(list(start = NULL, end = NULL, match = NULL, split = s))
        else
            return(list(start = NULL, end = NULL, match = NULL, split = NULL))

    # Return start, end, and match
    rstart <- res
    rend <- rstart + attr(res, "match.length") - 1
    attr(rstart, "match.length") <- attr(rend, "match.length") <-NULL
    rmatch <- substring(s, rstart, rend)
    if (split) {
        # rsplit <- strsplit(s, pat, perl = TRUE)[[1]]  # does not ignore case
        n <- nchar(s)
        rs <- c(0, rstart, n+1)
        re <- c(0, rend, n+1)
        rsplit <- c()
        for (i in 1:(length(rs)-1)) {
            if (rs[i+1] - re[i] > 1)
                rsplit <- c(rsplit, substr(s, re[i]+1, rs[i+1]-1))
        }
    } else {
        rsplit <- NULL
    }

    list(start = rstart, end = rend, match = rmatch, split = rsplit)
}

regexpi <- function(s, pat, once = FALSE, split = FALSE)
{
    regexp(s, pat, ignorecase = TRUE, once = once, split = split)
}

regexprep <- function(s, expr, repstr, ignorecase = FALSE, once = FALSE)
{
    # Replace string using regular expression
    if (! is.character(s))
        stop("Argument 's' must be a character vector.")
    if (!is.character(expr) || !is.character(repstr) ||
        length(expr) != 1   || length(repstr) != 1)
        stop("Arguments 'old' and 'new' must be simple character strings.")

    if (once) {
        sub(expr, repstr, s, ignore.case = ignorecase, perl = TRUE)
    } else {
        gsub(expr, repstr, s, ignore.case = ignorecase, perl = TRUE)
    }
}

refindall <- function(s, pat, over = 1, ignorecase = FALSE)
{
  if (!is.character(s) || !is.character(pat) ||
      length(s) != 1 || length(pat) != 1)
      stop("Arguments 's' and 'pat' must be single strings.")
  if (!is.numeric(over) || length(over) != 1 ||
      over < 1 || over != round(over))
      stop("Argument 'over' must be a positive integer.")

  pos <- c()  # positions of matches
  i <- 1; n <- nchar(s)
  found <- regexpr(pat, substr(s, i, n), ignore.case = ignorecase, perl=TRUE)
  while (found > 0) {
    pos <- c(pos, i + found - 1)
    i <- i + found + (over - 1)
    found <- regexpr(pat, substr(s, i, n), ignore.case = ignorecase, perl=TRUE)
  }
  return(pos)
}

##
##  g o l d e n _ r a t i o .R  Golden Ratio Search
##


golden_ratio <- function(f, a, b, ...,
                         maxiter = 100, tol = .Machine$double.eps^0.5)
# Golden Ratio search for a univariate function minimum in a bounded interval
{
    fun <- match.fun(f)
    f <- function(x) fun(x, ...)

	phi <- 1 - (sqrt(5) - 1)/2
	x <- c(a, a + phi*(b-a), b - phi*(b-a), b)
	y2 <- f(x[2])
	y3 <- f(x[3])
	n <- 0
	while (x[3] - x[2] > tol) {
		n <- n + 1
		if (y3 > y2) {
			x <- c(x[1], x[1]+phi*(x[3]-x[1]), x[2], x[3])
			y3 <- y2
			y2 <- f(x[2])
		} else {
			x <- c(x[2], x[3], x[4]-phi*(x[4]-x[2]), x[4])
			y2 <- y3
			y3 <- f(x[3])
		}
		if (n >= maxiter) break
	}
	xm <- (x[2]+x[3])/2
	fxm <- if (abs(f(xm)) <= tol^2) 0.0 else f(xm)
	return(list(xmin=xm, fmin=fxm, iter=n, estim.prec=abs(x[3]-x[2])))
}

##
##  f f t . R  Fourier Transform
##


ifft <- function(x) {
    if (length(x) == 0)
        return(c())
    if ( (!is.vector(x, mode="numeric") && !is.vector(x, mode="complex")))
        stop("Argument 'x' must be real or complex vector.")
    
    fft(x, inverse = TRUE) / length(x)
}


fftshift <- function(x) {
    stopifnot(is.double(x) || is.complex(x) || is.integer(x))
    if (!is.vector(x))
        stop("Argument 'x' must be a real or complex vector.")

    m <- length(x)
    p <- ceiling(m/2)
    idx <- c((p+1):m, 1:p)
    x[idx]
}


ifftshift <- function(x) {
    stopifnot(is.double(x) || is.complex(x) || is.integer(x))
    if (!is.vector(x))
        stop("Argument 'x' must be a real or complex vector.")

    m <- length(x)
    p <- floor(m/2)
    idx <- c((p+1):m, 1:p)
    x[idx]
}

##
##  m e s h g r i d . R  Generate a Mesh Grid
##


meshgrid <- function(x, y = x) {
    if (!is.numeric(x) || !is.numeric(y))
        stop("Arguments 'x' and 'y' must be numeric vectors.")

    x <- c(x); y <- c(y)
    n <- length(x)
    m <- length(y)

    X <- matrix(rep(x, each = m),  nrow = m, ncol = n)
    Y <- matrix(rep(y, times = n), nrow = m, ncol = n)

    return(list(X = X, Y = Y))
}


peaks <- function(v = 49, w) {
    stopifnot(is.numeric(v))
    if (missing(w)) {
        if (length(v) == 1 && v >= 1) {
            mg <- meshgrid(linspace(-3, 3, floor(v)))
             x <- mg$X; y <- mg$Y
        } else {
            mg <- meshgrid(v, v)
             x <- mg$X; y <- mg$Y
        }
    } else {
        stopifnot(is.numeric(w))
        x <- v; y <- w
    }

    z <-  3 * (1-x)^2 * exp(-(x^2) - (y+1)^2) -
         10 * (x/5 - x^3 - y^5) * exp(-x^2 - y^2) -
        1/3 * exp(-(x+1)^2 - y^2)

    return(list(X = x, Y = y, Z = z))
}

##
##  l i n p r o g . R  Linear Programming Solver
##


linprog <- function(cc, A = NULL, b = NULL, Aeq = NULL, beq = NULL,
                    lb = NULL, ub = NULL, x0 = NULL, I0 = NULL,
                    bigM = 100, maxiter = 20, maximize = FALSE)
{
    .lp.check(cc, A, b, Aeq, beq, lb, ub, x0, I0)
    if (maximize) cc <- -cc

    # there are only inequality constraints
    if (is.null(Aeq) && all(b >= 0)) {
        # go and find a base vector and index set
        Pin <- .lp.create(cc, A, b, lb, ub)
        Sin <- .lp.solve(Pin$cc, Pin$A, Pin$b, Pin$x0, Pin$I0,
                         maxiter = maxiter)

    # find a feasible base vector first
    } else {
        # there are only equality constraints
        if (is.null(A) && is.null(lb) && is.null(ub)) {
            A <- Aeq
            b <- beq
            cc0 <- cc

        # there are both equality and inequality constraints
        } else {
            Pin <- .lp.create(cc, A, b, lb, ub)
            Ain <- Pin$A
            bin <- Pin$b
            cc0 <- Pin$cc
            if (!is.null(Aeq)) {
                Aeq <- cbind(Aeq, matrix(0, nrow = nrow(Aeq),
                                    ncol = ncol(Ain)-ncol(Aeq)))
                A <- rbind(Ain, Aeq)
                b <- c(Pin$b, beq)
            } else {
                A <- Ain
                b <- bin
            }
        }

        # only equalities; now guarantee that b >= 0
        inds <- which(b < 0)
        if (length(inds) > 0) {
            A[inds, ] <- -A[inds, ]
            b[inds] <- -b[inds]

        }
        # all constraints combined in one equality matrix A and vectors b, cc
        m <- nrow(A); n <- ncol(A)
        A0 <- cbind(A, diag(m))
        b0 <- b

        x0 <- c(rep(0, n), b0)
        I0 <- (n+1):(n+m)

        if (bigM > 0) {                 # big-M approach
            M  <- bigM
            k <- 1; kmax <- 8
            while (k < kmax) {
                f <- c(cc0, rep(M, m))
                Sin <- .lp.solve(f, A0, b0, x0, I0, maxiter = maxiter)
                if (Sin$errno < 0 || all(Sin$x[I0] == 0)) break
                M <- 10 * M
                k <- k + 1
            }
            # browser()
            if (k >= kmax) {
                Sin$errno <- -4
            }
        } else {                        # phase-I approach
            f <- rep(1, n+m)
            Sin <- .lp.solve(f, A0, b0, x0, I0, maxiter = maxiter)
            if (Sin$errno < 0) {
                Sin$errno <- -5
            } else {
                x1 <- Sin$x[1:n]; z1 <- Sin$x[(n+1):(n+m)]
                I1 <- which(x1 != 0)
                if (length(I1) != m) {
                    Sin$errno <- -5
                } else if (all(z1 == 0)) {
                    Sin <- .lp.solve(cc0, A, b, x1, I1, maxiter = maxiter)
                } else
                    Sin$errno <- -2
            }
        }
    }
    errno <- Sin$errno
    errmsg <- c("Maximum no. of iterations exceeded.",
                "Problem is most likely unfeasible.",
                "Problem is most likely unbounded.",
                "Big-M appraoch not successful.",
                "Phase-I approach not successful.")

    if (errno < 0) {
        mess <- errmsg[abs(errno)]
        return(list(x = NA, fval = NA, errno = errno, message = mess))
    } else {
        mess <- "Solver LP converged successfully."
        x <- Sin$x[1:length(cc)]
        y <- Sin$y[1:length(b)]
        f <- sum(cc * x)
        if (maximize) f <- -f
        return(list(x = x,  fval = f, errno = errno, message = mess))
    }
    cat("LP solver stopped.\n")
}


.lp.check <- function(cc, A, b, Aeq, beq, lb, ub, x0, I0) {
    stopifnot(is.numeric(cc))
    if (is.numeric(lb) && length(lb) != length(cc) ||
        is.numeric(ub) && length(ub) != length(cc))
        stop("Arguments 'cc', 'lb', and 'ub' must have equal lengths.")

    if (!is.null(A)) {
        if (is.null(b)) stop("Vector 'b' must be present if 'A' is.")
        if (!is.matrix(A)) stop("Argument 'A' must be a matrix.")
        m <- nrow(A); n <- ncol(A)
        if (length(cc) != n) stop("Length of 'cc' does not fit to 'ncol(A)'.")
        if (length(b) != m)  stop("Length of 'b' does not fit to 'nrow(A)'.")
    }
}


.lp.create <- function(cc, Ain, bin, lb, ub) {
    A <- Ain
    b <- bin
    if (is.null(Ain)) {
        m_in <- 0
        n <- length(cc)
    } else {
        m_in <- nrow(Ain)
        n <- ncol(Ain)
    }

    # upper bounds
    if (!is.null(ub)) {
        inds <- which(is.finite(ub))
        m1 <- length(inds)
        B <- matrix(0, nrow = m1, ncol = n)
        for (k in 1:m1) B[k, inds[k]] <- 1
        A <- rbind(A, B)
        b <- c(b, ub[inds])
    }

    # lower bounds
    if (!is.null(lb)) {
        inds <- which(lb > 0)   # all(lb >= 0)
        m2 <- length(inds)
        B <- matrix(0, nrow = m2, ncol = n)
        for (k in 1:m2) B[k, inds[k]] <- -1
        A <- rbind(A, B)
        b <- c(b, -lb[inds])
    }

    # slack variables and base vector
    m <- nrow(A)            # m <- m_in + m1 + m2
    A <- cbind(A, diag(m))
    cc <- c(cc, rep(0, m))
    v <- c(rep(0, n), b)
    I <- (n+1):(n+m)

    return(list(A = A, b = b, cc = cc, x0 = v, I0 = I))
}


.lp.solve <- function(cc, A, b, x, I, maxiter = maxiter) {
    # Linear program  A x = b, minimize cc * x.
    # x is assumed to be a base vector with index set I.
    stopifnot(is.numeric(A), is.numeric(b), is.numeric(x))

    if (!is.matrix(A))
        stop("Argument 'A' must be a numeric matrix.")
    m <- nrow(A); n <- ncol(A)
    if (length(b) != m || length(x) != n)
        stop("One of arguments 'x' or 'b' does not have correct length.")

    # cat("Start value:", cc %*% x, "\n")
    # check I: must be a strict subset of {1, ..., n}

    iter <- 0
    errno <- 0
    while (iter < maxiter) {
        iter <- iter + 1
        J <- setdiff(1:n, I)
        B <- A[, I]; N <- A[, J]
        x_I <- x[I]; x_J <- x[J]
        c_I <- cc[I]; c_J <- cc[J]
        
        # Transform base vector
        y <- solve(t(B), c_I)
        u <- numeric(n)
        for (j in J)
	        u[j] <- cc[j] - t(A[, j]) %*% y
        
        # Case 1: x is a solution of the LP
        if (all(u >= 0)) {
            # cat("Solution found!\n")
            errno <- 1
            break
        }
        
        # Case 2: r in J with u[j] < 0
        r <- which(u < 0)
        if (length(r) > 1) r <- r[sample(1:length(r), 1)]
        
        dd <- solve(B, A[, r])
        d <- numeric(n)
        d[I] <- dd
        
        # Case 2a: The LP does not have a solution
        if (all(d <= 0)) {
            # cat("LP is infeasible!\n")
            errno <- -2
            break
        }
        
        # Case 2b: i in I with d[i] > 0
        i0 <- which(d > 0)
        t <- min(x[i0]/d[i0])
        s <- which(x[i0]/d[i0] == t); s <- i0[s]
        if (length(s) > 1)
            s <- s[sample(1:length(s), 1)]
        
        z <- numeric(n)
        z[r] <- t
        z[I] <- x_I - t*d[I]

        # Define a new base vector
        x <- z
        is <- which(I == s)
        I[is] <- r
        # cat("New base vector:", cc %*% x, "\n")
    }
    if (iter >= maxiter) {
        errno <- -1
    }
    if (errno < 0) {
        x <- y <- NA
    }

    return(list(x = x, dual.x = y, errno = errno))
}

blkdiag <-function(...) {
	dots <- list(...)
	if (! all(sapply(dots, is.matrix)) ||
	    ! all(sapply(dots, is.numeric)) )
		stop("All input arguments in '...' must be numeric matrices")

	nrows <- sapply(dots, nrow)
	ncols <- sapply(dots, ncol)
	if (any(nrows == 0) || any(ncols == 0))
		stop("All input matrices '...' must be non-empty.")

	n <- sum(nrows)
	N <- c(0, cumsum(nrows))
	m <- sum(ncols)
	M <- c(0, cumsum(ncols))

	A <- matrix(0, nrow = n, ncol = m)

	k <- length(dots)
	for (i in 1:k) {
		A[(N[i]+1):N[i+1], (M[i]+1):M[i+1]] <- dots[[i]]
	}


	return(A)
}

##
##  s i z e . R  Matlab size, numel, ndims, and isempty functions
##


size <- function(x, k) {
	if (length(x) == 0)    sz <- 0
	else if (is.vector(x)) sz <- c(1, length(x))
	else if (is.array(x))  sz <- dim(x)
	else                   sz <- NULL

	if (!missing(k)) {
		if (k > length(sz)) sz <- 1
		else if (k >= 1)    sz <- sz[k]
		else
			stop("Requested dimension 'k' is out of range.")
	}
	return(sz)
}

numel <- function(x) {
	sz <- size(x)
	if (!is.null(sz)) prod(sz)
	else              return(NULL)
}

nnz <- function(x) {
    if (length(x) == 0) return(0)
    stopifnot(is.numeric(x) || is.complex(x))
    sum(x != 0)
}

ndims <- function(x) {
    if (length(x) == 0) nd <- 0
    else if (is.vector(x)) nd <- 1
    else if (is.array(x)) nd <- length(dim(x))
    else nd <- NA
    
    return(nd)
}

# ndims <- function(x) {
#   sz <- size(x)
#   if (!is.null(sz)) length(sz)
#   else              return(NULL)
# }

isempty <- function(x) {
	length(x) == 0
}

broyden <- function(Ffun, x0, J0 = NULL, ...,
                    maxiter = 100, tol = .Machine$double.eps^(1/2)) {
    if (!is.numeric(x0))
        stop("Argument 'x0' must be a numeric (row or column) vector.")
    fun <- match.fun(Ffun)
    F <- function(x) fun(x, ...)
    y0 <- F(x0)
    if (length(x0) != length(y0))
        stop("Function 'F' must be 'square', i.e. from R^n to R^n .")
    if (length(x0) == 1)
        stop("Function 'F' must not be a univariate function.")

    # Compute once the Jacobian and its inverse
    if (is.null(J0)) {
        A0 <- jacobian(F, x0)
    } else {
        A0 <- J0
    }

    B0 <- inv(A0)
    if (any(is.infinite(B0)))
        B0 <- diag(length(x0))

    # Secant-like step in Broyden's method
    xnew <- x0 - B0 %*% y0
    ynew <- F(xnew)

    k <- 1
    while (k < maxiter) {
        s <- xnew - x0
        d <- ynew - y0
        if (norm(s, "F") < tol || norm(as.matrix(ynew), "F") < tol)  break

        # Sherman-Morrison formula
        B0 <- B0 + (s - B0 %*% d) %*% t(s) %*% B0 / c(t(s) %*% B0 %*% d)

        # Update for next iteration
        x0 <- xnew
        xnew <- xnew - B0 %*% ynew
        y0 <- ynew
        ynew <- F(xnew)

        k <- k + 1
    }

    if (k >= maxiter)
        warning(paste("Not converged: Max number of iterations reached."))

    fnew <- sqrt(sum(ynew^2))
    return(list(zero = c(xnew), fnorm = fnew, niter = k))
}

##
##  a n d o r . R  Logical AND, OR
##


and <- function(l, k) {
    return((l & k) + 0)
}


or <- function(l, k) {
    return((l | k) + 0)
}


# and <- function(...) {
# 	all(sapply(as.list(...), as.logical))
# }
# 
# or <- function(...)  {
# 	any(sapply(as.list(...), as.logical))
# }

##
##  o d r l i n r e g . R  Orthogonal Distance Regression
##


# Linear orthogonal distance regression method
odregress <- function(x, y) {
    stopifnot(is.numeric(x), is.numeric(y))
    
    Z <- cbind(x, y)
    n <- nrow(Z)      # no. of data points
    m <- ncol(Z) - 1  # no. of independent variables

    meanZ <- repmat(apply(Z, 2, mean), n, 1)
    svdZ <- svd(Z - meanZ)
    V <- svdZ$v

    a <- -V[1:m, m+1] / V[m+1, m+1]
    b <- mean(Z %*% V[, m+1]) / V[m+1, m+1]

    # Fitted values
    yfit <- cbind(x, 1) %*% c(a, b)
    resd <- y - yfit

    # orthogonal distance
    normal <- V[, m+1]
    err <- abs((Z - meanZ) %*% normal)
    ssq <- sum(err^2)

    return( list(coeff = c(a, b), ssq = ssq, err = err, 
                 fitted = yfit, resid = resd, normal = normal) )
}

##
##  i n v l a p . R  Inverse Laplacian
##


invlap <- function(Fs, t1, t2, nnt, a = 6, ns = 20, nd = 19) {
    stopifnot(is.numeric(t1), length(t1) == 1, is.numeric(t2), length(t2) == 1,
              is.numeric(nnt), length(nnt) == 1)
    Fs <- match.fun(Fs)

    radt <- linspace(t1, t2, nnt)
    if (t1 == 0)  {
        radt <- radt[2:nnt]
        nnt <- nnt - 1
    }

    alfa <- beta <- numeric(ns+1+nd)
    for (n in 1:(ns+1+nd)) {
       alfa[n] <- a + (n-1) * pi * 1i
       beta[n] <- -exp(a) * (-1)^n
    }
    n <- 1:nd
    bdif <- rev(cumsum(gamma(nd+1) / gamma(nd+2-n) / gamma(n))) / 2^nd
    beta[(ns+2):(ns+1+nd)] <- beta[(ns+2):(ns+1+nd)] * bdif
    beta[1] = beta[1]/2

    ft <- numeric(nnt)
    for (kt in 1:nnt) {
       tt <- radt[kt]
       s <- alfa/tt
       bt <- beta/tt
       btF <- bt * Fs(s)
       ft[kt] <- sum(Re(btF))
    }

    return(list(x = radt, y = ft))
}

##
##  r r e f . R  Reduced Row Echelon Form
##


rref <- function(A) {
    stopifnot(is.numeric(A))
    if (!is.matrix(A))
        stop("Input parameter 'A' must be a matrix.")

    nr <- nrow(A); nc <- ncol(A)
    tol <- eps() * max(nr, nc) * max(abs(A))

    r <- 1
    for (i in 1:nc) {
        pivot <- which.max(abs(A[r:nr, i]))
        pivot <- r + pivot - 1
        m <- abs(A[pivot, i])
        if (m <= tol) {
            A[r:nr, i] <- 0  # zeros(nr-r+1, 1)
        } else {
            A[c(pivot, r), i:nc] <- A[c(r, pivot), i:nc]
            A[r, i:nc] <- A[r, i:nc] / A[r, i]
            if (r == 1) {
                ridx <- c((r+1):nr)
            } else if (r == nr) {
                ridx <- c(1:(r-1))
            } else {
                ridx <- c(1:(r-1), (r+1):nr)
            }
            A[ridx, i:nc] <- A[ridx, i:nc] - 
                             A[ridx, i, drop=FALSE] %*% A[r, i:nc, drop=FALSE]
            if (r == nr) break
            r <- r+1
        }
    }
    A[abs(A) < tol] <- 0
    return(A)
}

##
##  i n t e g r a l . R  Numerical Integration
##


integral <- function(fun, xmin, xmax,
                method = c("Kronrod", "Clenshaw","Simpson"),
                no_intervals = 8, random = FALSE,
                reltol = 1e-8, abstol = 0, ...)
{
    stopifnot(is.numeric(xmin), length(xmin) == 1,
              is.numeric(xmax), length(xmax) == 1)
    no_intervals <- max(1, floor(no_intervals))

    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

    if (length(f(xmin)) > 1 || length(f(xmax)) > 1) {
        stop("Function 'fun' is array-valued! Use 'quadv'.\n")
    }
    
    if (length(f(c(xmin, xmax))) != 2) {
        cat("Warning: Function 'fun' is not vectorized!\n")
        f = Vectorize(f)
    }

    if (xmin == xmax) return(0)
    method <- match.arg(method)
    tol <- if (abstol > 0) min(reltol, abstol) else reltol

    if (is.infinite(xmin) || is.infinite(xmax)) {
        cat("For infinite domains Gauss integration is applied!\n")
        Q <- quadinf(f, xmin, xmax, tol = tol)$Q
        return(Q)
    }

    if (random) {
        xs <- c(xmin,
                (xmax - xmin)*sort(runif(no_intervals - 1)) + xmin,
                xmax)
    } else {
        xs <- linspace(xmin, xmax, no_intervals + 1)
    }

    # Q <- switch(method,
    #         "Kronrod"    = quadgk(f, xmin, xmax, tol = tol),
    #         "Clenshaw"   = quadcc(f, xmin, xmax, tol = tol),
    #         "Simpson"    = simpadpt(f, xmin, xmax, tol = tol)
    #         )
    Q <- 0
    if (method == "Kronrod") {
        for (i in 1:no_intervals) {
            Q = Q + quadgk(f, xs[i], xs[i+1], tol = tol)
        }
    } else if (method == "Clenshaw") {
        for (i in 1:no_intervals) {
            Q = Q + quadcc(f, xs[i], xs[i+1], tol = tol)
        }
    } else if (method == "Simpson") {
        for (i in 1:no_intervals) {
            Q = Q + simpadpt(f, xs[i], xs[i+1], tol = tol)
        }
    } else {
        stop("Unknown method; not available as integration routine.")
    }

    return(Q)
}


line_integral <- function (fun, waypoints, method = NULL, reltol = 1e-8, ...) {
    stopifnot(is.complex(waypoints) || is.numeric(waypoints),
              is.null(method) || is.character(method))

    if (length(waypoints) <= 1) return(0 + 0i)

    fun <- match.fun(fun)
    f <- function(z) fun(z, ...)

    Q <- 0 + 0i
    for (i in 2:length(waypoints)) {
        a <- waypoints[i-1]
        b <- waypoints[i]
        d <- b - a

        f1 <- function(t) Re(f(a + t*d))
        f2 <- function(t) Im(f(a + t*d))

        if (is.null(method)) {
            Qre <- integrate(f1, 0, 1, subdivisions = 300L, rel.tol = reltol)$value
            Qim <- integrate(f2, 0, 1, subdivisions = 300L, rel.tol = reltol)$value
        } else {
            Qre <- integral(f1, 0, 1, reltol = reltol, method = method)
            Qim <- integral(f2, 0, 1, reltol = reltol, method = method)
        }
        Q <- Q + d * (Qre + Qim*1i)
    }

    return(Q)
}

##
##  ne v i l l e . R  Neville and Newton Interpolation
##


neville <- function(x, y, xs) {
    stopifnot(is.numeric(x), is.numeric(y))
    if (!is.numeric(xs))
        stop("Argument 'xs' must be empty or a numeric vector.")
    x <- c(x); y <- c(y)
    n <- length(x)
    if (length(y) != n)
        stop("Vectors 'x' and 'y' must be of the same length.")

    ys <- y
    for (k in 1:(n-1)) {
        y[1:(n-k)] <- ((xs - x[(k+1):n]) * y[1:(n-k)] +
                       (x[1:(n-k)] - xs) * y[2:(n-k+1)]) /
                       (x[1:(n-k)] - x[(k+1):n])
    }
    ys <- y[1]
    return(ys)
}


newtonInterp <- function(x, y, xs = c()) {
    stopifnot(is.numeric(x), is.numeric(y))
    if (length(xs) != 0 && !is.numeric(xs))
        stop("Argument 'xs' must be empty or a numeric vector.")
    x <- c(x); y <- c(y)
    n <- length(x)
    if (length(y) != n)
        stop("Vectors 'x' and 'y' must be of the same length.")

    # Newton's polynomial interpolation formula
    p <- y
    for (k in 2:n) {
        p[k:n] <- (p[k:n] - p[k-1]) / (x[k:n] - x[k-1])
    }
    if (length(xs) == 0) return(p)

    # Evaluating Newton's interpolation formula
    ys <- rep(p[n], length(xs))
    for (k in 1:(n-1)) {
        ys <- p[n-k] + (xs - x[n-k]) * ys
    }
    return(ys)
}


lagrangeInterp <- function(x, y, xs) {
    stopifnot(is.numeric(x), is.numeric(y))
    if (!is.numeric(xs))
        stop("Argument 'xs' must be empty or a numeric vector.")
    x <- c(x); y <- c(y)
    n <- length(x)
    if (length(y) != n)
        stop("Vectors 'x' and 'y' must be of the same length.")

    A <- matrix(0, n, n)

    A[, 1] <- y
    for (i in 2:n) {
        A[i:n,i] <- (A[i:n, i-1] - A[i-1, i-1]) / (x[i:n]-x[i-1])
    }

    ys <- A[n,n] * (xs - x[n-1]) + A[n-1,n-1]
    for (i in 2:(n-1)) {
        ys <- ys * (xs - x[n-i]) + A[n-i,n-i]
    }

    return(ys)
}

##
##  n e w t o n . R  Newton Root finding
##


newtonRaphson <- function(fun, x0, dfun = NULL, 
	               maxiter = 500, tol = 1e-08, ...) {
	# Newton method for finding function zeros
    stopifnot(is.function(fun))
	if  (is.null(dfun)) {
		dfun <- function(x, ...) { h <- tol^(2/3)
			(fun(x+h, ...) - fun(x-h, ...)) / (2*h)
		}
	}
	x   <- x0
	fx  <- fun(x, ...)
	dfx <- dfun(x, ...)
	niter <- 0
	diff  <- tol + 1
	while (diff >= tol && niter <= maxiter) {
		niter <- niter + 1
        if (dfx == 0) {
            warning("Slope is zero: no further improvement possible.")
            break
        }
		diff  <- - fx/dfx
		x <- x + diff
		diff <- abs(diff)
		fx  <- fun(x, ...)
		dfx <- dfun(x, ...)
	}
	if (niter > maxiter) {
		warning("Maximum number of iterations 'maxiter' was reached.")
	}
	return(list(root=x, f.root=fx, niter=niter, estim.prec=diff))
}


# alias
newton <- newtonRaphson


halley <- function(fun, x0, maxiter = 500, tol = 1e-08, ...) {
    fun <- match.fun(fun)
    f <- function(x) fun(x, ...)

    f0 <- f(x0)
    if (abs(f0) < tol^(3/2))
        return(list(root = x0, f.root = f0, maxiter = 0, estim.prec = 0))

    f1 <- fderiv(f, x0, 1)
    f2 <- fderiv(f, x0, 2)
    x1 <- x0 - 2*f0*f1 / (2*f1^2 - f0*f2)

    niter = 1
    while (abs(x1 - x0) > tol && niter < maxiter) {
        x0 <- x1
        f0 <- f(x0)
        f1 <- fderiv(f, x0, 1)
        f2 <- fderiv(f, x0, 2)
        x1 <- x0 - 2*f0*f1 / (2*f1^2 - f0*f2)
        niter <- niter + 1
    }
    return(list(root = x1, f.root = f(x1),
                iter = niter, estim.prec = abs(x1 - x0)))
}


newtonHorner <- function(p, x0, 
                         maxiter = 50, tol = .Machine$double.eps^0.5) {
    n <- length(p) - 1
    niter <- 0
    x <- x0
    diff <- 1 + tol

    while (niter <= maxiter && diff >= tol) {
        H <- horner(p, x)
        if (abs(H$dy) <= tol) {
            warning("Newton's method encountered a slope almost zero.")
            return(list(root = NULL, f.root = NULL, deflate = NULL,
                        iters = niter, estim.prec = Inf))
        }
        xnew <- x - H$y / H$dy
        diff <- abs(x - xnew)
        niter <- niter + 1
        x <- xnew
    }

    if (niter > maxiter) {
        warning("Maximum number of iterations exceeded.")
    }
    defl <- hornerdefl(p, x)

    return(list(root = x, f.root = defl$y, deflate = defl$q,
                iters = niter, estim.prec = diff))
}

##
##  g r a d i e n t . R  Discrete Derivatives
##


gradient <- function(F, h1 = 1, h2 = 1) {
    if (length(F) == 0 )
        return(c())
    if (!is.numeric(F))
        stop("Argument 'F' must be a numeric vector or matrix.")
    if (length(h1) == 0 || length(h2) == 0 ||
        (length(h1) == 1 && h1 == 0) || (length(h2) == 1 && h2 == 0))
        stop("Arguments 'h1', 'h2' must be non-empty and non-zero.")
    if (any(diff(h1) == 0) || any(diff(h2) == 0))
        stop("Arguments 'h1' and 'h2' must be strictly increasing.")

    if (is.vector(F)) {
        n <- length(F)
        if (n == 1) return(0)
        if (length(h1) == 1) {
            x <- seq(1*h1, n*h1, length.out = n)
        } else if (length(h1) == n) {
            x <- h1
        } else
            stop("Length of 'h1' must be 1 or equal to length of 'F'.")

        g <- numeric(n)
        g[1] <- (F[2] - F[1]) / (x[2] - x[1])
        g[n] <- (F[n] - F[n-1]) / (x[n] - x[n-1])

        if (n > 2)
            g[2:(n-1)] <- (F[3:n] - F[1:(n-2)]) / (x[3:n] - x[1:(n-2)])

        return(g)
        
    } else if (is.matrix(F)) {
        # stop("Two-dimensional version not yet implemented.")
        n <- nrow(F)
        m <- ncol(F)

        if (length(h1) == 1) {
            x <- seq(1*h1, m*h1, length.out = m)
        } else if (length(h1) == m) {
            x <- h1
        } else
            stop("Length of 'h1' must be 1 or equal to ncol of 'F'.")
        if (length(h2) == 1) {
            y <- seq(1*h2, n*h2, length.out = n)
        } else if (length(h2) == n) {
            y <- h2
        } else
            stop("Length of 'h2' must be 1 or equal to nrow of 'F'.")

        gX <- gY <- 0 * F  # matrix(NA, nrow = n, ncol = m)

        gX[, 1] <- (F[, 2] - F[, 1]) / (x[2] - x[1])
        gX[, m] <- (F[, m] - F[, m-1]) / (x[m] - x[m-1])
        if (m > 2)
            gX[, 2:(m-1)] <- (F[, 3:m] - F[, 1:(m-2)]) / (x[3:m] - x[1:(m-2)])

        gY[1, ] <- (F[2, ] - F[1, ]) / (y[2] - y[1])
        gY[n, ] <- (F[n, ] - F[n-1, ]) / (y[n] - y[n-1])
        if (n > 2)
            gY[2:(n-1), ] <- (F[3:n, ] - F[1:(n-2), ]) / (y[3:n] - y[1:(n-2)])

        return(list(X = gX, Y = gY))

    } else
        stop("Argument 'F' cannot be a higher-dimensional array.")
}

##
##  f p r i n t f . R  Formatted printing to stdout or file
##


fprintf <- function(fmt, ..., file = "", append = FALSE) {
    mystr <- sprintf(fmt, ...)
    cat(mystr, file = file, append = append)
    invisible(nchar(mystr))
}

##
##  h y p o t h . R
##


hypot <- function(x, y) {
    if ((length(x) == 0 && is.numeric(y) && length(y) <= 1) ||
        (length(y) == 0 && is.numeric(x) && length(x) <= 1))
            return(c())
    if (!is.numeric(x) && !is.complex(x) || !is.numeric(y) && !is.complex(y))
            stop("Arguments 'x' and 'y' must be numeric or complex.")
    if (length(x) == 1 && length(y) > 1) {
        x <- rep(x, length(y)); dim(x) <- dim(y)
    } else if (length(x) > 1 && length(y) == 1) {
        y <- rep(y, length(x)); dim(y) <- dim(x)
    }
    if ((is.vector(x) && is.vector(y) && length(x) != length(y)) ||
        (is.matrix(x) && is.matrix(y) && dim(x) != dim(y)) ||
        (is.vector(x) && is.matrix(y)) || is.matrix(x) && is.vector(y))
            stop("Arguments 'x' and 'y' must be of the same size.")

    x <- abs(x); y <- abs(y)
    m <- pmin(x, y); M <- pmax(x, y)
    ifelse(M == 0, 0, M * sqrt(1 + (m / M)^2))
}

abm3pc <- function(f, a, b, y0, n = 50, ...) {
    stopifnot(is.numeric(a), is.numeric(b))
    stopifnot(is.numeric(y0), length(y0) == 1)
    if (!is.numeric(n) || length(n) != 1 || n < 5)
        stop("Argument 'n' must be an integer greater or equal to 5.")

    n <- floor(n)
    fun <- match.fun(f)
    f <- function(x, y) fun(x, y, ...)

    h <- (b-a)/n	
    k <- h/12

    x  <- seq(a, b, by = h)
    z  <- y <- numeric(n+1)
    z[1] <- f(a, y0)
    y[1] <- y0

    # Use midpoint method to start
    k1 <- h * z[1]
    k2 <- h * f(a + h/2, y0 + k1/2)
    k3 <- h * f(a + 0.75*h, y0 + 0.75*k2)
    y[2] <- y0 + (2*k1 +3*k2 + 4*k3)/9
    z[2] <- f(x[2], y[2])

    # Use Runge-Kutta for next step
    k1 <- h * z[2] 
    k2 <- h * f(x[2] + h/2, y[2] + k1/2)
    k3 <- h * f(x[2] + 0.75*h, y[2] + 0.75*k2)
    y[3] <- y[2] + (2*k1 +3*k2 + 4*k3)/9
    z[3] <- f(x[2], y[2])

    zz <- yy <- numeric(n)
    errorest <- numeric(n)

    # Use 3rd order A-B-M method for the remaining points
    # yy is the predicted, y the corrected value
    for (i in 3:n) {
       yy[i+1] <- y[i] + k * (23*z[i] - 16*z[i-1] + 5*z[i-2])
       zz[i+1] <- f(x[i+1], yy[i+1])
       y[i+1]  <- y[i] + k * (5*zz[i+1] + 8*z[i] - z[i-1])
       z[i+1]  <- f(x[i+1], y[i+1])

       # Error estimation
       errorest[i+1] <- -0.1 * (y[i+1] - yy[i+1])
    }

    errorest <- sqrt(abs(errorest))
    return(list(x = x, y = y, est.error = errorest))
}

##
##  l s q l i n . R 
##


lsqlin <- function(A, b, C, d, tol = 1e-13) {
    stopifnot(is.numeric(A), is.numeric(b))
    if (!is.matrix(A))
        stop("Argument 'A' must be a numeric matrix.")

    n <- nrow(A); m <- ncol(A)
    if (is.vector(b)) {
        if (length(b) != n) {
            stop("As vector argument 'b' must have 'nrow(A)' elements.")
        } else {
            b <- as.matrix(b)
            l <- 1
        }
    } else if (is.matrix(b)) {
        if (nrow(b) != n) {
            stop("As Matrix argument 'b' must also have 'nrow(A)' rows.")
        } else {
            l <- ncol(b)
        }
    } else
        stop("Argument 'b' must be a vector or a matrix with n rows.")
    
    if (missing(C) && missing(d)) {
        # x <- pinv(A) %*% b
        # x <- qr.solve(t(A) %*% A, t(A) %*% as.matrix(b))
        x <- qr.solve(A, as.matrix(b))
        return(x)
    } else if ( (missing(C) && !missing(d)) || (!missing(C) && missing(d)))
        stop("Condition 'C * x = d' not fully specified, 'C' or 'd' missing.")

    stopifnot(is.numeric(C), is.numeric(d))
    if (!is.matrix(C) || ncol(C) != m )
        stop("Argument 'C' must be a numeric matrix with 'ncol(C)=ncol(A)'.")

    # xc <- qr.solve(C, d)
    xc <- pinv(C) %*% d
    if ( any(abs(C %*% xc - d) > tol) ) {
        warning("Precondition 'C * x = d' cannot be satisfied (within tolerance 'tol').")
        return(c())
    }

    N <- nullspace(C)                   # (m x k)-matrix, k <= p
    if (is.null(N)) return(c(xc))

    M <- A %*% N                        # (n x k)-matrix
    #xn <- qr.solve(M, b - repmat(A %*% xc, 1, l))
    xn <- pinv(M) %*% (b - repmat(A %*% xc, 1, l))

    x0 <- repmat(xc, 1, l) + N %*% xn
    return(x0)
}

##
##  p a s c a l . R  Pascal Triangle
##


pascal <- function(n, k=0) {
    # Tests: P0 == P1 %*% t(P1);  P2 %^% 3 == eye
	stopifnot(is.numeric(n), length(n) == 1,
	          is.numeric(k), length(k) == 1)
	if (!(k %in% c(0, 1, 2)))
		stop("Argument 'k' must be 0, 1 or 2.")
	if (floor(n) != ceiling(n)) n <- floor(n)
	if (n <= 0) return(c())
	if (n == 1) return(c(1))

	p <- matrix(0, nrow=n, ncol=n)
	p[1, ] <- rep(1, n)
    for (i in 2:n) {
		p[i, ] <- cumsum(p[i-1, ])
	}
	if (k == 0) return(p)
	# k == 1:
	p1 <- matrix(0, nrow=n, ncol=n)
	for (j in 1:n) {
		p1[j, 1:j] <- diag(p[1:j, j:1]) * (-1)^(0:(j-1))
	}
	if (k == 2) {
		p1 <- rot90(p1, -1)
		if (n %% 2 == 0) p1 <- -p1
	}	
	return(p1)
}

##
##  f n o r m .R  Function Norm
##


fnorm <- function(f, g, x1, x2, p = 2, npoints = 100) {
    stopifnot(is.numeric(x1), length(x1) == 1,
              is.numeric(x2), length(x2) == 1, x1 < x2,
              is.numeric(npoints), length(npoints) == 1, npoints >= 2)

    f <- match.fun(f)
    g <- match.fun(g)

    x  <- seq(x1, x2, length.out = npoints)
    yf <- f(x)
    yg <- g(x)
    if (length(yf) != npoints || length(yg) != npoints)
        stop("Arguments 'f' and 'g' must be vectorized functions.")

    fd <- Norm(yf - yg, p = p)
    return(fd)
}

rationalfit <- function(x, y, d1 = 5, d2 = 5) {
    stopifnot(is.numeric(x), is.numeric(y))
    n <- length(x)
    if (n <= 2)
        stop("Length of arguments 'x' and 'y' must be greater than 2.")
    if (length(y) != n)
        stop("Arguments 'x' ans 'y' must be of the same length.")

    if (is.unsorted(x))
        stop("Argument 'x' must be a sorted vector")

    p <- finds(!is.finite(y))

    dinf <- c()
    while (length(p) > 0) {
       y <- y * (x - x[p[1]])       # adjust remaining y values
       y <- y[-p[1]]                # remove bad y value, now a NaN
       dinf <- c(dinf, x[p[1]])     # remember where pole was   
       x <- x[-p[1]]                # now remove that x value too
       if (d2 > 0) d2 <- d2 - 1     # reduce expected order of den
       p <- finds(!is.finite(y))     # have all Inf values been removed yet?
    }

    yy <- length(y)                 # x and y have a new length
    an <- outer(x, d1:0, "^")       # vandermonde matrix
    ad <- outer(x, d2:0, "^")
    for (k in 1:yy)
        ad[k, ] <- y[k] * ad[k, ]

    # A is basically N-y*D
    A <- cbind(an, -ad)             #  LS solution is in the null space of A
    
    V <- svd(A, nv = ncol(A))$v     # [u,s,v]=svd(A); % null space is in the cols of V
    ND <- V[, ncol(A)]              # use the "most null" vector
    
    N <- ND[1:(d1+1)]
    D <- ND[(d1+2):length(ND)]
        
    D1 <- D[1]
    if (D1 == 0) D1 <- 1
    N <- N/D1
    D <- D/D1
    D <- Poly(c(dinf, roots(D)))    # and then add the removed +/- Inf poles back in

    eps <- .Machine$double.eps      # remove small imaginary parts
    if (all(Im(D) < eps)) D <- Re(D)
    
    maxd <- max(abs(D))             # normalize max Den value to be +/- 1
    if (maxd == 0) maxd <- 1
    N <- N/maxd
    D <- D/maxd

    return(list(p1 = N, p2 = D))
}

##
##  d e g 2 r a d . R  Angle Conversion
##


deg2rad <- function(deg) {
    stopifnot(is.numeric(deg))
    ( rad <- (pi/180)*deg )
}


rad2deg <- function(rad) {
    stopifnot(is.numeric(rad))
    ( deg <- rad/(pi/180) )
}

##
##  f i g u r e . r  Figure (Matlab Style)
##


figure <- function(figno, title = "") {
    if (missing(figno)) figno <- NULL
    else {
        if (!is.numeric(figno) || length(figno) != 1 || floor(figno) != ceiling(figno))
            stop("The figure handle must be a whole number.")
    }

    if (!is.null(figno)) {
        if (figno == 1 || figno == -1) {
            stop("Device 1 is the null device; cannot be opened or closed.")
        } else if (figno == 0) {
            stop("Requested figure handle 0 is in use by another object.")
        }
    }

#     if (.Platform$OS.type == "unix") {
#         if (.Platform$GUI == "AQUA") win <- quartz
#         else if (.Platform$GUI == "X11") win <- X11
#         else
#             stop("Unknown platform GUI for Unix platform type.")
#     } else if (.Platform$OS.type == "Linux") {
#         win <- X11
#     } else if (.Platform$OS.type == "windows") {
#         win <- windows
#     } else
#         stop(paste("Unknown platform type:", .Platform$OS.type))

    if (is.null(figno)) {
        dev.new()               # dev.new() may be platform independent
    } else {
        devl <- dev.list()
        if (abs(figno) %in% devl) {
            if (figno > 0) dev.set(figno)
            else           dev.off(-figno)
        } else {
            cat("Device", figno, "is not an open device. List of devices:\n")
            return(devl)
        }
    }
    invisible()
}

##
##  s e g m e n t . R  Segment Functions
##


segm_intersect <- function(s1, s2) {
    stopifnot(is.numeric(s1), nrow(s1) == 2, ncol(s1) == 2,
              is.numeric(s2), nrow(s2) == 2, ncol(s2) == 2)

    bb <- function(s) {  # bounding box coordinates
        matrix(c(min(s[,1]), max(s[,1]), min(s[,2]), max(s[,2])), 2, 2)
    }
    # compute bounding boxes
    bb1 <- bb(s1)
    bb2 <- bb(s2)

    # bounding boxes do not intersect
    if (! all(rbind(bb1[2,], bb2[2,]) >= rbind(bb2[1,], bb1[1,])) )
        return(FALSE)

    # bounding boxes are intersecting
    p1 <- s1[1,]; p2 <- s1[2,]
    p3 <- s2[1,]; p4 <- s2[2,]
    sgn1 <- sign(cross(c(p3-p1, 0), c(p2-p1, 0))[3]) *
            sign(cross(c(p4-p1, 0), c(p2-p1, 0))[3])
    sgn2 <- sign(cross(c(p1-p3, 0), c(p4-p3, 0))[3]) *
            sign(cross(c(p2-p3, 0), c(p4-p3, 0))[3])

    if (sgn1 <= 0 && sgn2 <= 0) TRUE else FALSE
}


segm_distance <- function(p1, p2, p3, p4 = c()) {
    stopifnot(is.numeric(p1),  is.numeric(p2),  is.numeric(p3),
              length(p1) == 2, length(p2) == 2, length(p3) == 2)

    edist <- function(p1, p2) sqrt((p1[1]-p2[1])^2 + (p1[2]-p2[2])^2)

    if (is.null(p4)) {
        if (edist(p1, p2) == 0) return(list(d = edist(p1, p3), p = p1))

        p21 <- p2 - p1
        # det(A) = 0 only if p1 = p2
        A <- matrix(c(-p21[2], -p21[1],
                       p21[1], -p21[2]), 2, 2, byrow=TRUE)
        b <- as.matrix(p1 - p3)
        a <- solve(A, b)[2]     # crossing point at p1 + a*(p2-p1)

        if (a >= 0 && a <= 1) p <- p1 + a*(p2-p1)
        else if (a < 0)       p <- p1
        else                  p <- p2

        return(list(d = edist(p, p3), p = p, q = p3))

    } else if (is.numeric(p4) && length(p4) == 2) {
        if (segm_intersect(rbind(p1, p2), rbind(p3, p4)) &&
            cross(c(p2-p1, 0), c(p4-p3, 0))[3] != 0) {
            A <- cbind(p2 - p1, p4 - p3)
            b <- (p3 - p1)
            a <- solve(A, b)

            return(list(d = 0, p = p1+a[1]*(p2-p1), q = p3-a[2]*(p4-p3)))

        } else {
            P <- list(p3, p4, p1, p2)
            S <- list(segm_distance(p1, p2, p3), segm_distance(p1, p2, p4),
                      segm_distance(p3, p4, p1), segm_distance(p3, p4, p2))
            i <- which.min(lapply(S, function(s) s$d))

            return(list(d = S[[i]]$d, p = S[[i]]$p, q = P[[i]]))
        }
        
    } else
        stop("Argument 'p4' must be NULL or a vector of length 2.")
}

##
##  m o d e . R
##


Mode <- function(x) {
    if (all(is.na(x))) return(NA)
    if (is.matrix(x))  x <- c(x)

    if (is.numeric(x)) {
        x   <- sort(x)
        tbl <- table(x)
        n   <- which.max(tbl)
        xm  <- as.numeric(names(tbl)[n])
    } else if (is.complex(x)) {
        x   <- x[order(abs(x))]
        tbl <- table(x)
        n   <- which.max(tbl)
        xm  <- as.complex(names(tbl)[n])
    } else if (is.factor(x)) {
        tbl <- table(x)
        n   <- which.max(tbl)
        xm  <- names(tbl)[n]        
    } else
        xm <- NA

    return(xm)
}

nearest_spd <- function(A) {
    stopifnot(is.numeric(A), is.matrix(A))
    eps <- .Machine$double.eps

    m <- nrow(A); n <- ncol(A)
    if (m != n) {
        stop("Argument 'A' must be a square matrix.")
    } else if (n == 1 && A <= 0)
        return(as.matrix(eps))

    B <- (A + t(A)) / 2                 # symmetrize A
    svdB <- svd(B)                      # H is symmetric polar factor of B
    H <- svdB$v %*% diag(svdB$d) %*% t(svdB$v)

    Ahat <- (B + H) / 2
    Ahat <- (Ahat + t(Ahat)) / 2

    # Test that Ahat is in fact positive-definite;
    # if it is not so, then tweak it just a bit.
    k <- 0; not_pd <- TRUE
    while (not_pd) {
        k <- k + 1
        try_R <- try(chol(Ahat), silent = TRUE)
        if(inherits(try_R, "try-error")) {
            mineig <- min(eigen(Ahat, symmetric = TRUE, only.values = TRUE)$values)
            Ahat = Ahat + (-mineig*k^2 + eps(mineig)) * diag(1, n)
        } else
            not_pd <- FALSE
    }
    Ahat
}

##
##  p o l a r . R
##


polar <- function(t, r, type="l", 
                        col = "blue", grcol = "darkgrey", bxcol = "black",
                        main = "Polar Plot", add = FALSE, ...) {
    stopifnot(is.numeric(t), is.numeric(r))
    n <- length(t)
    if (!is.vector(t) || !is.vector(r) || length(r) != n)
        stop("Arguments 't', 'r' have to be vectors of equal length.")
    z <- cbind(t, r)

    # transform coordinates
    xy <- pol2cart(z)
    if (n == 1) dim(xy) <- c(1, 2)
    hy <- hypot(xy[, 1], xy[, 2])

    if (!add) {
        # grid circle coordinates
        drs <- pretty(c(0, hy), min.n = 3)
        phi <- deg2rad(seq(0, 360, by = 2))
        cx <- cos(phi)
        cy <- sin(phi)
        
        # plot grid circles
        mad <- max(abs(drs))
        plot(c(-mad, mad), c(-mad, mad), type = "n", asp = 1,
             axes = FALSE, main = main,
             xlab = "", ylab = "")      # ann = FALSE
        box(col = bxcol)
        for (dr in drs) {
            lines(dr*cx, dr*cy, col=grcol, lty=3)
        }

        s1 <- 0.5 * mad; s2 <- mad * sqrt(3)/2
        # grid lines
        lines(c(-mad, mad), c(0, 0), col=grcol, lty=3)
        lines(c(0, 0), c(-mad, mad), col=grcol, lty=3)
        lines(c(-s2, s2), c(-s1, s1), col=grcol, lty=3)
        lines(c(-s2, s2), c(s1, -s1), col=grcol, lty=3)
        lines(c(-s1, s1), c(-s2, s2), col=grcol, lty=3)
        lines(c(-s1, s1), c(s2, -s2), col=grcol, lty=3)

        # grid annotation
        for (dr in drs) {
            text(0, dr, as.character(dr), adj = c(0.5, 1), col = grcol, cex = 0.75)
            last <- drs[length(drs)]
            text(last, 0, "0", pos = 4, offset = 0.2, col = grcol, cex = 0.75, font=2)
            text(-last, 0, "180", pos = 2, offset = 0.2, col = grcol, cex = 0.75, font=2)
            text(0, last, "90", pos = 3, offset=0.2, col = grcol, cex = 0.75, font=2)
            text(0, -last, "270", pos = 1, offset = 0.3, col = grcol, cex = 0.75, font=2)
            text(s2, s1, "30", adj = c(0, 0), col = grcol, cex = 0.75)
            text(s1, s2, "60", adj = c(0, 0), col = grcol, cex = 0.75)
            text(-s1, s2, "120", adj = c(1, 0), col = grcol, cex = 0.75)
            text(-s2, s1, "150", adj = c(1, 0), col = grcol, cex = 0.75)
            text(-s2, -s1, "210", adj = c(1, 1), col = grcol, cex = 0.75)
            text(-s1, -s2, "240", adj = c(1, 1), col = grcol, cex = 0.75)
            text(s1, -s2, "300", adj = c(0, 1), col = grcol, cex = 0.75)
            text(s2, -s1, "330", adj = c(0, 1), col = grcol, cex = 0.75)
        }
    }

    # Plot the function (type can be 'l', 'p', or 'n')
    lines(xy[, 1], xy[, 2], type = type, col = col, ...)

    invisible()
}

##
##  r a t . R  Continuous Fractions
##


.contfrac <- function(x, tol = 1e-6) {
    if (!is.numeric(x) || is.matrix(x))
        stop("Argument 'x' must be a numeric scalar or vector.")

    if (length(x) > 1) {
        # Compute value of a continuous fraction
        n <- length(x)
        B <- diag(1, 2)
        for (i in seq(along=x)) {
            B <- B %*% matrix(c(x[i], 1, 1, 0), 2, 2)
        }
        return(B[1,1]/B[2,1])

    } else {
        # Generate the continuous fraction of a value
        sgnx <- sign(x)
        x <- abs(x)

        b <- floor(x)
        k <- b
        r <- x - b
        B <- matrix(c(b, 1, 1, 0), 2, 2)
        while ( abs(x - B[1,1]/B[2,1])  > tol) {
            b <- floor(1/r)
            k <- c(k, b)
            r <- 1/r - b
            B <- B %*% matrix(c(b, 1, 1, 0), 2, 2)
        }
        return(list(cf = sgnx * k, rat = c(sgnx*B[1,1], B[2,1]),
                    prec = abs(x - B[1,1]/B[2,1])))
    }
}


rat <- function(x, tol = 1e-6) {
    if (length(x) == 0)
        return(c())
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector.")
    xs <- c(x)

    n <- length(xs)
    R <- character(n)
    for (i in 1:n) {
        x <- xs[i]
        k <- .contfrac(x, tol = tol)$cf
        if (length(k) >= 1) {
            cf <- paste("[ ", k[1], sep="")
        }
        if (length(k) >= 2) {
            cf <- paste(cf, "; ", k[2], sep="")
        }
        if (length(k) >= 3) {
            for (j in 3:length(k)) {
                cf <- paste(cf, ", ", k[j], sep="")
            }
            cf <- paste(cf, "]", sep="")
        }
        R[i] <- cf
    }
    return(R)
}

rats <- function(x, tol = 1e-6) {
    if (length(x) == 0)
        return(c())
    if (!is.numeric(x))
        stop("Argument 'x' must be a numeric vector.")
    xs <- c(x)

    n <- length(xs)
    R <- numeric(n)
    for (i in 1:n) {
        x <- xs[i]
        k <- .contfrac(x, tol = tol)$rat
        cf <- paste(k[1], "/", k[2], sep="")
        cat(cf, "\n")
        R[i] <- k[1]/k[2]
    }
    invisible(R)    
}

##
##  p i e c e w i s e . R  Piecewise Linear Function
##


piecewise <- function(x, y, abs = FALSE)
{
	n <- length(x)
	areas <- 0.0
	zeros <- if (y[1] == 0) c(x[1]) else c()
	for (i in 2:n) {
		if (y[i]*y[i-1] >= 0) {
			if (y[i] == 0) zeros <- c(zeros, x[i])
			areas <- c(areas, (y[i]+y[i-1]) * (x[i]-x[i-1]) / 2.0)
		} else {
			x0 <- (x[i-1]*y[i] - x[i]*y[i-1])/(y[i] - y[i-1])
			zeros <- c(zeros, x0)
			areas <- c(areas, y[i-1]*(x0-x[i-1])/2.0, y[i]*(x[i]-x0)/2.0)
		}
	}
	area <- if (abs) sum(abs(areas)) else sum(areas)
	return(list(area=area, zeros=zeros))
}

##
##  c g m i n . R  Conjugate Gradient Minimization
##


fletcher_powell <- function(x0, f, g = NULL,
                            maxiter = 1000, tol = .Machine$double.eps^(2/3)) {
    eps <- .Machine$double.eps
    if (tol < eps) tol <- eps
    if (!is.numeric(maxiter) || length(maxiter) > 1 || maxiter < 1)
        stop("Argument 'maxiter' must be a positive integer.")
    maxiter <- floor(maxiter)
    if (! is.numeric(x0))
        stop("Argument 'x0' must be a numeric vector.")
    n <- length(x0)
    if (n == 1)
        stop("Function 'f' is univariate; use some other optimization method.")
    
    # User provided or numerical gradient
    f <- match.fun(f)
    if (! is.null(g)) {
        g <- match.fun(g)
    } else {
        g <- function(x) grad(f, x)   
    }     

    x <- x0  # column vector?
    H <- diag(1, n, n)
    f0 <- f(x)
    g0 <- g(x)  # row vector !

    for (k in 1:maxiter) {
        s <- - H %*% as.matrix(g0)  # downhill direction
        # Find minimal f(x + a*s) along the direction s
        f1 <- f0
        z <- sqrt(sum(s^2))
        if (z == 0) return(list(xmin = x, fmin = f1, ninter = k))

        s <- c(s / z)
        a1 <- 0
        a3 <- 1; f3 <- f(x + a3*s)
        while (f3 >= f1) {
            a3 <- a3/2; f3 <- f(x + a3*s)
            if (a3 < tol/2) return(list(xmin = x, fmin = f1, niter = k))
        }

        a2 <- a3/2; f2 <- f(x + a2*s)
        h1 <- (f2 - f1)/a2
        h2 <- (f3 -f2)/(a3 - a2)
        h3 <- (h2 - h1)/a3
        a0 <- 0.5*(a2 - h1/h3); f0 <- f(x + a0*s)
        
        if (f0 < f3) a <- a0
        else         a <- a3

        d <- a * s; dp <- as.matrix(d)
        xnew <- x + d
        fnew <- f(xnew)
        gnew <- g(xnew)
        y <- gnew - g0; yp <- as.matrix(y)
        A <- (dp %*% d) / sum(d * y)
        B <- (H %*% yp) %*% t(H %*% yp) / c(y %*% H %*% yp)
        Hnew <- H + A - B
        if (max(abs(d)) < tol) break

        # Prepare for next iteration
        H <- Hnew
        f0 <- fnew
        g0 <- gnew
        x <- xnew
    }
    if (k == maxiter)
        warning("Max. number of iterations reached -- may not converge.")

    return(list(xmin = x, fmin = f(x), niter = k))
}


# alias -- deprecated
# cgmin <- function(x0, f, g = NULL,
#                   maxiter = 1000, tol = .Machine$double.eps^(2/3)) {
#     warning("Function 'cgmin' deprecated: use 'fletcher_powell' instead.")
#     fletcher_powell(x0, f, g, maxiter = maxiter, tol = tol)
# }

##
##  m e x p f i t . R  Multi-exponential Fitting
##


mexpfit <- function(x, y, p0, w = NULL, const = TRUE, options = list()) {
    stopifnot(is.numeric(x), is.numeric(y), is.numeric(p0))
    n <- length(x)
    if (length(y) != n)
        stop("Arguments 'x', 'y' must be of the same length.")
    p0 <- unique(p0)
    m <- length(p0)
    if (n <= 2*m+1)
        stop("Not enough data points available for fitting exponential sums.")

    opts <- list(tau     = 1e-4,
                 tolx    = 1e-7,
                 tolg    = 1e-9,
                 maxeval = 1000)
    namedOpts <- match.arg(names(options), choices = names(opts),
                           several.ok = TRUE)
    if (!is.null(names(options)))
        opts[namedOpts] <- options

    if (any(p0 == 0) || any(duplicated(p0)))
        stop("All entries in 'p0' must be different and not equal to zero.")

    .fexp <- function(b) {
        M <- outer(x, b, function(x, b) exp(b*x))
        if (const) M <- cbind(1, M)
        a <- qr.solve(M, y) 
        M %*% a - y
    }

    Lsq <- lsqnonlin(.fexp, p0, options = opts)
    b <- Lsq$x

    M <- outer(x, b, function(x, b) exp(b*x))
    if (const) M <- cbind(1, M)
    a <- qr.solve(M, y)

    if (const) { a0 <- a[1]; a <- a[-1] }
    else         a0 <- 0
    return(list(a0 = a0, a = a, b = b,
           ssq = Lsq$ssq, iter = Lsq$neval, errmess = Lsq$errmess))
}


lsqsep <- function(flist, p0, xdata, ydata, const = TRUE) {
    stopifnot(is.numeric(xdata), is.numeric(ydata), is.numeric(p0))
    n <- length(xdata)
    if (length(ydata) != n)
        stop("Numeric arguments 'xdata', 'ydata' must have the same length.")
    m <- length(flist)
    # lapply is.function

    .fapply <- function(b) {
        M <- matrix(1, nrow = n, ncol = m + 1)
        for (i in 1:m) {
            fi <- flist[[i]]
            xi <- fi(b[i], xdata)
            M[, i+1] <- xi
        }
        if (!const) M <- M[, 2:ncol(M)]
        a <- qr.solve(M, ydata)         # sum((M %*% a - ydata)^2)
        M %*% a - ydata                 # for lsqnonlin
    }

    # Find the function parameters b
    Lsq <- lsqnonlin(.fapply, p0)
    b <- Lsq$x

    # Find the linear parameters a
    M <- matrix(1, nrow = n, ncol = m + 1)
    for (i in 1:m) {
        fi <- flist[[i]]
        xi <- fi(b[i], xdata)
        M[, i+1] <- xi
    }
    if (!const) M <- M[, 2:ncol(M)]
    a <- qr.solve(M, ydata)

    if (const) {
        a0 <- a[1]; a <- a[2:length(a)]
    } else {
        a0 <- 0
    }
    return(list(a0 = a0, a = a, b = b, ssq = Lsq$ssq))
}

##
##  f z e r o . R
##


fzero <- function(fun, x, maxiter = 500, tol = 1e-12, ...) {
    if (!is.numeric(x) || length(x) > 2)
        stop("Argument 'x' must be a scalar or a vector of length 2.")

    err <- try(fun <- match.fun(fun), silent = TRUE)
    if(inherits(err, "try-error")) {
        stop("Argument function 'fun' not known in parent environment.")
    } else {
        f <- function(x) fun(x, ...)
    }

    zin <- NULL
    if (length(x) == 2) {
        if (x[1] <= x[2]) {
            a <- x[1]; b <- x[2]
        } else {
            warning("Left endpoint bigger than right one: exchanged points.")
            a <- x[2]; b <- x[1]
        }
        zin <- .zeroin(f, a, b, maxiter = maxiter, tol = tol)

    } else {  # try to get b
        a <- x; fa <- f(a)
        if (fa == 0) return(list(x = a, fval = fa))
        if (a == 0) {
            aa <- 1
        } else {
            aa <- a
        }
        bb <- c(0.9*aa, 1.1*aa, aa-1, aa+1, 0.5*aa, 1.5*aa,
                -aa, 2*aa, -10*aa, 10*aa)
        for (b in bb) {
            fb <- f(b)
            if (fb == 0) return(list(x = b, fval = fb))
            if (sign(fa) * sign(fb) < 0) {
                zin <- .zeroin(f, a, b, maxiter = maxiter, tol = tol)
                break
            }
        }
    }

    if (is.null(zin)) {
        warning("No interval w/ function 'f' changing sign was found.")
        return(list(x = NA, fval = NA))
    } else {
        x1 <- zin$bra[1]; x2 <- zin$bra[2]
        f1 <- zin$ket[1]; f2 <- zin$ket[2]
        x0 <- sum(zin$bra)/2; f0 <- f(x0)
        if (f0 < f1 && f0 < f2) {
            return(list(x = x0, fval = f0))
        } else if (f1 <= f2) {
            return(list(x = x1, fval = f1))
        } else {
            return(list(x = x2, fval = f2))
        }
    }
}


.zeroin <- function(f, a, b, maxiter = 100, tol = 1e-07) {
    stopifnot(is.numeric(a), is.numeric(b),
                length(a) == 1, length(b) == 1)

    mu <- 0.5
    eps <- .Machine$double.eps
    info <- 0

    ## Set up and prepare ...
    if (a > b) {
        tt <- a; a <- b; b <- tt
    }
    fa <- f(a); fb <- f(b) 
    nfev <- 2
    if (sign(fa) * sign(fb) > 0)
        stop("Function must differ in sign at interval endpoints.")

    itype <- 1
    if (abs(fa) < abs(fb)) {
        u <- a; fu <- fa
    } else {
        u <- b; fu <- fb
    }
    d <- e <- u
    fd <- fe <- fu

    mba <- mu * (b - a)
    niter <- 0
    while (niter < maxiter) {
        if (itype == 1) {
            # The initial test
            if ((b-a) <= 2*(2*abs(u)*eps + tol)) {
                x <- u; fval <- fu
                info <- 1
                break
            }
            if (abs (fa) <= 1e3*abs(fb) && abs(fb) <= 1e3*abs(fa)) {
                # Secant step.
                c <- u - (a - b) / (fa - fb) * fu
            } else {
                # Bisection step.
                c <- 0.5 * (a + b)
            }
            d <- u; fd <- fu
            itype <- 5

        } else if (itype == 2 || itype == 3) {
            l <- length(unique(c(fa, fb, fd, fe)))
            if (l == 4) {
                # Inverse cubic interpolation.
                q11 <- (d - e) * fd / (fe - fd)
                q21 <- (b - d) * fb / (fd - fb)
                q31 <- (a - b) * fa / (fb - fa)
                d21 <- (b - d) * fd / (fd - fb)
                d31 <- (a - b) * fb / (fb - fa)
                q22 <- (d21 - q11) * fb / (fe - fb)
                q32 <- (d31 - q21) * fa / (fd - fa)
                d32 <- (d31 - q21) * fd / (fd - fa)
                q33 <- (d32 - q22) * fa / (fe - fa)
                c <- a + q31 + q32 + q33;
            }
            if (l < 4 || sign(c - a) * sign(c - b) > 0) {
                # Quadratic interpolation + newton
                a0 <- fa
                a1 <- (fb - fa)/(b - a)
                a2 <- ((fd - fb)/(d - b) - a1) / (d - a)
                # Modification 1: this is simpler and does not seem to be worse.
                c <- a - a0/a1
                if (a2 != 0) {
                    c <- a - a0/a1
                    for (i in 1:itype) {
                        pc <- a0 + (a1 + a2*(c - b))*(c - a)
                        pdc <- a1 + a2*(2*c - a - b)
                        if (pdc == 0) {
                            c <- a - a0/a1
                            break
                        }
                        c <- c - pc/pdc
                    }
                }
            }
            itype <- itype + 1 
            
        } else if (itype == 4) {
            # Double secant step.
            c <- u - 2*(b - a)/(fb - fa)*fu
            # Bisect if too far.
            if (abs (c - u) > 0.5*(b - a)) {
                c <- 0.5 * (b + a)
            }
            itype <- 5

        } else if (itype == 5) {
            # Bisection step.
            c <- 0.5 * (b + a)
            itype <- 2
        }

        # Don't let c come too close to a or b.
        delta <- 2 * 0.7 * (2 * abs(u) * eps + tol)
        if ((b - a) <= 2*delta) {
            c <- (a + b)/2
        } else {
            c <- max(a + delta, min(b - delta, c))
        }

        # Calculate new point.
        x <- c;
        fval <- fc <- f(c)
        niter <- niter + 1; nfev <- nfev + 1

        # Mod2: skip inverse cubic interpolation if nonmonotonicity is detected.
        if (sign(fc - fa) * sign(fc - fb) >= 0) {
          ## The new point broke monotonicity. 
          ## Disable inverse cubic.
          fe <- fc
        } else {
          e <- d; fe <- fd
        }

        # Bracketing.
        if (sign(fa) * sign(fc) < 0) {
            d <- b; fd <- fb
            b <- c; fb <- fc
        } else if (sign(fb) * sign(fc) < 0) {
            d <- a; fd <- fa
            a <- c; fa <- fc
        } else if (fc == 0) {
            a <- b <- c; fa <- fb <- fc
            info <- 1
            break
        } else {
            # This should never happen.
            stop("zeroin: zero point could not be bracketed")
        }

        if (abs(fa) < abs(fb)) {
          u <- a; fu <- fa
        } else {
          u <- b; fu <- fb
        }
        if (b - a <= 2*(2 * abs (u) * eps + tol)) {
          info <- 1
          break
        }

        # Skip bisection step if successful reduction.
        if (itype == 5 && (b - a) <= mba) {
          itype <- 2
        }
        if (itype == 2) {
          mba <- mu * (b - a)
        }
    } # endwhile

    return(list(bra = c(a, b), ket = c(fa, fb), niter = niter, info = info))
}

\name{segm_intersect}
\alias{segm_intersect}
\title{
  Segment Intersection
}
\description{
  Do two segments have at least one point in common?
}
\usage{
segm_intersect(s1, s2)
}
\arguments{
  \item{s1, s2}{Two segments, represented by their end points; i.e.,
        \code{s <- rbind(p1, p2)} when \code{p1, p2} are the end points.}
}
\details{
  First compares the `bounding boxes', and if those intersect looks at
  whether the other end points lie on different sides of each segment.
}
\value{
  Logical, \code{TRUE} if these segments intersect.
}
\references{
  Cormen, Th. H., Ch. E. Leiserson, and R. L. Rivest (2009). Introduction
  to Algorithms. Third Edition, The MIT Press, Cambridge, MA.
}
\note{
  Should be written without reference to the \code{cross} function.
  Should also return the intersection point, see the example.
}
\seealso{
\code{\link{segm_distance}}
}
\examples{
\dontrun{
plot(c(0, 1), c(0, 1), type="n",
     xlab = "", ylab = "", main = "Segment Intersection")
grid()
for (i in 1:20) {
s1 <- matrix(runif(4), 2, 2)
s2 <- matrix(runif(4), 2, 2)
if (segm_intersect(s1, s2)) {
    clr <- "red"
    p1 <- s1[1, ]; p2 <- s1[2, ]; p3 <- s2[1, ]; p4 <- s2[2, ]
    A <- cbind(p2 - p1, p4 - p3)
    b <- (p3 - p1)
    a <- solve(A, b)
    points((p1 + a[1]*(p2-p1))[1], (p1 + a[1]*(p2-p1))[2], pch = 19, col = "blue")
} else
    clr <- "darkred"
lines(s1[,1], s1[, 2], col = clr)
lines(s2[,1], s2[, 2], col = clr)
}}
}
\keyword{ geom }

\name{cd, pwd, what}
\alias{cd}
\alias{pwd}
\alias{what}
\title{
Directory Functions (Matlab style)
}
\description{
  Displays or changes working directory, or lists files therein.
}
\usage{
cd(dname)
pwd()

what(dname = getwd())
}
\arguments{
  \item{dname}{(relative or absolute) directory path.}
}
\details{
  \code{pwd()} displays the name of the current directory, and is the same
  as \code{cd()}. \code{cd(dname)} changes to directory \code{dname} and if
  successfull displays the directory name.

  \code{what()} lists all files in a directory.\cr
}
\value{
  Name of the current working directory.
}
\seealso{
  \code{\link{getwd}}, \code{\link{setwd}}, \code{\link{list.files}}
}
\examples{
# cd()
# pwd()
# what()
}
\keyword{ utilities }

\name{strRep}
\alias{strRep}
\title{
  Find and replace substring
}
\description{
  Find and replace all occurrences of a substring with another one
  in all strings of a character vector.
}
\usage{
strRep(s, old, new)
}
\arguments{
  \item{s}{Character vector.}
  \item{old}{String to be replaced.}
  \item{new}{String that replaces another one.}
}
\details{
  Replaces all occurrences of \code{old} with \code{new} in all strings
  of character vector \code{s}. The matching is case sensitive.
}
\value{
  A character vector of the same length.
}
\seealso{
\code{\link{gsub}}, \code{regexprep}
}
\examples{
S <- c('This is a good example.', "He has a good character.",
       'This is good, good food.', "How goodgood this is!")
strRep(S, 'good', 'great')
}
\keyword{ string }

\name{refindall}
\alias{refindall}
\title{
  Find overlapping regular expression matches.
}
\description{
  Find overlapping matches for a regular expression.
}
\usage{
refindall(s, pat, over = 1, ignorecase = FALSE)
}
\arguments{
\item{s}{Single character string.}
\item{pat}{Regular expression.}
\item{over}{Natural number, indication how many steps to go forward
            after a match; defaults to 1.}
\item{ignorecase}{logical, whether to ignore case.}
}
\details{
  Returns the starting position of all --- even overlapping --- matches
  of the regular expression \code{pat} in the character string \code{s}.

  The syntax for pattern matching has to be PERL-like.
}
\value{
  A numeric vector with the indices of starting positions of all matches.
}
\note{
  This effect can also be reached with the R function gregexpr(), see the
  example below.
}
\seealso{
\code{\link{regexp}}
}
\examples{
refindall("ababababa", 'aba')
gregexpr('a(?=ba)', "ababababa", perl=TRUE)

refindall("AbababaBa", 'aba')
refindall("AbababaBa", 'aba', ignorecase = TRUE)
}
\keyword{ string }

\name{semilogx,semilogy}
\alias{semilogx}
\alias{semilogy}
\alias{loglog}
\title{
  Semi-logarithmic Plots (Matlab Style)
}
\description{
  Generates semi- and double-logarithmic plots.
}
\usage{
semilogx(x, y, ...)
semilogy(x, y, ...)

loglog(x, y, ...)
}
\arguments{
  \item{x, y}{x-, y-coordinates.}
  \item{...}{additional graphical parameters passed to the plot function.}
}
\details{
  Plots data in logarithmic scales for the x-axis or y-axis, or uses
  logarithmic scales in both axes, and adds grid lines.
}
\value{
  Generates a plot, returns nothing.
}
\note{
  Matlab's logarithmic plots find a more appropriate grid.
}
\seealso{
  \code{\link{plot}} with \code{log= } option.
}
\examples{
\dontrun{
x <- logspace(-1, 2)
loglog(x, exp(x), type = 'b')}
}
\keyword{ graphs }

\name{interp1}
\alias{interp1}
\title{
  One-dimensional Interpolation
}
\description{
  One-dimensional interpolation of points.
}
\usage{
interp1(x, y, xi = x,
        method = c("linear", "constant", "nearest", "spline", "cubic"))
}
\arguments{
  \item{x}{Numeric vector; points on the x-axis; at least two points require;
           will be sorted if necessary.}
  \item{y}{Numeric vector; values of the assumed underlying function;
           \code{x} and \code{y} must be of the same length.}
  \item{xi}{Numeric vector; points at which to compute the interpolation;
            all points must lie between \code{min(x)} and \code{max(x)}.}
  \item{method}{One of ``constant", ``linear", ``nearest", ``spline", or ``cubic"; default is ``linear"}
}
\details{
  Interpolation to find \code{yi}, the values of the underlying function
  at the points in the vector \code{xi}.

  Methods can be:
  \tabular{ll}{
  \code{linear} \tab linear interpolation (default) \cr
  \code{constant} \tab constant between points \cr
  \code{nearest} \tab nearest neighbor interpolation \cr
  \code{spline} \tab cubic spline interpolation \cr
  \code{cubic} \tab cubic Hermite interpolation \cr
  }
}
\value{
  Numeric vector representing values at points \code{xi}.
}
\note{
  Method `spline' uses the spline approach by Moler et al., and is identical 
  with the Matlab option of the same name, but slightly different from R's 
  spline function.

  The Matlab option ``cubic'' seems to have no direct correspondence in R.
  Therefore, we simply use \code{pchip} here.
}
\seealso{
\code{\link{approx}}, \code{\link{spline}}
}
\examples{
x <- c(0.8, 0.3, 0.1, 0.6, 0.9, 0.5, 0.2, 0.0, 0.7, 1.0, 0.4)
y <- x^2
xi <- seq(0, 1, len = 81)
yl <- interp1(x, y, xi, method = "linear")
yn <- interp1(x, y, xi, method = "nearest")
ys <- interp1(x, y, xi, method = "spline")

\dontrun{
plot(x, y); grid()
lines(xi, yl, col="blue", lwd = 2)
lines(xi, yn, col="black", lty = 2)
lines(xi, ys, col="red")
  }

## Difference between spline (Matlab) and spline (R).
x <- 1:6
y <- c(16, 18, 21, 17, 15, 12)
xs <- linspace(1, 6, 51)
ys <- interp1(x, y, xs, method = "spline")
sp <- spline(x, y, n = 51, method = "fmm")

\dontrun{
plot(x, y, main = "Matlab and R splines")
grid()
lines(xs, ys, col = "red")
lines(sp$x, sp$y, col = "blue")
legend(4, 20, c("Matlab spline", "R spline"), 
              col = c("red", "blue"), lty = 1)
  }
}
\keyword{ math }

\name{normest}
\alias{normest}
\title{
  Estimated Matrix Norm
}
\description{
  Estimate the 2-norm of a real (or complex-valued) matrix.
  2-norm is also the maximum absolute eigenvalue of M, computed here
  using the power method.
}
\usage{
normest(M, maxiter = 100, tol = .Machine$double.eps^(1/2))
}
\arguments{
  \item{M}{Numeric matrix; vectors will be considered as column vectors.}
  \item{maxiter}{Maximum number of iterations allowed; default: 100.}
  \item{tol}{Tolerance used for stopping the iteration.}
}
\details{
  Estimate the 2-norm of the matrix \code{M}, typically used for large or
  sparse matrices, where the cost of calculating the \code{norm (A)} is
  prohibitive and an approximation to the 2-norm is acceptable.
  
  Theoretically, the 2-norm of a matrix \eqn{M} is defined as

  \eqn{||M||_2 = max \frac{||M*x||_2}{||x||_2}} for all \eqn{x \neq 0}

  where \eqn{||.||_2} is the Euclidean/Frobenius norm.
}
\value{
  2-norm of the matrix as a positive real number.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Philadelphia.   
}
\note{
  If feasible, an accurate value of the 2-norm would simply be calculated
  as the maximum of the singular values (which are all positive):

  \code{max(svd(M)\$d)}
}
\seealso{
  \code{\link{cond}}, \code{\link{svd}}
}
\examples{
normest(magic(5)) == max(svd(magic(5))$d)  # TRUE
normest(magic(100))                        # 500050
}
\keyword{ array }

\name{eye}
\alias{eye}
\alias{ones}
\alias{zeros}
\title{Some Basic Matrices}
\description{
  Create basic matrices.
}
\usage{
eye(n, m = n)
ones(n, m = n)
zeros(n, m = n)
}
\arguments{
  \item{m, n}{numeric scalars specifying size of the matrix}
}
\value{
  Matrix of size \code{n x m}.
  Defaults to a square matrix if \code{m} is missing.

  No dropping of dimensions; if \code{n = 1}, still returns a matrix and
  not a vector.
}
\seealso{ 
  \code{\link{Diag}},
}   
\examples{
eye(3)
ones(3, 1)
zeros(1, 3)
}
\keyword{ array }

\name{size}
\alias{size}
\title{Size of Matrix}
\description{
  Provides the dimensions of \code{x}.
}
\usage{
size(x, k)
}
\arguments{
  \item{x}{vector, matrix, or array}
  \item{k}{integer specifying a particular dimension}
}
\details{
  Returns the number of dimensions as \code{length(x)}.

  Vector will be treated as a single row matrix.
}
\value{
  vector containing the dimensions of \code{x}, or the \code{k}-th dimension
  if \code{k} is not missing.
}
\note{
  The result will differ from Matlab when \code{x} is a character vector.
}
\seealso{
\code{\link[base]{dim}}
}
\examples{
size(1:8)
size(matrix(1:8, 2, 4))		# 2 4
size(matrix(1:8, 2, 4), 2)	# 4
size(matrix(1:8, 2, 4), 3)	# 1
}
\keyword{array}

\name{fminsearch}
\alias{fminsearch}
\title{
  Derivative-free Nonlinear Function Minimization
}
\description{
  Find minimum of multivariable functions using derivative-free methods.
}
\usage{
fminsearch(fn, x0, ..., lower = NULL, upper = NULL,
           method = c("Nelder-Mead", "Hooke-Jeeves"),
           minimize = TRUE, maxiter = 1000, tol = 1e-08)
}
\arguments{
  \item{fn}{function whose minimum or maximum is to be found.}
  \item{x0}{point considered near to the optimum.}
  \item{...}{additional variables to be passed to the function.}
  \item{lower, upper}{lower and upper bounds constraints.}
  \item{method}{"Nelder-Mead" (default) or "Hooke-Jeeves"; can be abbreviated.}
  \item{minimize}{logical; shall a minimum or a maximum be found.}
  \item{maxiter}{maximal number of iterations}
  \item{tol}{relative tolerance.}
}
\details{
  \code{fminsearch} finds the minimum of a nonlinear scalar multivariable
  function, starting at an initial estimate and returning a value x that is
  a local minimizer of the function. With \code{minimize=FALSE} it searches
  for a maximum, by default for a (local) minimum.

  As methods/solvers "Nelder-Mead" and "Hooke-Jeeves" are available. Only
  Hooke-Jeeves can handle bounds constraints. For nonlinear constraints see
  \code{fmincon}, and for methods using gradients see \code{fminunc}.

  Important: \code{fminsearch} may only give local solutions.
}
\value{
  List with
  \item{xopt}{location of the location of minimum resp. maximum.}
  \item{fmin}{function value at the optimum.}
  \item{count}{number of function calls.}
  \item{convergence}{info about convergence: not used at the moment.}
  \item{info}{special information from the solver.}
}
\references{
  Nocedal, J., and S. Wright (2006). Numerical Optimization.
  Second Edition, Springer-Verlag, New York.
}
\note{
  \code{fminsearch} mimics the Matlab function of the same name.
}
\seealso{
  \code{\link{nelder_mead}}, \code{\link{hooke_jeeves}}
}
\examples{
# Rosenbrock function
rosena <- function(x, a) 100*(x[2]-x[1]^2)^2 + (a-x[1])^2  # min: (a, a^2)

fminsearch(rosena, c(-1.2, 1), a = sqrt(2), method="Nelder-Mead")
## $xmin                   $fmin
## [1] 1.414292 2.000231   [1] 1.478036e-08

fminsearch(rosena, c(-1.2, 1), a = sqrt(2), method="Hooke-Jeeves")
## $xmin                   $fmin
## [1] 1.414215 2.000004   [1] 1.79078e-12
}
\keyword{ optimize }

\name{chebApprox}
\alias{chebApprox}
\title{Chebyshev Approximation}
\description{
  Function approximation through Chebyshev polynomials (of the first kind).
}
\usage{
chebApprox(x, fun, a, b, n)
}
\arguments{
  \item{x}{Numeric vector of points within interval \code{[a, b]}.}
  \item{fun}{Function to be approximated.}
  \item{a, b}{Endpoints of the interval.}
  \item{n}{An integer \code{>= 0}.}
}
\details{
  Return approximate y-coordinates of points at x by computing the
  Chebyshev approximation of degree n for \code{fun} on the interval
  \code{[a, b]}.
}
\value{
  A numeric vector of the same length as \code{x}.
}
\references{
  Press, W. H., S. A. Teukolsky, W. T. Vetterling, and B. P. Flannery (1992).
  Numerical Recipes in C: The Art of Scientific Computing. Second Edition,
  Cambridge University Press.
}
\note{
  TODO: Evaluate the Chebyshev approximative polynomial by using the
  Clenshaw recurrence formula.
  (Not yet vectorized, that's why we still use the Horner scheme.)
}
\seealso{
\code{\link{polyApprox}}
}
\examples{
# Approximate sin(x) on [-pi, pi] with a polynomial of degree 9 !
# This polynomial has to be beaten:
# P(x) = x - 1/6*x^3 + 1/120*x^5 - 1/5040*x^7 + 1/362880*x^9

# Compare these polynomials
p1 <- rev(c(0, 1, 0, -1/6, 0, 1/120, 0, -1/5040, 0, 1/362880))
p2 <- chebCoeff(sin, -pi, pi, 9)

# Estimate the maximal distance
x  <- seq(-pi, pi, length.out = 101)
ys <- sin(x)
yp <- polyval(p1, x)
yc <- chebApprox(x, sin, -pi, pi, 9)
max(abs(ys-yp))                       # 0.006925271
max(abs(ys-yc))                       # 1.151207e-05

\dontrun{
# Plot the corresponding curves
plot(x, ys, type = "l", col = "gray", lwd = 5)
lines(x, yp, col = "navy")
lines(x, yc, col = "red")
grid()}
}
\keyword{ math }

\name{line_integral}
\alias{line_integral}
\title{
  Line integral (in the complex plane)
}
\description{
  Provides complex line integrals.
}
\usage{
line_integral(fun, waypoints, method = NULL, reltol = 1e-8, ...)
}
\arguments{
  \item{fun}{integrand, complex (vectorized) function.}
  \item{method}{integration procedure, see below.}
  \item{waypoints}{complex integration: points on the integration curve.}
  \item{reltol}{relative tolerance.}
  \item{...}{additional parameters to be passed to the function.}
}
\details{
  \code{line_integral} realizes complex line integration, in this case straight
  lines between the waypoints. By passing discrete points densely along the
  curve, arbitrary line integrals can be approximated.

  \code{line_integral} will accept the same methods as \code{integral};
  default is \code{integrate} from Base R.
}
\value{
  Returns the integral, no error terms given.
}
\seealso{
  \code{\link{integral}}
}
\examples{
##  Complex integration examples
points <- c(0, 1+1i, 1-1i, 0)           # direction mathematically negative
f <- function(z) 1 / (2*z -1)
I <- line_integral(f, points)
abs(I - (0-pi*1i))                      # 0 ; residuum 2 pi 1i * 1/2

f <- function(z) 1/z
points <- c(-1i, 1, 1i, -1, -1i)
I <- line_integral(f, points)           # along a rectangle around 0+0i
abs(I - 2*pi*1i)                        #=> 0 ; residuum: 2 pi i * 1

N <- 100
x <- linspace(0, 2*pi, N)
y <- cos(x) + sin(x)*1i
J <- line_integral(f, waypoints = y)    # along a circle around 0+0i
abs(I - J)                              #=> 5.015201e-17; same residuum
}
\keyword{ math }

\name{polyval, polyvalm}
\alias{polyval}
\alias{polyvalm}
\title{Evaluating a Polynomial}
\description{
  Evaluate polynomial on vector or matrix.
}
\usage{
  polyval(p, x)

  polyvalm(p, A)
}
\arguments{
  \item{p}{vector representing a polynomial.}
  \item{x}{vector of values where to evaluate the polynomial.}
  \item{A}{matrix; needs to be square.}
}
\details{
  \code{polyval} valuates the polynomial given by \code{p} at the 
  values specified by the elements of \code{x}. If \code{x} is 
  a matrix, the polynomial will be evaluated at each element and  
  a matrix returned.

  \code{polyvalm} will evaluate the polynomial in the matrix sense,
  i.e., matrix multiplication is used instead of element by element
  multiplication as used in 'polyval'. The argument matrix \code{A}
  must be a square matrix.
}
\value{
  Vector of values, resp. a matrix.
}
\seealso{
  \code{\link{poly}}, \code{\link{roots}}
}
\examples{
  # Evaluate 3 x^2 + 2 x + 1 at x = 5, 7, and 9
  p = c(3, 2, 1);
  polyval(p, c(5, 7, 9))    # 86  162  262

  # Apply the characteristic polynomial to its matrix
  A <- pascal(4)
  p <- pracma::Poly(A)      # characteristic polynomial of A
  polyvalm(p, A)            # almost zero 4x4-matrix
}
\keyword{ math }

\name{integral2}
\alias{integral2}
\alias{integral3}
\title{
  Numerically Evaluate Double  and Triple Integrals
}
\description{
  Numerically evaluate a double integral, resp. a triple integral by
  reducing it to a double integral.
}
\usage{
integral2(fun, xmin, xmax, ymin, ymax, sector = FALSE,
            reltol = 1e-6, abstol = 0, maxlist = 5000,
            singular = FALSE, vectorized = TRUE, ...)

integral3(fun, xmin, xmax, ymin, ymax, zmin, zmax,
            reltol = 1e-6, ...)
}
\arguments{
  \item{fun}{function}
  \item{xmin, xmax}{lower and upper limits of x.}
  \item{ymin, ymax}{lower and upper limits of y.}
  \item{zmin, zmax}{lower and upper limits of z.}
  \item{sector}{logical.}
  \item{reltol}{relative tolerance.}
  \item{abstol}{absolute tolerance.}
  \item{maxlist}{maximum length of the list of rectangles.}
  \item{singular}{logical; are there singularities at vertices.}
  \item{vectorized}{logical; is the function fully vectorized.}
  \item{...}{additional parameters to be passed to the function.}
}
\details{
  \code{integral2} implements the `TwoD' algorithm, that is Gauss-Kronrod
  with (3, 7)-nodes on 2D rectangles.

  The borders of the domain of integration must be finite. The limits of
  \code{y}, that is \code{ymin} and \code{ymax}, can be constants or scalar
  functions of x that describe the lower and upper boundaries. These
  functions must be vectorized.

  \code{integral2} attempts to satisfy \code{ERRBND <= max(AbsTol,RelTol*|Q|)}.
  This is absolute error control when \code{|Q|} is sufficiently small and
  relative error control when \code{|Q|} is larger.

  The function \code{fun} itself must be fully vectorized:
  It must accept arrays \code{X} and \code{Y} and return an array
  \code{Z = f(X,Y)} of corresponding values. If option \code{vectorized} is
  set to \code{FALSE} the procedure will enforce this vectorized behavior.

  With \code{sector=TRUE} the region is a generalized sector that is described
  in polar coordinates (r,theta) by

  \code{0 <= a <= theta <= b} -- a and b must be constants\cr
  \code{c <= r <= d} -- c and d can be constants or ...

  ... functions of theta that describe the lower and upper boundaries.
  Functions must be vectorized.\cr
  NOTE Polar coordinates  are used only to describe the region --
  the integrand is \code{f(x,y)} for both kinds of regions.

  \code{integral2} can be applied to functions that are singular on a boundary.
  With value \code{singular=TRUE}, this option causes \code{integral2} to use
  transformations to weaken singularities for better performance.

  \code{integral3} also accepts functions for the inner interval limits.
  \code{ymin, ymax} must be constants or functions of one variable (\code{x}),
  \code{zmin, zmax} constants or functions of two variables (\code{x, y}), all
  functions vectorized.

  The triple integral will be first integrated over the second and third 
  variable with \code{integral2}, and then integrated over a single variable 
  with \code{integral}.
}
\value{
  Returns a list with \code{Q} the integral and \code{error} the error term.
}
\references{
  Shampine, L. F. (2008). MATLAB Program for Quadrature in 2D.
  Proceedings of Applied Mathematics and Computation, 2008, pp. 266--274.
}
\author{
  Copyright (c) 2008 Lawrence F. Shampine for Matlab code and description
  of the program; adapted and converted to R by Hans W Borchers.
}
\note{
  To avoid recursion, a possibly large matrix will be used and passed between
  subprograms. A more efficient implementation may be possible.
}
\seealso{
  \code{\link{integral}}, \code{cubature:adaptIntegrate}
}
\examples{
fun <- function(x, y) cos(x) * cos(y)
integral2(fun, 0, 1, 0, 1, reltol = 1e-10)
# $Q:     0.708073418273571  # 0.70807341827357119350 = sin(1)^2
# $error: 8.618277e-19       # 1.110223e-16

##  Compute the volume of a sphere
f <- function(x, y) sqrt(1 -x^2 - y^2)
xmin <- 0; xmax <- 1
ymin <- 0; ymax <- function(x) sqrt(1 - x^2)
I <- integral2(f, xmin, xmax, ymin, ymax)
I$Q                             # 0.5236076 - pi/6 => 8.800354e-06

##  Compute the volume over a sector
I <- integral2(f, 0,pi/2, 0,1, sector = TRUE)
I$Q                             # 0.5236308 - pi/6 => 3.203768e-05

##  Integrate 1/( sqrt(x + y)*(1 + x + y)^2 ) over the triangle
##   0 <= x <= 1, 0 <= y <= 1 - x.  The integrand is infinite at (0,0).
f <- function(x,y) 1/( sqrt(x + y) * (1 + x + y)^2 )
ymax <- function(x) 1 - x
I <- integral2(f, 0,1, 0,ymax)
I$Q + 1/2 - pi/4                # -3.247091e-08

##  Compute this integral as a sector
rmax <- function(theta) 1/(sin(theta) + cos(theta))
I <- integral2(f, 0,pi/2, 0,rmax, sector = TRUE, singular = TRUE)
I$Q + 1/2 - pi/4                # -4.998646e-11

##  Examples of computing triple integrals
f0 <- function(x, y, z) y*sin(x) + z*cos(x)
integral3(f0, 0, pi, 0,1, -1,1) # - 2.0 => 0.0

f1 <- function(x, y, z) exp(x+y+z)
integral3(f1, 0, 1, 1, 2, 0, 0.5)
## [1] 5.206447                         # 5.20644655

f2 <- function(x, y, z) x^2 + y^2 + z
a <- 2; b <- 4
ymin <- function(x) x - 1
ymax <- function(x) x + 6
zmin <- -2
zmax <- function(x, y) 4 + y^2
integral3(f2, a, b, ymin, ymax, zmin, zmax)
## [1] 47416.75556                      # 47416.7555556

f3 <- function(x, y, z) sqrt(x^2 + y^2)
a <- -2; b <- 2
ymin <- function(x) -sqrt(4-x^2)
ymax <- function(x)  sqrt(4-x^2)
zmin <- function(x, y)  sqrt(x^2 + y^2)
zmax <- 2
integral3(f3, a, b, ymin, ymax, zmin, zmax)
## [1] 8.37758                          # 8.377579076269617
}
\keyword{ math }

\name{lsqlin}
\alias{lsqlin}
\title{
  Linear Least-Squares Fitting
}
\description{
  Solves linearly constrained linear least-squares problems.
}
\usage{
  lsqlin(A, b, C, d, tol = 1e-13)
}
\arguments{
  \item{A}{\code{nxm}-matrix defining the least-squares problem.}
  \item{b}{vector or colum matrix with \code{n} rows; when it has more than 
           one column it describes several least-squares problems.}
  \item{C}{\code{pxm}-matrix for the constraint system.}
  \item{d}{vector or \code{px1}-matrix, right hand side for the constraints.}
  \item{tol}{tolerance to be passed to \code{pinv}.}
}
\details{
  \code{lsqlin(A, b, C, d)} minimizes \code{||A*x - b||} (i.e., in the 
  least-squares sense) subject to \code{C*x = d}.
}
\value{
  Returns a least-squares solution as column vector, or a matrix of solutions 
  in the columns if \code{b} is a matrix with several columns.
}
\note{
  The Matlab function \code{lsqlin} solves a more general problem, allowing
  additional linear inequalities and bound constraints. In \code{pracma} this
  task is solved applying function \code{lsqlincon}.
}
\author{
  HwB  email: <hwborchers@googlemail.com>
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra.
  SIAM, Society for Industrial and Applied Mathematics, Philadelphia.
}
\seealso{
  \code{\link{nullspace}}, \code{\link{pinv}}, \code{\link{lsqlincon}}
}
\examples{
A <- matrix(c(
    0.8147,    0.1576,    0.6557,
    0.9058,    0.9706,    0.0357,
    0.1270,    0.9572,    0.8491,
    0.9134,    0.4854,    0.9340,
    0.6324,    0.8003,    0.6787,
    0.0975,    0.1419,    0.7577,
    0.2785,    0.4218,    0.7431,
    0.5469,    0.9157,    0.3922,
    0.9575,    0.7922,    0.6555,
    0.9649,    0.9595,    0.1712), 10, 3, byrow = TRUE)
b <- matrix(c(
    0.7060,    0.4387,
    0.0318,    0.3816,
    0.2769,    0.7655,
    0.0462,    0.7952,
    0.0971,    0.1869,
    0.8235,    0.4898,
    0.6948,    0.4456,
    0.3171,    0.6463,
    0.9502,    0.7094,
    0.0344,    0.7547), 10, 2, byrow = TRUE)
C <- matrix(c(
    1.0000,    1.0000,    1.0000,
    1.0000,   -1.0000,    0.5000), 2, 3, byrow = TRUE)
d <- as.matrix(c(1, 0.5))

# With a full rank constraint system
(L <- lsqlin(A, b, C, d))
#  0.10326838 0.3740381
#  0.03442279 0.1246794
#  0.86230882 0.5012825
C \%*\% L
#  1.0  1.0
#  0.5  0.5

\dontrun{
# With a rank deficient constraint system
C <- str2num('[1 1 1;1 1 1]')
d <- str2num('[1;1]')
(L <- lsqlin(A, b[, 1], C, d))
#  0.2583340
# -0.1464215
#  0.8880875
C \%*\% L         # 1 1  as column vector

# Where both A and C are rank deficient
A2 <- repmat(A[, 1:2], 1, 2)
C <- ones(2, 4) # d as above
(L <- lsqlin(A2, b[, 2], C, d))
#  0.2244121
#  0.2755879
#  0.2244121
#  0.2755879
C \%*\% L         # 1 1  as column vector}
}
\keyword{ fitting }

\name{distmat}
\alias{distmat}
\alias{pdist}
\alias{pdist2}
\title{Distance Matrix}
\description{
  Computes the Euclidean distance between rows of two matrices.
}
\usage{
distmat(X, Y)
pdist(X)
pdist2(X, Y)
}
\arguments{
  \item{X}{matrix of some size \code{m x k}; vector will be taken as row matrix.}
  \item{Y}{matrix of some size \code{n x k}; vector will be taken as row matrix.}
}
\details{
  Computes Euclidean distance between two vectors A and B as:

    \code{||A-B|| = sqrt ( ||A||^2 + ||B||^2 - 2*A.B )}

  and vectorizes to rows of two matrices (or vectors).

  \code{pdist2} is an alias for \code{distmat}, while \code{pdist(X)} is the
  same as \code{distmat(X, X)}.
}
\value{
  matrix of size \code{m x n} if \code{x} is of size \code{m x k} and
  \code{y} is of size \code{n x k}.
}
\references{
  Copyright (c) 1999 Roland Bunschoten for a Matlab version on MatlabCentral
  under the name \code{distance.m}. Translated to R by Hans W Borchers.
}
\note{
  If \code{a} is \code{m x r} and \code{b} is \code{n x r} then 

    \code{apply(outer(a,t(b),"-"),c(1,4),function(x)sqrt(sum(diag(x*x))))}

  is the \code{m x n} matrix of distances between the \code{m} rows
  of \code{a} and \code{n} rows of \code{b}.

  This can be modified as necessary, if one wants to apply distances other
  than the euclidean.

  BUT: The code shown here is 10-100 times faster, utilizing the similarity
  between Euclidean distance and matrix operations.
}
\seealso{
\code{\link{dist}}
}
\examples{
A <- c(0.0, 0.0)
B <- matrix(c(
        0,0, 1,0, 0,1, 1,1), nrow=4, ncol = 2, byrow = TRUE)
distmat(A, B)  #=> 0 1 1 sqrt(2)

X <- matrix(rep(0.5, 5), nrow=1, ncol=5)
Y <- matrix(runif(50), nrow=10, ncol=5)
distmat(X, Y)

# A more vectorized form of distmat:
distmat2 <- function(x, y) {
    sqrt(outer(rowSums(x^2), rowSums(y^2), '+') - tcrossprod(x, 2 * y))
}
}
\keyword{ array }

\name{histss}
\alias{histss}
\title{
  Histogram Bin-width Optimization
}
\description{
  Method for selecting the bin size of time histograms.
}
\usage{
histss(x, n = 100, plotting = FALSE)
}
\arguments{
  \item{x}{numeric vector or matrix.}
  \item{n}{maximum number of bins.}
  \item{plotting}{logical; shall a histogram be plotted.}
}
\details{
  Bin sizes of histograms are optimized in a way to best displays the
  underlying spike rate, for example in neurophysiological studies.
}
\value{
  Returns the same list as the \code{hist} function; the list is invisible
  if the histogram is plotted.
}
\references{
  Shimazaki H. and S. Shinomoto. A method for selecting the bin size of
  a time histogram. Neural Computation (2007) Vol. 19(6), 1503-1527
}
\seealso{
  \code{\link{hist}}, \code{\link{histc}}
}
\examples{
x <- sin(seq(0, pi/2, length.out = 200))
H <- histss(x, n = 50, plotting = FALSE)
\dontrun{
plot(H, col = "gainsboro")  # Compare with hist(x), or
hist(x, breaks = H$breaks)  # the same }
}
\keyword{ timeseries }

\name{qpspecial, qpsolve}
\alias{qpspecial}
\alias{qpsolve}
\title{
  Special Quadratic Programming Solver
}
\description{
  Solves a special Quadratic Programming problem.
}
\usage{
qpspecial(G, x, maxit = 100)

qpsolve(d, A, b, meq = 0, tol = 1e-07)
}
\arguments{
  \item{G}{\code{m x n}-matrix.}
  \item{x}{column vector of length \code{n}, the initial (feasible) iterate; 
           if not present (or requirements on x0 not met), x0 will be found.}
  \item{maxit}{maximum number of iterates allowed; default 100.}
  \item{d}{Linear term of the quadratic form.}
  \item{A, b}{Linear equality and inequality constraints.}
  \item{meq}{First meq rows are used as equality constraints.}
  \item{tol}{Tolerance used for stopping the iteration.}
}
\details{
  \code{qpspecial} solves the special QP problem:

  \code{min     q(x)  = || G*x ||_2^2 = x'*(G'*G)*x}\cr
  \code{s.t.  sum(x)  = 1}\cr
  \code{and   x  >= 0}

  The problem corresponds to finding the smallest vector (2-norm) in the 
  convex hull of the columns of \code{G}.
  
  \code{qpsolve} solves the more general QP problem:

  \code{min  q(x) = 0.5 t(x)*x - d x}\cr
  \code{s.t. A x >= b}

  with \code{A x = b} for the first \code{meq} rows.
}
\value{
  Returns a list with the following components:
  \itemize{
  \item \code{x} -- optimal point attaining optimal value;
  \item \code{d = G*x} -- smallest vector in the convex hull;
  \item \code{q} -- optimal value found, \code{= t(d) \%*\% d};
  \item \code{niter} -- number of iterations used;
  \item \code{info} -- error number:\cr
    \code{= 0}: everything went well, q is optimal,\cr
    \code{= 1}:  maxit reached and final x is feasible,\cr
    \code{= 2}:  something went wrong.
  }
}
\note{
  \code{x} may be missing, same as if requirements are not met; may stop with 
  an error if \code{x} is not feasible.
}
\references{
  [Has to be found.]
}
\author{
  Matlab code by Anders Skajaa, 2010, under GPL license (HANSO toolbox);
  converted to R by Abhirup Mallik and Hans W. Borchers, with permission.
}
\examples{
G <- matrix(c(0.31, 0.99, 0.54, 0.20,
              0.56, 0.97, 0.40, 0.38,
              0.81, 0.06, 0.44, 0.80), 3, 4, byrow =TRUE)
qpspecial(G)
# $x
#              [,1]
# [1,] 1.383697e-07
# [2,] 5.221698e-09
# [3,] 8.648168e-01
# [4,] 1.351831e-01
# $d
#           [,1]
# [1,] 0.4940377
# [2,] 0.3972964
# [3,] 0.4886660
# $q
# [1] 0.6407121
# $niter
# [1] 6
# $info
# [1] 0

# Example from quadprog::solve.QP
d <- c(0,5,0)
A <- matrix(c(-4,-3,0,2,1,0,0,-2,1),3,3)
b <- c(-8,2,0)
qpsolve(d, A, b)
## $sol
## [1] 0.4761905 1.0476190 2.0952381
## $val
## [1] -2.380952
## $niter
## [1] 3
}

\name{pow2}
\alias{pow2}
\title{Base 2 Power}
\description{
  Power with base 2.
}
\usage{
  pow2(f, e)
}
\arguments{
  \item{f}{numeric vector of factors}
  \item{e}{numeric vector of exponents for base 2}
}
\details{
  Computes the expression \code{f * 2^e}, setting \code{e} to \code{f}
  and \code{f} to 1 in case \code{e} is missing.
  Complex values are only processed if \code{e} is missing.
}
\value{
  Returns a numeric vector computing \eqn{f\,2^e}.
}
\seealso{
  \code{\link{nextpow2}}
}
\examples{
  pow2(c(0, 1, 2, 3))                   #=> 1 2 4 8
  pow2(c(0, -1, 2, 3), c(0,1,-2,3))     #=> 0.0 -2.0  0.5 24.0
  pow2(1i)                              #=> 0.7692389+0.6389613i
}
\keyword{ arith }

\name{sortrows}
\alias{sortrows}
\title{Sort Rows of a Matrix (Matlab Style)}
\description{
  Sort rows of a matrix according to values in a column.
}
\usage{
sortrows(A, k = 1)
}
\arguments{
  \item{A}{numeric matrix.}
  \item{k}{number of column to sort the matrix accordingly.}
}
\details{
  \code{sortrows(A, k)} sorts the rows of the matrix \code{A} such that
  column \code{k} is increasingly sorted.
}
\value{
  Returns the sorted matrix.
}
\seealso{ 
  \code{\link{sort}}
}   
\examples{
A <- magic(5)
sortrows(A)
sortrows(A, k = 2)
}
\keyword{array}

\name{dot}
\alias{dot}
\title{Scalar Product}
\description{
  'dot' or 'scalar' product of vectors or pairwise columns of matrices.
}
\usage{
  dot(x, y)
}
\arguments{
  \item{x}{numeric vector or matrix}
  \item{y}{numeric vector or matrix}
}
\details{
  Returns the 'dot' or 'scalar' product of vectors or columns of matrices.
  Two vectors must be of same length, two matrices must be of
  the same size.
  If \code{x} and \code{y} are column or row vectors, their dot product
  will be computed as if they were simple vectors.
}
\value{
  A scalar or vector of length the number of columns of \code{x} and
  \code{y}. 
}
\seealso{
  \code{\link{cross}}
}
\examples{
  dot(1:5, 1:5)  #=> 55
  # Length of space diagonal in 3-dim- cube:
  sqrt(dot(c(1,1,1), c(1,1,1)))  #=> 1.732051
}
\keyword{ array }

\name{taylor}
\alias{taylor}
\title{
  Taylor Series Approximation
}
\description{
  Local polynomial approximation through Taylor series.
}
\usage{
taylor(f, x0, n = 4, ...)
}
\arguments{
  \item{f}{differentiable function.}
  \item{x0}{point where the series expansion will take place.}
  \item{n}{Taylor series order to be used; should be \code{n <= 8}.}
  \item{...}{more variables to be passed to function \code{f}.}
}
\details{
  Calculates the first four coefficients of the Taylor series through
  numerical differentiation and uses some polynomial `yoga'.
}
\value{
  Vector of length \code{n+1} representing a polynomial of degree \code{n}.
}
\note{
  TODO: Pade approximation.
}
\seealso{
  \code{\link{fderiv}}
}
\examples{
taylor(sin, 0, 4)  #=> -0.1666666  0.0000000  1.0000000  0.0000000
taylor(exp, 1, 4)  #=>  0.04166657 0.16666673 0.50000000 1.00000000 1.00000000

f <- function(x) log(1+x)
p <- taylor(f, 0, 4)
p                     # log(1+x) = 0 + x - 1/2 x^2 + 1/3 x^3 - 1/4 x^4 +- ...
                      # [1] -0.250004  0.333334 -0.500000  1.000000  0.000000

\dontrun{
x <- seq(-1.0, 1.0, length.out=100)
yf <- f(x)
yp <- polyval(p, x)
plot(x, yf, type = "l", col = "gray", lwd = 3)
lines(x, yp, col = "red")
grid()}
}
\keyword{ math }

\name{neville}
\alias{neville}
\title{
  Neville's Method
}
\description{
  Neville's's method of polynomial interpolation.
}
\usage{
neville(x, y, xs)
}
\arguments{
  \item{x, y}{x-, y-coordinates of data points defining the polynomial.}
  \item{xs}{single point to be interpolated.}
}
\details{
  Straightforward implementation of Neville's method; not yet vectorized.
}
\value{
  Interpolated value at \code{xs} of the polynomial defined by \code{x,y}.
}
\references{
  Each textbook on numerical analysis.
}
\seealso{
  \code{\link{newtonInterp}}, \code{\link{barylag}}
}
\examples{
p <- Poly(c(1, 2, 3))
fp <- function(x) polyval(p, x)

x <- 0:4; y <- fp(x)
xx <- linspace(0, 4, 51)
yy <- numeric(51)
for (i in 1:51) yy[i] <- neville(x, y, xx[i])

\dontrun{
ezplot(fp, 0, 4)
points(xx, yy)}
}
\keyword{ math }

\name{polymul, polydiv}
\alias{polymul}
\alias{polydiv}
\title{Multiplying and Dividing Polynomials}
\description{
  Multiply or divide two polynomials given as vectors.
}
\usage{
  polymul(p, q)

  polydiv(p, q)
}
\arguments{
  \item{p, q}{Vectors representing two polynomials.}
}
\details{
  Polynomial multiplication realized simply by multiplying and summing up
  all the coefficients. Division is an alias for \code{deconv}.
  Polynomials are defined from highest to lowest coefficient.
}
\value{
  Vector representing a polynomial. For division, it returns a list with
  'd' the result of the division and 'r' the rest.
}
\note{
  \code{conv} also realizes polynomial multiplication, through Fast Fourier
  Transformation, with the drawback that small imaginary parts may evolve.
  \code{deconv} can also be used for polynomial division.
}
\seealso{
  \code{conv}, \code{deconv}
}
\examples{
# Multiply x^2 + x + 1 with itself
polymul(c(1, 1, 1), c(0, 1, 1, 1))  #=> 1 2 3 2 1

polydiv(c(1, 2, 3, 2, 1), c(1, 1, 1))
#=> d = c(1,1,1); #=> r = c(0.000000e+00 -1.110223e-16)
}
\keyword{ math }

\name{blkdiag}
\alias{blkdiag}
\title{
Block Diagonal Matrix
}
\description{
  Build a block diagonal matrix.
}
\usage{
blkdiag(...)
}
\arguments{
  \item{\dots}{sequence of non-empty, numeric matrices}
}
\details{
  Generate a block diagonal matrix from A, B, C, .... 
  All the arguments must be numeric and non-empty matrices.
}
\value{
  a numeric matrix
}
\note{
  Vectors as input have to be converted to matrices before. Note that
  \code{as.matrix(v)} with \code{v} a vector will generate a column vector;
  use \code{matrix(v, nrow=1)} if a row vector is intended.
}
\seealso{
\code{\link{Diag}}
}
\examples{
a1 <- matrix(c(1,2), 1)
a2 <- as.matrix(c(1,2))
blkdiag(a1, diag(1, 2, 2), a2)
}
\keyword{ array }

\name{anms}
\alias{anms}
\title{
  Adaptive Nelder-Mead Minimization
}
\description{
  An implementation of the Nelder-Mead algorithm for derivative-free
  optimization / function minimization.
}
\usage{
anms(fn, x0, ...,
     tol = 1e-10, maxfeval = NULL)
}
\arguments{
  \item{fn}{nonlinear function to be minimized.}
  \item{x0}{starting vector.}
  \item{tol}{relative tolerance, to be used as stopping rule.}
  \item{maxfeval}{maximum number of function calls.}
  \item{\ldots}{additional arguments to be passed to the function.}
}
\details{
  Also called a `simplex' method for finding the local minimum of a function
  of several variables. The method is a pattern search that compares function
  values at the vertices of the simplex. The process generates a sequence of
  simplices with ever reducing sizes.

  \code{anms} can be used up to 20 or 30 dimensions (then `tol' and `maxfeval'
  need to be increased). It applies adaptive parameters for simplicial search, 
  depending on the problem dimension -- see Fuchang and Lixing (2012).

  With upper and/or lower bounds, \code{anms} will apply a transformation of
  bounded to unbounded regions before utilizing Nelder-Mead. Of course, if the
  optimum is near to the boundary, results will not be as accurate as when the
  minimum is in the interior.
}
\value{
  List with following components:
    \item{xmin}{minimum solution found.}
    \item{fmin}{value of \code{f} at minimum.}
    \item{nfeval}{number of function calls performed.}
}
\references{
  Nelder, J., and R. Mead (1965). A simplex method for function minimization.
  Computer Journal, Volume 7, pp. 308-313.

  O'Neill, R. (1971). Algorithm AS 47: Function Minimization Using a Simplex 
  Procedure. Applied Statistics, Volume 20(3), pp. 338-345.

  J. C. Lagarias et al. (1998). Convergence properties of the Nelder-Mead
  simplex method in low dimensions. SIAM Journal for Optimization, Vol. 9,
  No. 1, pp 112-147.

  Fuchang Gao and Lixing Han (2012). Implementing the Nelder-Mead simplex
  algorithm with adaptive parameters. Computational Optimization and
  Applications, Vol. 51, No. 1, pp. 259-277.
}
\note{
  Copyright (c) 2012 by F. Gao and L. Han, implemented in Matlab with a
  permissive license. Implemented in R by Hans W. Borchers. For another
  elaborate implementation of Nelder-Mead see the package `dfoptim'.
}
\seealso{
  \code{\link{optim}}
}
\examples{
##  Rosenbrock function
rosenbrock <- function(x) {
    n <- length(x)
    x1 <- x[2:n]
    x2 <- x[1:(n-1)]
    sum(100*(x1-x2^2)^2 + (1-x2)^2)
}

anms(rosenbrock, c(0,0,0,0,0))
# $xmin
# [1] 1 1 1 1 1
# $fmin
# [1] 8.268732e-21
# $nfeval
# [1] 1153

# To add constraints to the optimization problem, use a slightly 
# modified objective function. Equality constraints not possible.
# Warning: Avoid a starting value too near to the boundary !

\dontrun{
# Example: 0.0 <= x <= 0.5
fun <- function(x) {
    if (any(x < 0) || any(x > 0.5)) 100
    else rosenbrock(x)
}
x0 <- rep(0.1, 5)

anms(fun, x0)
## $xmin
## [1] 0.500000000 0.263051265 0.079972922 0.016228138 0.000267922}
}
\keyword{ optimize }

\name{piecewise}
\alias{piecewise}
\title{
Piecewise Linear Function
}
\description{
  Compute zeros and area of a piecewise linear function.
}
\usage{
piecewise(x, y, abs = FALSE)
}
\arguments{
  \item{x, y}{x- and y-coordinates of points defining the piecewise linear function}
  \item{abs}{logical; shall the integral or the total area between the
             x-axis and the function be calculated}
}
\details{
  Compute zeros and integral resp. area of a piecewise linear function
  given by points with x and y as coordinates.
}
\value{
  Returns a list with the integral or area as first element and the vector
  as all zeroes as second.
}
\seealso{
\code{\link{trapz}}
}
\examples{
x <- c(0,  2, 3,  4, 5)
y <- c(2, -2, 0, -2, 0)
piecewise(x, y)
piecewise(x, y, abs=TRUE)
}
\keyword{ math }

\name{gauss_kronrod}
\alias{gauss_kronrod}
\title{
  Gauss-Kronrod Quadrature
}
\description{
  Simple Gaussian-Kronrod quadrature formula.
}
\usage{
gauss_kronrod(f, a, b, ...)
}
\arguments{
  \item{f}{function to be integrated.}
  \item{a, b}{end points of the interval.}
  \item{...}{variables to be passed to the function.}
}
\details{
  Gaussian quadrature of degree 7 with Gauss-Kronrod of degree 15 for error
  estimation, the \code{quadQK15} procedure in the QUADPACK library.
}
\value{
  List of value and relative error.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\note{
  The function needs to be vectorized (though this could easily be changed),
  but the function does not need to be defined at the end points.
}
\seealso{
  \code{\link{quadgk}}, \code{\link{romberg}}
}
\examples{
gauss_kronrod(sin, 0, pi)  #  2.000000000000000 , rel.error: 1.14e-12
gauss_kronrod(exp, 0, 1)   #  1.718281828459045 , rel.error: 0
                           #  1.718281828459045 , i.e. exp(1) - 1
}
\keyword{ math }

\name{mldivide}
\alias{mldivide}
\alias{mrdivide}
\title{Matlab backslash operator}
\description{
  Emulate the Matlab backslash operator ``\\'' through QR decomposition.
}
\usage{
mldivide(A, B, pinv = TRUE)
mrdivide(A, B, pinv = TRUE)
}
\arguments{
  \item{A, B}{
  Numerical or complex matrices; \code{A} and \code{B} must have the same 
  number of rows (for \code{mldivide}) or the same number of columns
  (for \code{mrdivide})
  }
  \item{pinv}{logical; shall SVD decomposition be used; default true.}
}
\details{
  \code{mldivide} performs matrix left division (and \code{mrdivide} matrix
  right division). If \code{A} is scalar it performs element-wise division.

  If \code{A} is square, \code{mldivide} is roughly the same as
  \code{inv(A) \%*\% B} except it is computed in a different way ---
  using QR decomposition.

  If \code{pinv = TRUE}, the default, the SVD will be used as
  \code{pinv(t(A)\%*\%A)\%*\%t(A)\%*\%B} to generate results similar
  to Matlab. Otherwise, \code{qr.solve} will be used.

  If \code{A} is not square, \code{x <- mldivide(A, b)} returnes a
  least-squares solution that minimizes the length of the vector
  \code{A \%*\% x - b}
  (which is equivalent to \code{norm(A \%*\% x - b, "F")}.
}
\value{
  If \code{A} is an n-by-p matrix and \code{B} n-by-q, then the result of
  \code{mldivide(A, B)} is a p-by-q matrix (\code{mldivide}).
}
\note{
  \code{mldivide(A, B)} corresponds to \code{A\\B} in Matlab notation.
}
\examples{
# Solve a system of linear equations
A <- matrix(c(8,1,6, 3,5,7, 4,9,2), nrow = 3, ncol = 3, byrow = TRUE)
b <- c(1, 1, 1)
mldivide(A, b)  # 0.06666667 0.06666667 0.06666667

A <- rbind(1:3, 4:6)
mldivide(A, c(1,1))                 # -0.5  0  0.5 ,i.e. Matlab/Octave result
mldivide(A, c(1,1), pinv = FALSE)   # -1    1  0         R    qr.solve result
}
\keyword{ math }

\name{Toeplitz}
\alias{Toeplitz}
\title{Toeplitz Matrix}
\description{
  Generate Toeplitz matrix from column and row vector.
}
\usage{
Toeplitz(a, b)
}
\arguments{
  \item{a}{vector that will be the first column}
  \item{b}{vector that if present will form the first row.}
}
\details{
  \code{Toeplitz(a, b)} returns a (non-symmetric) Toeplitz matrix whose
  first column is \code{a} and whose first row is \code{b}. The following
  rows are shifted to the left.

  If the first element of \code{b} differs from the last element of \code{a}
  it is overwritten by this one (and a warning sent).
}
\value{
  Matrix of size \code{(length(a), length(b))}.
}
\note{
  \code{stats::Toeplitz} does not allow to specify the row vector, that is
  returns only the \emph{symmetric} Toeplitz matrix.
}
\seealso{
  \code{\link{hankel}}
}
\examples{
Toeplitz(c(1, 2, 3, 4, 5))
Toeplitz(c(1, 2, 3, 4, 5), c(1.5, 2.5, 3.5, 4.5, 5.5))
}
\keyword{ array }

\name{randcomb}
\alias{randcomb}
\title{
Random Combination
}
\description{
Generates a random combination.
}
\usage{
randcomb(a, m)
}
\arguments{
  \item{a}{numeric vector of some length \code{n}}
  \item{m}{integer with \code{0 <= m <= n}}
}
\details{
  Generates one random combination of the elements \code{a} of length
  \code{m}.
}
\value{
  vector of combined elements of \code{a}
}
\note{
  This behavior is different from Matlab/Octave, but does better correspond
  with the behavior of the perms() function.
}
\seealso{
\code{\link{combs}}, \code{\link{randperm}}
}
\examples{
randcomb(seq(2, 10, by=2), m = 3)
}
\keyword{ arith }

\name{stereographic}
\alias{stereographic}
\alias{stereographic_inv}
\title{
  Stereographic Projection
}
\description{
  The stereographic projection is a function that maps the n-dimensional
  sphere from the South pole (0,...,-1) to the tangent plane of the sphere
  at the north pole (0,...,+1).
}
\usage{
stereographic(p)

stereographic_inv(q)
}
\arguments{
  \item{p}{point on the n-spere ; can also be a set of points,
           each point represented as a column of a matrix.}
  \item{q}{point on the tangent plane at the north pole
           (last coordinate = 1); can also be a set of such points.}
}
\details{
The stereographic projection is a smooth function from \eqn{S^n - (0,\dots,-1)}
to the tangent hyperplane at the north pole. The south pole is mapped to
infinity, that is why one speaks of \eqn{S^n} as a 'one-point compactification'
of \eqn{R^{n-1}}.

All mapped points will have a last coordinate 1.0 (lying on the tangent
plane.) Points mapped by 'stereographic_inv' are assumed to have a last
coordinate 1.0 (this will not be checked), otherwise the result will be
different from what is expected -- though the result is still correct in
itself.

All points are column vectors: \code{stereographic} will transform a row
vector to column; \code{stereographic_inv} will return a single vector
as column.
}
\value{
Returns a point (or a set of point) of (n-1) dimensions on the tangent plane
resp. an n-dimensional point on the n-sphere, i.e., \code{sum(x^2) = 1}.
}
\references{
  See the "Stereographic projection" article on Wikipedia.
}
\author{
  Original MATLAB code by J.Burkardt under LGPL license; rewritten in R
  by Hans W Borchers.
}
\note{
  To map a region around the south pole, a similar function would be possible.
  Instead it is simpler to change the sign of the last coordinate.
}
\examples{
# points in the xy-plane (i.e., z = 0)
A <- matrix(c(1,0,0, -1,0,0, 0,1,0, 0,-1,0), nrow = 3)
B <- stereographic(A); B
##      [,1] [,2] [,3] [,4]
## [1,]    2   -2    0    0
## [2,]    0    0    2   -2
## [3,]    1    1    1    1

stereographic_inv(B)
##      [,1] [,2] [,3] [,4]
## [1,]    1   -1    0    0
## [2,]    0    0    1   -1
## [3,]    0    0    0    0

stereographic_inv(c(2,0,2))     # not correct: z = 2
##      [,1]
## [1,]  1.0
## [2,]  0.0
## [3,]  0.5

\dontrun{
# Can be used for optimization with sum(x^2) == 1
# Imagine to maximize the product x*y*z for x^2 + y^2 + z^2 == 1 !
  fnObj <- function(x) {                # length(x) = 2
    x1 <- stereographic_inv(c(x, 1))    # on S^2
    return( -prod(x1) )                 # Maximize
  }
  sol <- optim(c(1, 1), fnObj)
  -sol$value                            # the maximal product
  ## [1] 0.1924501                      #   1/3 * sqrt(1/3)
  stereographic_inv(c(sol$par, 1))      # the solution coordinates
               [,1]                     #   on S^2
  ## [1,] 0.5773374                     # by symmetry must be
  ## [2,] 0.5773756                     # sqrt(1/3) = 0.5773503...
  ## [3,] 0.5773378}
}
\keyword{ manip }

\name{eigjacobi}
\alias{eigjacobi}
\title{
  Jacobi Eigenvalue Method
}
\description{
  Jacobi's iteration method for eigenvalues and eigenvectors.
}
\usage{
eigjacobi(A, tol = .Machine$double.eps^(2/3))
}
\arguments{
  \item{A}{a real symmetric matrix.}
  \item{tol}{requested tolerance.}
}
\details{
  The Jacobi eigenvalue method repeatedly performs (Givens) transformations
  until the matrix becomes almost diagonal.
}
\value{
  Returns a list with components \code{V}, a matrix containing the
  eigenvectors as columns, and \code{D} a vector of the eigenvalues.
}
\note{
  This R implementation works well up to 50x50-matrices. 
}
\references{
  Mathews, J. H., and K. D. Fink (2004). Numerical Methods Using Matlab.
  Fourth edition, Pearson education, Inc., New Jersey.
}
\seealso{
  \code{\link{eig}}
}
\examples{
A <- matrix(c( 1.06, -0.73,  0.77, -0.67,
              -0.73,  2.64,  1.04,  0.72,
               0.77,  1.04,  3.93, -2.14,
              -0.67,  0.72, -2.14,  2.04), 4, 4, byrow = TRUE)
eigjacobi(A)
# $V
#            [,1]       [,2]       [,3]       [,4]
# [1,] 0.87019414 -0.3151209  0.1975473 -0.3231656
# [2,] 0.11138094  0.8661855  0.1178032 -0.4726938
# [3,] 0.07043799  0.1683401  0.8273261  0.5312548
# [4,] 0.47475776  0.3494040 -0.5124734  0.6244140
# 
# $D
# [1] 0.66335457 3.39813189 5.58753257 0.02098098
}
\keyword{ math }

\name{ellipke,ellipj}
\alias{ellipke}
\alias{ellipj}
\title{
  Elliptic and Jacobi Elliptic Integrals
}
\description{
  Complete elliptic integrals of the first and second kind, and
  Jacobi elliptic integrals.
}
\usage{
ellipke(m, tol = .Machine$double.eps)

ellipj(u, m, tol = .Machine$double.eps)
}
\arguments{
  \item{u}{numeric vector.}
  \item{m}{input vector, all input elements must satisfy \code{0 <= x <= 1}.}
  \item{tol}{tolerance; default is machine precision.}
}
\details{
  \code{ellipke} computes the complete elliptic integrals to accuracy 
  \code{tol}, based on the algebraic-geometric mean.

  \code{ellipj} computes the Jacobi elliptic integrals \code{sn}, \code{cn},
  and \code{dn}. For instance, \eqn{sn} is the inverse function for
  \deqn{u = \int_0^\phi dt / \sqrt{1 - m \sin^2 t}}
  with \eqn{sn(u) = \sin(\phi)}.

  Some definitions of the elliptic functions use the modules \code{k} instead
  of the parameter \code{m}. They are related by \code{k^2=m=sin(a)^2} where
  \code{a} is the `modular angle'.
}
\value{
  \code{ellipke} returns list with two components, \code{k} the values for 
  the first kind, \code{e} the values for the second kind.

  \code{ellipj} returns a list with components the three Jacobi elliptic
  integrals \code{sn}, \code{cn}, and \code{dn}.
}
\references{
  Abramowitz, M., and I. A. Stegun (1965).
  Handbook of Mathematical Functions. Dover Publications, New York.
}
\seealso{
  \code{elliptic::sn,cn,dn}
}
\examples{
x <- linspace(0, 1, 20)
ke <- ellipke(x)

\dontrun{
plot(x, ke$k, type = "l", col ="darkblue", ylim = c(0, 5),
     main = "Elliptic Integrals")
lines(x, ke$e, col = "darkgreen")
legend( 0.01, 4.5,
        legend = c("Elliptic integral of first kind",
                   "Elliptic integral of second kind"),
        col = c("darkblue", "darkgreen"), lty = 1)
grid()}

## ellipse circumference with axes a, b
ellipse_cf <- function(a, b) {
    return(4*a*ellipke(1 - (b^2/a^2))$e)
}
print(ellipse_cf(1.0, 0.8), digits = 10)
# [1] 5.672333578

## Jacobi elliptic integrals
u <- c(0, 1, 2, 3, 4, 5)
m <- seq(0.0, 1.0, by = 0.2)
je <- ellipj(u, m)
# $sn       0.0000  0.8265  0.9851  0.7433  0.4771  0.9999
# $cn       1.0000  0.5630 -0.1720 -0.6690 -0.8789  0.0135
# $dn       1.0000  0.9292  0.7822  0.8176  0.9044  0.0135
je$sn^2 + je$cn^2       # 1 1 1 1 1 1
je$dn^2 + m * je$sn^2   # 1 1 1 1 1 1
}
\keyword{ specfun }

\name{simpadpt}
\alias{simpadpt}
\title{
  Adaptive Simpson Quadrature
}
\description{
  Numerically evaluate an integral using adaptive Simpson's rule.
}
\usage{
simpadpt(f, a, b, tol = 1e-6, ...)
}
\arguments{
  \item{f}{univariate function, the integrand.}
  \item{a, b}{lower limits of integration; must be finite.}
  \item{tol}{relative tolerance}
  \item{\ldots}{additional arguments to be passed to \code{f}.}
}
\details{
   Approximates the integral of the function \code{f} from a to b to within
   an error of \code{tol} using recursive adaptive Simpson quadrature.
}
\value{
  A numerical value or vector, the computed integral.
}
\note{
  Based on code from the book by Quarteroni et al.,
  with some tricks borrowed from Matlab and Octave.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
  \code{\link{quad}}, \code{\link{simpson2d}}
}
\examples{
myf <- function(x, n) 1/(x+n)  # 0.0953101798043249 , log((n+1)/n) for n=10
simpadpt(myf, 0, 1, n = 10)    # 0.095310179804535

##  Dilogarithm function
flog  <- function(t) log(1-t) / t  # singularity at t=1, almost at t=0
dilog <- function(x) simpadpt(flog, x, 0, tol = 1e-12)
dilog(1)  # 1.64493406685615
          # 1.64493406684823 = pi^2/6

\dontrun{
N <- 51
xs <- seq(-5, 1, length.out = N)
ys <- numeric(N)
for (i in 1:N) ys[i] <- dilog(xs[i])
plot(xs, ys, type = "l", col = "blue",
             main = "Dilogarithm function")
grid()}
}
\keyword{ math }

\name{softline}
\alias{softline}
\title{
  Soft (Inexact) Line Search
}
\description{
  Fletcher's inexact line search algorithm.
}
\usage{
softline(x0, d0, f, g = NULL)
}
\arguments{
  \item{x0}{initial point for linesearch.}
  \item{d0}{search direction from \code{x0}.}
  \item{f}{real function of several variables that is to be minimized.}
  \item{g}{gradient of objective function \code{f}; computed numerically
           if not provided.}
}
\details{
  Many optimization methods have been found to be quite tolerant to line
  search imprecision, therefore inexact line searches are often used in
  these methods.
}
\value{
  Returns the suggested inexact optimization paramater as a real number
  \code{a0} such that \code{x0+a0*d0} should be a reasonable approximation.
}
\note{
  Matlab version of an inexact linesearch algorithm by A. Antoniou and
  W.-S. Lu in their textbook ``Practical Optimization''. Translated to R
  by Hans W Borchers.
}
\references{
  Fletcher, R. (1980). Practical Methods of Optimization, Volume 1.,
  Section 2.6. Wiley, New York.

  Antoniou, A., and W.-S. Lu (2007). Practical Optimization: Algorithms and
  Engineering Applications. Springer Science+Business Media, New York.
}
\seealso{
  \code{\link{gaussNewton}}
}
\examples{
##  Himmelblau function
  f_himm <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
  g_himm <- function(x) {
    w1 <- (x[1]^2 + x[2] - 11); w2 <- (x[1] + x[2]^2 - 7)
    g1 <- 4*w1*x[1] + 2*w2;     g2 <- 2*w1 + 4*w2*x[2]
    c(g1, g2)
  }
  # Find inexact minimum from [6, 6] in the direction [-1, -1] !
  softline(c(6, 6), c(-1, -1), f_himm, g_himm)
  # [1] 3.458463

  # Find the same minimum by using the numerical gradient
  softline(c(6, 6), c(-1, -1), f_himm)
  # [1] 3.458463
}
\keyword{ optimize }

\name{gammainc}
\alias{gammainc}
\alias{incgam}
\title{
  Incomplete Gamma Function
}
\description{
  Lower and upper incomplete gamma function.
}
\usage{
gammainc(x, a)

incgam(x, a)
}
\arguments{
  \item{x}{positive real number.}
  \item{a}{real number.}
}
\details{
  \code{gammainc} computes the lower and upper incomplete gamma
  function, including the regularized gamma function. The lower and
  upper incomplete gamma functions are defined as 
  \deqn{\gamma(x, a) = \int_0^x e^{-t} \, t^{a-1} \, dt}
  and
  \deqn{\Gamma(x, a) = \int_x^{\infty} e^{-t} \, t^{a-1} \, dt}
  while the regularized incomplete gamma function is
  \eqn{\gamma(x, a)/\Gamma(a)}.

  \code{incgam} (a name used in Pari/GP) computes the upper incomplete
  gamma function alone, applying the R function \code{pgamma}. The
  accuracy is thus much higher. It works for \code{a >= -1}, for even
  smaller values a recursion will give the result.
}
\value{
  \code{gammainc} returns a list with the values of the lower, the
  upper, and regularized lower incomplete gamma function.
  \code{incgam} only returns the value of the incomplete upper gamma
  function.
}
\references{
  Zhang, Sh., and J. Jin (1996). Computation of Special Functions.
  Wiley-Interscience, New York.
}
\note{
  Directly converting Fortran code is often easier than translating
  Matlab code generated with f2matlab.
}
\seealso{
  \code{\link{gamma}}, \code{\link{pgamma}}
}
\examples{
gammainc( 1.5, 2)
gammainc(-1.5, 2)

incgam(3, 1.2)
incgam(3, 0.5); incgam(3, -0.5)
}
\keyword{ specfun }

\name{plotyy}
\alias{plotyy}
\title{
  Plotting Two y-Axes
}
\description{
  Line plot with y-axes on both left and right side.
}
\usage{
plotyy(x1, y1, x2, y2, gridp = TRUE, box.col = "grey",
                       type = "l", lwd = 1, lty = 1,
                       xlab = "x", ylab = "y", main = "",
                       col.y1 = "navy", col.y2 = "maroon", ...)
}
\arguments{
    \item{x1, x2}{x-coordinates for the curves}
    \item{y1, y2}{the y-values, with ordinates y1 left, y2 right.}
    \item{gridp}{logical; shall a grid be plotted.}
    \item{box.col}{color of surrounding box.}
    \item{type}{type of the curves, line or points (for both data).}
    \item{lwd}{line width (for both data).}
    \item{lty}{line type (for both data).}
    \item{xlab, ylab}{text below and on the left.}
    \item{main}{main title of the plot.}
    \item{col.y1, col.y2}{colors to be used for the lines or points.}
    \item{...}{additional plotting parameters.}
}
\details{
  Plots \code{y1} versus \code{x1} with y-axis labeling on the left and plots
  \code{y2} versus \code{x2} with y-axis labeling on the right.

  The x-values should not be too far appart. To exclude certain points, use
  \code{NA} values. Both curves will be line or point plots, and have the
  same line type and width.
}
\value{
  Generates a graph, no return values.
}
\seealso{
  \code{plotrix::twoord.plot}
}
\examples{
\dontrun{
x  <- seq(0, 20, by = 0.01)
y1 <- 200*exp(-0.05*x)*sin(x)
y2 <- 0.8*exp(-0.5*x)*sin(10*x)

plotyy(x, y1, x, y2, main = "Two-ordinates Plot")
}
}
\keyword{ graphs }

\name{legendre}
\alias{legendre}
\title{
  Legendre Functions (Matlab Style)
}
\description{
  Calculate the values of (associated) Legendre functions.
}
\usage{
legendre(n, x)
}
\arguments{
  \item{n}{degree of the Legendre polynomial involved.}
  \item{x}{real points to evaluate Legendre's functions at.}
}
\details{
  \code{legendre(n,x)} computes the associated Legendre functions of degree
  \code{n} and order \code{m=0,1,...,n}, evaluated for each element of
  \code{x} where \code{x} must contain real values in \code{[-1,1]}.

  If \code{x} is a vector, then \code{L=legendre(n,x)} is an
  \code{(n+1)}-by-\code{N} matrix, where \code{N=length(x)}. Each element 
  \code{L[m+1,i]} corresponds to the associated Legendre function of degree
  \code{legendre(n,x)} and order \code{m} evaluated at \code{x[i]}.

  Note that the first row of \code{L} is the Legendre polynomial evaluated at
  \code{x}.
}
\value{
  Returns a matrix of size \code{(n+1)}-by-\code{N} where \code{N=length(x)}.
}
\note{
  Legendre functions are solutions to Legendre's differential equation (it
  occurs when solving Laplace's equation in spherical coordinates).
}
\seealso{
  \code{\link{chebPoly}}
}
\examples{
x <- c(0.0, 0.1, 0.2)
legendre(2, x)
#      [,1]       [,2]       [,3]
# [1,] -0.5 -0.4850000 -0.4400000
# [2,]  0.0 -0.2984962 -0.5878775
# [3,]  3.0  2.9700000  2.8800000

\dontrun{
x <- seq(0, 1, len = 50)
L <- legendre(2, x)
plot(x, L[1, ], type = "l", col = 1, ylim = c(-2, 3), ylab = "y",
                main = "Legendre Functions of degree 2")
lines(x, L[2, ], col = 2)
lines(x, L[3, ], col = 3)
grid()}
## Generate Legendre's Polynomial as function
# legendre_P <- function(n, x) {
#     L <- legendre(n, x)
#     return(L[1, ])
# }
}
\keyword{ math }

\name{nearest_spd}
\alias{nearest_spd}
\title{
  Nearest Symmetric Positive-definite Matrix
}
\description{
  Find nearest (in Frobenius norm) symmetric positive-definite matrix to A.
}
\usage{
nearest_spd(A)
}
\arguments{
  \item{A}{square numeric matrix.}
}
\details{
  "The nearest symmetric positive semidefinite matrix in the
  Frobenius norm to an arbitrary real matrix A is shown to be (B + H)/2,
  where H is the symmetric polar factor of B=(A + A')/2."\cr
  N. J. Highham
}
\value{
  Returns a matrix of the same size.
}
\references{
  Nicholas J. Higham (1988). Computing a nearest symmetric positive 
  semidefinite matrix. 
  Linear Algebra and its Applications. Vol. 103, pp.103-118.
}
\seealso{
  \code{\link{randortho}}, \code{\link{procrustes}}
}
\examples{
A <- matrix(1:9, 3, 3)
B <- nearest_spd(A); B
#          [,1]     [,2]     [,3]
# [1,] 2.034900 3.202344 4.369788
# [2,] 3.202344 5.039562 6.876781
# [3,] 4.369788 6.876781 9.383774
norm(B - A, type = 'F')
# [1] 3.758517
}
\keyword{ array }

\name{sqrtm,rootm}
\alias{sqrtm}
\alias{signm}
\alias{rootm}
\title{
  Matrix Square and p-th Roots
}
\description{
  Computes the matrix square root and matrix p-th root of a nonsingular
  real matrix.
}
\usage{
sqrtm(A, kmax = 20, tol = .Machine$double.eps^(1/2))
signm(A, kmax = 20, tol = .Machine$double.eps^(1/2))

rootm(A, p, kmax = 20, tol = .Machine$double.eps^(1/2))
}
\arguments{
\item{A}{numeric, i.e. real, matrix.}
\item{p}{p-th root to be taken.}
\item{kmax}{maximum number of iterations.}
\item{tol}{absolut tolerance, norm distance of \code{A} and \code{B^p}.}
}
\details{
  A real matrix may or may not have a real square root; if it has no real
  negative eigenvalues. The number of square roots can vary from two to
  infinity. A positive definite matric has one distinguished square root,
  called the principal one, with the property that the eigenvalues lie in
  the segment
  \code{{z | -pi/p < arg(z) < pi/p}} (for the p-th root).

  The matrix square root \code{sqrtm(A)} is computed here through the
  Denman-Beavers iteration (see the references) with quadratic rate of
  convergence, a refinement of the common Newton iteration determining
  roots of a quadratic equation.

  The matrix p-th root \code{rootm(A)} is computed as a complex integral
  \deqn{ A^{1/p} = \frac{p \sin(\pi/p)}{\pi} A \int_0^{\infty} (x^p I + A)^{-1} dx}
  applying the trapezoidal rule along the unit circle.

  One application is the computation of the matrix logarithm as
  \deqn{\log A = 2^k log A^{1/2^k}}
  such that the argument to the logarithm is close to the identity matrix
  and the Pade approximation can be applied to \eqn{\log(I + X)}.

  The matrix sector function is defined as \code{sectm(A,m)=(A^m)^(-1/p)\%*\%A};
  for \code{p=2} this is the matrix sign function.

  \code{S=signm(A)} is real if A is and has the following properties:\cr
  \code{S^2=Id; S A = A S}\cr
  \code{singm([0 A; B 0])=[0 C; C^-1 0]} where \code{C=A(BA)^-1}

  These functions arise in control theory.
}
\value{
  \code{sqrtm(A)} returns a list with components

  \item{ B }{square root matrix of \code{A}.}
  \item{ Binv }{inverse of the square root matrix.}
  \item{ k }{number of iterations.}
  \item{ acc }{accuracy or absolute error.}

  \code{rootm(A)} returns a list with components

  \item{ B }{square root matrix of \code{A}.}
  \item{ k }{number of iterations.}
  \item{ acc }{accuracy or absolute error.}

  If \code{k} is negative the iteration has \emph{not} converged.

  \code{signm} just returns one matrix, even when there was no convergence.
}
\note{
  The p-th root of a positive definite matrix can also be computed from
  its eigenvalues as

  \code{E <- eigen(A)}\cr
  \code{V <- E\$vectors; U <- solve(V)}\cr
  \code{D <- diag(E\$values)}\cr
  \code{B <- V \%*\% D^(1/p) \%*\% U}

  or by applying the functions \code{expm}, \code{logm} in package `expm':

  \code{B <- expm(1/p * logm(A))}

  As these approaches all calculate the principal branch, the results are
  identical (but will numerically slightly differ).
}
\references{
  N. J. Higham (1997). Stable Iterations for the Matrix Square Root.
  Numerical Algorithms, Vol. 15, pp. 227--242.

  D. A. Bini, N. J. Higham, and B. Meini (2005). Algorithms for the
  matrix pth root. Numerical Algorithms, Vol. 39, pp. 349--378.
}
\seealso{
  \code{\link{expm}}, \code{expm::sqrtm}
}
\examples{
A1 <- matrix(c(10,  7,  8,  7,
                7,  5,  6,  5,
                8,  6, 10,  9,
                7,  5,  9, 10), nrow = 4, ncol = 4, byrow = TRUE)

X <- sqrtm(A1)$B    # accuracy: 2.352583e-13
X %*% X             # A1

A2 <- matrix(c(90.81, 8.33, 0.68, 0.06, 0.08, 0.02, 0.01, 0.01,
                0.70, 90.65, 7.79, 0.64, 0.06, 0.13, 0.02, 0.01,
                0.09, 2.27, 91.05, 5.52, 0.74, 0.26, 0.01, 0.06,
                0.02, 0.33, 5.95, 85.93, 5.30, 1.17, 1.12, 0.18,
                0.03, 0.14, 0.67, 7.73, 80.53, 8.84, 1.00, 1.06,
                0.01, 0.11, 0.24, 0.43, 6.48, 83.46, 4.07, 5.20,
                0.21, 0, 0.22, 1.30, 2.38, 11.24, 64.86, 19.79,
                0, 0, 0, 0, 0, 0, 0, 100
              ) / 100, nrow = 8, ncol = 8, byrow = TRUE)

X <- rootm(A2, 12)  # k = 6, accuracy: 2.208596e-14

##  Matrix sign function
signm(A1)                               # 4x4 identity matrix
B <- rbind(cbind(zeros(4,4), A1),
           cbind(eye(4), zeros(4,4)))
signm(B)                                # [0, signm(A1)$B; signm(A1)$Binv 0]
}
\keyword{ math }

\name{polypow}
\alias{polypow}
\title{Polynomial Powers}
\description{
  Power of a polynomial.
}
\usage{
polypow(p, n)
}
\arguments{
  \item{p}{vector representing a polynomial.}
  \item{n}{positive integer, the exponent.}
}
\details{
  Uses \code{polymul} to multiply the polynomial \code{p} \code{n} times
  with itself.
}
\value{
  Vector representing a polynomial.
}
\note{
  There is no such function in Matlab or Octave.
}
\seealso{
  \code{\link{polymul}}
}
\examples{
polypow(c(1, -1), 6)             #=> (x - 1)^6 = (1  -6  15 -20  15  -6   1)
polypow(c(1, 1, 1, 1, 1, 1), 2)  # 1 2 3 4 5 6 5 4 3 2 1
}
\keyword{ math }

\name{compan}
\alias{compan}
\title{Companion Matrix}
\description{
  Computes the companion matrix of a real or complex vector.
}
\usage{
  compan(p)
}
\arguments{
  \item{p}{vector representing a polynomial}
}
\details{
  Computes the companion matrix corresponding to the vector \code{p}
  with \code{-p[2:length(p)]/p[1]} as first row.

  The eigenvalues of this matrix are the roots of the polynomial.
}
\value{
  A square matrix of \code{length(p)-1} rows and columns
}
\seealso{
  \code{\link{roots}}
}
\examples{
  p <- c(1, 0, -7, 6)
  compan(p)
  # 0  7 -6
  # 1  0  0
  # 0  1  0
}
\keyword{ array }

\name{deeve}
\alias{deeve}
\title{
  Event Detection in ODE solution
}
\description{
  Detect events in solutions of a differential equation.
}
\usage{
deeve(x, y, yv = 0, idx = NULL)
}
\arguments{
  \item{x}{vector of (time) points at which the differential equation
           has been solved.}
  \item{y}{values of the function(s) that have been computed for the
           given (time) points.}
  \item{yv}{point or numeric vector at which the solution is wanted.}
  \item{idx}{index of functions whose vales shall be returned.}
}
\details{
  Determines when (in \code{x} coordinates) the \code{idx}-th solution
  function will take on the value \code{yv}.

  The interpolation is linear for the moment. For points outside the
  \code{x} interval \code{NA} is returned.
}
\value{
  A (time) point \code{x0} at which the event happens.
}
\note{
  The interpolation is linear only for the moment.
}
\seealso{
  \code{\link{deval}}
}
\examples{
##  Damped pendulum:  y'' = -0.3 y' - sin(y)
#   y1 = y, y2 = y':  y1' = y2,  y2' = -0.3*y2 - sin(y1)
f <- function(t, y) {
	dy1 <- y[2]
	dy2 <- -0.3*y[2] - sin(y[1])
	return(c(dy1, dy2))
}
sol <- rk4sys(f, 0, 10, c(pi/2, 0), 100)
deeve(sol$x, sol$y[,1])                   # y1 = 0 : elongation in [sec]
# [1] 2.073507 5.414753 8.650250
# matplot(sol$x, sol$y); grid()
}
\keyword{ ode }

\name{logspace}
\alias{logspace}
\alias{logseq}
\title{Log-linearly Spaced Sequences}
\description{
  Generate log-linearly spaced sequences.
}
\usage{
  logspace(x1, x2, n = 50)
  logseq(x1, x2, n = 100)
}
\arguments{
  \item{x1}{numeric scalar specifying starting point}
  \item{x2}{numeric scalar specifying ending point}
  \item{n}{numeric scalar specifying number of points to be generated}
}
\details{
  These functions will generate logarithmically resp.
  exponentially spaced points between \code{x1} and \code{x2} resp.
  \code{10^x1} and \code{10^x2}.

  If \eqn{n < 2}, the result will be the ending point \code{x2}. For
  \code{logspace()}, if \code{x2 = pi}, the endpoint will be \code{pi}
  and not \code{10^pi}!
}
\value{
  vector containing \code{n} points between \code{x1} and \code{x2} inclusive.
}
\seealso{
  \code{\link{logspace}}, \code{\link{seq}}
}
\examples{
logspace(1, pi, 36)
logseq(0.05, 1, 20)
}
\keyword{ manip }

\name{flipdim}
\alias{flipdim}
\alias{flipud}
\alias{fliplr}
\alias{circshift}
\title{Matrix Flipping (Matlab Style)}
\description{
Flip matrices up and down or left and right; or circulating indices per
dimension.
}
\usage{
flipdim(a, dim)
flipud(a)
fliplr(a)
circshift(a, sz)
}
\arguments{
  \item{a}{numeric or complex matrix}
  \item{dim}{flipping dimension; can only be 1 (default) or 2}
  \item{sz}{integer vector of length 1 or 2.}
}
\details{
\code{flipdim} will flip a matrix along the \code{dim} dimension, where
\code{dim=1} means flipping rows, and \code{dim=2} flipping the columns.

\code{flipud} and \code{fliplr} are simply shortcuts for \code{flipdim(a, 1)}
resp. \code{flipdim(a, 2)}.

\code{circshift(a, sz)} circulates each dimension
(should be applicable to arrays).
}
\value{
the original matrix somehow flipped or circularly shifted.
}
\examples{
a <- matrix(1:12, nrow=3, ncol=4, byrow=TRUE)
flipud(a)
fliplr(a)

circshift(a, c(1, -1))
v <- 1:10
circshift(v, 5)
}
\keyword{ manip }

\name{titanium}
\alias{titanium}
\docType{data}
\title{
  Titanium Test Data
}
\description{
  The Titanium data set describes measurements of a certain property of 
  titanium as a function of temperature.
}
\usage{
data(titanium)
}
\format{
  The format is:\cr
  Two columns called `x' and `y', the first being the temperature.
}
\details{
  These data have become a standard test for data fitting since they are hard
  to fit by classical techniques and have a significant amount of noise.
}
\source{
  Boor, C. de, and J. R. Rice (1968). Least squares cubic spline
  approximation II -- Variable knots, CSD TR 21, Comp.Sci., Purdue Univ.
}
\examples{
\dontrun{
data(titanium)
plot(titanium)
grid()}
}
\keyword{ datasets }

\name{gaussHermite}
\alias{gaussHermite}
\title{
  Gauss-Hermite Quadrature Formula
}
\description{
  Nodes and weights for the n-point Gauss-Hermite quadrature formula.
}
\usage{
gaussHermite(n)
}
\arguments{
  \item{n}{Number of nodes in the interval \code{]-Inf, Inf[}.}
}
\details{
  Gauss-Hermite quadrature is used for integrating functions of the form
  \deqn{\int_{-\infty}^{\infty} f(x) e^{-x^2} dx}
  over the infinite interval \eqn{]-\infty, \infty[}.

  \code{x} and \code{w} are obtained from a tridiagonal eigenvalue problem.
  The value of such an integral is then \code{sum(w*f(x))}.
}
\value{
  List with components \code{x}, the nodes or points in\code{]-Inf, Inf[}, and
  \code{w}, the weights applied at these nodes.
}
\references{
  Gautschi, W. (2004). Orthogonal Polynomials: Computation and Approximation.
  Oxford University Press.

  Trefethen, L. N. (2000). Spectral Methods in Matlab. SIAM, Society for
  Industrial and Applied Mathematics.
}
\note{
  The basic quadrature rules are well known and can, e. g., be found in
  Gautschi (2004) --- and explicit Matlab realizations in Trefethen (2000).
  These procedures have also been implemented in Matlab by Geert Van Damme,
  see his entries at MatlabCentral since 2010.
}
\seealso{
\code{\link{gaussLegendre}}, \code{\link{gaussLaguerre}}
}
\examples{
cc <- gaussHermite(17)
# Integrate  exp(-x^2)  from -Inf to Inf
sum(cc$w)                        #=> 1.77245385090552 == sqrt(pi)
# Integrate  x^2 exp(-x^2)
sum(cc$w * cc$x^2)               #=> 0.88622692545276 == sqrt(pi) /2
# Integrate  cos(x) * exp(-x^2)
sum(cc$w * cos(cc$x))            #=> 1.38038844704314 == sqrt(pi)/exp(1)^0.25
}
\keyword{ math }

\name{cotes}
\alias{cotes}
\title{
  Newton-Cotes Formulas
}
\description{
  Closed composite Newton-Cotes formulas of degree 2 to 8.
}
\usage{
cotes(f, a, b, n, nodes, ...)
}
\arguments{
  \item{f}{the integrand as function of two variables.}
  \item{a, b}{lower and upper limit of the integral.}
  \item{n}{number of subintervals (grid points).}
  \item{nodes}{number of nodes in the Newton-Cotes formula.}
  \item{\ldots}{additional parameters to be passed to the function.}
}
\details{
  2 to 8 point closed and summed Newton-Cotes numerical integration formulas.

  These formulas are called `closed' as they include the endpoints.
  They are called `composite' insofar as they are combined with a
  Lagrange interpolation over subintervals.
}
\value{
  The integral as a scalar.
}
\note{
  It is generally recommended not to apply Newton-Cotes formula of degrees
  higher than 6, instead increase the number \code{n} of subintervals used.
}
\author{
  Standard Newton-Cotes formulas can be found in every textbook.
  Copyright (c) 2005 Greg von Winckel of nicely vectorized Matlab code,
  available from MatlabCentral, for 2 to 11 grid points.
  R version by Hans W Borchers, with permission.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
  \code{\link{simpadpt}}, \code{\link{trapz}}
}
\examples{
cotes(sin, 0, pi/2, 20, 2)      # 0.999485905248533
cotes(sin, 0, pi/2, 20, 3)      # 1.000000211546591
cotes(sin, 0, pi/2, 20, 4)      # 1.000000391824184
cotes(sin, 0, pi/2, 20, 5)      # 0.999999999501637
cotes(sin, 0, pi/2, 20, 6)      # 0.999999998927507
cotes(sin, 0, pi/2, 20, 7)      # 1.000000000000363  odd degree is better
cotes(sin, 0, pi/2, 20, 8)      # 1.000000000002231
}
\keyword{ math }

\name{polytrans, polygcf}
\alias{polytrans}
\alias{polygcf}
\title{Polynomial Transformations}
\description{
  Transform a polynomial, find a greatest common factor, or determine the
  multiplicity of a root.
}
\usage{
polytrans(p, q)

polygcf(p, q, tol = 1e-12)
}
\arguments{
  \item{p, q}{vectors representing two polynomials.}
  \item{tol}{tolerance for coefficients to tolerate.}
}
\details{
  Transforms polynomial \code{p} replacing occurences of \code{x} with
  another polynomial \code{q} in \code{x}.

  Finds a greatest common divisor (or factor) of two polynomials.
  Determines the multiplicity of a possible root; returns 0 if not a root.
  This is in general only true to a certain tolerance.
}
\value{
  \code{polytrans} and \code{polygcf} return vectors representing polynomials.
  \code{rootsmult} returns a natural number (or 0).
}
\note{
  There are no such functions in Matlab or Octave.
}
\seealso{
  \code{\link{polyval}}
}
\examples{
# (x+1)^2 + (x+1) + 1
polytrans(c(1, 1, 1), c(1, 1))    #=> 1 3 3
polytrans(c(1, 1, 1), c(-1, -1))  #=> 1 1 1

p <- c(1,-1,1,-1,1)         #=>  x^4 - x^3 + x^2 - x + 1
q <- c(1,1,1)               #=>  x^2 + x + 1
polygcf(polymul(p, q), q)   #=>  [1] 1 1 1

p = polypow(c(1, -1), 6)    #=>  [1] 1  -6  15 -20  15  -6   1
rootsmult(p, 1)             #=>  [1] 6
}
\keyword{ math }

\name{deconv}
\alias{deconv}
\title{Deconvolution}
\description{
  Deconvolution and polynomial division.
}
\usage{
deconv(b, a)
}
\arguments{
  \item{b, a}{real or complex vectors.}
}
\details{
  \code{deconv(b,a)} deconvolves vector \code{a} out of vector \code{b}.
  The quotient is returned in vector \code{q} and the remainder in vector
  \code{r} such that \code{b = conv(a,q)+r}.

  If \code{b} and \code{a} are vectors of polynomial coefficients,
  convolving them is equivalent to multiplying the two polynomials,
  and deconvolution is polynomial division.
}
\value{
  List with elements named \code{q} and \code{r}.
}
\note{
  TODO: Base \code{deconv} on some \code{filter1d} function.
}
\seealso{
  \code{\link{conv}}, \code{\link{polymul}}
}
\examples{
b <- c(10, 40, 100, 160, 170, 120)
a <- c(1, 2, 3, 4)

p <- deconv(b, a)
p$q                #=> 10 20 30
p$r                #=>  0  0  0
}
\keyword{ timeseries }

\name{polyint}
\alias{polyint}
\title{Anti-derivative of Polynomial}
\description{
  Integrate polynomials.
}
\usage{
  polyint(p, k)
}
\arguments{
  \item{p}{polynomial \code{p} given as a vector}
  \item{k}{an integration constant}
}
\details{
  Calculates the integral, i.e. the antiderivative, of a polynomial
  and adds a constant of integration \code{k} if given, else 0.
}
\value{
  a vector representing a polynomial
}
\seealso{
  \code{\link{polyval}}, \code{\link{polyder}}
}
\examples{
  polyint(c(1, 1, 1, 1, 1), 1)
}
\keyword{ math }

\name{fibsearch}
\alias{fibsearch}
\title{
  Fibonacci Search
}
\description{
  Fibonacci search for function minimum.
}
\usage{
fibsearch(f, a, b, ..., endp = FALSE, tol = .Machine$double.eps^(1/2))
}
\arguments{
  \item{f}{Function or its name as a string.}
  \item{a, b}{endpoints of the interval}
  \item{endp}{logical; shall the endpoints be considered as possible minima?}
  \item{tol}{absolute tolerance; default \code{eps^(1/2)}.}
  \item{...}{Additional arguments to be passed to f.}
}
\details{
  Fibonacci search for a univariate function minimum in a bounded interval.
}
\value{
  Return a list with components \code{xmin}, \code{fmin}, 
  the function value at the minimum, \code{niter}, the number of iterations
  done, and the estimated precision \code{estim.prec}
}
\seealso{
\code{\link{uniroot}}
}
\examples{
f <- function(x) x * cos(0.1*exp(x)) * sin(0.1*pi*exp(x))
fibsearch(f, 0, 4, tol=10^-10)   # $xmin    = 3.24848329403424
optimize(f, c(0,4), tol=10^-10)  # $minimum = 3.24848328971188
}
\keyword{ optimize }

\name{trigApprox}
\alias{trigApprox}
\title{
  Trigonometric Approximation
}
\description{
  Computes the trigonometric series.
}
\usage{
trigApprox(t, x, m)
}
\arguments{
  \item{t}{vector of points at which to compute the values of the
           trigonometric approximation.}
  \item{x}{data from \code{t=0} to \code{t=2*(n-1)*pi/n}.}
  \item{m}{degree of trigonometric regression.}
}
\details{
  Calls \code{trigPoly} to get the trigonometric coefficients and then
  sums the finite series.
}
\value{
  Vector of values the same length as \code{t}.
}
\note{
  TODO: Return an approximating function instead.
}
\seealso{
\code{\link{trigPoly}}
}
\examples{
\dontrun{
##  Example: Gauss' Pallas data (1801)
asc <- seq(0, 330, by = 30)
dec <- c(408, 89, -66, 10, 338, 807, 1238, 1511, 1583, 1462, 1183, 804)
plot(2*pi*asc/360, dec, pch = "+", col = "red", xlim = c(0, 2*pi), ylim = c(-500, 2000),
     xlab = "Ascension [radians]", ylab = "Declination [minutes]",
     main = "Gauss' Pallas Data")
grid()
points(2*pi*asc/360, dec, pch = "o", col = "red")
ts <- seq(0, 2*pi, len = 100)
xs <- trigApprox(ts ,dec, 1)
lines(ts, xs, col = "black")
xs <- trigApprox(ts ,dec, 2)
lines(ts, xs, col = "blue")
legend(3, 0, c("Trig. Regression of degree 1", "Trig. Regression of degree 2",
                  "Astronomical position"), col = c("black", "blue", "red"),
                lty = c(1,1,0), pch = c("", "", "+"))}
}
\keyword{ math }

\name{nnz}
\alias{nnz}
\title{Nonzero Elements}
\description{
  Number of non-zero elements.
}
\usage{
nnz(x)
}
\arguments{
  \item{x}{a numeric or complex vector or matrix.}
}
\value{
  the number of non-zero elements of \code{x}.
}
\seealso{
  \code{\link{find}}
}
\examples{
nnz(diag(10))
}
\keyword{array}

\name{quadcc}
\alias{quadcc}
\title{
  Adaptive Clenshaw-Curtis Quadrature
}
\description{
  Adaptive Clenshaw-Curtis Quadrature.
}
\usage{
quadcc(f, a, b, tol = .Machine$double.eps^0.5, ...)
}
\arguments{
  \item{f}{integrand as function, may have singularities at the endpoints.}
  \item{a, b}{endpoints of the integration interval.}
  \item{tol}{relative tolerence.}
  \item{\ldots}{Additional parameters to be passed to the function \code{f}.}
}
\details{
  Adaptive version of the Clenshaw-Curtis quadrature formula with an
  (4, 8)-point erroe term.
}
\value{
  List with two components, \code{value} the value of the integral and
  the relative error \code{error}.
}
\seealso{
  \code{clenshaw_curtis}
}
\examples{
\dontrun{
##  Dilogarithm function
flog <- function(t) log(1-t)/t
quadcc(flog, 1, 0, tol = 1e-12)
# 1.644934066848128 - pi^2/6 < 1e-13
}
}
\keyword{ math }

\name{quadgk}
\alias{quadgk}
\title{
  Adaptive Gauss-Kronrod Quadrature
}
\description{
  Adaptive Gauss-Kronrod Quadrature.
}
\usage{
quadgk(f, a, b, tol = .Machine$double.eps^0.5, ...)
}
\arguments{
  \item{f}{integrand as function; needs to be vectorized,
           but may have singularities at the endpoints.}
  \item{a, b}{endpoints of the integration interval.}
  \item{tol}{relative tolerence.}
  \item{\ldots}{Additional parameters to be passed to the function f.}
}
\details{
  Adaptive version of the (7, 15)-point Gauss-Kronrod quadrature formula,
  where in each recursion the error is taken as the difference between these
  two estimated integrals.

  The function \code{f} must be vectorized, though this will not be checked
  and may lead to strange errors. If it is not, use \code{F = Vectorize(f)}.
}
\value{
  Value of the integration. The relative error should be of the same
  order of magnitude as the relative tolerance (or much smaller).
}
\note{
  Uses the same nodes and weights as the \code{quadQK15} procedure in the
  QUADPACK library.
}
\seealso{
  \code{gauss_kronrod}
}
\examples{
##  Dilogarithm function
flog <- function(t) log(1-t)/t
quadgk(flog, 1, 0, tol = 1e-12)
# 1.644934066848128 - pi^2/6 < 1e-13
}
\keyword{ math }

\name{deval}
\alias{deval}
\title{
  Evaluate ODE Solution
}
\description{
  Evaluate solution of a differential equation solver.
}
\usage{
deval(x, y, xp, idx = NULL)
}
\arguments{
  \item{x}{vector of (time) points at which the differential equation
           has been solved.}
  \item{y}{values of the function(s) that have been computed for the
           given (time) points.}
  \item{xp}{point or numeric vector at which the solution is wanted;
            must be sorted.}
  \item{idx}{index of functions whose vales shall be returned.}
}
\details{
  Determines where the points \code{xp} lie within the vector \code{x}
  and interpolates linearly.
}
\value{
  An \code{length(xp)}-by-\code{length(idx)} matrix of values at points
  \code{xp}.
}
\note{
  The interpolation is linear only for the moment.
}
\seealso{
  \code{\link{deeve}}
}
\examples{
##  Free fall:  v' = -g - cw abs(v)^1.1,  cw = 1.6 drag coefficien
f <- function(t, y) -9.81 + 1.6*abs(y)^1.1
sol <- rk4(f, 0, 10, 0, 100)
# speed after 0.5, 1, 1.5, 2 seconds
cbind(c(0.5,1,1.5,2), -deval(sol$x, sol$y, c(0.5, 1, 1.5, 2)))
#  0.5  3.272267  m/s
#  1.0  4.507677
#  1.5  4.953259
#  2.0  5.112068
# plot(sol$x, -sol$y, type="l", col="blue"); grid()
}
\keyword{ ode }

\name{hessenberg}
\alias{hessenberg}
\title{
  Hessenberg Matrix
}
\description{
  Generates the Hessenberg matrix for A.
}
\usage{
hessenberg(A)
}
\arguments{
  \item{A}{square matrix}
}
\details{
  An (upper) Hessenberg matrix has zero entries below the first
  subdiagonal. 

  The function generates a Hessenberg matrix \code{H} and a unitary 
  matrix \code{P} (a similarity transformation) such that
  \code{A = P * H * t(P)}.

  The Hessenberg matrix has the same eigenvalues. If \code{A} is 
  symmetric, its Hessenberg form will be a tridiagonal matrix.
}
\value{
  Returns a list with two elements,
    \item{H}{the upper Hessenberg Form of matrix A.}
    \item{H}{a unitary matrix.}
}
\references{
  Press, Teukolsky, Vetterling, and Flannery (2007).
  Numerical Recipes: The Art of Scientific Computing. 3rd Edition,
  Cambridge University Press. (Section 11.6.2)
}
\seealso{
  \code{\link{householder}}
}
\examples{
A <- matrix(c(-149,   -50,  -154,
               537,   180,   546,
               -27,    -9,   -25), nrow = 3, byrow = TRUE)
hb  <- hessenberg(A)
hb
## $H
##           [,1]         [,2]        [,3]
## [1,] -149.0000  42.20367124 -156.316506
## [2,] -537.6783 152.55114875 -554.927153
## [3,]    0.0000   0.07284727    2.448851
## 
## $P
##      [,1]       [,2]      [,3]
## [1,]    1  0.0000000 0.0000000
## [2,]    0 -0.9987384 0.0502159
## [3,]    0  0.0502159 0.9987384

hb$P \%*\% hb$H \%*\% t(hb$P)
##      [,1] [,2] [,3]
## [1,] -149  -50 -154
## [2,]  537  180  546
## [3,]  -27   -9  -25
}
\keyword{ array }

\name{polylog}
\alias{polylog}
\title{
  Polylogarithm Function
}
\description{
  Computes the \code{n}-based polylogarithm of \code{z}: \code{Li_n(z)}.
}
\usage{
polylog(z, n)
}
\arguments{
  \item{z}{real number or vector, all entries satisfying \code{abs(z)<1}.}
  \item{n}{base of polylogarithm, integer greater or equal -4.}
}
\details{
  The Polylogarithm is also known as Jonquiere's function. It is defined as
  \deqn{\sum_{k=1}^{\infty}{z^k / k^n} = z + z^2/2^n + ...}

  The polylogarithm function arises, e.g., in Feynman diagram integrals. It
  also arises in the closed form of the integral of the Fermi-Dirac and the
  Bose-Einstein distributions.

  The special cases \code{n=2} and \code{n=3} are called the dilogarithm and 
  trilogarithm, respectively.

  Approximation should be correct up to at least 5 digits for \eqn{|z| > 0.55}
  and on the order of 10 digits for \eqn{|z| <= 0.55}.
}
\value{
  Returns the function value (not vectorized).
}
\note{
  Based on some equations, see references.
  A Matlab implementation is available in the Matlab File Exchange.
}
\references{
  V. Bhagat, et al. (2003). On the evaluation of generalized BoseEinstein and 
  FermiDirac integrals. Computer Physics Communications, Vol. 155, p.7.
}
\examples{
polylog(0.5,  1)    # polylog(z, 1) = -log(1-z)
polylog(0.5,  2)    # (p1^2 - 6*log(2)^2) / 12
polylog(0.5,  3)    # (4*log(2)^3 - 2*pi^2*log(2) + 21*zeta(3)) / 24
polylog(0.5,  0)    # polylog(z,  0) = z/(1-z)
polylog(0.5, -1)    # polylog(z, -1) = z/(1-z)^2
}
\keyword{ math }

\name{cot,csc,sec, etc.}
\alias{cot}
\alias{csc}
\alias{sec}
\alias{acot}
\alias{acsc}
\alias{asec}
\title{
  More Trigonometric Functions
}
\description{
  More trigonometric functions not available in R.
}
\usage{
cot(z)
csc(z)
sec(z)
acot(z)
acsc(z)
asec(z)
}
\arguments{
  \item{z}{numeric or complex scalar or vector.}
}
\details{
  The usual trigonometric cotangens, cosecans, and secans functions
  and their inverses, computed through the other well known -- in R --
  sine, cosine, and tangens functions.
}
\value{
  Result vector of numeric or complex values.
}
\note{
  These function names are available in Matlab, that is the reason they have
  been added to the `pracma' package.
}
\seealso{
  Trigonometric and hyperbolic functions in R.
}
\examples{
cot(1+1i)       # 0.2176 - 0.8680i
csc(1+1i)       # 0.6215 - 0.3039i
sec(1+1i)       # 0.4983 + 0.5911i
acot(1+1i)      # 0.5536 - 0.4024i
acsc(1+1i)      # 0.4523 - 0.5306i
asec(1+1i)      # 1.1185 + 0.5306i
}
\keyword{ math }

\name{accumarray}
\alias{accumarray}
\alias{uniq}
\title{
  Accumulate Vector Elements
}
\description{
  \code{accumarray} groups elements from a data set and applies a function
  to each group.
}
\usage{
accumarray(subs, val, sz = NULL, func = sum, fillval = 0)

uniq(a, first = FALSE)
}
\arguments{
  \item{subs}{vector or matrix of positive integers,
              used as indices for the result vector.}
  \item{val}{numerical vector.}
  \item{sz}{size of the resulting array.}
  \item{func}{function to be applied to a vector of numbers.}
  \item{fillval}{value used to fill the array when there are no indices
                 pointing to that component.}
  \item{a}{numerical vector.}
  \item{first}{logical, shall the first or last element encountered be used.}
}
\details{
  \code{A <- accumarray(subs, val)} creates an array \code{A} by accumulating
  elements of the vector \code{val} using the lines of \code{subs} as indices
  and applying \code{func} to that accumulated vector. The size of the array
  can be predetermined by the size vector \code{sz}.

  \code{A = uniq(a)} returns a vector \code{b} identical to \code{unique(a)}
  and two other vectors of indices \code{m} and \code{n} such that
  \code{b == a[m]} and \code{a == b[n]}.
}
\value{
\code{accumarray} returns an array of size the maximum in each column of 
\code{subs}, or by \code{sz}.

\code{uniq} returns a list with components

\item{ b }{vector of unique elements of a.}
\item{ m }{vector of indices such that \code{b = a[m]}}
\item{ n }{vector of indices such that \code{a = b[n]}}
}
\note{
  The Matlab function \code{accumarray} can also handle sparse matrices.
}
\seealso{
  \code{\link{unique}}
}
\examples{
##  Examples for accumarray
val = 101:105
subs = as.matrix(c(1, 2, 4, 2, 4))
accumarray(subs, val)
# [101; 206; 0; 208]

val = 101:105
subs <- matrix(c(1,2,2,2,2, 1,1,3,1,3, 1,2,2,2,2), ncol = 3)
accumarray(subs, val)
# , , 1
# [,1] [,2] [,3]
# [1,]  101    0    0
# [2,]    0    0    0
# , , 2
# [,1] [,2] [,3]
# [1,]    0    0    0
# [2,]  206    0  208

val = 101:106
subs <- matrix(c(1, 2, 1, 2, 3, 1, 4, 1, 4, 4, 4, 1), ncol = 2, byrow = TRUE)
accumarray(subs, val, func = function(x) sum(diff(x)))
# [,1] [,2] [,3] [,4]
# [1,]    0    1    0    0
# [2,]    0    0    0    0
# [3,]    0    0    0    0
# [4,]    2    0    0    0

val = 101:105
subs = matrix(c(1, 1, 2, 1, 2, 3, 2, 1, 2, 3), ncol = 2, byrow = TRUE)
accumarray(subs, val, sz = c(3, 3), func = max, fillval = NA)
# [,1] [,2] [,3]
# [1,]  101   NA   NA
# [2,]  104   NA  105
# [3,]   NA   NA   NA

##  Examples for uniq
a <- c(1, 1, 5, 6, 2, 3, 3, 9, 8, 6, 2, 4)
A <- uniq(a); A
# A$b  1  5  6  2  3  9  8  4
# A$m  2  3 10 11  7  8  9 12
# A$n  1  1  2  3  4  5  5  6  7  3  4  8
A <- uniq(a, first = TRUE); A
# A$m  1  3  4  5  6  8  9 12

##  Example: Subset sum problem
# Distribution of unique sums among all combinations of a vectors.
allsums <- function(a) {
    S <- c(); C <- c()
    for (k in 1:length(a)) {
        U <- uniq(c(S, a[k], S + a[k]))
        S <- U$b
        C <- accumarray(U$n, c(C, 1, C))
    }
    o <- order(S); S <- S[o]; C <- C[o]
    return(list(S = S, C = C))
}
A <- allsums(seq(1, 9, by=2)); A
# A$S  1  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 24 25
# A$C  1  1  1  1  1  1  2  2  2  1  2  2  1  2  2  2  1  1  1  1  1  1  1
}
\keyword{ array }

\name{moler}
\alias{moler}
\title{Moler Matrix}
\description{
Generate the Moler matrix of size \code{n x n}. The Moler matrix is for
testing eigenvalue computations.
}
\usage{
moler(n)
}
\arguments{
  \item{n}{integer}
}
\details{
The Moler matrix for testing eigenvalue computations is a symmetric
matrix with exactly one small eigenvalue. 
}
\value{
matrix of size \code{n x n}
}
\seealso{
\code{\link{wilkinson}}
}
\examples{
(a <- moler(10))
min(eig(a))
}
\keyword{ specmat }

\name{humps}
\alias{humps}
\alias{sinc}
\alias{psinc}
\title{
Matlab Test Functions
}
\description{
Matlab test functions.
}
\usage{
humps(x)
sinc(x)
psinc(x, n)
}
\arguments{
  \item{x}{numeric scalar or vector.}
  \item{n}{positive integer.}
}
\details{
  \code{humps} is a test function for finding zeros, for optimization
  and integration. Its root is at \code{x = 1.2995}, a (local) minimum
  at \code{x = 0.6370}, and the integral from \code{0.5} to \code{1.0}
  is \code{8.0715}.

  \code{sinc} is defined as \eqn{sinc(t) = \frac{\sin(\pi t)}{\pi t}}.
  It is the continuous inverse Fourier transform of the rectangular pulse
  of width \eqn{2\pi} and height \eqn{1}.

  \code{psinc} is the 'periodic sinc function' and is defined as
  \eqn{psinc(x,n) = \frac{\sin(x n/2)}{n \sin(x/2)}}.
}
\value{
  Numeric scalar or vector.
}
\examples{
\dontrun{
plot(humps(), type="l"); grid()

x <- seq(0, 10, length=101)
plot(x, sinc(x), type="l"); grid()
}
}

\name{trisolve}
\alias{trisolve}
\title{
  Tridiagonal Linear System Solver
}
\description{
  Solves tridiagonal linear systems \code{A*x=rhs} efficiently.
}
\usage{
trisolve(a, b, d, rhs)
}
\arguments{
  \item{a}{diagonal of the tridiagonal matrix \code{A}.}
  \item{b, d}{upper and lower secondary diagonal of \code{A}.}
  \item{rhs}{right hand side of the linear system \code{A*x=rhs}.}
}
\details{
  Solves tridiagonal linear systems \code{A*x=rhs} by applying Givens
  transformations.

  By only storing the three diagonals, \code{trisolve} has memory requirements 
  of \code{3*n} instead of \code{n^2} and
  is faster than the standard \code{solve} function for larger matrices.
}
\value{
  Returns the solution of the tridiagonal linear system as vector.
}
\note{
  Has applications for spline approximations and for solving boundary value
  problems (ordinary differential equations).
}
\references{
  Gander, W. (1992). Computermathematik. Birkhaeuser Verlag, Basel.
}
\seealso{
  \code{\link{qrSolve}}
}
\examples{
set.seed(8237)
a <- rep(1, 100)
e <- runif(99); f <- rnorm(99)
x <- rep(seq(0.1, 0.9, by = 0.2), times = 20)
A <- diag(100) + Diag(e, 1) + Diag(f, -1)
rhs <- A \%*\% x
s <- trisolve(a, e, f, rhs)
s[1:10]                         #=> 0.1 0.3 0.5 0.7 0.9 0.1 0.3 0.5 0.7 0.9
s[91:100]                       #=> 0.1 0.3 0.5 0.7 0.9 0.1 0.3 0.5 0.7 0.9
}
\keyword{ array }

\name{blanks}
\alias{blanks}
\title{String of Blank Carakters}
\description{
  Create a string of blank characters.
}
\usage{
blanks(n)
}
\arguments{
  \item{n}{integer greater or equal to 0.}
}
\details{
  \code{blanks(n)} is a string of \code{n} blanks.
}
\value{
  String of \code{n} blanks.
}
\seealso{
\code{\link{deblank}}
}
\examples{
blanks(6)
}
\keyword{ string }

\name{rk4, rk4sys}
\alias{rk4}
\alias{rk4sys}
\title{
  Classical Runge-Kutta
}
\description{
  Classical Runge-Kutta of order 4.
}
\usage{
rk4(f, a, b, y0, n)

rk4sys(f, a, b, y0, n)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)};\cr
           defined as a function \eqn{R \times R^m \rightarrow R^m}, where \eqn{m}
           is the number of equations.}
  \item{a, b}{endpoints of the interval.}
  \item{y0}{starting values; for \eqn{m} equations \code{y0} needs to be
                a vector of length \code{m}.}
  \item{n}{the number of steps from \code{a} to \code{b}.}
}
\details{
  Classical Runge-Kutta of order 4 for (systems of) ordinary differential
  equations with fixed step size.
}
\value{
  List with components \code{x} for grid points between \code{a} and \code{b}
  and \code{y} an n-by-m matrix with solutions for variables in columns, i.e.
  each row contains one time stamp.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\note{
  This function serves demonstration purposes only.
}
\seealso{
  \code{\link{ode23}}, \code{\link{deval}}
}
\examples{
##  Example1: ODE
# y' = y*(-2*x + 1/x) for x != 0, 1 if x = 0
# solution is x*exp(-x^2)
f <- function(x, y) {
	if (x != 0) dy <- y * (- 2*x + 1/x)
	else        dy <- rep(1, length(y))
	return(dy)
}
sol <- rk4(f, 0, 2, 0, 50)
\dontrun{
x <- seq(0, 2, length.out = 51)
plot(x, x*exp(-x^2), type = "l", col = "red")
points(sol$x, sol$y, pch = "*")
grid()}

##  Example2: Chemical process
  f <- function(t, u) {
    u1 <- u[3] - 0.1 * (t+1) * u[1]
    u2 <- 0.1 * (t+1) * u[1] - 2 * u[2]
    u3 <- 2 * u[2] - u[3]
    return(c(u1, u2, u3))
  }
u0 <- c(0.8696, 0.0435, 0.0870)
a <- 0; b <- 40
n <- 40
sol <- rk4sys(f, a, b, u0, n)
\dontrun{
matplot(sol$x, sol$y, type = "l", lty = 1, lwd = c(2, 1, 1),
        col = c("darkred", "darkblue", "darkgreen"),
        xlab = "Time [min]", ylab= "Concentration [Prozent]",
        main = "Chemical composition")
grid()}
}
\keyword{ ode }

\name{ridders}
\alias{ridders}
\title{
  Ridders' Root Finding Method
}
\description{
  Ridders' root finding method is a powerful variant of `regula falsi' (and
  `false position'). In reliability and speed, this method is competitive
  with Brent-Dekker and similar approaches.
}
\usage{
ridders(fun, a, b, maxiter = 500, tol = 1e-12, ...)
}
\arguments{
\item{fun}{function whose root is to be found.}
\item{a, b}{left and right interval bounds.}
\item{maxiter}{maximum number of iterations (function calls).}
\item{tol}{tolerance, length of the last interval.}
\item{...}{additional parameters passed on to the function.}
}
\details{
  Given a bracketing interval $[x_1, x_2]$, the method first calculates the
  midpoint \eqn{x_3 = (x_1 + x_2)/2} and the uses an updating formula
  \deqn{x_4 = x_3 + (x_3 - x_1) \frac{sgn(f(x_1) - f(x_2)) f(x_3)}{\sqrt{f(x_3)^2 - f(x_1) f(x_2)}}} 
}
\value{
  Returns a list with components
  \item{root}{root of the function.}
  \item{f.root}{value of the function at the found root.}
  \item{niter}{number of iterations,or more specifically: number of function calls.}
  \item{estim.prec}{the estimated precision, coming from the last brackett.}
}
\note{
  See function \code{f12} whose zero at \eqn{\sqrt{e}} is difficult to find
  exactly for all root finders.
}
\author{
  HwB  email: <hwborchers@googlemail.com>
}
\references{
  Press, Teukolsky, Vetterling, and Flannery (1992). Numerical Recipes in C.
  Cambridge University Press.
}
\seealso{
  \code{\link{brent}}
}
\examples{
##  Test functions
f1  <- function(x)                          # [0, 1.2],     0.399 422 2917
            x^2 * (x^2/3 + sqrt(2)*sin(x)) - sqrt(3)/18
f2  <- function(x) 11*x^11 - 1              # [0.4, 1.6],   0.804 133 0975
f3  <- function(x) 35*x^35 - 1              # [-0.5, 1.9],  0.903 407 6632
f4  <- function(x)                          # [-0.5, 0.7],  0.077 014 24135
            2*(x*exp(-9) - exp(-9*x)) + 1 
f5  <- function(x) x^2 - (1 - x)^9          # [-1.4, 1],    0.259 204 4937
f6  <- function(x) (x-1)*exp(-9*x) + x^9    # [-0.8, 1.6],  0.536 741 6626
f7  <- function(x) x^2 + sin(x/9) - 1/4     # [-0.5, 1.9],  0.4475417621
f8  <- function(x) 1/8 * (9 - 1/x)        # [0.001, 1.201], 0.111 111 1111 
f9  <- function(x) tan(x) - x - 0.0463025   # [-0.9, 1.5],  0.500 000 0340
f10 <- function(x)                          # [0.4, 1],     0.679 808 9215
            x^2 + x*sin(sqrt(75)*x) - 0.2
f11 <- function(x) x^9 + 0.0001             # [-1.2, 0],   -0.359 381 3664 
f12 <- function(x)                          # [1, 3.4],     1.648 721 27070
            log(x) + x^2/(2*exp(1)) - 2 * x/sqrt(exp(1)) + 1

r <- ridders(f1 , 0, 1.2);       r$root; r$niter # 18
r <- ridders(f2 , 0.4, 1.6);     r$root; r$niter # 14
r <- ridders(f3 ,-0.5, 1.9);     r$root; r$niter # 20
r <- ridders(f4 ,-0.5, 0.7);     r$root; r$niter # 12
r <- ridders(f5 ,-1.4, 1);       r$root; r$niter # 16
r <- ridders(f6 ,-0.8, 1.6);     r$root; r$niter # 20
r <- ridders(f7 ,-0.5, 1.9);     r$root; r$niter # 16
r <- ridders(f8 ,0.001, 1.201);  r$root; r$niter # 18
r <- ridders(f9 ,-0.9, 1.5);     r$root; r$niter # 20
r <- ridders(f10,0.4, 1);        r$root; r$niter # 14
r <- ridders(f11,-1.2, 0);       r$root; r$niter # 12
r <- ridders(f12,1, 3.4);        r$root; r$niter # 30, err = 1e-5

\dontrun{
##  Use ridders() with Rmpfr
options(digits=16)
library("Rmpfr") # unirootR
prec <- 256
.N <- function(.) mpfr(., precBits = prec)

f12 <- function(x) {
    e1 <- exp(.N(1))
    log(x) + x^2/(2*e1) - 2*x/sqrt(e1) + 1
}
sqrte <- sqrt(exp(.N(1)))  # 1.648721270700128...
f12(sqrte)                 # 0

unirootR(f12, interval=mpfr(c(1, 3.4), prec), tol=1e-20)
# $root
# 1 'mpfr' number of precision  200   bits 
# [1] 1.648721270700128...

ridders(f12, .N(1), .N(3.4), maxiter=200, tol=1e-20)
# $root
# 1 'mpfr' number of precision  200   bits 
# [1] 1.648721270700128...
}
}
\keyword{ math }

\name{isempty}
\alias{isempty}
\title{isempty Property}
\description{
  Determine if an object is empty.
}
\usage{
isempty(x)
}
\arguments{
  \item{x}{an R object}
}
\details{
  An empty object has length zero.
}
\value{
  \code{TRUE} if \code{x} has length 0; otherwise, \code{FALSE}.
}
\examples{
isempty(c(0))            # FALSE
isempty(matrix(0, 1, 0)) # TRUE
}
\keyword{logic}

\name{gmres}
\alias{gmres}
\title{
  Generalized Minimal Residual Method
}
\description{
  \code{gmres(A,b)} attempts to solve the system of linear equations
  \code{A*x=b} for \code{x}.
}
\usage{
    gmres(A, b, x0 = rep(0, length(b)), 
          errtol = 1e-6, kmax = length(b)+1, reorth = 1)
}
\arguments{
  \item{A}{square matrix.}
  \item{b}{numerical vector or column vector.}
  \item{x0}{initial iterate.}
  \item{errtol}{relative residual reduction factor.}
  \item{kmax}{maximum number of iterations}
  \item{reorth}{reorthogonalization method, see Details.}
}
\details{
  Iterative method for the numerical solution of a system of linear equations. 
  The method approximates the solution by the vector in a Krylov subspace with 
  minimal residual. The Arnoldi iteration is used to find this vector.

  Reorthogonalization method:\cr
  1 -- Brown/Hindmarsh condition (default)\cr
  2 -- Never reorthogonalize (not recommended)\cr
  3 -- Always reorthogonalize (not cheap!)
}
\value{
  Returns a list with components \code{x} the solution, \code{error} the 
  vector of residual norms, and \code{niter} the number of iterations.
}
\references{
  C. T. Kelley (1995). Iterative Methods for Linear and Nonlinear Equations.
  SIAM, Society for Industrial and Applied Mathematics, Philadelphia, USA.
}
\author{
  Based on Matlab code from C. T. Kelley's book, see references.
}
\seealso{
  \code{\link{solve}}
}
\examples{
A <- matrix(c(0.46, 0.60, 0.74, 0.61, 0.85,
              0.56, 0.31, 0.80, 0.94, 0.76,
              0.41, 0.19, 0.15, 0.33, 0.06,
              0.03, 0.92, 0.15, 0.56, 0.08,
              0.09, 0.06, 0.69, 0.42, 0.96), 5, 5)
x <- c(0.1, 0.3, 0.5, 0.7, 0.9)
b <- A \%*\% x
gmres(A, b)
# $x
#      [,1]
# [1,]  0.1
# [2,]  0.3
# [3,]  0.5
# [4,]  0.7
# [5,]  0.9
# 
# $error
# [1] 2.37446e+00 1.49173e-01 1.22147e-01 1.39901e-02 1.37817e-02 2.81713e-31
# 
# $niter
# [1] 5
}

\keyword{ math }

\name{einsteinF}
\alias{einsteinF}
\title{
  Einstein Functions
}
\description{
  Einstein functions.
}
\usage{
einsteinF(d, x)
}
\arguments{
  \item{x}{numeric or complex vector.}
  \item{d}{parameter to select one of the Einstein functions E1, E2, E3, E4.}
}
\details{
  The Einstein functions are sometimes used for the Planck-Einstein
  oscillator in one degree of freedom.

  The functions are defined as:
  \deqn{E1(x) = \frac{x^2 e^x}{(e^x - 1)^2}}
  \deqn{E2(x) = \frac{x}{e^x - 1}}
  \deqn{E3(x) = ln(1 - e^{-x})}
  \deqn{E4(x) = \frac{x}{e^x - 1} - ln(1 - e^{-x})}

  \code{E1} has an inflection point as \code{x=2.34694130...}.
}
\value{
  Numeric/complex scalar or vector.
}
\examples{
\dontrun{
x1 <- seq(-4, 4, length.out = 101)
y1 <- einsteinF(1, x1)
plot(x1, y1, type = "l", col = "red",
             xlab = "", ylab = "", main = "Einstein Function E1(x)")
grid()

y2 <- einsteinF(2, x1)
plot(x1, y2, type = "l", col = "red",
             xlab = "", ylab = "", main = "Einstein Function E2(x)")
grid()

x3 <- seq(0, 5, length.out = 101)
y3 <- einsteinF(3, x3)
plot(x3, y3, type = "l", col = "red",
             xlab = "", ylab = "", main = "Einstein Function E3(x)")
grid()

y4 <- einsteinF(4, x3)
plot(x3, y4, type = "l", col = "red",
             xlab = "", ylab = "", main = "Einstein Function E4(x)")
grid()}
}

\name{simpson}
\alias{simpson}
\title{
  Simpson Integration
}
\description{
  Numerically evaluate an integral by Simpson's rule.
}
\usage{
simpson(f, a, b, n = 100, ...)
}
\arguments{
  \item{f}{function of one variable, the integrand.}
  \item{a, b}{left and right endpoint of the interval.}
  \item{n}{number of sub-intervals, default 100.}
  \item{\ldots}{additional parameters to be passed to the integrand.}
}
\details{
  Simpson's rule calculates an integral of a function of one variable
  by approximating it quadratically. It is an easy to get and often quite
  accurate estimate. 
}
\value{
  Numerical scalar, the value of the integral.
}
\note{
  This version has been generated by DeepSeek.
  For a non-vectorized function f use Vectorize(f)!
}
\seealso{
  \code{\link{simpson2d}}, \code{\link{simpadpt}}
}
\examples{
simpson(sin, 0, pi, n=100)      # 2.0000000108245
simpson(sin, 0, pi, n=1000)     # 2.0000000000011

# Can also be used for a discretized function ...
xs <- seq(0, pi, length.out = 101)
ys <- sin(xs)
# ... by a linear approximation of that function
f <- approxfun(xs, ys, method = "linear")
simpson(f, 0, pi, n = 100)      # 2.0000000108245
simpson(f, 0, pi, n = 1000)     # 1.9998355038874
trapz(xs, ys)                   # 1.9998355038875
}
\keyword{ math }

\name{hankel}
\alias{hankel}
\title{Hankel Matrix}
\description{
Generate Hankel matrix from column and row vector
}
\usage{
  hankel(a, b)
}
\arguments{
  \item{a}{vector that will be the first column}
  \item{b}{vector that if present will form the last row.}
}
\details{
\code{hankel(a)} returns the square Hankel matrix whose first column is
\code{a} and whose elements are zero below the secondary diagonal. (I.e.:
\code{b} may be missing.)

\code{hankel(a, b)} returns a Hankel matrix whose first column is \code{a}
and whose last row is \code{b}. If the first element of \code{b} differs
from the last element of \code{a} it is overwritten by this one.
}
\value{
  matrix of size \code{(length(a), length(b))}
}
\seealso{
  \code{\link{Toeplitz}}, \code{\link{hadamard}}
}
\examples{
hankel(1:5, 5:1)
}
\keyword{ specmat }

\name{gaussLaguerre}
\alias{gaussLaguerre}
\title{
  Gauss-Laguerre Quadrature Formula
}
\description{
  Nodes and weights for the n-point Gauss-Laguerre quadrature formula.
}
\usage{
gaussLaguerre(n, a = 0)
}
\arguments{
  \item{n}{Number of nodes in the interval \code{[0, Inf[}.}
  \item{a}{exponent of \code{x} in the integrand: must be greater or equal
           to 0, otherwise the integral would not converge.}
}
\details{
  Gauss-Laguerre quadrature is used for integrating functions of the form
  \deqn{\int_0^{\infty} f(x) x^a e^{-x} dx}
  over the infinite interval \eqn{]0, \infty[}.

  \code{x} and \code{w} are obtained from a tridiagonal eigenvalue problem.
  The value of such an integral is then \code{sum(w*f(x))}.
}
\value{
  List with components \code{x}, the nodes or points in\code{[0, Inf[}, and
  \code{w}, the weights applied at these nodes.
}
\references{
  Gautschi, W. (2004). Orthogonal Polynomials: Computation and Approximation.
  Oxford University Press.

  Trefethen, L. N. (2000). Spectral Methods in Matlab. SIAM, Society for
  Industrial and Applied Mathematics.
}
\note{
  The basic quadrature rules are well known and can, e. g., be found in
  Gautschi (2004) --- and explicit Matlab realizations in Trefethen (2000).
  These procedures have also been implemented in Matlab by Geert Van Damme,
  see his entries at MatlabCentral since 2010.
}
\seealso{
\code{\link{gaussLegendre}}, \code{\link{gaussHermite}}
}
\examples{
cc <- gaussLaguerre(7)
# integrate exp(-x) from 0 to Inf
sum(cc$w)                     # 1
# integrate x^2 * exp(-x)     # integral x^n * exp(-x) is n!
sum(cc$w * cc$x^2)            # 2
# integrate sin(x) * exp(-x)
cc <- gaussLaguerre(17, 0)    # we need more nodes
sum(cc$w * sin(cc$x))         #=> 0.499999999994907 , should be 0.5
}
\keyword{ math }

\name{vander}
\alias{vander}
\title{Vandermonde matrix}
\description{
  Generate Vandermonde matrix from a numeric vector.
}
\usage{
  vander(x)
}
\arguments{
  \item{x}{Numeric vector}
}
\details{
  Generates the usual Vandermonde matrix from a numeric vector, e.g.
  applied when fitting a polynomial to given points.
  Complex values are allowed.
}
\value{
  Vandermonde matrix of dimension n where \code{n = length(x)}.
}
\examples{
  vander(c(1:10))
}
\keyword{ specmat }

\name{hurstexp}
\alias{hurstexp}
\title{
  Hurst Exponent
}
\description{
  Calculates the Hurst exponent using R/S analysis.
}
\usage{
  hurstexp(x, d = 50, display = TRUE)
}
\arguments{
  \item{x}{a time series.}
  \item{d}{smallest box size; default 50.}
  \item{display}{logical; shall the results be printed to the console?}
}
\details{
  \code{hurstexp(x)} calculates the Hurst exponent of a time series \code{x}
  using R/S analysis, after Hurst, with slightly different approaches, or
  corrects it with small sample bias, see for example Weron.

  These approaches are a corrected R/S method, an empirical and corrected
  empirical method, and a try at a theoretical Hurst exponent. It should be
  mentioned that the results are sometimes very different, so providing error
  estimates will be highly questionable.

  Optimal sample sizes are automatically computed with a length that
  possesses the most divisors among series shorter than \code{x} by no more
  than 1 percent.
}
\value{
  \code{hurstexp(x)} returns a list with the following components:
  \itemize{
    \item \code{Hs}  - simplified R over S approach
    \item \code{Hrs} - corrected R over S Hurst exponent
    \item \code{He}  - empirical Hurst exponent
    \item \code{Hal} - corrected empirical Hurst exponent
    \item \code{Ht}  - theoretical Hurst exponent
  }
}
\note{
  Derived from Matlab code of R. Weron, published on Matlab Central.
}
\references{
  H.E. Hurst (1951) Long-term storage capacity of reservoirs, Transactions
  of the American Society of Civil Engineers 116, 770-808.

  R. Weron (2002) Estimating long range dependence: finite sample properties
  and confidence intervals, Physica A 312, 285-299.
}
\seealso{
  \code{fractal::hurstSpec, RoverS, hurstBlock} and \code{fArma::LrdModelling}
}
\examples{
##  Computing the Hurst exponent
data(brown72)
x72 <- brown72                          #  H = 0.72
xgn <- rnorm(1024)                      #  H = 0.50
xlm <- numeric(1024); xlm[1] <- 0.1     #  H = 0.43
for (i in 2:1024) xlm[i] <- 4 * xlm[i-1] * (1 - xlm[i-1])

hurstexp(brown72, d = 128)           # 0.72
# Simple R/S Hurst estimation:         0.6590931 
# Corrected R over S Hurst exponent:   0.7384611 
# Empirical Hurst exponent:            0.7068613 
# Corrected empirical Hurst exponent:  0.6838251 
# Theoretical Hurst exponent:          0.5294909

hurstexp(xgn)                        # 0.50
# Simple R/S Hurst estimation:         0.5518143 
# Corrected R over S Hurst exponent:   0.5982146 
# Empirical Hurst exponent:            0.6104621 
# Corrected empirical Hurst exponent:  0.5690305 
# Theoretical Hurst exponent:          0.5368124 

hurstexp(xlm)                        # 0.43
# Simple R/S Hurst estimation:         0.4825898 
# Corrected R over S Hurst exponent:   0.5067766 
# Empirical Hurst exponent:            0.4869625 
# Corrected empirical Hurst exponent:  0.4485892 
# Theoretical Hurst exponent:          0.5368124 


##  Compare with other implementations
\dontrun{
library(fractal)

x <- x72
hurstSpec(x)                    # 0.776   # 0.720
RoverS(x)                       # 0.717
hurstBlock(x, method="aggAbs")  # 0.648
hurstBlock(x, method="aggVar")  # 0.613
hurstBlock(x, method="diffvar") # 0.714
hurstBlock(x, method="higuchi") # 1.001

x <- xgn
hurstSpec(x)                    # 0.538   # 0.500
RoverS(x)                       # 0.663
hurstBlock(x, method="aggAbs")  # 0.463
hurstBlock(x, method="aggVar")  # 0.430
hurstBlock(x, method="diffvar") # 0.471
hurstBlock(x, method="higuchi") # 0.574

x <- xlm
hurstSpec(x)                    # 0.478   # 0.430
RoverS(x)                       # 0.622
hurstBlock(x, method="aggAbs")  # 0.316
hurstBlock(x, method="aggVar")  # 0.279
hurstBlock(x, method="diffvar") # 0.547
hurstBlock(x, method="higuchi") # 0.998
}
}
\keyword{ timeseries }

\name{factors}
\alias{factors}
\title{Prime Factors}
\description{
  Returns a vector containing the prime factors of \code{n}.
}
\usage{
  factors(n)
}
\arguments{
  \item{n}{nonnegative integer}
}
\details{
  Computes the prime factors of \code{n} in ascending order,
  each one as often as its multiplicity requires, such that 
  \code{n == prod(factors(n))}.

  The corresponding Matlab function is called `factor', but because
  factors have a special meaning in R and the factor() function in R
  could not (or should not) be shadowed, the number theoretic function
  has been renamed here.
}
\value{
  Vector containing the prime factors of \code{n}.
}
\seealso{
  \code{\link{isprime}, \link{primes}}
}
\examples{
\dontrun{
  factors(1002001)       # 7  7  11  11  13  13
  factors(65537)         # is prime
  # Euler's calculation
  factors(2^32 + 1)      # 641  6700417}
}
\keyword{ math }

\name{barylag}
\alias{barylag}
\title{Barycentric Lagrange Interpolation}
\description{
  Barycentric Lagrange interpolation in one dimension.
}
\usage{
barylag(xi, yi, x)
}
\arguments{
  \item{xi, yi}{x- and y-coordinates of supporting nodes.}
  \item{x}{x-coordinates of interpolation points.}
}
\details{
  \code{barylag} interpolates the given data using the barycentric
  Lagrange interpolation formula (vectorized to remove all loops).
}
\value{
  Values of interpolated data at points \code{x}.
}
\references{
  Berrut, J.-P., and L. Nick Trefethen (2004). ``Barycentric Lagrange
  Interpolation''. SIAM Review, Vol. 46(3), pp.501--517.
}
\note{
  Barycentric interpolation is preferred because of its numerical stability.
}
\seealso{
Lagrange or Newton interpolation.
}
\examples{
##  Generates an example with plot.
# Input:
#   fun  ---  function that shall be 'approximated'
#   a, b ---  interval [a, b] to be used for the example
#   n    ---  number of supporting nodes
#   m    ---  number of interpolation points
# Output
#   plot of function, interpolation, and nodes
#   return value is NULL (invisible)
\dontrun{
barycentricExample <- function(fun, a, b, n, m)
{
	xi <- seq(a, b, len=n)
	yi <- fun(xi)
	x  <- seq(a, b, len=m)

	y <- barylag(xi, yi, x)
	plot(xi, yi, col="red", xlab="x", ylab="y",
		main="Example of barycentric interpolation")

	lines(x, fun(x), col="yellow", lwd=2)
	lines(x, y, col="darkred")

	grid()
}

barycentricExample(sin, -pi, pi, 11, 101)  # good interpolation
barycentricExample(runge, -1, 1, 21, 101)  # bad interpolation
}
}
\keyword{ math }

\name{runge}
\alias{runge}
\title{Runge Function}
\description{
Runge's test function for interpolation techniques.
}
\usage{
runge(x)
}
\arguments{
  \item{x}{numeric scalar.}
}
\details{
  Runge's function is a classical test function for interpolation and 
  and approximation techniques, especially for equidistant nodes.

  For example, when approximating the Runge function on the interval
  \code{[-1, 1]}, the error at the endpoints will diverge when the number
  of nodes is increasing.
}
\value{
Numerical value of the function.
}
\seealso{
  \code{\link{fnorm}}
}
\examples{
\dontrun{
x <- seq(-1, 1, length.out = 101)
y <- runge(x)
plot(x, y, type = "l", lwd = 2, col = "navy", ylim = c(-0.2, 1.2))
grid()

n <- c(6, 11, 16)
for (i in seq(along=n)) {
    xp <- seq(-1, 1, length.out = n[i])
    yp <- runge(xp)
    p  <- polyfit(xp, yp, n[i]-1)
    y  <- polyval(p, x)
    lines(x, y, lty=i) }
}
}
\keyword{ math }

\name{chebCoeff}
\alias{chebCoeff}
\title{Chebyshev Polynomials}
\description{
  Chebyshev Coefficients for Chebyshev polynomials of the first kind.
}
\usage{
chebCoeff(fun, a, b, n)
}
\arguments{
  \item{fun}{function to be approximated.}
  \item{a, b}{endpoints of the interval.}
  \item{n}{an integer \code{>= 0}.}
}
\details{
  For a function \code{fun} on on the interval \code{[a, b]} determines the
  coefficients of the Chebyshev polynomials up to degree \code{n} that will
  approximate the function (in L2 norm).
}
\value{
  Vector of coefficients for the Chebyshev polynomials, from low to high
  degrees (see the example).
}
\references{
  Weisstein, Eric W. ``Chebyshev Polynomial of the First Kind."
  From MathWorld --- A Wolfram Web Resource.
  \url{https://mathworld.wolfram.com/ChebyshevPolynomialoftheFirstKind.html}
}
\note{
  See the ``Chebfun Project'' <https://www.chebfun.org/> by
  Nick Trefethen.
}
\seealso{
\code{\link{chebPoly}}, \code{\link{chebApprox}}
}
\examples{
##  Chebyshev coefficients for x^2 + 1
n <- 4
f2 <- function(x) x^2 + 1
cC <- chebCoeff(f2, -1, 1, n)  #  3.0   0  0.5   0   0
cC[1] <- cC[1]/2               # correcting the absolute Chebyshev term
                               # i.e.  1.5*T_0 + 0.5*T_2
cP <- chebPoly(n)              # summing up the polynomial coefficients
p <- cC \%*\% cP                 #  0 0 1 0 1
}
\keyword{ math }

\name{laplacian}
\alias{laplacian}
\title{
  Laplacian Operator
}
\description{
  Numerically compute the Laplacian of a function.
}
\usage{
laplacian(f, x0, h = .Machine$double.eps^(1/4), ...)
}
\arguments{
  \item{f}{univariate function of several variables.}
  \item{x0}{point in \eqn{R^n}.}
  \item{h}{step size.}
  \item{...}{variables to be passed to \code{f}.}
}
\details{
  Computes the Laplacian operator \eqn{f_{x_1 x_1} + \ldots + f_{x_n x_n}}
  based on the three-point central difference formula, expanded to this
  special case.

  Assumes that the function has continuous partial derivatives.
}
\value{
  Real number.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\seealso{
  \code{\link{hessian}}
}
\examples{
f <- function(x) x[1]^2 + 2*x[1]*x[2] + x[2]^2
laplacian(f, c(1,1))
}
\keyword{ math }

\name{Norm}
\alias{Norm}
\title{
Vector Norm
}
\description{
  The \code{Norm} function calculates several different types of vector
  norms for \code{x}, depending on the argument \code{p}. 
}
\usage{
Norm(x, p = 2)
}
\arguments{
  \item{x}{Numeric vector; matrices not allowed.}
  \item{p}{Numeric scalar or Inf, -Inf; default is 2}
}
\details{
  \code{Norm} returns a scalar that gives some measure of the magnitude
  of the elements of \code{x}. It is called the \eqn{p}-norm for values
  \eqn{-Inf \le p \le Inf}, defining Hilbert spaces on \eqn{R^n}.

  \code{Norm(x)} is the Euclidean length of a vecor \code{x}; same as
  \code{Norm(x, 2)}.\cr
  \code{Norm(x, p)} for finite p is defined as \code{sum(abs(A)^p)^(1/p)}.\cr
  \code{Norm(x, Inf)} returns \code{max(abs(x))},
  while \code{Norm(x, -Inf)} returns \code{min(abs(x))}.
}
\value{
  Numeric scalar (or \code{Inf}), or \code{NA} if an element of \code{x}
  is \code{NA}.
}
\note{
  In Matlab/Octave this is called \code{norm}; R's \code{norm} function
  \code{norm(x, "F")} (`Frobenius Norm') is the same as \code{Norm(x)}.
}
\seealso{
  \code{\link{norm}} of a matrix
}
\examples{
Norm(c(3, 4))          #=> 5  Pythagoras triple
Norm(c(1, 1, 1), p=2)  #   sqrt(3)
Norm(1:10, p = 1)      #   sum(1:10)
Norm(1:10, p = 0)      #   Inf
Norm(1:10, p = Inf)    #   max(1:10)
Norm(1:10, p = -Inf)   #   min(1:10)
}
\keyword{ array }

\name{fderiv}
\alias{fderiv}
\title{
  Numerical Differentiation
}
\description{
  Numerical function differentiation for orders \code{n=1..4} using
  finite difference approximations.
}
\usage{
fderiv(f, x, n = 1, h = 0,
        method = c("central", "forward", "backward"), ...)
}
\arguments{
  \item{f}{function to be differentiated.}
  \item{x}{point(s) where differentiation will take place.}
  \item{n}{order of derivative, should only be between 1 and 8;
           for \code{n=0} function values will be returned.}
  \item{h}{step size: if \code{h=0} step size will be set automatically.}
  \item{method}{one of ``central'', ``forward'', or ``backward''.}
  \item{...}{more variables to be passed to function \code{f}.}
}
\details{
  Derivatives are computed applying central difference formulas that stem
  from the Taylor series approximation. These formulas have a convergence
  rate of \eqn{O(h^2)}.

  Use the `forward' (right side) or `backward' (left side) method if the
  function can only be computed or is only defined on one side. Otherwise,
  always use the central difference formulas.

  Optimal step sizes depend on the accuracy the function can be computed with.
  Assuming internal functions with an accuracy 2.2e-16, appropriate step
  sizes might be \code{5e-6, 1e-4, 5e-4, 2.5e-3} for \code{n=1,...,4} and
  precisions of about \code{10^-10, 10^-8, 5*10^-7, 5*10^-6} (at best).

  For \code{n>4} a recursion (or finite difference) formula will be applied,
  cd. the Wikipedia article on ``finite difference''.
}
\value{
  Vector of the same length as \code{x}.
}
\references{
  Kiusalaas, J. (2005). Numerical Methods in Engineering with Matlab.
  Cambridge University Press.
}
\note{
  Numerical differentiation suffers from the conflict between round-off
  and truncation errors. 
}
\seealso{
  \code{\link{numderiv}}, \code{\link{taylor}}
}
\examples{
\dontrun{
f <- sin
xs <- seq(-pi, pi, length.out = 100)
ys <- f(xs)
y1 <- fderiv(f, xs, n = 1, method = "backward")
y2 <- fderiv(f, xs, n = 2, method = "backward")
y3 <- fderiv(f, xs, n = 3, method = "backward")
y4 <- fderiv(f, xs, n = 4, method = "backward")
plot(xs, ys, type = "l", col = "gray", lwd = 2,
     xlab = "", ylab = "", main = "Sinus and its Derivatives")
lines(xs, y1, col=1, lty=2)
lines(xs, y2, col=2, lty=3)
lines(xs, y3, col=3, lty=4)
lines(xs, y4, col=4, lty=5)
grid()}
}
\keyword{ math }

\name{shubert}
\alias{shubert}
\title{
  Shubert-Piyavskii Method
}
\description{
  Shubert-Piyavskii Univariate Function Maximization
}
\usage{
shubert(f, a, b, L, crit = 1e-04, nmax = 1000)
}
\arguments{
  \item{f}{function to be optimized.}
  \item{a, b}{search between a and b for a maximum.}
  \item{L}{a Lipschitz constant for the function.}
  \item{crit}{critical value}
  \item{nmax}{maximum number of steps.}
}
\details{
  The Shubert-Piyavskii method, often called the Sawtooth Method, finds 
  the global maximum of a univariate function on a known interval. It is 
  guaranteed to find the global maximum on the interval under certain
  conditions:

  The function f is Lipschitz-continuous, that is there is a constant L
  such that \deqn{|f(x) - f(y)| \le L |x - y|}
  for all \eqn{x, y} in \eqn{[a, b]}.

  The process is stopped when the improvement in the last step is smaller 
  than the input argument \code{crit}.
}
\value{
Returns a list with the following components:
\item{xopt}{the x-coordinate of the minimum found.}
\item{fopt}{the function value at the minimum.}
\item{nopt}{number of steps.}
}
\references{
  Y. K. Yeo. Chemical Engineering Computation with MATLAB.
  CRC Press, 2017.
}
\seealso{
  \code{\link{findmins}}
}
\examples{
# Determine the global minimum of sin(1.2*x)+sin(3.5*x) in [-3, 8].
f <- function(x) sin(1.2*x) + sin(3.5*x)
shubert(function(x) -f(x), -3, 8, 5, 1e-04, 1000)
## $xopt
## [1] 3.216231     # 3.216209
## $fopt
## [1] 1.623964
## $nopt
## [1] 481
}
\keyword{ optimize }

\name{expint}
\alias{expint}
\alias{expint_E1}
\alias{expint_Ei}
\alias{li}
\title{
  Exponential and Logarithmic Integral
}
\description{
  The exponential integral functions E1 and Ei and
  the logarithmic integral Li.

  The exponential integral is defined for \eqn{x > 0} as
  \deqn{\int_x^\infty \frac{e^{-t}}{t} dt}
  and by analytic continuation in the complex plane. It can also be defined
  as the Cauchy principal value of the integral
  \deqn{\int_{-\infty}^x \frac{e^t}{t} dt}
  This is denoted as \eqn{Ei(x)} and the relationship between \code{Ei} and
  \code{expint(x)} for x real, x > 0 is as follows:
  \deqn{Ei(x) = - E1(-x) -i \pi}

  The logarithmic integral \eqn{li(x)} for real \eqn{x, x > 0}, is defined as
  \deqn{li(x) = \int_0^x \frac{dt}{log(t)}}
  and the Eulerian logarithmic integral as \eqn{Li(x) = li(x) - li(2)}.

  The integral \eqn{Li} approximates the prime number function \eqn{\pi(n)},
  i.e., the number of primes below or equal to n (see the examples).
}
\usage{
expint(x)
expint_E1(x)

expint_Ei(x)
li(x)
}
\arguments{
  \item{x}{vector of real or complex numbers.}
}
\details{
  For \code{x} in \code{[-38, 2]} we use a series expansion,
  otherwise a continued fraction, see the references below, chapter 5.
}
\value{
  Returns a vector of real or complex numbers, the vectorized exponential
  integral, resp. the logarithmic integral.
}
\note{
  The logarithmic integral \code{li(10^i)-li(2)} is an approximation of the
  number of primes below \code{10^i}, i.e., \code{Pi(10^i)}, see ``?primes''.
}
\references{
  Abramowitz, M., and I.A. Stegun (1965). Handbook of Mathematical Functions.
  Dover Publications, New York.
}
\seealso{
  \code{gsl::expint_E1,expint_Ei}, \code{\link{primes}}
}
\examples{
expint_E1(1:10)
#   0.2193839  0.0489005  0.0130484  0.0037794  0.0011483
#   0.0003601  0.0001155  0.0000377  0.0000124  0.0000042
expint_Ei(1:10)

\dontrun{
estimPi <- function(n) round(Re(li(n) - li(2))) # estimated number of primes
primesPi <- function(n) length(primes(n))       # true number of primes <= n
N <- 1e6
(estimPi(N) - primesPi(N)) / estimPi(N)         # deviation is 0.16 percent!}
}
\keyword{ specfun }

\name{abm3pc}
\alias{abm3pc}
\title{
  Adams-Bashford-Moulton
}
\description{
  Third-order Adams-Bashford-Moulton predictor-corrector method.
}
\usage{
abm3pc(f, a, b, y0, n = 50, ...)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)}.}
  \item{a, b}{endpoints of the interval.}
  \item{y0}{starting values at point \code{a}.}
  \item{n}{the number of steps from \code{a} to \code{b}.}
  \item{\ldots}{additional parameters to be passed to the function.}
}
\details{
  Combined Adams-Bashford and Adams-Moulton (or: multi-step) method of
  third order with corrections according to the predictor-corrector approach.
}
\value{
  List with components \code{x} for grid points between \code{a} and \code{b}
  and \code{y} a vector \code{y} the same length as \code{x}; additionally
  an error estimation \code{est.error} that should be looked at with caution.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\note{
  This function serves demonstration purposes only.
}
\seealso{
  \code{\link{rk4}}, \code{\link{ode23}}
}
\examples{
##  Attempt on a non-stiff equation
#   y' = y^2 - y^3, y(0) = d, 0 <= t <= 2/d, d = 0.01
f <- function(t, y) y^2 - y^3
d <- 1/250
abm1 <- abm3pc(f, 0, 2/d, d, n = 1/d)
abm2 <- abm3pc(f, 0, 2/d, d, n = 2/d)
\dontrun{
plot(abm1$x, abm1$y, type = "l", col = "blue")
lines(abm2$x, abm2$y, type = "l", col = "red")
grid()}
}
\keyword{ ode }

\name{lu}
\alias{lu}
\alias{lu_crout}
\alias{lufact}
\alias{lusys}
\title{
  LU Matrix Factorization
}
\description{
  LU decomposition of a positive definite matrix as Gaussian factorization.
}
\usage{
lu(A, scheme = c("kji", "jki", "ijk"))
lu_crout(A)

lufact(A)
lusys(A, b)
}
\arguments{
  \item{A}{square positive definite numeric matrix (will not be checked).}
  \item{scheme}{order of row and column operations.}
  \item{b}{right hand side of a linear system of equations.}
}
\details{
  For a given matrix \code{A}, the LU decomposition exists and is unique iff
  its principal submatrices of order \code{i=1,...,n-1} are nonsingular. The
  procedure here is a simple Gauss elimination with or without pivoting.

  The scheme abbreviations refer to the order in which the cycles of row- and
  column-oriented operations are processed. The ``ijk'' scheme is one of the
  two compact forms, here the Doolite factorization (the Crout factorization
  would be similar).

  \code{lu_crout} implements the Crout algorithm. For the Doolite algorithm,
  the \code{L} matrix has ones on its diagonal, for the Crout algorithm, the 
  diagonal of the \code{U} matrix only has ones.

  \code{lufact} applies partial pivoting (along the rows).
  \code{lusys} uses LU factorization to solve the linear system \code{A*x=b}.

  These function are not meant to process huge matrices or linear systems of
  equations.
  Without pivoting they may also be harmed by considerable inaccuracies.
}
\value{
   \code{lu} and \code{lu_crout} return a list with components \code{L}
   and \code{U}, the lower and upper triangular matrices such that
   \code{A=L\%*\%U}. 

  \code{lufact} returns a list with \code{L} and \code{U} combined into one
  matrix \code{LU}, the \code{rows} used in partial pivoting, and \code{det}
  representing the determinant of \code{A}. See the examples how to extract
  matrices \code{L} and \code{U} from \code{LU}.

  \code{lusys} returns the solution of the system as a column vector.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second edition, Springer-Verlag, Berlin Heidelberg.

  J.H. Mathews and K.D. Fink (2003). Numerical Methods Using MATLAB.
  Fourth Edition, Pearson (Prentice-Hall), updated 2006.
}
\note{
  To get the Crout decomposition of a matrix \code{A} do
  \code{Z <- lu(t(A)); L <- t(Z$U); U <- t(Z$L)}.
}
\seealso{
  \code{\link{qr}}
}
\examples{
A <- magic(5)
D <- lu(A, scheme = "ijk")     # Doolittle scheme
D$L \%*\% D$U
##      [,1] [,2] [,3] [,4] [,5]
## [1,]   17   24    1    8   15
## [2,]   23    5    7   14   16
## [3,]    4    6   13   20   22
## [4,]   10   12   19   21    3
## [5,]   11   18   25    2    9

H4 <- hilb(4)
lufact(H4)$det
## [1] 0.0000001653439

x0 <- c(1.0, 4/3, 5/3, 2.0)
b  <- H4 \%*\% x0
lusys(H4, b)
##          [,1]
## [1,] 1.000000
## [2,] 1.333333
## [3,] 1.666667
## [4,] 2.000000
}

\keyword{ array }

\name{errorbar}
\alias{errorbar}
\title{
  Plot Error Bars
}
\description{
  Draws symmetric error bars in x- and/or y-direction.
}
\usage{
errorbar(x, y, xerr = NULL, yerr = NULL,
         bar.col = "red", bar.len = 0.01,
         grid = TRUE, with = TRUE, add = FALSE, ...)
}
\arguments{
  \item{x, y}{x-, y-coordinates}
  \item{xerr, yerr}{length of the error bars, relative to the x-, y-values.}
  \item{bar.col}{color of the error bars; default: red}
  \item{bar.len}{length of the cross bars orthogonal to the error bars;
                 default: 0.01.}
  \item{grid}{logical; should the grid be plotted?; default: true}
  \item{with}{logical; whether to end the error bars with small cross bars.}
  \item{add}{logical; should the error bars be added to an existing plot?;
             default: false.}
  \item{...}{additional plotting parameters that will be passed to the
             \code{plot} function.}
}
\details{
  \code{errorbar} plots \code{y} versus \code{x} with symmetric error bars,
  with a length determined by \code{xerr} resp. \code{yerr} in x- and/or
  y-direction. If \code{xerr} or \code{yerr} is \code{NULL} error bars in
  this direction will not be drawn.

  A future version will allow to draw unsymmetric error bars by specifying
  upper and lower limits when \code{xerr} or \code{yerr} is a matrix of
  size \code{(2 x length(x))}.
}
\value{
  Generates a plot, no return value.
}
\seealso{
  \code{plotrix::plotCI}, \code{Hmisc::errbar}
}
\examples{
\dontrun{
x <- seq(0, 2*pi, length.out = 20)
y <- sin(x)
xe <- 0.1
ye <- 0.1 * y
errorbar(x, y, xe, ye, type = "l", with = FALSE)

cnt <- round(100*randn(20, 3))
y <- apply(cnt, 1, mean)
e <- apply(cnt, 1, sd)
errorbar(1:20, y, yerr = e, bar.col = "blue")
}
}
\keyword{ graphs }

\name{strcat}
\alias{strcat}
\title{String Concatenation}
\description{
  Concatenate all strings  in a character vector
}
\usage{
strcat(s1, s2 = NULL, collapse = "")
}
\arguments{
  \item{s1}{character string or vectors}
  \item{s2}{character string or vector, or NULL (default)}
  \item{collapse}{character vector of length 1 (at best a single character)}
}
\details{
  Concatenate all strings  in character vector \code{s1}, if \code{s2} is
  \code{NULL}, or cross-concatenate all string elements in \code{s1} and
  \code{s2} using \code{collapse} as `glue'.
}
\value{
  a character string or character vector
}
\seealso{
\code{\link{paste}}
}
\examples{
strcat(c("a", "b", "c"))                        #=> "abc"
strcat(c("a", "b"), c("1", "2"), collapse="x")  #=> "ax1" "ax2" "bx1" "bx2"
}
\keyword{ string }

\name{newtonsys}
\alias{newtonsys}
\title{Newton Method for Nonlinear Systems}
\description{
  Newton's method applied to multivariate nonlinear functions.
}
\usage{
newtonsys(Ffun, x0, Jfun = NULL, ...,
    	  maxiter = 100, tol = .Machine$double.eps^(1/2))
}
\arguments{
\item{Ffun}{\code{m} functions of \code{n} variables.}
\item{Jfun}{Function returning a square \code{n}-by-\code{n} matrix
            (of partial derivatives) or \code{NULL}, the default.}
\item{x0}{Numeric vector of length \code{n}.}
\item{maxiter}{Maximum number of iterations.}
\item{tol}{Tolerance, relative accuracy.}
\item{...}{Additional parameters to be passed to f.}
}
\details{
  Solves the system of equations applying Newton's method with the univariate
  derivative replaced by the Jacobian.
}
\value{
  List with components: \code{zero} the root found so far, \code{fnorm} the
  square root of sum of squares of the values of f, and \code{iter} the
  number of iterations needed.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  TODO: better error checking, e.g. when the Jacobian is not invertible.
}
\seealso{
  \code{\link{newtonRaphson}}, \code{\link{broyden}}
}
\examples{
##  Example from Quarteroni & Saleri
F1 <- function(x) c(x[1]^2 + x[2]^2 - 1, sin(pi*x[1]/2) + x[2]^3)
newtonsys(F1, x0 = c(1, 1))  # zero: 0.4760958 -0.8793934

##  Find the roots of the complex function sin(z)^2 + sqrt(z) - log(z)
F2 <- function(x) {
    z  <- x[1] + x[2]*1i
    fz <- sin(z)^2 + sqrt(z) - log(z)
    c(Re(fz), Im(fz))
}
newtonsys(F2, c(1, 1))
# $zero   0.2555197 0.8948303 , i.e.  z0 = 0.2555 + 0.8948i
# $fnorm  2.220446e-16
# $niter  8

##  Two more problematic examples
F3 <- function(x)
        c(2*x[1] - x[2] - exp(-x[1]), -x[1] + 2*x[2] - exp(-x[2]))
newtonsys(F3, c(0, 0))
# $zero   0.5671433 0.5671433
# $fnorm  0
# $niter  4

\dontrun{
F4 <- function(x)  # Dennis Schnabel
        c(x[1]^2 + x[2]^2 - 2, exp(x[1] - 1) + x[2]^3 - 2)
newtonsys(F4, c(2.0, 0.5))
# will result in an error ``missing value in  ... err<tol && niter<maxiter''}
}
\keyword{ math }

\name{angle}
\alias{Real}
\alias{Imag}
\alias{angle}
\title{Basic Complex Functions}
\description{
Basic complex functions (Matlab style)
}
\usage{
Real(z)
Imag(z)
angle(z)
}
\arguments{
  \item{z}{Vector or matrix of real or complex numbers}
}
\details{
These are just Matlab names for the corresponding functions in R. The
\code{angle} function is simply defined as \code{atan2(Im(z), Re(z))}.
}
\value{
returning real or complex values; \code{angle} returns in radians.
}
\note{
The true Matlab names are \code{real}, \code{imag}, and \code{conj}, but as
\code{real} was taken in R, all these beginnings are changed to capitals.

The function \code{Mod} has no special name in Matlab;
use \code{abs()} instead.
}
\seealso{
\code{\link{Mod}}, \code{\link{abs}}
}
\examples{
z <- c(0, 1, 1+1i, 1i)
Real(z)   # Re(z)
Imag(z)   # Im(z)
Conj(z)   # Conj(z)
abs(z)    # Mod(z)
angle(z)
}
\keyword{ arith }

\name{newtonRaphson}
\alias{newtonRaphson}
\alias{newton}
\title{
  Rootfinding through Newton-Raphson or Secant.
}
\description{
  Finding roots of univariate functions. (Newton never invented or used
  this method; it should be called more appropriately Simpson's method!)
}
\usage{
newtonRaphson(fun, x0, dfun = NULL, maxiter = 500, tol = 1e-08, ...)
newton(fun, x0, dfun = NULL, maxiter = 500, tol = 1e-08, ...)
}
\arguments{
  \item{fun}{Function or its name as a string.}
  \item{x0}{starting value for newtonRaphson().}
  \item{dfun}{A function to compute the derivative of \code{f}.
              If \code{NULL}, a numeric derivative will be computed.}
  \item{maxiter}{maximum number of iterations; default 100.}
  \item{tol}{absolute tolerance; default \code{eps^(1/2)}}
  \item{...}{Additional arguments to be passed to f.}
}
\details{
  Well known root finding algorithms for real, univariate, continuous
  functions. 
}
\value{
  Return a list with components \code{root}, \code{f.root}, 
  the function value at the found root, \code{iter}, the number of iterations
  done, and \code{root}, and the estimated precision \code{estim.prec}

  The estimated precision is given as the difference to the last solution 
  before stop; this may be misleading.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
\code{\link{newtonHorner}}
}
\examples{
# Legendre polynomial of degree 5
lp5 <- c(63, 0, -70, 0, 15, 0)/8
f <- function(x) polyval(lp5, x)
newton(f, 1.0)         # 0.9061798459 correct to 10 decimals in 5 iterations
}
\keyword{ math }

\name{newtonInterp}
\alias{newtonInterp}
\alias{lagrangeInterp}
\title{
  Lagrange and Newtons Interpolation
}
\description{
  Lagrange's and Newton's method of polynomial interpolation.
}
\usage{
newtonInterp(x, y, xs = c())

lagrangeInterp(x, y, xs)
}
\arguments{
  \item{x, y}{x-, y-coordinates of data points defining the polynomial.}
  \item{xs}{either empty, or a vector of points to be interpolated.}
}
\details{
  Straightforward implementation of Lagrange's Newton's method
  (vectorized in \code{xs}).
}
\value{
  A vector of values at \code{xs} of the polynomial defined by \code{x,y}.
}
\references{
  Each textbook on numerical analysis.
}
\seealso{
  \code{\link{neville}}, \code{\link{barylag}}
}
\examples{
p <- Poly(c(1, 2, 3))
fp <- function(x) polyval(p, x)

x <- 0:4; y <- fp(x)
xx <- linspace(0, 4, 51)
yy <- lagrangeInterp(x, y, xx)
yy <- newtonInterp(x, y, xx)
\dontrun{
ezplot(fp, 0, 4)
points(xx, yy)}
}
\keyword{ math }

\name{findintervals}
\alias{findintervals}
\title{
  Find Interval Indices
}
\description{
  Find indices \code{i} in vector \code{xs} such that either \code{x=xs[i]}
  or such that \code{xs[i]<x<xs[i+1]} or \code{xs[i]>x>xs[i+1]}.
}
\usage{
findintervals(x, xs)
}
\arguments{
  \item{x}{single number.}
  \item{xs}{numeric vector, not necessarily sorted.}
}
\details{
  Contrary to \code{findInterval}, the vector \code{xs} in
  \code{findintervals} need not be sorted.
}
\value{
  Vector of indices in \code{1..length(xs)}.
  If none is found, returns \code{integer(0)}.
}
\note{
  If \code{x} is equal to the last element in \code{xs}, the index
  \code{length(xs)} will also be returned.
}
\examples{
xs <- zapsmall(sin(seq(0, 10*pi, len=100)))
findintervals(0, xs)
#   1  10  20  30  40  50  60  70  80  90 100
}
\keyword{ logic }

\name{grad}
\alias{grad}
\title{
  Numerical Gradient
}
\description{
  Numerical function gradient.
}
\usage{
grad(f, x0, heps = .Machine$double.eps^(1/3), ...)
}
\arguments{
  \item{f}{function of several variables.}
  \item{x0}{point where the gradient is to build.}
  \item{heps}{step size.}
  \item{...}{more variables to be passed to function \code{f}.}
}
\details{
  Computes the gradient
  \deqn{(\frac{\partial f}{\partial x_1}, \ldots, \frac{\partial f}{\partial x_n})}
  numerically using the ``central difference formula''.
}
\value{
  Vector of the same length as \code{x0}.
}
\references{
  Mathews, J. H., and K. D. Fink (1999). Numerical Methods Using Matlab.
  Third Edition, Prentice Hall.
}
\seealso{
  \code{\link{fderiv}}
}
\examples{
f <- function(u) {
    x <- u[1]; y <- u[2]; z <- u[3]
    return(x^3 + y^2 + z^2 +12*x*y + 2*z)
 }
x0 <- c(1,1,1)
grad(f, x0)     # 15 14  4        # direction of steepest descent

sum(grad(f, x0) * c(1, -1, 0))    # 1 , directional derivative

f <- function(x) x[1]^2 + x[2]^2
grad(f, c(0,0))                   # 0 0 , i.e. a local optimum
}
\keyword{ math }

\name{Mode}
\alias{Mode}
\title{
Mode function (Matlab style)
}
\description{
  Most frequent value in vector or matrix
}
\usage{
Mode(x)
}
\arguments{
  \item{x}{Real or complex vector or of factor levels.}
}
\details{
  Computes the `sample mode', i.e. the most frequently occurring value in x.

  Among values occurring equally frequently, \code{Mode()} chooses the
  smallest one (for a numeric vector), one with a smallest absolute value
  (for complex ones) or the first occurring value (for factor levels).

  A matrix will be changed to a vector.
}
\value{
  One element from x and of the same type. The number of occurrences will 
  not be returned.
}
\note{
  In Matlab/Octave an array dimension can be selected along which to find
  the mode value; this has not been realized here.

  Shadows the R function \code{mode} that returns essentially the type
  of an object.
}
\seealso{
  \code{\link{median}}
}
\examples{
x <- round(rnorm(1000), 2)
Mode(x)
}
\keyword{ manip }

\name{numel}
\alias{numel}
\title{Number of Elements}
\description{
  Number of elements in a vector, matrix, or array.
}
\usage{
numel(x)
}
\arguments{
  \item{x}{a vector, matrix, array or list}
}
\value{
  the number of elements of \code{a}.
}
\seealso{
  \code{\link{size}}
}
\examples{
numel(c(1:12))
numel(matrix(1:12, 3, 4))
}
\keyword{array}

\name{lsqnonlin}
\alias{lsqnonlin}
\alias{lsqnonneg}
\alias{lsqcurvefit}
\alias{lsqsep}
\title{
  Nonlinear Least-Squares Fitting
}
\description{
  \code{lsqnonlin} solves nonlinear least-squares problems, including
  nonlinear data-fitting problems, through the Levenberg-Marquardt approach.

  \code{lsqnonneg} solve nonnegative least-squares constraints problem.
}
\usage{
lsqnonlin(fun, x0, options = list(), ...)
lsqnonneg(C, d)

lsqsep(flist, p0, xdata, ydata, const = TRUE)
lsqcurvefit(fun, p0, xdata, ydata)
}
\arguments{
  \item{fun}{User-defined, vector-valued function.}
  \item{x0}{starting point.}
  \item{...}{additional parameters passed to the function.}
  \item{options}{list of options, for details see below.}
  \item{C, d}{matrix and vector such that \code{C x - d} will be
              minimized with \code{x >= 0}.}

  \item{flist}{list of (nonlinear) functions, depending on one extra parameter.}
  \item{p0}{starting parameters.}
  \item{xdata, ydata}{data points to be fitted.}
  \item{const}{logical; shall a constant term be included.}
}
\details{
  \code{lsqnonlin} computes the sum-of-squares of the vector-valued function
  \code{fun}, that is if \eqn{f(x) = (f_1(x), \ldots ,f_n(x))} then
  \deqn{min || f(x) ||_2^2 = min(f_1(x)^2 + \ldots + f_n(x)^2)}
  will be minimized.

  \code{x=lsqnonlin(fun,x0)} starts at point \code{x0} and finds a minimum
  of the sum of squares of the functions described in fun. \code{fun} shall
  return a vector of values and not the sum of squares of the values.
  (The algorithm implicitly sums and squares fun(x).)

  \code{options} is a list with the following components and defaults:
  \itemize{
    \item \code{tau}: used as starting value for Marquardt parameter.
    \item \code{tolx}: stopping parameter for step length.
    \item \code{tolg}: stopping parameter for gradient.
    \item \code{maxeval} the maximum number of function evaluations.
  }
  Typical values for \code{tau} are from \code{1e-6...1e-3...1} with small
  values for good starting points and larger values for not so good or known
  bad starting points.

  \code{lsqnonneg} solves the linear least-squares problem \code{C x - d},
  \code{x} nonnegative, treating it through an active-set approach..

  \code{lsqsep} solves the separable least-squares fitting problem

  \code{y = a0 + a1*f1(b1, x) + ... + an*fn(bn, x)}

  where \code{fi} are nonlinear functions each depending on a single extra
  paramater \code{bi}, and \code{ai} are additional linear parameters that
  can be separated out to solve a nonlinear problem in the \code{bi} alone.

  \code{lsqcurvefit} is simply an application of \code{lsqnonlin} to fitting
  data points. \code{fun(p, x)} must be a function of two groups of variables
  such that \code{p} will be varied to minimize the least squares sum, see
  the example below.
}
\value{
  \code{lsqnonlin} returns a list with the following elements:
  \itemize{
    \item \code{x}: the point with least sum of squares value.
    \item \code{ssq}: the sum of squares.
    \item \code{ng}: norm of last gradient.
    \item \code{nh}: norm of last step used.
    \item \code{mu}: damping parameter of Levenberg-Marquardt.
    \item \code{neval}: number of function evaluations.
    \item \code{errno}: error number, corresponds to error message.
    \item \code{errmess}: error message, i.e. reason for stopping.
  }

  \code{lsqnonneg} returns a list of \code{x} the non-negative solition, and
  \code{resid.norm} the norm of the residual.

  \code{lsqsep} will return the coefficients sparately, \code{a0} for the
  constant term (being 0 if \code{const=FALSE}) and the vectors \code{a} and
  \code{b} for the linear and nonlinear terms, respectively.
}
\note{
  The refined approach, Fletcher's version of the Levenberg-Marquardt
  algorithm, may be added at a later time; see the references.
}
\references{
  Madsen, K., and H. B.Nielsen (2010). Introduction to Optimization and
  Data Fitting. Technical University of Denmark, Intitute of Computer
  Science and Mathematical Modelling.

  Lawson, C.L., and R.J. Hanson (1974). Solving Least-Squares Problems.
  Prentice-Hall, Chapter 23, p. 161.

  Fletcher, R., (1971). A Modified Marquardt Subroutine for Nonlinear Least
  Squares. Report AERE-R 6799, Harwell.
}
\seealso{
  \code{\link{nlm}}, \code{\link{nls}}
}
\examples{
##  Rosenberg function as least-squares problem
x0  <- c(0, 0)
fun <- function(x) c(10*(x[2]-x[1]^2), 1-x[1])
lsqnonlin(fun, x0)

##  Example from R-help
y <- c(5.5199668,  1.5234525,  3.3557000,  6.7211704,  7.4237955,  1.9703127,
       4.3939336, -1.4380091,  3.2650180,  3.5760906,  0.2947972,  1.0569417)
x <- c(1,   0,   0,   4,   3,   5,  12,  10,  12, 100, 100, 100)
# Define target function as difference
f <- function(b)
     b[1] * (exp((b[2] - x)/b[3]) * (1/b[3]))/(1 + exp((b[2] - x)/b[3]))^2 - y
x0 <- c(21.16322, 8.83669, 2.957765)
lsqnonlin(f, x0)        # ssq 50.50144 at c(36.133144, 2.572373, 1.079811)

# nls() will break down
# nls(Y ~ a*(exp((b-X)/c)*(1/c))/(1 + exp((b-X)/c))^2,
#     start=list(a=21.16322, b=8.83669, c=2.957765), algorithm = "plinear")
# Error: step factor 0.000488281 reduced below 'minFactor' of 0.000976563

##  Example: Hougon function
x1 <- c(470, 285, 470, 470, 470, 100, 100, 470, 100, 100, 100, 285, 285)
x2 <- c(300,  80, 300,  80,  80, 190,  80, 190, 300, 300,  80, 300, 190)
x3 <- c( 10,  10, 120, 120,  10,  10,  65,  65,  54, 120, 120,  10, 120)
rate <- c(8.55,  3.79, 4.82, 0.02,  2.75, 14.39, 2.54,
          4.35, 13.00, 8.50, 0.05, 11.32,  3.13)
fun <- function(b)
        (b[1]*x2 - x3/b[5])/(1 + b[2]*x1 + b[3]*x2 + b[4]*x3) - rate
lsqnonlin(fun, rep(1, 5))
# $x    [1.25258502 0.06277577 0.04004772 0.11241472 1.19137819]
# $ssq  0.298901

##  Example for lsqnonneg()
C1 <- matrix( c(0.1210, 0.2319, 0.4398, 0.9342, 0.1370,
                0.4508, 0.2393, 0.3400, 0.2644, 0.8188,
                0.7159, 0.0498, 0.3142, 0.1603, 0.4302,
                0.8928, 0.0784, 0.3651, 0.8729, 0.8903,
                0.2731, 0.6408, 0.3932, 0.2379, 0.7349,
                0.2548, 0.1909, 0.5915, 0.6458, 0.6873,
                0.8656, 0.8439, 0.1197, 0.9669, 0.3461,
                0.2324, 0.1739, 0.0381, 0.6649, 0.1660,
                0.8049, 0.1708, 0.4586, 0.8704, 0.1556,
                0.9084, 0.9943, 0.8699, 0.0099, 0.1911), ncol = 5, byrow = TRUE)
C2 <- C1 - 0.5
d <- c(0.4225, 0.8560, 0.4902, 0.8159, 0.4608,
       0.4574, 0.4507, 0.4122, 0.9016, 0.0056)
( sol <- lsqnonneg(C1, d) )     #-> resid.norm   0.3694372
( sol <- lsqnonneg(C2, d) )     #-> $resid.norm  2.863979

##  Example for lsqcurvefit()
#   Lanczos1 data (artificial data)
#   f(x) = 0.0951*exp(-x) + 0.8607*exp(-3*x) + 1.5576*exp(-5*x)
x <- linspace(0, 1.15, 24)
y <- c(2.51340000, 2.04433337, 1.66840444, 1.36641802, 1.12323249, 0.92688972,
       0.76793386, 0.63887755, 0.53378353, 0.44793636, 0.37758479, 0.31973932,
       0.27201308, 0.23249655, 0.19965895, 0.17227041, 0.14934057, 0.13007002,
       0.11381193, 0.10004156, 0.08833209, 0.07833544, 0.06976694, 0.06239313)

p0 <- c(1.2, 0.3, 5.6, 5.5, 6.5, 7.6)
fp <- function(p, x) p[1]*exp(-p[2]*x) + p[3]*exp(-p[4]*x) + p[5]*exp(-p[6]*x)
lsqcurvefit(fp, p0, x, y)

##  Example for lsqsep()
f <- function(x) 0.5 + x^-0.5 + exp(-0.5*x)
set.seed(8237); n <- 15
x <- sort(0.5 + 9*runif(n))
y <- f(x)                       #y <- f(x) + 0.01*rnorm(n)

m <- 2
f1 <- function(b, x) x^b
f2 <- function(b, x) exp(b*x)
flist <- list(f1, f2)
start <- c(-0.25, -0.75)

sol <- lsqsep(flist, start, x, y, const = TRUE)
a0 <- sol$a0; a <- sol$a; b <- sol$b
fsol <- function(x) a0 + a[1]*f1(b[1], x) + a[2]*f2(b[2], x)

\dontrun{
    ezplot(f, 0.5, 9.5, col = "gray")
    points(x, y, col = "blue")
    xs <- linspace(0.5, 9.5, 51)
    ys <- fsol(xs)
    lines(xs, ys, col = "red")
}
}
\keyword{ fitting }

\name{ratinterp}
\alias{ratinterp}
\title{
  Rational Interpolation
}
\description{
  Burlisch-Stoer rational interpolation.
}
\usage{
ratinterp(x, y, xs = x)
}
\arguments{
  \item{x}{numeric vector; points on the x-axis; needs to be sorted;
           at least three points required.}
  \item{y}{numeric vector; values of the assumed underlying function;
           \code{x} and \code{y} must be of the same length.}
  \item{xs}{numeric vector; points at which to compute the interpolation;
            all points must lie between \code{min(x)} and \code{max(x)}.}
}
\details{
  The Burlisch-Stoer approach to rational interpolation is a recursive
  procedure (similar to the Newton form of polynomial interpolation) that
  produces a ``diagonal'' rational function, that is the degree of the
  numerator is either the same or one less than the degree of the denominator.

  Polynomial interpolation will have difficulties if some kind of singularity
  exists in the neighborhood, even if the pole occurs in the complex plane.
  For instance, Runge's function has a pole at \eqn{z = 0.2 i}, quite close
  to the interval \eqn{[-1, 1]}.
}
\value{
  Numeric vector representing values at points \code{xs}.
}
\note{
  The algorithm does not yield a simple algebraic expression for the
  rational function found.
}
\references{
  Stoer, J., and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Springer-Verlag, New York.

  Fausett, L. V. (2008). Applied Numerical Analysis Using Matlab.
  Second Edition, Pearson Education.
}
\seealso{
  \code{\link{rationalfit}}, \code{\link{pade}}
}
\examples{
## Rational interpolation of Runge's function
x <- c(-1, -0.5, 0, 0.5, 1.0)
y <- runge(x)
xs <- linspace(-1, 1)
ys <- runge(xs)
yy <- ratinterp(x, y, xs)  # returns exactly the Runge function

\dontrun{
plot(xs, ys, type="l", col="blue", lty = 2, lwd = 3)
points(x, y)
yy <- ratinterp(x, y, xs)
lines(xs, yy, col="red")
grid()}
}
\keyword{ fitting }

\name{figure}
\alias{figure}
\title{
  Control Plot Devices (Matlab Style)
}
\description{
  Open, activate, and close grahics devices.
}
\usage{
figure(figno, title = "")
}
\arguments{
  \item{figno}{(single) number of plot device.}
  \item{title}{title of the plot device; not yet used.}
}
\details{
  The number of a graphics device cannot be 0 or 1. The function will work
  for the operating systems Mac OS, MS Windows, and most Linux systems.
  
  If \code{figno} is negative and a graphics device with that number does
  exist, it will be closed.
}
\value{
  No return value, except when a device of that number does not exist,
  in which case it returns a list of numbers of open graphics devices.
}
\note{
  Does not bring the activated graphics device in front.
}
\seealso{
  \code{dev.set, dev.off, dev.list}
}
\examples{
\dontrun{
figure()
figure(-2)
}
}
\keyword{ graphs }

\name{hampel}
\alias{hampel}
\title{
Hampel Filter
}
\description{
Median absolute deviation (MAD) outlier in Time Series
}
\usage{
hampel(x, k, t0 = 3)
}
\arguments{
  \item{x}{numeric vector representing a time series}
  \item{k}{window length \code{2*k+1} in indices}
  \item{t0}{threshold, default is 3 (Pearson's rule), see below.}
}
\details{
  The `median absolute deviation' computation is done in the \code{[-k...k]}
  vicinity of each point at least \code{k} steps away from the end points of
  the interval.
  At the lower and upper end the time series values are preserved.

  A high threshold makes the filter more forgiving, a low one will declare
  more points to be outliers. \code{t0<-3} (the default) corresponds to Ron 
  Pearson's 3 sigma edit rule, \code{t0<-0} to John Tukey's median filter.
}
\value{
  Returning a list \code{L} with \code{L$y} the corrected time series and
  \code{L$ind} the indices of outliers in the `median absolut deviation'
  sense.
}
\note{
  Don't take the expression \emph{outlier} too serious. It's just a hint to
  values in the time series that appear to be unusual in the vicinity of
  their neighbors under a normal distribution assumption.
}
\references{
  Pearson, R. K. (1999). ``Data cleaning for dynamic modeling and control''.
  European Control Conference, ETH Zurich, Switzerland.
}
\seealso{
\code{\link{findpeaks}}
}
\examples{
set.seed(8421)
x <- numeric(1024)
z <- rnorm(1024)
x[1] <- z[1]
for (i in 2:1024) {
	x[i] <- 0.4*x[i-1] + 0.8*x[i-1]*z[i-1] + z[i]
}
omad <- hampel(x, k=20)

\dontrun{
plot(1:1024, x, type="l")
points(omad$ind, x[omad$ind], pch=21, col="darkred")
grid()}
}
\keyword{ timeseries }

\name{newmark}
\alias{newmark}
\title{
  Newmark Method
}
\description{
  Newmark's is a method to solve higher-order differential equations
  without passing through the equivalent first-order system.
  It generalizes the so-called `leap-frog' method.
  Here it is restricted to second-order equations.
}
\usage{
newmark(f, t0, t1, y0, ..., N = 100, zeta = 0.25, theta = 0.5)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y'' = f(x, y, y')};\cr
           defined as a function \eqn{R \times R^2 \rightarrow R}.}
  \item{t0, t1}{start and end points of the interval.}
  \item{y0}{starting values as row or column vector;
            \code{y0} needs to be a vector of length 2, the first component
            representing \code{y(t0)}, the second \code{dy/dt(t0)}.}
  \item{N}{number of steps.}
  \item{zeta, theta}{two non-negative real numbers.}
  \item{...}{Additional parameters to be passed to the function.}
}
\details{
  Solves second order differential equations using the Newmark method
  on an equispaced grid of \code{N} steps.

  Function \code{f} must return a vector, whose elements hold the evaluation
  of \code{f(t,y)}, of the same dimension as \code{y0}. Each row in the
  solution array Y corresponds to a time returned in \code{t}.

  The method is `implicit' unless \code{zeta=theta=0}, second order if
  \code{theta=1/2} and first order accurate if \code{theta!=1/2}.
  \code{theta>=1/2} ensures stability.
  The condition set \code{theta=1/2; zeta=1/4} (the defaults) is a popular
  approach that is unconditionally stable, but introduces oscillatory
  spurious solutions on long time intervals.
  (For these simulations it is preferable to use \code{theta>1/2} and
  \code{zeta>(theta+1/2)^(1/2)}.)

  No attempt is made to catch any errors in the root finding functions.
}
\value{
  List with components \code{t} for grid (or `time') points between \code{t0}
  and \code{t1}, and \code{y} an n-by-2 matrix with solution variables in
  columns, i.e. each row contains one time stamp.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  This is for demonstration purposes only; for real problems or applications
  please use \code{ode23} or \code{rk4sys}.
}
\seealso{
  \code{\link{ode23}}, \code{\link{cranknic}}
}
\examples{
# Mathematical pendulum  m l y'' + m g sin(y) = 0
pendel <- function(t, y)  -sin(y[1])
sol <- newmark(pendel, 0, 4*pi, c(pi/4, 0))

\dontrun{
plot(sol$t, sol$y[, 1], type="l", col="blue",
     xlab="Time", ylab="Elongation/Speed", main="Mathematical Pendulum")
lines(sol$t, sol$y[, 2], col="darkgreen")
grid()}
}
\keyword{ ode }

\name{roots, polyroots}
\alias{roots}
\alias{rootsmult}
\alias{polyroots}
\title{Polynomial Roots}
\description{
  Computes the roots (and multiplicities) of a polynomial.
}
\usage{
  roots(p)
  polyroots(p, ntol = 1e-04, ztol = 1e-08)

  rootsmult(p, r, tol=1e-12)
}
\arguments{
  \item{p}{vector of real or complex numbers representing the polynomial.}
  \item{r}{a possible root of the polynomial.}
  \item{tol, ntol, ztol}{norm tolerance and accuracy for polyroots.}
}
\details{
  The function \code{roots} computes roots of a polynomial as eigenvalues 
  of the companion matrix. 

  \code{polyroots} attempts to refine the results of \code{roots} with special 
  attention to multiple roots. For a reference of this implementation see 
  F. C. Chang, "Solving multiple-root polynomials", 
  IEEE Antennas and Propagation Magazine Vol. 51, No. 6 (2010), pp. 151-155.

  \code{rootsmult} determines te order of a possible root \code{r}. As this 
  computation is problematic in double precision, the result should be taken 
  with a grain of salt.
}
\value{
  \code{roots} returns a vector holding the roots of the polynomial, 
  \code{rootsmult} the multiplicity of a root as an integer. And 
  \code{polyroots} returns a data frame witha column 'root' and a column 
  'mult' giving the multiplicity of that root.
}
\seealso{
  \code{\link{polyroot}}
}
\examples{
  roots(c(1, 0, 1, 0, 0))                     # 0 0 1i -1i
  p <- Poly(c(-2, -1, 0, 1, 2))               # 1*x^5 - 5*x^3 + 4*x
  roots(p)                                    # 0 -2  2 -1  1

  p <- Poly(c(rep(1, 4), rep(-1, 4), 0, 0))   # 1  0 -4  0  6  0 -4  0  1
  rootsmult(p, 1.0); rootsmult(p, -1.0)       # 4  4
  polyroots(p)
  ##   root mult
  ## 1    0    2
  ## 2    1    4
  ## 3   -1    4
}
\keyword{ math }

\name{matlab}
\alias{matlab}
\title{
  Matlab Compatibility
}
\description{
  Matlab compatibility.
}
\usage{
matlab()
}
\details{
  Lists all the functions and function names that emulate Matlab functions.
}
\value{
  Invisible NULL value.
}

\name{odregress}
\alias{odregress}
\title{
  Orthogonal Distance Regression
}
\description{
  Orthogonal Distance Regression (ODR, a.k.a. total least squares) 
  is a regression technique in which observational errors on both dependent 
  and independent variables are taken into account.
}
\usage{
odregress(x, y)
}
\arguments{
  \item{x}{matrix of independent variables.}
  \item{y}{vector representing dependent variable.}
}
\details{
  The implementation used here is applying PCA resp. the singular value 
  decomposition on the matrix of independent and dependent variables.
}
\value{
  Returns list with components \code{coeff} linear coefficients and intercept 
  term, \code{ssq} sum of squares of orthogonal distances to the linear line 
  or hyperplane, \code{err} the orthogonal distances, \code{fitted} the 
  fitted values,  \code{resid} the residuals, and \code{normal} the normal 
  vector to the hyperplane.
}
\references{
  Golub, G.H., and C.F. Van Loan (1980). An analysis of the total least 
  squares problem.\cr
  Numerical Analysis, Vol. 17, pp. 883-893.

  See ODRPACK or ODRPACK95 (TOMS Algorithm 676).\cr
  URL: https://docs.scipy.org/doc/external/odr_ams.pdf
}
\note{
  The ``geometric mean" regression not implemented because questionable.
}
\seealso{
  \code{\link{lm}}
}
\examples{
# Example in one dimension
x <- c(1.0, 0.6, 1.2, 1.4, 0.2)
y <- c(0.5, 0.3, 0.7, 1.0, 0.2)
odr <- odregress(x, y)
( cc <- odr$coeff )
# [1]  0.65145762 -0.03328271
lm(y ~ x)
# Coefficients:
# (Intercept)            x 
#    -0.01379      0.62931 

# Prediction
xnew <- seq(0, 1.5, by = 0.25)
( ynew <- cbind(xnew, 1) \%*\% cc )

\dontrun{
plot(x, y, xlim=c(0, 1.5), ylim=c(0, 1.2), main="Orthogonal Regression")
abline(lm(y ~ x), col="blue")
lines(c(0, 1.5), cc[1]*c(0, 1.5) + cc[2], col="red")
points(xnew, ynew, col = "red")
grid()}

# Example in two dimensions
x <- cbind(c(0.92, 0.89, 0.85, 0.05, 0.62, 0.55, 0.02, 0.73, 0.77, 0.57),
           c(0.66, 0.47, 0.40, 0.23, 0.17, 0.09, 0.92, 0.06, 0.09, 0.60))
y <- x \%*\% c(0.5, 1.5) + 1
odr <- odregress(x, y); odr
# $coeff
# [1] 0.5 1.5 1.0
# $ssq
# [1] 1.473336e-31

y <- y + rep(c(0.1, -0.1), 5)
odr <- odregress(x, y); odr
# $coeff
# [1] 0.5921823 1.6750269 0.8803822
# $ssq
# [1] 0.02168174

lm(y ~ x)
# Coefficients:
# (Intercept)           x1           x2  
#      0.9153       0.5671       1.6209  
}

\keyword{ fitting }

\name{spinterp}
\alias{spinterp}
\title{
  Monotone (Shape-Preserving) Interpolation
}
\description{
  Monotone interpolation preserves the monotonicity of the data being
  interpolated, and when the data points are also monotonic, the slopes 
  of the interpolant should also be monotonic.
}
\usage{
spinterp(x, y, xp)
}
\arguments{
  \item{x, y}{x- and y-coordinates of the points that shall be interpolated.}
  \item{xp}{points that should be interpolated.}
}
\details{
  This implementation follows a cubic version of the method of Delbourgo and
  Gregory. It yields `shaplier' curves than the Stineman method.

  The calculation of the slopes is according to recommended practice:

  - monotonic and convex --> harmonic\cr
  - monotonic and nonconvex --> geometric\cr
  - nonmonotonic and convex --> arithmetic\cr
  - nonmonotonic and nonconvex --> circles (Stineman) [not implemented]

  The choice of supplementary coefficients \code{r[i]} depends on whether
  the data are montonic or convex or both:

  - monotonic, but not convex\cr
  - otherwise

  and that can be detected from the data. The choice \code{r[i]=3} for all
  \code{i} results in the standard cubic Hermitean rational interpolation.
}
\value{
  The interpolated values at all the points of \code{xp}.
}
\references{
  Stan Wagon (2010). Mathematica in Action. Third Edition, Springer-Verlag.
}
\note{
  At the moment, the data need to be monotonic and the case of convexity
  is not considered.
}
\seealso{
  \code{stinepack::stinterp}, \code{demography::cm.interp}
}
\examples{
data1 <- list(x = c(1,2,3,5,6,8,9,11,12,14,15),
              y = c(rep(10,6), 10.5,15,50,60,95))
data2 <- list(x = c(0,1,4,6.5,9,10),
              y = c(10,4,2,1,3,10))
data3 <- list(x = c(7.99,8.09,8.19,8.7,9.2,10,12,15,20),
              y = c(0,0.000027629,0.00437498,0.169183,0.469428,
                    0.94374,0.998636,0.999919,0.999994))
data4 <- list(x = c(22,22.5,22.6,22.7,22.8,22.9,
                    23,23.1,23.2,23.3,23.4,23.5,24),
              y = c(523,543,550,557,565,575,
                    590,620,860,915,944,958,986))
data5 <- list(x = c(0,1.1,1.31,2.5,3.9,4.4,5.5,6,8,10.1),
              y = c(10.1,8,4.7,4.0,3.48,3.3,5.8,7,7.7,8.6))

data6 <- list(x = c(-0.8, -0.75, -0.3, 0.2, 0.5),
              y = c(-0.9,  0.3,   0.4, 0.5, 0.6))
data7 <- list(x = c(-1, -0.96, -0.88, -0.62, 0.13, 1),
              y = c(-1, -0.4,   0.3,   0.78, 0.91, 1))

data8 <- list(x = c(-1, -2/3, -1/3, 0.0, 1/3, 2/3, 1),
              y = c(-1, -(2/3)^3, -(1/3)^3, -(1/3)^3, (1/3)^3, (1/3)^3, 1))

\dontrun{
opr <- par(mfrow=c(2,2))

# These are well-known test cases:
D <- data1
plot(D, ylim=c(0, 100)); grid()
xp <- seq(1, 15, len=51); yp <- spinterp(D$x, D$y, xp)
lines(spline(D), col="blue")
lines(xp, yp, col="red")

D <- data3
plot(D, ylim=c(0, 1.2)); grid()
xp <- seq(8, 20, len=51); yp <- spinterp(D$x, D$y, xp)
lines(spline(D), col="blue")
lines(xp, yp, col="red")

D <- data4
plot(D); grid()
xp <- seq(22, 24, len=51); yp <- spinterp(D$x, D$y, xp)
lines(spline(D), col="blue")
lines(xp, yp, col="red")

# Fix a horizontal slope at the end points
D <- data8
x <- c(-1.05, D$x, 1.05); y <- c(-1, D$y, 1)
plot(D); grid()
xp <- seq(-1, 1, len=101); yp <- spinterp(x, y, xp)
lines(spline(D, n=101), col="blue")
lines(xp, yp, col="red")

par(opr)}
}
\keyword{ math }

\name{sigmoid}
\alias{sigmoid}
\alias{logit}
\title{
  Sigmoid Function
}
\description{
  Sigmoid function (aka sigmoidal curve or logistic function).
}
\usage{
sigmoid(x, a = 1, b = 0)
logit(x, a = 1, b = 0)
}
\arguments{
  \item{x}{numeric vector.}
  \item{a, b}{parameters.}
}
\details{
  The \code{sigmoidal} function with parameters \code{a,b} is the function
  \deqn{y = 1/(1 + e^{-a (x-b)})}

  The \code{sigmoid} function is also the solution of the ordinary 
  differentialequation
  \deqn{y' = y (1-y)}
  with \eqn{y(0) = 1/2} and has an indefinite integral \eqn{\ln(1 + e^x)}.

  The \code{logit} function is the inverse of the sigmoid function and is
  (therefore) omly defined between 0 and 1. Its definition is
  \deqn{y = b + 1/a log(x/(1-x))}

  The parameters must be scalars; if they are vectors, only the first
  component will be taken.
}
\value{
  Numeric/complex scalar or vector.
}
\examples{
x <- seq(-6, 6, length.out = 101)
y1 <- sigmoid(x)
y2 <- sigmoid(x, a = 2)
\dontrun{
plot(x, y1, type = "l", col = "darkblue", 
        xlab = "", ylab = "", main = "Sigmoid Function(s)")
lines(x, y2, col = "darkgreen")
grid()}

# The slope in 0 (in x = b) is a/4
# sigmf with slope 1 and range [-1, 1].
sigmf <- function(x) 2 * sigmoid(x, a = 2) - 1

# logit is the inverse of the sigmoid function
x <- c(-0.75, -0.25, 0.25, 0.75)
y <- sigmoid(x)
logit(y)        #=> -0.75 -0.25  0.25  0.75
}

\name{rand}
\alias{rand}
\alias{randn}
\alias{randi}
\alias{randsample}
\alias{rands}
\alias{randp}
\title{Create Random Matrices}
\description{
  Create random matrices or random points in a unit circle (Matlab style).
}
\usage{
rand(n = 1, m = n)
randn(n = 1, m = n)
randi(imax, n = 1, m = n)
randsample(n, k, w = NULL, replacement = FALSE)

rands(n = 1, N = 1, r = 1)
randp(n = 1, r = 1)
}
\arguments{
  \item{n, m}{integers specifying the size of the matrix}
  \item{imax}{integer or pair of integers}
  \item{k}{number of elements to return.}
  \item{w}{weight vector, used for discrete probabilities.}
  \item{replacement}{logical; sampling with or without replacement.}
  \item{N}{dimension of a shere, N=1 for the unit circle}
  \item{r}{radius of circle, default 1.}
}
\details{
  \code{rand()}, \code{randn()}, \code{randi()} create random matrices of
  size \code{n x m}, where the default is square matrices if \code{m} is
  missing.

  \code{rand()} uses the uniform distribution on \code{]0, 1[}, while 
  \code{randn()} uses the normal distribution with mean 0 and standard
  deviation 1.

  \code{randi()} generates integers between \code{imax[1]} and \code{imax[2]}
  resp. 1 and \code{imax}, if \code{imax} is a scalar.

  \code{randsample()} samples \code{k} elements from \code{1:n}, with or 
  without replacement, or returns a weighted sample (with replacement),
  using the weight vector \code{w} for probabilities.

  \code{rands()} generates uniformly random points on an \code{N}-sphere in 
  the \code{N+1}-dimensional space. To generate uniformly random points in the 
  \code{N}-dim. unit cube, take points in \code{S^{N-1}} und multiply with
  \code{unif(n)^(1/(N-1))}.

  \code{randp()} generates uniformly random points in the unit circle (or in
  a circle of radius r).
}
\value{
  Matrices of size \code{nxm} resp. a vector of length \code{n}.

  \code{randp()} returns a pair of values representing a point in the circle,
  or a matrix of size \code{(n,2)}. \code{rands()} returns a matrix of size
  \code{(n, N+1)} with all rows being vectors of length \code{1}.
}
\note{
  The Matlab style of setting a seed is not available; use R style
  \code{set.seed(...)}.
}
\references{
  Knuth, D. (1981). The Art of Computer programming; Vol. 2: Seminumerical
  Algorithms; Chapt. 3: Random Numbers. Addison-Wesley, Reading.
}
\seealso{
  \code{\link{set.seed}}
}
\examples{
rand(3)
randn(1, 5)
randi(c(1,6), 1, 10)
randsample(10, 5, replacement = TRUE, w = c(0,0,0, 1, 1, 1, 1, 0,0,0))

P <- rands(1000, N = 1, r = 2)
U <- randp(1000, 2)
\dontrun{
plot(U[, 1], U[, 2], pch = "+", asp = 1)
points(P, pch = ".")}

#-- v is 2 independent normally distributed elements
# u <- randp(1); r <- t(u) %*% u
# v <- sqrt(-2 * log(r)/r) * u

n <- 5000; U <- randp(n)
R <- apply(U*U, 1, sum)
P <- sqrt(-2 * log(R)/R) * U  # rnorm(2*n)
\dontrun{
hist(c(P))}
}
\keyword{ stat }

\name{fmincon}
\alias{fmincon}
\title{
  Minimize Nonlinear Constrained Multivariable Function.
}
\description{
  Find minimum of multivariable functions with nonlinear constraints.
}
\usage{
  fmincon(x0, fn, gr = NULL, ..., method = "SQP",
          A = NULL, b = NULL, Aeq = NULL, beq = NULL,
          lb = NULL, ub = NULL, hin = NULL, heq = NULL,
          tol = 1e-06, maxfeval = 10000, maxiter = 5000)
}
\arguments{
  \item{x0}{starting point.}
  \item{fn}{objective function to be minimized.}
  \item{gr}{gradient function of the objective; not used for SQP method.}
  \item{...}{additional parameters to be passed to the function.}
  \item{method}{method options 'SQP', 'auglag'; only 'SQP is implemented.}
  \item{A, b}{linear ineqality constraints of the form A x <= b .}
  \item{Aeq, beq}{linear eqality constraints of the form Aeq x = beq .}
  \item{lb, ub}{bounds constraints of the form lb <= x <= ub .}
  \item{hin}{nonlinear inequality constraints of the form hin(x) <= 0 .}
  \item{heq}{nonlinear equality constraints of the form heq(x) = 0 .}
  \item{tol}{relative tolerance.}
  \item{maxiter}{maximum number of iterations.}
  \item{maxfeval}{maximum number of function evaluations.}
}
\details{
  Wraps the function \code{solnl} in the 'NlcOptim' package. The
  underlying method is a Squential Quadratic Programming (SQP) approach.

  Constraints can be defined in different ways, as linear constraints in
  matrix form, as nonlinear functions, or as bounds constraints.
}
\value{
  List with the following components:
  \item{par}{the best minimum found.}
  \item{value}{function value at the minimum.}
  \item{convergence}{integer indicating the terminating situation.}
  \item{info}{parameter list describing the final situation.}
}
\references{
  J. Nocedal and S. J. Wright (2006). Numerical Optimization. Second
  Edition, Springer Science+Business Media, New York.
}
\note{
  \code{fmincon} mimics the Matlab function of the same name.
}
\author{
  Xianyan Chen for the package NlcOptim.
}
\seealso{
  \code{\link{fminsearch}}, \code{\link{fminunc}}, 
}
\examples{
# Classical Rosenbrock function
n <- 10; x0 <- rep(1/n, n)
fn <- function(x) {n <- length(x)
    x1 <- x[2:n]; x2 <- x[1:(n - 1)]
    sum(100 * (x1 - x2^2)^2 + (1 - x2)^2)
}
# Equality and inequality constraints
heq1 <- function(x) sum(x)-1.0
hin1 <- function(x) -1 * x
hin2 <- function(x) x - 0.5
ub <- rep(0.5, n)

# Apply constraint minimization
res <- fmincon(x0, fn, hin = hin1, heq = heq1)
res$par; res$value
}
\keyword{ optimize }

\name{shooting}
\alias{shooting}
\title{Shooting Method}
\description{
  The shooting method solves the boundary value problem for 
  second-order differential equations.
}
\usage{
shooting(f, t0, tfinal, y0, h, a, b,
         itermax = 20, tol = 1e-6, hmax = 0)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y'' = f(x, y, y')}.}
  \item{t0, tfinal}{start and end points of the interval.}
  \item{y0}{starting value of the solution.}
  \item{h}{function defining the boundary condition as a function at the
           end point of the interval.}
  \item{a, b}{two guesses of the derivative at the start point.}
  \item{itermax}{maximum number of iterations for the secant method.}
  \item{tol}{tolerance to be used for stopping and in the \code{ode45}
             solver.}
  \item{hmax}{maximal step size, to be passed to the solver.}
}
\details{
  A second-order differential equation is solved with boundary conditions
  \code{y(t0) = y0} at the start point of the interval, and
  \code{h(y(tfinal), dy/dt(tfinal)) = 0} at the end. The zero of
  \code{h} is found by a simple secant approach.
}
\value{
  Returns a list with two components, \code{t} for grid (or `time')
  points between \code{t0} and \code{tfinal}, and \code{y} the solution
  of the differential equation evaluated at these points.
}
\references{
  L. V. Fausett (2008). Applied Numerical Analysis Using MATLAB.
  Second Edition, Pearson Education Inc.
}
\note{
  Replacing secant with Newton's method would be an easy exercise.
  The same for replacing \code{ode45} with some other solver.
}
\seealso{
  \code{\link{bvp}}
}
\examples{
#-- Example 1
f <- function(t, y1, y2) -2*y1*y2
h <- function(u, v) u + v - 0.25

t0 <- 0; tfinal <- 1
y0 <- 1
sol <- shooting(f, t0, tfinal, y0, h, 0, 1)
\dontrun{
plot(sol$t, sol$y[, 1], type='l', ylim=c(-1, 1))
xs <- linspace(0, 1); ys <- 1/(xs+1)
lines(xs, ys, col="red")
lines(sol$t, sol$y[, 2], col="gray")
grid()}

#-- Example 2
f <- function(t, y1, y2) -y2^2 / y1
h <- function(u, v) u - 2
t0 <- 0; tfinal <- 1
y0 <- 1
sol <- shooting(f, t0, tfinal, y0, h, 0, 1)
}
\keyword{ode}

\name{hessian}
\alias{hessian}
\title{
  Hessian Matrix
}
\description{
  Numerically compute the Hessian matrix.
}
\usage{
hessian(f, x0, h = .Machine$double.eps^(1/4), ...)
}
\arguments{
  \item{f}{univariate function of several variables.}
  \item{x0}{point in \eqn{R^n}.}
  \item{h}{step size.}
  \item{...}{variables to be passed to \code{f}.}
}
\details{
  Computes the hessian matrix based on the three-point central difference
  formula, expanded to two variables.

  Assumes that the function has continuous partial derivatives.
}
\value{
  An n-by-n matrix with \eqn{\frac{\partial^2 f}{\partial x_i \partial x_j}}
  as (i, j) entry.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\seealso{
  \code{\link{hessdiag}}, \code{\link{hessvec}}, \code{\link{laplacian}}
}
\examples{
f <- function(x) cos(x[1] + x[2])
x0 <- c(0, 0)
hessian(f, x0)

f <- function(u) {
    x <- u[1]; y <- u[2]; z <- u[3]
    return(x^3 + y^2 + z^2 +12*x*y + 2*z)
}
x0 <- c(1,1,1)
hessian(f, x0)
}
\keyword{ math }

\name{rmserr}
\alias{rmserr}
\title{
  Accuracy Measures
}
\description{
  Calculates different accuracy measures, most prominently RMSE.
}
\usage{
rmserr(x, y, summary = FALSE)
}
\arguments{
  \item{x, y}{two vectors of real numbers}
  \item{summary}{logical; should a summary be printed to the screen?}
}
\details{
  Calculates six different measures of accuracy for two given vectors or
  sequences of real numbers:

  \tabular{ll}{
  MAE  \tab Mean Absolute Error\cr
  MSE  \tab Mean Squared Error\cr
  RMSE \tab Root Mean Squared Error\cr
  MAPE \tab Mean Absolute Percentage Error\cr
  LMSE \tab Normalized Mean Squared Error\cr
  rSTD \tab relative Standard Deviation
  }
}
\value{
  Returns a list with different accuracy measures.
}
\references{
  Gentle, J. E. (2009). Computational Statistics, section 10.3.
  Springer Science+Business Media LCC, New York.
}
\note{
  Often used in Data Mining for \emph{predicting} the accuracy of predictions.
}
\examples{
x <- rep(1, 10)
y <- rnorm(10, 1, 0.1)
rmserr(x, y, summary = TRUE)
}
\keyword{ stat }

\name{ifft}
\alias{ifft}
\alias{ifftshift}
\alias{fftshift}
\title{
  Inverse Fast Fourier Transformation
}
\description{
  Performs the inverse Fast Fourier Transform.
}
\usage{
ifft(x)

ifftshift(x)
fftshift(x)
}
\arguments{
  \item{x}{a real or complex vector}
}
\details{
  \code{ifft} returns the value of the normalized discrete, univariate,
  inverse Fast Fourier Transform of the values in \code{x}.

  \code{ifftshift} and \code{fftshift} shift the zero-component to the center
  of the spectrum, that is swap the left and right half of \code{x}.
}
\value{
  Real or complex vector of the same length.
}
\note{
  Almost an alias for R's \code{fft(x, inverse=TRUE)}, but dividing by
  \code{length(x)}.
}
\seealso{
  \code{\link{fft}}
}
\examples{
x <- c(1, 2, 3, 4)
(y <- fft(x))
ifft(x)
ifft(y)

##  Compute the derivative: F(df/dt) = (1i*k) * F(f)
#   hyperbolic secans f <- sech
df <- function(x) -sech(x) * tanh(x)
d2f <- function(x) sech(x) - 2*sech(x)^3
L <- 20                                 # domain [-L/2, L/2]
N <- 128                                # number of Fourier nodes
x <- linspace(-L/2, L/2, N+1)           # domain discretization
x <- x[1:N]                             # because of periodicity
dx <- x[2] - x[1]                       # finite difference
u <- sech(x)                            # hyperbolic secans
u1d <- df(x); u2d <- d2f(x)             # first and second derivative
ut <- fft(u)                            # discrete Fourier transform
k <- (2*pi/L)*fftshift((-N/2):(N/2-1))  # shifted frequencies
u1 <- Re(ifft((1i*k) * ut))             # inverse transform
u2 <- Re(ifft(-k^2 * ut))               # first and second derivative
\dontrun{
plot(x, u1d, type = "l", col = "blue")
points(x, u1)
grid()
figure()
plot(x, u2d, type = "l", col = "darkred")
points(x, u2)
grid()}
}
\keyword{ array }

\name{polyadd}
\alias{polyadd}
\title{Adding Polynomials}
\description{
  Add two polynomials given as vectors.
}
\usage{
  polyadd(p, q)
}
\arguments{
  \item{p, q}{Vectors representing two polynomials.}
}
\details{
  Polynomial addition realized simply by multiplying and summing up
  all the coefficients after extending vectors to the same length.
}
\value{
  Vector representing a polynomial.
}
\note{
  There is no such function in Matlab or Octave.
}
\seealso{
  \code{\link{conv}}
}
\examples{
polyadd(c(1, 1, 1), 1)
polyadd(c(1, 1, 1), c(0, 0, 1))
polyadd(c(-0.5, 1, -1), c(0.5, 0, 1))
}
\keyword{ math }

\name{rationalfit}
\alias{rationalfit}
\title{
  Rational Function Approximation
}
\description{
  Fitting a rational function to data points.
}
\usage{
rationalfit(x, y, d1 = 5, d2 = 5)
}
\arguments{
  \item{x}{numeric vector; points on the x-axis; needs to be sorted;
           at least three points required.}
  \item{y}{numeric vector; values of the assumed underlying function;
           \code{x} and \code{y} must be of the same length.}
  \item{d1, d2}{maximal degrees of numerator (\code{d1}) and denominator
                (\code{d1}) of the requested rational function.}
}
\details{
  A rational fit is a rational function of two polynomials \code{p1} and
  \code{p2} (of user specified degrees \code{d1} and \code{d2}) such that
  \code{p1(x)/p2(x)} approximates \code{y} in a least squares sense.

  \code{d1} and \code{d2} must be large enough to get a good fit and usually
  \code{d1=d2} gives good results
}
\value{
  List with components \code{p1} and \code{p2} for the polynomials in
  numerator and denominator of the rational function.
}
\note{
  This implementation will later be replaced by a `barycentric rational
  interpolation'.
}
\author{
  Copyright (c) 2006 by Paul Godfrey for a Matlab version available from the
  MatlabCentral under BSD license. R re-implementation by Hans W Borchers.
}
\references{
  Press, W. H., S. A. Teukolsky, W. T Vetterling, and B. P. Flannery (2007).
  Numerical Recipes: The Art of Numerical Computing. Third Edition,
  Cambridge University Press, New York.
}
\seealso{
  \code{\link{ratinterp}}
}
\examples{
\dontrun{
x <- linspace(0, 15, 151); y <- sin(x)/x
rA <- rationalfit(x, y, 10, 10); p1 <- rA$p1; p2 <- rA$p2
ys <- polyval(p1,x) / polyval(p2,x)
plot(x, y, type="l", col="blue", ylim=c(-0.5, 1.0))
points(x, Re(ys), col="red")  # max(abs(y-ys), na.rm=TRUE) < 1e-6
grid()

# Rational approximation of the Zeta function
x <- seq(-5, 5, by = 1/16)
y <- zeta(x)
rA <- rationalfit(x, y, 10, 10); p1 <- rA$p1; p2 <- rA$p2
ys <- polyval(p1,x) / polyval(p2,x)
plot(x, y, type="l", col="blue", ylim=c(-5, 5))
points(x, Re(ys), col="red")
grid()

# Rational approximation to the Gamma function
x <- seq(-5, 5, by = 1/32); y <- gamma(x)
rA <- rationalfit(x, y, 10, 10); p1 <- rA$p1; p2 <- rA$p2
ys <- polyval(p1,x) / polyval(p2,x)
plot(x, y, type="l", col = "blue")
points(x, Re(ys), col="red")
grid()}
}
\keyword{ fitting }

\name{brentDekker}
\alias{brentDekker}
\alias{brent}
\title{
  Brent-Dekker Root Finding Algorithm
}
\description{
  Find root of continuous function of one variable.
}
\usage{
brentDekker(fun, a, b, maxiter = 500, tol = 1e-12, ...)
brent(fun, a, b, maxiter = 500, tol = 1e-12, ...)
}
\arguments{
  \item{fun}{function whose root is to be found.}
  \item{a, b}{left and right end points of an interval;
              function values need to be of different sign at the endpoints.}
  \item{maxiter}{maximum number of iterations.}
  \item{tol}{relative tolerance.}
  \item{...}{additional arguments to be passed to the function.}
}
\details{
  \code{brentDekker} implements a version of the Brent-Dekker algorithm,
  a well known root finding algorithms for real, univariate, continuous
  functions. The Brent-Dekker approach is a clever combination of secant
  and bisection with quadratic interpolation.

  \code{brent} is simply an alias for \code{brentDekker}.
}
\value{
  \code{brent} returns a list with
    \item{root}{location of the root.}
    \item{f.root}{funtion value at the root.}
    \item{f.calls}{number of function calls.}
    \item{estim.prec}{estimated relative precision.}
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
  \code{\link{ridders}}, \code{\link{newtonRaphson}}
}
\examples{
# Legendre polynomial of degree 5
lp5 <- c(63, 0, -70, 0, 15, 0)/8
f <- function(x) polyval(lp5, x)
brent(f, 0.6, 1)                # 0.9061798459 correct to 12 places
}
\keyword{ math }

\name{polar}
\alias{polar}
\title{
  Polar Coordinate Plot (Matlab Style)
}
\description{
  The polar function accepts polar coordinates, plots them in a Cartesian
  plane, and draws the polar grid on the plane.
}
\usage{
polar(t, r, type="l", 
      col = "blue", grcol = "darkgrey", bxcol = "black",
      main = "Polar Plot", add = FALSE, ...)
}
\arguments{
    \item{t, r}{vectors specifying angle and radius.}
    \item{type}{type of the plot, lines, points, or no plotting.}
    \item{col}{color of the graph.}
    \item{grcol, bxcol}{color of grid anf box around the plot.}
    \item{main}{plot title.}
    \item{add}{logical; if true, the graph will be plotted into the
               coordinate system of an existing plot.}
    \item{...}{plotting parameters to be passed to the \code{points} function.}
}
\details{
    \code{polar(theta,rho)} creates a polar coordinate plot of the angle
    \code{theta} versus the radius \code{rho}. \code{theta} is the angle
    from the x-axis to the radius vector specified in radians; \code{rho}
    is the length of the radius vector.
}
\value{
  Generates a plot; no returns.
}
\examples{
\dontrun{
t <- deg2rad(seq(0, 360, by = 2))
polar(t, cos(2*t), bxcol = "white", main = "Sine and Cosine")
polar(t, sin(2*t), col = "red", add = TRUE)
}
}
\keyword{ graphs }

\name{muller}
\alias{muller}
\title{
  Muller's Method
}
\description{
  Muller's root finding method, similar to the secant method, using a 
  parabola through three points for approximating the curve.
}
\usage{
muller(f, p0, p1, p2 = NULL, maxiter = 100, tol = 1e-10)
}
\arguments{
  \item{f}{function whose root is to be found; function needs to be defined
           on the complex plain.}
  \item{p0, p1, p2}{three starting points, should enclose the assumed root.}
  \item{tol}{relative tolerance, change in successive iterates.}
  \item{maxiter}{maximum number of iterations.}
}
\details{
  Generalizes the secant method by using parabolic interpolation between
  three points. This technique can be used for any root-finding problem, 
  but is particularly useful for approximating the roots of polynomials,
  and for finding zeros of analytic functions in the complex plane.
}
\value{
  List of \code{root}, \code{fval}, \code{niter}, and \code{reltol}.
}
\note{
  Muller's method is considered to be (a bit) more robust than Newton's.
}
\references{
  Pseudo- and C code available from the `Numerical Recipes';
  pseudocode in the book `Numerical Analysis' by Burden and Faires (2011).
}
\seealso{
  \code{\link{secant}}, \code{\link{newtonRaphson}}, \code{\link{newtonsys}}
}
\examples{
muller(function(x) x^10 - 0.5, 0, 1)  # root: 0.9330329915368074

f <- function(x) x^4 - 3*x^3 + x^2 + x + 1
p0 <- 0.5; p1 <- -0.5; p2 <- 0.0
muller(f, p0, p1, p2)
## $root
## [1] -0.3390928-0.4466301i
## ...

##  Roots of complex functions:
fz <- function(z) sin(z)^2 + sqrt(z) - log(z)
muller(fz, 1, 1i, 1+1i)
## $root
## [1] 0.2555197+0.8948303i
## $fval
## [1] -4.440892e-16+0i
## $niter
## [1] 8
## $reltol
## [1] 3.656219e-13
}
\keyword{ math }

\name{poisson2disk}
\alias{poisson2disk}
\title{
  Poisson Disk Sampling
}
\description{
  Approximate Poisson disk distribution of points in a rectangle.
}
\usage{
poisson2disk(n, a = 1, b = 1, m = 10, info = TRUE)
}
\arguments{
  \item{n}{number of points to generate in a rectangle.}
  \item{a, b}{width and height of the rectangle}
  \item{m}{number of points to try in each step.}
  \item{info}{shall additional info be printed.}
}
\details{
  Realizes Mitchell's best-candidate algorithm for creating a Poisson disk
  distribution on a rectangle. Can be used for sampling, and will be more 
  appropriate in some sampling applications than uniform sampling or 
  grid-like sampling.

  With m = 1 uniform sampling will be generated.
}
\value{
  Returns the points as a matrix with two columns for x- and
  y-coordinates. Prints the minimal distance between points generated.
}
\references{
  A. Lagae and Ph. Dutre. A Comparison of Methods for Generating Poisson
  Disk Distributions. Computer Graphics Forum, Vol. 27(1), pp. 114-129,
  2008. URL: citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.192.5862
}
\note{
  Bridson's algorithm for Poisson disk sampling may be added later as an
  alternative. Also a variant that generates points in a circle.
}
\examples{
set.seed(1111)
P <- poisson2disk(n = 20, m = 10)
head(P)
##            [,1]       [,2]
## [1,] 0.46550264 0.41292487
## [2,] 0.13710541 0.98737065
## [3,] 0.96028255 0.83222920
## [4,] 0.06044078 0.09325431
## [5,] 0.78579426 0.09267546
## [6,] 0.49670274 0.99852771

# Plotting points
# plot(P, pch = 'x', col = "blue")
}
\keyword{ stat }

\name{aitken}
\alias{aitken}
\title{
  Aitken' Method
}
\description{
  Aitken's acceleration method.
}
\usage{
aitken(f, x0, nmax = 12, tol = 1e-8, ...)
}
\arguments{
  \item{f}{Function with a fixpoint.}
  \item{x0}{Starting value.}
  \item{nmax}{Maximum number of iterations.}
  \item{tol}{Relative tolerance.}
  \item{...}{Additional variables passed to f.}
}
\details{
  Aitken's acceleration method, or delta-squared process, is used for
  accelerating the rate of convergence of a sequence (from linear to
  quadratic), here applied to the fixed point iteration scheme of a
  function.
}
\value{
  The fixpoint (as found so far).
}
\references{
  Quarteroni, A., and F. Saleri (2006). Scientific Computing with Matlab
  and Octave. Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  Sometimes used to accerate Newton-Raphson (Steffensen's method).
}
\seealso{
  \code{\link{lambertWp}}
}
\examples{
# Find a zero of    f(x) = cos(x) - x*exp(x)
# as fixpoint of  phi(x) = x + (cos(x) - x*exp(x))/2
phi <- function(x) x + (cos(x) - x*exp(x))/2
aitken(phi, 0)  #=> 0.5177574
}
\keyword{ math }

\name{cranknic}
\alias{cranknic}
\title{
  Crank-Nicolson Method
}
\description{
  The Crank-Nicolson method for solving ordinary differential equations is a
  combination of the generic steps of the forward and backward Euler methods.
}
\usage{
cranknic(f, t0, t1, y0, ..., N = 100)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)};\cr
           defined as a function \eqn{R \times R^m \rightarrow R^m}, where
           \eqn{m} is the number of equations.}
  \item{t0, t1}{start and end points of the interval.}
  \item{y0}{starting values as row or column vector;
    for \eqn{m} equations \code{y0} needs to be a vector of length \code{m}.}
  \item{N}{number of steps.}
  \item{...}{Additional parameters to be passed to the function.}
}
\details{
  Adding together forward and backword Euler method in the \code{cranknic}
  method is by finding the root of the function merging these two formulas.

  No attempt is made to catch any errors in the root finding functions.
}
\value{
  List with components \code{t} for grid (or `time') points between \code{t0}
  and \code{t1}, and \code{y} an n-by-m matrix with solution variables in
  columns, i.e. each row contains one time stamp.
}
\references{
  Quarteroni, A., and F. Saleri (2006). Scientific Computing With MATLAB and
  Octave. Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  This is for demonstration purposes only; for real problems or applications
  please use \code{ode23} or \code{rkf54}.
}
\seealso{
  \code{\link{ode23}}, \code{\link{newmark}}
}
\examples{
##  Newton's example
f <- function(x, y) 1 - 3*x + y + x^2 + x*y
sol100  <- cranknic(f, 0, 1, 0, N = 100)
sol1000 <- cranknic(f, 0, 1, 0, N = 1000)

\dontrun{
# Euler's forward approach
feuler <- function(f, t0, t1, y0, n) {
    h <- (t1 - t0)/n;  x <- seq(t0, t1, by = h)
    y <- numeric(n+1); y[1] <- y0
    for (i in 1:n) y[i+1] <- y[i] + h * f(x[i], y[i])
    return(list(x = x, y = y))
}

solode <- ode23(f, 0, 1, 0)
soleul <- feuler(f, 0, 1, 0, 100)

plot(soleul$x, soleul$y, type = "l", col = "blue", 
     xlab = "", ylab = "", main = "Newton's example")
lines(solode$t, solode$y, col = "gray", lwd = 3)
lines(sol100$t, sol100$y, col = "red")
lines(sol1000$t, sol1000$y, col = "green")
grid()

##  System of differential equations
# "Herr und Hund"
fhh <- function(x, y) {
    y1 <- y[1]; y2 <- y[2]
    s <- sqrt(y1^2 + y2^2)
    dy1 <- 0.5 - 0.5*y1/s
    dy2 <- -0.5*y2/s
    return(c(dy1, dy2))
}

sol <- cranknic(fhh, 0, 60, c(0, 10))
plot(sol$y[, 1], sol$y[, 2], type = "l", col = "blue",
     xlab = "", ylab = "", main = '"Herr und Hund"')
grid()}
}
\keyword{ ode }

\name{str2num}
\alias{str2num}
\alias{num2str}
\title{
  Converting string to number (Matlab style)
}
\description{
  Functions for converting strings to numbers and numbers to strings.
}
\usage{
str2num(S)
num2str(A, fmt = 3)
}
\arguments{
  \item{S}{string containing numbers (in Matlab format).}
  \item{A}{numerical vector or matrix.}
  \item{fmt}{format string, or integer indicating number of decimals.}
}
\details{
  \code{str2num} converts a string containing numbers into a numerical object.
  The string can begin and end with '[' and ']', numbers can be separated with
  blanks or commas; a semicolon within the brackets indicates a new row for
  matrix input. When a semicolon appears behind the braces, no output is shown
  on the command line.

  \code{num2str} converts a numerical object, vector or matrix, into a 
  character object of the same size. \code{fmt} will be a format string for
  use in \code{sprintf}, or an integer \code{n} being used in \code{'\%.nf'}.
}
\value{
  Returns a vector or matrix of the same size, converted to strings,
  respectively numbers.
}
\seealso{
  \code{\link{sprintf}}
}
\examples{
str1 <- " [1 2 3; 4, 5, 6; 7,8,9]  "
str2num(str1)
# matrix(1:9, nrow = 3, ncol = 3, byrow = TRUE)

# str2 <- " [1 2 3; 45, 6; 7,8,9]  "
# str2num(str2)
# Error in str2num(str2) : 
#   All rows in Argument 's' must have the same length.

A <- matrix(c(pi, 0, exp(1), 1), 2, 2)
B <- num2str(A, 2); b <- dim(B)
B <- as.numeric(B); dim(B) <- b
B
#      [,1] [,2]
# [1,] 3.14 2.72
# [2,] 0.00 1.00
}
\keyword{ manip }

\name{histc}
\alias{histc}
\title{
  Histogram Count (Matlab style)
}
\description{
  Histogram-like counting.
}
\usage{
  histc(x, edges)
}
\arguments{
  \item{x}{numeric vector or matrix.}
  \item{edges}{numeric vector of grid points, must be monotonically
        non-decreasing.}
}
\details{
  \code{n = histc(x,edges)} counts the number of values in vector \code{x}
  that fall between the elements in the \code{edges} vector (which must
  contain monotonically nondecreasing values).
  \code{n} is a \code{length(edges)} vector containing these counts.

  If \code{x} is a matrix then \code{cnt} and \code{bin} are matrices too, and

  \code{ for (j in (1:n))  cnt[k,j] <- sum(bin[, j] == k) }
}
\value{
  returns a list with components \code{cnt} and \code{bin}.
  \code{n(k)} counts the number of values in \code{x} that lie between
  \code{edges(k) <= x(i) < edges(k+1)}. The last counts any values of \code{x}
  that match \code{edges(n)}. Values outside the values in edges are not
  counted. Use \code{-Inf} and \code{Inf} in edges to include all values.

  \code{bin[i]} returns \code{k} if \code{edges(k) <= x(i) < edges(k+1)},
  and \code{0} if \code{x[i]} lies outside the grid.
}
\seealso{
  \code{\link{hist}}, code{\link{histss}}, \code{\link{findInterval}}
}
\examples{
x <- seq(0.0, 1.0, by = 0.05)
e <- seq(0.1, 0.9, by = 0.10)
histc(x, e)
# $cnt
# [1] 2 2 2 2 2 2 2 2 1
# $bin
# [1] 0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 0 0

\dontrun{
# Compare
findInterval(x, e)
# [1] 0 0 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 9 9 9
findInterval(x, e, all.inside = TRUE)
# [1] 1 1 1 1 2 2 3 3 4 4 5 5 6 6 7 7 8 8 8 8 8
# cnt[i] <- sum(findInterval(x, e) == i)}

x <- matrix( c(0.5029, 0.2375, 0.2243, 0.8495,
               0.0532, 0.1644, 0.4215, 0.4135,
               0.7854, 0.0879, 0.1221, 0.6170), 3, 4, byrow = TRUE)
e <- seq(0.0, 1.0, by = 0.2)
histc(x, e)
# $cnt
#      [,1] [,2] [,3] [,4]
# [1,]    1    2    1    0
# [2,]    0    1    1    0
# [3,]    1    0    1    1
# [4,]    1    0    0    1
# [5,]    0    0    0    1
# [6,]    0    0    0    0
# 
# $bin
#      [,1] [,2] [,3] [,4]
# [1,]    3    2    2    5
# [2,]    1    1    3    3
# [3,]    4    1    1    4
}
\keyword{ manip }

\name{givens}
\alias{givens}
\title{Givens Rotation}
\description{
  Givens Rotations and QR decomposition
}
\usage{
givens(A)
}
\arguments{
  \item{A}{numeric square matrix.}
}
\details{
  \code{givens(A)} returns a QR decomposition (or factorization) of the
  square matrix \code{A} by applying unitary 2-by-2 matrices \code{U} such
  that \code{U * [xk;xl] = [x,0]} where \code{x=sqrt(xk^2+xl^2)}
}
\value{
  List with two matrices \code{Q} and \code{R}, \code{Q} orthonormal and
  \code{R} upper triangular, such that \code{A=Q\%*\%R}.
}
\references{
  Golub, G. H., and Ch. F. van Loan (1996). Matrix Computations.
  Third edition, John Hopkins University Press, Baltimore.
}
\seealso{
  \code{\link{householder}}
}
\examples{
##  QR decomposition
A <- matrix(c(0,-4,2, 6,-3,-2, 8,1,-1), 3, 3, byrow=TRUE)
gv <- givens(A)
(Q <- gv$Q); (R <- gv$R)
zapsmall(Q \%*\% R)

givens(magic(5))
}
\keyword{ array }

\name{Reshape}
\alias{Reshape}
\title{Reshape Matrix}
\description{
  Reshape matrix or vector.
}
\usage{
Reshape(a, n, m)
}
\arguments{
  \item{a}{matrix or vector}
  \item{n, m}{size of the result}
}
\details{
  \code{Reshape(a, n, m)} returns the n-by-m matrix whose elements are taken
  column-wise from \code{a}.

  An error results if \code{a} does not have \code{n*m} elements.
  If \code{m} is missing, it will be calculated from \code{n} and the
  size of \code{a}.
}   
\value{
  Returns matrix (or array) of the requested size containing the elements
  of \code{a}.
}
\examples{
a <- matrix(1:12, nrow=4, ncol=3)
Reshape(a, 6, 2)
Reshape(a, 6)     # the same
Reshape(a, 3, 4)
}
\keyword{array}

\name{cross}
\alias{cross}
\title{Vector Cross Product}
\description{
  Vector or cross product
}
\usage{
  cross(x, y)
}
\arguments{
  \item{x}{numeric vector or matrix}
  \item{y}{numeric vector or matrix}
}
\details{
  Computes the cross (or: vector) product of vectors in 3 dimensions.
  In case of matrices it takes the first dimension of length 3 and
  computes the cross product between corresponding columns or rows.

  The more general cross product of \code{n-1} vectors in n-dimensional
  space is realized as \code{crossn}.
}
\value{
  3-dim. vector if \code{x} and \code{<} are vectors, a matrix of
  3-dim. vectors if \code{x} and \code{y} are matrices themselves.
}
\seealso{
  \code{\link{dot}}, \code{\link{crossn}}
}
\examples{
  cross(c(1, 2, 3), c(4, 5, 6))  # -3  6 -3
}
\keyword{ array }

\name{quadv}
\alias{quadv}
\title{
  Vectorized Integration
}
\description{
  Vectorized adaptive Simpson integration.
}
\usage{
quadv(f, a, b, tol = .Machine$double.eps^(1/2), ...)
}
\arguments{
  \item{f}{univariate, vector-valued function; need not be vectorized.}
  \item{a, b}{endpoints of the integration interval.}
  \item{tol}{acuracy required for the recursion step.}
  \item{\dots}{further parameters to be passed to the function \code{f}.}
}
\details{
  Recursive version of the adaptive Simpson quadrature, recursion is based
  on the maximum of all components of the function calls.

  \code{quad} is not suitable for functions with singularities in the
  interval or at end points.
}
\value{
  Returns a list with components \code{Q} the integral value, \code{fcnt}
  the number of function calls, and \code{estim.prec} the estimated precision
  that normally will be much too high.
}
\seealso{
  \code{\link{quad}}
}
\examples{
##  Examples
f1 <- function(x) c(sin(x), cos(x))
quadv(f1, 0, pi)
# $Q
#  [1] 2.000000e+00 1.110223e-16
# $fcnt
#  [1] 65
# $estim.prec
#  [1] 4.321337e-07

f2 <- function(x) x^c(1:10)
quadv(f2, 0, 1, tol = 1e-12)
# $Q
#  [1] 0.50000000 0.33333333 0.25000000 0.20000000 0.16666667
#  [6] 0.14285714 0.12500000 0.11111111 0.10000000 0.09090909
# $fcnt
#  [1] 505
# $estim.prec
#  [1] 2.49e-10
}
\keyword{ math }

\name{randortho}
\alias{randortho}
\title{
  Generate Random Orthonormal or Unitary Matrix
}
\description{
  Generates random orthonormal or unitary matrix of size \code{n}.

  Will be needed in applications that explore high-dimensional data spaces,
  for example optimization procedures or Monte Carlo methods.
}
\usage{
randortho(n, type = c("orthonormal", "unitary"))
}
\arguments{
  \item{n}{positive integer.}
  \item{type}{orthonormal (i.e., real) or unitary (i.e., complex) matrix.}
}
\details{
  Generates orthonormal or unitary matrices \code{Q}, that is
  \code{t(Q)} resp \code{t(Conj(Q))} is inverse to \code{Q}. The randomness
  is meant with respect to the (additively invariant) Haar measure on
  \eqn{O(n)} resp. \eqn{U(n)}.

  Stewart (1980) describes a way to generate such matrices by applying
  Householder transformation. Here a simpler approach is taken based on the
  QR decomposition, see Mezzadri (2006),
}
\value{
  Orthogonal (or unitary) matrix \code{Q} of size \code{n}, that is
  \code{Q \%*\% t(Q)} resp. \code{Q \%*\% t(Conj(Q))} is the unit matrix
  of size \code{n}.
}
\note{
  \code{rortho} was deprecated and eventually removed in version 2.1.7.
}
\references{
G. W. Stewart (1980). ``The Efficient Generation of Random Orthogonal Matrices
with an Application to Condition Estimators''.
SIAM Journal on Numerical Analysis, Vol. 17, No. 3, pp. 403-409.

F. Mezzadri (2006). ``How to generate random matrices from the classical
compact groups''. NOTICES of the AMS, Vol. 54 (2007), 592-604.
(arxiv.org/abs/math-ph/0609050v2)
}
\examples{
Q <- randortho(5)
zapsmall(Q \%*\% t(Q))
zapsmall(t(Q) \%*\% Q)
}
\keyword{ math }

\name{expm}
\alias{expm}
\alias{logm}
\title{
  Matrix Exponential
}
\description{
  Computes the exponential of a matrix.
}
\usage{
expm(A, np = 128)

logm(A)
}
\arguments{
  \item{A}{numeric square matrix.}
  \item{np}{number of points to use on the unit circle.}
}
\details{
  For an analytic function \eqn{f} and a matrix \eqn{A} the expression
  \eqn{f(A)} can be computed by the Cauchy integral
  \deqn{f(A)  =  (2 \pi i)^{-1} \int_G (zI-A)^{-1} f(z) dz}
  where \eqn{G}  is a closed contour around the eigenvalues of \eqn{A}.

  Here this is achieved by taking G to be a circle and approximating the
  integral by the trapezoid rule.

  \code{logm} is a fake at the moment as it computes the matrix logarithm
  through taking the logarithm of its eigenvalues; will be replaced by an
  approach using Pade interpolation.

  Another more accurate and more reliable approach for computing these
  functions can be found in the R package `expm'.
}
\value{
  Matrix of the same size as \code{A}.
}
\references{
  Moler, C., and Ch. Van Loan (2003). Nineteen Dubious Ways to Compute
  the Exponential of a Matrix, Twenty-Five Years Later.
  SIAM Review, Vol. 1, No. 1, pp. 1--46.

  N. J. Higham (2008). Matrix Functions: Theory and Computation. SIAM
  Society for Industrial and Applied Mathematics.
}
\author{
  Idea and Matlab code for a cubic root by Nick Trefethen in his 
  ``10 digits 1 page'' project.
}
\note{
  This approach could be used for other analytic functions, but a point to
  consider is which branch to take (e.g., for the \code{logm} function).
}
\seealso{
  \code{expm::expm}
}
\examples{
##  The Ward test cases described in the help for expm::expm agree up to
##  10 digits with the values here and with results from Matlab's expm !
A <- matrix(c(-49, -64, 24, 31), 2, 2)
expm(A)
# -0.7357588 0.5518191
# -1.4715176 1.1036382

A1 <- matrix(c(10,  7,  8,  7,
                7,  5,  6,  5,
                8,  6, 10,  9,
                7,  5,  9, 10), nrow = 4, ncol = 4, byrow = TRUE)
expm(logm(A1))
logm(expm(A1))

##  System of linear differential equations: y' = M y  (y = c(y1, y2, y3))
M <- matrix(c(2,-1,1, 0,3,-1, 2,1,3), 3, 3, byrow=TRUE)
M
C1 <- 0.5; C2 <- 1.0; C3 <- 1.5
t  <- 2.0; Mt <- expm(t * M)
yt <- Mt %*% c(C1, C2, C3)       # [y1,y2,y3](t) = [C1, C2, C3] %*% t(Mt)
}
\keyword{ math }

\name{combs}
\alias{combs}
\title{
Generate Combinations
}
\description{
Generates all combinations of length \code{m} of a vector \code{a}.
}
\usage{
combs(a, m)
}
\arguments{
  \item{a}{numeric vector of some length \code{n}}
  \item{m}{integer with \code{0 <= m <= n}}
}
\details{
  \code{combs} generates combinations of length \code{n} of the elements
  of the vector \code{a}.
}
\value{
  matrix representing combinations of the elements of \code{a}
}
\seealso{
\code{\link{perms}}, \code{\link{randcomb}}
}
\examples{
combs(seq(2, 10, by=2), m = 3)
}
\keyword{ arith }

\name{horner}
\alias{horner}
\alias{hornerdefl}
\title{
Horner's Rule
}
\description{
  Compute the value of a polynomial via Horner's Rule.
}
\usage{
horner(p, x)
hornerdefl(p, x)
}
\arguments{
  \item{p}{Numeric vector representing a polynomial.}
  \item{x}{Numeric scalar, vector or matrix at which to evaluate the polynomial.}
}
\details{
  \code{horner} utilizes the Horner scheme to evaluate the polynomial and its
  first derivative at the same time.

  The polynomial \code{p = p_1*x^n + p_2*x^{n-1} + ... + p_n*x + p_{n+1}}
  is hereby represented by the vector \code{p_1, p_2, ..., p_n, p_{n+1}},
  i.e. from highest to lowest coefficient.

  \code{hornerdefl} uses a similar approach to return the value of \code{p}
  at \code{x} and a polynomial \code{q} that satisfies

  \code{p(t) = q(t) * (t - x) + r, r constant}

  which implies \code{r=0} if \code{x} is a root of \code{p}. This will allow
  for a repeated root finding of polynomials.
}
\value{
  \code{horner} returns a list with two elements, \code{list(y=..., dy=...)}
  where the first list elements returns the values of the polynomial, the
  second the values of its derivative at the point(s) \code{x}.

  \code{hornerdefl} returns a list \code{list(y=..., dy=...)} where \code{q}
  represents a polynomial, see above.
}
\note{
  For fast evaluation, there is no error checking for \code{p} and \code{x},
  which both must be numerical vectors
  (\code{x} can be a matrix in \code{horner}).
}
\references{
  Quarteroni, A., and Saleri, F. (2006) Scientific Computing with Matlab
  and Octave. Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
\code{\link{polyval}}
}
\examples{
x <- c(-2, -1, 0, 1, 2)
p <- c(1, 0, 1)  # polynomial x^2 + x, derivative 2*x
horner(p, x)$y   #=>  5  2  1  2  5
horner(p, x)$dy  #=> -4 -2  0  2  4

p <- Poly(c(1, 2, 3))  # roots 1, 2, 3
hornerdefl(p, 3)          # q = x^2- 3 x + 2  with roots 1, 2
}
\keyword{ math }

\name{polyApprox}
\alias{polyApprox}
\title{
  Polynomial Approximation
}
\description{
  Generate a polynomial approximation.
}
\usage{
polyApprox(f, a, b, n, ...)
}
\arguments{
  \item{f}{function to be approximated.}
  \item{a, b}{end points of the interval.}
  \item{n}{degree of the polynomial.}
  \item{...}{further variables for function \code{f}.}
}
\details{
  Uses the Chebyshev coefficients to derive polynomial coefficients.
}
\value{
  List with four components:
  \item{p}{the approximating polynomial.}
  \item{f}{a function evaluating this polynomial.}
  \item{cheb.coeff}{the Chebyshev coefficients.} 
  \item{estim.prec}{the estimated precision over the given interval.}
}
\references{
  Carothers, N. L. (1998). A Short Course on Approximation Theory.
  Bowling Green State University.
}
\note{
  The Chebyshev approximation is optimal in the sense of the \eqn{L^1} norm,
  but not as a solution of the \emph{minimax} problem; for this, an
  application of the Remez algorithm is needed.
}
\seealso{
\code{\link{chebApprox}}, \code{\link{polyfit}}
}
\examples{
##  Example
#   Polynomial approximation for sin
polyApprox(sin, -pi, pi, 9)
# $p
#  [1]  2.197296e-06  0.000000e+00 -1.937495e-04  0.000000e+00  8.317144e-03
#  [6]  0.000000e+00 -1.666468e-01  0.000000e+00  9.999961e-01  0.000000e+00
#
# $f
# function (x) 
# polyval(p, x)
#
# $cheb.coeff
#  [1]  0.06549943  0.00000000 -0.58518036  0.00000000  2.54520983  0.00000000
#  [7] -5.16709776  0.00000000  3.14158037  0.00000000
#
# $estim.prec
# [1] 1.151207e-05

\dontrun{
f <- polyApprox(sin, -pi, pi, 9)$f
x <- seq(-pi, pi, length.out = 100)
y <- sin(x) - f(x)
plot(x, y, type = "l", col = "blue")
grid()}
}
\keyword{ math }

\name{cutpoints}
\alias{cutpoints}
\title{
  Find Cutting Points
}
\description{
  Finds cutting points for vector s of real numbers.
}
\usage{
cutpoints(x, nmax = 8, quant = 0.95)
}
\arguments{
  \item{x}{vector of real values.}
  \item{nmax}{the maximum number of cutting points to choose}
  \item{quant}{quantile of the gaps to consider for cuts.}
}
\details{
  Finds cutting points for vector s of real numbers, based on the gaps in
  the values of the vector. The number of cutting points is derived from a
  quantile of gaps in the values. The user can set a lower limit for this
  number of gaps.
}
\value{
  Returns a list with components \code{cutp}, the cutting points selected,
  and \code{cutd}, the gap between values of \code{x} at this cutting point.
}
\note{
  Automatically finding cutting points is often requested in Data Mining.
  If a target attribute is available, Quinlan's C5.0 does a very good job
  here. Unfortunately, the `C5.0' package (of the R-Forge project ``Rulebased
  Models'') is quite cumbersome to use.
}
\references{
  Witten, I. H., and E. Frank (2005). Data Mining: Practical Machine
  Learning Tools and Techniques. Morgan Kaufmann Publishers, San Francisco.
}
\seealso{
  \code{\link{cut}}
}
\examples{
N <- 100; x <- sort(runif(N))
cp <- cutpoints(x, 6, 0.9)
n <- length(cp$cutp)

# Print out
nocp <- rle(findInterval(x, c(-Inf, cp$cutp, Inf)))$lengths
cbind(c(-Inf, cp$cutp), c(cp$cutp, Inf), nocp)

# Define a factor from the cutting points
fx <- cut(x, breaks = c(-Inf, cp$cutp, Inf))

\dontrun{
# Plot points and cutting points
plot(x, rep(0, N), col="gray", ann = FALSE)
points(cp$cutp, rep(0, n), pch="|", col=2)

# Compare with k-means clustering
km <- kmeans(x, n)
points(x, rep(0, N), col = km$cluster, pch = "+")

##  A 2-dimensional example
x <- y <- c()
for (i in 1:9) {
  for (j in 1:9) {
    x <- c(x, i + rnorm(20, 0, 0.2))
    y <- c(y, j + rnorm(20, 0, 0.2))
  }
}
cpx <- cutpoints(x, 8, 0)
cpy <- cutpoints(y, 8, 0)

plot(x, y, pch = 18, col=rgb(0.5,0.5,0.5), axes=FALSE, ann=FALSE)
for (xi in cpx$cutp) abline(v=xi, col=2, lty=2)
for (yi in cpy$cutp) abline(h=yi, col=2, lty=2)

km <- kmeans(cbind(x, y), 81)
points(x, y, col=km$cluster)
}
}
\keyword{ timeseries }

\name{pchip}
\alias{pchip}
\alias{pchipfun}
\title{Hermitean Interpolation Polynomials}
\description{
  Piecewise Cubic Hermitean Interpolation Polynomials.
}
\usage{
pchip(xi, yi, x)

pchipfun(xi, yi)
}
\arguments{
  \item{xi, yi}{x- and y-coordinates of supporting nodes.}
  \item{x}{x-coordinates of interpolation points.}
}
\details{
  \code{pchip} is a `shape-preserving' piecewise cubic Hermite polynomial
  approach that apptempts to determine slopes such that function values do
  not overshoot data values.
  \code{pchipfun} is a wrapper around \code{pchip} and returns a function.
  Both \code{pchip} and the function returned by \code{pchipfun} are vectorized.

  \code{xi} and \code{yi} must be vectors of the same length greater or equal 3
  (for cubic interpolation to be possible), and \code{xi} must be sorted.
  \code{pchip} can be applied to points outside \code{[min(xi), max(xi)]}, but
  the result does not make much sense outside this interval.
}
\value{
  Values of interpolated data at points \code{x}.
}
\references{
  Moler, C. (2004). Numerical Computing with Matlab. Revised Reprint, SIAM.
}
\author{
  Copyright of the Matlab version from Cleve Moler in his book ``Numerical
  Computing with Matlab'', Chapter 3 on Interpolation.
  R Version by Hans W. Borchers, 2011.
}
\seealso{
  \code{\link{interp1}}
}
\examples{
x <- c(1, 2, 3, 4, 5, 6)
y <- c(16, 18, 21, 17, 15, 12)
pchip(x, y, seq(1, 6, by = 0.5))
fp <- pchipfun(x, y)
fp(seq(1, 6, by = 0.5))

\dontrun{
plot(x, y, col="red", xlim=c(0,7), ylim=c(10,22),
     main = "Spline and 'pchip' Interpolation")
grid()

xs <- seq(1, 6, len=51)
ys <- interp1(x, y, xs, "spline")
lines(xs, ys, col="cyan")
yp <- pchip(x, y, xs)
lines(xs, yp, col = "magenta")}
}
\keyword{ math }

\name{linprog}
\alias{linprog}
\title{
  Linear Programming Solver
}
\description{
  Solves simple linear programming problems, allowing for inequality and
  equality constraints as well as lower and upper bounds.
}
\usage{
linprog(cc, A = NULL, b = NULL, Aeq = NULL, beq = NULL,
        lb = NULL, ub = NULL, x0 = NULL, I0 = NULL,
        bigM = 100, maxiter = 20, maximize = FALSE)
}
\arguments{
  \item{cc}{defines the linear objective function.}
  \item{A}{matrix representing the inequality constraints \code{A x <= b}.}
  \item{b}{vector, right hand side of the inequalities.}
  \item{Aeq}{matrix representing the equality constraints \code{Aeq x <= beq}.}
  \item{beq}{vector, right hand side of the inequalities.}
  \item{lb}{lower bounds, if not \code{NULL} must all be greater or equal 0.}
  \item{ub}{upper bounds, if not \code{NULL} must all be greater or equal \code{lb}.}
  \item{x0}{feasible base vector, will not be used at the moment.}
  \item{I0}{index set of \code{x0}, will not be used at the moment.}
  \item{bigM}{big-M constant, will be used for finding a base vector.}
  \item{maxiter}{maximum number of iterations.}
  \item{maximize}{logical; shall the objective be minimized or maximized?}
}
\details{
  Solves linear programming problems of the form \eqn{min cc' * x}
  such that
  \deqn{A * x \le b}
  \deqn{A_{eq} * x = b_{eq}}
  \deqn{lb \le x \le ub}
}
\value{
  List with
  \itemize{
    \item{\code{x}} the solution vector.
    \item{\code{fval}} the value at the optimal solution.
    \item{\code{errno}, \code{mesage}} the error number and message.
  }
}
\references{
  Vanderbei, R. J. (2001). Linear Programming: Foundations and Extensions.
  Princeton University Press.

  Eiselt, H. A., and C.-L. Sandblom (2012). Operations Research: 
  A Model-based Approach. Springer-Verlag, Berlin Heidelberg.
}
\author{
  HwB <hwborchers@googlemail.com>
}
\note{
  This is a first version that will be unstable at times. For real linear
  programming problems use package \code{lpSolve}.
}
\seealso{
  \code{linprog::solveLP}, \code{lpSolve::lp}
}
\examples{
##  Examples from the book "Operations research - A Model-based Approach"
#-- production planning
cc <- c(5, 3.5, 4.5)
Ain <- matrix(c(3, 5, 4,
                6, 1, 3), 2, 3, byrow=TRUE)
bin <- c(540, 480)
linprog(cc, A = Ain, b = bin, maximize = TRUE)
# $x     20   0 120
# $fval  640

#-- diet problem
cc <- c(1.59, 2.19, 2.99)
Ain <- matrix(c(-250, -380, -257,
                 250,  380,  257,
                  13,   31,   28), 3, 3, byrow = TRUE)
bin <- c(-1800, 2200, 100)
linprog(cc, A = Ain, b = bin)

#-- employee scheduling
cc <- c(1, 1, 1, 1, 1, 1)
A <- (-1)*matrix(c(1, 0, 0, 0, 0, 1,
                   1, 1, 0, 0, 0, 0,
                   0, 1, 1, 0, 0, 0,
                   0, 0, 1, 1, 0, 0,
                   0, 0, 0, 1, 1, 0,
                   0, 0, 0, 0, 1, 1), 6, 6, byrow = TRUE)
b <- -c(17, 9, 19, 12, 5, 8)
linprog(cc, A, b)

#-- inventory models
cc <- c(1, 1.1, 1.2, 1.25, 0.05, 0.15, 0.15)
Aeq <- matrix(c(1, 0, 0, 0, -1,  0,  0,
                0, 1, 0, 0,  1, -1,  0,
                0, 0, 1, 0,  0,  1, -1,
                0, 0, 0, 1,  0,  0,  1), 4, 7, byrow = TRUE)
beq <- c(60, 70, 130, 150)
ub <- c(120, 140, 150, 140, Inf, Inf, Inf)
linprog(cc, Aeq = Aeq, beq = beq, ub = ub)

#-- allocation problem
cc <- c(1, 1, 1, 1, 1)
A <- matrix(c(-5,    0,    0,    0,    0,
               0, -4.5,    0,    0,    0,
               0,    0, -5.5,    0,    0,
               0,    0,    0, -3.5,    0,
               0,    0,    0,    0, -5.5,
               5,    0,    0,    0,    0,
               0,  4.5,    0,    0,    0,
               0,    0,  5.5,    0,    0,
               0,    0,    0,  3.5,    0,
               0,    0,    0,    0,  5.5,
              -5, -4.5, -5.5, -3.5, -5.5,
              10, 10.0, 10.0, 10.0, 10.0,
              0.2, 0.2,  0.2, -1.0,  0.2), 13, 5, byrow = TRUE)
b <- c(-50, -55, -60, -50, -50, rep(100, 5), -5*64, 700, 0)
# linprog(cc, A = A, b = b)
lb <- b[1:5] / diag(A[1:5, ])
ub <- b[6:10] / diag(A[6:10, ])
A1 <- A[11:13, ]
b1 <- b[11:13]
linprog(cc, A1, b1, lb = lb, ub = ub)

#-- transportation problem
cc <- c(1, 7, 4, 2, 3, 5)
Aeq <- matrix(c(1, 1, 1, 0, 0, 0,
                0, 0, 0, 1, 1, 1,
                1, 0, 0, 1, 0, 0,
                0, 1, 0, 0, 1, 0,
                0, 0, 1, 0, 0, 1), 5, 6, byrow = TRUE)
beq <- c(30, 20, 15, 25, 10)
linprog(cc, Aeq = Aeq, beq = beq)
}
\keyword{ optimize }

\name{eps}
\alias{eps}
\title{
  Floating Point Relative Accuracy
}
\description{
  Distance from 1.0 to the next largest double-precision number.
}
\usage{
eps(x = 1.0)
}
\arguments{
  \item{x}{scalar or numerical vector or matrix.}
}
\details{
  \code{d=eps(x)} is the positive distance from \code{abs(x)} to the next 
  larger floating point number in double precision.

  If \code{x} is an array, \code{eps(x)} will return \code{eps(max(abs(x)))}.
}
\value{
  Returns a scalar.
}
\examples{
for (i in -5:5) cat(eps(10^i), "\n")
# 1.694066e-21 
# 1.355253e-20 
# 2.168404e-19 
# 1.734723e-18 
# 1.387779e-17 
# 2.220446e-16 
# 1.776357e-15 
# 1.421085e-14 
# 1.136868e-13 
# 1.818989e-12 
# 1.455192e-11 
}
\keyword{ arith }

\name{fminunc}
\alias{fminunc}
\title{
  Minimize Unconstrained Multivariable Function
}
\description{
  Find minimum of unconstrained multivariable functions.
}
\usage{
  fminunc(x0, fn, gr = NULL, ...,
          tol = 1e-08, maxiter = 0, maxfeval = 0)
}
\arguments{
  \item{x0}{starting point.}
  \item{fn}{objective function to be minimized.}
  \item{gr}{gradient function of the objective.}
  \item{...}{additional parameters to be passed to the function.}
  \item{tol}{relative tolerance.}
  \item{maxiter}{maximum number of iterations.}
  \item{maxfeval}{maximum number of function evaluations.}
}
\details{
  The method used here for unconstrained minimization is a variant of a
  "variable metric" resp. quasi-Newton approach.
}
\value{
  List with the following components:
  \item{par}{the best minimum found.}
  \item{value}{function value at the minimum.}
  \item{counts}{number of function and gradient calls.}
  \item{convergence}{integer indicating the terminating situation.}
  \item{message}{description of the final situation.}
}
\references{
  J. Nocedal and S. J. Wright (2006). Numerical Optimization. Second
  Edition, Springer Science+Business Media, New York.
}
\note{
  \code{fminunc} mimics the Matlab function of the same name.
}
\author{
  The "variable metric" code provided by John Nash (package Rvmmin),
  stripped-down version by Hans W. Borchers.
}
\seealso{
  \code{\link{fminsearch}}, \code{\link{fmincon}}, 
}
\examples{
  fun = function(x) 
          x[1]*exp(-(x[1]^2 + x[2]^2)) + (x[1]^2 + x[2]^2)/20
  fminunc(x0 = c(1, 2), fun)
  ## xmin: c(-0.6691, 0.0000); fmin: -0.4052
}
\keyword{ optimize }

\name{cart2sph}
\alias{cart2sph}
\alias{sph2cart}
\alias{cart2pol}
\alias{pol2cart}
\title{
  Coordinate Transformations
}
\description{
  Transforms between cartesian, spherical, polar, and cylindrical coordinate
  systems in two and three dimensions.
}
\usage{
cart2sph(xyz)
sph2cart(tpr)
cart2pol(xyz)
pol2cart(prz)
}
\arguments{
  \item{xyz}{cartesian coordinates x, y, z as vector or matrix.}
  \item{tpr}{spherical coordinates theta, phi, and r as vector or matrix.}
  \item{prz}{polar coordinates phi, r or cylindrical coordinates phi, r, z
             as vector or matrix.}
}
\details{
  The spherical coordinate system used here consists of

  - \code{theta}, azimuth angle relative to the positive x-axis
  
  - \code{phi},   elevation angle measured from the reference plane
  
  - \code{r},     radial distance. i.e., distance to the origin

The polar angle, measured with respect from the polar axis, is then 
calculated as \code{pi/2 - phi}.
Note that this convention differs slightly from spherical coordinates 
\code{(r, theta, phi)} as often used in mathematics, where \code{phi} 
is the polar angle.

  \code{cart2sph} returns spherical coordinates as (theta, phi, r), and
  \code{sph2cart} expects them in this sequence.

  \code{cart2pol} returns polar coordinates (phi, r) if \code{length(xyz)==2}
  and cylindrical coordinates (phi, r, z) else. \code{pol2cart} needs them in
  this sequence and length.

  To go from cylindrical to cartesian coordinates, transform to cartesian
  coordinates first --- or write your own function, see the examples.

  All transformation functions are vectorized.
}
\value{
  All functions return a (2- or 3-dimensional) vector representing a point
  in the requested coordinate system, or a matrix with 2 or 3 named columns
  where is row represents a point. The columns are named accordingly.
}
\note{
  In Matlab these functions accept two or three variables and return two or
  three values. In R it did not appear appropriate to return coordinates as
  a list.

  These functions should be vectorized in the sense that they accept will
  accept matrices with number of rows or columns equal to 2 or 3.
}
\examples{
x <- 0.5*cos(pi/6); y <- 0.5*sin(pi/6); z <- sqrt(1 - x^2 - y^2)
(s <-cart2sph(c(x, y, z)))      # 0.5235988 1.0471976 1.0000000
sph2cart(s)                     # 0.4330127 0.2500000 0.8660254

cart2pol(c(1,1))                # 0.7853982 1.4142136
cart2pol(c(1,1,0))              # 0.7853982 1.4142136 0.0000000
pol2cart(c(pi/2, 1))            # 6.123234e-17 1.000000e+00
pol2cart(c(pi/4, 1, 1))         # 0.7071068 0.7071068 1.0000000

##  Transform spherical to cylindrical coordinates and vice versa
#   sph2cyl <- function(th.ph.r) cart2pol(sph2cart(th.ph.r))
#   cyl2sph <- function(phi.r.z) cart2sph(pol2cart(phi.r.z))
}
\keyword{ math }

\name{clear, who(s), ver}
\alias{clear}
\alias{ver}
\alias{who}
\alias{whos}
\title{
Clear function (Matlab style)
}
\description{
  List or remove items from workspace, or display system information.
}
\usage{
clear(lst)
ver()

who()
whos()
}
\arguments{
  \item{lst}{Character vector of names of variables in the global environment.}
}
\details{
  Remove these or all items from the workspace, i.e. the global environment,
  and freeing up system memory.

  \code{who()}  lists all items on the workspace.\cr
  \code{whos()} lists all items and their class and size.

  \code{ver()} displays version and license information for R and all the
  loaded packages.
}
\value{
  Invisibly NULL.
}
\seealso{
  \code{\link{ls}}, \code{\link{rm}}, \code{\link{sessionInfo}}
}
\examples{
# clear()  # DON'T
# who()
# whos()
# ver()
}
\keyword{ utilities }

\name{disp,beep}
\alias{disp}
\alias{beep}
\title{
Utility functions (Matlab style)
}
\description{
  Display text or array, or produce beep sound.
}
\usage{
disp(...)
beep()
}
\arguments{
  \item{...}{any R object that can be printed.}
}
\details{
  Display text or array, or produces the computer's default beep sound
  using `cat' with closing newline.
}
\value{
  beep() returns NULL invisibly, disp() displays with newline.
}
\examples{
disp("Some text, and numbers:", pi, exp(1))
# beep()
}
\keyword{ utilities }

\name{akimaInterp}
\alias{akimaInterp}
\title{
  Univariate Akima Interpolation
}
\description{
  Interpolate smooth curve through given points on a plane.
}
\usage{
  akimaInterp(x, y, xi)
}
\arguments{
  \item{x, y}{x/y-coordinates of (irregular) grid points defining the curve.}
  \item{xi}{x-coordinates of points where to interpolate.}
}
\details{
  Implementation of Akima's univariate interpolation method, built from
  piecewise third order polynomials. There is no need to solve large systems
  of equations, and the method is therefore computationally very efficient.
}
\value{
  Returns the interpolated values at the points \code{xi} as a vector.
}
\note{
  There is also a 2-dimensional version in package `akima'.
}
\author{
  Matlab code by H. Shamsundar under BSC License; re-implementation in R
  by Hans W Borchers.
}
\references{
  Akima, H. (1970). A New Method of Interpolation and Smooth Curve Fitting
  Based on Local Procedures. Journal of the ACM, Vol. 17(4), pp 589-602.

  Hyman, J. (1983). Accurate Monotonicity Preserving Cubic Interpolation.
  SIAM J. Sci. Stat. Comput., Vol. 4(4), pp. 645-654.

  Akima, H. (1996). Algorithm 760: Rectangular-Grid-Data Surface Fitting that
  Has the Accurancy of a Bicubic Polynomial. ACM TOMS Vol. 22(3), pp. 357-361.

  Akima, H. (1996). Algorithm 761: Scattered-Data Surface Fitting that
  Has the Accuracy of a Cubic Polynomial. ACM TOMS, Vol. 22(3), pp. 362-371.
}
\seealso{
  \code{\link{kriging}}, \code{akima::aspline}, \code{akima::interp}
}
\examples{
x <- c( 0,  2,  3,  5,  6,  8,  9,   11, 12, 14, 15)
y <- c(10, 10, 10, 10, 10, 10, 10.5, 15, 50, 60, 85)
xs <- seq(12, 14, 0.5)          # 12.0 12.5     13.0     13.5     14.0
ys <- akimaInterp(x, y, xs)     # 50.0 54.57405 54.84360 55.19135 60.0
xs; ys

\dontrun{
plot(x, y, col="blue", main = "Akima Interpolation")
xi <- linspace(0,15,51)
yi <- akimaInterp(x, y, xi)
lines(xi, yi, col = "darkred")
grid()}
}
\keyword{ fitting }

\name{invlap}
\alias{invlap}
\title{
  Inverse Laplacian
}
\description{
  Numerical inversion of Laplace transforms.
}
\usage{
invlap(Fs, t1, t2, nnt, a = 6, ns = 20, nd = 19)
}
\arguments{
  \item{Fs}{function representing the function to be inverse-transformed.}
  \item{t1, t2}{end points of the interval.}
  \item{nnt}{number of grid points between t1 and t2.}
  \item{a}{shift parameter; it is recommended to preserve value 6.}
  \item{ns, nd}{further parameters, increasing them leads to lower error.}
}
\details{
  The transform Fs may be any reasonable function of a variable s^a, where a 
  is a real exponent. Thus, the function \code{invlap} can solve fractional 
  problems and invert functions Fs containing (ir)rational or transcendental 
  expressions.
}
\value{
  Returns a list with components \code{x} the x-coordinates and \code{y}
  the y-coordinates representing the original function in the interval
  \code{[t1,t2]}.
}
\note{
  Based on a presentation in the first reference. The function \code{invlap} 
  on MatlabCentral (by ) served as guide. The Talbot procedure from the 
  second reference could be an interesting alternative.
}
\references{
  J. Valsa and L. Brancik (1998). Approximate Formulae for Numerical Inversion 
  of Laplace Transforms. Intern. Journal of Numerical Modelling: Electronic 
  Networks, Devices and Fields, Vol. 11, (1998), pp. 153-166.

  L.N.Trefethen, J.A.C.Weideman, and T.Schmelzer (2006). Talbot quadratures 
  and rational approximations. BIT. Numerical Mathematics, 46(3):653--670.
}
\examples{
Fs <- function(s) 1/(s^2 + 1)           # sine function
Li <- invlap(Fs, 0, 2*pi, 100)

\dontrun{
plot(Li[[1]], Li[[2]], type = "l", col = "blue"); grid()

Fs <- function(s) tanh(s)/s             # step function
L1 <- invlap(Fs, 0.01, 20, 1000)
plot(L1[[1]], L1[[2]], type = "l", col = "blue")
L2 <- invlap(Fs, 0.01, 20, 2000, 6, 280, 59)
lines(L2[[1]], L2[[2]], col="darkred"); grid()

Fs <- function(s) 1/(sqrt(s)*s)
L1 <- invlap(Fs, 0.01, 5, 200, 6, 40, 20)
plot(L1[[1]], L1[[2]], type = "l", col = "blue"); grid()

Fs <- function(s) 1/(s^2 - 1)           # hyperbolic sine function
Li <- invlap(Fs, 0, 2*pi, 100)
plot(Li[[1]], Li[[2]], type = "l", col = "blue"); grid()

Fs <- function(s) 1/s/(s + 1)           # exponential approach
Li <- invlap(Fs, 0, 2*pi, 100)
plot(Li[[1]], Li[[2]], type = "l", col = "blue"); grid()

gamma <- 0.577215664901532              # Euler-Mascheroni constant
Fs <- function(s) -1/s * (log(s)+gamma) # natural logarithm
Li <- invlap(Fs, 0, 2*pi, 100)
plot(Li[[1]], Li[[2]], type = "l", col = "blue"); grid()

Fs <- function(s) (20.5+3.7343*s^1.15)/(21.5+3.7343*s^1.15+0.8*s^2.2+0.5*s^0.9)/s
L1 <- invlap(Fs, 0.01, 5, 200, 6, 40, 20)
plot(L1[[1]], L1[[2]], type = "l", col = "blue")
grid()}
}
\keyword{ timeseries }

\name{hilb}
\alias{hilb}
\title{Hilbert Matrix}
\description{
  Generate Hilbert matrix of dimension n
}
\usage{
  hilb(n)
}
\arguments{
  \item{n}{positive integer specifying the dimension of the Hilbert matrix}
}
\details{
  Generate the Hilbert matrix \code{H} of dimension \code{n} with elements
  \code{H[i, j] = 1/(i+j-1)}.

  (Note: This matrix is ill-conditioned, see e.g. \code{det(hilb(6))}.)
}
\value{
  matrix of dimension n
}
\seealso{
  \code{\link{vander}}
}
\examples{
  hilb(5)
}
\keyword{ specmat }

\name{ppfit}
\alias{ppfit}
\title{
  Piecewise Polynomial Fit
}
\description{
  Piecewise linear or cubic fitting.
}
\usage{
ppfit(x, y, xi, method = c("linear", "cubic"))
}
\arguments{
  \item{x, y}{x-, y-coordinates of given points.}
  \item{xi}{x-coordinates of the choosen support nodes.}
  \item{method}{interpolation method,
                can be `constant', `linear', or `cubic' (i.e., `spline').}
}
\details{
  \code{ppfit} fits a piece-wise polynomial to the input independent and 
    dependent variables,\code{x} and \code{y}, respectively. A weighted linear 
    least squares solution is provided. The weighting vector \code{w} must be 
    of the same size as the input variables.
}
\value{
  Returns a \code{pp} (i.e., piecewise polynomial) structure.
}
\note{
  Following an idea of Copyright (c) 2012 Ben Abbott, Martin Helm for Octave.
}
\seealso{
  \code{\link{mkpp}}, \code{\link{ppval}}
}
\examples{
x <- 0:39
y <- c(  8.8500,  32.0775,  74.7375, 107.6775, 132.0975, 156.6675,
       169.0650, 187.5375, 202.2575, 198.0750, 225.9600, 204.3550,
       233.8125, 204.5925, 232.3625, 204.7550, 220.1925, 199.5875,
       197.3025, 175.3050, 218.6325, 163.0775, 170.6625, 148.2850,
       154.5950, 135.4050, 138.8600, 125.6750, 118.8450,  99.2675,
       129.1675,  91.1925,  89.7000,  76.8825,  83.6625,  74.1950,
        73.9125,  55.8750,  59.8675,  48.1900)

xi <- linspace(0, 39, 8)
pplin <- ppfit(x, y, xi)  # method = "linear"
ppcub <- ppfit(x, y, xi, method = "cubic")

\dontrun{
plot(x, y, type = "b", main = "Piecewise polynomial approximation")
xs <- linspace(0, 39, 100)
yslin <- ppval(pplin, xs)
yscub <- ppval(ppcub, xs)
lines(xs, yscub, col="red",lwd = 2)
lines(xs, yslin, col="blue")
grid()}
}
\keyword{ fitting }

\name{strcmp}
\alias{strcmp}
\alias{strcmpi}
\title{String Comparison}
\description{
  Compare two strings or character vectors for equality.
}
\usage{
strcmp(s1, s2)
strcmpi(s1, s2)
}
\arguments{
  \item{s1, s2}{character strings or vectors}
}
\details{
  For \code{strcmp} comparisons are case-sensitive, while for \code{strcmpi}
  the are case-insensitive. Leading and trailing blanks do count.
}
\value{
  logical, i.e. \code{TRUE} if \code{s1} and \code{s2} have the same length
  as character vectors and all elements are equal as character strings, else
  \code{FALSE}.
}
\seealso{
\code{\link{strcat}}
}
\examples{
strcmp(c("yes", "no"), c("yes", "no"))
strcmpi(c("yes", "no"), c("Yes", "No"))
}
\keyword{ string }

\name{barylag2d}
\alias{barylag2d}
\title{2-D Barycentric Lagrange Interpolation}
\description{
  Two-dimensional barycentric Lagrange interpolation.
}
\usage{
barylag2d(F, xn, yn, xf, yf)
}
\arguments{
  \item{F}{matrix representing values of a function in two dimensions.}
  \item{xn, yn}{x- and y-coordinates of supporting nodes.}
  \item{xf, yf}{x- and y-coordinates of an interpolating grid..}
}
\details{
  Well-known Lagrange interpolation using barycentric coordinates, here
  extended to two dimensions. The function is completely vectorized.

  x-coordinates run downwards in F, y-coordinates to the right. That conforms
  to the usage in image or contour plots, see the example below.
}
\value{
  Matrix of size \code{length(xf)}-by-\code{length(yf)} giving the interpolated
  values at al the grid points \code{(xf, yf)}.
}
\references{
  Berrut, J.-P., and L. Nick Trefethen (2004). ``Barycentric Lagrange
  Interpolation''. SIAM Review, Vol. 46(3), pp.501--517.
}
\note{
  Copyright (c) 2004 Greg von Winckel of a Matlab function under BSD license;
  translation to R by Hans W Borchers with permission.
}
\seealso{
  \code{\link{interp2}}, \code{\link{barylag}}
}
\examples{
##  Example from R-help
xn <- c(4.05, 4.10, 4.15, 4.20, 4.25, 4.30, 4.35)
yn <- c(60.0, 67.5, 75.0, 82.5, 90.0)
foo <- matrix(c(
        -137.8379, -158.8240, -165.4389, -166.4026, -166.2593,
        -152.1720, -167.3145, -171.1368, -170.9200, -170.4605,
        -162.2264, -172.5862, -174.1460, -172.9923, -172.2861,
        -168.7746, -175.2218, -174.9667, -173.0803, -172.1853,
        -172.4453, -175.7163, -174.0223, -171.5739, -170.5384,
        -173.7736, -174.4891, -171.6713, -168.8025, -167.6662,
        -173.2124, -171.8940, -168.2149, -165.0431, -163.8390),
            nrow = 7, ncol = 5, byrow = TRUE)
xf <- c(4.075, 4.1)
yf <- c(63.75, 67.25)
barylag2d(foo, xn, yn, xf, yf)
#  -156.7964 -163.1753
#  -161.7495 -167.0424

# Find the minimum of the underlying function
bar <- function(xy) barylag2d(foo, xn, yn, xy[1], xy[2])
optim(c(4.25, 67.5), bar)  # "Nelder-Mead"
# $par
# 4.230547 68.522747
# $value
# -175.7959

\dontrun{
# Image and contour plots
image(xn, yn, foo)
contour(xn, yn, foo, col="white", add = TRUE)
xs <- seq(4.05, 4.35, length.out = 51)
ys <- seq(60.0, 90.0, length.out = 51)
zz <- barylag2d(foo, xn, yn, xs, ys)
contour(xs, ys, zz, nlevels = 20, add = TRUE)
contour(xs, ys, zz, levels=c(-175, -175.5), add = TRUE)
points(4.23, 68.52)}
}
\keyword{ math }

\name{fzsolve}
\alias{fzsolve}
\title{
  Complex Root Finding
}
\description{
  Find the root of a complex function
}
\usage{
fzsolve(fz, z0)
}
\arguments{
  \item{fz}{complex(-analytic) function.}
  \item{z0}{complex point near the assumed root.}
}
\details{
  \code{fzsolve} tries to find the root of the complex and relatively
  smooth (i.e., analytic) function near a starting point.

  The function is considered as real function \code{R^2 --> R^2} and the
  \code{newtonsys} function is applied.
}
\value{
  Complex point with sufficiently small function value.
}
\seealso{
  \code{\link{newtonsys}}
}
\examples{
fz <- function(z) sin(z)^2 + sqrt(z) - log(z)
fzsolve(fz, 1+1i)
# 0.2555197+0.8948303i
}
\keyword{ math }

\name{cubicspline}
\alias{cubicspline}
\title{
  Interpolating Cubic Spline
}
\description{
  Computes the natural interpolation cubic spline.
}
\usage{
cubicspline(x, y, xi = NULL, endp2nd = FALSE, der = c(0, 0))
}
\arguments{
  \item{x, y}{x- and y-coordinates of points to be interpolated.}
  \item{xi}{x-coordinates of points at which the interpolation is to be
            performed.}
  \item{endp2nd}{logical; if true, the derivatives at the endpoints are
                 prescribed by \code{der}.}
  \item{der}{a two-components vector prescribing derivatives at endpoints.}
}
\details{
  \code{cubicspline} computes the values at \code{xi} of the natural 
  interpolating cubic spline that interpolate the values \code{y} at the
  nodes \code{x}. The derivatives at the endpoints can be prescribed.
}
\value{
  Returns either the interpolated values at the points \code{xi} or, if
  \code{is.null(xi)}, the piecewise polynomial that represents the spline.
}
\note{
  From the piecewise polynomial returned one can easily generate the spline
  function, see the examples.
}
\references{
  Quarteroni, Q., and F. Saleri (2006). Scientific Computing with Matlab
  and Octave. Springer-Verlag Berlin Heidelberg.
}
\seealso{
  \code{\link{spline}}
}
\examples{
##  Example: Average temperatures at different latitudes
x <- seq(-55, 65, by = 10)
y <- c(-3.25, -3.37, -3.35, -3.20, -3.12, -3.02, -3.02,
       -3.07, -3.17, -3.32, -3.30, -3.22, -3.10)
xs <- seq(-60, 70, by = 1)

# Generate a function for this
pp <- cubicspline(x, y)
ppfun <- function(xs) ppval(pp, xs)

\dontrun{
# Plot with and without endpoint correction
plot(x, y, col = "darkblue",
           xlim = c(-60, 70), ylim = c(-3.5, -2.8),
           xlab = "Latitude", ylab = "Temp. Difference",
           main = "Earth Temperatures per Latitude")
lines(spline(x, y), col = "darkgray")
grid()

ys <- cubicspline(x, y, xs, endp2nd = TRUE)     # der = 0 at endpoints
lines(xs, ys, col = "red")
ys <- cubicspline(x, y, xs)                     # no endpoint condition
lines(xs, ys, col = "darkred")
}
}
\keyword{ fitting }

\name{geo_median}
\alias{geo_median}
\title{
  Geometric Median
}
\description{
  Compute the ``geometric median'' of points in n-dimensional space, that is
  the point with the least sum of (Euclidean) distances to all these points.
}
\usage{
geo_median(P, tol = 1e-07, maxiter = 200)
}
\arguments{
  \item{P}{matrix of points, \code{x_i}-coordinates in the ith column.}
  \item{tol}{relative tolerance.}
  \item{maxiter}{maximum number of iterations.}
}
\details{
  The task is solved applying an iterative process, known as Weiszfeld's 
  algorithm. The solution is unique whenever the points are not collinear.

  If the dimension is 1 (one column), the median will be returned.
}
\value{
  Returns a list with components \code{p} the coordinates of the solution 
  point, \code{d} the sum of distances to all the sample points, \code{reltol} 
  the relative tolerance of the iterative process, and \code{niter} the 
  number of iterations.
}
\references{
  See Wikipedia's entry on ``Geometric median''.
}
\note{
  This is also known as the ``1-median problem'' and can be generalized to the 
  ``k-median problem'' for k cluster centers; 
  see \code{kcca} in the `flexclust' package.
}
\seealso{
  \code{\link{L1linreg}}
}
\examples{
# Generate 100 points on the unit sphere in the 10-dim. space
set.seed(1001)
P <- rands(n=100, N=9)
( sol <- geo_median(P) )
# $p
#  [1] -0.009481361 -0.007643410 -0.001252910  0.006437703 -0.019982885 -0.045337987
#  [7]  0.036249563  0.003232175  0.035040592  0.046713023
# $d
# [1] 99.6638
# $reltol
# [1] 3.069063e-08
# $niter
# [1] 10
}

\keyword{ optimize }

\name{and, or}
\alias{and}
\alias{or}
\title{
  Logical AND, OR (Matlab Style)
}
\description{
  \code{and(l, k)} resp. \code{or(l, k)} the same as \code{(l & k) + 0} resp.
  \code{(l | k) + 0}.
}
\usage{
and(l, k)
or(l, k)
}
\arguments{
  \item{l, k}{Arrays.}
}
\details{
  Performs a logical operation of arrays \code{l} and \code{k} and returns an
  array containing elements set to either 1 (\code{TRUE}) or 0 (\code{FALSE}),
  that is in Matlab style.
}
\value{
  Logical vector.
}
\examples{
A <- matrix(c(0.5,  0.5,  0,    0.75, 0,
              0.5,  0,    0.75, 0.05, 0.85,
              0.35, 0,    0,    0,    0.01,
              0.5,  0.65, 0.65, 0.05, 0), 4, 5, byrow=TRUE)
B <- matrix(c( 0, 1, 0, 1, 0,
               1, 1, 1, 0, 1,
               0, 1, 1, 1, 0,
               0, 1, 0, 0, 1), 4, 5, byrow=TRUE)

and(A, B)
or(A, B)
}
\keyword{ logic }

\name{fnorm}
\alias{fnorm}
\title{
Function Norm
}
\description{
  The \code{fnorm} function calculates several different types of function
  norms for depending on the argument \code{p}. 
}
\usage{
fnorm(f, g, x1, x2, p = 2, npoints = 100)
}
\arguments{
  \item{f, g}{functions given by name or string.}
  \item{x1, x2}{endpoints of the interval.}
  \item{p}{Numeric scalar or Inf, -Inf; default is 2.}
  \item{npoints}{number of points to be considered in the interval.}
}
\details{
  \code{fnorm} returns a scalar that gives some measure of the distance
  of two functions \code{f} and \code{g} on the interval \code{[x1, x2]}.

  It takes \code{npoints} equidistant points in the interval, computes the
  function values for \code{f} and \code{g} and applies \code{Norm} to
  their difference.

  Especially \code{p=Inf} returns the maximum norm,
  while \code{fnorm(f, g, x1, x2, p = 1, npoints) / npoints}
  would return some estimate of the mean distance.
}
\value{
  Numeric scalar (or \code{Inf}), or \code{NA} if one of these functions
  returns \code{NA}.
}
\note{
  Another kind of `mean' distance could be calculated by integrating the
  difference \code{f-g} and dividing through the length of the interval.
}
\seealso{
  \code{\link{Norm}}
}
\examples{
xp <- seq(-1, 1, length.out = 6)
yp <- runge(xp)
p5 <- polyfit(xp, yp, 5)
f5 <- function(x) polyval(p5, x)
fnorm(runge, f5, -1, 1, p = Inf)                  #=> 0.4303246
fnorm(runge, f5, -1, 1, p = Inf, npoints = 1000)  #=> 0.4326690

# Compute mean distance using fnorm:
fnorm(runge, f5, -1, 1, p = 1, 1000) / 1000       #=> 0.1094193

# Compute mean distance by integration:
fn <- function(x) abs(runge(x) - f5(x))
integrate(fn, -1, 1)$value / 2                    #=> 0.1095285
}
\keyword{ math }

\name{chebPoly}
\alias{chebPoly}
\title{Chebyshev Polynomials}
\description{
  Chebyshev polynomials and their values.
}
\usage{
chebPoly(n, x = NULL)
}
\arguments{
  \item{n}{an integer \code{>= 0}.}
  \item{x}{a numeric vector, possibly empty; default \code{NULL}.}
}
\details{
  Determines an (n+1)-ny-(n+1)-Matrix of Chebyshev polynomials up to degree n.

  The coefficients of the first \code{n} Chebyshev polynomials are computed
  using the recursion formula. For computing any values at points the well
  known Horner schema is applied.
}
\value{
  If \code{x} is \code{NULL}, returns an \code{(n+1)}-by-\code{(n+1)} matrix
  with the coefficients of the first Chebyshev polynomials from \code{0} to
  \code{n}, one polynomial per row with coefficients from highest to lowest
  order.

  If \code{x} is a numeric vector, returns the values of the \code{n}-th
  Chebyshev polynomial at the points of \code{x}.
}
\references{
  Carothers, N. L. (1998). A Short Course on Approximation Theory.
  Bowling Green State University.
}
\note{
  See the ``Chebfun Project'' <https://www.chebfun.org/> by
  Nick Trefethen.
}
\seealso{
\code{\link{chebCoeff}}, \code{\link{chebApprox}}
}
\examples{
chebPoly(6)

\dontrun{
##  Plot 6 Chebyshev Polynomials
plot(0, 0, type="n", xlim=c(-1, 1), ylim=c(-1.2, 1.2),
    main="Chebyshev Polynomials for n=1..6", xlab="x", ylab="y")
grid()
x <- seq(-1, 1, length.out = 101)
for (i in 1:6) {
    y <- chebPoly(i, x)
    lines(x, y, col=i)
}
legend(x = 0.55, y = 1.2, c("n=1", "n=2", "n=3", "n=4", "n=5", "n=6"),
    col = 1:6, lty = 1, bg="whitesmoke", cex = 0.75)
}
}
\keyword{ math }

\name{charpoly}
\alias{charpoly}
\title{
  Characteristic Polynomial
}
\description{
  Computes the characteristic polynomial (and the inverse of the matrix, if
  requested) using the Faddeew-Leverrier method.
}
\usage{
charpoly(a, info = FALSE)
}
\arguments{
  \item{a}{quadratic matrix; size should not be much larger than 100.}
  \item{info}{logical; if true, the inverse matrix will also be reported.}
}
\details{
  Computes the characteristic polynomial recursively. In the last step
  the determinant and the inverse matrix can be determined without any
  extra cost (if the matrix is not singular).
}
\value{
  Either the characteristic polynomial as numeric vector, or a list with
  components \code{cp}, the characteristic polynomial, \code{det}, the
  determinant, and \code{inv}, the inverse matrix, will be returned.
}
\references{
  Hou, S.-H. (1998). Classroom Note: A Simple Proof of the Leverrier--Faddeev
  Characteristic Polynomial Algorithm, SIAM Review, 40(3), pp. 706--709.
}
\examples{
a <- magic(5)
A <- charpoly(a, info = TRUE)
A$cp
roots(A$cp)
A$det
zapsmall(A$inv \%*\% a)
}
\keyword{ array }

\name{sumalt}
\alias{sumalt}
\title{
  Alternating Series Acceleration
}
\description{
  Computes the value of an (infinite) alternating sum applying an
  acceleration method found by Cohen et al.
}
\usage{
sumalt(f_alt, n)
}
\arguments{
  \item{f_alt}{a funktion of \code{k=0..Inf} that returns element
               \code{a_k} of the infinite alternating series.}
  \item{n}{number of elements of the series used for calculating.}
}
\details{
  Computes the sum of an alternating series (whose entries are strictly
  decreasing), applying the acceleration method developped by H. Cohen,
  F. Rodriguez Villegas, and Don Zagier.

  For example, to compute the Leibniz series (see below) to 15 digits 
  exactly, \code{10^15} summands of the series will be needed. This
  accelleration approach here will only need about 20 of them!
}
\value{
  Returns an approximation of the series value.
}
\references{
  Henri Cohen, F. Rodriguez Villegas, and Don Zagier.
  Convergence Acceleration of Alternating Series.
  Experimental Mathematics, Vol. 9 (2000).
}
\author{
  Implemented by Hans W Borchers.
}
\seealso{
  \code{\link{aitken}}
}
\examples{
# Beispiel: Leibniz-Reihe 1 - 1/3 + 1/5 - 1/7 +- ...
a_pi4 <- function(k) (-1)^k / (2*k + 1)
sumalt(a_pi4, 20)  # 0.7853981633974484 = pi/4 + eps()

# Beispiel: Van Wijngaarden transform needs 60 terms
n <- 60; N <- 0:n
a <- cumsum((-1)^N / (2*N+1))
for (i in 1:n) {
    a <- (a[1:(n-i+1)] + a[2:(n-i+2)]) / 2
}
a - pi/4  # 0.7853981633974483

# Beispiel: 1 - 1/2^2 + 1/3^2 - 1/4^2 +- ...
b_alt <- function(k) (-1)^k / (k+1)^2
sumalt(b_alt, 20)  # 0.8224670334241133 = pi^2/12 + eps()

\dontrun{
# Dirichlet eta() function: eta(s) = 1/1^s - 1/2^s + 1/3^s -+ ...
  eta_ <- function(s) {
    eta_alt <- function(k) (-1)^k / (k+1)^s
    sumalt(eta_alt, 30)
  }
  eta_(1)                       # 0.6931471805599453 = log(2)
  abs(eta_(1+1i) - eta(1+1i))   # 1.24e-16
}
}
\keyword{ math }

\name{coth,csch,sech, etc.}
\alias{coth}
\alias{csch}
\alias{sech}
\alias{acoth}
\alias{acsch}
\alias{asech}
\title{
  More Hyperbolic Functions
}
\description{
  More hyperbolic functions not available in R.
}
\usage{
coth(z)
csch(z)
sech(z)
acoth(z)
acsch(z)
asech(z)
}
\arguments{
  \item{z}{numeric or complex scalar or vector.}
}
\details{
  The usual hyperbolic cotangens, cosecans, and secans functions and
  their inverses, computed through the other well known -- in R --
  hyperbolic sine, cosine, and tangens functions.
}
\value{
  Result vector of numeric or complex values.
}
\note{
  These function names are available in Matlab, that is the reason they have
  been added to the `pracma' package.
}
\seealso{
  Trigonometric and hyperbolic functions in R.
}
\examples{
coth(1+1i)      # 0.8680 - 0.2176i
csch(1+1i)      # 0.3039 - 0.6215i
sech(1+1i)      # 0.4983 - 0.5911i
acoth(1+1i)     # 0.4024 - 0.5536i
acsch(1+1i)     # 0.5306 - 0.4523i
asech(1+1i)     # 0.5306 - 1.1185i
}
\keyword{ math }

\name{rosser}
\alias{rosser}
\title{Rosser Matrix}
\description{
Generate the Rosser matrix.
}
\usage{
rosser()
}
\details{
This is a classic symmetric eigenvalue test problem.
It has a double eigenvalue, three nearly equal eigenvalues, dominant
eigenvalues of opposite sign, a zero eigenvalue, and a small, nonzero
eigenvalue.
}
\value{
matrix of size 8 x 8
}
\seealso{
  \code{\link{wilkinson}}
}
\examples{
rosser()
}
\keyword{ specmat }

\name{nextpow2}
\alias{nextpow2}
\title{Next Power of 2}
\description{
  Smallest power of 2 greater than the argument.
}
\usage{
  nextpow2(x)
}
\arguments{
  \item{x}{numeric scalar, vector, or matrix}

}
\details{
  Computes the smalest integer \code{n} such that \eqn{abs(x) \le 2^n}.
  IF \code{x} is a vector or matrix, returns the result component-wise.
  For negative or complex values, the absolute value will be taken.
}
\value{
  an integer \code{n} such that \eqn{x \le 2^n}.
}
\seealso{
  \code{\link{pow2}}
}
\examples{
  nextpow2(10)                   #=> 4
  nextpow2(1:10)                 #=> 0 1 2 2 3 3 3 3 4 4
  nextpow2(-2^10)                #=> 10
  nextpow2(.Machine$double.eps)  #=> -52
}
\keyword{ arith }

\name{quad2d}
\alias{quad2d}
\title{
  2-d Gaussian Quadrature
}
\description{
  Two-dimensional Gaussian Quadrature.
}
\usage{
quad2d(f, xa, xb, ya, yb, n = 32, ...)
}
\arguments{
  \item{f}{function of two variables; needs to be vectorized.}
  \item{xa, ya}{lower limits of integration; must be finite.}
  \item{xb, yb}{upper limits of integration; must be finite.}
  \item{n}{number of nodes used per direction.}
  \item{\dots}{additional arguments to be passed to \code{f}.}
}
\details{
  Extends the Gaussian quadrature to two dimensions by computing two sets
  of nodes and weights (in x- and y-direction), evaluating the function
  on this grid and multiplying weights appropriately.

  The function \code{f} needs to be vectorized in both variables such that
  \code{f(X, Y)} returns a matrix when \code{X} an \code{Y} are matrices
  (of the same size).

  \code{quad} is not suitable for functions with singularities.
}
\value{
  A single numerical value, the computed integral.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  The extension of Gaussian quadrature to two dimensions is obvious, but
  see also the example `integral2d.m' at Nick Trefethens ``10 digits 1 page''.
}
\seealso{
\code{\link{quad}}, \code{cubature::adaptIntegrate}
}
\examples{
##  Example:  f(x, y) = (y+1)*exp(x)*sin(16*y-4*(x+1)^2)
f <- function(x, y)
        (y+1) * exp(x) * sin(16*y-4*(x+1)^2)
# this is even faster than cubature::adaptIntegral():
quad2d(f, -1, 1, -1, 1)
# 0.0179515583236958  # true value 0.01795155832370

##  Volume of the sphere: use polar coordinates
f0 <- function(x, y) sqrt(1 - x^2 - y^2)  # for x^2 + y^2 <= 1
fp <- function(x, y) y * f0(y*cos(x), y*sin(x))
quad2d(fp, 0, 2*pi, 0, 1, n = 101)  # 2.09439597740074
2/3 * pi                            # 2.0943951023932
}
\keyword{ math }

\name{pinv}
\alias{pinv}
\title{
  Pseudoinverse or Generalized Inverse
}
\description{
  Computes the Moore-Penrose generalized inverse of a matrix.
}
\usage{
pinv(A, tol=.Machine$double.eps^(2/3))
}
\arguments{
  \item{A}{real or complex matrix}
  \item{tol}{tolerance used for assuming an eigenvalue is zero.}
}
\details{
  Compute the generalized inverse \code{B} of a matrix \code{A} using the
  singular value decomposition \code{svd()}. This generalized invers is
  characterized by this equation: \code{A \%*\% B \%*\% A == A}

  The pseudoinverse \eqn{B} solves the problem to minimize
  \eqn{|A x - b|} by setting \eqn{x = B b}

  \code{s <- svd(A)}\cr
  \code{D <- diag(s\$d)}\cr
  \code{Dinv <- diag(1/s\$d)}\cr
  \code{U <- s\$u; V <- s\$v}\cr
  \code{X = V Dinv t(U)}

  Thus \code{B} is computed as \code{s$v \%*\% diag(1/s$d) \%*\% t(s$u)}.
}
\value{
  The pseudoinverse of matrix \code{A}.
}
\references{
  Ben-Israel, A., and Th. N. E. Greville (2003). Generalized Inverses - 
  Theory and Applications. Springer-Verlag, New York.
}
\note{
  The pseudoinverse or `generalized inverse' is also provided by the function
  \code{ginv()} in package `MASS'. It is included in a somewhat simplified
  way to be independent of that package.
}
\seealso{
\code{MASS::ginv}
}
\examples{
A <- matrix(c(7,6,4,8,10,11,12,9,3,5,1,2), 3, 4)
b <- apply(A, 1, sum)  # 32 16 20  row sum
x <- pinv(A) \%*\% b
A \%*\% x              #=> 32 16 20  as column vector
}
\keyword{ array }

\name{ndims}
\alias{ndims}
\title{Number of Dimensions}
\description{
  Number of matrix or array dimensions.
}
\usage{
ndims(x)
}
\arguments{
  \item{x}{a vector, matrix, array, or list}
}
\details{
  Returns the number of dimensions as \code{length(x)}.

  For an empty object its dimension is 0, for vectors it is 1
  (deviating from MATLAB), for matrices it is 2, and for arrays
  it is the number of dimensions, as usual.
  Lists are considered to be (one-dimensional) vectors.
}
\value{
  the number of dimensions in a vector, matrix, or array \code{x}.
}
\seealso{
  \code{\link{size}}
}
\note{
  The result will differ from Matlab when \code{x} is a vector.
}
\examples{
ndims(c())                      # 0
ndims(as.numeric(1:8))          # 1
ndims(list(a=1, b=2, c=3))      # 1
ndims(matrix(1:12, 3, 4))       # 2
ndims(array(1:8, c(2,2,2)))     # 3
}
\keyword{array}

\name{eig}
\alias{eig}
\title{Eigenvalue Function (Matlab Style)}
\description{
  Eigenvalues of a matrix
}
\usage{
  eig(a)
}
\arguments{
  \item{a}{real or complex square matrix}
}
\details{
  Computes the eigenvalues of a square matrix of real or complex numbers,
  using the R routine \code{eigen} without computing the eigenvectors.
}
\value{
  Vector of eigenvalues
}
\seealso{
  \code{\link{compan}}
}
\examples{
  eig(matrix(c(1,-1,-1,1), 2, 2))   #=> 2 0
  eig(matrix(c(1,1,-1,1), 2, 2))    # complex values
  eig(matrix(c(0,1i,-1i,0), 2, 2))  # real values
}
\keyword{ array }

\name{findzeros}
\alias{findzeros}
\title{
  Find All Roots
}
\description{
  Finding all roots of a unvariate function in an interval by splitting
  the interval in many small subintervals.
}
\usage{
findzeros(f, a, b, n = 100, tol = .Machine$double.eps^(2/3), ...)
}
\arguments{
  \item{f}{functions whose roots shall be found.}
  \item{a, b}{endpoints of the interval.}
  \item{n}{number of subintervals to generate and search.}
  \item{tol}{tolerance for identifying zeros.}
  \item{\ldots}{Additional parameters to be passed to the function.}
}
\details{
  Roots, i.e. zeros in a subinterval will be found by applying \code{uniroot}
  to any subinterval where the sign of the function changes. The endpoints of
  the interval will be tested separately.

  If the function points are both positive or negative and the slope in this
  interval is high enough, the minimum or maximum will be determined with
  \code{optimize} and checked for a possible zero. 

  The function need not be vectorized.
}
\value{
  Numeric vector with the x-positions of all roots found in the interval.
}
\seealso{
  \code{\link{findmins}}
}
\examples{
f1 <- function(x) sin(pi/x)
findzeros(f1, 1/10, 1)
#  0.1000000  0.1111028  0.1250183  0.1428641  0.1666655
#  0.2000004  0.2499867  0.3333441  0.4999794  1.0000000

f2 <- function(x) 0.5*(1 + sin(10*pi*x))
findzeros(f2, 0, 1)
#  0.15  0.35  0.55  0.75  0.95

f3 <- function(x) sin(pi/x) + 1
findzeros(f3, 0.1, 0.5)
# 0.1052632 0.1333333 0.1818182 0.2857143

f4 <- function(x) sin(pi/x) - 1
findzeros(f4, 0.1, 0.5)
# 0.1176471 0.1538462 0.2222222 0.4000000

\dontrun{
# Dini function
Dini <- function(x) x * besselJ(x, 1) + 3 * besselJ(x, 0)
findzeros(Dini, 0, 100, n = 128)
ezplot(Dini, 0, 100, n = 512)
}
}
\keyword{ math }

\name{pracma-package}
\alias{pracma-package}
\alias{pracma}
\docType{package}
\title{
Practical Numerical Math Routines
}
\description{
  This package provides R implementations of more advanced functions in
  numerical analysis, with a special view on on optimization and time
  series routines. Uses Matlab/Octave function names where appropriate
  to simplify porting.

  Some of these implementations are the result of courses on Scientific
  Computing (``Wissenschaftliches Rechnen'') and are mostly intended to
  demonstrate how to implement certain algorithms in R/S. Others are
  implementations of algorithms found in textbooks.
}
\details{
  The package encompasses functions from all areas of numerical analysis,
  for example:
  \itemize{
    \item Root finding and minimization of univariate functions,\cr
    e.g. Newton-Raphson, Brent-Dekker, Fibonacci or `golden ratio' search.
    \item Handling polynomials, including roots and polynomial fitting,\cr
    e.g. Laguerre's and Muller's methods.
    \item Interpolation and function approximation,\cr
    barycentric Lagrange interpolation, Pade and rational interpolation,
    Chebyshev or trigonometric approximation.
    \item Some special functions,\cr
    e.g. Fresnel integrals, Riemann's Zeta or the complex Gamma function,
    and Lambert's W computed iteratively through Newton's method.
    \item Special matrices, e.g. Hankel, Rosser, Wilkinson
    \item Numerical differentiation and integration,\cr
    Richardson approach and ``complex step'' derivatives, adaptive
    Simpson and Lobatto integration and adaptive Gauss-Kronrod quadrature.
    \item Solvers for ordinary differential equations and systems,\cr
    Euler-Heun, classical Runge-Kutta, ode23, or predictor-corrector method 
    such as the Adams-Bashford-Moulton.
    \item Some functions from number theory,\cr
    such as primes and prime factorization, extended Euclidean algorithm.
    \item Sorting routines, e.g. recursive quickstep.
    \item Several functions for string manipulation and regular search,
    all wrapped and named similar to their Matlab analogues.
  }

  It serves three main goals:
  \itemize{
    \item Collecting R scripts that can be demonstrated in courses on
    `Numerical Analysis' or `Scientific Computing' using R/S as the chosen
    programming language.
    \item Wrapping functions with appropriate Matlab names to simplify
    porting programs from Matlab or Octave to R.
    \item Providing an environment in which R can be used as a full-blown
    numerical computing system.
  }

  Besides that, many of these functions could be called in R applications
  as they do not have comparable counterparts in other R packages (at least
  at this moment, as far as I know). 

  All referenced books have been utilized in one way or another.
  Web links have been provided where reasonable.
}
\note{
  The following 220 functions are emulations of correspondingly named Matlab 
  functions and bear the same signature as their Matlab cousins if possible:
  
  \code{accumarray, acosd, acot, acotd, acoth, acsc, acscd, acsch, and, angle, ans,}\cr
  \code{    arrayfun, asec, asecd, asech, asind, atand, atan2d,}\cr
  \code{beep, bernoulli, blank, blkdiag, bsxfun,}\cr
  \code{cart2pol, cart2sph, cd, ceil, circshift, clear, compan, cond, conv,}\cr
  \code{    cosd, cot, cotd, coth, cross, csc, cscd, csch, cumtrapz,}\cr
  \code{dblquad, deblank, deconv, deg2rad, detrend, deval, disp, dot,}\cr
  \code{eig, eigint, ellipj, ellipke, eps, erf, erfc, erfcinv, erfcx, erfi, erfinv,}\cr
  \code{    errorbar, expint, expm, eye, ezcontour, ezmesh, ezplot, ezpolar, ezsurf,}\cr
  \code{fact, fftshift, figure, findpeaks, findstr, flipdim, fliplr, flipud,}\cr
  \code{    fminbnd, fmincon, fminsearch, fminunc, fplot, fprintf, fsolve, fzero,}\cr
  \code{gammainc, gcd, geomean, gmres, gradient,}\cr
  \code{hadamard, hankel, harmmean, hilb, histc, humps, hypot,}\cr
  \code{idivide, ifft, ifftshift, inpolygon, integral, integral2, integral3,}\cr
  \code{    interp1, interp2, inv, isempty, isprime,}\cr
  \code{kron,}\cr
  \code{legendre, linprog, linspace, loglog, logm, logseq, logspace, lsqcurvefit,}\cr
  \code{    lsqlin, lsqnonlin, lsqnonneg, lu,}\cr
  \code{magic, meshgrid, mkpp, mldivide, mod, mrdivide,}\cr
  \code{nchoosek, ndims, nextpow2, nnz, normest, nthroot, null, num2str, numel,}\cr
  \code{ode23, ode23s, ones, or, orth,}\cr
  \code{pascal, pchip, pdist, pdist2, peaks, perms, piecewise, pinv, plotyy,}\cr
  \code{    pol2cart, polar, polyfit, polyint, polylog, polyval, pow2, ppval,}\cr
  \code{    primes, psi, pwd,}\cr
  \code{quad, quad2d, quadgk, quadl, quadprog, quadv, quiver,}\cr
  \code{rad2deg, randi, randn, randsample, rat, rats, regexp, regexpi,}\cr
  \code{    regexpreg, rem, repmat, roots, rosser, rot90, rref, runge,}\cr
  \code{sec, secd, sech, semilogx, semilogy, sinc, sind, size, sortrows, sph2cart,}\cr
  \code{    sqrtm, squareform, std, str2num, strcat, strcmp, strcmpi,}\cr
  \code{    strfind, strfindi, strjust, subspace,}\cr
  \code{tand, tic, toc, trapz, tril, trimmean, triplequad, triu,}\cr
  \code{vander, vectorfield, ver,}\cr
  \code{what, who, whos, wilkinson,}\cr
  \code{zeros, zeta}

  The following Matlab function names have been capitalized in `pracma' to
  avoid shadowing functions from R base or one of its recommended packages
  (on request of Bill Venables and because of Brian Ripley's CRAN policies):

  \code{Diag, factos, finds, Fix, Imag, Lcm, Mode, Norm, nullspace (<- null)},\cr
  \code{Poly, Rank, Real, Reshape, strRep, strTrim, Toeplitz, Trace, uniq (<- unique).}

  To use ``ans'' instead of ``ans()'' -- as is common practice in Matlab --
  type (and similar for other Matlab commands):

  \code{makeActiveBinding("ans", function() .Last.value, .GlobalEnv)}\cr
  \code{makeActiveBinding("who", who(), .GlobalEnv)}
}
\author{
Hans Werner Borchers

Maintainer: Hans W Borchers  <hwborchers@googlemail.com>
}
\references{
  Abramowitz, M., and I. A. Stegun (1972). Handbook of Mathematical Functions
  (with Formulas, Graphs, and Mathematical Tables). Dover, New York.  
  URL: https://www.math.ubc.ca/~cbm/aands/notes.htm

  Arndt, J. (2010). Matters Computational: Ideas, Algorithms, Source Code.
  Springer-Verlag, Berlin Heidelberg Dordrecht.
  FXT: a library of algorithms: \url{https://www.jjj.de/fxt/}.

  Cormen, Th. H., Ch. E. Leiserson, and R. L. Rivest (2009). Introduction
  to Algorithms. Third Edition, The MIT Press, Cambridge, MA.

  Encyclopedia of Mathematics (2012). Editor-in-Chief: Ulf Rehmann.
  \url{https://encyclopediaofmath.org/wiki/Main_Page}.

  Gautschi, W. (1997). Numerical Analysis: An Introduction.
  Birkhaeuser, Boston.

  Gentle, J. E. (2009). Computational Statistics.
  Springer Science+Business Media LCC, New York.

  MathWorld.com (2011).
  Matlab Central: \url{https://www.mathworks.com/matlabcentral/}.

  NIST: National Institute of Standards and Technology.
  Olver, F. W. J., et al. (2010). NIST Handbook of Mathematical Functions.
  Cambridge University Press. 
  Internet: NIST Digital Library of Mathematical Functions, 
  \url{https://dlmf.nist.gov/};
  Guide to Available Mathematical Software, \url{https://gams.nist.gov/}.

  Press, W. H., S. A. Teukolsky, W. T Vetterling, and B. P. Flannery (2007).
  Numerical Recipes: The Art of Numerical Computing. Third Edition, incl.
  Numerical Recipes Software, Cambridge University Press, New York.
  URL: numerical.recipes/book/book.html.

  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.

  Skiena, St. S. (2008). The Algorithm Design Manual. Second Edition,
  Springer-Verlag, London. The Stony Brook Algorithm Repository:
  \url{https://algorist.com/algorist.html}.

  Stoer, J., and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Springer-Verlag, New York.

  Strang, G. (2007). Computational Science and Engineering.
  Wellesley-Cambridge Press.

  Weisstein, E. W. (2003). CRC Concise Encyclopedia of Mathematics.
  Second Edition, Chapman & Hall/CRC Press.
  Wolfram MathWorld: \url{https://mathworld.wolfram.com/}.  

  Zhang, S., and J. Jin (1996). Computation of Special Functions.
  John Wiley & Sons.
}
\seealso{
  The R package `matlab' contains some of the basic routines from Matlab,
  but unfortunately not any of the higher math routines.
}
\examples{
\dontrun{
##  See examples in the help files for all functions.
    }
}
\keyword{ package }

\name{lsqlincon}
\alias{lsqlincon}
\title{
  Linear Least-Squares Fitting with linear constraints
}
\description{
  Solves linearly constrained linear least-squares problems.
}
\usage{
lsqlincon(C, d,  A = NULL, b = NULL,
          Aeq = NULL, beq = NULL, lb = NULL,  ub = NULL)
}
\arguments{
  \item{C}{\code{mxn}-matrix defining the least-squares problem.}
  \item{d}{vector or a one colum matrix with \code{m} rows}
  \item{A}{\code{pxn}-matrix for the linear inequality constraints.}
  \item{b}{vector or \code{px1}-matrix, right hand side for the constraints.}
  \item{Aeq}{\code{qxn}-matrix for the linear equality constraints.}
  \item{beq}{vector or \code{qx1}-matrix, right hand side for the constraints.}
  \item{lb}{lower bounds, a scalar will be extended to length n.}
  \item{ub}{upper bounds, a scalar will be extended to length n.}
}
\details{
  \code{lsqlincon(C, d, A, b, Aeq, beq, lb, ub)} minimizes \code{||C*x - d||}
  (i.e., in the least-squares sense) subject to the following constraints:
  \code{A*x <= b}, \code{Aeq*x = beq}, and \code{lb <= x <= ub}.

  It applies the quadratic solver in \code{quadprog} with an active-set
  method for solving quadratic programming problems.

  If some constraints are \code{NULL} (the default), they will not be taken
  into account. In case no constraints are given at all, it simply uses
  \code{qr.solve}.
}
\value{
  Returns the least-squares solution as a vector.
}
\note{
  Function \code{lsqlin} in \code{pracma} solves this for equality constraints
  only, by computing a base for the nullspace of \code{Aeq}. But for linear
  inequality constraints there is no simple linear algebra `trick', thus a real
  optimization solver is needed.
}
\author{
  HwB  email: <hwborchers@googlemail.com>
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra.
  SIAM, Society for Industrial and Applied Mathematics, Philadelphia.
}
\seealso{
  \code{\link{lsqlin}}, \code{quadprog::solve.QP}
}
\examples{
##  MATLABs lsqlin example
C <- matrix(c(
    0.9501,   0.7620,   0.6153,   0.4057,
    0.2311,   0.4564,   0.7919,   0.9354,
    0.6068,   0.0185,   0.9218,   0.9169,
    0.4859,   0.8214,   0.7382,   0.4102,
    0.8912,   0.4447,   0.1762,   0.8936), 5, 4, byrow=TRUE)
d <- c(0.0578, 0.3528, 0.8131, 0.0098, 0.1388)
A <- matrix(c(
    0.2027,   0.2721,   0.7467,   0.4659,
    0.1987,   0.1988,   0.4450,   0.4186,
    0.6037,   0.0152,   0.9318,   0.8462), 3, 4, byrow=TRUE)
b <- c(0.5251, 0.2026, 0.6721)
Aeq <- matrix(c(3, 5, 7, 9), 1)
beq <- 4
lb <- rep(-0.1, 4)   # lower and upper bounds
ub <- rep( 2.0, 4)

x <- lsqlincon(C, d, A, b, Aeq, beq, lb, ub)
# -0.1000000 -0.1000000  0.1599088  0.4089598
# check A %*% x - b >= 0
# check Aeq %*% x - beq == 0
# check sum((C %*% x - d)^2)    # 0.1695104
}
\keyword{ optimize }

\name{arnoldi}
\alias{arnoldi}
\title{Arnoldi Iteration}
\description{
  Arnoldi iteration generates an orthonormal basis of the Krylov space
  and a Hessenberg matrix.
}
\usage{
arnoldi(A, q, m)
}
\arguments{
  \item{A}{a square n-by-n matrix.}
  \item{q}{a vector of length n.}
  \item{m}{an integer.}
}
\details{
  \code{arnoldi(A, q, m)} carries out \code{m} iterations of the
  Arnoldi iteration with n-by-n matrix \code{A} and starting vector
  \code{q} (which need not have unit 2-norm). For \code{m < n} it 
  produces an n-by-(m+1) matrix \code{Q} with orthonormal columns
  and an (m+1)-by-m upper Hessenberg matrix \code{H} such that
  \code{A*Q[,1:m] = Q[,1:m]*H[1:m,1:m] + H[m+1,m]*Q[,m+1]*t(E_m)},
  where \code{E_m} is the m-th column of the m-by-m identity matrix.
}
\value{
Returns a list with two elements:

\code{Q} A matrix of orthonormal columns that generate the Krylov
space {A, A q, A^2 q, ...}.

\code{H} A Hessenberg matrix such that \code{A = Q * H * t(Q)}.
}
\references{
  Nicholas J. Higham (2008). Functions of Matrices: Theory and 
  Computation, SIAM, Philadelphia.
}
\seealso{
  \code{\link{hessenberg}}
}
\examples{
A <- matrix(c(-149,   -50,  -154,
               537,   180,   546,
               -27,    -9,   -25), nrow = 3, byrow = TRUE)
a <- arnoldi(A, c(1,0,0))
a
## $Q
##      [,1]       [,2]       [,3]
## [1,]    1  0.0000000  0.0000000
## [2,]    0  0.9987384 -0.0502159
## [3,]    0 -0.0502159 -0.9987384
## 
## $H
##           [,1]         [,2]        [,3]
## [1,] -149.0000 -42.20367124  156.316506
## [2,]  537.6783 152.55114875 -554.927153
## [3,]    0.0000   0.07284727    2.448851

a$Q \%*\% a$H \%*\% t(a$Q)
##      [,1] [,2] [,3]
## [1,] -149  -50 -154
## [2,]  537  180  546
## [3,]  -27   -9  -25
}
\keyword{ math }

\name{hausdorff_dist}
\alias{hausdorff_dist}
\title{Hausdorff Distance}
\description{
  Hausdorff distance (aka Hausdorff dimension)
}
\usage{
hausdorff_dist(P, Q)
}
\arguments{
  \item{P, Q}{numerical matrices, representing points in an m-dim. space.}
}
\details{
  Calculates the Hausdorff Distance between two sets of points, P and Q.
  Sets P and Q must be matrices with the same number of columns (dimensions).

  The `directional' Hausdorff distance (dhd) is defined as:

    dhd(P,Q) = max p in P [ min q in Q [ ||p-q|| ] ]

  Intuitively dhd finds the point p from the set P that is farthest from any
  point in Q and measures the distance from p to its nearest neighbor in Q.
  The Hausdorff Distance is defined as max(dhd(P,Q),dhd(Q,P)).
}
\value{
  A single scalar, the Hausdorff distance (dimension).
}
\references{
  Barnsley, M. (1993). Fractals Everywhere. Morgan Kaufmann, San Francisco.
}
\seealso{
\code{\link{distmat}}
}
\examples{
P <- matrix(c(1,1,2,2, 5,4,5,4), 4, 2)
Q <- matrix(c(4,4,5,5, 2,1,2,1), 4, 2)
hausdorff_dist(P, Q)    # 4.242641 = sqrt(sum((c(4,2)-c(1,5))^2))
}
\keyword{ math }

\name{householder}
\alias{householder}
\title{Householder Reflections}
\description{
  Householder reflections and QR decomposition
}
\usage{
  householder(A)
}
\arguments{
  \item{A}{numeric matrix with \code{nrow(A)>=ncol(A)}.}
}
\details{
  The Householder method applies a succession of elementary unitary
  matrices to the left of matrix \code{A}. These matrices are the so-called
  Householder reflections.
}
\value{
  List with two matrices \code{Q} and \code{R}, \code{Q} orthonormal and
  \code{R} upper triangular, such that \code{A=Q\%*\%R}.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Society for Industrial and Applied Mathematics, Philadelphia.
}
\seealso{
  \code{\link{givens}}
}
\examples{
##  QR decomposition
A <- matrix(c(0,-4,2, 6,-3,-2, 8,1,-1), 3, 3, byrow=TRUE)
S <- householder(A)
(Q <- S$Q); (R <- S$R)
Q \%*\% R  # = A

##  Solve an overdetermined linear system of equations
A <- matrix(c(1:8,7,4,2,3,4,2,2), ncol=3, byrow=TRUE)
S <- householder(A); Q <- S$Q; R <- S$R
m <- nrow(A); n <- ncol(A)
b <- rep(6, 5)

x <- numeric(n)
b <- t(Q) \%*\% b
x[n] <- b[n] / R[n, n]
for (k in (n-1):1)
    x[k] <- (b[k] - R[k, (k+1):n] \%*\% x[(k+1):n]) / R[k, k]
qr.solve(A, rep(6, 5)); x
}
\keyword{ array }

\name{bits}
\alias{bits}
\title{Binary Representation}
\description{
  Literal bit representation.
}
\usage{
bits(x, k = 54, pos_sign = FALSE, break0 = FALSE)
}
\arguments{
  \item{x}{a positive or negative floating point number.}
  \item{k}{number of binary digits after the decimal point}
  \item{pos_sign}{logical; shall the '+' sign be included.}
  \item{break0}{logical; shall trailing zeros be included.}
}
\details{
  The literal bit/binary representation of a floating point number is computed
  by subtracting powers of 2.
}
\value{
  Returns a string containing the binary representation.
}
\seealso{
\code{\link{nextpow2}}
}
\examples{
bits(2^10)        # "10000000000"
bits(1 + 2^-10)   #  "1.000000000100000000000000000000000000000000000000000000"
bits(pi)          # "11.001001000011111101101010100010001000010110100011000000"
bits(1/3.0)       #  "0.010101010101010101010101010101010101010101010101010101"
bits(1 + eps())   #  "1.000000000000000000000000000000000000000000000000000100"
}
\keyword{ arith }

\name{rref}
\alias{rref}
\title{
  Reduced Row Echelon Form
}
\description{
  Produces the reduced row echelon form of \code{A} using
  Gauss Jordan elimination with partial pivoting.
}
\usage{
rref(A)
}
\arguments{
  \item{A}{numeric matrix.}
}
\details{
  A matrix of ``row-reduced echelon form" has the following characteristics:

  1. All zero rows are at the bottom of the matrix

  2. The leading entry of each nonzero row after the first occurs
     to the right of the leading entry of the previous row.

  3. The leading entry in any nonzero row is 1.

  4. All entries in the column above and below a leading 1 are zero.

  Roundoff errors may cause this algorithm to compute a different value
  for the rank than \code{rank}, \code{orth} or \code{null}.
}
\value{
  A matrix the same size as \code{m}.
}
\note{
  This serves demonstration purposes only; don't use for large matrices.
}
\references{
  Weisstein, Eric W. ``Echelon Form." From MathWorld -- A Wolfram Web Resource.\cr
  \url{https://mathworld.wolfram.com/EchelonForm.html}
}
\seealso{
  \code{\link{qr.solve}}
}
\examples{
A <- matrix(c(1, 2, 3, 1, 3, 2, 3, 2, 1), 3, 3, byrow = TRUE)
rref(A)       
#      [,1] [,2] [,3]
# [1,]    1    0    0
# [2,]    0    1    0
# [3,]    0    0    1

A <- matrix(data=c(1, 2, 3, 2, 5, 9, 5, 7, 8,20, 100, 200),
            nrow=3, ncol=4, byrow=FALSE)  
rref(A)
#   1    0    0  120
#   0    1    0    0
#   0    0    1  -20

# Use rref on a rank-deficient magic square:
A = magic(4)
R = rref(A)
zapsmall(R)
#   1    0    0    1
#   0    1    0    3
#   0    0    1   -3
#   0    0    0    0
}
\keyword{ math }

\name{triquad}
\alias{triquad}
\title{
  Gaussian Triangle Quadrature
}
\description{
  Numerically integrates a function over an arbitrary triangular domain by
  computing the Gauss nodes and weights.
}
\usage{
triquad(f, x, y, n = 10, tol = 1e-10, ...)
}
\arguments{
  \item{f}{the integrand as function of two variables.}
  \item{x}{x-coordinates of the three vertices of the triangle.}
  \item{y}{y-coordinates of the three vertices of the triangle.}
  \item{n}{number of nodes.}
  \item{tol}{relative tolerance to be achieved.}
  \item{\ldots}{additional parameters to be passed to the function.}
}
\details{
  Computes the \code{N^2} nodes and weights for a triangle with vertices
  given by 3x2 vector. The nodes are produced by collapsing the square
  to a triangle.

  Then \code{f} will be applied to the nodes and the result multiplied
  left and right with the weights (i.e., Gaussian quadrature).

  By default, the function applies Gaussian quadrature with number of
  nodes \code{n=10,21,43,87,175} until the relative error is smaller than
  the tolerance.
}
\value{
  The integral as a scalar.
}
\note{
  A small relative tolerance is \emph{not} really indicating a small
  absolute tolerance.
}
\author{
  Copyright (c) 2005 Greg von Winckel Matlab code based on the publication
  mentioned and available from MatlabCentral (calculates nodes and weights).
  Translated to R (with permission) by Hans W Borchers.
}
\references{
  Lyness, J. N., and R. Cools (1994). A Survey of Numerical Cubature
  over Triangles. Proceedings of the AMS Conference ``Mathematics of
  Computation 1943--1993'', Vancouver, CA.
}
\seealso{
  \code{\link{quad2d}}, \code{\link{simpson2d}}
}
\examples{
x <- c(-1, 1, 0); y <- c(0, 0, 1)
f1 <- function(x, y) x^2 + y^2
(I <- triquad(f1, x, y))                        # 0.3333333333333333

# split the unit square
x1 <- c(0, 1, 1); y1 <- c(0, 0, 1)
x2 <- c(0, 1, 0); y2 <- c(0, 1, 1)
f2 <- function(x, y) exp(x + y)
I <- triquad(f2, x1, y1) + triquad(f2, x2, y2)  # 2.952492442012557
quad2d(f2, 0, 1, 0, 1)                          # 2.952492442012561
simpson2d(f2, 0, 1, 0, 1)                       # 2.952492442134769
dblquad(f2,  0, 1, 0, 1)                        # 2.95249244201256
}
\keyword{ math }

\name{hypot}
\alias{hypot}
\title{Hypotenuse Function}
\description{
Square root of sum of squares
}
\usage{
hypot(x, y)
}
\arguments{
  \item{x, y}{Vectors of real or complex numbers of the same size}
}
\details{
Element-by-element computation of the square root of the sum of squares
of vectors resp. matrices \code{x} and \code{y}.
}
\value{
Returns a vector or matrix of the same size.
}
\note{
Returns \code{c()} if \code{x} or \code{y} is empty and the other one has
length 1. If one input is scalar, the other a vector, the scalar will be
extended to a vector of appropriate length. In all other cases, \code{x}
and \code{y} have to be of the same size.
}
\examples{
hypot(3,4)
hypot(1, c(3, 4, 5))
hypot(c(0, 0), c(3, 4))
}
\keyword{ array }

\name{std}
\alias{std}
\title{Standard Deviation (Matlab Style)}
\description{
  Standard deviation of the values of \code{x}.
}
\usage{
std(x, flag=0)
}
\arguments{
  \item{x}{numeric vector or matrix}
  \item{flag}{numeric scalar. If \code{0}, selects unbiased algorithm; and
  if \code{1}, selects the biased version.}
}
\details{
  If \code{flag = 0} the result is the square root of an unbiased estimator of 
  the variance. \code{std(X,1)} returns the standard deviation producing the
  second moment of the set of values about their mean.
}
\value{
  Return value depends on argument \code{x}. If vector, returns the
  standard deviation. If matrix, returns vector containing the standard
  deviation of each column.
}
\note{
  \code{flag = 0} produces the same result as R's sd().
}
\examples{
std(1:10)          # 3.027650
std(1:10, flag=1)  # 2.872281
}
\keyword{ stat }

\name{Hessian utilities}
\alias{hessvec}
\alias{hessdiag}
\title{Hessian utilities}
\description{
  Fast multiplication of Hessian and vector where computation of the full 
  Hessian is not needed. Or determine the diagonal of the Hessian when
  non-diagonal entries are not needed or are nearly zero.
}
\usage{
  hessvec(f, x, v, csd = FALSE, ...)

  hessdiag(f, x, ...)
}
\arguments{
  \item{f}{function whose hessian is to be computed.}
  \item{x}{point in \code{R^n}.}
  \item{v}{vector of length \code{n}.}
  \item{csd}{logocal, shall complex-step be applied.}
  \item{...}{more arguments to be passed to the function.}
}
\details{
  \code{hessvec} computes the product of a Hessian of a function
  times a vector without deriving the full Hessian by approximating
  the gradient (see the reference). If the function allows for the
  complex-step method, the gradient can be calculated much more
  accurate (see \code{grad_csd}).

  \code{hessdiag} computes only the diagonal of the Hessian by
  applying the central difference formula of second order to
  approximate the partial derivatives.
}
\value{
  \code{hessvec} returns the product \code{H(f,x) * v} as a vector.

  \code{hessdiag} returns the diagonal of the Hessian of \code{f}.
}
\references{
  B.A. Pearlmutter, Fast Exact Multiplication by the Hessian, Neural Computation (1994), Vol. 6, Issue 1, pp. 147-160.
}
\seealso{
  \code{\link{hessian}}
}
\examples{
  \dontrun{
    set.seed(1237); n <- 100
    a <- runif(n); b <- rnorm(n)
    fn <- function(x, a, b) sum(exp(-a*x)*sin(b*pi*x))
    x0 <- rep(1, n)
    v0 <- rexp(n, rate=0.1)
    
    # compute with full hessian
    h0 <- hessian(fn, x0, a = a, b = b)             # n=100 runtimes
    v1 <- c(h0 \%*\% v0)                              # 0.167   sec
    
    v2 <- hessvec(fn, x0, v0, a = a, b = b)         # 0.00209 sec
    v3 <- hessvec(fn, x0, v0, csd=TRUE,a=a, b=b)    # 0.00145 sec
    v4 <- hessdiag(fn, x0, a = a, b = b) * v0       # 0.00204 sec
    
    # compare with exact analytical Hessian
    hex <- diag((a^2-b^2*pi^2)*exp(-a*x0)*sin(b*pi*x0) - 
                 2*a*b*pi*exp(-a*x0)*cos(b*pi*x0))
    vex <- c(hex \%*\% v0)

    max(abs(vex - v1))          # 2.48e-05
    max(abs(vex - v2))          # 7.15e-05
    max(abs(vex - v3))          # 0.09e-05
    max(abs(vex - v4))          # 2.46e-05 }
}
\keyword{ math }

\name{halley}
\alias{halley}

\title{
  Halley's Root Finding Mathod
}
\description{
  Finding roots of univariate functions using the Halley method.
}
\usage{
halley(fun, x0, maxiter = 500, tol = 1e-08, ...)
}
\arguments{
  \item{fun}{function whose root is to be found.}
  \item{x0}{starting value for the iteration.}
  \item{maxiter}{maximum number of iterations.}
  \item{tol}{absolute tolerance; default \code{eps^(1/2)}}
  \item{...}{additional arguments to be passed to the function.}
}
\details{
  Well known root finding algorithms for real, univariate, continuous
  functions; the second derivative must be smooth, i.e. continuous.
  The first and second derivative are computed numerically.
}
\value{
  Return a list with components \code{root}, \code{f.root}, 
  the function value at the found root, \code{iter}, the number of iterations
  done, and the estimated precision \code{estim.prec}
}
\references{
  \url{https://mathworld.wolfram.com/HalleysMethod.html}
}
\seealso{
\code{\link{newtonRaphson}}
}
\examples{
halley(sin, 3.0)        # 3.14159265358979 in 3 iterations
halley(function(x) x*exp(x) - 1, 1.0)
                        # 0.567143290409784 Gauss' omega constant

# Legendre polynomial of degree 5
lp5 <- c(63, 0, -70, 0, 15, 0)/8
f <- function(x) polyval(lp5, x)
halley(f, 1.0)          # 0.906179845938664
}
\keyword{ math }

\name{subspace}
\alias{subspace}
\title{
  Angle between two subspaces
}
\description{
  Finds the angle between two subspaces.
}
\usage{
subspace(A, B)
}
\arguments{
  \item{A, B}{Numeric matrices; vectors will be considered as column vectors.
              These matrices must have the same number or rows.}
}
\details{
  Finds the angle between two subspaces specified by the columns of A and B.
}
\value{
  An angle in radians.
}
\references{
  Strang, G. (1998). Introduction to Linear Algebra. Wellesley-Cambridge Press.
}
\note{
  It is not necessary that two subspaces be the same size in order to find
  the angle between them. Geometrically, this is the angle between two
  hyperplanes embedded in a higher dimensional space.
}
\seealso{
  \code{\link{orth}}
}
\examples{
180 * subspace(c(1, 2), c(2, 1)) / pi  #=> 36.87
180 * subspace(c(0, 1), c(1, 2)) / pi  #=> 26.565

H <- hadamard(8)
A <- H[, 2:4]
B <- H[, 5:8]
subspace(A, B)    #=> 1.5708 or pi/2, i.e. A and B are orthogonal
}
\keyword{ array }

\name{euler_heun}
\alias{euler_heun}
\title{
  Euler-Heun ODE Solver
}
\description{
  Euler and Euler-Heun ODE solver.
}
\usage{
euler_heun(f, a, b, y0, n = 100, improved = TRUE, ...)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)}.}
  \item{a, b}{start and end points of the interval.}
  \item{y0}{starting value at a.}
  \item{n}{number of grid points.}
  \item{improved}{logical; shall the Heun method be used; default TRUE.}
  \item{...}{additional parameters to be passed to the function.}
}
\details{
  \code{euler_heun} is an integration method for ordinary differential
  equations using the simple Euler resp. the improved Euler-Heun Method.
}
\value{
  List with components \code{t} for grid (or `time') points, and \code{y} 
  the vector of predicted values at those grid points.
}
\references{
  Quarteroni, A., and F. Saleri (). Scientific Computing with MATLAB
  and Octave. Second Edition, Springer-Verlag, Berlin Heidelberg, 2006.
}
\seealso{
  \code{\link{cranknic}}
}
\examples{
##  Flame-up process
f <- function(x, y) y^2 - y^3
s1 <- cranknic(f, 0, 200, 0.01)
s2 <- euler_heun(f, 0, 200, 0.01)
\dontrun{
plot(s1$t, s1$y, type="l", col="blue")
lines(s2$t, s2$y, col="red")
grid()}
}
\keyword{ ode }

\name{trigPoly}
\alias{trigPoly}
\title{
  Trigonometric Polynomial
}
\description{
  Computes the trigonometric coefficients.
}
\usage{
trigPoly(x, m)
}
\arguments{
  \item{x}{data from \code{t=0} to \code{t=2*(n-1)*pi/n}.}
  \item{m}{degree of trigonometric regression.}
}
\details{
  Compute the coefficients of the trigonometric series of degree \code{m},
  \deqn{a_0 + \sum_k(a_k \cos(k t) + b_k \sin(k t))}
  by applying orthogonality relations.
}
\value{
  Coefficients as a list with components \code{a0}, \code{a}, and \code{b}. 
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\note{
  For irregular spaced data or data not covering the whole period, use
  standard regression techniques, see examples.
}
\seealso{
\code{\link{trigApprox}}
}
\examples{
# Data available only from 0 to pi/2
t <- seq(0, pi, len=7)
x <- 0.5 + 0.25*sin(t) + 1/3*cos(t) - 1/3*sin(2*t) - 0.25*cos(2*t)

# use standard regression techniques
A <- cbind(1, cos(t), sin(t), cos(2*t), sin(2*t))
ab <- qr.solve(A, x)
ab
# [1]  0.5000000  0.3333333  0.2500000 -0.2500000 -0.3333333
ts <- seq(0, 2*pi, length.out = 100)
xs <- ab[1] + ab[2]*cos(ts) +
      ab[3]*sin(ts) + ab[4]*cos(2*ts) +ab[5]*sin(2*ts)

\dontrun{
# plot to make sure
plot(t, x, col = "red", xlim=c(0, 2*pi), ylim=c(-2,2),
           main = "Trigonometric Regression")
lines(ts, xs, col="blue")
grid()}
}
\keyword{ math }

\name{cond}
\alias{cond}
\title{
  Matrix Condition
}
\description{
  Condition number of a matrix.
}
\usage{
cond(M, p = 2)
}
\arguments{
  \item{M}{Numeric matrix; vectors will be considered as column vectors.}
  \item{p}{Indicates the \code{p}-norm.
           At the moment, norms other than \code{p=2} are not implemented.}
}
\details{
  The condition number of a matrix measures the sensitivity of the solution
  of a system of linear equations to small errors in the data. Values of
  \code{cond(M)} and \code{cond(M, p)} near \code{1} are indications of a
  well-conditioned matrix.
}
\value{
  \code{cond(M)} returns the 2-norm condition number, the ratio of the
  largest singular value of \code{M} to the smallest.

  \code{c = cond(M, p)} returns the matrix condition number in \code{p}-norm:

  \code{norm(X,p) * norm(inv(X),p)}.

  (Not yet implemented.)
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Philadelphia.   
}
\note{
  Not feasible for large or sparse matrices as \code{svd(M)} needs to be
  computed. The Matlab/Octave function \code{condest} for condition
  estimation has not been implemented.
}
\seealso{
  \code{\link{normest}}, \code{\link{svd}}
}
\examples{
cond(hilb(8))
}
\keyword{ array }

\name{segm_distance}
\alias{segm_distance}
\title{
  Segment Distance
}
\description{
  The minimum distance between a point and a segment, or the
  minimum distance between points of two segments.
}
\usage{
segm_distance(p1, p2, p3, p4 = c())
}
\arguments{
  \item{p1, p2}{end points of the first segment.}
  \item{p3, p4}{end points of the second segment, or the point \code{p3}
        alone if \code{p4} is \code{NULL}.}
}
\details{
  If \code{p4=c()}, determines the orthogonal line to the segment through
  the single point and computes the distance to the intersection point.

  Otherwise, it computes the distances of all four end points to the
  other segment and takes the minimum of those.
}
\value{
  Returns a list with component \code{l} the minimum distance and components
  \code{p, q} the two nearest points.

  If \code{p4=c()} then point \code{p} lies on the segment and \code{q} is
  \code{p4}.
}
\note{
  The interfaces of \code{segm_intersect} and \code{segm_distance} should be
  brought into line.
}
\seealso{
\code{\link{segm_intersect}}
}
\examples{
\dontrun{
plot(c(0, 1), c(0, 1), type = "n", asp=1, 
     xlab = "", ylab = "", main = "Segment Distances")
grid()
for (i in 1:20) {
    s1 <- matrix(runif(4), 2, 2)
    s2 <- matrix(runif(4), 2, 2)
    lines(s1[, 1], s1[, 2], col = "red")
    lines(s2[, 1], s2[, 2], col = "darkred")
    S <- segm_distance(s1[1,], s1[2,], s2[1,], s2[2,])
    S$d
    points(c(S$p[1], S$q[1]), c(S$p[2], S$q[2]), pch=20, col="navy")
    lines(c(S$p[1], S$q[1]), c(S$p[2], S$q[2]), col="gray")
}}
}
\keyword{ geom }

\name{nile}
\alias{nile}
\docType{data}
\title{
  Nile overflow data
}
\description{
  Nile overflow data 1871--1984, gathered mostly by H. E. Hurst.
}
\usage{data("nile")}
\format{
  A data frame with 114 years of observations during the months Jan to Dec.
}
\details{
  Monthly flow data taken at the Dongola measurement station just upstream
  from the high dam at Aswan.
}
\references{
  R. Weron (2001). Estimating long range dependence: finite sample properties and
  confidence intervals. arXiv.org:cond-mat0103510.pdf .
}
\examples{
data(nile)                      # loads "nile" data frame
\dontrun{
nile_dt <- nile[, 2:13]         # erase the "years" column

# plot all years in one figure
plot(ts(nile_dt), plot.type="single")

# merge all years in one time series
nile_ts <- ts( c(t(nile[, 2:13])), frequency = 12, start = c(1871, 1) )

# aggregated flow per year
nile_flow <- apply(nile_dt, 1, sum)

plot(ts(nile_flow, frequency = 1, start = 1871) / 1000,
     col = "darkblue", lwd = 2.0,
     main = "Nile flows 1871 - 1984", ylab = "Flow / 1000")
grid()

# Hurst exponent of yearly Nile flow
hurstexp(nile_flow)
# Simple R/S Hurst estimation:         0.7348662 
# Corrected R over S Hurst exponent:   1.041862 
# Empirical Hurst exponent:            0.6975531 
# Corrected empirical Hurst exponent:  0.7136607 
# Theoretical Hurst exponent:          0.5244148 
}
}
\keyword{datasets}

\name{lebesgue}
\alias{lebesgue}
\title{Lebesgue Constant}
\description{
  Estimates the Lebesgue constant.
}
\usage{
lebesgue(x, refine = 4, plotting = FALSE)
}
\arguments{
    \item{x}{numeric vector of grid points}
    \item{refine}{refine the grid with \code{2^refine} grid points;
                  can only be an integer between 2 and 10, default 4.}
    \item{plotting}{shall the Lebesgue function be plotted.}
}
\details{
  The Lebesgue constant gives an estimation \eqn{||P_n f|| \le L ||f||}
  (in minimax norm) where \eqn{P_n f} is the interpolating polynomial of
  order \eqn{n} for \eqn{f} on an interval \eqn{[a, b]}.
}
\value{
  Lebesgue constant for the given grid points.
}
\references{
  Berrut, J.-P., and L. Nick Trefethen (2004). ``Barycentric Lagrange
  Interpolation''. SIAM Review, Vol. 46(3), pp.501--517.
}
\note{
  The Lebesgue constant plays an important role when estimating the distance
  of interpolating polynomials from the minimax solution (see the Remez
  algorithm).
}
\seealso{
\code{\link{barylag}}
}
\examples{
lebesgue(seq(0, 1, length.out = 6))  #=> 3.100425
}
\keyword{ math }

\name{Rank}
\alias{Rank}
\title{
  Matrix Rank
}
\description{
  Provides an estimate of the rank of a matrix \code{M}.
}
\usage{
Rank(M)
}
\arguments{
  \item{M}{Numeric matrix; vectors will be considered as column vectors.}
}
\details{
  Provides an estimate of the number of linearly independent rows or columns
  of a matrix \code{M}. Compares an approach using QR-decomposition with one
  counting singular values larger than a certain tolerance (Matlab).
}
\value{
  Matrix rank as integer between \code{0} and \code{min(ncol(M), nrow(M))}.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Philadelphia. 
}
\note{
  The corresponding function in Matlab is called \code{rank}, but that term
  has a different meaning in R.
}
\seealso{
  \code{\link{nullspace}}
}
\examples{
Rank(magic(10))   #=> 7
Rank(magic(100))  #=> 3 (!)
Rank(hilb(8))     #=> 8 , but qr(hilb(8))$rank says, rank is 7.
# Warning message:
# In Rank(hilb(8)) : Rank calculation may be problematic.
}
\keyword{ array }

\name{regexp}
\alias{regexp}
\alias{regexpi}
\title{
  Match regular expression
}
\description{
  Returns the positions of substrings that match the regular expression.
}
\usage{
regexp(s, pat, ignorecase = FALSE, once = FALSE, split = FALSE)

regexpi(s, pat, once = FALSE, split = FALSE)
}
\arguments{
  \item{s}{Character string, i.e. of length 1.}
  \item{pat}{Matching pattern as character string.}
  \item{ignorecase}{Logical: whether case should be ignored;
        default: \code{FALSE}.}
  \item{once}{Logical: whether the first are all occurrences should be found;
        default: all.}
  \item{split}{Logical: should the string be splitted at the occurrences of
               the pattern?; default: no.}
}
\details{
  Returns the start and end positions and the exact value of substrings
  that match the regular expression. If \code{split} is choosen, the
  splitted strings will also be returned.
}
\value{
  A list with components \code{start} and \code{end} as numeric vectors
  indicating the start and end positions of the matches.

  \code{match} contains each exact match, and \code{split} contains the
  character vector of splitted strings.

  If no match is found all components will be \code{NULL}, except
  \code{split} that will contain the whole string if \code{split = TRUE}.
}
\note{
  This is the behavior of the corresponding Matlab function, though the
  signature, options and return values do not match exactly.
  Notice the transposed parameters \code{s} and \code{pat} compared to the
  corresponding R function \code{regexpr}.
}
\seealso{
\code{\link{regexpr}}
}
\examples{
s <- "bat cat can car COAT court cut ct CAT-scan"
pat <-  'c[aeiou]+t'
regexp(s, pat)
regexpi(s, pat)
}
\keyword{ string }

\name{brown72}
\alias{brown72}
\docType{data}
\title{
  Brownian Motion
}
\description{
  The Brown72 data set represents a fractal Brownian motion with
  a prescribed Hurst exponent 0f 0.72 .
}
\usage{
data(brown72)
}
\format{
  The format is: one column.
}
\details{
  Estimating the Hurst exponent for a data set provides a measure of whether
  the data is a pure random walk or has underlying trends. Brownian walks can
  be generated from a defined Hurst exponent.
}
\examples{
\dontrun{
data(brown72)
plot(brown72, type = "l", col = "blue")
grid()}
}
\keyword{ datasets }

\name{integral}
\alias{integral}
\title{
  Adaptive Numerical Integration
}
\description{
  Combines several approaches to adaptive numerical integration of 
  functions of one variable.
}
\usage{
integral(fun, xmin, xmax,
         method = c("Kronrod", "Clenshaw","Simpson"),
         no_intervals = 8, random = FALSE,
         reltol = 1e-8, abstol = 0, ...)
}
\arguments{
  \item{fun}{integrand, univariate (vectorized) function.}
  \item{xmin,xmax}{endpoints of the integration interval.}
  \item{method}{integration procedure, see below.}
  \item{no_intervals}{number of subdivisions at at start.}
  \item{random}{logical; shall the length of subdivisions be random.}
  \item{reltol}{relative tolerance.}
  \item{abstol}{absolute tolerance; not used.}
  \item{...}{additional parameters to be passed to the function.}
}
\details{
  \code{integral} combines the following methods for adaptive 
  numerical integration (also available as separate functions):
  \itemize{
    \item Kronrod (Gauss-Kronrod)
    \item Clenshaw (Clenshaw-Curtis; not yet made adaptive)
    \item Simpson (adaptive Simpson)
  }
  Recommended default method is Gauss-Kronrod. Also try Clenshaw-Curtis
  that may be faster at times.

  Most methods require that function \code{f} is vectorized. This will
  be checked and the function vectorized if necessary.
  
  By default, the integration domain is subdivided into \code{no_intervals}
  subdomains to avoid 0 results if the support of the integrand function is
  small compared to the whole domain. If \code{random} is true, nodes will
  be picked randomly, otherwise forming a regular division.

  If the interval is infinite, \code{quadinf} will be called that 
  accepts the same methods as well. [If the function is array-valued, 
  \code{quadv} is called that applies an adaptive Simpson procedure,
  other methods are ignored -- not true anymore.]
}
\value{
  Returns the integral, no error terms given.
}
\references{
  Davis, Ph. J., and Ph. Rabinowitz (1984). Methods of Numerical 
  Integration. Dover Publications, New York.
}
\note{
  \code{integral} does not provide `new' functionality, everything is 
  already contained in the functions called here. Other interesting
  alternatives are Gauss-Richardson (\code{quadgr}) and Romberg 
  (\code{romberg}) integration.
}
\seealso{
  \code{\link{quadgk}}, \code{\link{quadgr}}, \code{quadcc},
  \code{\link{simpadpt}}, \code{\link{romberg}},
  \code{\link{quadv}}, \code{\link{quadinf}}
}
\examples{
##  Very smooth function
fun <- function(x) 1/(x^4+x^2+0.9)
val <- 1.582232963729353
for (m in c("Kron", "Clen", "Simp")) {
    Q <- integral(fun, -1, 1, reltol = 1e-12, method = m)
    cat(m, Q, abs(Q-val), "\n")}
# Kron 1.582233 3.197442e-13 
# Rich 1.582233 3.197442e-13  # use quadgr()
# Clen 1.582233 3.199663e-13 
# Simp 1.582233 3.241851e-13 
# Romb 1.582233 2.555733e-13  # use romberg()

##  Highly oscillating function
fun <- function(x) sin(100*pi*x)/(pi*x)
val <- 0.4989868086930458
for (m in c("Kron", "Clen", "Simp")) {
    Q <- integral(fun, 0, 1, reltol = 1e-12, method = m)
    cat(m, Q, abs(Q-val), "\n")}
# Kron 0.4989868 2.775558e-16 
# Rich 0.4989868 4.440892e-16  # use quadgr()
# Clen 0.4989868 2.231548e-14
# Simp 0.4989868 6.328271e-15 
# Romb 0.4989868 1.508793e-13  # use romberg()

## Evaluate improper integral
fun <- function(x) log(x)^2 * exp(-x^2)
val <- 1.9475221803007815976
Q <- integral(fun, 0, Inf, reltol = 1e-12)
# For infinite domains Gauss integration is applied!
cat(m, Q, abs(Q-val), "\n")
# Kron 1.94752218028062 2.01587635473288e-11 

## Example with small function support
fun <- function(x)
            ifelse (x <= 0 | x >= pi, 0, sin(x))
integral(fun, -100, 100, no_intervals = 1)      # 0
integral(fun, -100, 100, no_intervals = 10)     # 1.99999999723
integral(fun, -100, 100, random=FALSE)          # 2
integral(fun, -100, 100, random=TRUE)           # 2 (sometimes 0 !)
integral(fun, -1000, 10000, random=FALSE)       # 0
integral(fun, -1000, 10000, random=TRUE)        # 0 (sometimes 2 !)
}
\keyword{ math }

\name{erf}
\alias{erf}
\alias{erfinv}
\alias{erfc}
\alias{erfcinv}
\alias{erfcx}
\alias{erfz}
\alias{erfi}
\title{
  Error Functions and Inverses (Matlab Style)
}
\description{
  The error or Phi function is a variant of the cumulative normal (or
  Gaussian) distribution.
}
\usage{
erf(x)
erfinv(y)
erfc(x)
erfcinv(y)
erfcx(x)

erfz(z)
erfi(z)
}
\arguments{
  \item{x, y}{vector of real numbers.}
  \item{z}{real or complex number; must be a scalar.}
}
\details{
  \code{erf} and \code{erfinv} are the error and inverse error functions.\cr
  \code{erfc} and \code{erfcinv} are the complementary error function and
  its inverse.\cr
  \code{erfcx} is the scaled complementary error function.\cr
  \code{erfz} is the complex, \code{erfi} the imaginary error function.
}
\value{
  Real or complex number(s), the value(s) of the function.
}
\author{
  First version by Hans W Borchers;
  vectorized version of \code{erfz} by Michael Lachmann.
}
\note{
  For the complex error function we used Fortran code from the book 
  S. Zhang & J. Jin ``Computation of Special Functions'' (Wiley, 1996).
}
\seealso{
  \code{\link{pnorm}}
}
\examples{
  x <- 1.0
  erf(x); 2*pnorm(sqrt(2)*x) - 1
# [1] 0.842700792949715
# [1] 0.842700792949715
  erfc(x); 1 - erf(x); 2*pnorm(-sqrt(2)*x)
# [1] 0.157299207050285
# [1] 0.157299207050285
# [1] 0.157299207050285
  erfz(x)
# [1] 0.842700792949715
  erfi(x)
# [1] 1.650425758797543
}
\keyword{ stat }

\name{meshgrid}
\alias{meshgrid}
\title{
  Generate a Mesh Grid
}
\description{
  Generate two matrices for use in three-dimensional plots.
}
\usage{
meshgrid(x, y = x)
}
\arguments{
  \item{x}{numerical vector, represents points along the x-axis.}
  \item{y}{numerical vector, represents points along the y-axis.}
}
\details{
  The rows of the output array X are copies of the vector x;
  columns of the output array Y are copies of the vector y.
}
\value{
  Returns two matrices as a list with \code{X} and \code{Y} components.
}
\note{
  The three-dimensional variant \code{meshgrid(x, y, z)} is not yet implemented.
}
\seealso{
\code{\link{outer}}
}
\examples{
meshgrid(1:5)$X
meshgrid(c(1, 2, 3), c(11, 12))
}
\keyword{ array }

\name{Poly}
\alias{Poly}
\title{Define Polynomial by Roots}
\description{
  Define a polynomial by its roots.
}
\usage{
  Poly(x)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{vector or square matrix, real or complex}
}
\details{
  Computes the characteristic polynomial of an (n x n)-Matrix.

  If \code{x} is a vector, \code{Poly(x)} is the vector of coefficients
  of the polynomial whose roots are the elements of \code{x}.
}
\value{
  Vector representing a polynomial.
}
\note{
In Matlab/Octave this function is called \code{poly()}.
}
\seealso{
  \code{\link{polyval}}, \code{\link{roots}}
}
\examples{
  Poly(c(1, -1, 1i, -1i))  # Solves x^4 -1 = 0
  # Wilkinson's example:
  roots(Poly(1:20))
}
\keyword{ math }

\name{ezplot}
\alias{ezplot}
\alias{fplot}
\title{
  Easy Function Plot
}
\description{
  Easy function plot w/o the need to define \code{x, y} coordinates.
}
\usage{
fplot(f, interval, ...)

ezplot( f, a, b, n = 101, col = "blue", add = FALSE,
        lty = 1, lwd = 1, marker = 0, pch = 1,
        grid = TRUE, gridcol = "gray", 
        fill = FALSE, fillcol = "lightgray",
        xlab = "x", ylab = "f (x)", main = "Function Plot", ...)
}
\arguments{
  \item{f}{Function to be plotted.}
  \item{interval}{interval [a, b] to plot the function in}
  \item{a, b}{Left and right endpoint for the plot.}
  \item{n}{Number of points to plot.}
  \item{col}{Color of the function graph.}
  \item{add}{logical; shall the polt be added to an existing plot.}
  \item{lty}{line type; default 1.}
  \item{lwd}{line width; default 1.}
  \item{marker}{no. of markers to be added to the curve; defailt: none.}
  \item{pch}{poimt character; default circle.}
  \item{grid}{Logical; shall a grid be plotted?; default \code{TRUE}.}
  \item{gridcol}{Color of grid points.}
  \item{fill}{Logical; shall the area between function and axis be filled?;
              default: \code{FALSE}.}
  \item{fillcol}{Color of fill area.}
  \item{xlab}{Label on the \code{x}-axis.}
  \item{ylab}{Label on the \code{y}-axis.}
  \item{main}{Title of the plot}
  \item{...}{More parameters to be passed to \code{plot}.}
}
\details{
  Calculates the \code{x, y} coordinates of points to be plotted and
  calls the \code{plot} function.

  If \code{fill} is \code{TRUE}, also calls the \code{polygon} function
  with the \code{x, y} coordinates in appropriate order.

  If the no. of \code{markers} is greater than 2, this number of markers
  will be added to the curve, with equal distances measured along the curve.
}
\value{
  Plots the function graph and invisibly returns \code{NULL}.
}
\note{
  \code{fplot} is almost an alias for \code{ezplot} as all \code{ez...} 
  will be replaced by MATLAB with function names \code{f...} in 2017.

  \code{ezplot} should mimick the Matlab function of the same name, has
  more functionality, misses the possibility to plot several functions.
}
\seealso{
  \code{\link{curve}}
}
\examples{
\dontrun{
fun <- function(x) x * cos(0.1*exp(x)) * sin(0.1*pi*exp(x))
ezplot(fun, 0, 5, n = 1001, fill = TRUE)
  }
}
\keyword{ graphs }

\name{lambertWp}
\alias{lambertWp}
\alias{lambertWn}
\title{
  Lambert's W Function
}
\description{
  Principal real branch of the Lambert W function.
}
\usage{
lambertWp(x)
lambertWn(x) 
}
\arguments{
  \item{x}{Numeric vector of real numbers \code{>= -1/e}.}
}
\details{
  The Lambert W function is the inverse of \code{x --> x e^x}, with two
  real branches, W0 for \code{x >= -1/e} and W-1 for \code{-1/e <= x < 0}.
  Here the principal branch is called \code{lambertWp}, tho other one
  \code{lambertWp}, computed for real \code{x}.

  The value is calculated using an iteration that stems from applying
  Halley's method. This iteration is quite fast and accurate.

  The functions is not really vectorized, but at least returns a vector of
  values when presented with a numeric vector of length \code{>= 2}.
}
\value{
  Returns the solution \code{w} of \code{w*exp(w) = x} for real \code{x}
  with \code{NaN} if \code{x < 1/exp(1)} (resp. \code{x >= 0} for the
  second branch).
}
\references{
  Corless, R. M., G. H.Gonnet, D. E. G Hare, D. J. Jeffrey, and D. E. Knuth
  (1996). On the Lambert W Function. Advances in Computational Mathematics,
  Vol. 5, pp. 329-359.
}
\note{
  See the examples how values for the second branch or the complex
  Lambert W function could be calculated by Newton's method.
}
\seealso{
  \code{\link{halley}}
}
\examples{
##  Examples
lambertWp(0)          #=> 0
lambertWp(1)          #=> 0.5671432904097838...  Omega constant
lambertWp(exp(1))     #=> 1
lambertWp(-log(2)/2)  #=> -log(2)

# The solution of  x * a^x = z  is  W(log(a)*z)/log(a)
# x * 123^(x-1) = 3
lambertWp(3*123*log(123))/log(123)  #=> 1.19183018...

x <- seq(-0.35, 0.0, by=0.05)
w <- lambertWn(x)
w * exp(w)            # max. error < 3e-16
# [1] -0.35 -0.30 -0.25 -0.20 -0.15 -0.10 -0.05   NaN

\dontrun{
xs <- c(-1/exp(1), seq(-0.35, 6, by=0.05))
ys <- lambertWp(xs)
plot(xs, ys, type="l", col="darkred", lwd=2, ylim=c(-2,2),
     main="Lambert W0 Function", xlab="", ylab="")
grid()
points(c(-1/exp(1), 0, 1, exp(1)), c(-1, 0, lambertWp(1), 1))
text(1.8, 0.5, "Omega constant")
  }

## Analytic derivative of lambertWp (similar for lambertWn)
D_lambertWp <- function(x) {
    xw <- lambertWp(x)
    1 / (1+xw) / exp(xw)
}
D_lambertWp(c(-1/exp(1), 0, 1, exp(1)))
# [1] Inf 1.0000000 0.3618963 0.1839397

## Second branch resp. the complex function lambertWm()
F <- function(xy, z0) {
    z <- xy[1] + xy[2]*1i
    fz <- z * exp(z) - z0
    return(c(Re(fz), Im(fz)))
}
newtonsys(F, c(-1, -1), z0 = -0.1)   #=> -3.5771520639573
newtonsys(F, c(-1, -1), z0 = -pi/2)  #=> -1.5707963267949i = -pi/2 * 1i
}
\keyword{ specfun }

\name{ezpolar}
\alias{ezpolar}
\title{
  Easy Polar Plot
}
\description{
  Easy function plot w/o the need to define \code{x, y} coordinates.
}
\usage{
ezpolar(fun, interv = c(0, 2*pi))
}
\arguments{
  \item{fun}{function to be plotted.}
  \item{interv}{left and right endpoint for the plot.}
}
\details{
  Calculates the \code{x, y} coordinates of points to be plotted and
  calls the \code{polar} function.
}
\value{
  Plots the function graph and invisibly returns \code{NULL}.
}
\note{
  Mimick the Matlab function of the same name.
}
\seealso{
  \code{\link{ezplot}}
}
\examples{
\dontrun{
fun <- function(x) 1 + cos(x)
ezpolar(fun)
  }
}
\keyword{ graphs }

\name{gradient}
\alias{gradient}
\title{
  Discrete Gradient (Matlab Style)
}
\description{
  Discrete numerical gradient.
}
\usage{
gradient(F, h1 = 1, h2 = 1)
}
\arguments{
  \item{F}{vector of function values, or a matrix of values of a function
           of two variables.}
  \item{h1}{x-coordinates of grid points, or one value for the difference
            between grid points in x-direction.}
  \item{h2}{y-coordinates of grid points, or one value for the difference
            between grid points in y-direction.}
}
\details{
  Returns the numerical gradient of a vector or matrix as a vector or matrix
  of discrete slopes in x- (i.e., the differences in horizontal direction)
  and slopes in y-direction (the differences in vertical direction).

  A single spacing value, \code{h}, specifies the spacing between points in
  every direction, where the points are assumed equally spaced.
}
\value{
  If \code{F} is a vector, one gradient vector will be returned.

  If \code{F} is a matrix, a list with two components will be returned:
  \item{X}{numerical gradient/slope in x-direction.}
  \item{Y}{numerical gradient/slope in x-direction.}
  where each matrix is of the same size as \code{F}.
}
\note{
  TODO: If \code{h2} is missing, it will not automatically be adapted.
}
\seealso{
  \code{\link{fderiv}}
}
\examples{
x <- seq(0, 1, by=0.2)
y <- c(1, 2, 3)
(M <- meshgrid(x, y))
gradient(M$X^2 + M$Y^2)
gradient(M$X^2 + M$Y^2, x, y)

\dontrun{
# One-dimensional example
x <- seq(0, 2*pi, length.out = 100)
y <- sin(x)
f <- gradient(y, x)
max(f - cos(x))      #=> 0.00067086
plot(x, y, type = "l", col = "blue")
lines(x, cos(x), col = "gray", lwd = 3)
lines(x, f, col = "red")
grid()

# Two-dimensional example
v <- seq(-2, 2, by=0.2)
X <- meshgrid(v, v)$X
Y <- meshgrid(v, v)$Y

Z <- X * exp(-X^2 - Y^2)
image(v, v, t(Z))
contour(v, v, t(Z), col="black", add = TRUE)
grid(col="white")

grX <- gradient(Z, v, v)$X
grY <- gradient(Z, v, v)$Y

quiver(X, Y, grX, grY, scale = 0.2, col="blue")
}
}
\keyword{ math }

\name{interp2}
\alias{interp2}
\title{
  Two-dimensional Data Interpolation
}
\description{
  Two-dimensional data interpolation similar to a table look-up.
}
\usage{
    interp2(x, y, Z, xp, yp, method = c("linear", "nearest", "constant"))
}
\arguments{
  \item{x, y}{vectors with monotonically increasing elements, representing
              x- and y-coordinates of the data values in \code{Z}.}
  \item{Z}{numeric \code{length(y)}-by-\code{length(x)} matrix.}
  \item{xp, yp}{x-, y-coordinates of points at which interpolated values
                will be computed.}
  \item{method}{interpolation method, ``linear'' the most useful.}
}
\details{
   Computes a vector containing elements corresponding to the elements of
   \code{xp} and \code{yp}, determining by interpolation within the
   two-dimensional function specified by vectors \code{x} and \code{y},
   and matrix \code{Z}.
   
   \code{x} and \code{y} must be monotonically increasing. They specify
   the points at which the data \code{Z} is given.
   Therefore, \code{length(x) = nrow(Z)} and \code{length(y) = ncol(Z)}
   must be satisfied.

  \code{xp} and \code{yp} must be of the same length.

  The functions appears vectorized as \code{xp}, \code{yp} can be
  vectors, but internally they are treated in a \code{for} loop.
}
\value{
  Vector the length of \code{xp} of interpolated values.

  For methods ``constant'' and ``nearest'' the intervals are considered
  closed from left and below. Out of range values are returned as NAs.
}
\note{
  The corresponding Matlab function has also the methods ``cubic'' and
  ``spline''. If in need of a nonlinear interpolation, take a look at
  \code{barylag2d} in this package and the example therein.
}
\seealso{
  \code{\link{interp1}}, \code{barylag2d}
}
\examples{
\dontrun{
    x <- linspace(-1, 1, 11)
    y <- linspace(-1, 1, 11)
    mgrid <- meshgrid(x, y)
    Z <- mgrid$X^2 + mgrid$Y^2
    xp <- yp <- linspace(-1, 1, 101)

    method <- "linear"
    zp <- interp2(x, y, Z, xp, yp, method)
    plot(xp, zp, type = "l", col = "blue")

    method = "nearest"
    zp <- interp2(x, y, Z, xp, yp, method)
    lines(xp, zp, col = "red")
    grid()}
}
\keyword{ math }

\name{fletcher_powell}
\alias{fletcher_powell}
\title{
  Fletcher-Powell Conjugate Gradient Minimization
}
\description{
  Conjugate Gradient (CG) minimization through the Davidon-Fletcher-Powell 
  approach for function minimization.

  The Davidon-Fletcher-Powell (DFP) and the Broyden-Fletcher-Goldfarb-Shanno
  (BFGS) methods are the first quasi-Newton minimization methods developed.
  These methods differ only in some details; in general, the BFGS approach
  is more robust.
}
\usage{
fletcher_powell(x0, f, g = NULL,
                maxiter = 1000, tol = .Machine$double.eps^(2/3))
}
\arguments{
  \item{x0}{start value.}
  \item{f}{function to be minimized.}
  \item{g}{gradient function of \code{f};
           if \code{NULL}, a numerical gradient will be calculated.}
  \item{maxiter}{max. number of iterations.}
  \item{tol}{relative tolerance, to be used as stopping rule.}
}
\details{
  The starting point is Newton's method in the multivariate case, when
  the estimate of the minimum is updated by the following equation
  \deqn{x_{new} = x - H^{-1}(x) grad(g)(x)}
  where \eqn{H} is the Hessian and \eqn{grad} the gradient.

  The basic idea is to generate a sequence of good approximations to the
  inverse Hessian matrix, in such a way that the approximations are again
  positive definite.
}
\value{
  List with following components:
    \item{xmin}{minimum solution found.}
    \item{fmin}{value of \code{f} at minimum.}
    \item{niter}{number of iterations performed.}
}
\references{
  J. F. Bonnans, J. C. Gilbert, C. Lemarechal, and C. A. Sagastizabal.
  Numerical Optimization: Theoretical and Practical Aspects. Second Edition,
  Springer-Verlag, Berlin Heidelberg, 2006.
}
\note{
  Used some Matlab code as described in the book ``Applied Numerical Analysis
  Using Matlab'' by L. V.Fausett.
}
\seealso{
  \code{\link{steep_descent}}
}
\examples{
##  Rosenbrock function
rosenbrock <- function(x) {
    n <- length(x)
    x1 <- x[2:n]
    x2 <- x[1:(n-1)]
    sum(100*(x1-x2^2)^2 + (1-x2)^2)
}
fletcher_powell(c(0, 0), rosenbrock)
# $xmin
# [1] 1 1
# $fmin
# [1] 1.774148e-27
# $niter
# [1] 14
}
\keyword{ optimize }

\name{nchoosek}
\alias{nchoosek}
\title{
Binomial Coefficients
}
\description{
  Compute the Binomial coefficients.
}
\usage{
nchoosek(n, k)
}
\arguments{
  \item{n, k}{integers with \code{k} between 0 and \code{n}}
}
\details{
  Alias for the corresponding R function \code{choose}.
}
\value{
  integer, the Binomial coefficient \eqn{({n \over k})}.
}
\note{
  In Matlab/Octave, if \code{n} is a vector all combinations of \code{k}
  elements from vector \code{n} will be generated. Here, use the function
  \code{combs} instead.
}
\seealso{
\code{\link{choose}}
}
\examples{
S <- sapply(0:6, function(k) nchoosek(6, k))  # 1  6 15 20 15  6  1

# Catalan numbers
catalan <- function(n) choose(2*n, n)/(n+1)
catalan(0:10)
# 1  1  2  5  14  42  132  429  1430  4862  16796

# Relations
n <- 10
sum((-1)^c(0:n) * sapply(0:n, function(k) nchoosek(n, k)))  # 0
}
\keyword{ arith }

\name{linspace}
\alias{linspace}
\title{Linearly Spaced Sequences}
\description{
  Generate linearly spaced sequences.
}
\usage{
  linspace(x1, x2, n = 100)
}
\arguments{
  \item{x1}{numeric scalar specifying starting point}
  \item{x2}{numeric scalar specifying ending point}
  \item{n}{numeric scalar specifying number of points to be generated}
}
\details{
  These functions will generate \code{n} linearly spaced points between
  \code{x1} and \code{x2}.

  If \eqn{n < 2}, the result will be the ending point \code{x2}.
}
\value{
  vector containing \code{n} points between \code{x1} and \code{x2} inclusive.
}
\seealso{
  \code{\link{logspace}}, \code{\link{seq}}
}
\examples{
linspace(1, 10, 9)
}
\keyword{ manip }

\name{mexpfit}
\alias{mexpfit}
\title{
  Multi-exponential Fitting
}
\description{
  Multi-exponential fitting means fitting of data points by a sum of
  (decaying) exponential functions, with or without a constant term.
}
\usage{
mexpfit(x, y, p0, w = NULL, const = TRUE, options = list())
}
\arguments{
  \item{x, y}{x-, y-coordinates of data points to be fitted.}
  \item{p0}{starting values for the exponentials alone; can be positive
            or negative, but not zero.}
  \item{w}{weight vector; not used in this version.}
  \item{const}{logical; shall an absolute term be included.}
  \item{options}{list of options for \code{lsqnonlin}, see there.}
}
\details{
  The multi-exponential fitting problem is solved here with with a separable
  nonlinear least-squares approach. If the following function is to be fitted,
  \deqn{y = a_0 + a_1 e^{b_1 x} + \ldots + a_n e^{b_n x}}
  it will be looked at as a nonlinear optimization problem of the coefficients
  \eqn{b_i} alone. Given the \eqn{b_i}, coefficients \eqn{a_i} are uniquely
  determined as solution of an (overdetermined) system of linear equations.

  This approach reduces the dimension of the search space by half and improves
  numerical stability and accuracy. As a convex problem, the solution is unique
  and global.

  To solve the nonlinear part, the function \code{lsqnonlin} that uses the
  Levenberg-Marquard algorithm will be applied.
}
\value{
  \code{mexpfit} returns a list with the following elements:
  \itemize{
    \item \code{a0}: the absolute term, 0 if \code{const} is false.
    \item \code{a}: linear coefficients.
    \item \code{b}: coefficient in the exponential functions.
    \item \code{ssq}: the sum of squares for the final fitting.
    \item \code{iter}: number of iterations resp. function calls.
    \item \code{errmess}: an error or info message.
  }
}
\note{
  As the Jacobian for this expression is known, a more specialized approch
  would be possible, without using \code{lsqnonlin};
  see the \code{immoptibox} of H. B. Nielsen, Techn. University of Denmark.
}
\author{
  HwB  email: <hwborchers@googlemail.com>
}
\references{
  Madsen, K., and H. B. Nielsen (2010). Introduction to Optimization and
  Data Fitting. Technical University of Denmark, Intitute of Computer
  Science and Mathematical Modelling.

  Nielsen, H. B. (2000). Separable Nonlinear Least Squares. IMM, DTU,
  Report IMM-REP-2000-01.
}
\seealso{
  \code{\link{lsqsep}}, \code{\link{lsqnonlin}}
}
\examples{
#   Lanczos1 data (artificial data)
#   f(x) = 0.0951*exp(-x) + 0.8607*exp(-3*x) + 1.5576*exp(-5*x)
x <- linspace(0, 1.15, 24)
y <- c(2.51340000, 2.04433337, 1.66840444, 1.36641802, 1.12323249, 0.92688972,
       0.76793386, 0.63887755, 0.53378353, 0.44793636, 0.37758479, 0.31973932,
       0.27201308, 0.23249655, 0.19965895, 0.17227041, 0.14934057, 0.13007002,
       0.11381193, 0.10004156, 0.08833209, 0.07833544, 0.06976694, 0.06239313)
p0 <- c(-0.3, -5.5, -7.6)
mexpfit(x, y, p0, const = FALSE)
## $a0
## [1] 0
## $a
## [1] 0.09510431 0.86071171 1.55758398
## $b
## [1] -1.000022 -3.000028 -5.000009
## $ssq
## [1] 1.936163e-16
## $iter
## [1] 26
## $errmess
## [1] "Stopped by small gradient."
}
\keyword{ fitting }

\name{strjust}
\alias{strjust}
\title{
  Justify character vector
}
\description{
  Justify the strings in a character vector.
}
\usage{
strjust(s, justify = c("left", "right", "center"))
}
\arguments{
  \item{s}{Character vector.}
  \item{justify}{Whether to justify left, right, or centered.}
}
\details{
  \code{strjust(s)} or \code{strjust(s, justify = ``right'')} returns
  a right-justified character vector. All strings have the same length,
  the length of the longest string in \code{s} --- but the strings in
  \code{s} have been trimmed before.

  \code{strjust(s, justify = ``left'')} does the same, with all strings
  left-justified.

  \code{strjust(s, justify = ``centered'')} returns all string in \code{s}
  centered. If an odd number of blanks has to be added, one blank more is
  added to the left than to the right.
}
\value{
  A character vector of the same length.
}
\seealso{
\code{\link{strTrim}}
}
\examples{
S <- c("abc", "letters", "1", "2  2")
strjust(S, "left")
}
\keyword{ string }

\name{quadl}
\alias{quadl}
\title{
Adaptive Lobatto Quadrature
}
\description{
  Adaptive quadrature of functions of one variable over a finite interval.
}
\usage{
quadl(f, xa, xb, tol = .Machine$double.eps^0.5, trace = FALSE, ...)
}
\arguments{
  \item{f}{a one-dimensional function; needs to be vectorized.}
  \item{xa}{lower limit of integration; must be finite}
  \item{xb}{upper limit of integration; must be finite}
  \item{tol}{accuracy requested.}
  \item{trace}{logical; shall a trace be printed?}
  \item{\dots}{additional arguments to be passed to \code{f}.}
}
\details{
  Realizes adaptive Lobatto quadrature in R through recursive calls.

  The function \code{f} needs to be vectorized though this could be changed
  easily.
}
\value{
  A single numeric value, the computed integral.
}
\references{
  Gander, W. and W. Gautschi (2000). ``Adaptive Quadrature --- Revisited''.
  BIT, Vol. 40, 2000, pp. 84-101.
}
\author{
  Copyright (c) 1998 Walter Gautschi for the Matlab version published as
  part of the referenced article. R implementation by Hans W Borchers 2011.
}
\note{
Compared to Gaussian quadrature, Lobatto integration include the end points
of the integration interval. It is accurate for polynomials up to degree
2n-3, where n is the number of integration points.
}
\seealso{
\code{\link{quad}}
}
\examples{
# options(digits=15)
f <- function(x) x * cos(0.1*exp(x)) * sin(0.1*pi*exp(x))
quadl(f, 0, 4)              # 1.2821290743501
integrate(f, 0, 4)
# 1.28212907435010 with absolute error < 4.1e-06

\dontrun{
xx <- seq(0, 4, length.out = 200)
yy <- f(xx)
plot(xx, yy, type = 'l')
grid()}
}
\keyword{ math }

\name{ezcontour,ezsurf,ezmesh}
\alias{ezcontour}
\alias{ezsurf}
\alias{ezmesh}
\title{
  Contour, Surface, and Mesh Plotter
}
\description{
  Easy-to-use contour and 3-D surface resp mesh plotter.
}
\usage{
ezcontour(f, xlim = c(-pi,pi), ylim = c(-pi,pi), 
          n = 60, filled = FALSE, col = NULL)

ezsurf(f, xlim = c(-pi, pi), ylim = c(-pi, pi),
       n = 60, ...)

ezmesh(f, xlim = c(-pi,pi), ylim = c(-pi,pi), 
       n = 60, ...)
}
\arguments{
  \item{f}{2-D function to be plotted, must accept \code{(x,y)} as a vector.}
  \item{xlim, ylim}{defines x- and y-ranges as intervals.}
  \item{n}{number of grid points in each direction.}
  \item{col}{colour of isolines lines, resp. the surface color.}
  \item{filled}{logical; shall the contour plot be }
  \item{...}{parameters to be passed to the \code{persp} function.}
}
\details{
  \code{ezcontour} generates a contour plot of the function \code{f} using 
  \code{contour} (and \code{image} if \code{filled=TRUE} is chosen).
  If \code{filled=TRUE} is chosen, \code{col} should be a color scheme,
  the default is \code{heat.colors(12)}.

  \code{ezsurf} resp. \code{ezmesh} generates a surface/mesh plot of the 
  function \code{f} using \code{persp}.

  The function \code{f} needs not be vectorized in any form.
}
\value{
  Plots the function graph and invisibly returns \code{NULL}.
}
\note{
  Mimicks Matlab functions of the same names; Matlab's \code{ezcontourf} can 
  be generated with \code{filled=TRUE}.
}
\seealso{
  \code{\link{contour}}, \code{\link{image}}, \code{\link{persp}}
}
\examples{
\dontrun{
f <- function(xy) {
    x <- xy[1]; y <- xy[2]
    3*(1-x)^2 * exp(-(x^2) - (y+1)^2) -
        10*(x/5 - x^3 - y^5) * exp(-x^2 - y^2) -
        1/3 * exp(-(x+1)^2 - y^2)
    }
ezcontour(f, col = "navy")
ezcontour(f, filled = TRUE)
ezmesh(f)
ezmesh(f, col="lightblue", theta = -15, phi = 30)
  }
}
\keyword{ graphs }

\name{curvefit}
\alias{curvefit}
\title{
  Parametric Curve Fit
}
\description{
  Polynomial fitting of parametrized points on 2D curves, also
  requiring to meet some points exactly.
}
\usage{
curvefit(u, x, y, n, U = NULL, V = NULL)
}
\arguments{
  \item{u}{the parameter vector.}
  \item{x, y}{x-, y-coordinates for each parameter value.}
  \item{n}{order of the polynomials, the same in x- and y-dirction.}
  \item{U}{parameter values where points will be fixed.}
  \item{V}{matrix with two columns and \code{lemgth(U)} rows;
           first column contains the x-, the second the y-values of those
           points kept fixed.}
}
\details{
  This function will attempt to fit two polynomials to parametrized curve 
  points using the linear least squares approach with linear equality 
  constraints in \code{lsqlin}. The requirement to meet exactly some fixed 
  points is interpreted as a linear equality constraint.
}
\value{
  Returns a list with 4 components, \code{xp} and \code{yp} coordinates of 
  the fitted points, and \code{px} and \code{py} the coefficients of the
  fitting polynomials in x- and y-direction.
}
\note{
  In the same manner, derivatives/directions could be prescribed at certain
  points.
}
\seealso{
  \code{\link{circlefit}}, \code{\link{lsqlin}}
}
\examples{
##  Approximating half circle arc with small perturbations
N <- 50
u <- linspace(0, pi, N)
x <- cos(u) + 0.05 * randn(1, N)
y <- sin(u) + 0.05 * randn(1, N)
n <- 8
cfit1 <- curvefit(u, x, y, n)
\dontrun{
plot(x, y, col = "darkgray", pch = 19, asp = 1)
xp <- cfit1$xp; yp <- cfit1$yp
lines(xp, yp, col="blue")
grid()}

##  Fix the end points at t = 0 and t = pi
U <- c(0, pi)
V <- matrix(c(1, 0, -1, 0), 2, 2, byrow = TRUE)
cfit2 <- curvefit(u, x, y, n, U, V)
\dontrun{
xp <- cfit2$xp; yp <- cfit2$yp
lines(xp, yp, col="red")}

\dontrun{
##  Archimedian spiral
n <- 8
u <- linspace(0, 3*pi, 50)
a <- 1.0
x <- as.matrix(a*u*cos(u))
y <- as.matrix(a*u*sin(u))
plot(x, y, type = "p", pch = 19, col = "darkgray", asp = 1)
lines(x, y, col = "darkgray", lwd = 3)
cfit <- curvefit(u, x, y, n)
px <- c(cfit$px); py <- c(cfit$py)
v <- linspace(0, 3*pi, 200)
xs <- polyval(px, v)
ys <- polyval(py, v)
lines(xs, ys, col = "navy")
grid()}
}
\keyword{ fitting }

\name{strTrim}
\alias{strTrim}
\alias{deblank}
\title{
  Remove leading and trailing white space.
}
\description{
  Removes leading and trailing white space from a string.
}
\usage{
strTrim(s)
deblank(s)
}
\arguments{
  \item{s}{character string or character vector}
}
\details{
  \code{strTrim} removes leading and trailing white space from a string or
  from all strings in a character vector.

  \code{deblank} removes trailing white space only from a string or
  from all strings in a character vector.  
}
\value{
  A character string or character vector with (leading and) trailing
  white space.
}
\seealso{
\code{\link{strjust}}
}
\examples{
s <- c("  abc", "abc   ", " abc ", " a b c ", "abc", "a b c")
strTrim(s)
deblank(s)
}
\keyword{ string }

\name{sind,cosd,tand, etc.}
\alias{sind}
\alias{cosd}
\alias{tand}
\alias{cotd}
\alias{asind}
\alias{acosd}
\alias{atand}
\alias{acotd}
\alias{secd}
\alias{cscd}
\alias{asecd}
\alias{acscd}
\alias{atan2d}
\title{
  Trigonometric Functions in Degrees
}
\description{
  Trigonometric functions expecting input in degrees, not radians.
}
\usage{
sind(x)
cosd(x)
tand(x)
cotd(x)
asind(x)
acosd(x)
atand(x)
acotd(x)
secd(x)
cscd(x)
asecd(x)
acscd(x)
atan2d(x1, x2)
}
\arguments{
  \item{x, x1, x2}{numeric or complex scalars or vectors}
}
\details{
  The usual trigonometric functions with input values as scalar or vector
  in degrees. Note that \code{tan(x)} with fractional part does not return
  \code{NaN} as \code{tanpi(x)}, but is computed as \code{sind(x)/cosd(x)}.

  For \code{atan2d} the inputs \code{x1,x2} can be both degrees or radians,
  but don't mix! The result is in degrees, of course.
}
\value{
  Returns a scalar or vector of numeric values.
}
\note{
  These function names are available in Matlab, that is the reason
  they have been added to the `pracma' package.
}
\seealso{
  Other trigonometric functions in R.
}
\examples{
# sind(x) and cosd(x) are accurate for x which are multiples
# of 90 and 180 degrees, while tand(x) is problematic.

x <- seq(0, 720, by = 90)
sind(x)                     # 0  1  0 -1  0  1  0 -1  0
cosd(x)                     # 1  0 -1  0  1  0 -1  0  1
tand(x)                     # 0  Inf  0  -Inf  0  Inf  0  -Inf  0
cotd(x)                     # Inf  0  -Inf  0  Inf  0  -Inf  0  Inf

x <- seq(5, 85, by = 20)
asind(sind(x))              # 5 25 45 65 85
asecd(sec(x))
tand(x)                     # 0.08748866  0.46630766  1.00000000  ...
atan2d(1, 1)                # 45
}
\keyword{ math }

\name{polyder}
\alias{polyder}
\title{Derivative of Polynomial}
\description{
  Differentiate polynomials.
}
\usage{
  polyder(p, q)
}
\arguments{
  \item{p}{polynomial \code{p} given as a vector}
  \item{q}{polynomial \code{p} given as a vector}
}
\details{
  Calculates the derivative of polynomials and polynomial products.

  \code{polyder(p)} returns the derivative of \code{p} while
  \code{polyder(p, q)} returns the derivative of the product of the
  polynomials \code{p} and \code{q}.
}
\value{
  a vector representing a polynomial
}
\seealso{
    \code{\link{polyval}}, \code{\link{polyint}}
}
\examples{
  polyder(c(3, 6, 9), c(1, 2, 0))  # 12 36 42 18
}
\keyword{ math }

\name{ode23}
\alias{ode23}
\alias{ode23s}
\alias{ode45}
\alias{ode78}
\title{
  Non-stiff (and stiff) ODE solvers
}
\description{
  Runge-Kutta (2, 3)-method with variable step size, resp. (4,5)-method
  with Dormand-Price coefficients, or (7,8)-pairs with Fehlberg coefficients.
  The function \code{f(t, y)} has to return the derivative as a column vector.
}
\usage{
ode23(f, t0, tfinal, y0, ..., rtol = 1e-3, atol = 1e-6)

ode23s(f, t0, tfinal, y0, jac = NULL, ...,
            rtol = 1e-03, atol = 1e-06, hmax = 0.0)

ode45(f, t0, tfinal, y0, ..., atol = 1e-6, hmax = 0.0)
ode78(f, t0, tfinal, y0, ..., atol = 1e-6, hmax = 0.0)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)};\cr
           defined as a function \eqn{R \times R^m \rightarrow R^m}, where
           \eqn{m} is the number of equations.}
  \item{t0, tfinal}{start and end points of the interval.}
  \item{y0}{starting values as column vector;
    for \eqn{m} equations \code{u0} needs to be a vector of length \code{m}.}
  \item{jac}{jacobian of \code{f} as a function of \code{x} alone;
    if not specified, a finite difference approximation will be used.}
  \item{rtol, atol}{relative and absolute tolerance.}
  \item{hmax}{maximal step size, default is \code{(tfinal - t0)/10.}}
  \item{...}{Additional parameters to be passed to the function.}
}
\details{
  \code{ode23} is an integration method for systems of ordinary differential
  equations using second and third order Runge-Kutta-Fehlberg formulas with
  automatic step-size.

  \code{ode23s} can be used to solve a stiff system of ordinary differential
  equations, based on a modified Rosenbrock triple method of order (2,3);
  See section 4.1 in [Shampine and Reichelt].

  \code{ode45} implements Dormand-Prince (4,5) pair that minimizes the local
  truncation error in the 5th-order estimate which is what is used to step
  forward (local extrapolation). Generally it produces more accurate results
  and costs roughly the same computationally.

  \code{ode78} implements Fehlberg's (7,8) pair and is a 7th-order accurate
  integrator therefore the local error normally expected is O(h^8).  However,
  because this particular implementation uses the 8th-order estimate for xout
  (i.e. local extrapolation) moving forward with the 8th-order estimate will
  yield errors on the order of O(h^9). It requires 13 function evaluations per
  integration step.
}
\value{
  List with components \code{t} for grid (or `time') points between \code{t0}
  and \code{tfinal}, and \code{y} an n-by-m matrix with solution variables in
  columns, i.e. each row contains one time stamp.
}
\references{
  Ascher, U. M., and L. R. Petzold (1998). Computer Methods for Ordinary
  Differential Equations and Differential-Algebraic Equations. SIAM.

  L.F. Shampine and M.W. Reichelt (1997). The MATLAB ODE Suite.
  SIAM Journal on Scientific Computing, Vol. 18, pp. 1-22.

  Moler, C. (2004). Numerical Computing with Matlab. Revised Reprint, SIAM.
  \url{https://www.mathworks.com/moler/chapters.html}.
}
\note{
  Copyright (c) 2004 C. Moler for the Matlab textbook version \code{ode23tx}.
}
\seealso{
  \code{\link{rk4sys}}, \code{\link{deval}}
}
\examples{
##  Example1: Three-body problem
f <- function(t, y)
		as.matrix(c(y[2]*y[3], -y[1]*y[3], 0.51*y[1]*y[2]))
y0 <- as.matrix(c(0, 1, 1))
t0 <- 0; tf <- 20
sol <- ode23(f, t0, tf, y0, rtol=1e-5, atol=1e-10)
\dontrun{
matplot(sol$t, sol$y, type = "l", lty = 1, lwd = c(2, 1, 1),
        col = c("darkred", "darkblue", "darkgreen"),
        xlab = "Time [min]", ylab= "",
        main = "Three-body Problem")
grid()}

##  Example2: Van der Pol Equation
#   x'' + (x^2 - 1) x' + x = 0
f <- function(t, x)
        as.matrix(c(x[1] * (1 - x[2]^2) -x[2], x[1]))
t0 <- 0; tf <- 20
x0 <- as.matrix(c(0, 0.25))
sol <- ode23(f, t0, tf, x0)
\dontrun{
plot(c(0, 20), c(-3, 3), type = "n",
     xlab = "Time", ylab = "", main = "Van der Pol Equation")
lines(sol$t, sol$y[, 1], col = "blue")
lines(sol$t, sol$y[, 2], col = "darkgreen")
grid()}

##  Example3: Van der Pol as stiff equation
vdP  <- function(t,y) as.matrix(c(y[2], 10*(1-y[1]^2)*y[2]-y[1]))
ajax <- function(t, y)
            matrix(c(0, 1, -20*y[1]*y[2]-1, 10*(1-y[1]^2)), 2,2, byrow = TRUE)
sol <- ode23s(vdP, t0, tf, c(2, 0), jac = ajax, hmax = 1.0)
\dontrun{
plot(sol$t, sol$y[, 1], col = "blue")
lines(sol$t, sol$y[, 1], col = "blue")
lines(sol$t, sol$y[, 2]/8, col = "red", lwd = 2)
grid()}

##  Example4: pendulum
m = 1.0;  l = 1.0   # [kg] resp. [m]
g = 9.81; b = 0.7   # [m/s^2] resp. [N s/m]
fp = function(t, x)
        c( x[2] , 1/(1/3*m*l^2)*(-b*x[2]-m*g*l/2*sin(x[1])) )
t0 <- 0.0; tf <- 5.0; hmax = 0.1
y0 = c(30*pi/180, 0.0)
sol = ode45(fp, t0, tf, y0, hmax = 0.1)
\dontrun{
matplot(sol$t, sol$y, type = "l", lty = 1)
grid()}

##  Example: enforced pendulum
g <- 9.81
L <- 1.0; Y <- 0.25; w <- 2.5
f <- function(t, y) {
    as.matrix(c(y[2], -g/L * sin(y[1]) + w^2/L * Y * cos(y[1]) * sin(w*t)))
}
y0 <- as.matrix(c(0, 0))
sol <- ode78(f, 0.0, 60.0, y0, hmax = 0.05)
\dontrun{
plot(sol$t, sol$y[, 1], type="l", col="blue")
grid()}
}
\keyword{ ode }

\name{tic,toc}
\alias{tic}
\alias{toc}
\title{MATLAB timer functions}
\description{
  Provides stopwatch timer. Function \code{tic} starts the timer and \code{toc}
  updates the elapsed time since the timer was started. 
}
\usage{
tic(gcFirst=FALSE)
toc(echo=TRUE)
}
\arguments{
  \item{gcFirst}{logical scalar. If \code{TRUE}, perform garbage collection
    prior to starting stopwatch}
  \item{echo}{logical scalar. If \code{TRUE}, print elapsed time to screen}
}
\details{
  Provides analog to \code{\link[base]{system.time}}.
  Function \code{toc} can be invoked multiple times in a row.
}
\value{
  \code{toc} invisibly returns the elapsed time as a named scalar (vector).
}
\examples{
tic()
for(i in 1:100) mad(runif(1000))	# kill time
toc()
}
\author{
  P. Roebuck \email{proebuck@mdanderson.org}
}
\keyword{utilities}

\name{qrSolve}
\alias{qrSolve}
\title{LSE Solution}
\description{
  Systems of linear equations via QR decomposition.
}
\usage{
  qrSolve(A, b)
}
\arguments{
  \item{A}{numerical matrix with \code{nrow(A)>=ncol(A)}.}
  \item{b}{numerical vector with \code{length(b) == nrow(A)}.}
}
\details{
  Solves (overdetermined) systems of linear equations via QR decomposition. 
}
\value{
  The solution of the system as vector.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Society for Industrial and Applied Mathematics, Philadelphia.
}
\seealso{
  \code{\link{householder}}
}
\examples{
A <- matrix(c(0,-4,2, 6,-3,-2, 8,1,-1), 3, 3, byrow=TRUE)
b <- c(-2, -6, 7)
qrSolve(A, b)

##  Solve an overdetermined linear system of equations
A <- matrix(c(1:8,7,4,2,3,4,2,2), ncol=3, byrow=TRUE)
b <- rep(6, 5)
x <- qrSolve(A, b)
qr.solve(A, rep(6, 5)); x
}
\keyword{ array }

\name{kriging}
\alias{kriging}
\title{
  Interpolation by Kriging
}
\description{
  Simple and ordinary Kriging interpolation and interpolating function.
}
\usage{
kriging(u, v, u0, type = c("ordinary", "simple"))
}
\arguments{
  \item{u}{an \code{nxm}-matrix of n points in the m-dimensional space.}
  \item{v}{an \code{n}-dim. (column) vector of interpolation values.}
  \item{u0}{a \code{kxm}-matrix of k points in \code{R^m} to be interpolated.}
  \item{type}{character; values `simple' or `ordinary'; no partial matching.}
}
\details{
  Kriging is a geo-spatial estimation procedure that estimates points based
  on the variations of known points in a non-regular grid. It is especially
  suited for surfaces.
}
\note{
  In the literature, different versions and extensions are discussed.
}
\value{
  \code{kriging} returns a \code{k}-dim. vektor of interpolation values.
}
\references{
  Press, W. H., A. A. Teukolsky, W. T. Vetterling, and B. P. Flannery (2007).
  Numerical recipes: The Art of Scientific Computing (3rd Ed.). Cambridge
  University Press, New York, Sect. 3.7.4, pp. 144-147.
}
\seealso{
  \code{\link{akimaInterp}}, \code{\link{barylag2d}}, package \code{kriging}
}
\examples{
##  Interpolate the Saddle Point function
f <- function(x) x[1]^2 - x[2]^2       # saddle point function

set.seed(8237)
n <- 36
x <- c(1, 1, -1, -1, runif(n-4, -1, 1)) # add four vertices
y <- c(1, -1, 1, -1, runif(n-4, -1, 1))
u <- cbind(x, y)
v <- numeric(n)
for (i in 1:n) v[i] <- f(c(x[i], y[i]))

kriging(u, v, c(0, 0))                      #=>  0.006177183
kriging(u, v, c(0, 0), type = "simple")     #=>  0.006229557

\dontrun{
xs <- linspace(-1, 1, 101)              # interpolation on a diagonal
u0 <- cbind(xs, xs)

yo <- kriging(u, v, u0, type = "ordinary")  # ordinary kriging
ys <- kriging(u, v, u0, type = "simple")    # simple kriging
plot(xs, ys, type = "l", col = "blue", ylim = c(-0.1, 0.1),
             main = "Kriging interpolation along the diagonal")
lines(xs, yo, col = "red")
legend( -1.0, 0.10, c("simple kriging", "ordinary kriging", "function"),
        lty = c(1, 1, 1), lwd = c(1, 1, 2), col=c("blue", "red", "black"))
grid()
lines(c(-1, 1), c(0, 0), lwd = 2)}

##  Find minimum of the sphere function
f <- function(x, y) x^2 + y^2 + 100
v <- bsxfun(f, x, y)

ff <- function(w) kriging(u, v, w)
ff(c(0, 0))                                 #=>  100.0317
\dontrun{
optim(c(0.0, 0.0), ff)
# $par:   [1]  0.04490075 0.01970690
# $value: [1]  100.0291
ezcontour(ff, c(-1, 1), c(-1, 1))
points(0.04490075, 0.01970690, col = "red")}
}
\keyword{ fitting }

\name{isprime}
\alias{isprime}
\title{isprime Property}
\description{
  Vectorized version, returning for a vector or matrix of positive integers
  a vector of the same size containing 1 for the elements that are prime and
  0 otherwise.
}
\usage{
  isprime(x)
}
\arguments{
  \item{x}{vector or matrix of nonnegative integers}
}
\details{
  Given an array of positive integers returns an array of the same size
  of 0 and 1, where the i indicates a prime number in the same position.
}
\value{
  array of elements 0, 1 with 1 indicating prime numbers
}
\seealso{
  \code{\link{factors}, \link{primes}}
}
\examples{
  x <- matrix(1:10, nrow=10, ncol=10, byrow=TRUE)
  x * isprime(x)

  # Find first prime number octett:
  octett <- c(0, 2, 6, 8, 30, 32, 36, 38) - 19
  while (TRUE) {
      octett <- octett + 210
      if (all(as.logical(isprime(octett)))) {
          cat(octett, "\n", sep="  ")
          break
      }
  }
}
\keyword{ math }

\name{vectorfield}
\alias{vectorfield}
\title{
  Vector Field Plotting
}
\description{
  Plotting a vector field
}
\usage{
vectorfield(fun, xlim, ylim, n = 16,
            scale = 0.05, col = "green", ...)
}
\arguments{
  \item{fun}{function of two variables --- must be vectorized.}
  \item{xlim}{range of \code{x} values.}
  \item{ylim}{range of \code{y} values.}
  \item{n}{grid size, proposed 16 in each direction.}
  \item{scale}{scales the length of the arrows.}
  \item{col}{arrow color, proposed `green'.}
  \item{...}{more options presented to the \code{arrows} primitive.}
}
\details{
  Plots a vector field for a function \code{f}. Main usage could be to plot
  the solution of a differential equation into the same graph.
}
\value{
  Opens a graph window and plots the vector field.
}
\seealso{
  \code{\link{quiver}}, \code{\link{arrows}}
}
\examples{
f <- function(x, y) x^2 - y^2
xx <- c(-1, 1); yy <- c(-1, 1)
\dontrun{
vectorfield(f, xx, yy, scale = 0.1)
for (xs in seq(-1, 1, by = 0.25)) {
    sol <- rk4(f, -1, 1, xs, 100)
    lines(sol$x, sol$y, col="darkgreen")
}
grid()}
}
\keyword{ graphs }

\name{trapz}
\alias{trapz}
\alias{cumtrapz}
\alias{trapzfun}
\title{Trapezoidal Integration}
\description{
  Compute the area of a function with values \code{y} at the points
  \code{x}.
}
\usage{
  trapz(x, y)
  cumtrapz(x, y)

  trapzfun(f, a, b, maxit = 25, tol = 1e-07, ...)
}
\arguments{
  \item{x}{x-coordinates of points on the x-axis}
  \item{y}{y-coordinates of function values}
  \item{f}{function to be integrated.}
  \item{a, b}{lower and upper border of the integration domain.}
  \item{maxit}{maximum number of steps.}
  \item{tol}{tolerance; stops when improvements are smaller.}
  \item{...}{arguments passed to the function.}
}
\details{
  The points \code{(x, 0)} and \code{(x, y)} are taken as vertices of a
  polygon and the area is computed using \code{polyarea}. This approach
  matches exactly the approximation for integrating the function using the
  trapezoidal rule with basepoints \code{x}.

  \code{cumtrapz} computes the cumulative integral of \code{y} with respect 
  to \code{x} using trapezoidal integration. \code{x} and \code{y} must be
  vectors of the same length, or \code{x} must be a vector and \code{y} a
  matrix whose first dimension is \code{length(x)}.
  
  Inputs \code{x} and \code{y} can be complex.

  \code{trapzfun} realizes trapezoidal integration and stops when the
  differencefrom one step to the next is smaller than tolerance (or the
  of iterations get too big). The function will only be evaluated once
  on each node.
}
\value{
  Approximated integral of the function, discretized through the points
  \code{x, y}, from \code{min(x)} to \code{max(x)}.
  Or a matrix of the same size as \code{y}.

  \code{trapzfun} returns a lst with components \code{value} the value of
  the integral, \code{iter} the number of iterations, and \code{rel.err}
  the relative error.
}
\seealso{
  \code{\link{polyarea}}
}
\examples{
  # Calculate the area under the sine curve from 0 to pi:
  n <- 101
  x <- seq(0, pi, len = n)
  y <- sin(x)
  trapz(x, y)                       #=> 1.999835504

  # Use a correction term at the boundary: -h^2/12*(f'(b)-f'(a))
  h  <- x[2] - x[1]
  ca <- (y[2]-y[1]) / h
  cb <- (y[n]-y[n-1]) / h
  trapz(x, y) - h^2/12 * (cb - ca)  #=> 1.999999969

  # Use two complex inputs
  z  <- exp(1i*pi*(0:100)/100)
  ct <- cumtrapz(z, 1/z)
  ct[101]                           #=> 0+3.14107591i

  f <- function(x) x^(3/2)          # 
  trapzfun(f, 0, 1)                 #=> 0.4 with 11 iterations
}

\keyword{ math }

\name{agmean}
\alias{agmean}
\title{
  Arithmetic-geometric Mean
}
\description{
  The arithmetic-geometric mean of real or complex numbers.
}
\usage{
agmean(a, b)
}
\arguments{
  \item{a, b}{vectors of real or complex numbers of the same length (or scalars).}
}
\details{
  The arithmetic-geometric mean is defined as the common limit of the two
  sequences \eqn{a_{n+1} = (a_n + b_n)/2} and \eqn{b_{n+1} = \sqrt(a_n b_n)}.

  When used for negative or complex numbers, the complex square root function
  is applied.
}
\value{
  Returns a list with compoinents: \code{agm} a vector of arithmetic-geometric 
  means, component-wise, \code{niter} the number of iterations, and \code{prec}
  the overall estimated precision.
}
\note{
  Gauss discovered that elliptic integrals can be effectively computed via
  the arithmetic-geometric mean (see example below), for example:
  \deqn{\int_0^{\pi/2} \frac{dt}{\sqrt{1 - m^2 sin^2(t)}}  = \frac{(a+b) \pi}{4 \cdot agm(a,b)}}
  where \eqn{m = (a-b)/(a+b)}
}
\references{
  \url{https://mathworld.wolfram.com/Arithmetic-GeometricMean.html}
}
\seealso{
  Arithmetic, geometric, and harmonic mean.
}
\examples{
##  Accuracy test: Gauss constant
1/agmean(1, sqrt(2))$agm - 0.834626841674073186  # 1.11e-16 < eps = 2.22e-16

## Gauss' AGM-based computation of \pi
a <- 1.0
b <- 1.0/sqrt(2)
s <- 0.5
d <- 1L
while (abs(a-b) > eps()) {
    t <- a
    a <- (a + b)*0.5
    b <- sqrt(t*b)
    c <- (a-t)*(a-t)
    d <- 2L * d
    s <- s - d*c
}
approx_pi <- (a+b)^2 / s / 2.0
abs(approx_pi - pi)             # 8.881784e-16 in 4 iterations

##  Example: Approximate elliptic integral
N <- 20
m <- seq(0, 1, len = N+1)[1:N]
E <- numeric(N)
for (i in 1:N) {
    f <- function(t) 1/sqrt(1 - m[i]^2 * sin(t)^2)
    E[i] <- quad(f, 0, pi/2)
}
A <- numeric(2*N-1)
a <- 1
b <- a * (1-m) / (m+1)

\dontrun{
plot(m, E, main = "Elliptic Integrals vs. arith.-geom. Mean")
lines(m, (a+b)*pi / 4 / agmean(a, b)$agm, col="blue")
grid()}
}
\keyword{ arith }

\name{newtonHorner}
\alias{newtonHorner}
\title{
  Newton's Root Finding Method for Polynomials.
}
\description{
  Finding roots of univariate polynomials.
}
\usage{
newtonHorner(p, x0, maxiter = 50, tol = .Machine$double.eps^0.5)
}
\arguments{
  \item{p}{Numeric vector representing a polynomial.}
  \item{x0}{starting value for newtonHorner().}
  \item{maxiter}{maximum number of iterations; default 100.}
  \item{tol}{absolute tolerance; default \code{eps^(1/2)}}
}
\details{
  Similar to \code{newtonRahson}, except that the computation of the
  derivative is done through the Horner scheme in parallel with computing
  the value of the polynomial. This makes the algorithm significantly
  faster. 
}
\value{
  Return a list with components \code{root}, \code{f.root}, 
  the function value at the found root, \code{iter}, the number of iterations
  done, and \code{root}, and the estimated precision \code{estim.prec}

  The estimated precision is given as the difference to the last solution
  before stop.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
\code{\link{newtonRaphson}}
}
\examples{
##  Example: x^3 - 6 x^2 + 11 x - 6  with roots 1, 2, 3
p <- c(1, -6, 11, -6)
x0 <- 0
while (length(p) > 1) {
    N <- newtonHorner(p, x0)
    if (!is.null(N$root)) {
        cat("x0 =", N$root, "\n")
        p <- N$deflate
    } else {
        break
    }
}
##  Try: p <- Poly(c(1:20))
}
\keyword{ math }

\name{romberg}
\alias{romberg}
\title{
  Romberg Integration
}
\description{
  Romberg Integration
}
\usage{
romberg(f, a, b, maxit = 25, tol = 1e-12, ...)
}
\arguments{
  \item{f}{function to be integrated.}
  \item{a, b}{end points of the interval.}
  \item{maxit}{maximum number of iterations.}
  \item{tol}{requested tolerance.}
  \item{...}{variables to be passed to the function.}
}
\details{
  Simple Romberg integration with an explicit Richardson method applied
  to a series of trapezoidal integrals. This scheme works best with smooth
  and non-oscillatory functions and needs the least number of function calls
  among all integration routines.

  The function does \emph{not} need to be vectorized.
}
\value{
  List of value, number or iterations, and relative error.
}
\references{
  Chapra, S. C., and R. P. Canale (2006). Numerical Methods for Engineers.
  Fifth Edition, McGraw-Hill, New York.
}
\note{
  Using a trapezoid formula Romberg integration will use
  \code{2*(2^iter-1)+iter} function calls. By remembering function values
  this could be reduced to \code{2^iter+1} calls.
}
\seealso{
  \code{\link{integrate}}, \code{\link{quadgr}}
}
\examples{
romberg(sin, 0, pi, tol = 1e-15)    #  2                 , rel.error 1e-15
romberg(exp, 0, 1,  tol = 1e-15)    #  1.718281828459044 , rel error 1e-15
                                    #  1.718281828459045 , i.e. exp(1) - 1

f <- function(x, p) sin(x) * cos(p*x)
romberg(f, 0, pi, p = 2)            #  2/3               , abs.err 1.5e-14
# value: -0.6666667, iter: 7, rel.error: 1e-12
}
\keyword{ math }

\name{gaussNewton}
\alias{gaussNewton}
\title{Gauss-Newton Function Minimization}
\description{
  Gauss-Newton method of minimizing a term \eqn{f_1(x)^2 + \ldots + f_m(x)^2}
  or \eqn{F' F} where \eqn{F = (f_1, \ldots, f_m)} is a multivariate function
  of \eqn{n} variables, not necessarily \eqn{n = m}.
}
\usage{
gaussNewton(x0, Ffun, Jfun = NULL,
                        maxiter =100, tol = .Machine$double.eps^(1/2), ...)
}
\arguments{
\item{Ffun}{\code{m} functions of \code{n} variables.}
\item{Jfun}{function returning the Jacobian matrix of \code{Ffun};
            if \code{NULL}, the default, the Jacobian will be computed
            numerically. The gradient of \code{f} will be computed
            internally from the Jacobian (i.e., cannot be supplied).}
\item{x0}{Numeric vector of length \code{n}.}
\item{maxiter}{Maximum number of iterations.}
\item{tol}{Tolerance, relative accuracy.}
\item{...}{Additional parameters to be passed to f.}
}
\details{
  Solves the system of equations applying the Gauss-Newton's method. It is
  especially designed for minimizing a sum-of-squares of functions and can
  be used to find a common zero of several function.
  
  This algorithm is described in detail in the textbook by Antoniou and Lu,
  incl. different ways to modify and remedy the Hessian if not being positive
  definite. Here, the approach by Goldfeld, Quandt and Trotter is used, and 
  the hessian modified by the Matthews and Davies algorithm if still not
  invertible.

  To accelerate the iteration, an inexact linesearch is applied.
}
\value{
  List with components:\cr
  \code{xs} the minimum or root found so far,\cr
  \code{fs} the square root of sum of squares of the values of f,\cr
  \code{iter} the number of iterations needed, and\cr
  \code{relerr} the absoulte distance between the last two solutions.
}
\references{
  Antoniou, A., and W.-S. Lu (2007). Practical Optimization: Algorithms and
  Engineering Applications. Springer Business+Science, New York.
}
\note{
  If \code{n=m} then directly applying the \code{newtonsys} function might
  be a better alternative.
}
\seealso{
  \code{\link{newtonsys}}, \code{\link{softline}}
}
\examples{
f1 <- function(x) c(x[1]^2 + x[2]^2 - 1, x[1] + x[2] - 1)
gaussNewton(c(4, 4), f1)

f2 <- function(x) c( x[1] + 10*x[2], sqrt(5)*(x[] - x[4]),
                    (x[2] - 2*x[3])^2, 10*(x[1] - x[4])^2)
gaussNewton(c(-2, -1, 1, 2), f2)

f3 <- function(x)
        c(2*x[1] - x[2] - exp(-x[1]), -x[1] + 2*x[2] - exp(-x[2]))
gaussNewton(c(0, 0), f3)
# $xs   0.5671433 0.5671433

f4 <- function(x)  # Dennis Schnabel
        c(x[1]^2 + x[2]^2 - 2, exp(x[1] - 1) + x[2]^3 - 2)
gaussNewton(c(2.0, 0.5), f4)
# $xs    1 1

##  Examples (from Matlab)
F1 <- function(x) c(2*x[1]-x[2]-exp(-x[1]), -x[1]+2*x[2]-exp(-x[2]))
gaussNewton(c(-5, -5), F1)

# Find a matrix X such that X %*% X %*% X = [1 2; 3 4]
F2 <- function(x) {
    X <- matrix(x, 2, 2)
    D <- X \%*\% X \%*\% X - matrix(c(1,3,2,4), 2, 2)
    return(c(D))
}
sol <- gaussNewton(ones(2,2), F2)
(X  <- matrix(sol$xs, 2, 2))
#            [,1]      [,2]
# [1,] -0.1291489 0.8602157
# [2,]  1.2903236 1.1611747
X \%*\% X \%*\% X
}
\keyword{ math }

\name{fzero}
\alias{fzero}
\title{
  Root Finding Algorithm
}
\description{
  Find root of continuous function of one variable.
}
\usage{
fzero(fun, x, maxiter = 500, tol = 1e-12, ...)
}
\arguments{
  \item{fun}{function whose root is sought.}
  \item{x}{a point near the root or an interval giving end points.}
  \item{maxiter}{maximum number of iterations.}
  \item{tol}{relative tolerance.}
  \item{...}{additional arguments to be passed to the function.}
}
\details{
  \code{fzero} tries to find a zero of \code{f} near \code{x}, if \code{x}
  is a scalar. Expands the interval until different signs are found at the
  endpoints or the maximum number of iterations is exceeded.
  If \code{x} is a vector of length two, \code{fzero} assumes \code{x} is
  an interval where the sign of \code{x[1]} differs from the sign of
  \code{x[1]}. An error occurs if this is not the case.

  ``This is essentially the ACM algorithm 748. The structure of the algorithm
  has been transformed non-trivially: it implement here a FSM version using
  one interior point determination and one bracketing per iteration, thus
  reducing the number of temporary variables and simplifying the structure.''

  This approach will not find zeroes of quadratic order.
}
\value{
  \code{fzero} returns a list with
    \item{x}{location of the root.}
    \item{fval}{function value at the root.}
}
\references{
  Alefeld, Potra and Shi (1995). Enclosing Zeros of Continuous Functions.
  ACM Transactions on Mathematical Software, Vol. 21, No. 3.
}
\note{
  \code{fzero} mimics the Matlab function of the same name, but is translated
  from Octave's \code{fzero} function, copyrighted (c) 2009 by Jaroslav Hajek.
}
\seealso{
  \code{\link{uniroot}}, \code{\link{brent}}
}
\examples{
fzero(sin, 3)                    # 3.141593
fzero(cos,c(1, 2))               # 1.570796
fzero(function(x) x^3-2*x-5, 2)  # 2.094551
}
\keyword{ math }

\name{primes}
\alias{primes}
\title{Prime Numbers}
\description{
  Generate a list of prime numbers less or equal \code{n}, resp. between
  \code{n1} and \code{n2}.
}
\usage{
  primes(n)
}
\arguments{
  \item{n}{nonnegative integer greater than 1.}
}
\details{
  The list of prime numbers up to \code{n} is generated using the "sieve of
  Erasthostenes". This approach is reasonably fast, but may require a lot of
  main memory when \code{n} is large.

  In double precision arithmetic integers are represented exactly only up to
  2^53 - 1, therefore this is the maximal allowed value.
}
\value{
  vector of integers representing prime numbers
}
\seealso{
  \code{\link{isprime}, \link{factors}}
}
\examples{
primes(1000)
\dontrun{
##  Appendix:  Logarithmic Integrals and Prime Numbers (C.F.Gauss, 1846)

library('gsl')
# 'European' form of the logarithmic integral
Li <- function(x) expint_Ei(log(x)) - expint_Ei(log(2))

# No. of primes and logarithmic integral for 10^i, i=1..12
i <- 1:12;  N <- 10^i
# piN <- numeric(12)
# for (i in 1:12) piN[i] <- length(primes(10^i))
piN <- c(4, 25, 168, 1229, 9592, 78498, 664579,
         5761455, 50847534, 455052511, 4118054813, 37607912018)
cbind(i, piN, round(Li(N)), round((Li(N)-piN)/piN, 6))

#  i     pi(10^i)      Li(10^i)  rel.err  
# --------------------------------------      
#  1            4            5  0.280109
#  2           25           29  0.163239
#  3          168          177  0.050979
#  4         1229         1245  0.013094
#  5         9592         9629  0.003833
#  6        78498        78627  0.001637
#  7       664579       664917  0.000509
#  8      5761455      5762208  0.000131
#  9     50847534     50849234  0.000033
# 10    455052511    455055614  0.000007
# 11   4118054813   4118066400  0.000003
# 12  37607912018  37607950280  0.000001
# --------------------------------------}
}
\keyword{ arith }

\name{hooke_jeeves}
\alias{hooke_jeeves}
\title{
  Hooke-Jeeves Function Minimization Method
}
\description{
  An implementation of the Hooke-Jeeves algorithm for derivative-free
  optimization.
}
\usage{
hooke_jeeves(x0, fn, ..., lb = NULL, ub = NULL, tol = 1e-08,
             maxfeval = 10000, target = Inf, info = FALSE)
}
\arguments{
  \item{x0}{starting vector.}
  \item{fn}{nonlinear function to be minimized.}
  \item{...}{additional arguments to be passed to the function.}
  \item{lb, ub}{lower and upper bounds.}
  \item{tol}{relative tolerance, to be used as stopping rule.}
  \item{maxfeval}{maximum number of allowed function evaluations.}
  \item{target}{iteration stops when this value is reached.}
  \item{info}{logical, whether to print information during the main loop.}
}
\details{
  This method computes a new point using the values of \code{f} at suitable
  points along the orthogonal coordinate directions around the last point.
}
\value{
  List with following components:
    \item{xmin}{minimum solution found so far.}
    \item{fmin}{value of \code{f} at minimum.}
    \item{count}{number of function evaluations.}
    \item{convergence}{NOT USED at the moment.}
    \item{info}{special info from the solver.}
}
\references{
  C.T. Kelley (1999), Iterative Methods for Optimization, SIAM.

  Quarteroni, Sacco, and Saleri (2007), Numerical Mathematics,
  Springer-Verlag.
}
\note{
  Hooke-Jeeves is notorious for its number of function calls.
  Memoization is often suggested as a remedy.

  For a similar implementation of Hooke-Jeeves see the `dfoptim' package.
}
\seealso{
  \code{\link{nelder_mead}}
}
\examples{
##  Rosenbrock function
rosenbrock <- function(x) {
    n <- length(x)
    x1 <- x[2:n]
    x2 <- x[1:(n-1)]
    sum(100*(x1-x2^2)^2 + (1-x2)^2)
}

hooke_jeeves(c(0,0,0,0), rosenbrock)
## $xmin
## [1] 1.000002 1.000003 1.000007 1.000013
## $fmin
## [1] 5.849188e-11
## $count
## [1] 1691
## $convergence
## [1] 0
## $info
## $info$solver
## [1] "Hooke-Jeeves"
## $info$iterations
## [1] 26

hooke_jeeves(rep(0,4), lb=rep(-1,4), ub=0.5, rosenbrock)
## $xmin
## [1] 0.50000000 0.26221320 0.07797602 0.00608027
## $fmin
## [1] 1.667875
## $count
## [1] 536
## $convergence
## [1] 0
## $info
## $info$solver
## [1] "Hooke-Jeeves"
## $info$iterations
## [1] 26
}
\keyword{ optimize }

\name{rectint}
\alias{rectint}
\title{
  Rectangle Intersection Areas
}
\description{
  Calculates the area of intersection of rectangles, specified by position
  vectors \code{x} and \code{y}.
}
\usage{
rectint(x, y)
}
\arguments{
  \item{x, y}{both vectors of length 4, or both matrices with 4 columns.}
}
\details{
  Rectangles are specified as position vectors, that is \code{c(x[1],x[2])}
  is the lower left corner, \code{x[3]} and \code{x[4]} are width and height
  of the rectangle. When \code{x} and \code{y} are matrices, each row is
  assumed to be a position vector specifying a rectangle.
}
\value{
  Returns a scalar if \code{x} and \code{y} are vectors. If \code{x} is
  a \code{n-by-4} and \code{y} a \code{m-by-4} matrix, then it returns
  a \code{n-by-m} matrix \code{R} with entry \code{(i,j)} being the area
  \code{rectint(x[i,], y[j,])}.
}
\seealso{
  \code{\link{polyarea}}
}
\examples{
x <- c(0.5, 0.5, 0.25, 1.00)
y <- c(0.3, 0.3, 0.35, 0.75)
rectint(x, y)
# [1] 0.0825
}
\keyword{ math }

\name{findpeaks}
\alias{findpeaks}
\title{
Find Peaks
}
\description{
  Find peaks (maxima) in a time series.
}
\usage{
findpeaks(x, nups = 1, ndowns = nups, zero = "0", peakpat = NULL,
          minpeakheight = -Inf, minpeakdistance = 1,
          threshold = 0, npeaks = 0, sortstr = FALSE)
}
\arguments{
  \item{x}{numerical vector taken as a time series (no NAs allowed)}
  \item{nups}{minimum number of increasing steps before a peak is reached}
  \item{ndowns}{minimum number of decreasing steps after the peak}
  \item{zero}{can be `+', `-', or `0'; how to interprete succeeding steps
              of the same value: increasing, decreasing, or special}
  \item{peakpat}{define a peak as a regular pattern, such as the default
        pattern ``[+]{1,}[-]{1,}''; if a pattern is provided, the parameters
        \code{nups} and \code{ndowns} are not taken into account}
  \item{minpeakheight}{the minimum (absolute) height a peak has to have
        to be recognized as such}
  \item{minpeakdistance}{the minimum distance (in indices) peaks have to have
        to be counted}
  \item{threshold}{the minimum }
  \item{npeaks}{the number of peaks to return}
  \item{sortstr}{logical; should the peaks be returned sorted in decreasing
        oreder of their maximum value}
}
\details{
  This function is quite general as it relies on regular patterns to determine
  where a peak is located, from beginning to end.
}
\value{
  Returns a matrix where each row represents one peak found. The first column
  gives the height, the second the position/index where the maximum is reached,
  the third and forth the indices of where the peak begins and ends --- in the
  sense of where the pattern starts and ends.
}
\note{
  On Matlab Central there are several realizations for finding peaks, for
  example ``peakfinder'', ``peakseek'', or ``peakdetect''. And ``findpeaks''
  is also the name of a function in the Matlab `signal' toolbox.

  The parameter names are taken from the ``findpeaks'' function in `signal',
  but the implementation utilizing regular expressions is unique and fast.
}
\seealso{
  \code{\link{hampel}}
}
\examples{
x <- seq(0, 1, len = 1024)
pos <- c(0.1, 0.13, 0.15, 0.23, 0.25, 0.40, 0.44, 0.65, 0.76, 0.78, 0.81)
hgt <- c(4, 5, 3, 4, 5, 4.2, 2.1, 4.3, 3.1, 5.1, 4.2)
wdt <- c(0.005, 0.005, 0.006, 0.01, 0.01, 0.03, 0.01, 0.01, 0.005, 0.008, 0.005)

pSignal <- numeric(length(x))
for (i in seq(along=pos)) {
	pSignal <- pSignal + hgt[i]/(1 + abs((x - pos[i])/wdt[i]))^4
}
findpeaks(pSignal, npeaks=3, threshold=4, sortstr=TRUE)

\dontrun{
plot(pSignal, type="l", col="navy")
grid()
x <- findpeaks(pSignal, npeaks=3, threshold=4, sortstr=TRUE)
points(x[, 2], x[, 1], pch=20, col="maroon")}
}
\keyword{ timeseries }

\name{bvp}
\alias{bvp}
\title{
  Boundary Value Problems
}
\description{
  Solves boundary value problems of linear second order differential equations.
}
\usage{
bvp(f, g, h, x, y, n = 50)
}
\arguments{
  \item{f, g, h}{functions on the right side of the differential equation.
        If \code{f, g} or \code{h} is a scalar instead of a function, it is
        assumed to be a constant coefficient in the differential equation.}
  \item{x}{\code{x[1], x[2]} are the interval borders where the solution
           shall be computed.}
  \item{y}{boundary conditions such that
           \code{y(x[1]) = y[1], y(x[2]) = y[2]}.}
  \item{n}{number of intermediate grid points; default 50.}
}
\details{
  Solves the two-point boundary value problem given as a linear differential 
  equation of second order in the form:
  \deqn{y'' = f(x) y' + g(x) y + h(x)}
  with the finite element method. The solution \eqn{y(x)} shall exist
  on the interval \eqn{[a, b]} with boundary conditions \eqn{y(a) = y_a} 
  and \eqn{y(b) = y_b}.
}
\value{
  Returns a list \code{list(xs, ys)} with the grid points \code{xs} and the
  values \code{ys} of the solution at these points, including the boundary
  points.
}
\references{
  Kutz, J. N. (2005). Practical Scientific Computing. Lecture Notes 
  98195-2420, University of Washington, Seattle.
}
\note{
  Uses a tridiagonal equation solver that may be faster then \code{qr.solve}
  for large values of \code{n}.
}
\seealso{
  \code{\link{shooting}}
}
\examples{
##  Solve y'' = 2*x/(1+x^2)*y' - 2/(1+x^2) * y + 1
##  with y(0) = 1.25 and y(4) = -0.95 on the interval [0, 4]:
f1 <- function(x) 2*x / (1 + x^2)
f2 <- function(x)  -2 / (1 + x^2)
f3 <- function(x) rep(1, length(x))     # vectorized constant function 1
x <- c(0.0,   4.0)
y <- c(1.25, -0.95)
sol <- bvp(f1, f2, f3, x, y)
\dontrun{
plot(sol$xs, sol$ys, ylim = c(-2, 2),
     xlab = "", ylab = "", main = "Boundary Value Problem")
# The analytic solution is
sfun <- function(x) 1.25 + 0.4860896526*x - 2.25*x^2 + 
                    2*x*atan(x) - 1/2 * log(1+x^2) + 1/2 * x^2 * log(1+x^2)
xx <- linspace(0, 4)
yy <- sfun(xx)
lines(xx, yy, col="red")
grid()}
}
\keyword{ ode }

\name{Trace}
\alias{Trace}
\title{Matrix trace}
\description{
Sum of the main diagonal elements.
}
\usage{
Trace(a)
}
\arguments{
  \item{a}{a square matrix}
}
\details{
Sums the elements of the main diagonal of areal or complrx square matrix.
}
\value{
scalar value
}
\note{
The corresponding function in Matlab/Octave is called trace(), but this in \R
has a different meaning.
}
\seealso{
\code{\link{Diag}}, \code{\link{diag}}
}
\examples{
Trace(matrix(1:16, nrow=4, ncol=4))
}
\keyword{ array }

\name{movavg}
\alias{movavg}
\title{
  Moving Average Filters
}
\description{
  Different types of moving average of a time series.
}
\usage{
movavg(x, n, type=c("s", "t", "w", "m", "e", "r"))
}
\arguments{
  \item{x}{time series as numeric vector.}
  \item{n}{backward window length.}
  \item{type}{one of 's', 't', 'w', 'm', 'e', or 'r'; default is 's'.}
}
\details{
  Types of available moving averages are:
  \itemize{
  \item \code{s} for ``simple'', it computes the simple moving average.
        \code{n} indicates the number of previous data points used with the 
        current data point when calculating the moving average.
  \item \code{t} for ``triangular'', it computes the triangular moving average 
        by calculating the first simple moving average with window width of 
        \code{ceil(n+1)/2}; then it calculates a second simple moving average 
        on the first moving average with the same window size.
  \item \code{w} for ``weighted", it calculates the weighted moving average 
        by supplying weights for each element in the moving window. Here the 
        reduction of weights follows a linear trend.
  \item \code{m} for ``modified", it calculates the modified moving average. 
        The first modified moving average is calculated like a simple moving 
        average. Subsequent values are calculated by adding the new value and 
        subtracting the last average from the resulting sum.
  \item \code{e} for``exponential", it computes the exponentially weighted 
        moving average. The exponential moving average is a weighted moving 
        average that reduces influences by applying more weight to recent 
        data points () reduction factor \code{2/(n+1)}; or
  \item \code{r} for``running", this is an exponential moving average with a 
        reduction factor of \code{1/n} [same as the modified average?].
  }
}
\value{
  Vector the same length as time series \code{x}.
}
\references{
  Matlab Techdoc
}
\seealso{
  \code{filter}
}
\examples{
\dontrun{
abbshares <- scan(file="")
25.69 25.89 25.86 26.08 26.41 26.90 26.27 26.45 26.49 26.08 26.11 25.57 26.02
25.53 25.27 25.95 25.19 24.78 24.96 24.63 25.68 25.24 24.87 24.71 25.01 25.06
25.62 25.95 26.08 26.25 25.91 26.61 26.34 25.55 25.36 26.10 25.63 25.52 24.74
25.00 25.38 25.01 24.57 24.95 24.89 24.13 23.83 23.94 23.74 23.12 23.13 21.05
21.59 19.59 21.88 20.59 21.59 21.86 22.04 21.48 21.37 19.94 19.49 19.46 20.34
20.59 19.96 20.18 20.74 20.83 21.27 21.19 20.27 18.83 19.46 18.90 18.09 17.99
18.03 18.50 19.11 18.94 18.21 18.06 17.66 16.77 16.77 17.10 17.62 17.22 17.95
17.08 16.42 16.71 17.06 17.75 17.65 18.90 18.80 19.54 19.23 19.48 18.98 19.28
18.49 18.49 19.08 19.63 19.40 19.59 20.37 19.95 18.81 18.10 18.32 19.02 18.78
18.68 19.12 17.79 18.10 18.64 18.28 18.61 18.20 17.82 17.76 17.26 17.08 16.70
16.68 17.68 17.70 18.97 18.68 18.63 18.80 18.81 19.03 18.26 18.78 18.33 17.97
17.60 17.72 17.79 17.74 18.37 18.24 18.47 18.75 18.66 18.51 18.71 18.83 19.82
19.71 19.64 19.24 19.60 19.77 19.86 20.23 19.93 20.33 20.98 21.40 21.14 21.38
20.89 21.08 21.30 21.24 20.55 20.83 21.57 21.67 21.91 21.66 21.53 21.63 21.83
21.48 21.71 21.44 21.67 21.10 21.03 20.83 20.76 20.90 20.92 20.80 20.89 20.49
20.70 20.60 20.39 19.45 19.82 20.28 20.24 20.30 20.66 20.66 21.00 20.88 20.99
20.61 20.45 20.09 20.34 20.61 20.29 20.20 20.00 20.41 20.70 20.43 19.98 19.92
19.77 19.23 19.55 19.93 19.35 19.66 20.27 20.10 20.09 20.48 19.86 20.22 19.35
19.08 18.81 18.87 18.26 18.27 17.91 17.68 17.73 17.56 17.20 17.14 16.84 16.47
16.45 16.25 16.07

plot(abbshares, type = "l", col = 1, ylim = c(15, 30),
                main = "Types of moving averages", sub = "Mid 2011--Mid 2012",
                xlab = "Days", ylab = "ABB Shares Price (in USD)")
y <- movavg(abbshares, 50, "s"); lines(y, col = 2)
y <- movavg(abbshares, 50, "t"); lines(y, col = 3)
y <- movavg(abbshares, 50, "w"); lines(y, col = 4)
y <- movavg(abbshares, 50, "m"); lines(y, col = 5)
y <- movavg(abbshares, 50, "e"); lines(y, col = 6)
y <- movavg(abbshares, 50, "r"); lines(y, col = 7)
grid()
legend(120, 29, c("original data", "simple", "triangular", "weighted",
                                   "modified", "exponential", "running"),
                col = 1:7, lty = 1, lwd = 1, box.col = "gray", bg = "white")
}
}
\keyword{ timeseries }

\name{fractalcurve}
\alias{fractalcurve}
\title{
  Fractal Curves
}
\description{
  Generates the following fractal curves: Dragon Curve, Gosper Flowsnake 
  Curve, Hexagon Molecule Curve, Hilbert Curve, Koch Snowflake Curve, 
  Sierpinski Arrowhead Curve, Sierpinski (Cross) Curve, Sierpinski Triangle
  Curve.
}
\usage{
fractalcurve(n, which = c("hilbert", "sierpinski", "snowflake",
    "dragon", "triangle", "arrowhead", "flowsnake", "molecule"))
}
\arguments{
  \item{n}{integer, the `order' of the curve}
  \item{which}{character string, which curve to cumpute.}
}
\details{
  The Hilbert curve is a continuous curve in the plane with 4^N points.

  The Sierpinski (cross) curve is a closed curve in the plane with 4^(N+1)+1
  points.

  His arrowhead curve is a continuous curve in the plane with 3^N+1 points,
  and his triangle curve is a closed curve in the plane with 2*3^N+2 points.

  The Koch snowflake curve is a closed curve in the plane with 3*2^N+1
  points.

  The dragon curve is a continuous curve in the plane with 2^(N+1) points.

  The flowsnake curve is a continuous curve in the plane with 7^N+1 points.

  The hexagon molecule curve is a closed curve in the plane with 6*3^N+1
  points.
}
\value{
  Returns a list with \code{x, y} the x- resp. y-coordinates of the
  generated points describing the fractal curve.
}
\references{
  Peitgen, H.O., H. Juergens, and D. Saupe (1993). Fractals for the
  Classroom. Springer-Verlag Berlin Heidelberg.
}
\author{
  Copyright (c) 2011 Jonas Lundgren for the Matlab toolbox \code{fractal 
  curves} available on MatlabCentral under BSD license;
  here re-implemented in R with explicit allowance from the author.
}
\examples{
## The Hilbert curve transforms a 2-dim. function into a time series.
z <- fractalcurve(4, which = "hilbert")

\dontrun{
f1 <- function(x, y) x^2 + y^2
plot(f1(z$x, z$y), type = 'l', col = "darkblue", lwd = 2,
     ylim = c(-1, 2), main = "Functions transformed by Hilbert curves")

f2 <- function(x, y) x^2 - y^2
lines(f2(z$x, z$y), col = "darkgreen", lwd = 2)

f3 <- function(x, y) x^2 * y^2
lines(f3(z$x, z$y), col = "darkred", lwd = 2)
grid()}

\dontrun{
## Show some more fractal surves
n <- 8
opar <- par(mfrow=c(2,2), mar=c(2,2,1,1))

z <- fractalcurve(n, which="dragon")
x <- z$x; y <- z$y
plot(x, y, type='l', col="darkgrey", lwd=2)
title("Dragon Curve")

z <- fractalcurve(n, which="molecule")
x <- z$x; y <- z$y
plot(x, y, type='l', col="darkblue")
title("Molecule Curve")

z <- fractalcurve(n, which="arrowhead")
x <- z$x; y <- z$y
plot(x, y, type='l', col="darkgreen")
title("Arrowhead Curve")

z <- fractalcurve(n, which="snowflake")
x <- z$x; y <- z$y
plot(x, y, type='l', col="darkred", lwd=2)
title("Snowflake Curve")

par(opar)}
}
\keyword{ math }

\name{psi}
\alias{psi}
\title{
  Psi (Polygamma) Function
}
\description{
  Arbitrary order Polygamma function valid in the entire complex plane.
}
\usage{
psi(k, z)
}
\arguments{
  \item{k}{order of the polygamma function, whole number greater or equal 0.}
  \item{z}{numeric complex number or vector.}
}
\details{
  Computes the Polygamma function of arbitrary order, and valid in the entire
  complex plane. The polygamma function is defined as

  \deqn{\psi(n, z) = \frac{d^{n+1}}{dz^{n+1}} \log(\Gamma(z))}

  If \code{n} is 0 or absent then \code{psi} will be the Digamma function.
  If \code{n=1,2,3,4,5} etc. then \code{psi} will be the
  tri-, tetra-, penta-, hexa-, hepta- etc. gamma function.
}
\value{
  Returns a complex number or a vector of complex numbers.
}
\examples{
psi(2) - psi(1)         # 1
-psi(1)                 # Eulers constant: 0.57721566490153  [or, -psi(0, 1)]
psi(1, 2)               # pi^2/6 - 1     : 0.64493406684823
psi(10, -11.5-0.577007813568142i)
                        # is near a root of the decagamma function
}

\name{andrewsplot}
\alias{andrewsplot}
\title{
  Andrews' Curves
}
\description{
  Plots Andrews' curves in cartesian or polar coordinates.
}
\usage{
andrewsplot(A, f, style = "pol", scaled = FALSE, npts = 101)
}
\arguments{
  \item{A}{numeric matrix with at least two columns.}
  \item{f}{factor or integer vector with \code{nrow(A)} elements.}
  \item{style}{character variable, only possible values `cart' or `pol'.}
  \item{scaled}{logical; if true scales each column to have mean 0 and
                standard deviation 1 (not yet implemented).}
  \item{npts}{number of points to plot.}
}
\details{
  \code{andrewsplot} creates an Andrews plot of the multivariate data in the
  matrix \code{A}, assigning different colors according to the factor or
  integer vector \code{f}.

  Andrews' plot represent each observation (row) by a periodic function over
  the interval \code{[0, 2*pi]}. This function for the \code{i}-th observation
  is defined as ...

  The plot can be seen in cartesian or polar coordinates --- the latter seems
  appropriate as all these functions are periodic.
}
\value{
  Generates a plot, no return value.
}
\note{
  Please note that a different ordering of the columns will result in quite
  different functions and overall picture.

  There are variants utilizing principal component scores, in order of
  decreasing eigenvalues.
}
\references{
  R. Khattree and D. N. Naik (2002). Andrews PLots for Multivariate Data:
  Some New Suggestions and Applications. Journal of Statistical Planning
  and Inference, Vol. 100, No. 2, pp. 411--425.
}
\seealso{
  \code{\link{polar}}, \code{andrews::andrews}
}
\examples{
\dontrun{
data(iris)
s <- sample(1:4, 4)
A <- as.matrix(iris[, s])
f <- as.integer(iris[, 5])
andrewsplot(A, f, style = "pol")
}
}
\keyword{ graphs }

\name{strfind}
\alias{strfind}
\alias{strfindi}
\alias{findstr}
\title{Find Substrings}
\description{
  Find substrings within strings of a character vector.
}
\usage{
strfind(s1, s2, overlap = TRUE)
strfindi(s1, s2, overlap = TRUE)

findstr(s1, s2, overlap = TRUE)
}
\arguments{
\item{s1}{character string or character vector}
\item{s2}{character string (character vector of length 1)}
\item{overlap}{logical (are overlapping substrings allowed)}
}
\details{
  \code{strfind} finds positions of substrings within \code{s1} that
  match exactly with \code{s2}, and is case sensitive; no regular patterns.

  \code{strfindi} does not distinguish between lower and upper case.

  \code{findstr} should only be used as internal function, in Matlab it is
  deprecated. It searches for the shorter string within the longer one.
}
\value{
  Returns a vector of indices, or a list of such index vectors if
  \code{s2} is a character vector of length greater than 1.
}
\seealso{
\code{\link{strcmp}}
}
\examples{
S <- c("", "ab", "aba", "aba aba", "abababa")
s <- "aba"
strfind(S, s)
strfindi(toupper(S), s)
strfind(S, s, overlap = FALSE)
}
\keyword{ string }

\name{std_err}
\alias{std_err}
\title{Standard Error}
\description{
  Standard error of the values of \code{x}.
}
\usage{
std_err(x)
}
\arguments{
  \item{x}{numeric vector or matrix}
}
\details{
  Standard error is computed as \code{var(x)/length(x)}.
}
\value{
  Returns the standard error of all elements of the vector or matrix.
}
\examples{
std_err(1:10)  #=> 0.9574271
}
\keyword{ stat }

\name{perms}
\alias{perms}
\title{
Generate Permutations
}
\description{
Generates all permutations of a vector \code{a}.
}
\usage{
perms(a)
}
\arguments{
  \item{a}{numeric vector of some length \code{n}}
}
\details{
  If \code{a} is a vector of length \code{n}, generate all permutations
  of the elements in \code{a} as a matrix of size \code{n! x n} where
  each row represents one permutation.

  A matrix will be expanded as vector.
}
\value{
  matrix of permutations of the elements of \code{a}
}
\note{
Not feasible for \code{length(a) > 10}.
}
\seealso{
\code{\link{randperm}}
}
\examples{
perms(6)
perms(1:6)
perms(c(1, exp(1), pi))
}
\keyword{ arith }

\name{quiver}
\alias{quiver}
\title{
  Quiver or Velocity Plot
}
\description{
  A quiver plot displays velocity vectors as arrows with components
  \code{(u,v)} at the points \code{(x,y)}.
}
\usage{
    quiver(x, y, u, v,
           scale = 0.05, angle = 10, length = 0.1, ...)
}
\arguments{
  \item{x, y}{x,y-coordinates of start points of the arrows.}
  \item{u, v}{x,y-coordinates of start points.}
  \item{scale}{scales the length of the arrows.}
  \item{angle}{angle between shaft and edge of the arrows.}
  \item{length}{length of the arrow edges.}
  \item{...}{more options presented to the \code{arrows} primitive.}
}
\details{
  The matrices \code{x, y, u, v} must all be the same size and contain
  corresponding position and velocity components.
  However, x and y can also be vectors.
}
\value{
  Opens a graph window and plots the velocity vectors.
}
\seealso{
  \code{\link{vectorfield}}, \code{\link{arrows}}
}
\keyword{ graphs }

\name{nthroot}
\alias{nthroot}
\title{Real nth Root}
\description{
  Compute the real n-th root of real numbers.
}
\usage{
  nthroot(x, n)
}
\arguments{
  \item{x}{numeric vector or matrix}
  \item{n}{positive integer specifying the exponent \eqn{1/n}.}
}
\details{
  Computes the n-th root real numbers of a numeric vector \code{x},
  while \code{x^(1/n)} will return \code{NaN} for negative numbers,
  even in case \code{n} is odd. If some numbers in \code{x} are negative,
  \code{n} must be odd. (This is different in \emph{Octave})
}
\value{
  Returns a numeric vector of solutions to \eqn{x^{1/n}}.
}
\seealso{
  \code{\link{sqrt}}
}
\examples{
  nthroot(c(1, -2, 3), 3)  #=> 1.000000 -1.259921  1.442250
  (-2)^(1/3)               #=> NaN
}
\keyword{ arith }

\name{tri}
\alias{tril}
\alias{triu}
\title{
  Triangular Matrices (Matlab Style)
}
\description{
  Extract lower or upper triangular part of a matrix.
}
\usage{
tril(M, k = 0)
triu(M, k = 0)
}
\arguments{
  \item{M}{numeric matrix.}
  \item{k}{integer, indicating a secondary diagonal.}
}
\details{
  \code{tril}\cr
  Returns the elements on and below the kth diagonal of X, where k = 0 is
  the main diagonal, k > 0 is above the main diagonal, and k < 0 is below
  the main diagonal.

  \code{triu}\cr
  Returns the elements on and above the kth diagonal of X, where k = 0 is
  the main diagonal, k > 0 is above the main diagonal, and k < 0 is below
  the main diagonal.
}
\value{
  Matrix the same size as the input matrix.
}
\note{
  For \code{k==0} it is simply an application of the R functions
  \code{lower.tri} resp. \code{upper.tri}.
}
\seealso{
  \code{\link{Diag}}
}
\examples{
tril(ones(4,4), +1)
#    1  1  0  0
#    1  1  1  0
#    1  1  1  1
#    1  1  1  1

triu(ones(4,4), -1)
#    1  1  1  1
#    1  1  1  1
#    0  1  1  1
#    0  0  1  1
}
\keyword{ array }

\name{ceil}
\alias{ceil}
\alias{Fix}
\title{Integer Functions (Matlab Style)}
\description{
  Functions for rounding and truncating numeric values towards near
  integer values.
}
\usage{
ceil(n)
Fix(n)
}
\arguments{
  \item{n}{a numeric vector or matrix}
}
\details{
  \code{ceil()} is an alias for \code{ceiling()} and rounds to the smallest
  integer equal to or above \code{n}.

  \code{Fix()} truncates values towards 0 and is an alias for 
  \code{trunc()}. Uses \code{ml} prefix to indicate Matlab style.

  The corresponding functions \code{floor()} (rounding to the largest interger
  equal to or smaller than \code{n}) and \code{round()} (rounding to the
  specified number of digits after the decimal point, default being 0) are
  already part of R base.
}
\value{
  integer values
}
\examples{
x <- c(-1.2, -0.8, 0, 0.5, 1.1, 2.9)
ceil(x)
Fix(x)
}
\keyword{ arith }

\name{fprintf}
\alias{fprintf}
\title{
  Formatted Printing (Matlab style)
}
\description{
  Formatted printing to stdout or a file.
}
\usage{
fprintf(fmt, ..., file = "", append = FALSE)
}
\arguments{
  \item{fmt}{a character vector of format strings.}
  \item{...}{values passed to the format string.}
  \item{file}{a connection or a character string naming the file to
              print to; default is "" which means standard output.}
  \item{append}{logical; shall the output be appended to the file;
                default is \code{FALSE}.}
}
\details{
  \code{fprintf} applies the format string \code{fmt} to all input
  data \code{...} and writes the result to standard output or a file.
  The usual C-style string formatting commands are used-
}
\value{
  Returns invisibly the number of bytes printed (using \code{nchar}).
}
\seealso{
  \code{\link{sprintf}}
}
\examples{
##  Examples:
nbytes <- fprintf("Results are:\n", file = "")
for (i in 1:10) {
    fprintf("\%4d  \%15.7f\n", i, exp(i), file = "")
}
}
\keyword{ utilities }

\name{bsxfun}
\alias{bsxfun}
\alias{arrayfun}
\title{
  Elementwise Function Application (Matlab Style)
}
\description{
  Apply a binary function elementwise.
}
\usage{
  bsxfun(func, x, y)

  arrayfun(func, ...)
}
\arguments{
  \item{func}{function with two or more input parameters.}
  \item{x, y}{two vectors, matrices, or arrays of the same size.}
  \item{...}{list of arrays of the same size.}
}
\details{
  \code{bsxfun} applies element-by-element a binary function to two vectors,
  matrices, or arrays of the same size. For matrices, \code{sweep} is used for
  reasons of speed, otherwise \code{mapply}. (For arrays of more than two
  dimensions this may become very slow.)

  \code{arrayfun} applies \code{func} to each element of the arrays and
  returns an array of the same size.
}
\value{
  The result will be a vector or matrix of the same size as \code{x, y}.
}
\note{
  The underlying function \code{mapply} can be applied in a more general
  setting with many function parameters:

  \code{mapply(f, x, y, z, ...)}

  but the array structure will not be preserved in this case.
}
\seealso{
  \code{\link{Vectorize}}
}
\examples{
X <- matrix(rep(1:10, each = 10), 10, 10)
Y <- t(X)
bsxfun("*", X, Y)  # multiplication table

f <- function(x, y) x[1] * y[1]     # function not vectorized
A <- matrix(c(2, 3, 5, 7), 2, 2)
B <- matrix(c(11, 13, 17, 19), 2, 2)
arrayfun(f, A, B)
}
\keyword{ math }

\name{rkf54}
\alias{rkf54}
\title{
  Runge-Kutta-Fehlberg
}
\description{
  Runge-Kutta-Fehlberg with adaptive step size.
}
\usage{
rkf54(f, a, b, y0, tol = .Machine$double.eps^0.5,
                   control = list(), ...)
}
\arguments{
  \item{f}{function in the differential equation \eqn{y' = f(x, y)}.}
  \item{a, b}{endpoints of the interval.}
  \item{y0}{starting values at \code{a}.}
  \item{tol}{relative tolerance, used for determining the step size.}
  \item{control}{list for influencing the step size with components\cr
                 \code{hmin, hmax}, the minimal, maximal step size\cr
                 \code{jmax}, the maximally allowed number of steps.}
  \item{\ldots}{additional parameters to be passed to the function.}
}
\details{
  Runge-Kutta-Fehlberg is a kind of Runge-Kutta method of solving ordinary
  differential equations of order (5, 4) with variable step size.

  ``At each step, two different approximations for the solution are made and
  compared.  If the two answers are in close agreement, the approximation is
  accepted. If the two answers do not agree to a specified accuracy, the step
  size is reduced.  If the answers agree to more significant digits than
  required, the step size is increased.''

  Some textbooks promote the idea to use the five-order formula as the
  accepted value instead of using it for error estimation. This approach
  is taken here, that is why the function is called \code{rkf54}. The idea
  is still debated as the accuracy determinations appears to be diminished.
}
\value{
  List with components \code{x} for grid points between \code{a} and \code{b}
  and \code{y} the function values of the numerical solution.
}
\references{
  Stoer, J., and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Springer-Verlag, New York.

  Mathematica code associated with the book:\cr
  Mathews, J. H., and K. D. Fink (2004). Numerical Methods Using Matlab.
  Fourth Edition, Prentice Hall.
}
\note{
  This function serves demonstration purposes only.
}
\seealso{
  \code{\link{rk4}}, \code{\link{ode23}}
}
\examples{
# Example: y' = 1 + y^2
f1 <- function(x, y)  1 + y^2
sol11 <- rkf54(f1, 0, 1.1, 0.5, control = list(hmin = 0.01))
sol12 <- rkf54(f1, 0, 1.1, 0.5, control = list(jmax =  250))

# Riccati equation: y' = x^2 + y^2
f2 <- function(x, y)  x^2 + y^2
sol21 <- rkf54(f2, 0, 1.5, 0.5, control = list(hmin = 0.01))
sol22 <- rkf54(f2, 0, 1.5, 0.5, control = list(jmax =  250))

\dontrun{
plot(0, 0, type = "n", xlim = c(0, 1.5), ylim = c(0, 20),
     main = "Riccati", xlab = "", ylab = "")
points(sol11$x, sol11$y, pch = "*", col = "darkgreen")
lines(sol12$x, sol12$y)
points(sol21$x, sol21$y, pch = "*", col = "blue")
lines(sol22$x, sol22$y)
grid()}
}
\keyword{ ode }

\name{pascal}
\alias{pascal}
\title{
Pascal Triangle
}
\description{
  Pascal triangle in matrix format
}
\usage{
pascal(n, k = 0)
}
\arguments{
  \item{n}{natural number}
  \item{k}{natural number, \code{k <= n}}
}
\details{
  Pascal triangle with \code{k} variations.
}
\value{
  matrix representing the Pascal triangle
}
\seealso{
\code{nchoosek}
}
\examples{
pascal(5)
pascal(5, 1)
pascal(5, 2)
}
\keyword{ specmat }

\name{inv}
\alias{inv}
\title{Matrix Inverse (Matlab Style)}
\description{
Invert a numeric or complex matrix.
}
\usage{
inv(a)
}
\arguments{
  \item{a}{real or complex square matrix}
}
\details{
Computes the matrix inverse by calling \code{solve(a)} and catching the error
if the matrix is nearly singular.
}
\value{
square matrix that is the inverse of \code{a}.
}
\note{
\code{inv()} is the function name used in Matlab/Octave.
}
\seealso{
\code{\link{solve}}
}
\examples{
A <- hilb(6)
B <- inv(A)
B
# Compute the inverse matrix through Cramer's rule:
n <- nrow(A)
detA <- det(A) 
b <- matrix(NA, nrow = n, ncol = n)
for (i in 1:n) {
    for (j in 1:n) {
        b[i, j] <- (-1)^(i+j) * det(A[-j, -i]) / detA
    }
}
b
}
\keyword{ array }

\name{jacobian}
\alias{jacobian}
\title{Jacobian Matrix}
\description{
  Jacobian matrix of a function R^n --> R^m .
}
\usage{
jacobian(f, x0, heps = .Machine$double.eps^(1/3), ...)
}
\arguments{
\item{f}{\code{m} functions of \code{n} variables.}
\item{x0}{Numeric vector of length \code{n}.}
\item{heps}{This is \code{h} in the derivative formula.}
\item{...}{parameters to be passed to f.}
}
\details{
  Computes the derivative of each funktion \eqn{f_j} by variable \eqn{x_i}
  separately, taking the discrete step \eqn{h}.
}
\value{
  Numeric \code{m}-by-\code{n} matrix \code{J} where the entry \code{J[j, i]}
  is \eqn{\frac{\partial f_j}{\partial x_i}}, i.e. the derivatives of function
  \eqn{f_j} line up in row \eqn{i} for \eqn{x_1, \ldots, x_n}.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  Obviously, this function is \emph{not} vectorized.
}
\seealso{
\code{gradient}
}
\examples{
##  Example function from Quarteroni & Saleri
f <- function(x) c(x[1]^2 + x[2]^2 - 1, sin(pi*x[1]/2) + x[2]^3)
jf <- function(x) 
          matrix( c(2*x[1], pi/2 * cos(pi*x[1]/2), 2*x[2], 3*x[2]^2), 2, 2)
all.equal(jf(c(1,1)), jacobian(f, c(1,1)))
# TRUE
}
\keyword{ math }

\name{fminbnd}
\alias{fminbnd}
\title{
  Finding Function Minimum
}
\description{
  Find minimum of single-variable function on fixed interval.
}
\usage{
fminbnd(f, a, b, maxiter = 1000, maximum = FALSE,
        tol = 1e-07, rel.tol = tol, abs.tol = 1e-15, ...)
}
\arguments{
  \item{f}{function whose minimum or maximum is to be found.}
  \item{a, b}{endpoints of the interval to be searched.}
  \item{maxiter}{maximal number of iterations.}
  \item{maximum}{logical; shall maximum or minimum be found; default FALSE.}
  \item{tol}{relative tolerance; left over for compatibility.}
  \item{rel.tol, abs.tol}{relative and absolute tolerance.}
  \item{...}{additional variables to be passed to the function.}
}
\details{
  fminbnd finds the minimum of a function of one variable within a fixed
  interval. It applies Brent's algorithm, based on golden section search and
  parabolic interpolation.

  \code{fminbnd} may only give local solutions.
  \code{fminbnd} never evaluates \code{f} at the endpoints.
}
\value{
  List with
  \item{xmin}{location of the minimum resp. maximum.}
  \item{fmin}{function value at the optimum.}
  \item{niter}{number of iterations used.}
  \item{estim.prec}{estimated precision.}
}
\references{
  R. P. Brent (1973). Algorithms for Minimization Without Derivatives.
  Dover Publications, reprinted 2002.
}
\note{
  \code{fminbnd} mimics the Matlab function of the same name.
}
\seealso{
  \code{\link{fibsearch}}, \code{\link{golden_ratio}}
}
\examples{
##  CHEBFUN example by Trefethen
f <- function(x) exp(x)*sin(3*x)*tanh(5*cos(30*x))
fminbnd(f, -1, 1)                   # fourth local minimum (from left)
g <- function(x) complexstep(f, x)  # complex-step derivative
xs <- findzeros(g, -1, 1)           # local minima and maxima
ys <- f(xs); n0 <- which.min(ys)    # index of global minimum
fminbnd(f, xs[n0-1], xs[n0+1])      # xmin:0.7036632, fmin: -1.727377

\dontrun{
ezplot(f, -1, 1, n = 1000, col = "darkblue", lwd = 2)
ezplot(function(x) g(x)/150, -1, 1, n = 1000, col = "darkred", add = TRUE)
grid()}
}
\keyword{ optimize }

\name{isposdef}
\alias{isposdef}
\title{
  Positive Definiteness
}
\description{
  Test for positive definiteness.
}
\usage{
isposdef(A, psd = FALSE, tol = 1e-10)
}
\arguments{
  \item{A}{symmetric matrix}
  \item{psd}{logical, shall semi-positive definiteness be tested?}
  \item{tol}{tolerance to check symmetry and Cholesky decomposition.}
}
\details{
  Whether matrix \code{A} is positive definite will be determined by
  applying the Cholesky decomposition. The matrix must be symmetric.

  With \code{psd=TRUE} the matrix will be tested for being semi-positive
  definite. If not positive definite, still a warning will be generated.
}
\value{
  Returns \code{TRUE} or \code{FALSE}.
}
\examples{
A <- magic(5)
# isposdef(A)
## [1] FALSE
## Warning message:
## In isposdef(A) : Matrix 'A' is not symmetric.
## FALSE

A <- t(A) \%*\% A
isposdef(A)
## [1] TRUE

A[5, 5] <- 0
isposdef(A)
## [1] FALSE
}
\keyword{ array }

\name{bulirsch-stoer}
\alias{bulirsch_stoer}
\alias{midpoint}
\title{
  Bulirsch-Stoer Algorithm
}
\description{
  Bulirsch-Stoer algorithm for solving Ordinary Differential Equations (ODEs)
  very accurately.
}
\usage{
bulirsch_stoer(f, t, y0, ..., tol = 1e-07)

midpoint(f, t0, tfinal, y0, tol = 1e-07, kmax = 25)
}
\arguments{
  \item{f}{function describing the differential equation \eqn{y' = f(t, y)}.}
  \item{t}{vector of \code{x}-values where the values of the ODE function
           will be computed; needs to be increasingly sorted.}
  \item{y0}{starting values as column vector.}
  \item{...}{additional parameters to be passed to the function.}
  \item{tol}{relative tolerance in the Ricardson extrapolation.}
  \item{t0, tfinal}{start and end point of the interval.}
  \item{kmax}{maximal number of steps in the Richardson extrapolation.}
}
\details{
  The Bulirsch-Stoer algorithm is a well-known method to obtain high-accuracy
  solutions to ordinary differential equations with reasonable computational
  efforts. It exploits the midpoint method to get good accuracy in each step.
  
  The (modified) midpoint method computes the values of the dependent
  variable \code{y(t)} from \code{t0} to \code{tfinal} by a sequence of
  substeps, applying Richardson extrapolation in each step.

  Bulirsch-Stoer and midpoint shall not be used with non-smooth functions or
  singularities inside the interval. The best way to get intermediate points
  \code{t = (t[1], ..., t[n])} may be to call \code{ode23} or \code{ode23s}
  first and use the \code{x}-values returned to start \code{bulirsch_stoer}
  on.
}
\value{
  bulirsch_stoer returns a list with \code{x} the grid points input, and
  \code{y} a vector of function values at the se points.
}
\references{
  J. Stoer and R. Bulirsch (2002). Introduction to Numerical Analysis.
  Third Edition, Texts in Applied Mathematics 12, Springer Science +
  Business, LCC, New York.
}
\author{
  Copyright (c) 2014 Hans W Borchers
}
\note{
  Will be extended to become a full-blown Bulirsch-Stoer implementation.
}
\seealso{
  \code{\link{ode23}}, \code{\link{ode23s}}
}
\examples{
## Example: y'' = -y
f1 <- function(t, y) as.matrix(c(y[2], -y[1]))
y0 <- as.matrix(c(0.0, 1.0))
tt <- linspace(0, pi, 13)
yy <- bulirsch_stoer(f1, tt, c(0.0, 1.0))   # 13 equally-spaced grid points
yy[nrow(yy), 1]                             # 1.1e-11

\dontrun{
S  <- ode23(f1, 0, pi, c(0.0, 1.0))
yy <- bulirsch_stoer(f1, S$t, c(0.0, 1.0))  # S$x 13 irregular grid points
yy[nrow(yy), 1]                             #  2.5e-11
S$y[nrow(S$y), 1]                           # -7.1e-04

## Example: y' = -200 x y^2                 # y(x) = 1 / (1 + 100 x^2)
f2 <- function(t, y) -200 * t * y^2
y0 < 1
tic(); S <- ode23(f2, 0, 1, y0); toc()            # 0.002 sec
tic(); yy <- bulirsch_stoer(f2, S$t, y0); toc()   # 0.013 sec}
}
\keyword{ ode }

\name{wilkinson}
\alias{wilkinson}
\title{wilkinson Matrix}
\description{
Generate the Wilkinson matrix of size \code{n x n}.The Wilkinson matrix for
testing eigenvalue computations
}
\usage{
wilkinson(n)
}
\arguments{
  \item{n}{integer}
}
\details{
The Wilkinson matrix for testing eigenvalue computations is a symmetric
matrix with three non-zero diagonals and with several pairs of nearly equal
eigenvalues. 
}
\value{
matrix of size \code{n x n}
}
\note{
The two largest eigenvalues of \code{wilkinson(21)} agree to 14, but not 15
decimal places.
}
\seealso{
\code{\link{Toeplitz}}
}
\examples{
(a <- wilkinson(7))
eig(a)
}
\keyword{ specmat }

\name{quadgr}
\alias{quadgr}
\title{
  Gaussian Quadrature with Richardson Extrapolation
}
\description{
  Gaussian 12-point quadrature with Richardson extrapolation.
}
\usage{
quadgr(f, a, b, tol = .Machine$double.eps^(1/2), ...)
}
\arguments{
  \item{f}{integrand as function, may have singularities at the endpoints.}
  \item{a, b}{endpoints of the integration interval.}
  \item{tol}{relative tolerence.}
  \item{\ldots}{Additional parameters to be passed to the function \code{f}.}
}
\details{
  \code{quadgr} uses a 12-point Gauss-Legendre quadrature.
  The error estimate is based on successive interval bisection. Richardson
  extrapolation accelerates the convergence for some integrals, especially
  integrals with endpoint singularities.

  Through some preprocessing infinite intervals can also be handled.
}
\value{
  List with \code{value} and \code{rel.err}.
}
\author{
  Copyright (c) 2009 Jonas Lundgren for the Matlab function \code{quadgr}
  available on MatlabCentral under the BSD license.
  
  R re-implementation by HwB, email: <hwborchers@googlemail.com>, in 2011.
}
\seealso{
  \code{gaussLegendre}
}
\examples{
##  Dilogarithm function
flog <- function(t) log(1-t)/t
quadgr(flog, 1, 0, tol = 1e-12)
# value
# 1.6449340668482 , is pi^2/6 = 1.64493406684823
# rel.err
# 2.07167616395054e-13
}
\keyword{ math }

\name{complexstep}
\alias{complexstep}
\alias{grad_csd}
\alias{jacobian_csd}
\alias{hessian_csd}
\alias{laplacian_csd}
\title{Complex Step Derivatives}
\description{
  Complex step derivatives of real-valued functions, including gradients,
  Jacobians, and Hessians.
}
\usage{
complexstep(f, x0, h = 1e-20, ...)

grad_csd(f, x0, h = 1e-20, ...)
jacobian_csd(f, x0, h = 1e-20, ...)
hessian_csd(f, x0, h = 1e-20, ...)
laplacian_csd(f, x0, h = 1e-20, ...)
}
\arguments{
  \item{f}{Function that is to be differentiated.}
  \item{x0}{Point at which to differentiate the function.}
  \item{h}{Step size to be applied; shall be \emph{very} small.}
  \item{...}{Additional variables to be passed to \code{f}.}
}
\details{
  Complex step derivation is a fast and highly exact way of numerically
  differentiating a function. If the following conditions are satisfied,
  there will be no loss of accuracy between computing a function value
  and computing the derivative at a certain point.
  \itemize{
    \item \code{f} must have an analytical (i.e., complex differentiable)
    continuation into an open neighborhood of \code{x0}.
    \item \code{x0} \bold{and} \code{f(x0)} must be real.
    \item \code{h} is real and \emph{very} small: \code{0 < h << 1}.
  }

  \code{complexstep} handles differentiation of univariate functions, while
  \code{grad_csd} and \code{jacobian_csd} compute gradients and Jacobians by
  applying the complex step approach iteratively. Please understand that these 
  functions are not vectorized, but \code{complexstep} is.

  As complex step cannot be applied twice (the first derivative does not
  fullfil the conditions), \code{hessian_csd} works differently. For the
  first derivation, complex step is used, to the one time derived function
  Richardson's method is applied. The same applies to \code{lapalacian_csd}.

  
}
\value{
  \code{complexstep(f, x0)} returns the derivative \eqn{f'(x_0)} of \eqn{f}
  at \eqn{x_0}. The function is vectorized in \code{x0}.  
}
\references{
  Martins, J. R. R. A., P. Sturdza, and J. J. Alonso (2003).
  The Complex-step Derivative Approximation.
  ACM Transactions on Mathematical Software, Vol. 29, No. 3, pp. 245--262.
}
\author{
  HwB <hwborchers@googlemail.com>
}
\note{
  This surprising approach can be easily deduced from the complex-analytic
  Taylor formula.
}
\seealso{
\code{\link{numderiv}}
}
\examples{
##  Example from Martins et al.
f <- function(x) exp(x)/sqrt(sin(x)^3 + cos(x)^3)  # derivative at x0 = 1.5
# central diff formula    # 4.05342789402801, error 1e-10
# numDeriv::grad(f, 1.5)  # 4.05342789388197, error 1e-12  Richardson
# pracma::numderiv        # 4.05342789389868, error 5e-14  Richardson
complexstep(f, 1.5)       # 4.05342789389862, error 1e-15
# Symbolic calculation:   # 4.05342789389862

jacobian_csd(f, 1.5)

f1 <- function(x) sum(sin(x))
grad_csd(f1, rep(2*pi, 3))
## [1] 1 1 1

laplacian_csd(f1, rep(pi/2, 3))
## [1] -3

f2 <- function(x) c(sin(x[1]) * exp(-x[2]))
hessian_csd(f2, c(0.1, 0.5, 0.9))
##             [,1]        [,2] [,3]
## [1,] -0.06055203 -0.60350053    0
## [2,] -0.60350053  0.06055203    0
## [3,]  0.00000000  0.00000000    0

f3 <- function(u) {
    x <- u[1]; y <- u[2]; z <- u[3]
    matrix(c(exp(x^+y^2), sin(x+y), sin(x)*cos(y), x^2 - y^2), 2, 2)
  }
jacobian_csd(f3, c(1,1,1))
##            [,1]       [,2] [,3]
## [1,]  2.7182818  0.0000000    0
## [2,] -0.4161468 -0.4161468    0
## [3,]  0.2919266 -0.7080734    0
## [4,]  2.0000000 -2.0000000    0
}
\keyword{ math }

\name{crossn}
\alias{crossn}
\title{n-dimensional Vector Cross Product}
\description{
  Vector cross product of \code{n-1} vectors in n-dimensional space
}
\usage{
crossn(A)
}
\arguments{
  \item{A}{matrix of size \code{(n-1) x n} where \code{n >= 2}.}
}
\details{
  The rows of the matrix \code{A} are taken as\code{(n-1)} vectors in
  \code{n}-dimensional space. The cross product generates a vector in this
  space that is orthogonal to all these rows in \code{A} and its length is
  the volume of the geometric hypercube spanned by the vectors.
}
\value{
  a vector of length \code{n}
}
\note{
  The `scalar triple product' in \eqn{R^3} can be defined as

  \code{spatproduct <- function(a, b, c) dot(a, crossn(b, c))}

  It represents the volume of the parallelepiped spanned by the three vectors.
}
\seealso{
\code{\link{cross}}, \code{\link{dot}}
}
\examples{
A <- matrix(c(1,0,0, 0,1,0), nrow=2, ncol=3, byrow=TRUE)
crossn(A)  #=> 0 0 1

x <- c(1.0, 0.0, 0.0)
y <- c(1.0, 0.5, 0.0)
z <- c(0.0, 0.0, 1.0)
identical(dot(x, crossn(rbind(y, z))), det(rbind(x, y, z)))
}
\keyword{ array }

\name{simpson2d}
\alias{simpson2d}
\title{
  Double Simpson Integration
}
\description{
  Numerically evaluate double integral by 2-dimensional Simpson method.
}
\usage{
simpson2d(f, xa, xb, ya, yb, nx = 128, ny = 128, ...)
}
\arguments{
  \item{f}{function of two variables, the integrand.}
  \item{xa, xb}{left and right endpoint for first variable.}
  \item{ya, yb}{left and right endpoint for second variable.}
  \item{nx, ny}{number of intervals in x- and y-direction.}
  \item{\ldots}{additional parameters to be passed to the integrand.}
}
\details{
  The 2D Simpson integrator has weights that are most easily determined 
  by taking the outer product of the vector of weights for the 1D Simpson
  rule.
}
\value{
  Numerical scalar, the value of the integral.
}
\note{
  Copyright (c) 2008 W. Padden and Ch. Macaskill for Matlab code published
  under BSD License on MatlabCentral.
}
\seealso{
  \code{\link{dblquad}}, \code{\link{quad2d}}
}
\examples{
f1 <- function(x, y) x^2 + y^2
simpson2d(f1, -1, 1, -1, 1)     #   2.666666667 , i.e. 8/3 . err = 0

f2 <- function(x, y) y*sin(x)+x*cos(y)
simpson2d(f2, pi, 2*pi, 0, pi)  #  -9.869604401 , i.e. -pi^2, err = 2e-8

f3 <- function(x, y) sqrt((1 - (x^2 + y^2)) * (x^2 + y^2 <= 1))
simpson2d(f3, -1, 1, -1, 1)     #   2.094393912 , i.e. 2/3*pi , err = 1e-6
}
\keyword{ math }

\name{L1linreg}
\alias{L1linreg}
\title{
  L1 Linear Regression
}
\description{
  Solve the linear system \code{A x = b} in an Lp sense, that is minimize the
  term \code{sum |b - A x|^p}. The case \code{p=1} is also called 
  ``least absolute deviation'' (LAD) regression.
}
\usage{
L1linreg(A, b, p = 1, tol = 1e-07, maxiter = 200)
}
\arguments{
  \item{A}{matrix of independent variables.}
  \item{b}{independent variables.}
  \item{p}{the p in L^p norm, \code{p<=1}.}
  \item{tol}{relative tolerance.}
  \item{maxiter}{maximum number of iterations.}
}
\details{
  L1/Lp regression is here solved  applying the ``iteratively reweighted least
  square'' (IRLS) method in which each step involves a weighted least squares
  problem.

  If an intercept term is required, add a unit column to \code{A}.
}
\value{
  Returns a list with components \code{x} the linear coefficients describing
  the solution, \code{reltol} the relative tolerance reached, and \code{niter}
  the number of iterations.
}
\references{
  Dasgupta, M., and S.K. Mishra (2004). Least absolute deviation estimation 
  of linear econometric models: A literature review. MPRA Paper No. 1781.
}
\note{
  In this case of \code{p=1}, the problem would be better approached by use
  of linear programming methods.
}
\seealso{
  \code{\link{lm}}, \code{\link{lsqnonlin}}, \code{quantreg::rq}
}
\examples{
m <- 101; n <- 10       # no. of data points, degree of polynomial
x <- seq(-1, 1, len=m)
y <- runge(x)           # Runge's function
A <- outer(x, n:0, '^') # Vandermonde matrix
b <- y

( sol <- L1linreg(A, b) )
# $x
# [1] -21.93242   0.00000  62.91092   0.00000 -67.84854   0.00000
# [7]  34.14400   0.00000  -8.11899   0.00000   0.84533
# 
# $reltol
# [1] 6.712355e-10
# 
# $niter
# [1] 81

# minimum value of polynomial L1 regression
sum(abs(polyval(sol$x, x) - y))
# [1] 3.061811
}

\keyword{ optimize }

\name{itersolve}
\alias{itersolve}
\title{
  Iterative Methods
}
\description{
  Iterative solutions of systems of linear equations.
}
\usage{
itersolve(A, b, x0 = NULL, nmax = 1000, tol = .Machine$double.eps^(0.5),
            method = c("Gauss-Seidel", "Jacobi", "Richardson"))
}
\arguments{
\item{A}{numerical matrix, square and non-singular.}
\item{b}{numerical vector or column vector.}
\item{x0}{starting solution for iteration; defaults to null vector.}
\item{nmax}{maximum number of iterations.}
\item{tol}{relative tolerance.}
\item{method}{iterative method, Gauss-Seidel, Jacobi, or Richardson.}
}
\details{
  Iterative methods are based on splitting the matrix \code{A=(P-A)-A}
  with a so-called `preconditioner' matrix P. The methods differ in how
  to choose this preconditioner.
}
\value{
  Returns a list with components \code{x} the solution, \code{iter} the
  number of iterations, and \code{method} the name of the method applied.
}
\references{
  Quarteroni, A., and F. Saleri (2006). Scientific Computing with MATLAB
  and Octave. Springer-Verlag, Berlin Heidelberg.
}
\note{
  Richardson's method allows to specify a `preconditioner'; this has not
  been implemented yet.
}
\seealso{
  \code{\link{qrSolve}}
}
\examples{
N <- 10
A <- Diag(rep(3,N)) + Diag(rep(-2, N-1), k=-1) + Diag(rep(-1, N-1), k=1)
b <- A \%*\% rep(1, N)
x0 <- rep(0, N)

itersolve(A, b, tol = 1e-8, method = "Gauss-Seidel")
# [1]  1  1  1  1  1  1  1  1  1  1
# [1]  87
itersolve(A, b, x0 = 1:10, tol = 1e-8, method = "Jacobi")
# [1]  1  1  1  1  1  1  1  1  1  1
# [1]  177
}
\keyword{ array }

\name{quadprog}
\alias{quadprog}
\title{
  Quadratic Programming
}
\description{
  Solves quadratic programming problems with linear and box constraints.
}
\usage{
quadprog(C, d, A = NULL, b = NULL,
         Aeq = NULL, beq = NULL, lb = NULL, ub = NULL) 
}
\arguments{
  \item{C}{symmetric matrix, representing the quadratic term.}
  \item{d}{vector, representing the linear term.}
  \item{A}{matrix, represents the linear constraint coefficients.}
  \item{b}{vector, constant vector in the constraints.}
  \item{Aeq}{matrix, linear equality constraint coefficients.}
  \item{beq}{vector, constant equality constraint vector.}
  \item{lb}{elementwise lower bounds.}
  \item{ub}{elementwise upper bounds.}
}
\details{
  Finds a minimum for the quadratic programming problem specified as:
  \deqn{min 1/2 x'Cx + d'x}
  such that the following constraints are satisfied:
  \deqn{A x <= b}
  \deqn{Aeq x = beq}
  \deqn{lb <= x <= ub}
  The matrix should be symmetric and positive definite, in which case
  the solution is unique, indicated when the exit flag is 1.

  For more information, see \code{?solve.QP}.
}
\value{
  Returns a list with components
    \item{xmin}{minimum solution, subject to all bounds and constraints.}
    \item{fval}{value of the target expression at the arg minimum.}
    \item{eflag}{exit flag.}
}
\references{
  Nocedal, J., and St. J. Wright (2006). Numerical Optimization.
  Second Edition, Springer Series in Operations Research, New York.
}
\note{
  This function is wrapping the active set quadratic solver in the 
  \code{quadprog} package: \code{quadprog::solve.QP}, combined with
  a more MATLAB-like API interface.
}
\seealso{
  \code{\link{lsqlincon}}, \code{quadprog::solve.QP}
}
\examples{
## Example in ?solve.QP
# Assume we want to minimize: 1/2 x^T x - (0 5 0) %*% x
# under the constraints:      A x <= b
# with b = (8,-2, 0)
# and      ( 4  3  0) 
#      A = (-2 -1  0)
#          ( 0  2,-1)
# and possibly equality constraint  3x1 + 2x2 + x3 = 1
# or upper bound c(1.5, 1.5, 1.5).

C <- diag(1, 3); d <- -c(0, 5, 0)
A <- matrix(c(4,3,0, -2,-1,0, 0,2,-1), 3, 3, byrow=TRUE)
b <- c(8, -2, 0)

quadprog(C, d, A, b)
# $xmin
# [1] 0.4761905 1.0476190 2.0952381
# $fval
# [1] -2.380952
# $eflag
# [1] 1

Aeq <- c(3, 2, 1);  beq <- 1
quadprog(C, d, A, b, Aeq, beq)
# $xmin
# [1]  1.4 -0.8 -1.6
# $fval
# [1] 6.58
# $eflag
# [1] 1

quadprog(C, d, A, b, lb = 0, ub = 1.5)
# $xmin
# [1] 0.625 0.750 1.500
# $fval
# [1] -2.148438
# $eflag
# [1] 1

## Example help(quadprog)
C <- matrix(c(1, -1, -1, 2), 2, 2)
d <- c(-2, -6)
A <- matrix(c(1,1, -1,2, 2,1), 3, 2, byrow=TRUE)
b <- c(2, 2, 3)
lb <- c(0, 0)

quadprog(C, d, A, b, lb=lb)
# $xmin
# [1] 0.6666667 1.3333333
# $fval
# [1] -8.222222
# $eflag
# [1] 1
}
\keyword{ optimize }

\name{detrend}
\alias{detrend}
\title{
  Remove Linear Trends
}
\description{
  Removes the mean value or (piecewise) linear trend from a vector or
  from each column of a matrix.
}
\usage{
detrend(x, tt = 'linear', bp = c())
}
\arguments{
  \item{x}{vector or matrix, columns considered as the time series.}
  \item{tt}{trend type, `constant' or `linear', default is `linear'.}
  \item{bp}{break points, indices between 1 and \code{nrow(x)}.}
}
\details{
  \code{detrend} computes the least-squares fit of a straight line (or
  composite line for piecewise linear trends) to the data and subtracts the
  resulting function from the data.

  To obtain the equation of the straight-line fit, use \code{polyfit}.
}
\value{
  removes the mean or (piecewise) linear trend from \code{x} and returns it
  in \code{y=detrend(x)}, that is \code{x-y} \emph{is} the linear trend.
}
\note{
  Detrending is often used for FFT processing.
}
\seealso{
  \code{\link{polyfit}}
}
\examples{
t <- 1:9
x <- c(0, 2, 0, 4, 4, 4, 0, 2, 0)
x - detrend(x, 'constant')
x - detrend(x, 'linear')

y <- detrend(x, 'linear', 5)
\dontrun{
plot(t, x, col="blue")
lines(t, x - y, col="red")
grid()}
}
\keyword{ math }

\name{dblquad}
\alias{dblquad}
\alias{triplequad}
\title{
  Double and Triple Integration
}
\description{
  Numerically evaluate double integral over rectangle.
}
\usage{
dblquad(f, xa, xb, ya, yb, dim = 2, ..., 
        subdivs = 300, tol = .Machine$double.eps^0.5)

triplequad(f, xa, xb, ya, yb, za, zb, 
            subdivs = 300, tol = .Machine$double.eps^0.5, ...)
}
\arguments{
  \item{f}{function of two variables, the integrand.}
  \item{xa, xb}{left and right endpoint for first variable.}
  \item{ya, yb}{left and right endpoint for second variable.}
  \item{za, zb}{left and right endpoint for third variable.}
  \item{dim}{which variable to integrate first.}
  \item{subdivs}{number of subdivisions to use.}
  \item{tol}{relative tolerance to use in \code{integrate}.}
  \item{\ldots}{additional parameters to be passed to the integrand.}
}
\details{
  Function \code{dblquad} applies the internal single variable integration
  function \code{integrate} two times, once for each variable.

  Function \code{triplequad} reduces the problem to \code{dblquad} by
  first integrating over the innermost variable.
}
\value{
  Numerical scalar, the value of the integral.
}
\seealso{
  \code{\link{integrate}}, \code{\link{quad2d}}, \code{\link{simpson2d}}
}
\examples{
f1 <- function(x, y) x^2 + y^2
dblquad(f1, -1, 1, -1, 1)       #   2.666666667 , i.e. 8/3 . err = 0

f2 <- function(x, y) y*sin(x)+x*cos(y)
dblquad(f2, pi, 2*pi, 0, pi)    #  -9.869604401 , i.e. -pi^2, err = 0

# f3 <- function(x, y) sqrt((1 - (x^2 + y^2)) * (x^2 + y^2 <= 1))
f3 <- function(x, y) sqrt(pmax(0, 1 - (x^2 + y^2)))
dblquad(f3, -1, 1, -1, 1)       #   2.094395124 , i.e. 2/3*pi , err = 2e-8

f4 <- function(x, y, z) y*sin(x)+z*cos(x)
triplequad(f4, 0,pi, 0,1, -1,1) # - 2.0 => -2.220446e-16
}
\keyword{ math }

\name{repmat}
\alias{repmat}
\title{Replicate Matrix}
\description{
  Replicate and tile matrix.
}
\usage{
repmat(a, n, m = n)
}
\arguments{
  \item{a}{vector or matrix to be replicated.}
  \item{n, m}{number of times to replicate in each dimension.}
}
\details{
  \code{repmat(a,m,n)} creates a large matrix consisting of an m-by-n tiling
  of copies of \code{a}. 
}
\value{
  Returns matrix with value \code{a} replicated to the number of times
  in each dimension specified.
  Defaults to square if dimension argument resolves to a single value.
}
\seealso{ 
  \code{\link{Reshape}}
}   
\examples{
repmat(1, 3)                  # same as ones(3)
repmat(1, 3, 3)
repmat(matrix(1:4, 2, 2), 3)
}
\keyword{array}

\name{Si, Ci}
\alias{Si}
\alias{Ci}
\title{
  Sine and Cosine Integral Functions
}
\description{
  Computes the sine and cosine integrals through approximations.
}
\usage{
Si(x)
Ci(x)
}
\arguments{
  \item{x}{Scalar or vector of real numbers.}
}
\details{
  The sine and cosine integrals are defined as
  \deqn{Si(x) = \int_0^x \frac{\sin(t)}{t} dt}
  \deqn{Ci(x) = - \int_x^\infty \frac{\cos(t)}{t} dt = \gamma + \log(x) + \int_0^x \frac{\cos(t)-1}{t} dt}
  where \eqn{\gamma} is the Euler-Mascheroni constant.
}
\value{
  Returns a scalar of sine resp. cosine integrals applied to each
  element of the scalar/vector. The value \code{Ci(x)} is not correct, 
  it should be \code{Ci(x)+pi*i}, only the real part is returned!
  
  The function is not truely vectorized, for vectors the values are
  calculated in a for-loop. The accuracy is about \code{10^-13} and better
  in a reasonable range of input values.
}
\references{
  Zhang, S., and J. Jin (1996). Computation of Special Functions. Wiley-Interscience.
}
\seealso{
  \code{\link{sinc}}, \code{\link{expint}}
}

\examples{
x <- c(-3:3) * pi
Si(x); Ci(x)

\dontrun{
xs <- linspace(0, 10*pi, 200)
ysi <- Si(xs); yci <- Ci(xs)
plot(c(0, 35), c(-1.5, 2.0), type = 'n', xlab = '', ylab = '',
     main = "Sine and cosine integral functions")
lines(xs, ysi, col = "darkred",  lwd = 2)
lines(xs, yci, col = "darkblue", lwd = 2)
lines(c(0, 10*pi), c(pi/2, pi/2), col = "gray")
lines(xs, cos(xs), col = "gray")
grid()}
}

\keyword{ specfun }

\name{inpolygon}
\alias{inpolygon}
\title{
  Polygon Region
}
\description{
  Points inside polygon region.
}
\usage{
inpolygon(x, y, xp, yp, boundary = FALSE)
}
\arguments{
  \item{x, y}{x-, y-coordinates of points to be tested for being inside
              the polygon region.}
  \item{xp, yp}{coordinates of the vertices specifying the polygon.}
  \item{boundary}{Logical; does the boundary belong to the interior.}
}
\details{
  For a polygon defined by points \code{(xp, yp)}, determine if the
  points \code{(x, y)} are inside or outside the polygon. The boundary
  can be included or excluded (default) for the interior.
}
\value{
  Logical vector, the same length as \code{x}.
}
\references{
  Hormann, K., and A. Agathos (2001). The Point in Polygon Problem for
  Arbitrary Polygons. Computational Geometry, Vol. 20, No. 3, pp. 131--144.
}
\note{
  Special care taken for points on the boundary.
}
\seealso{
\code{\link{polygon}}
}
\examples{
xp <- c(0.5, 0.75, 0.75, 0.5, 0.5)
yp <- c(0.5, 0.5, 0.75, 0.75, 0.5)
x <- c(0.6, 0.75, 0.6, 0.5)
y <- c(0.5, 0.6, 0.75, 0.6)
inpolygon(x, y, xp, yp, boundary = FALSE)  # FALSE
inpolygon(x, y, xp, yp, boundary = TRUE)   # TRUE

\dontrun{
pg <- matrix(c(0.15, 0.75, 0.25, 0.45, 0.70,
               0.80, 0.35, 0.55, 0.20, 0.90), 5, 2)
plot(c(0, 1), c(0, 1), type="n")
polygon(pg[,1], pg[,2])
P <- matrix(runif(20000), 10000, 2)
R <- inpolygon(P[, 1], P[, 2], pg[, 1], pg[,2])
clrs <- ifelse(R, "red", "blue")
points(P[, 1], P[, 2], pch = ".", col = clrs)}
}
\keyword{ geom }

\name{haversine}
\alias{haversine}
\title{
  Haversine Formula
}
\description{
  Haversine formula to calculate the arc distance between two points
  on earth (i.e., along a great circle).
}
\usage{
haversine(loc1, loc2, R = 6371.0)
}
\arguments{
  \item{loc1, loc2}{Locations on earth; for format see Details.}
  \item{R}{Average earth radius R = 6371 km, can be changed on input.}
}
\details{
  The Haversine formula is more robust for the calculating the distance 
  as with the spherical cosine formula. The user may want to assume a 
  slightly different earth radius, so this can be provided as input.

  The location can be input in two different formats, as latitude and
  longitude in a character string, e.g. for Frankfurt airport as
  '50 02 00N, 08 34 14E', or as a numerical two-vector in degrees
  (not radians).

  Here for latitude 'N' and 'S' stand for North and South, and for
  longitude 'E' or 'W' stand for East and West. For the degrees format,
  South and West must be negative.

  These two formats can be mixed.
}
\value{
  Returns the distance in km.
}
\references{
  Entry 'Great_circle_distance' in Wikipedia.
}
\author{
  Hans W. Borchers
}
\seealso{
  Implementations of the Haversine formula can also be found in other
  R packages, e.g. 'geoPlot' or 'geosphere'.
}
\examples{
FRA = '50 02 00N, 08 34 14E'  # Frankfurt Airport
ORD = '41 58 43N, 87 54 17W'  # Chicago O'Hare Interntl. Airport
fra <- c(50+2/60, 8+34/60+14/3600)
ord <- c(41+58/60+43/3600, -(87+54/60+17/3600))

dis <- haversine(FRA, ORD)    # 6971.059 km
fprintf('Flight distance Frankfurt-Chicago is \%8.3f km.\n', dis)

dis <- haversine(fra, ord)
fprintf('Flight distance Frankfurt-Chicago is \%8.3f km.\n', dis)
}
\keyword{ geom }

\name{deg2rad}
\alias{deg2rad}
\alias{rad2deg}
\title{Degrees to Radians}
\description{
  Transforms between angles in degrees and radians.
}
\usage{
deg2rad(deg)
rad2deg(rad)
}
\arguments{
  \item{deg}{(array of) angles in degrees.}
  \item{rad}{(array of) angles in radians.}
}
\details{
  This is a simple calculation back and forth. Note that angles greater than
  360 degrees are allowed and will be returned. This may appear incorrect but
  follows a corresponding discussion on Matlab Central.
}
\value{
  The angle in degrees or radians.
}
\examples{
deg2rad(c(0, 10, 20, 30, 40, 50, 60, 70, 80, 90))
rad2deg(seq(-pi/2, pi/2, length = 19))
}
\keyword{math}

\name{bernstein}
\alias{bernstein}
\alias{bernsteinb}
\title{
  Bernstein Polynomials
}
\description{
  Bernstein base polynomials and approximations.
}
\usage{
bernstein(f, n, x)

bernsteinb(k, n, x)
}
\arguments{
  \item{f}{function to be approximated by Bernstein polynomials.}
  \item{k}{integer between 0 and n, the k-th Bernstein polynomial
           of order n.}
  \item{n}{order of the Bernstein polynomial(s).}
  \item{x}{numeric scalar or vector where the Bernstein polynomials
           will be calculated.}
}
\details{
  The Bernstein basis polynomials \eqn{B_{k,n}(x)} are defined as
  \deqn{ B_{k,n}(x) = {{n}\choose{k}} x^k (1-x)^{n-k} }
  and form a basis for the vector space of polynomials of degree 
  \eqn{n} over the interval \eqn{[0,1]}.

  \code{bernstein(f, n, x)} computes the approximation of function
  \code{f} through Bernstein polynomials of degree \code{n}, resp.
  computes the value of this approximation at \code{x}. The function
  is vectorized and applies a brute force calculation.

  But if \code{x} is a scalar, the value will be calculated using
  De Casteljau's algorithm for higher accuracy. For bigger \code{n}
  the binomial coefficients may be in for problems.
}
\value{
  Returns a scalar or vector of function values.
}
\references{
  See https://en.wikipedia.org/wiki/Bernstein_polynomial
}
\examples{
## Example
f <- function(x) sin(2*pi*x)
xs <- linspace(0, 1)
ys <- f(xs)
\dontrun{
plot(xs, ys, type='l', col="blue",
     main="Bernstein Polynomials")
grid()
b10  <- bernstein(f,  10, xs)
b100 <- bernstein(f, 100, xs)
lines(xs, b10,  col="magenta")
lines(xs, b100, col="red") }

# Bernstein basis polynomials
\dontrun{
xs <- linspace(0, 1)
plot(c(0,1), c(0,1), type='n',
     main="Bernstein Basis Polynomials")
grid()
n = 10
for (i in 0:n) {
    bs <- bernsteinb(i, n, xs)
    lines(xs, bs, col=i+1)
} }
}
\keyword{ math }

\name{mod, rem}
\alias{mod}
\alias{rem}
\alias{idivide}
\title{Integer Division}
\description{
  Integer division functions and remainders
}
\usage{
mod(n, m)
rem(n, m)

idivide(n, m, rounding = c("fix", "floor", "ceil", "round"))
}
\arguments{
  \item{n}{numeric vector (preferably of integers)}
  \item{m}{must be a scalar integer (positive, zero, or negative)}
  \item{rounding}{rounding mode.}
}
\details{
  \code{mod(n, m)} is the modulo operator and returns \eqn{n\,mod\,m}.
  \code{mod(n, 0)} is \code{n}, and the result always has the same sign
  as \code{m}.

  \code{rem(n, m)} is the same modulo operator and returns \eqn{n\,mod\,m}.
  \code{mod(n, 0)} is \code{NaN}, and the result always has the same sign
  as \code{n}.

  \code{idivide(n, m)} is integer division, with the same effect as
  \code{n \%/\% m} or using an optional rounding mode.
}
\value{
  a numeric (integer) value or vector/matrix.
}
\note{
  The following relation is fulfilled (for \code{m != 0}):

  \code{mod(n, m) = n - m * floor(n/m)}
}
\seealso{
Binary R operators \code{\%/\%} and \code{\%\%}.
}
\examples{
mod(c(-5:5), 5)
rem(c(-5:5), 5)

idivide(c(-2, 2), 3, "fix")     #  0 0
idivide(c(-2, 2), 3, "floor")   # -1 0
idivide(c(-2, 2), 3, "ceil")    #  0 1
idivide(c(-2, 2), 3, "round")   # -1 1
}
\keyword{ arith }

\name{hadamard}
\alias{hadamard}
\title{Hadamard Matrix}
\description{
  Generate Hadamard matrix of a certain size.
}
\usage{
hadamard(n)
}
\arguments{
  \item{n}{An integer of the form 2^e, 12*2^e, or 20*2^e}
}
\details{
  An \code{n}-by-\code{n} Hadamard matrix with \code{n>2} exists only if
  \code{rem(n,4)=0}. This function handles only the cases where \code{n},
  \code{n/12}, or \code{n/20} is a power of 2.
}
\value{
  Matrix of size \code{n}-by-\code{n} of orthogonal columns consisting of
  1 and -1 only.
}
\note{
  Hadamard matrices have applications in combinatorics, signal processing,
  and numerical analysis.
}
\seealso{
  \code{\link{hankel}}, \code{\link{Toeplitz}}
}
\examples{
hadamard(4)
H <- hadamard(8)
t(H) %*% H        # t(H) %*% H == diag(n, n, n)
}
\keyword{ specmat }

\name{squareform}
\alias{squareform}
\title{
  Format Distance Matrix (Matlab Style)
}
\description{
  Format or generate a distance matrix.
}
\usage{
squareform(x)
}
\arguments{
  \item{x}{numeric vector or matrix.}
}
\details{
  If \code{x} is a vector as created by the \code{dist} function, it converts
  it into a fulll square, symmetric matrix.
  And if \code{x} is a distance matrix, i.e. square, symmetric amd with zero
  diagonal elements, it returns the flattened lower triangular submatrix.
}
\value{
  Returns a matrix if \code{x} is a vector,
  and a vextor if \code{x} is a matrix.
}
\seealso{
  \code{\link{dist}}
}
\examples{
x <- 1:6
y <- squareform(x)
#  0  1  2  3
#  1  0  4  5
#  2  4  0  6
#  3  5  6  0
all(squareform(y) == x)
# TRUE
}
\keyword{ array }

\name{bernoulli}
\alias{bernoulli}
\title{
  Bernoulli Numbers and Polynomials
}
\description{
  The Bernoulli numbers are a sequence of rational numbers that play an
  important role for the series expansion of hyperbolic functions, in the
  Euler-MacLaurin formula, or for certain values of Riemann's function at
  negative integers.
}
\usage{
bernoulli(n, x)
}
\arguments{
  \item{n}{the index, a whole number greater or equal to 0.}
  \item{x}{real number or vector of real numbers; if missing, the
           Bernoulli numbers will be given, otherwise the polynomial.}
}
\details{
  The calculation of the Bernoulli numbers uses the values of the zeta function
  at negative integers, i.e. \eqn{B_n = -n \, zeta(1-n)}. Bernoulli numbers
  \eqn{B_n} for odd \code{n} are 0 except \eqn{B_1} which is set to -0.5 on 
  purpose.

  The Bernoulli polynomials can be directly defined as
  \deqn{ B_n(x) = \sum_{k=0}^n {n \choose k} b_{n-k}\, x^k }
  and it is immediately clear that the Bernoulli numbers are then given as
  \eqn{B_n = B_n(0)}.
}
\value{
  Returns the first \code{n+1} Bernoulli numbers, if \code{x} is missing, or
  the value of the Bernoulli polynomial at point(s) \code{x}.
}
\references{
  See the entry on Bernoulli numbers in the Wikipedia.
}
\note{
  The definition uses \code{B_1 = -1/2} in accordance with the definition of
  the Bernoulli polynomials.
}
\seealso{
  \code{\link{zeta}}
}
\examples{
bernoulli(10)
# 1.00000000 -0.50000000  0.16666667  0.00000000 -0.03333333
# 0.00000000  0.02380952  0.00000000 -0.03333333  0.00000000  0.07575758
                #
\dontrun{
x1 <- linspace(0.3, 0.7, 2)
y1 <- bernoulli(1, x1)
plot(x1, y1, type='l', col='red', lwd=2,
     xlim=c(0.0, 1.0), ylim=c(-0.2, 0.2),
     xlab="", ylab="", main="Bernoulli Polynomials")
grid()
xs <- linspace(0, 1, 51)
lines(xs, bernoulli(2, xs), col="green", lwd=2)
lines(xs, bernoulli(3, xs), col="blue", lwd=2)
lines(xs, bernoulli(4, xs), col="cyan", lwd=2)
lines(xs, bernoulli(5, xs), col="brown", lwd=2)
lines(xs, bernoulli(6, xs), col="magenta", lwd=2)
legend(0.75, 0.2, c("B_1", "B_2", "B_3", "B_4", "B_5", "B_6"),
       col=c("red", "green", "blue", "cyan", "brown", "magenta"),
       lty=1, lwd=2)
  }
}
\keyword{ specfun }

\name{gramSchmidt}
\alias{gramSchmidt}
\title{Gram-Schmidt}
\description{
  Modified Gram-Schmidt Process
}
\usage{
  gramSchmidt(A, tol = .Machine$double.eps^0.5)
}
\arguments{
  \item{A}{numeric matrix with \code{nrow(A)>=ncol(A)}.}
  \item{tol}{numerical tolerance for being equal to zero.}
}
\details{
  The modified Gram-Schmidt process uses the classical orthogonalization
  process to generate step by step an orthonoral basis of a vector space.
  The modified Gram-Schmidt iteration uses orthogonal projectors in order
  ro make the process numerically more stable.
}
\value{
  List with two matrices \code{Q} and \code{R}, \code{Q} orthonormal and
  \code{R} upper triangular, such that \code{A=Q\%*\%R}.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Society for Industrial and Applied Mathematics, Philadelphia.
}
\seealso{
  \code{\link{householder}, \link{givens}}
}
\examples{
##  QR decomposition
A <- matrix(c(0,-4,2, 6,-3,-2, 8,1,-1), 3, 3, byrow=TRUE)
gs <- gramSchmidt(A)
(Q <- gs$Q); (R <- gs$R)
Q \%*\% R  # = A
}
\keyword{ array }

\name{eta}
\alias{eta}
\title{
  Dirichlet Eta Function
}
\description{
  Dirichlet's eta function valid in the entire complex plane.
}
\usage{
eta(z)
}
\arguments{
  \item{z}{Real or complex number or a numeric or complex vector.}
}
\details{
  Computes the eta function for complex arguments using a series expansion.

  Accuracy is about 13 significant digits for \code{abs(z)<100},
  drops off with higher absolute values.
}
\value{
  Returns a complex vector of function values.
}
\references{
  Zhang, Sh., and J. Jin (1996). Computation of Special Functions.
  Wiley-Interscience, New York.
}
\note{
  Copyright (c) 2001 Paul Godfrey for a Matlab version available on
  Mathwork's Matlab Central under BSD license.
}
\seealso{
  \code{\link{gammaz}}, \code{\link{zeta}}
}
\examples{
z <- 0.5 + (1:5)*1i
eta(z)
z <- c(0, 0.5+1i, 1, 1i, 2+2i, -1, -2, -1-1i)
eta(z)
}
\keyword{ specfun }

\name{magic}
\alias{magic}
\title{Magic Square}
\description{
  Create a magic square.
}
\usage{
magic(n)
}
\arguments{
  \item{n}{numeric scalar specifying dimensions for the result;
           \code{n} must be a scalar greater than or equal to 3.}
}
\details{
  A magic square is a square matrix where all row and column sums and also
  the diagonal sums all have the same value.

  This value or the characteristic sum for a magic square of order \eqn{n}
  is \eqn{sum(1:n^2)/n}.
}
\value{
  Returns an \code{n}-by-\code{n} matrix constructed from
  the integers \code{1} through \code{N^2} with equal row and column sums.
}
\note{
  A magic square, scaled by its magic sum, is doubly stochastic.
}
\examples{
magic(3)
}
\author{
  P. Roebuck \email{roebuck@mdanderson.org} for the first R version in the
  package `matlab'. The version here is more R-like.
}
\keyword{array}

\name{fsolve}
\alias{fsolve}
\title{
  Solve System of Nonlinear Equations
}
\description{
  Solve a system of \code{m} nonlinear equations of \code{n} variables.
}
\usage{
fsolve(f, x0, J = NULL,
       maxiter = 100, tol = .Machine$double.eps^(0.5), ...)
}
\arguments{
  \item{f}{function describing the system of equations.}
  \item{x0}{point near to the root.}
  \item{J}{Jacobian function of \code{f}, or \code{NULL}.}
  \item{maxiter}{maximum number of iterations in \code{gaussNewton}.}
  \item{tol}{tolerance to be used in Gauss-Newton.}
  \item{...}{additional variables to be passed to the function.}
}
\details{
  \code{fsolve} tries to solve the components of function \code{f}
  simultaneously and uses the Gauss-Newton method with numerical gradient
  and Jacobian. If \code{m = n}, it uses \code{broyden}. Not applicable
  for univariate root finding.
}
\value{
  List with
  \item{x}{location of the solution.}
  \item{fval}{function value at the solution.}
}
\references{
  Antoniou, A., and W.-S. Lu (2007). Practical Optimization: Algorithms and
  Engineering Applications. Springer Science+Business Media, New York.
}
\note{
  \code{fsolve} mimics the Matlab function of the same name.
}
\seealso{
  \code{\link{broyden}}, \code{\link{gaussNewton}}
}
\examples{
\dontrun{
# Find a matrix X such that X * X * X = [1, 2; 3, 4]
  F <- function(x) {
    a <- matrix(c(1, 3, 2, 4), nrow = 2, ncol = 2, byrow = TRUE)
    X <- matrix(x,             nrow = 2, ncol = 2, byrow = TRUE)
    return(c(X \%*\% X \%*\% X - a))
  }
  x0 <- matrix(1, 2, 2)
  X  <- matrix(fsolve(F, x0)$x, 2, 2)
  X
  # -0.1291489  0.8602157
  #  1.2903236  1.1611747
}
}
\keyword{ optimize }

\name{numderiv}
\alias{numderiv}
\alias{numdiff}
\title{
  Richardson's Numerical Derivative
}
\description{
  Richardson's method applied to the computation of the numerical derivative.
}
\usage{
numderiv(f, x0, maxiter = 16, h = 1/2, ..., tol = .Machine$double.eps)

numdiff(f, x, maxiter = 16, h = 1/2, ..., tol = .Machine$double.eps)
}
\arguments{
  \item{f}{function to be differentiated.}
  \item{x0, x}{point(s) at which the derivative is to be computed.}
  \item{maxiter}{maximum number of iterations.}
  \item{h}{starting step size, should be the default \code{h=0.5}.}
  \item{tol}{relative tolerance.}
  \item{...}{variables to be passed to function \code{f}.}
}
\details{
  \code{numderiv} returns the derivative of \code{f} at \code{x0}, where
  \code{x0} must be a single scalar in the domain of the function.

  \code{numdiff} is a vectorized form of \code{numderiv} such that the
  derivatives will be returned at all points of the vector \code{x}.
}
\value{
  Numeric scalar or vector of approximated derivatives.
}
\references{
  Mathews, J. H., and K. D. Fink (1999). Numerical Methods Using Matlab.
  Third Edition, Prentice Hall.
}
\note{
  See \code{grad} in the `numDeriv' package for another implementation of
  Richardson's method in the context of numerical differentiation.
}
\seealso{
  \code{\link{fderiv}}, \code{\link{complexstep}}
}
\examples{
# Differentiate an anti-derivative function
f <- function(x) sin(x)*sqrt(1+sin(x))
F <- function(x)
        integrate(f, 0, x, rel.tol = 1e-12)$value
x0 <- 1
dF0 <- numderiv(F, x0, tol = 6.5e-15)   #=> 1.141882942715462
f(x0)                                   #   1.141882942715464 true value
# fderiv(F, x0)                         #   1.141882942704476
# numDeriv::grad(F, x0)                 #   1.141882942705797

# Compare over a whole period
x <- seq(0, 2*pi, length.out = 11)
max(abs(numdiff(sin, x) - cos(x)))          #=> 3.44e-15
# max(abs(numDeriv::grad(sin, x) - cos(x))) #   7.70e-12

# Example from complex step
f <- function(x) exp(x) / sqrt(sin(x)^3 + cos(x)^3)
x0 <- 1.5
numderiv(f, x0)                          #   4.05342789389876, error 0.5e-12
                                         #   4.053427893898621... true value
}
\keyword{ math }

\name{quadinf}
\alias{quadinf}
\title{
Infinite Integrals
}
\description{
  Iterative quadrature of functions over finite, semifinite, or
  infinite intervals.
}
\usage{
quadinf(f, xa, xb, tol = 1e-12, ...)
}
\arguments{
  \item{f}{univariate function; needs not be vectorized.}
  \item{xa}{lower limit of integration; can be infinite}
  \item{xb}{upper limit of integration; can be infinite}
  \item{tol}{accuracy requested.}
  \item{\dots}{additional arguments to be passed to \code{f}.}
}
\details{
  \code{quadinf} implements the `double exponential method' for fast 
  numerical integration of smooth real functions on finite intervals.
  For infinite intervals, the tanh-sinh quadrature scheme is applied,
  that is the transformation \code{g(t)=tanh(pi/2*sinh(t))}.

  Please note that this algorithm does work very accurately for
  `normal' function, but should not be applied to (heavily)
  oscillating functions. The maximal number of iterations is 7, so
  if this is returned the iteration may not have converged.

  The integrand function needs \emph{not} be vectorized.
}
\value{
  A list with components \code{Q} the integral value, \code{relerr}
  the relative error, and \code{niter} the number of iterations.
}
\note{
  See also my remarks on R-help in September 2010 in the thread
  ``bivariate vector numerical integration with infinite range''.
}
\references{
  D. H. Bayley. Tanh-Sinh High-precision Quadrature. 2006.\cr
  URL: https://www.davidhbailey.com//dhbpapers/dhb-tanh-sinh.pdf
}
\seealso{
  \code{\link{integrate}}, \code{\link{quadgk}}
}
\examples{
##  We will look at the error function exp(-x^2)
f <- function(x) exp(-x^2)          # sqrt(pi)/2         theory
quadinf(f, 0, Inf)                  # 0.8862269254527413
quadinf(f, -Inf, 0)                 # 0.8862269254527413

f = function(x) sqrt(x) * exp(-x)   # 0.8862269254527579 exact
quadinf(f, 0, Inf)                  # 0.8862269254527579

f = function(x) x * exp(-x^2)       # 1/2
quadinf(f, 0, Inf)                  # 0.5

f = function(x) 1 / (1+x^2)         # 3.141592653589793 = pi
quadinf(f, -Inf, Inf)               # 3.141592653589784
}
\keyword{ math }

\name{fornberg}
\alias{fornberg}
\title{
  Fornberg's Finite Difference Approximation
}
\description{
  Finite difference approximation using Fornberg's method for the derivatives
  of order 1 to k based on irregulat grid values.
}
\usage{
fornberg(x, y, xs, k = 1)
}
\arguments{
  \item{x}{grid points on the x-axis, must be distinct.}
  \item{y}{discrete values of the function at the grid points.}
  \item{xs}{point at which to approximate (not vectorized).}
  \item{k}{order of derivative, \code{k<=length(x)-1} required.}
}
\details{
  Compute coefficients for finite difference approximation for the derivative
  of order \code{k} at \code{xs} based on grid values at points in \code{x}.
  For \code{k=0} this will evaluate the interpolating polynomial itself, but
  call it with \code{k=1}.
}
\value{
  Returns a matrix of size \code{(length(xs))}, where the (k+1)-th column
  gives the value of the k-th derivative. Especially the first column returns 
  the polynomial interpolation of the function.
}
\note{
  Fornberg's method is considered to be numerically more stable than applying
  Vandermonde's matrix.
}
\references{
  LeVeque, R. J. (2007). Finite Difference Methods for Ordinary and Partial
  Differential Equations. Society for Industrial and Applied Mathematics 
  (SIAM), Philadelphia.
}
\seealso{
  \code{\link{neville}}, \code{\link{newtonInterp}}
}
\examples{
x <- 2 * pi * c(0.0, 0.07, 0.13, 0.2, 0.28, 0.34, 0.47, 0.5, 0.71, 0.95, 1.0)
y <- sin(0.9*x)
xs <- linspace(0, 2*pi, 51)
fornb <- fornberg(x, y, xs, 10)
\dontrun{
matplot(xs, fornb, type="l")
grid()}
}
\keyword{ fitting }

\name{sorting}
\alias{bubbleSort}
\alias{insertionSort}
\alias{selectionSort}
\alias{shellSort}
\alias{heapSort}
\alias{mergeSort}
\alias{mergeOrdered}
\alias{quickSort}
\alias{quickSortx}
\alias{is.sorted}
\alias{testSort}
\title{Sorting Routines}
\description{
  R implementations of several sorting routines. These implementations are
  meant for demonstration and lecturing purposes.
}
\usage{
is.sorted(a)
testSort(n = 1000)

bubbleSort(a)
insertionSort(a)
selectionSort(a)
shellSort(a, f = 2.3)
heapSort(a)
mergeSort(a, m = 10)
mergeOrdered(a, b)
quickSort(a, m = 3)
quickSortx(a, m = 25)
}
\arguments{
  \item{a, b}{Numeric vectors to be sorted or merged.}
  \item{f}{Retracting factor for \code{shellSort}.}
  \item{m}{Size of subsets that are sorted by \code{insertionSort} when the
           sorting procedure is called recursively.}
  \item{n}{Only in \code{testSort}: the length of a vector of random numbers
           to be sorted.}
}
\details{
  \code{bubbleSort(a)} is the well-known ``bubble sort'' routine; it is
  forbiddingly slow.

  \code{insertionSort(a)} sorts the array one entry at a time; it is slow,
  but quite efficient for small data sets.

  \code{selectionSort(a)} is an in-place sorting routine that is inefficient,
  but noted for its simplicity.

  \code{shellSort(a, f = 2.3)} exploits the fact that insertion sort works
  efficiently on input that is already almost sorted. It reduces the gaps
  by the factor \code{f}; \code{f=2.3} is said to be a reasonable choice.

  \code{heapSort(a)} is not yet implemented.

  \code{mergeSort(a, m = 10)} works recursively, merging already sorted parts
  with \code{mergeOrdered}. \code{m} should be between\code{3} and 1/1000 of
  the size of \code{a}.

  \code{mergeOrdered(a, b)} works only correctly if \code{a} and \code{a}
  are already sorted.

  \code{quickSort(a, m = 3)} realizes the celebrated ``quicksort algorithm''
  and is the fastest of all implementations here. To avoid too deeply nested
  recursion with R, \code{insertionSort} is called when the size of a subset
  is smaller than \code{m}.
  
  Values between \code{3..30} seem reasonable and smaller values are better,
  with the risk of running into a too deeply nested recursion.

  \code{quickSort(a, m = 25)} is an extended version where the split is
  calculated more carefully, but in general this approach takes too much
  time.

  Values for \code{m} are \code{20..40} with \code{m=25} favoured.

  \code{testSort(n = 1000)} is a test routine, e.g. for testing your
  computer power. On an iMac, \code{quickSort} will sort an array of
  size 1,000,000 in less than 15 secs.
}
\value{
  All routines return the vector sorted.

  \code{is.sorted} indicates logically whether the vector is sorted.
}
\references{
  Knuth, D. E. (1973). The Art of Computer Programming, Volume 3: Sorting
  and Searching, Chapter 5: Sorting. Addison-Wesley Publishing Company.
}
\author{
  HwB <hwborchers@googlemail.com>
}
\note{
  At the moment, only increasingly sorting is possible
  (if needed apply \code{rev} afterwards).
}
\seealso{
\code{\link{sort}}, the internal C-based sorting routine.
}
\examples{
\dontrun{
testSort(100)

a <- sort(runif(1000)); b <- sort(runif(1000))
system.time(y <- mergeSort(c(a, b)))
system.time(y <- mergeOrdered(a, b))
is.sorted(y)}
}
\keyword{ array }

\name{Diag}
\alias{Diag}
\title{Matrix Diagonal}
\description{
Generate diagonal matrices or return diagonal of a matrix
}
\usage{
Diag(x, k = 0)
}
\arguments{
  \item{x}{vector or matrix}
  \item{k}{integer indicating a secondary diagonal}
}
\details{
If \code{x} is a vector, \code{Diag(x, k)} generates a matrix with \code{x}
as the (k-th secondary) diagonal.

If \code{x} is a matrix, \code{Diag(x, k)} returns the (\code{k}-th secondary) diagonal of \code{x}.

The \code{k}-th secondary diagonal is above the main diagonal for \code{k > 0}
and below the main diagonal for \code{k < 0}.
}
\value{
matrix or vector
}
\note{
In Matlab/Octave this function is called \code{diag()} and has a different
signature than the corresponding function in \R.
}
\seealso{
\code{\link{diag}}, \code{\link{Trace}}
}
\examples{
Diag(matrix(1:12,3,4),  1)
Diag(matrix(1:12,3,4), -1)

Diag(c(1,5,9), 1)
Diag(c(1,5,9), -1)
}
\keyword{ array }

\name{pade}
\alias{pade}
\title{
  Pade Approximation
}
\description{
  A Pade approximation is a rational function (of a specified order) whose
  power series expansion agrees with a given function and its derivatives
  to the highest possible order.
}
\usage{
pade(p1, p2 = c(1), d1 = 5, d2 = 5)
}
\arguments{
  \item{p1}{polynomial representing or approximating the function,
            preferably the Taylor series of the function around some point.}
  \item{p2}{if present, the function is given as \code{p1/p2}.}
  \item{d1}{the degree of the numerator of the rational function.}
  \item{d2}{the degree of the denominator of the rational function.}
}
\details{
  The relationship between the coefficients of \code{p1} (and \code{p2})
  and \code{r1} and \code{r2} is determined by a system of linear equations.
  The system is then solved by applying the pseudo-inverse \code{pinv} for
  for the left-hand matrix.
}
\value{
  List with components \code{r1} and \code{r2} for the numerator and 
  denominator polynomials, i.e. \code{r1/r2} is the rational approximation
  sought.
}
\note{
  In general, errors for Pade approximations are smallest when the degrees
  of numerator and denominator are the same or when the degree of the
  numerator is one larger than that of the denominator.
}
\references{
  Press, W. H., S. A. Teukolsky, W. T Vetterling, and B. P. Flannery (2007).
  Numerical Recipes: The Art of Numerical Computing. Third Edition,
  Cambridge University Press, New York.
}
\seealso{
  \code{\link{taylor}}, \code{ratInterp}
}
\examples{
##  Exponential function
p1 <- c(1/24, 1/6, 1/2, 1.0, 1.0)  # Taylor series of exp(x) at x=0
R  <- pade(p1); r1 <- R$r1; r2 <- R$r2
f1 <- function(x) polyval(r1, x) / polyval(r2, x)
\dontrun{
xs <- seq(-1, 1, length.out=51); ys1 <- exp(xs); ys2 <- f1(xs)
plot(xs, ys1, type = "l", col="blue")
lines(xs, ys2, col = "red")
grid()}
}
\keyword{ math }

\name{savgol}
\alias{savgol}
\title{
Savitzky-Golay Smoothing
}
\description{
  Polynomial filtering method of Savitzky and Golay.
}
\usage{
savgol(T, fl, forder = 4, dorder = 0)
}
\arguments{
  \item{T}{Vector of signals to be filtered.}
  \item{fl}{Filter length (for instance fl = 51..151), has to be odd.}
  \item{forder}{Filter order (2 = quadratic filter, 4 = quartic).}
  \item{dorder}{Derivative order (0 = smoothing, 1 = first derivative, etc.).}
}
\details{
  Savitzky-Golay smoothing performs a local polynomial regression on a
  series of values which are treated as being equally spaced to determine
  the smoothed value for each point.
  Methods are also provided for calculating derivatives.
}
\value{
  Vector representing the smoothed time series.
}
\references{
  See Numerical Recipes, 1992, Chapter 14.8, for details.
}
\author{
  Peter Riegler implemented a Matlab version in 2001. Based on this,
  Hans W. Borchers published an R version in 2003.
}
\note{
  For derivatives T2 has to be divided by the step size to the order\cr
  (and to be multiplied by k! --- the sign appears to be wrong).
}
\seealso{
\code{RTisean::sav_gol}, \code{signal::sgolayfilt}, \code{\link{whittaker}}.
}
\examples{
# *** Sinosoid test function ***
ts <- sin(2*pi*(1:1000)/200)
t1 <- ts + rnorm(1000)/10
t2 <- savgol(t1, 51)
\dontrun{
plot( 1:1000, t1, col = "grey")
lines(1:1000, ts, col = "blue")
lines(1:1000, t2, col = "red")}
}
\keyword{ timeseries }

\name{kron}
\alias{kron}
\title{Kronecker product (Matlab Style)}
\description{
Kronecker tensor product of two matrices.
}
\usage{
kron(a, b)
}
\arguments{
  \item{a}{real or complex matrix}
  \item{b}{real or complex matrix}
}
\details{
The Kronecker product is a large matrix formed by all products between the
elements of \code{a} and those of \code{b}. The first left block is a11*b,
etc.
}
\value{
an \code{(n*p x m*q}-matrix, if \code{a} is \code{(n x m} and
\code{b} is \code{(p x q)}.
}
\note{
\code{kron()} is an alias for the R function \code{kronecker()}, which can
also be executed with the binary operator `\%x\%'.
}
\examples{
a <- diag(1, 2, 2)
b <- matrix(1:4, 2, 2)
kron(a, b)
kron(b, a)
}
\keyword{ array }

\name{laguerre}
\alias{laguerre}
\title{
  Laguerre's Method
}
\description{
  Laguerre's method for finding roots of complex polynomials.
}
\usage{
laguerre(p, x0, nmax = 25, tol = .Machine$double.eps^(1/2))
}
\arguments{
  \item{p}{real or complex vector representing a polynomial.}
  \item{x0}{real or complex point near the root.}
  \item{nmax}{maximum number of iterations.}
  \item{tol}{absolute tolerance.}
}
\details{
  Uses values of the polynomial and its first and second derivative.
}
\value{
  The root found, or a warning about the number of iterations.
}
\references{
  Fausett, L. V. (2007). Applied Numerical Analysis Using Matlab.
  Second edition, Prentice Hall.
}
\note{
  Computations are caried out in complex arithmetic, and it is possible
  to obtain a complex root even if the starting estimate is real.
}
\seealso{
  \code{\link{roots}}
}
\examples{
# 1 x^5 - 5.4 x^4 + 14.45 x^3 - 32.292 x^2 + 47.25 x - 26.46
p <- c(1.0, -5.4, 14.45, -32.292, 47.25, -26.46)
laguerre(p, 1)   #=> 1.2
laguerre(p, 2)   #=> 2.099987     (should be 2.1)
laguerre(p, 2i)  #=> 0+2.236068i  (+- 2.2361i, i.e sqrt(-5))
}
\keyword{ math }

\name{nelder_mead}
\alias{nelder_mead}
\title{
  Nelder-Mead Function Minimization Method
}
\description{
  An implementation of the Nelder-Mead algorithm for derivative-free
  optimization / function minimization.
}
\usage{
nelder_mead(fn, x0, ..., adapt = TRUE,
            tol = 1e-08, maxfeval = 5000, 
			step = rep(1.0, length(x0)))
}
\arguments{
  \item{fn}{nonlinear function to be minimized.}
  \item{x0}{starting point for the iteration.}
  \item{...}{additional arguments to be passed to the function.}
  \item{adapt}{logical; adapt to parameter dimension.}
  \item{tol}{terminating limit for the variance of function values;
             can be made *very* small, like \code{tol=1e-50}.}
  \item{maxfeval}{maximum number of function evaluations.}
  \item{step}{size and shape of initial simplex; relative magnitudes of
              its elements should reflect the units of the variables.}
}
\details{
  Also called a `simplex' method for finding the local minimum of a function
  of several variables. The method is a pattern search that compares function
  values at the vertices of the simplex. The process generates a sequence of
  simplices with ever reducing sizes.

  The simplex function minimisation procedure due to Nelder and Mead (1965),
  as implemented by O'Neill (1971), with subsequent comments by Chambers and 
  Ertel 1974, Benyon 1976, and Hill 1978. For another elaborate implementation 
  of Nelder-Mead in R based on Matlab code by Kelley see package `dfoptim'.

  \code{nelder_mead} can be used up to 20 dimensions (then `tol' and `maxfeval'
  need to be increased). With \code{adapt=TRUE} it applies adaptive
  coefficients for the simplicial search, depending on the problem dimension
  -- see Fuchang and Lixing (2012). This approach especially reduces the
  number of function calls.
}
\value{
  List with following components:
    \item{xmin}{minimum solution found.}
    \item{fmin}{value of \code{f} at minimum.}
    \item{fcount}{number of iterations performed.}
    \item{restarts}{number of restarts.}
    \item{errmess}{error message}
}
\references{
  Nelder, J., and R. Mead (1965). A simplex method for function minimization.
  Computer Journal, Volume 7, pp. 308-313.

  O'Neill, R. (1971). Algorithm AS 47: Function Minimization Using a Simplex 
  Procedure. Applied Statistics, Volume 20(3), pp. 338-345.

  J. C. Lagarias et al. (1998). Convergence properties of the Nelder-Mead
  simplex method in low dimensions. SIAM Journal for Optimization, Vol. 9,
  No. 1, pp 112-147.

  Fuchang Gao and Lixing Han (2012). Implementing the Nelder-Mead simplex
  algorithm with adaptive parameters. Computational Optimization and
  Applications, Vol. 51, No. 1, pp. 259-277.
}
\note{
  Original FORTRAN77 version by R O'Neill; MATLAB version by John Burkardt
  under LGPL license. Re-implemented in R by Hans W. Borchers.
}
\seealso{
  \code{\link{hooke_jeeves}}
}
\examples{
##  Classical tests as in the article by Nelder and Mead
# Rosenbrock's parabolic valley
rpv <- function(x) 100*(x[2] - x[1]^2)^2 + (1 - x[1])^2
x0 <- c(-2, 1)
nelder_mead(rpv, x0)                     #  1 1

# Fletcher and Powell's helic valley
fphv <- function(x)
    100*(x[3] - 10*atan2(x[2], x[1])/(2*pi))^2 + 
        (sqrt(x[1]^2 + x[2]^2) - 1)^2 +x[3]^2
x0 <- c(-1, 0, 0)
nelder_mead(fphv, x0)                    #  1 0 0

# Powell's Singular Function (PSF)
psf <- function(x)  (x[1] + 10*x[2])^2 + 5*(x[3] - x[4])^2 + 
                    (x[2] - 2*x[3])^4 + 10*(x[1] - x[4])^4
x0 <- c(3, -1, 0, 1)
# needs maximum number of function calls
nelder_mead(psf, x0, maxfeval=30000)         #  0 0 0 0

\dontrun{
# Can run Rosenbrock's function in 30 dimensions in one and a half minutes:
nelder_mead(fnRosenbrock, rep(0, 30), tol=1e-20, maxfeval=10^7)
# $xmin
#  [1]  0.9999998 1.0000004 1.0000000 1.0000001 1.0000000 1.0000001
#  [7]  1.0000002 1.0000001 0.9999997 0.9999999 0.9999997 1.0000000
# [13]  0.9999999 0.9999994 0.9999998 0.9999999 0.9999999 0.9999999
# [19]  0.9999999 1.0000001 0.9999998 1.0000000 1.0000003 0.9999999
# [25]  1.0000000 0.9999996 0.9999995 0.9999990 0.9999973 0.9999947
# $fmin
# [1] 5.617352e-10
# $fcount
# [1] 1426085
# elapsed time is 96.008000 seconds }
}
\keyword{ optimize }

\name{approx_entropy}
\alias{approx_entropy}
\alias{sample_entropy}
\title{
  Approximate and Sample Entropy
}
\description{
  Calculates the approximate or sample entropy of a time series.
}
\usage{
approx_entropy(ts, edim = 2, r = 0.2*sd(ts), elag = 1)

sample_entropy(ts, edim = 2, r = 0.2*sd(ts), tau = 1)
}
\arguments{
  \item{ts}{a time series.}
  \item{edim}{the embedding dimension, as for chaotic time series;
              a preferred value is 2.}
  \item{r}{filter factor; work on heart rate variability has suggested
           setting r to be 0.2 times the standard deviation of the data.}
  \item{elag}{embedding lag; defaults to 1, more appropriately it should be
              set to the smallest lag at which the autocorrelation function
              of the time series is close to zero.
              (At the moment it cannot be changed by the user.)}
  \item{tau}{delay time for subsampling, similar to \code{elag}.}
}
\details{
  Approximate entropy was introduced to quantify the the amount of
  regularity and the unpredictability of fluctuations in a time series.
  A low value of the entropy indicates that the time series is deterministic;
  a high value indicates randomness.

  Sample entropy is conceptually similar with the following differences:
  It does not count self-matching, and it does not depend that much on the
  length of the time series.
}
\value{
  The approximate, or sample, entropy, a scalar value.
}
\note{
  This code here derives from Matlab versions at Mathwork's File Exchange,
  ``Fast Approximate Entropy'' and ``Sample Entropy'' by Kijoon Lee under
  BSD license.
}
\references{
  Pincus, S.M. (1991). Approximate entropy as a measure of system complexity.
  Proc. Natl. Acad. Sci. USA, Vol. 88, pp. 2297--2301.

  Kaplan, D., M. I. Furman, S. M. Pincus, S. M. Ryan, L. A. Lipsitz, and
  A. L. Goldberger (1991). Aging and the complexity of cardiovascular
  dynamics, Biophysics Journal, Vol. 59, pp. 945--949.

  Yentes, J.M., N. Hunt, K.K. Schmid, J.P. Kaipust, D. McGrath, N. Stergiou
  (2012). The Appropriate use of approximate entropy and sample entropy with
  short data sets. Ann. Biomed. Eng.
}
\seealso{
  \code{RHRV::CalculateApEn}
}
\examples{
ts <- rep(61:65, 10)
approx_entropy(ts, edim = 2)                      # -0.0004610253
sample_entropy(ts, edim = 2)                      #  0

set.seed(8237)
approx_entropy(rnorm(500), edim = 2)              # 1.351439  high, random
approx_entropy(sin(seq(1,100,by=0.2)), edim = 2)  # 0.171806  low,  deterministic
sample_entropy(sin(seq(1,100,by=0.2)), edim = 2)  # 0.2359326

\dontrun{(Careful: This will take several minutes.)
# generate simulated data
N <- 1000; t <- 0.001*(1:N)
sint   <- sin(2*pi*10*t);    sd1 <- sd(sint)    # sine curve
whitet <- rnorm(N);          sd2 <- sd(whitet)  # white noise
chirpt <- sint + 0.1*whitet; sd3 <- sd(chirpt)  # chirp signal

# calculate approximate entropy
rnum <- 30; result <- zeros(3, rnum)
for (i in 1:rnum) {
    r <- 0.02 * i
    result[1, i] <- approx_entropy(sint,   2, r*sd1)
    result[2, i] <- approx_entropy(chirpt, 2, r*sd2)
    result[3, i] <- approx_entropy(whitet, 2, r*sd3)
}

# plot curves
r <- 0.02 * (1:rnum)
plot(c(0, 0.6), c(0, 2), type="n",
     xlab = "", ylab = "", main = "Approximate Entropy")
points(r, result[1, ], col="red");    lines(r, result[1, ], col="red")
points(r, result[2, ], col="green");  lines(r, result[2, ], col="green")
points(r, result[3, ], col="blue");   lines(r, result[3, ], col="blue")
grid()}
}
\keyword{ timeseries }

\name{rot90}
\alias{rot90}
\title{Matrix Rotation}
\description{
Rotate matrices for 90, 180, or 270 degrees..
}
\usage{
rot90(a, k = 1)
}
\arguments{
  \item{a}{numeric or complex matrix}
  \item{k}{scalar integer number of times the matrix will be rotated for
  90 degrees; may be negative.}
}
\details{
  Rotates a numeric or complex matrix for 90 (k = 1), 180 (k = 2) or
  270 (k = 3 or k = -1) degrees.

  Value of k is taken mod 4.
}
\value{
the original matrix rotated
}
\examples{
a <- matrix(1:12, nrow=3, ncol=4, byrow=TRUE)
rot90(a)
rot90(a, 2)
rot90(a, -1)
}
\keyword{ manip }

\name{polyfit,polyfix}
\alias{polyfit}
\alias{polyfix}
\title{Fitting by Polynomial}
\description{
  Polynomial curve fitting
}
\usage{
polyfit(x, y, n)

polyfix(x, y, n, xfix, yfix)
}
 \arguments{
  \item{x}{x-coordinates of points}
  \item{y}{y-coordinates of points}
  \item{n}{degree of the fitting polynomial}
  \item{xfix,yfix}{x- and y-coordinates of points to be fixed}
}
\details{
  \code{polyfit} finds the coefficients of a polynomial of degree \code{n}
  fitting the points given by their \code{x}, \code{y} coordinates in a
  least-squares sense. In \code{polyfit}, if \code{x}, \code{y} are matrices
  of the same size, the coordinates are taken elementwise. Complex values are 
  not allowed.

  \code{polyfix} finds a polynomial that fits the data in a least-squares
  sense, but also passes exactly through all the points with coordinates
  \code{xfix} and \code{yfix}. Degree \code{n} should be greater or equal
  to the number of fixed points, but not too big to avoid `singular matrix'
  or similar error messages
}
\value{
  vector representing a polynomial.
}
\note{
  Please not that \code{polyfit2} is has been removed since 1.9.3; please use
  \code{polyfix} instead.
}
\seealso{
  \code{\link{poly}}, \code{\link{polyval}}
}
\examples{
  # Fitting the sine function by a polynomial
  x <- seq(0, pi, length.out=25)
  y <- sin(x)
  p <- polyfit(x, y, 6)
  
\dontrun{
  # Plot sin and fitted polynomial
  plot(x, y, type="b")
  yf <- polyval(p, x)
  lines(x, yf, col="red")
  grid()}

\dontrun{
  n <- 3
  N <- 100
  x <- linspace(0, 2*pi, N); y = sin(x) + 0.1*rnorm(N)
  xfix <- c(0, 2*pi); yfix = c(0, 0)

  xs <- linspace(0, 2*pi); ys <- sin(xs)
  plot(xs, ys, type = 'l', col = "gray",
	   main = "Polynom Approximation of Degree 3")
  grid()
  points(x, y, pch='o', cex=0.5)
  points(xfix, yfix, col = "darkred")

  p0 <- polyfit(x, y, n)
  lines(xs, polyval(p0, xs), col = "blue")

  p1 <- polyfix(x, y, n, xfix, yfix)
  lines(xs, polyval(p1, xs), col = "red")

  legend(4, 1, c("sin", "polyfit", "polyfix"),
         col=c("gray", "blue", "red"), lty=c(1,1,1))}
}
\keyword{ math }

\name{arclength}
\alias{arclength}
\title{
  Arc Length of a Curve
}
\description{
  Calculates the arc length of a parametrized curve.
}
\usage{
arclength(f, a, b, nmax = 20, tol = 1e-05, ...)
}
\arguments{
  \item{f}{parametrization of a curve in n-dim. space.}
  \item{a,b}{begin and end of the parameter interval.}
  \item{nmax}{maximal number of iterations.}
  \item{tol}{relative tolerance requested.}
  \item{...}{additional arguments to be passed to the function.}
}
\details{
  Calculates the arc length of a parametrized curve in \code{R^n}. It applies
  Richardson's extrapolation by refining polygon approximations to the curve.

  The parametrization of the curve must be vectorized:
  if \code{t-->F(t)} is the parametrization, \code{F(c(t1,t1,...))} must
  return \code{c(F(t1),F(t2),...)}.

  Can be directly applied to determine the arc length of a one-dimensional 
  function \code{f:R-->R} by defining \code{F} (if \code{f} is vectorized)
  as \code{F:t-->c(t,f(t))}.
}
\value{
  Returns a list with components \code{length} the calculated arc length,
  \code{niter} the number of iterations, and \code{rel.err} the relative
  error generated from the extrapolation.
}
\author{
  HwB <hwborchers@googlemail.com>
}
\note{
  If by chance certain equidistant points of the curve lie on a straight line,
  the result may be wrong, then use \code{polylength} below.
}
\seealso{
  \code{\link{poly_length}}
}
\examples{
##  Example: parametrized 3D-curve with t in 0..3*pi
f <- function(t) c(sin(2*t), cos(t), t)
arclength(f, 0, 3*pi)
# $length:  17.22203            # true length 17.222032...

##  Example: length of the sine curve
f <- function(t) c(t, sin(t))
arclength(f, 0, pi)             # true length  3.82019...

## Example: Length of an ellipse with axes a = 1 and b = 0.5
# parametrization x = a*cos(t), y = b*sin(t)
a <- 1.0; b <- 0.5
f <- function(t) c(a*cos(t), b*sin(t))
L <- arclength(f, 0, 2*pi, tol = 1e-10)     #=> 4.84422411027
# compare with elliptic integral of the second kind
e <- sqrt(1 - b^2/a^2)                      # ellipticity
L <- 4 * a * ellipke(e^2)$e                 #=> 4.84422411027

\dontrun{
##  Example: oscillating 1-dimensional function (from 0 to 5)
f <- function(x) x * cos(0.1*exp(x)) * sin(0.1*pi*exp(x))
F <- function(t) c(t, f(t))
L <- arclength(F, 0, 5, tol = 1e-12, nmax = 25)
print(L$length, digits = 16)
# [1] 82.81020372882217         # true length 82.810203728822172...

# Split this computation in 10 steps (run time drops from 2 to 0.2 secs)
L <- 0
for (i in 1:10)
	L <- L + arclength(F, (i-1)*0.5, i*0.5, tol = 1e-10)$length
print(L, digits = 16)
# [1] 82.81020372882216

# Alternative calculation of arc length
f1 <- function(x) sqrt(1 + complexstep(f, x)^2)
L1 <- quadgk(f1, 0, 5, tol = 1e-14)
print(L1, digits = 16)
# [1] 82.81020372882216
  }

\dontrun{
#-- --------------------------------------------------------------------
#   Arc-length parametrization of Fermat's spiral
#-- --------------------------------------------------------------------
# Fermat's spiral: r = a * sqrt(t) 
f <- function(t) 0.25 * sqrt(t) * c(cos(t), sin(t))

t1 <- 0; t2 <- 6*pi
a  <- 0; b  <- arclength(f, t1, t2)$length
fParam <- function(w) {
    fct <- function(u) arclength(f, a, u)$length - w
    urt <- uniroot(fct, c(a, 6*pi))
    urt$root
}

ts <- linspace(0, 6*pi, 250)
plot(matrix(f(ts), ncol=2), type='l', col="blue", 
     asp=1, xlab="", ylab = "",
     main = "Fermat's Spiral", sub="20 subparts of equal length")

for (i in seq(0.05, 0.95, by=0.05)) {
    v <- fParam(i*b); fv <- f(v)
    points(fv[1], f(v)[2], col="darkred", pch=20)
} }
}
\keyword{ math }

\name{zeta}
\alias{zeta}
\title{
  Riemann Zeta Function
}
\description{
  Riemann's zeta function valid in the entire complex plane.
}
\usage{
zeta(z)
}
\arguments{
  \item{z}{Real or complex number or a numeric or complex vector.}
}
\details{
  Computes the zeta function for complex arguments using a series expansion
  for Dirichlet's eta function.

  Accuracy is about 7 significant digits for \code{abs(z)<50},
  drops off with higher absolute values.
}
\value{
  Returns a complex vector of function values.
}
\references{
  Zhang, Sh., and J. Jin (1996). Computation of Special Functions.
  Wiley-Interscience, New York.
}
\note{
  Copyright (c) 2001 Paul Godfrey for a Matlab version available on
  Mathwork's Matlab Central under BSD license.
}
\seealso{
  \code{\link{gammaz}}, \code{\link{eta}}
}
\examples{
##  First zero on the critical line s = 0.5 + i t
\dontrun{
x <- seq(0, 20, len=1001)
z <- 0.5 + x*1i
fr <- Re(zeta(z))
fi <- Im(zeta(z))
fa <- abs(zeta(z))
plot(x, fa, type="n", xlim = c(0, 20), ylim = c(-1.5, 2.5),
     xlab = "Imaginary part (on critical line)", ylab = "Function value",
     main = "Riemann's Zeta Function along the critical line")
lines(x, fr, col="blue")
lines(x, fi, col="darkgreen")
lines(x, fa, col = "red", lwd = 2)
points(14.1347, 0, col = "darkred")
legend(0, 2.4, c("real part", "imaginary part", "absolute value"),
       lty = 1, lwd = c(1, 1, 2), col = c("blue", "darkgreen", "red"))
grid()}
}
\keyword{ specfun }

\name{bisect}
\alias{bisect}
\alias{secant}
\alias{regulaFalsi}
\title{
Rootfinding Through Bisection or Secant Rule
}
\description{
Finding roots of univariate functions in bounded intervals.
}
\usage{
bisect(fun, a, b, maxiter = 500, tol = NA, ...)

secant(fun, a, b, maxiter = 500, tol = 1e-08, ...)

regulaFalsi(fun, a, b, maxiter = 500, tol = 1e-08, ...)
}
\arguments{
  \item{fun}{Function or its name as a string.}
  \item{a, b}{interval end points.}
  \item{maxiter}{maximum number of iterations; default 100.}
  \item{tol}{absolute tolerance; default \code{eps^(1/2)}}
  \item{...}{additional arguments passed to the function.}
}
\details{
  ``Bisection'' is a well known root finding algorithms for real, univariate, 
  continuous functions. Bisection works in any case if the function has
  opposite signs at the endpoints of the interval.

  \code{bisect} stops when floating point precision is reached, attaching
  a tolerance is no longer needed. This version is trimmed for exactness, 
  not speed. Special care is taken when 0.0 is a root of the function.
  Argument 'tol' is deprecated and not used anymore.

  The ``Secant rule'' uses a succession of roots of secant lines to better 
  approximate a root of a function. ``Regula falsi'' combines bisection and 
  secant methods. The so-called `Illinois' improvement is used here.
}
\value{
  Return a list with components \code{root}, \code{f.root}, 
  the function value at the found root, \code{iter}, the number of iterations
  done, and \code{root}, and the estimated accuracy \code{estim.prec}
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\seealso{
\code{\link{ridders}}
}
\examples{
bisect(sin, 3.0, 4.0)
# $root             $f.root             $iter   $estim.prec
# 3.1415926536      1.2246467991e-16    52      4.4408920985e-16

bisect(sin, -1.0, 1.0)
# $root             $f.root             $iter   $estim.prec
# 0                 0                   2       0

# Legendre polynomial of degree 5
lp5 <- c(63, 0, -70, 0, 15, 0)/8
f <- function(x) polyval(lp5, x)
bisect(f, 0.6, 1)       # 0.9061798453      correct to 15 decimals
secant(f, 0.6, 1)       # 0.5384693         different root
regulaFalsi(f, 0.6, 1)  # 0.9061798459      correct to 10 decimals
}
\keyword{ math }

\name{steep_descent}
\alias{steep_descent}
\title{
  Steepest Descent Minimization
}
\description{
  Function minimization by steepest descent.
}
\usage{
steep_descent(x0, f, g = NULL, info = FALSE,
              maxiter = 100, tol = .Machine$double.eps^(1/2))
}
\arguments{
  \item{x0}{start value.}
  \item{f}{function to be minimized.}
  \item{g}{gradient function of \code{f};
           if \code{NULL}, a numerical gradient will be calculated.}
  \item{info}{logical; shall information be printed on every iteration?}
  \item{maxiter}{max. number of iterations.}
  \item{tol}{relative tolerance, to be used as stopping rule.}
}
\details{
  Steepest descent is a line search method that moves along the downhill
  direction.
}
\value{
  List with following components:
    \item{xmin}{minimum solution found.}
    \item{fmin}{value of \code{f} at minimum.}
    \item{niter}{number of iterations performed.}
}
\references{
  Nocedal, J., and S. J. Wright (2006). Numerical Optimization.
  Second Edition, Springer-Verlag, New York, pp. 22 ff.
}
\note{
  Used some Matlab code as described in the book ``Applied Numerical Analysis
  Using Matlab'' by L. V.Fausett.
}
\seealso{
  \code{\link{fletcher_powell}}
}
\examples{
##  Rosenbrock function: The flat valley of the Rosenbruck function makes
##  it infeasible for a steepest descent approach.
# rosenbrock <- function(x) {
#     n <- length(x)
#     x1 <- x[2:n]
#     x2 <- x[1:(n-1)]
#     sum(100*(x1-x2^2)^2 + (1-x2)^2)
# }
# steep_descent(c(1, 1), rosenbrock)
# Warning message:
# In steep_descent(c(0, 0), rosenbrock) :
#   Maximum number of iterations reached -- not converged.

## Sphere function
sph <- function(x) sum(x^2)
steep_descent(rep(1, 10), sph)
# $xmin   0 0 0 0 0 0 0 0 0 0
# $fmin   0
# $niter  2
}
\keyword{ optimize }

\name{peaks}
\alias{peaks}
\title{
  Peaks Function (Matlab Style)
}
\description{
  An example functions in two variables, with peaks.
}
\usage{
peaks(v = 49, w)
}
\arguments{
  \item{v}{vector, whose length will be used, or a natural number.}
  \item{w}{another vector, will be used in \code{meshgrid(x,y)}.}
}
\details{
  \code{peaks} is a function of two variables, obtained by translating
  and scaling Gaussian distributions, which is useful for demonstrating
  three-dimensional plots.
}
\value{
  Returns three matrices as a list with \code{X}, \code{Y}, and \code{Z}
  components, the first two being the result of the \code{meshgrid} function,
  and \code{Z} the application of the following function at the points of
  \code{X} and \code{Y}:

  \code{z <-  3 * (1-x)^2 * exp(-(x^2) - (y+1)^2) -
             10 * (x/5 - x^3 - y^5) * exp(-x^2 - y^2) -
            1/3 * exp(-(x+1)^2 - y^2)}
}
\note{
  The variant that \code{peaks()} will display the 3-dim. graph as in Matlab
  is not yet implemented.
}
\seealso{
\code{\link{meshgrid}}
}
\examples{
peaks(3)
\dontrun{
P <- peaks()
x <- P$X[1,]; y <- P$Y[, 1]
persp(x, y, P$Z)
}
}
\keyword{ graphs }

\name{finds}
\alias{finds}
\title{find function (Matlab Style)}
\description{
  Finds indices of nonzero elements.
}
\usage{
finds(v)
}
\arguments{
  \item{v}{logical or numeric vector or array}
}
\details{
  Finds indices of true or nonzero elements of argument \code{v};
  can be used with a logical expression.
}
\value{
  Indices of elements matching the expression \code{x}.
}
\examples{
finds(-3:3 >= 0)
finds(c(0, 1, 0, 2, 3))
}
\keyword{logic}

\name{randperm}
\alias{randperm}
\title{
Random Permutation
}
\description{
Generates a random permutation.
}
\usage{
randperm(a, k)
}
\arguments{
  \item{a}{integer or numeric vector of some length \code{n}.}
  \item{k}{integer, smaller as \code{a} or \code{length(a)}.}
}
\details{
  Generates one random permutation of \code{k} of the elements \code{a}, if
  \code{a} is a vector, or of \code{1:a} if \code{a} is a single integer.
}
\value{
  Vector of permuted elements of \code{a} or \code{1:a}.
}
\note{
  This behavior is different from Matlab/Octave, but does better correspond
  with the behavior of the perms() function.
}
\seealso{
\code{\link{perms}}
}
\examples{
randperm(1:6, 3)
randperm(6, 6)
randperm(11:20, 5)
randperm(seq(2, 10, by=2))
}
\keyword{ arith }

\name{regexprep}
\alias{regexprep}
\title{
  Replace string using regular expression
}
\description{
  Replace string using regular expression.
}
\usage{
regexprep(s, expr, repstr, ignorecase = FALSE, once = FALSE)
}
\arguments{
\item{s}{Single character string.}
\item{expr}{Regular expression to be matched.}
\item{repstr}{String that replaces the matched substring(s).}
\item{ignorecase}{logical, whether to ignore case.}
\item{once}{logical, shall only the first or all occurences be replaced.}
}
\details{
  Matches the regular expression against the string and replaces the first
  or all non-overlapping occurrences with the replacement string.

  The syntax for regular expression has to be PERL-like.
}
\value{
  String with substrings replaced.
}
\note{
  The Matlab/Octave variant allows a character vector. This is not possible
  here as it would make the return value quite complicated.
}
\seealso{
\code{\link{gsub}}
}
\examples{
s <- "bat cat can car COAT court cut ct CAT-scan"
pat <-  'c[aeiou]+t'
regexprep(s, pat, '---')
regexprep(s, pat, '---', once = TRUE)
regexprep(s, pat, '---', ignorecase = TRUE)
}
\keyword{ string }

\name{rat}
\alias{rat}
\alias{rats}
\title{
  Continuous Fractions (Matlab Style)
}
\description{
  Generate continuous fractions for numeric values.
}
\usage{
rat(x, tol = 1e-06)
rats(x, tol = 1e-06)
}
\arguments{
  \item{x}{a numeric scalar or vector.}
  \item{tol}{tolerance; default \code{1e-6} to make a nicer appearance for
             \code{pi}.}
}
\details{
  \code{rat} generates continuous fractions, while \code{rats} prints the
  the corresponding rational representation and returns the numeric values.
}
\value{
  \code{rat} returns a character vector of string representations of
  continuous fractions in the format \code{[b0; b1, ..., b_{n-1}]}.

  \code{rats} prints the rational number and returns a numeric vector.
}
\note{
  Essentially, these functions apply \code{contfrac}.
}
\seealso{
\code{numbers::contfrac}
}
\examples{
rat(pi)
rats(pi)
rat(sqrt(c(2, 3, 5)),  tol = 1e-15)
rats(sqrt(c(2, 3, 5)), tol = 1e-15)
}
\keyword{ math }

\name{gaussLegendre}
\alias{gaussLegendre}
\title{
  Gauss-Legendre Quadrature Formula
}
\description{
  Nodes and weights for the n-point Gauss-Legendre quadrature formula.
}
\usage{
gaussLegendre(n, a, b)
}
\arguments{
  \item{n}{Number of nodes in the interval \code{[a,b]}.}
  \item{a, b}{lower and upper limit of the integral; must be finite.}
}
\details{
  \code{x} and \code{w} are obtained from a tridiagonal eigenvalue problem.
}
\value{
  List with components \code{x}, the nodes or points in\code{[a,b]}, and
  \code{w}, the weights applied at these nodes.
}
\references{
  Gautschi, W. (2004). Orthogonal Polynomials: Computation and Approximation.
  Oxford University Press.

  Trefethen, L. N. (2000). Spectral Methods in Matlab. SIAM, Society for
  Industrial and Applied Mathematics.
}
\note{
  Gauss quadrature is not suitable for functions with singularities.
}
\seealso{
\code{\link{gaussHermite}}, \code{\link{gaussLaguerre}}
}
\examples{
##  Quadrature with Gauss-Legendre nodes and weights
f <- function(x) sin(x+cos(10*exp(x))/3)
#\dontrun{ezplot(f, -1, 1, fill = TRUE)}
cc <- gaussLegendre(51, -1, 1)
Q <- sum(cc$w * f(cc$x))  #=> 0.0325036515865218 , true error: < 1e-15

# If f is not vectorized, do an explicit summation:
Q <- 0; x <- cc$x; w <- cc$w
for (i in 1:51) Q <- Q + w[i] * f(x[i])

# If f is infinite at b = 1, set  b <- b - eps  (with, e.g., eps = 1e-15)

# Use Gauss-Kronrod approach for error estimation
cc <- gaussLegendre(103, -1, 1)
abs(Q - sum(cc$w * f(cc$x)))     # rel.error < 1e-10

# Use Gauss-Hermite for vector-valued functions
f <- function(x) c(sin(pi*x), exp(x), log(1+x))
cc <- gaussLegendre(32, 0, 1)
drop(cc$w \%*\% matrix(f(cc$x), ncol = 3))  # c(2/pi, exp(1) - 1, 2*log(2) - 1)
# absolute error < 1e-15
}
\keyword{ math }

\name{procrustes}
\alias{procrustes}
\alias{kabsch}
\title{
  Solving the Procrustes Problem
}
\description{
  \code{procrustes} solves for two matrices \code{A} and \code{B} the 
  `Procrustes Problem' of finding an orthogonal matrix \code{Q} such that
  \code{A-B*Q} has the minimal Frobenius norm.

  \code{kabsch} determines a best rotation of a given vector set into a
  second vector set by minimizing the weighted sum of squared deviations.
  The order of vectors is assumed fixed.
}
\usage{
procrustes(A, B)

kabsch(A, B, w = NULL)
}
\arguments{
  \item{A, B}{two numeric matrices of the same size.}
  \item{w}{weights , influence the distance of points}
}
\details{
  The function \code{procrustes(A,B)} uses the \code{svd} decomposition 
  to find an orthogonal matrix \code{Q} such that \code{A-B*Q} has a 
  minimal Frobenius norm, where this norm for a matrix \code{C} is defined
  as \code{sqrt(Trace(t(C)*C))}, or \code{norm(C,'F')} in R.

  Solving it with \code{B=I} means finding a nearest orthogonal matrix.

  \code{kabsch} solves a similar problem and uses the Procrustes procedure
  for its purpose. Given two sets of points, represented as columns of the
  matrices \code{A} and \code{B}, it determines an orthogonal matrix
  \code{U} and a translation vector \code{R} such that \code{U*A+R-B} 
  is minimal.
}
\value{
  \code{procrustes} returns a list with components \code{P}, which is 
  \code{B*Q}, then \code{Q}, the orthogonal matrix, and \code{d}, the
  Frobenius norm of \code{A-B*Q}.

  \code{kabsch} returns a list with \code{U} the orthogonal matrix applied, 
  \code{R} the translation vector, and \code{d} the least root mean square
  between \code{U*A+R} and \code{B}.
}
\note{
  The \code{kabsch} function does not take into account scaling of the sets,
  but this could easily be integrated.
}
\references{
  Golub, G. H., and Ch. F. van Loan (1996). Matrix Computations. 3rd Edition,
  The John Hopkins University Press, Baltimore London. [Sect. 12.4, p. 601]

  Kabsch, W. (1976). A solution for the best rotation to relate two sets 
  of vectors. Acta Cryst A, Vol. 32, p. 9223.
}
\seealso{
  \code{\link{svd}}
}
\examples{
##  Procrustes
U <- randortho(5)               # random orthogonal matrix
P <- procrustes(U, eye(5))

##  Kabsch
P <- matrix(c(0, 1, 0, 0, 1, 1, 0, 1,
              0, 0, 1, 0, 1, 0, 1, 1,
              0, 0, 0, 1, 0, 1, 1, 1), nrow = 3, ncol = 8, byrow = TRUE)
R <- c(1, 1, 1)
phi <- pi/4
U <- matrix(c(1, 0, 0,
              0, cos(phi), -sin(phi),
              0, sin(phi),  cos(phi)), nrow = 3, ncol = 3, byrow = TRUE)

Q <- U \%*\% P + R
K <- kabsch(P, Q)
# K$R == R  and  K$U %*% P + c(K$R) == Q
}
\keyword{ array }

\encoding{utf8}
\name{circlefit}
\alias{circlefit}
\title{Fitting a Circle}
\description{
  Fitting a circle from points in the plane
}
\usage{
circlefit(xp, yp)
}
\arguments{
  \item{xp, yp}{Vectors representing the x and y coordinates of plane points}
}
\details{
  This routine finds an `algebraic' solution based on a linear fit.
  The value to be minimized is the distance of the given points to
  the nearest point on the circle along a radius.
}
\value{
  Returns x- and y-coordinates of the center and the radius as a vector
  of length 3.

  Writes the RMS error of the (radial) distance of the original points
  to the circle directly onto the console.
}
\references{
  Gander, W., G. H. Golub, and R. Strebel (1994). Fitting of Circles and
  Ellipses --- Least Squares Solutions. ETH Zürich, Technical Report 217,
  Institut für Wissenschaftliches Rechnen.
}
\examples{
# set.seed(8421)
n  <- 20
w  <- 2*pi*runif(n)
xp <- cos(w) + 1 + 0.25 * (runif(n) - 0.5)
yp <- sin(w) + 1 + 0.25 * (runif(n) - 0.5)

circe <- circlefit(xp, yp)  #=> 0.9899628 1.0044920 1.0256633
                            # RMS error: 0.07631986 
\dontrun{
x0 <- circe[1]; y0 <- circe[2]; r0 <- circe[3]
plot(c(-0.2, 2.2), c(-0.2, 2.2), type="n", asp=1)
grid()
abline(h=0, col="gray"); abline(v=0, col="gray")
points(xp, yp, col="darkred")

w  <- seq(0, 2*pi, len=100)
xx <- r0 * cos(w) + x0
yy <- r0 * sin(w) + y0
lines(xx, yy, col="blue")}
}
\keyword{ fitting }

\name{gammaz}
\alias{gammaz}
\title{
  Complex Gamma Function
}
\description{
  Gamma function valid in the entire complex plane.
}
\usage{
gammaz(z)
}
\arguments{
  \item{z}{Real or complex number or a numeric or complex vector.}
}
\details{
  Computes the Gamma function for complex arguments using the Lanczos series
  approximation.

  Accuracy is 15 significant digits along the real axis and 13 significant
  digits elsewhere.

  To compute the logarithmic Gamma function use \code{log(gammaz(z))}.
}
\value{
  Returns a complex vector of function values.
}
\references{
  Zhang, Sh., and J. Jin (1996). Computation of Special Functions.
  Wiley-Interscience, New York.
}
\note{
  Copyright (c) 2001 Paul Godfrey for a Matlab version available on
  Mathwork's Matlab Central under BSD license.

  Numerical Recipes used a 7 terms formula for a less effective approximation.
}
\seealso{
  \code{\link{gamma}}, \code{gsl::lngamma_complex}
}
\examples{
max(gamma(1:10) - gammaz(1:10))
gammaz(-1)
gammaz(c(-2-2i, -1-1i, 0, 1+1i, 2+2i))

# Euler's reflection formula
z <- 1+1i
gammaz(1-z) * gammaz(z)  # == pi/sin(pi*z)
}
\keyword{ specfun }

\name{clenshaw_curtis}
\alias{clenshaw_curtis}
\title{
  Clenshaw-Curtis Quadrature Formula
}
\description{
  Clenshaw-Curtis Quadrature Formula
}
\usage{
clenshaw_curtis(f, a = -1, b = 1, n = 1024, ...)
}
\arguments{
  \item{f}{function, the integrand, without singularities.}
  \item{a, b}{lower and upper limit of the integral; must be finite.}
  \item{n}{Number of Chebyshev nodes to account for.}
  \item{\ldots}{Additional parameters to be passed to the function}
}
\details{
  Clenshaw-Curtis quadrature is based on sampling the integrand on
  Chebyshev points, an operation that can be implemented using the
  Fast Fourier Transform.
}
\value{
  Numerical scalar, the value of the integral.
}
\references{
  Trefethen, L. N. (2008). Is Gauss Quadrature Better Than Clenshaw-Curtis?
  SIAM Review, Vol. 50, No. 1, pp 67--87.
}
\seealso{
\code{\link{gaussLegendre}}, \code{\link{gauss_kronrod}}
}
\examples{
##  Quadrature with Chebyshev nodes and weights
f <- function(x) sin(x+cos(10*exp(x))/3)
\dontrun{ezplot(f, -1, 1, fill = TRUE)}
cc <- clenshaw_curtis(f, n = 64)  #=>  0.0325036517151 , true error > 1.3e-10
}
\keyword{ math }

\name{poly2str}
\alias{poly2str}
\title{
  Print Polynomial
}
\description{
  Print polynomial as a character string.
}
\usage{
poly2str(p, svar = "x", smul = "*", d = options("digits")$digits)
}
\arguments{
  \item{p}{numeric vector representing a polynomial}
  \item{svar}{character representing the unknown, default \code{x}.}
  \item{smul}{multiplication symbol, default \code{*}.}
  \item{d}{significant digits, default \code{options("digits")}.}
}
\details{
  Simple string manipulation.
}
\value{
  Returns the usual string representing a polynomial in mathematics.
}
\examples{
poly2str(c(0))
poly2str(c(1, -1, 1, -1, 1))
poly2str(c(0, 1e-6, 1e6), d = 2)
}
\keyword{ array }

\name{broyden}
\alias{broyden}
\title{Broyden's Method}
\description{
  Broyden's method for the numerical solution of nonlinear systems of
  \code{n} equations in \code{n} variables.
}
\usage{
broyden(Ffun, x0, J0 = NULL, ...,
        maxiter = 100, tol = .Machine$double.eps^(1/2))
}
\arguments{
\item{Ffun}{\code{n} functions of \code{n} variables.}
\item{x0}{Numeric vector of length \code{n}.}
\item{J0}{Jacobian of the function at \code{x0}.}
\item{...}{additional parameters passed to the function.}
\item{maxiter}{Maximum number of iterations.}
\item{tol}{Tolerance, relative accuracy.}
}
\details{
  F as a function must return a vector of length \code{n}, and accept an
  \code{n}-dim. vector or column vector as input. F must not be univariate,
  that is \code{n} must be greater than 1.

  Broyden's method computes the Jacobian and its inverse only at the first
  iteration, and does a rank-one update thereafter, applying the so-called
  Sherman-Morrison formula that computes the inverse of the sum of an
  invertible matrix A and the dyadic product, uv', of a column vector u and
  a row vector v'.
}
\value{
  List with components: \code{zero} the best root found so far, \code{fnorm}
  the square root of sum of squares of the values of f, and \code{niter} the
  number of iterations needed.
}
\references{
  Quarteroni, A., R. Sacco, and F. Saleri (2007). Numerical Mathematics.
  Second Edition, Springer-Verlag, Berlin Heidelberg.
}
\note{
  Applied to a system of \code{n} linear equations it will stop in
  \code{2n} steps
}
\seealso{
  \code{\link{newtonsys}}, \code{\link{fsolve}}
}
\examples{
##  Example from Quarteroni & Saleri
F1 <- function(x) c(x[1]^2 + x[2]^2 - 1, sin(pi*x[1]/2) + x[2]^3)
broyden(F1, x0 = c(1, 1))
# zero: 0.4760958 -0.8793934; fnorm: 9.092626e-09; niter: 13

F <- function(x) {
    x1 <- x[1]; x2 <- x[2]; x3 <- x[3]
    as.matrix(c(x1^2 + x2^2 + x3^2 - 1,
                x1^2 + x3^2 - 0.25,
                x1^2 + x2^2 - 4*x3), ncol = 1)
}
x0 <- as.matrix(c(1, 1, 1))
broyden(F, x0)
# zero: 0.4407629 0.8660254 0.2360680; fnorm: 1.34325e-08; niter: 8

##  Find the roots of the complex function sin(z)^2 + sqrt(z) - log(z)
F2 <- function(x) {
    z  <- x[1] + x[2]*1i
    fz <- sin(z)^2 + sqrt(z) - log(z)
    c(Re(fz), Im(fz))
}
broyden(F2, c(1, 1))
# zero   0.2555197 0.8948303 , i.e.  z0 = 0.2555 + 0.8948i
# fnorm  7.284374e-10
# niter  13

##  Two more problematic examples
F3 <- function(x)
        c(2*x[1] - x[2] - exp(-x[1]), -x[1] + 2*x[2] - exp(-x[2]))
broyden(F3, c(0, 0))
# $zero   0.5671433 0.5671433   # x = exp(-x)

F4 <- function(x)   # Dennis Schnabel
        c(x[1]^2 + x[2]^2 - 2, exp(x[1] - 1) + x[2]^3 - 2)
broyden(F4, c(2.0, 0.5), maxiter = 100)
}
\keyword{ math }

\name{whittaker}
\alias{whittaker}
\title{
  Whittaker Smoothing
}
\description{
  Smoothing of time series using the Whittaker-Henderson approach.
}
\usage{
whittaker(y, lambda = 1600, d = 2)
}
\arguments{
  \item{y}{signal to be smoothed.}
  \item{lambda}{smoothing parameter (rough 50..1e4 smooth); the default
                value of 1600 has been recommended in the literature.}
  \item{d}{order of differences in penalty (generally 2)}
}
\details{
  The Whittaker smoother family was first presented by Whittaker in 
  1923 for life tables, based on penalized least squares. These ideas 
  were revived by Paul Eilers, Leiden University, in 2003. This
  approach is also known as Whittaker-Henderson smoothing.

  The smoother attempts to both fit a curve that represents the raw 
  data, but is penalized if subsequent points vary too much.
  Mathematically it is a large, but sparse optimization problem that 
  can be expressed in a few lines of Matlab or R code.
}
\value{
  A smoothed time series.
}
\note{
  This is a version that avoids package 'SparseM'.
}
\author{
  An R version, based on Matlab code by P. Eilers in 2002, has been 
  published by Nicholas Lewin-Koh on the R-help mailing list in Feb. 
  2004, and in private communication to the author of this package.
}
\references{
  P. H. C. Eilers (2003). A Perfect Smoother. Analytical Chemistry,
  Vol. 75, No. 14, pp. 3631--3636.

  Wilson, D. I. (2006). The Black Art of Smoothing. Electrical and 
  Automation Technology, June/July issue.
}
\seealso{
  \code{\link{supsmu}}, \code{\link{savgol}}, \code{ptw::whit2}
}
\examples{
# **Sinosoid test function**
ts <- sin(2*pi*(1:1000)/200)
t1 <- ts + rnorm(1000)/10
t3 <- whittaker(t1, lambda = 1600)
\dontrun{
plot(1:1000, t1, col = "grey")
lines(1:1000, ts, col="blue")
lines(1:1000, t3, col="red")}
}
\keyword{ timeseries }

\name{linearproj, affineproj}
\alias{linearproj}
\alias{affineproj}
\title{
  Linear Projection onto a Subspace
}
\description{
  Computes the projection of points in the columns of B onto the
  linear subspace spaned by the columns of A, resp. the projection
  of a point onto an affine subspace and its distance.
}
\usage{
  linearproj(A, B)

  affineproj(x0, C, b, unbound = TRUE, maxniter = 100)
}
\arguments{
  \item{A}{Matrix whose columns span a subspace of some R^n.}
  \item{B}{Matrix whose columns are to be projected.}
  \item{x0}{Point in R^n to be projected onto C x = b.}
  \item{C, b}{Matrix and vector, defining an affine subspace as C x = b}
  \item{unbound}{Logical; require all x >= 0 if unbound is false.}
  \item{maxniter}{Maximum number of iterations (if  is unbound is false).}
}
\details{
  \code{linearproj} projects points onto a \emph{linear} subspace in R^n.
  The columns of A are assumed be the basis of a linear subspace, esp.
  they are required to be linearly independent. The columns of matrix B
  define points in R^n that will be projected onto A, and their resp.
  coefficients in terms of the basis in A are computed.

  The columns of A need to be linearly independent; if not, generate an 
  orthonormal basis of this subspace with \code{orth(A)}. If you want to 
  project points onto a subspace that is defined by \code{A x = 0}, then 
  generate an orthonormal basis of the nullspace of A with \code{null(A)}.

  Technically, the orthogonal projection can be determined by a finite 
  'Fourier expansion' with coefficients calculated as scalar products,
  see the examples.

  \code{affineproj} projects (single) points onto an affine subspace 
  defined by \code{A x = b} and calculates the distance of \code{x0} from 
  this subspace. The calculation is based on the following formula:
  \deqn{p = (I - A' (A A')^{-1}) x0 + A' (A A')^{-1} b}

  Technically, if \code{a} is one solution of \code{C x = b}, then the 
  projection onto C can be derived from the projection onto S = {C x = 0}
  with \code{proj_C(x) = a + proj_S(x - a)}, see the examples.

  In case the user requests the coordinates of the projected point to be 
  positive, an iteration procedure is started where negative coordinates 
  are set to zero in each iteration.
}
\value{
  The functions \code{linearproj} returns a list with components P and Q. 
  The columns of P contain the coefficients -- in the basis of A -- of the 
  corresponding projected points in B, and the columns of Q are the the 
  coordinates of these points in the natural coordinate system of R^n.

  \code{affineproj} returns a list with components \code{proj}, \code{dist}, 
  and \code{niter}. \code{proj} is the projected point, \code{dist} the 
  distance from the subspace (and \code{niter} the number of iterations 
  if positivity of the coordinates was requested.).
}
\references{
  G. Strang (2006). Linear Algebra and Its Applications. Fourth Edition,
  Cengage Learning, Boston, MA.
}
\note{
  Some timings show that these implementations are to a certain extent
  competitive with direct applications of quadprog.
}
\author{
  Hans W. Borchers, partly based on code snippets by Ravi Varadhan.
}
\seealso{
  \code{\link{nullspace}}, \code{\link{orth}}
}
\examples{
#-- Linear projection --------------------------------------------------

# Projection onto the line (1,1,1) in R^3
A <- matrix(c(1,1,1), 3, 1)
B <- matrix(c(1,0,0, 1,2,3, -1,0,1), 3, 3)
S <- linearproj(A, B)
## S$Q
##           [,1] [,2] [,3]
## [1,] 0.3333333    2    0
## [2,] 0.3333333    2    0
## [3,] 0.3333333    2    0

# Fourier expansion': sum(<x0, a_i> a_i /<a_i, a_i>), a_i = A[ ,i]
dot(c(1,2,3), A) * A / dot(A, A)    # A has only one column

#-- Affine projection --------------------------------------------------

# Projection onto the (hyper-)surface x+y+z = 1 in R^3
A <- t(A); b <- 1
x0 <- c(1,2,3)
affineproj(x0, A, b)            # (-2/3, 1/3, 4/3)

# Linear translation: Let S be the linear subspace and A the parallel
# affine subspace of A x = b, a the solution of the linear system, then
#   proj_A(x) = a + proj_S(x-a)
a <- qr.solve(A, b)
A0 <- nullspace(A)
xp <- c(a + linearproj(A0, x0 - a)$Q)
## [1] -0.6666667  0.3333333  1.3333333

#-- Projection with positivity ----------------------- 24 ms -- 1.3 s --
s <- affineproj(x0, A, b, unbound = FALSE)
zapsmall(s$proj)                 # [1] 0 0 1
## $x     : 0.000000e+00 3.833092e-17 1.000000e+00
## $niter : 35

#-- Extended Example ------------------------------------------ 80 ms --
\dontrun{
set.seed(65537)
n = 1000; m = 100                       # dimension, codimension
x0 <- rep(0, n)                         # project (0, ..., 0)
A <- matrix(runif(m*n), nrow = m)       # 100 x 1000
b <- rep(1, m)                          # A x = b, linear system
a <- qr.solve(A, b)                     # A a = b, LS solution
A0 <- nullspace(A)                      # 1000 x 900, base of <A>
xp <- a+drop(A0 \%*\% dot(x0-a, A0))      # projection
Norm(xp - x0)                           # [1] 0.06597077
}

#-- Solution with quadprog ------------------------------------ 40 ms --
# D <- diag(1, n)             # quadratic form
# A1 <- rbind(A, diag(1, n))  # A x = b and
# b1 <- c(b, rep(0, n))       #   x >= 0
# n <- nrow(A)
# sol = quadprog::solve.QP(D, x0, t(A1), b1, meq = n)
# xp <- sol$solution

#-- Solution with CVXR ---------------------------------------- 50 ms --
# library(CVXR)
# x = Variable(n)                             # n decision variables
# objective = Minimize(p_norm(x0 - x))        # min! || p0 - x ||
# constraint = list(A %*% x == b, x >= 0)     # A x = b, x >= 0
# problem = Problem(objective, constraint)
# solution = solve(problem)                   # Solver: ECOS
# solution$value                              # 
# xp <- solution$getValue(x)                  # 
}
\keyword{ math }

\name{fresnelS/C}
\alias{fresnelS}
\alias{fresnelC}
\title{
  Fresnel Integrals
}
\description{
  (Normalized) Fresnel integrals S(x) and C(x)
}
\usage{
fresnelS(x)
fresnelC(x)
}
\arguments{
  \item{x}{numeric vector.}
}
\details{
  The \emph{normalized} Fresnel integrals are defined as
  \deqn{S(x) = \int_0^x \sin(\pi/2 \, t^2) dt}
  \deqn{C(x) = \int_0^x \cos(\pi/2 \, t^2) dt}

  This program computes the Fresnel integrals S(x) and C(x) using Fortran
  code by Zhang and Jin. The accuracy is almost up to Machine precision.

  The functions are not (yet) truly vectorized, but use a call to `apply'.
  The underlying function \code{.fresnel} (not exported) computes single
  values of \code{S(x)} and \code{C(x)} at the same time.
}
\value{
  Numeric vector of function values.
}
\references{
  Zhang, S., and J. Jin (1996). Computation of Special Functions.
  Wiley-Interscience.
}
\note{
  Copyright (c) 1996 Zhang and Jin for the Fortran routines, converted to
  Matlab using the open source project `f2matlab' by Ben Barrowes, posted to
  MatlabCentral in 2004, and then translated to R by Hans W. Borchers.
}
\seealso{
  \code{\link{gaussLegendre}}
}
\examples{
##  Compute Fresnel integrals through Gauss-Legendre quadrature
f1 <- function(t) sin(0.5 * pi * t^2)
f2 <- function(t) cos(0.5 * pi * t^2)
for (x in seq(0.5, 2.5, by = 0.5)) {
    cgl <- gaussLegendre(51, 0, x)
    fs <- sum(cgl$w * f1(cgl$x))
    fc <- sum(cgl$w * f2(cgl$x))
    cat(formatC(c(x, fresnelS(x), fs, fresnelC(x), fc),
        digits = 8, width = 12, flag = " ----"), "\n")
}

\dontrun{
xs <- seq(0, 7.5, by = 0.025)
ys <- fresnelS(xs)
yc <- fresnelC(xs)

##  Function plot of the Fresnel integrals
plot(xs, ys, type = "l", col = "darkgreen",
    xlim = c(0, 8), ylim = c(0, 1),
    xlab = "", ylab = "", main = "Fresnel Integrals")
lines(xs, yc, col = "blue")
legend(6.25, 0.95, c("S(x)", "C(x)"), col = c("darkgreen", "blue"), lty = 1)
grid()

##  The Cornu (or Euler) spiral
plot(c(-1, 1), c(-1, 1), type = "n",
    xlab = "", ylab = "", main = "Cornu Spiral")
lines(ys, yc, col = "red")
lines(-ys, -yc, col = "red")
grid()}
}
\keyword{ specfun }

\name{polyarea}
\alias{polyarea}
\alias{poly_center}
\alias{poly_length}
\alias{poly_crossings}
\title{Area of a Polygon}
\description{
  Calculates the area and length of a polygon given by the vertices in the 
  vectors \code{x} and \code{y}.
}
\usage{
  polyarea(x, y)

  poly_length(x, y)
  poly_center(x, y)

  poly_crossings(L1, L2)
}
\arguments{
  \item{x}{x-coordinates of the vertices defining the polygon}
  \item{y}{y-coordinates of the vertices}
  \item{L1, L2}{matrices of type \code{2xn} with x- and y-coordinates.}
}
\details{
  \code{polyarea} calculates the area of a polygon defined by the vertices
  with coordinates \code{x} and \code{y}. Areas to the left of the vertices
  are positive, those to the right are counted negative.

  The computation is based on the Gauss polygon area formula. The polygon
  automatically be closed, that is the last point need not be / should not
  be the same as the first.

  If some points of self-intersection of the polygon line are not in the
  vertex set, the calculation will be inexact. The sum of all areas will be
  returned, parts that are circulated in the mathematically negative sense
  will be counted as negative in this sum.

  If \code{x}, \code{y} are matrices of the same size, the areas of all
  polygons defined by corresponding columns are computed.

  \code{poly_center} calculates the center (of mass) of the figure defined by
  the polygon. Self-intersections should be avoided in this case.
  The mathematical orientation of the polygon does not have influence on the
  center coordinates.

  \code{poly_length} calculates the length of the polygon

  \code{poly_crossings} calculates the crossing points of two polygons given
  as matrices with x- and y-coordinates in the first and second row. Can be 
  used for finding the crossing points of parametrizised curves.
}
\value{
  Area or length of the polygon resp. sum of the enclosed areas; or the
  coordinates of the center of gravity.

  \code{poly_crossings} returns a matrix with column names \code{x} and
  \code{y} representing the crossing points.
}
\seealso{
  \code{\link{trapz}}, \code{\link{arclength}}
}
\examples{
  # Zu Chongzhi's calculation of pi (China, about 480 A.D.),
  # approximating the circle from inside by a regular 12288-polygon(!):
  phi <- seq(0, 2*pi, len=3*2^12+1)
  x <- cos(phi)
  y <- sin(phi)
  pi_approx <- polyarea(x, y)
  print(pi_approx, digits=8)    #=> 3.1415925 or 355/113

  poly_length(x, y)              #=> 6.2831852 where 2*pi is 6.2831853

  x1 <- x + 0.5; y1 <- y + 0.5
  x2 <- rev(x1); y2 <- rev(y1)
  poly_center(x1, y1)            #=> 0.5 0.5
  poly_center(x2, y2)            #=> 0.5 0.5

  # A simple example
  L1 <- matrix(c(0, 0.5, 1, 1,   2,
                0, 1,   1, 0.5, 0), nrow = 2, byrow = TRUE)
  L2 <- matrix(c(0.5, 0.75, 1.25, 1.25,
                0,   0.75, 0.75, 0   ), nrow = 2, byrow = TRUE)
  P <- poly_crossings(L1, L2)
  P
  ##         x     y
  ## [1,] 1.00 0.750
  ## [2,] 1.25 0.375

\dontrun{
  # Crossings of Logarithmic and Archimedian spirals
  # Logarithmic spiral
  a <- 1; b <- 0.1
  t <- seq(0, 5*pi, length.out = 200)
  xl <- a*exp(b*t)*cos(t) - 1
  yl <- a*exp(b*t)*sin(t)
  plot(xl, yl, type = "l", lwd = 2, col = "blue",
       xlim = c(-6, 3), ylim = c(-3, 4), xlab = "", ylab = "",
       main = "Intersecting Logarithmic and Archimedian spirals")
  grid()

  # Archimedian spiral
  a <- 0; b <- 0.25
  r <- a + b*t
  xa <- r * cos(t)
  ya <- r*sin(t)
  lines(xa, ya, type = "l", lwd = 2, col = "red")
  legend(-6.2, -1.0, c("Logarithmic", "Archimedian"),
         lwd = 2, col = c("blue", "red"), bg = "whitesmoke")

  L1 <- rbind(xl, yl)
  L2 <- rbind(xa, ya)
  P <- poly_crossings(L1, L2)
  points(P)
  }
}
\keyword{ math }

\name{fact}
\alias{fact}
\alias{factorial2}
\title{
  Factorial Function
}
\description{
  Factorial for non-negative integers \code{n <= 170}.
}
\usage{
fact(n)

factorial2(n)
}
\arguments{
  \item{n}{Vector of integers, for \code{fact}, resp. a single integer for
           \code{factorial2}.}
}
\details{
  The factorial is computed by brute force; factorials for \code{n >= 171}
  are not representable as `double' anymore.
}
\value{
  \code{fact} returns the factorial of each element in \code{n}.
  If \code{n < 0} the value is \code{NaN}, and for \code{n > 170}
  it is \code{Inf}.
  Non-integers will be reduced to integers through \code{floor(n)}.

  \code{factorial2} returns the product of all even resp. odd integers,
  depending on whether \code{n} is even or odd.
}
\note{
  The R core function \code{factorial} uses the \code{gamma} function,
  whose implementation is not accurate enough for larger input values.
}
\seealso{
  \code{\link{factorial}}
}
\examples{
fact(c(-1, 0, 1, NA, 171))  #=> NaN   1   1  NA Inf
fact(100)                   #=> 9.332621544394410e+157
factorial(100)              #=> 9.332621544394225e+157
# correct value:                9.332621544394415e+157
# Stirling's approximation:     9.324847625269420e+157
# n! ~ sqrt(2*pi*n) * (n/e)^n

factorial2(8);  factorial2(9);  factorial2(10)  # 384   945  3840
factorial(10) / factorial2(10)                  # => factorial2(9)
}
\keyword{ math }

\name{nullspace}
\alias{nullspace}
\alias{null}
\title{
  Kernel or Nullspace
}
\description{
  Kernel of the linear map defined by matrix \code{M}.
}
\usage{
nullspace(M)
null(M)
}
\arguments{
  \item{M}{Numeric matrix; vectors will be considered as column vectors.}
}
\details{
  The kernel (aka null space/nullspace) of a matrix \code{M} is the set of
  all vectors \code{x} for which \code{Ax=0}. It is computed from the
  QR-decomposition of the matrix.

  \code{null} is simply an alias for \code{nullspace} -- and the Matlab name.
}
\value{
  If \code{M} is an \code{n}-by-\code{m} (operating from left on
  \code{m}-dimensional column vectors), then \code{N=nullspace(M)} is a
  \code{m}-by-\code{k} matrix whose columns define a (linearly independent)
  basis of the \code{k}-dimensional kernel in \code{R^m}.

  If the kernel is only the null vector \code{(0 0 ... 0)}, then NULL will
  be returned.

  As the rank of a matrix is also the dimension of its image, the following
  relation is true:

  \code{m = dim(nullspace(M)) + rank(M)}
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Philadelphia. 
}
\note{
  The image of \code{M} can be retrieved from \code{orth()}.
}
\seealso{
  \code{\link{Rank}}, \code{\link{orth}}, \code{MASS::Null}
}
\examples{
M <- matrix(1:12, 3, 4)
Rank(M)                 #=> 2
N <- nullspace(M)
#           [,1]       [,2]      [,3]
# [1,] 0.4082483 -0.8164966 0.4082483
M %*% N                  # almost c(0, 0, 0)

M1 <- matrix(1:6, 2, 3)  # of rank 2
M2 <- t(M1)
nullspace(M1)            # corresponds to 1 -2  1
nullspace(M2)            # NULL, i.e. 0 0

M <- magic(5)
Rank(M)                 #=> 5
nullspace(M)             #=> NULL, i.e. 0 0 0 0 0
}
\keyword{ array }

\name{findmins}
\alias{findmins}
\title{
  Find All Minima
}
\description{
  Finding all local(!) minima of a unvariate function in an interval by
  splitting the interval in many small subintervals.
}
\usage{
findmins(f, a, b, n = 100, tol = .Machine$double.eps^(2/3), ...)
}
\arguments{
  \item{f}{functions whose minima shall be found.}
  \item{a, b}{endpoints of the interval.}
  \item{n}{number of subintervals to generate and search.}
  \item{tol}{has no effect at this moment.}
  \item{\ldots}{Additional parameters to be passed to the function.}
}
\details{
  Local minima are found by looking for one minimum in each subinterval.
  It will be found by applying \code{optimize} to any two adjacent
  subinterval where the first slope is negative and the second one
  positive.

  If the function is minimal on a whole subinterval, this will cause
  problems. If some minima are apparently not found, increase the number
  of subintervals.
  
  Note that the endpoints of the interval will never be considered to be
  local minima. The function need not be vectorized.
}
\value{
  Numeric vector with the x-positions of all minima found in the interval.
}
\seealso{
  \code{\link{optimize}}
}
\examples{
fun <- function(x) x * cos(0.1*exp(x)) * sin(0.1*pi*exp(x))
\dontrun{ezplot(fun, 0, 5, n = 1001)}

# If n is smaller, the rightmost minimum will not be found.
findmins(fun, 0, 5, n= 1000)
#  2.537727 3.248481 3.761840 4.023021 4.295831
#  4.455115 4.641481 4.756263 4.897461 4.987802
}
\keyword{ optimize }

\name{geomean, harmmean}
\alias{geomean}
\alias{harmmean}
\alias{trimmean}
\title{
  Geometric and Harmonic Mean (Matlab Style)
}
\description{
  Geometric and harmonic mean along a dimension of a vector, matrix, or
  array.\cr
  \code{trimmean} is almost the same as \code{mean} in R.
}
\usage{
geomean(x, dim = 1)
harmmean(x, dim = 1)

trimmean(x, percent = 0)
}
\arguments{
  \item{x}{numeric vector, matrix, or array.}
  \item{dim}{dimension along which to take the mean; \code{dim=1} means
             along columns, \code{dim=2} along rows, the result will still
             be a row vector, not a column vector as in Matlab.}
  \item{percent}{percentage, between 0 and 100, of trimmed values.}
}
\details{
  \code{trimmean} does not call \code{mean} with the \code{trim} option, but
  rather calculates \code{k<-round(n*percent/100/2)} and leaves out \code{k}
  values at the beginning and end of the sorted \code{x} vector (or row or
  column of a matrix).
}
\value{
  Returns a scalar or vector (or array) of geometric or harmonic means:
  For \code{dim=1} the mean of columns, \code{dim=2} the mean of rows, etc.
}
\note{
  To have an exact analogue of \code{mean(x)} in Matlab,
  apply \code{trimmean(x)}.
}
\seealso{
  \code{\link{mean}}
}
\examples{
A <- matrix(1:12, 3, 4)
geomean(A, dim = 1)
## [1]  1.817121  4.932424  7.958114 10.969613
harmmean(A, dim = 2)
## [1] 2.679426 4.367246 5.760000

x <- c(-0.98, -0.90, -0.68, -0.61, -0.61, -0.38, -0.37, -0.32, -0.20, -0.16,
        0.00,  0.05,  0.12,  0.30,  0.44,  0.77,  1.37,  1.64,  1.72,  2.80)
trimmean(x); trimmean(x, 20)    # 0.2  0.085
mean(x); mean(x, 0.10)          # 0.2  0.085
}
\keyword{ stat }

\name{orth}
\alias{orth}
\title{
  Range Space
}
\description{
  Range space or image of a matrix.
}
\usage{
orth(M)
}
\arguments{
  \item{M}{Numeric matrix; vectors will be considered as column vectors.}
}
\details{
   \code{B=orth(A)} returns an orthonormal basis for the range of \code{A}.
   The columns of \code{B} span the same space as the columns of \code{A},
   and the columns of \code{B} are orthogonal to each other.

  The number of columns of \code{B} is the rank of \code{A}.
}
\value{
  Matrix of orthogonal columns, spanning the image of \code{M}.
}
\references{
  Trefethen, L. N., and D. Bau III. (1997). Numerical Linear Algebra. SIAM,
  Philadelphia. 
}
\seealso{
  \code{\link{nullspace}}
}
\examples{
M <- matrix(1:12, 3, 4)
Rank(M)                 #=> 2
orth(M)
}
\keyword{ array }

\name{gcd, lcm}
\alias{gcd}
\alias{Lcm}
\title{GCD and LCM Integer Functions}
\description{
  Greatest common divisor and least common multiple
}
\usage{
gcd(a, b, extended = FALSE)
Lcm(a, b)
}
\arguments{
  \item{a, b}{vectors of integers.}
  \item{extended}{logical; if \code{TRUE}
                           the extended Euclidean algorithm will be applied.}
}
\details{
  Computation based on the extended Euclidean algorithm.

  If both \code{a} and \code{b} are vectors of the same length, the greatest 
  common divisor/lowest common multiple will be computed elementwise.
  If one is a vektor, the other a scalar, the scalar will be replicated to
  the same length.
}
\value{
  A numeric (integer) value or vector of integers. Or a list of three vectors
  named \code{c, d, g}, g containing the greatest common divisors, such that

  \code{g = c * a + d * b}.
}
\note{
  The following relation is always true:

  \code{n * m = gcd(n, m) * lcm(n, m)}
}
\seealso{
\code{numbers::extGCD}
}
\examples{
gcd(12, 1:24)
gcd(46368, 75025)  # Fibonacci numbers are relatively prime to each other
Lcm(12, 1:24)
Lcm(46368, 75025)  # = 46368 * 75025
}
\keyword{ arith }

\name{conv}
\alias{conv}
\title{Polynomial Convolution}
\description{
  Convolution and polynomial multiplication.
}
\usage{
conv(x, y)
}
\arguments{
  \item{x, y}{real or complex vectors.}
}
\details{
  \code{r = conv(p,q)} convolves vectors \code{p} and \code{q}.
  Algebraically, convolution is the same operation as multiplying the
  polynomials whose coefficients are the elements of \code{p} and \code{q}.
}
\value{
  Another vector.
}
\note{
  \code{conv} utilizes fast Fourier transformation.
}
\seealso{
  \code{\link{deconv}}, \code{\link{polyadd}}
}
\examples{
conv(c(1, 1, 1), 1)
conv(c(1, 1, 1), c(0, 0, 1))
conv(c(-0.5, 1, -1), c(0.5, 0, 1))
}
\keyword{ timeseries }

\name{ppval}
\alias{mkpp}
\alias{ppval}
\title{
  Piecewise Polynomial Structures
}
\description{
  Make or evaluate a piecewise polynomial.
}
\usage{
mkpp(x, P)

ppval(pp, xx)
}
\arguments{
  \item{x}{increasing vector of real numbers.}
  \item{P}{matrix containing the coefficients of polynomials in each row.}
  \item{pp}{a piecewise polynomial structure, generated by \code{mkpp}.}
  \item{xx}{numerical vector}
}
\details{
  \code{pp<-mkpp(x,P)} builds a piecewise polynomial from its breaks
  \code{x} and coefficients \code{P}. \code{x} is a monotonically increasing
  vector of length \code{L+1}, and \code{P} is an \code{L-by-k} matrix where 
  each row contains the coefficients of the polynomial of order \code{k}, from 
  highest to lowest exponent, on the interval \code{[x[i],x[i+1])}.

  \code{ppval(pp,xx)} returns the values of the piecewise polynomial
  \code{pp} at the entries of the vector \code{xx}. The first and last
  polynomial will be extended to the left resp. right of the interval
  \code{[x[1],x[L+1])}.
}
\value{
  \code{mkpp} will return a piecewise polynomial structure, that is a list
  with components \code{breaks=x}, \code{pieces=P}, \code{order=k} and
  \code{dim=1} for scalar-valued functions.
}
\note{
  Matlab allows to generate vector-valued piecewise polynomials. This may be
  included in later versions.
}
\seealso{
  \code{\link{cubicspline}}
}
\examples{
##  Example: Linear interpolation of the sine function
xs <- linspace(0, pi, 10)
ys <- sin(xs)
P <- matrix(NA, nrow = 9, ncol = 2)
for (i in 1:9) {
    P[i, ] <- c((ys[i+1]-ys[i])/(xs[i+1]-xs[i]), ys[i])
}
ppsin <- mkpp(xs, P)

\dontrun{
plot(xs, ys); grid()
x100 <- linspace(0, pi, 100)
lines(x100, sin(x100), col="darkgray")
ypp <- ppval(ppsin, x100)
lines(x100, ypp, col="red")
}
}
\keyword{ fitting }
